/*
 * Created on Nov 4, 2003
 * 
 */
package AcmeDiagramLegend.actions;

import AcmeDiagramLegend.AcmeDiagramLegendPlugin;
import AcmeDiagramLegend.model.AcmeLegend;
import AcmeStudio.model.ModelCommand;
import AcmeStudio.util.AcmeStudioChangeManager;
import acmeLib.elements.AcmeSystem;

/**
 * @author Bradley Schmerl
 * 
 * The command for deleting the legend from the diagram
 */
public class DeleteLegendCommand extends ModelCommand {
    /**
     * @param label
     */
    public DeleteLegendCommand(AcmeLegend legend) {
        super("Delete");
        _legend = legend;
        _system = (AcmeSystem )_legend.getParent ();
    }

    private AcmeLegend _legend;
    private AcmeSystem _system;
    
    public void execute () {
        setLabel ("Delete legend");
        primExecute ();
    }

    /**
     * 
     */
    private void primExecute() {
        _system.setUserData(AcmeDiagramLegendPlugin.class, null);
        AcmeStudioChangeManager.globalChangeManager.onPluginChange(AcmeDiagramLegendPlugin.REMOVE_LEGEND, _system, _legend, this, _system.getParentDesign ());
    }
    
    public void redo () {
        primExecute ();
        
    }
    
    public void undo () {
        _system.setUserData (AcmeDiagramLegendPlugin.class, _legend);
        AcmeStudioChangeManager.globalChangeManager.onPluginChange(AcmeDiagramLegendPlugin.ADD_LEGEND, _system, _legend, this, _system.getParentDesign ());
    }
    
    
}
