/*
 * Created on Nov 6, 2003
 * 
 */
package AcmeDiagramLegend.dialogs;

import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.jface.preference.IPreferenceStore;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Shell;

import AcmeDiagramLegend.AcmeDiagramLegendPlugin;


/**
 * @author Bradley Schmerl
 *
 */
public class FormatLegendDialog extends Dialog {

    private Button _btnUseLargeIcons;
    private Button _btnLayoutUnconstrained;
    private Button _btnLayoutHorizontal;
    private Button _btnLayoutVertical;
    private Button _btnLayoutTable;
    private Button _btnLayoutLegend;
    
    /**
     * @param parentShell
     */
    public FormatLegendDialog(Shell parentShell) {
        super(parentShell);
    }

    /* (non-Javadoc)
     * @see org.eclipse.jface.dialogs.Dialog#createDialogArea(org.eclipse.swt.widgets.Composite)
     */
    protected Control createDialogArea(Composite parent) {
        Composite top =  (Composite) super.createDialogArea(parent);
        
        _btnLayoutUnconstrained = new Button (top, SWT.RADIO);
        _btnLayoutUnconstrained.setText ("Layout legend items unconstrained");
        _btnLayoutUnconstrained.setEnabled (false);
               
        _btnLayoutLegend = new Button (top, SWT.RADIO);
        _btnLayoutLegend.setText ("Layout legend items in columns");
        
        _btnUseLargeIcons = new Button (top, SWT.CHECK);
        _btnUseLargeIcons.setText ("Use large icons for items");
        
        IPreferenceStore preferences = AcmeDiagramLegendPlugin.getDefault().getPreferenceStore();
        _btnUseLargeIcons.setSelection(preferences.getBoolean("LegendItem.UseLargeIcons"));
        
        int layout = preferences.getInt("LegendItem.Layout");
        switch (layout) {
            case AcmeDiagramLegendPlugin.LAYOUT_FLOW_HORIZONTAL:
                _btnLayoutHorizontal.setSelection(true);
                break;
            case AcmeDiagramLegendPlugin.LAYOUT_FLOW_VERTICAL:
                _btnLayoutVertical.setSelection (true);
                break;
                case AcmeDiagramLegendPlugin.LAYOUT_FREEFORM:
                	_btnLayoutUnconstrained.setSelection (true);
                	break;
                case AcmeDiagramLegendPlugin.LAYOUT_TABLE:
                	_btnLayoutTable.setSelection (true);
                	break;
                case AcmeDiagramLegendPlugin.LAYOUT_LEGEND:
                	_btnLayoutLegend.setSelection (true);
                	break;
                }
        return top;
    }

    /* (non-Javadoc)
     * @see org.eclipse.jface.dialogs.Dialog#okPressed()
     */
    protected void okPressed() {
        IPreferenceStore preferences = AcmeDiagramLegendPlugin.getDefault().getPreferenceStore();
        preferences.setValue("LegendItem.UseLargeIcons", _btnUseLargeIcons.getSelection());
       
         if (_btnLayoutUnconstrained.getSelection()) preferences.setValue("LegendItem.Layout", AcmeDiagramLegendPlugin.LAYOUT_FREEFORM);
//         else if (_btnLayoutHorizontal.getSelection()) preferences.setValue("LegendItem.Layout", AcmeDiagramLegendPlugin.LAYOUT_FLOW_HORIZONTAL);
//         else if (_btnLayoutVertical.getSelection())preferences.setValue("LegendItem.Layout", AcmeDiagramLegendPlugin.LAYOUT_FLOW_VERTICAL);
//         else if (_btnLayoutTable.getSelection())preferences.setValue("LegendItem.Layout", AcmeDiagramLegendPlugin.LAYOUT_TABLE);
         else if (_btnLayoutLegend.getSelection())preferences.setValue("LegendItem.Layout", AcmeDiagramLegendPlugin.LAYOUT_LEGEND);
         
        super.okPressed();
    }

}
