/*
 * Created on Nov 4, 2003
 * 
 */
package AcmeDiagramLegend.figures;

import org.eclipse.draw2d.AbstractBorder;
import org.eclipse.draw2d.ColorConstants;
import org.eclipse.draw2d.Graphics;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.geometry.Insets;
import org.eclipse.draw2d.geometry.Rectangle;

/**
 * @author Bradley Schmerl
 * 
 * A border for the legend
 */
public class LegendBorder extends AbstractBorder {

   private static Insets _insets = new Insets (10, 6, 6, 6);
    
    /* (non-Javadoc)
     * @see org.eclipse.draw2d.Border#getInsets(org.eclipse.draw2d.IFigure)
     */
    public Insets getInsets(IFigure arg0) {
        return _insets;
    }

    /* (non-Javadoc)
     * @see org.eclipse.draw2d.Border#paint(org.eclipse.draw2d.IFigure, org.eclipse.draw2d.Graphics, org.eclipse.draw2d.geometry.Insets)
     */
    public void paint(IFigure figure, Graphics g, Insets in) {
        Rectangle r = figure.getBounds ().getCropped (in);
        g.pushState();
        g.setForegroundColor (ColorConstants.darkBlue);
        Rectangle outerRectangle = r.getCopy();
        outerRectangle.y = outerRectangle.y + 3;
        outerRectangle.height = outerRectangle.height - 3;
        g.drawRectangle(outerRectangle);
        g.drawRectangle(outerRectangle.expand(-3, -3));
//        g.drawText("Legend:", r.x + 20, r.y - 10);
        
        //g.drawText("Legend2:", (int)Math.random() + 50, r.y + 20);
        g.popState ();
    }

}
