/*
 * Created on Nov 6, 2003
 * 
 */
package AcmeDiagramLegend.figures;

import org.eclipse.draw2d.Graphics;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.draw2d.geometry.Point;
import AcmeStudio.ui.editors.diagram.figures.AcmeVisElement;
import AcmeStudio.util.Helper;
import acmeLib.core.globals.CategoryT;
import acmeLib.elements.AcmeElement;

/**
 * @author Bradley Schmerl
 *
 */
public class LegendItemIcon extends AcmeVisElement {
	
    protected CategoryT _type;

    /* (non-Javadoc)
     * @see org.eclipse.draw2d.IFigure#invalidate()
     */
    public void invalidate() {
        Dimension oldPrefSize = prefSize;
        super.invalidate();
        prefSize = oldPrefSize;
    }
    
    public CategoryT getType()
    {
    	return _type;
    }
    
    public void setType(CategoryT type)
    {
    	_type=type;
    }

    
	
	/**
	 * @param graphics
	 * @see AcmeStudio.ui.editors.diagram.figures.AcmeVisElement#outlineShape(org.eclipse.draw2d.Graphics)
	 **/
	protected void outlineShape(Graphics graphics) {
		if (_type != CategoryT.ACME_ROLE_TYPE) {
			super.outlineShape (graphics);
		}
		else {
			graphics.setForegroundColor(_vis.getOutlineColor());
			graphics.setLineWidth(_vis.getOutlineWidth());
			graphics.setLineStyle(_vis.getOutlineStyle());
			Point location = getLocation ().getCopy ();
//			graphics.drawRectangle(getBounds ());
			graphics.drawLine(location.x, location.y + getSize ().height / 2, location.x + 5, location.y + getSize ().height/2);
			location.x += 5;
			Dimension size = Helper.getSize (_model);
			_vis.getVariantToApply(_model).outlineShape (graphics, _model, location, size);
		}
	}

	
	/**
	 * @param graphics
	 * @see AcmeStudio.ui.editors.diagram.figures.AcmeVisElement#fillShape(org.eclipse.draw2d.Graphics)
	 **/
	protected void fillShape(Graphics graphics) {
		if (_type != CategoryT.ACME_ROLE_TYPE) {
			super.fillShape (graphics);
		}
		else {
			graphics.drawLine(getLocation ().x, getSize ().height / 2,getLocation().x + 5, getSize ().height/2);
			Point location = getLocation ();
			location.x += 5;
			Dimension size = Helper.getSize (_model);
			_vis.getVariantToApply(_model).fillShape (graphics, _model, location, size);
		}
	}
	
	/**
	 * @param model
	 * @see AcmeStudio.ui.editors.diagram.figures.AcmeVisElement#setModel(acmeLib.elements.AcmeElement)
	 **/
	public void setModel(AcmeElement model) {
		super.setModel (model);
		if (_type == CategoryT.ACME_ROLE_TYPE) {
			Dimension size = getSize ();
			size.width += 5;
			setSize (size);
		}
	}
}
