/*
 * Created on Nov 6, 2003
 * 
 */
package AcmeDiagramLegend.figures;

import org.eclipse.draw2d.Figure;
import org.eclipse.draw2d.MarginBorder;
import org.eclipse.draw2d.StackLayout;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.draw2d.geometry.Point;
import org.eclipse.draw2d.text.FlowPage;
import org.eclipse.draw2d.text.ParagraphTextLayout;
import org.eclipse.draw2d.text.TextFlow;
import org.eclipse.swt.graphics.Font;

import AcmeDiagramLegend.model.AcmeLegendItemDescription;

/**
 * @author Bradley Schmerl
 *
 */
public class LegendItemLabel extends Figure {
	

	private TextFlow _textFlow;

	private FlowPage _flowPage;
	
	private AcmeLegendItemDescription _model;
	
	public LegendItemLabel () {
		setBorder (new MarginBorder (1));
		_flowPage = new FlowPage () {
			public void setFont (Font f) {
				super.setFont (f);
			}
			
			public void layout () {
//				if (font == null) return;
				super.layout ();
			}
			
			public void validate () {
//				if (font == null) return;
				try {
				super.validate ();
				} catch (Exception e) {
//					e.printStackTrace();
				}
			}
		};
		_textFlow = new TextFlow ();
		_textFlow.setLayoutManager (new ParagraphTextLayout (_textFlow,
				ParagraphTextLayout.WORD_WRAP_SOFT));
		_flowPage.add (_textFlow);
		setLayoutManager (new StackLayout ());
		add (_flowPage);
	}
	
    /* (non-Javadoc)
     * @see org.eclipse.draw2d.IFigure#invalidate()
     */
    public void invalidate() {
        Dimension oldPrefSize = prefSize;
        super.invalidate();
        prefSize = oldPrefSize;
    }
    
    
    public String getText () {
    	return _textFlow.getText ();
    }
    
    public void setText (String text) {
    	if (text == null || text == "") {
    		_textFlow.setVisible (false);
    		return;
    	}
    	_textFlow.setVisible (true);
    	_textFlow.setText (text);
    }

	/* (non-Javadoc)
	 * @see org.eclipse.draw2d.IFigure#setLocation(org.eclipse.draw2d.geometry.Point)
	 */
	public void setLocation(Point p) {
		invalidate ();
		super.setLocation (p);
	}
	/* (non-Javadoc)
	 * @see org.eclipse.draw2d.IFigure#getPreferredSize(int, int)
	 */
	public Dimension getPreferredSize(int wHint, int hHint) {
		return _flowPage.getPreferredSize (wHint, hHint);
	}
	/**
	 * @return Returns the model.
	 */
	public AcmeLegendItemDescription getModel() {
		return _model;
	}
	/**
	 * @param model The model to set.
	 */
	public void setModel(AcmeLegendItemDescription model) {
		_model = model;
	}
}
