/*
 * Created on Nov 3, 2003
 * 
 */
package AcmeDiagramLegend.model;

import org.eclipse.draw2d.geometry.Point;
import acmeLib.elements.AcmeElement;
import acmeLib.elements.AcmeElementType;

/**
 * 
 */
public class AcmeLegendItemDescription {
    protected AcmeElementType _type;
    protected String _description;
    private Point _location;
    private AcmeLegendItemIcon _itemIcon;
private int _width;
private AcmeElement	_element;
 
    public AcmeLegendItemDescription (AcmeElementType type) {
        _type = type;
//        _description = Helper.getDescription((AcmeElement )type);
//        if (_description == null || _description.equals ("")) {
            _description = type.getTypeName();
//        }
    }
    
    public AcmeLegendItemDescription (AcmeElementType type, String description) {
        _type = type;
        _description = description;
    }
    
    public AcmeLegendItemDescription (AcmeElement element) {
    	_element = element;
    	_description = "???";
    }
    
    public AcmeLegendItemDescription (AcmeElement element, String description) {
    	_element = element;
    	_description = description;
    }
    
    /**
     * @return Returns the description.
     */
    public String getDescription() {
    	return _description;
    }
    
    public void getDescription(String description) {
    	_description = description;
    }
    
    /**
     * @param description The description to set.
     */
    public void setDescription(String description) {
        _description = description;
    }

    /**
     * @return Returns the type.
     */
    public AcmeElementType getType() {
        return _type;
    }

    /**
     * @param type The type to set.
     */
    public void setType(AcmeElementType type) {
        _type = type;
    }

    /**
     * @param pos
     */
    public void setLocation(Point pos) {
        _location = pos;
    }
    
    public Point getLocation () {
        return _location;
    }

	/**
	 * @return Returns the itemIcon.
	 */
	public AcmeLegendItemIcon getItemIcon() {
		return _itemIcon;
	}

	/**
	 * @param itemIcon The itemIcon to set.
	 */
	public void setItemIcon(AcmeLegendItemIcon itemIcon) {
		_itemIcon = itemIcon;
	}

/**
 * @return Returns the width.
 */
public int getWidth() {
	return _width;
}
/**
 * @param width The width to set.
 */
public void setWidth(int width) {
	_width = width;
}
public AcmeElement getElement() {
	return _element;
}
}
