/*
 * Created on Nov 5, 2003
 * 
 */
package AcmeDiagramLegend.model;

import AcmeDiagramLegend.AcmeDiagramLegendPlugin;
import AcmeStudio.model.ModelCommand;
import AcmeStudio.util.AcmeStudioChangeManager;

/**
 * @author Bradley Schmerl
 *
 */
public class ReorderPartCommand extends ModelCommand {
    
    private AcmeLegendItemDescription _item;
    private AcmeLegend _legend;
    private int _oldIndex;
    private int _newIndex;

    public ReorderPartCommand (AcmeLegendItemDescription item, AcmeLegend legend, int oldIndex, int newIndex) {
        super ("Reorder legend items");
        _item = item;
        _legend = legend;
        _oldIndex = oldIndex;
        _newIndex = newIndex;
    }
    
    public void execute () {
        _legend.getItems().remove(_item);
        _legend.getItems ().add(_newIndex, _item);
        
        AcmeStudioChangeManager.globalChangeManager.onPluginChange(AcmeDiagramLegendPlugin.REORDER_LEGEND, _legend, _item, this, _legend.getParent ().getParentDesign ());
        
    }
    
    public void undo () {
        _legend.getItems ().remove (_item);
        _legend.getItems ().add (_oldIndex, _item);
        AcmeStudioChangeManager.globalChangeManager.onPluginChange(AcmeDiagramLegendPlugin.REORDER_LEGEND, _legend, _item, this, _legend.getParent ().getParentDesign ());
     
    }

}
