/*
 * Created on Feb 3, 2004
 *
 */
package AcmeDiagramLegend.parts;

import org.eclipse.draw2d.FigureListener;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.geometry.Point;
import org.eclipse.gef.DragTracker;
import org.eclipse.gef.Request;
import org.eclipse.gef.requests.ChangeBoundsRequest;
import org.eclipse.gef.tools.DragEditPartsTracker;

import AcmeDiagramLegend.figures.ColumnSeparatorFigure;
import AcmeDiagramLegend.figures.LegendFigure;
import AcmeDiagramLegend.model.AcmeLegend;
import AcmeDiagramLegend.model.ColumnSeparator;
import AcmeStudio.ui.editors.diagram.parts.ElementEditPart;



/**
 * @author Bradley Schmerl
 * Created Feb 3, 2004
 */
public class ColumnSeparatorEditPart extends ElementEditPart implements FigureListener {
	
	/* (non-Javadoc)
	 * @see org.eclipse.gef.editparts.AbstractGraphicalEditPart#createFigure()
	 */
	protected IFigure createFigure() {
		ColumnSeparatorFigure figure = new ColumnSeparatorFigure ();
		figure.addFigureListener(this);
		return figure;
	}
	/* (non-Javadoc)
	 * @see org.eclipse.gef.editparts.AbstractEditPart#refreshVisuals()
	 */
	protected void refreshVisuals() {
		LegendEditPart lep = (LegendEditPart )getParent();
		LegendFigure lfig = (LegendFigure )lep.getFigure ();
		ColumnSeparator model = (ColumnSeparator )getModel ();
		AcmeLegend legend = model.getLegend ();
		ColumnSeparatorFigure figure = (ColumnSeparatorFigure )getFigure ();
		figure.setModel (model);
		if (legend.getColumnWidth(model.getColumn ()) < 1) {
			figure.setVisible (false);
		}
		else {
			figure.setVisible (true);
			int xPos = legend.getColumnStart (model.getColumn());
			figure.setLocation (new Point (xPos, 0));
			
			int height = lfig.getSize().height;
			figure.setSize (8, height-50);
//			((GraphicalEditPart )getParent ()).setLayoutConstraint (this, getFigure (), figure.getBounds());
//			((GraphicalEditPart )getParent ()).getFigure().getUpdateManager().performUpdate();
		}
		super.refreshVisuals ();
	}
	/* (non-Javadoc)
	 * @see org.eclipse.draw2d.FigureListener#figureMoved(org.eclipse.draw2d.IFigure)
	 */
	public void figureMoved(IFigure source) {
		this.refresh ();
	}

	/* (non-Javadoc)
	 * @see org.eclipse.gef.editparts.AbstractEditPart#createEditPolicies()
	 */
	protected void createEditPolicies() {
//		installEditPolicy (EditPolicy.SELECTION_FEEDBACK_ROLE, new SeparatorSelectionEditPolicy ());
////		installEditPolicy (EditPolicy.PRIMARY_DRAG_ROLE, new SeparatorDragPolicy ());
	}
	/* (non-Javadoc)
	 * @see org.eclipse.gef.EditPart#getDragTracker(org.eclipse.gef.Request)
	 */
	public DragTracker getDragTracker(Request request) {
		return new DragEditPartsTracker (this) {
			// Makes sure that the request is restricted in the y direction
			protected void updateTargetRequest () {
				super.updateTargetRequest ();
				ChangeBoundsRequest request = (ChangeBoundsRequest )getTargetRequest();
				request.setMoveDelta(new Point (request.getMoveDelta().x, 0));
			}	
		};
	}
	/* (non-Javadoc)
	 * @see org.eclipse.gef.EditPart#showSourceFeedback(org.eclipse.gef.Request)
	 */
	public void showSourceFeedback(Request request) {
		super.showSourceFeedback (request);
	}
}
