/*
 * Created on Nov 5, 2003
 * 
 */
package AcmeDiagramLegend.parts;

import java.util.Iterator;
import java.util.List;

import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.commands.CompoundCommand;
import org.eclipse.gef.editpolicies.ComponentEditPolicy;
import org.eclipse.gef.requests.GroupRequest;

import AcmeDiagramLegend.actions.ItemLifecycleCommand;
import AcmeDiagramLegend.model.AcmeLegend;
import AcmeDiagramLegend.model.AcmeLegendItemDescription;
import AcmeDiagramLegend.model.AcmeLegendItemIcon;

/**
 * @author Bradley Schmerl
 *
 */
public class LegendElementEditPolicy
    extends ComponentEditPolicy
    implements EditPolicy {

    /* (non-Javadoc)
     * @see org.eclipse.gef.editpolicies.ComponentEditPolicy#createDeleteCommand(org.eclipse.gef.requests.GroupRequest)
     */
    protected Command createDeleteCommand(GroupRequest deleteRequest) {
        int i=0;
        
        List editParts = deleteRequest.getEditParts();
        if (editParts.size() > 1) return null;
        CompoundCommand command = new CompoundCommand ("Delete items");
        for (Iterator iter = editParts.iterator(); iter.hasNext();) {
            EditPart ep = (EditPart) iter.next();
            AcmeLegendItemDescription desc = null;
            AcmeLegendItemIcon icon = null;
            LegendEditPart lep = null;
            
            if (ep instanceof LegendItemDescriptionEditPart) {
				LegendItemDescriptionEditPart descEp = (LegendItemDescriptionEditPart) ep;
				lep = (LegendEditPart )descEp.getParent ();
				int index = ((AcmeLegend )lep.getModel ()).getItems ().indexOf (descEp.getModel ());
				index--;
				desc = (AcmeLegendItemDescription )descEp.getModel();
				icon = (AcmeLegendItemIcon )((AcmeLegend )lep.getModel ()).getItems ().get (index);
				
			}
            else if (ep instanceof LegendItemIconEditPart) {
				LegendItemIconEditPart iconEp = (LegendItemIconEditPart) ep;
				lep = (LegendEditPart )iconEp.getParent ();
				int index = ((AcmeLegend )lep.getModel ()).getItems ().indexOf (iconEp.getModel ());
				index++;
				desc = (AcmeLegendItemDescription )((AcmeLegend )lep.getModel ()).getItems ().get (index);
				icon = (AcmeLegendItemIcon )iconEp.getModel ();
			}
            ItemLifecycleCommand del = new ItemLifecycleCommand (lep, ItemLifecycleCommand.REMOVE_ITEM);
            del.setItemDescription (desc);
            del.setItemIcon(icon);
            del.setLegend ((AcmeLegend )lep.getModel ());
            command.add (del);
            
       
            i++;
        }
        if (command.size() > 0)
            return command;
        else
            return null;
    }

}
