/*
 * Created on Nov 5, 2003
 * 
 */
package AcmeDiagramLegend.parts;

import org.eclipse.draw2d.ColorConstants;
import org.eclipse.draw2d.IFigure;
import org.eclipse.gef.GraphicalEditPart;
import org.eclipse.gef.Request;
import org.eclipse.gef.RequestConstants;
import org.eclipse.gef.editpolicies.GraphicalEditPolicy;
import org.eclipse.swt.graphics.Color;

/**
 * @author Bradley Schmerl
 *
 */
public class LegendHighlightEditPolicy extends GraphicalEditPolicy {
    private Color _revertColor;
    
    public void eraseTargetFeedback (Request r) {
        if (_revertColor != null) {
            setContainerBackground (_revertColor);
            _revertColor = null;
        }
    }
    
    /**
     * @param color
     */
    private void setContainerBackground(Color color) {
        getContainerFigure ().setBackgroundColor(color);
    }

    private Color getContainerBackground () {
        return getContainerFigure ().getBackgroundColor ();
    }

    /**
     * @return
     */
    private IFigure getContainerFigure() {
        return ((GraphicalEditPart )getHost ()).getFigure ();
    }
    
    
    /* (non-Javadoc)
     * @see org.eclipse.gef.EditPolicy#showTargetFeedback(org.eclipse.gef.Request)
     */
    public void showTargetFeedback(Request request) {
        if (request.getType ().equals (RequestConstants.REQ_MOVE) ||
                request.getType ().equals (RequestConstants.REQ_ADD) ||
                request.getType ().equals (RequestConstants.REQ_RESIZE) ||
                request.getType ().equals (RequestConstants.REQ_CREATE)) {
            showHighlight ();
        }
    }

    /**
     * 
     */
    private void showHighlight() {
        if (_revertColor == null) {
            _revertColor = getContainerBackground();
            setContainerBackground(ColorConstants.lightBlue);
        }
    }

}
