/*
 * Created on Jan 31, 2004
 *
 * To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package AcmeDiagramLegend.parts;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.gef.EditPolicy;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.ImageData;
import org.eclipse.swt.widgets.Display;
import AcmeDiagramLegend.AcmeDiagramLegendPlugin;
import AcmeDiagramLegend.figures.LegendItemIcon;
import AcmeDiagramLegend.model.AcmeLegendItemIcon;
import AcmeStudio.ui.editors.diagram.parts.ElementEditPart;
import AcmeStudio.ui.editors.diagram.styles.ElementVisualization;
import AcmeStudio.ui.editors.diagram.styles.VisualStyleRegistry;
import AcmeStudio.ui.editors.diagram.styles.constants.LabelOptions;
import AcmeStudio.util.Helper;
import AcmeStudio.util.Utils;
import acmeLib.core.globals.CategoryT;
import acmeLib.elements.*;

/**
 * @author schmerl
 *
 * To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class LegendItemIconEditPart extends ElementEditPart  {
	private ElementVisualization _vis = null;
	private ElementVisualization _visNoLabel = null;
	private PropertyChangeListener _visualizationChangedListener;
//	private Image _localImage = null;
	
	/* (non-Javadoc)
	 * @see org.eclipse.gef.editparts.AbstractEditPart#createEditPolicies()
	 */
	protected void createEditPolicies() {
		installEditPolicy (EditPolicy.COMPONENT_ROLE, new LegendElementEditPolicy ());
	}

	/* (non-Javadoc)
	 * @see org.eclipse.gef.editparts.AbstractGraphicalEditPart#createFigure()
	 */
	protected IFigure createFigure() {
//		ImageFigure figure = new ImageFigure ();
		LegendItemIcon label = new LegendItemIcon ();
		AcmeLegendItemIcon item = (AcmeLegendItemIcon )getModel ();
		label.setModel ((AcmeElement )item.getType ());
		return label;
	}

	/* (non-Javadoc)
	 * @see org.eclipse.gef.editparts.AbstractEditPart#refreshVisuals()
	 */
	protected void refreshVisuals() {
		AcmeLegendItemIcon item = (AcmeLegendItemIcon )getModel ();
//		AcmeLegendItemIcon item = (AcmeLegendItemIcon )getModel ();
		LegendItemIcon label = (LegendItemIcon )getFigure ();
		label.setModel ((AcmeElement )item.getType ());
//		ImageFigure icon = (ImageFigure )getFigure ();
//		if (_localImage != null) {
//			_localImage.dispose ();
//			_localImage = null;
//		}
		if (_visNoLabel != null) {
			boolean useLargeIcon = AcmeDiagramLegendPlugin.getDefault ().getPreferenceStore ().getBoolean ("LegendItem.UseLargeIcons");
			int maxIconWidth = AcmeDiagramLegendPlugin.getDefault ().getPreferenceStore().getInt ("AcmeLegend.maxItemWidth");
			int maxIconHeight = AcmeDiagramLegendPlugin.getDefault ().getPreferenceStore().getInt ("AcmeLegend.maxItemHeight");
			if (useLargeIcon) {
			
				if (label.getBounds().height > maxIconHeight) {
					label.setSize(new Dimension (label.getSize ().width, maxIconHeight));
				}
				if (label.getBounds ().width > maxIconWidth) {
					label.setSize (new Dimension (maxIconWidth, label.getSize ().height));
				}
				
				
			}
			else {
				int imageHeight = _visNoLabel.getSize ().height;
				int imageWidth = _visNoLabel.getSize ().width;
				float aspectRatio = (float )imageHeight/(float )imageWidth;
				if (imageHeight > 12) {
					imageHeight = 12;
					imageWidth = Utils.zeroGuard((int )(12/aspectRatio));
					if (imageWidth < 3) imageWidth = 20;
				}
				if (imageWidth > 20) {
					imageWidth = 20;
					imageHeight = Utils.zeroGuard ((int )(20*aspectRatio));
				}
				_visNoLabel.setSize(new Dimension (imageWidth, imageHeight));

				if (label.getType() != CategoryT.ACME_ROLE_TYPE) 
					label.setSize (imageWidth, imageHeight);
				else // make room for the line
					label.setSize (imageWidth + 5, imageHeight);
			}
			
		
		}
		
	}

	
	
	/* (non-Javadoc)
	 * @see org.eclipse.gef.EditPart#setModel(java.lang.Object)
	 */
	public void setModel(Object model) {
		super.setModel(model);
		AcmeLegendItemIcon item = (AcmeLegendItemIcon )model;
		AcmeElementType type = item.getType ();
		AcmeElement element = item.getElement ();
		if (type != null) {
			_vis = VisualStyleRegistry.getVisualization (item.getType ());
		}
		else {
			_vis = Helper.getVisualInformation(element).getVisualization();
		}
		
		if (_visualizationChangedListener == null) {
			_visualizationChangedListener = new PropertyChangeListener () {
				public void propertyChange (PropertyChangeEvent evt) {
					LegendItemIconEditPart.this.changeVisualization ();
					LegendItemIconEditPart.this.refresh ();
				}
			};
			_vis.addPropertyChangeListener(null, _visualizationChangedListener);
		}
		changeVisualization ();
		LegendItemIcon iconFigure = (LegendItemIcon )getFigure ();
		if (type instanceof AcmeComponentType || element instanceof AcmeComponent) iconFigure.setType (CategoryT.ACME_COMPONENT_TYPE);
		else if (type instanceof AcmeConnectorType || element instanceof AcmeConnector) iconFigure.setType (CategoryT.ACME_CONNECTOR_TYPE);
		else if (type instanceof AcmePortType || element instanceof AcmePort) iconFigure.setType (CategoryT.ACME_PORT_TYPE);
		else if (type instanceof AcmeRoleType || element instanceof AcmeRole)iconFigure.setType(CategoryT.ACME_ROLE_TYPE);
	}

	/**
	 * 
	 */
	protected void changeVisualization() {
		if (_visNoLabel != null) _visNoLabel.dispose();
		
		AcmeLegendItemIcon item = (AcmeLegendItemIcon )getModel ();
		_visNoLabel = _vis.copy(item.getType()!=null?(AcmeElement )item.getType ():item.getElement ());
		_visNoLabel.setLabelSource(LabelOptions.NOLABEL);
	}

	/* (non-Javadoc)
	 * @see org.eclipse.gef.EditPart#deactivate()
	 */
	public void deactivate() {
		super.deactivate();
		if (_vis != null && _visualizationChangedListener != null) {
			_vis.removePropertyChangeListener(null, _visualizationChangedListener);
			_visualizationChangedListener = null;
			if (_visNoLabel != null) {
				_visNoLabel.dispose ();
				_visNoLabel = null;
			}
		}
	}

}
