package AcmeStudio;

import org.eclipse.ui.IPageLayout;
import org.eclipse.ui.IPerspectiveFactory;

/**
 * Defines the layout and actions available in this perspective.
 * @see IPerspectiveFactory
 */
public class PerspectiveFactory implements IPerspectiveFactory {

	public PerspectiveFactory() {
	}

	/**
	 * Defines the initial layout for a perspective.  
	 *
	 * Implementors of this method may add additional views to a
	 * perspective.  The perspective already contains an editor folder
	 * with <code>ID = ILayoutFactory.ID_EDITORS</code>.  Add additional views
	 * to the perspective in reference to the editor folder.
	 *
	 * This method is only called when a new perspective is created.  If
	 * an old perspective is restored from a persistence file then
	 * this method is not called.
	 *
	 * @param factory the factory used to add views to the perspective
	 */
	public void createInitialLayout(IPageLayout layout) {
		defineActions(layout);
		defineLayout(layout);
	}

	private void defineActions(IPageLayout layout) {
		// Add "NeoAcmeStudio Perspective"
//        layout.addPerspectiveShortcut("AcmeStudio");

		// Add "new wizards".
//        layout.addNewWizardShortcut("AcmeStudio.wizards.AcmeStudioNewSystemWizard");
//        layout.addNewWizardShortcut("AcmeStudio.wizards.AcmeStudioNewFamilyWizard");
        
		// Add "show views".
//        layout.addShowViewShortcut("AcmeStudio.ui.views.ElementView");
//        layout.addShowViewShortcut(IPageLayout.ID_RES_NAV);
//        layout.addShowViewShortcut(IPageLayout.ID_TASK_LIST);

//        layout.addShowViewShortcut(IPageLayout.ID_BOOKMARKS);
//        layout.addShowViewShortcut(IPageLayout.ID_OUTLINE);
//        layout.addShowViewShortcut(IPageLayout.ID_PROP_SHEET);
		
//        layout.addActionSet("AcmeStudio_import_export");
//        layout.addActionSet ("AcmeStudio_builtin_analyses");
//        layout.addActionSet ("AcmeStudio_menus");
	}

	private void defineLayout(IPageLayout layout) {
		// Editors are placed for free.
//        String editorArea = layout.getEditorArea();

        // Top left.
//        IFolderLayout topLeft =
//            layout.createFolder("topLeft", IPageLayout.LEFT, (float) 0.26, editorArea);
//        topLeft.addView(IPageLayout.ID_RES_NAV);
        
//        topLeft.addPlaceholder("AcmeStudio.ui.views.TypeHierarchyView");       


        // Top right.
//        IPlaceholderFolderLayout topRight =
//            layout.createPlaceholderFolder("hierarchyPlace", IPageLayout.LEFT, (float) 0.65, editorArea);


		// Bottom left.
//        IFolderLayout bottomLeft =
//            layout.createFolder("bottomLeft", IPageLayout.BOTTOM, (float) 0.50, "topLeft");
//        bottomLeft.addView(IPageLayout.ID_OUTLINE);

		// Bottom right.
//        IFolderLayout bottomRight =
//            layout.createFolder("bottomRight", IPageLayout.BOTTOM, (float) 0.66, editorArea);
//        bottomRight.addView("AcmeStudio.ui.views.ElementView");
//        bottomRight.addView(IPageLayout.ID_TASK_LIST);
//        bottomRight.addView(IPageLayout.ID_PROP_SHEET);
	}

}