package AcmeStudio.core;

/**
 * @author Shang-Wen Cheng (zensoul@cs.cmu.edu)
 *
 * Status code constants used to indicate the status of CoreException.
 */
public interface ASStatus_Constants {

    // Normal code

    // Property-related status codes (0x100s)
    /** This property is undefined in the resource bundle from which a
     * retrieval was attempted. */
    public static int UNDEFINED_PROPERTY = 0x101;
    
    // File-related status codes (0x1000s)
    /** File does not exist, is a directory, or cannot be open for read for some reason. */
    public static int FILE_NOT_FOUND = 0x1001;
    /** File not synchronized. */
    public static int FILE_NOT_SYNCHRONIZED = 0x1002;
    /** Resource file type is not recognized. */
    public static int RESOURCE_TYPE_UNRECOGNIZED = 0x1003;
    /** Unrecognized/invalid editor input. */
    public static int INVALID_EDITOR_INPUT = 0x1004;
    /** Directory creation failed. */
    public static int DIRECTORY_CREATION_FAILED = 0x1005;
    /** IOException problem. */
    public static int IO_ERROR = 0x1006;

    // ASResource-related status code (0x2000s)
    /** The ASResource has null file. */
    public static int NULL_ASRESOURCE_FILE = 0x2001;
    /** The AcmeElement within an ASResource is null. */
    public static int NULL_ACME_ELEMENT = 0x2002;
    /** An Editor is null. */
    public static int NULL_EDITOR = 0x2003;

    // Acme-related status code (0x3000s)
    /** Generic Acme error occurred */
    public static int ACME_ERROR = 0x3001;
}
