package AcmeStudio.core;

/**
 * @author Shang-Wen Cheng (zensoul@cs.cmu.edu)
 *
 * Interface for an AcmeStudio context listener.<br>
 * <br>
 * Any object interested in the current context of AcmeStudio should implement
 * this interface and subscribe itself to ASContext.getContext()
 */
public interface IASContextListener {
    /**
     * Notifies that AcmeStudio context has changed.
     * @param event  the context event object
     */
    public void contextChanged (ASContextEvent event);
}
