/*
 * Created on Jan 26, 2004
 *
 */
package AcmeStudio.core.actions;

import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.IWorkbenchWindowActionDelegate;

import AcmeStudio.util.Helper;
import acmeLib.elements.AcmeElement;
import acmeLib.elements.AcmeSystem;



/**
 * @author Bradley Schmerl
 * Created Jan 26, 2004
 */
public class ForceSystemReevaluationAction implements IWorkbenchWindowActionDelegate {

	private AcmeSystem _system;

	/**
	 * 
	 */
	public ForceSystemReevaluationAction() {
		super();
	}

	/* (non-Javadoc)
	 * @see org.eclipse.ui.IWorkbenchWindowActionDelegate#dispose()
	 */
	public void dispose() {
	}

	/* (non-Javadoc)
	 * @see org.eclipse.ui.IWorkbenchWindowActionDelegate#init(org.eclipse.ui.IWorkbenchWindow)
	 */
	public void init(IWorkbenchWindow window) {
	}

	/* (non-Javadoc)
	 * @see org.eclipse.ui.IActionDelegate#run(org.eclipse.jface.action.IAction)
	 */
	public void run(IAction action) {
		_system.typecheck ();
	}

	/* (non-Javadoc)
	 * @see org.eclipse.ui.IActionDelegate#selectionChanged(org.eclipse.jface.action.IAction, org.eclipse.jface.viewers.ISelection)
	 */
	public void selectionChanged(IAction action, ISelection selection) {
		action.setEnabled (false);
		AcmeElement [] elements = Helper.getAcmeElementsFromSelection(selection);
		if (elements != null && elements.length > 0) {
			_system = Helper.getAcmeSystem(elements [0]);
			action.setEnabled (true);
		}
	}
	
}
