/*
 * Created on May 15, 2003
 *
 */
package AcmeStudio.core.actions;

import org.eclipse.jface.action.Action;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.IWorkbenchWindowActionDelegate;

import AcmeStudio.ui.views.TypeHierarchyView;
import acmeLib.elements.AcmeElement;

/**
 * @author schmerl
 */
public class OpenTypeHierarchyAction extends Action implements IWorkbenchWindowActionDelegate {

    private IWorkbenchWindow _window;
    private AcmeElement _element;
    
    public static final String ID = "$OITH$";
    
    public OpenTypeHierarchyAction() {
        super ();
        setId (ID);
        setText("Open in Type Browser");
        setDescription ("Opens the type hierarchy browser");
    }

    /* (non-Javadoc)
     * @see org.eclipse.ui.IWorkbenchWindowActionDelegate#dispose()
     */
    public void dispose() {

    }

    /* (non-Javadoc)
     * @see org.eclipse.ui.IWorkbenchWindowActionDelegate#init(org.eclipse.ui.IWorkbenchWindow)
     */
    public void init(IWorkbenchWindow window) {
        _window = window;
    }

    /* (non-Javadoc)
     * @see org.eclipse.ui.IActionDelegate#run(org.eclipse.jface.action.IAction)
     */
    public void run(IAction action) {
        run ();
    }

    /* (non-Javadoc)
     * @see org.eclipse.ui.IActionDelegate#selectionChanged(org.eclipse.jface.action.IAction, org.eclipse.jface.viewers.ISelection)
     */
    public void selectionChanged(IAction action, ISelection selection) {

    }

    /* (non-Javadoc)
     * @see org.eclipse.jface.action.IAction#run()
     */
    public void run() {
        TypeHierarchyView.open (_element, _window);
    }
    
    public void setElement (AcmeElement element) {
        _element = element;
    }

}
