package AcmeStudio.core.resource;

import org.eclipse.core.runtime.CoreException;

/**
 * @author Shang-Wen Cheng (zensoul@cs.cmu.edu)
 *
 * AcmeStudio Family resource type.
 */
public class ASFamily extends ASDesign {

    /** File extension of the ASFamily resource */
    public static String FILE_EXT = _resource_nls.getString("ASResource.familyExt");
    /** The shared null instance of this class */
     protected static IASResource _nullInstance = null;

    /**
     * Creates an empty ASFamily object.
     * @param parent  the parent IASResource object.
     */
    public ASFamily (IASResource parent) {
        super(parent, null);
    }

    /**
     * Returns a null instance of this type.  This method is useful for passing
     * IASResource objects around to identify the resource "types," as used, for
     * example, in ASRegistry.
     * @return IASResource  the null instance
     */
    public static IASResource nullInstance () {
        if (_nullInstance == null) {  // lazy init
            _nullInstance = new ASFamily(null);
        }
        return _nullInstance;
    }

    /**
     * @see AcmeStudio.core.resource.IASResource#getNewInstance(IASResource)
     */
    public IASResource getNewInstance (IASResource parent) throws CoreException {
        return new ASFamily(parent);
    }

    /**
     * @see AcmeStudio.core.resource.IASResource#isSameType(IResource)
     */
    public boolean isSameType (Object resource) {
        boolean retVal = false;

        String ext = getFileExt(resource);
        if (ext != null && ext.equals(FILE_EXT)) {
            // matches
            retVal = true;
        }

        return retVal;
    }

}
