package AcmeStudio.core.resource;

import java.util.Iterator;
import java.util.List;

import org.eclipse.core.runtime.IPath;

/**
 * @author Shang-Wen Cheng (zensoul@cs.cmu.edu)
 *
 * A specialized iterator that returns an IPath when nextPath() is invoked.
 */
public class ASPathIterator implements Iterator {

    /** The internal iterator instance */
    private Iterator _pathIter = null;

    /**
     * Constructor for ASPathIterator.
     */
    public ASPathIterator (List pathList) {
        super();
        
        _pathIter = pathList.iterator();
    }

    /**
     * @see java.util.Iterator#hasNext()
     */
    public boolean hasNext () {
        return _pathIter.hasNext();
    }

    /**
     * @see java.util.Iterator#next()
     */
    public Object next () {
        return _pathIter.next();
    }

    /**
     * Returns the next IPath instance in this path list.
     * @return IPath  next IPath
     */
    public IPath nextPath () {
        return (IPath) next();
    }

    /**
     * @see java.util.Iterator#remove()
     */
    public void remove () {
        _pathIter.remove();
    }
}
