/*
 * Created on Apr 5, 2003
 */
package AcmeStudio.core.resource;

/**
 * @author Shang-Wen Cheng (zensoul@cs.cmu.edu)
 *
 * Event notifying of a change in an ASResource.
 */
public interface IASResourceChangeEvent {
    public final static int NONE = 0x00;
    public final static int SELF_CHANGED = 0x01;
    public final static int ANCESTOR_CHANGED = 0x02;
    public final static int SELF_CHANGED_EXTERNALLY = 0x04;
    public final static int REMOVED = 0x08;

    /**
     * Returns the source of the resource change.
     * @return IASResource
     */
    public IASResource getSource ();

    /**
     * Returns the type of the IASResource change, refer to static constants
     * of this interface, IASResourceChangeEvent.
     * @return int  the change type
     */
    public int getType ();
}
