/*
 * Created on Mar 20, 2003
 */

package AcmeStudio.core.resource.provider;

import org.eclipse.jface.text.DocumentEvent;
import org.eclipse.jface.text.IDocumentListener;


/**
 * @author Shang-Wen Cheng (zensoul@cs.cmu.edu)
 *
 * Listener to the state of the document held by the AcmeDocumentProvider
 * used by the AcmeTextEditor.
 */
public class ASDocumentListener implements IDocumentListener {

	private final ASResourceProvider _provider;

	/**
	 * @param ASResourceProvider
	 */
	public ASDocumentListener(ASResourceProvider provider) {
		_provider = provider;
	}
    /**
     * @see org.eclipse.jface.text.IDocumentListener#documentAboutToBeChanged(DocumentEvent)
     */
    public void documentAboutToBeChanged(DocumentEvent event) {
//        Debug.traceln("ASDocumentListener.documentAboutToBeChanged():  length == " + event.getLength());
    }

    /**
     * @see org.eclipse.jface.text.IDocumentListener#documentChanged(DocumentEvent)
     */
    public void documentChanged(DocumentEvent event) {
        if (! _provider.isDirty()) {
            _provider.setDirty(true);
        }
        // Changes invalidate the region, could do something
        // smart here like increment all the regions, but this
        // would take too much time!
        _provider.setRegionManagerValid (false);
        _provider.setSynchedWithText(false);
//        int len = event.getText().length();
//        if (Debug.getInstance().isTraceOn()) {
//            String text = "";
//            if (len > 0) {
//                text += ", added " + len + " == [" +
//                    event.getText().substring(0, (len > 20) ? 20 : len);
//                text += ((len > 20) ? "...]" : "]");
//            } else {
//                text += ".";
//            }
//            Debug.traceln("ASDocumentListener.documentChanged():  replaced "
//                + event.getLength() + " chars" + text);
//        }
        // increment by both deletion & addition length
//        _provider.incrContentChangeCnt(event.getLength() + len);
    }
}
