/*
 * Created on Mar 20, 2003
 */
package AcmeStudio.core.resource.provider;

import org.eclipse.core.resources.IMarker;
import org.eclipse.core.resources.IMarkerDelta;
import org.eclipse.core.resources.IResourceDelta;
import org.eclipse.ui.IFileEditorInput;
import org.eclipse.ui.texteditor.ResourceMarkerAnnotationModel;


public class AcmeSourceAnnotationModel extends ResourceMarkerAnnotationModel {
		public AcmeSourceAnnotationModel (ASResourceProvider provider, IFileEditorInput input) {
            super (input.getFile ());

			listenToMarkerChanges(true);
        }

//        protected MarkerAnnotation createMarkerAnnotation (IMarker marker) {
//            return new AcmeMarkerAnnotation (marker);
//        }
        
        /* (non-Javadoc)
         * @see org.eclipse.ui.texteditor.ResourceMarkerAnnotationModel#update(org.eclipse.core.resources.IMarkerDelta[])
         */
        protected void update(IMarkerDelta[] markerDeltas) {
            if (markerDeltas.length == 0) return;
            
            for (int i = 0; i < markerDeltas.length; i++) {
                IMarkerDelta delta = markerDeltas [i];
                switch (delta.getKind ()) {
                case IResourceDelta.ADDED:
                
                    addMarkerAnnotation (delta.getMarker ());
                    break;
                case IResourceDelta.REMOVED:
                    removeMarkerAnnotation (delta.getMarker ());
                    break;
                case IResourceDelta.CHANGED:
                    IMarker marker = delta.getMarker ();

                        if (getMarkerAnnotation(marker) == null) {
                            addMarkerAnnotation (delta.getMarker ());    
                        }
                        else {
                            modifyMarkerAnnotation (delta.getMarker ());
                        }
                    
                }   
            }
        }

    }