package AcmeStudio.core.resource.provider;

/**
 * The event class for a IResourceProvider change.
 * 
 * @author Shang-Wen Cheng (zensoul@cs.cmu.edu)
 */
public class ResourceProviderEvent {

    // Kind of ASResourceProvider events
    /** No knowable change */
    public static final int NONE = 0x0;
    /** Resource managed by provider about to be removed */
    public static final int ABOUT_TO_REMOVE = 0x01;
    /** ASResource managed by provider got reloaded (e.g., should renew pages!) */
    public static final int AS_RESOURCE_RELOADED = 0x02;
    /** Provider synch status changed */
    public static final int SYNC_STATUS_CHANGED = 0x04; 
    /** ASResource managed by provider needs to be reloaded (e.g., should reconnnect AND renew pages!) */
    public static final int AS_RESOURCE_NEED_RELOAD = 0x10;

    /** Provider text region manager status changed **/
    public static final int REGION_MANAGER_CHANGED = 0x08;
    private ASResourceProvider _prov = null;
    private int _kind = NONE;

    /**
     * Constructor for ResourceProviderEvent.
     */
    public ResourceProviderEvent (ASResourceProvider prov, int kind) {
        super();
        
        _prov = prov;
        _kind = kind;
    }

    public ASResourceProvider getProvider () {
        return _prov;
    }
    
    public int getKind () {
        return _kind;
    }
}
