package AcmeStudio.model;

import acmeLib.elements.AcmeComponent;
import acmeLib.elements.AcmeConnector;
import acmeLib.elements.AcmeElement;
import acmeLib.elements.AcmeSystem;

public class AddElementCommand
	extends ModelCommand {

	private AcmeElement child;
	private AcmeSystem parent;

	public AddElementCommand() {
		super("AddCommand");
	}

	public void execute() {
		try {
			if (child instanceof AcmeComponent)
				parent.addComponent((AcmeComponent) child);
			else if (child instanceof AcmeConnector)
				parent.addConnector((AcmeConnector) child);
		} catch (Exception e) {
            _errorReason = e;
		}
	}

	public String getDescription() {
		String name = child.getQualifiedName();
		return "Add " + name;
	}

	public AcmeSystem getParent() {
		return parent;
	}

	public void redo() {
		try {
			if (child instanceof AcmeComponent)
				parent.addComponent((AcmeComponent) child);
			else if (child instanceof AcmeConnector)
				parent.addConnector((AcmeConnector) child);
		} catch (Exception e) {
            _errorReason = e;
		}
	}

	public void setChild(AcmeElement child) {
		this.child = child;
	}

	public void setParent(AcmeSystem parent) {
		this.parent = parent;
	}

	public void undo() {
		try {
			if (child instanceof AcmeComponent)
				parent.removeComponent((AcmeComponent) child);
			else if (child instanceof AcmeConnector)
				parent.removeConnector((AcmeConnector) child);
		} catch (Exception e) {
            _errorReason = e;
		}

	}

}