package AcmeStudio.model;

import AcmeStudio.util.AcmeStudioChangeManager;
import acmeLib.AcmeObject;
import acmeLib.properties.AcmeProperty;
import acmeLib.properties.AcmePropertyBearer;
import acmeLib.properties.AcmePropertyValue;

/**
 * @author schmerl
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class ChangePropertyCommand extends ModelCommand {

    AcmeProperty property;
    AcmePropertyValue newValue;
    AcmePropertyValue oldValue;
    AcmeObject target;
    
    /**
     * Constructor for ChangePropertyCommand.
     */
    public ChangePropertyCommand() {
        super("Change Property");
    }

    

    /**
     * @see org.eclipse.gef.commands.Command#canExecute()
     */
    public boolean canExecute() {
        return super.canExecute();
    }

    /**
     * @see org.eclipse.gef.commands.Command#canUndo()
     */
    public boolean canUndo() {
        return super.canUndo();
    }

    /**
     * @see org.eclipse.gef.commands.Command#execute()
     */
    public void execute() {
        setLabel ("Change " + property.getName ());
        primExecute ();
    }

    /**
     * @see org.eclipse.gef.commands.Command#redo()
     */
    public void redo() {
        primExecute ();
    }

    /**
     * @see org.eclipse.gef.commands.Command#undo()
     */
    public void undo() {
        property.setValue (oldValue);
        if (target instanceof AcmePropertyBearer) {
            AcmeStudioChangeManager.globalChangeManager.onSetProperty ((AcmePropertyBearer )target, property, oldValue, this);
        }          
    }

    protected void primExecute () {
        oldValue = property.getValue ();
        property.setValue (newValue);
        if (target instanceof AcmePropertyBearer)
        AcmeStudioChangeManager.globalChangeManager.onSetProperty ((AcmePropertyBearer )target, property, newValue, this);            
      }

    /**
     * Sets the newValue.
     * @param newValue The newValue to set
     */
    public void setNewValue(AcmePropertyValue newValue) {
        this.newValue = newValue;
    }

    /**
     * Sets the property.
     * @param property The property to set
     */
    public void setProperty(AcmeProperty property) {
        this.property = property;
    }

    /**
     * Sets the target.
     * @param target The target to set
     */
    public void setTarget(AcmeObject target) {
        this.target = target;
    }

}
