/*
 * Created on Mar 3, 2003
 *
 */
package AcmeStudio.prefs;

import org.eclipse.jface.preference.FieldEditorPreferencePage;
import org.eclipse.jface.preference.IPreferenceStore;
import org.eclipse.jface.preference.RadioGroupFieldEditor;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPreferencePage;

import AcmeStudio.AcmeStudioPlugin;
import AcmeStudio.util.DesignRuleHolder;

/**
 * @author schmerl
 */
public class ArmaniPreferences extends FieldEditorPreferencePage implements IWorkbenchPreferencePage{

    public ArmaniPreferences () {
        super ("Constraints", GRID);
    }

    /* (non-Javadoc)
     * @see org.eclipse.jface.preference.FieldEditorPreferencePage#createFieldEditors()
     */
    protected void createFieldEditors() {
        RadioGroupFieldEditor analysisGroup = 
            new RadioGroupFieldEditor (
                "ConstraintEvaluation",
                "Evaluation",
                1,
                new String [][] {
                    {"Do not evaluate constraints", DesignRuleHolder.NOEVALUATION},
                    {"Evaluate constraints in background", DesignRuleHolder.BACKGROUNDEVALUATION},
                    {"Pause while constraints are evaluated", DesignRuleHolder.FOREGROUNDEVALUATION}
                },
                getFieldEditorParent(), true);
        addField (analysisGroup);
    }

    /* (non-Javadoc)
     * @see org.eclipse.ui.IWorkbenchPreferencePage#init(org.eclipse.ui.IWorkbench)
     */
    public void init(IWorkbench workbench) {

    }

    /* (non-Javadoc)
     * @see org.eclipse.jface.preference.PreferencePage#doGetPreferenceStore()
     */
    protected IPreferenceStore doGetPreferenceStore() {
        return AcmeStudioPlugin.getDefault().getPreferenceStore();
    }

}
