/*******************************************************************************
 * Copyright (c) 2000, 2003 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/cpl-v10.html
 * 
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/

package AcmeStudio.prefs;

import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPreferencePage;

import AcmeStudio.ui.editors.diagram.styles.ElementVisualization;
import AcmeStudio.ui.editors.diagram.styles.VisualStyleRegistry;
import acmeLib.elements.AcmeComponentType;

/**
 * The preference page for setting the editor options.
 * <p>
 * This class is internal and not intended to be used by clients.</p>
 * 
 * @since 2.1
 */
public class ComponentVisPreferences
    extends VisPreferences
    implements IWorkbenchPreferencePage {
    
    public ComponentVisPreferences() {
        setDescription(null);
        _style = ElementVisualization.DEFAULT_COMPONENT;
        _type = new AcmeComponentType("CompT");
        _storeType = "ComponentVisualization.";
        _vis = loadVisFromStore(_style);        
    }

    /*
     * @see PreferencePage#createContents(Composite)
     */
    protected Control createContents(Composite parent) {
        return super.createContentsArea(parent);
    }

    /* (non-Javadoc)
     * @see org.eclipse.ui.IWorkbenchPreferencePage#init(org.eclipse.ui.IWorkbench)
     */
    public void init(IWorkbench workbench) {
        // TODO Auto-generated method stub

    }
    
    public boolean performOk () {
    	VisualStyleRegistry.DEFAULT_COMPONENT_VISUALIZATION.copyInto(_vis);
    	return super.performOk();
    }
    
    public void performApply () {
    	VisualStyleRegistry.DEFAULT_COMPONENT_VISUALIZATION.copyInto(_vis);
    }

}
