package AcmeStudio.prefs;

import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPreferencePage;

import AcmeStudio.ui.editors.diagram.styles.ElementVisualization;
import AcmeStudio.ui.editors.diagram.styles.VisualStyleRegistry;
import acmeLib.elements.AcmeConnectorType;

/**
 * The preference page for setting the editor options.
 * <p>
 * This class is internal and not intended to be used by clients.</p>
 * 
 * @since 2.1
 */
public class ConnectorVisPreferences
    extends VisPreferences
    implements IWorkbenchPreferencePage {
    
    public ConnectorVisPreferences() {
        setDescription(null);
        _style = ElementVisualization.DEFAULT_CONNECTOR;
        _type = new AcmeConnectorType("ConnT");
        _storeType = "ConnectorVisualization.";
        _vis = loadVisFromStore(_style);        
    }

    /*
     * @see PreferencePage#createContents(Composite)
     */
    protected Control createContents(Composite parent) {
        return super.createContentsArea(parent);
    }

    /* (non-Javadoc)
     * @see org.eclipse.ui.IWorkbenchPreferencePage#init(org.eclipse.ui.IWorkbench)
     */
    public void init(IWorkbench workbench) {
    }
    public boolean performOk () {
    	VisualStyleRegistry.DEFAULT_CONNECTOR_VISUALIZATION.copyInto(_vis);
    	return super.performOk();
    }
    
    public void performApply () {
    	VisualStyleRegistry.DEFAULT_CONNECTOR_VISUALIZATION.copyInto(_vis);
    }
}
