/*
 * Created on Apr 29, 2003
 * 
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package AcmeStudio.prefs;

import org.eclipse.gef.SnapToGrid;
import org.eclipse.jface.preference.BooleanFieldEditor;
import org.eclipse.jface.preference.IPreferenceStore;
import org.eclipse.jface.preference.IntegerFieldEditor;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Group;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPreferencePage;
import AcmeStudio.AcmeStudioPlugin;
import com.swtdesigner.FieldLayoutPreferencePage;
/**
 * @author schmerl
 * 
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class DiagramEditorPreferences extends FieldLayoutPreferencePage implements IWorkbenchPreferencePage {

	public static final String	JUMP_INTERSECTIONS			= "DiagramEditor.JumpIntersections";
	public static final String	ROUNDED_CORNERS				= "DiagramEditor.RoundedCorners";
	public static final String	SNAP_TO_GEOMETRY			= "DiagramEditor.snapToGeometry";
	public static final String	GRID_Y_SPACING				= "DiagramEditor.gridYSpacing";
	public static final String	GRID_X_SPACING				= "DiagramEditor.gridXSpacing";
	public static final String	GRID_ENABLED				= "DiagramEditor.gridEnabled";
	public static final String	RULERS_ENABLED				= "DiagramEditor.rulersEnabled";
	public static final String	ORGANIZE_PALETTE	= "DiagramEditor.paletteOrganization";
	public static final String	ORGANIZE_PALETTE_ELEMENT	= "ByElement";
	public static final String	DISPLAY_REPRESENTATION_ICON	= "DiagramEditor.DisplayRepresentationIcon";
	public static final String	AUTO_OPEN_REPRESENTATIONS	= "DiagramEditor.AutoOpenRepresentations";
	public static final String	DISPLAY_FLOATING_ERROR		= "DiagramEditor.DisplayFloatingError";
	public static final String	DISPLAY_ELEMENT_ERROR		= "DiagramEditor.DisplayElementError";
	public static final String	HIGHLIGHTTRANSPARENCY		= "DiagramEditor.highlightTransparency";
	public static final String	HIDETRANSPARENCY			= "DiagramEditor.hideTransparency";
	public static final String	ZOOMTOFITONOPEN				= "DiagramEditor.zoomToFitOnOpen";
	public static final String	ORGANIZE_PALETTE_FAMILY	= "ByFamily";
	public static final String	INLINE_REPRESENTATIONS	= "DiagramEditor.inlineRepresentations";
	
	public DiagramEditorPreferences() {
		super ("Diagram Editor");
	}

	public Control createPageContents(Composite parent) {
		Composite composite;
		Composite container = new Composite (parent, SWT.NULL);
		GridLayout gridLayout = new GridLayout ();
		gridLayout.numColumns = 2;
		container.setLayout (gridLayout);

		Group diagramGroup = new Group(container, SWT.NONE);
		diagramGroup.setText("Diagram options:");
		diagramGroup.setLayoutData(new GridData(GridData.FILL_HORIZONTAL | GridData.VERTICAL_ALIGN_FILL));
		diagramGroup.setLayout(new GridLayout());

		composite = new Composite(diagramGroup, SWT.NONE);

		BooleanFieldEditor zoomToFit = new BooleanFieldEditor(DiagramEditorPreferences.ZOOMTOFITONOPEN, "Zoom to fit diagram when editor is opened.", composite);

		composite = new Composite(diagramGroup, SWT.NONE);
		composite.setLayoutData(new GridData(GridData.HORIZONTAL_ALIGN_FILL));

		IntegerFieldEditor showHideTransparency = new IntegerFieldEditor(DiagramEditorPreferences.HIDETRANSPARENCY, "Transparency of hidden elements (0-100):", composite);
		showHideTransparency.setValidRange(0, 100);

		composite = new Composite(diagramGroup, SWT.NONE);
		composite.setLayoutData(new GridData(GridData.HORIZONTAL_ALIGN_FILL));

		IntegerFieldEditor integerFieldEditor = new IntegerFieldEditor(DiagramEditorPreferences.HIGHLIGHTTRANSPARENCY, "Transparency for highlighting (0-100):", composite);
		integerFieldEditor.setValidRange(0, 100);

		Group gefGroup = new Group(container, SWT.NONE);
		gefGroup.setText("Grids, etc:");
		gefGroup.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
		gefGroup.setLayout(new GridLayout());

		composite = new Composite(gefGroup, SWT.NONE);

		addField(new BooleanFieldEditor(DiagramEditorPreferences.RULERS_ENABLED, "Enable rulers and guides by default.", composite));

		composite = new Composite(gefGroup, SWT.NONE);

		addField(new BooleanFieldEditor(DiagramEditorPreferences.GRID_ENABLED, "Enable grid by default.", composite));

		composite = new Composite(gefGroup, SWT.NONE);

		IntegerFieldEditor xSpacing = new IntegerFieldEditor(DiagramEditorPreferences.GRID_X_SPACING, "Grid X Spacing:", composite);
		xSpacing.setValidRange(1, 1000);

		composite = new Composite(gefGroup, SWT.NONE);

		IntegerFieldEditor ySpacing = new IntegerFieldEditor(DiagramEditorPreferences.GRID_Y_SPACING, "Grid Y Spacing:", composite);
		ySpacing.setValidRange(1, 1000);

		composite = new Composite(gefGroup, SWT.NONE);

		addField(new BooleanFieldEditor(DiagramEditorPreferences.SNAP_TO_GEOMETRY, "Enable snap to geometry by default:", composite));

		Group errorGroup = new Group(container, SWT.NONE);
		errorGroup.setText("Error options:");
		errorGroup.setLayoutData(new GridData(GridData.HORIZONTAL_ALIGN_FILL | GridData.VERTICAL_ALIGN_FILL));
		errorGroup.setLayout(new GridLayout());

		composite = new Composite(errorGroup, SWT.NONE);

		addField(new BooleanFieldEditor(DiagramEditorPreferences.DISPLAY_ELEMENT_ERROR, "Place error icon in elements with errors.", composite));

		composite = new Composite(errorGroup, SWT.NONE);

		addField(new BooleanFieldEditor(DiagramEditorPreferences.DISPLAY_FLOATING_ERROR, "Display floating error if system has an error.", composite));

		Group connectorGroup = new Group(container, SWT.NONE);
		connectorGroup.setLayoutData(new GridData(GridData.HORIZONTAL_ALIGN_FILL));
		connectorGroup.setText("Connector options:");
		connectorGroup.setLayout(new GridLayout());

		composite = new Composite(connectorGroup, SWT.NONE);
		composite.setLayoutData(new GridData());

		addField(new BooleanFieldEditor(DiagramEditorPreferences.ROUNDED_CORNERS, "Round 90 degree corners.", composite));

		composite = new Composite(connectorGroup, SWT.NONE);

		addField(new BooleanFieldEditor(DiagramEditorPreferences.JUMP_INTERSECTIONS, "Draw jumps over intersecting connectors.", composite));

		Group representationGroup = new Group(container, SWT.NONE);
		representationGroup.setText("Representation options:");
		GridData gridData = new GridData(GridData.FILL_HORIZONTAL | GridData.VERTICAL_ALIGN_FILL);
		gridData.horizontalSpan = 2;
		gridData.widthHint = 416;
		representationGroup.setLayoutData(gridData);
		gridLayout = new GridLayout();
		representationGroup.setLayout(gridLayout);

		composite = new Composite(representationGroup, SWT.NONE);

		BooleanFieldEditor repAutoOpen = new BooleanFieldEditor(DiagramEditorPreferences.AUTO_OPEN_REPRESENTATIONS, "Automatically open representations after creating.", composite);

		composite = new Composite(representationGroup, SWT.NONE);

		BooleanFieldEditor repIcon = new BooleanFieldEditor(DiagramEditorPreferences.DISPLAY_REPRESENTATION_ICON, "Place an icon on elements that have representations.", composite);
		BooleanFieldEditor inlineRep = new BooleanFieldEditor (DiagramEditorPreferences.INLINE_REPRESENTATIONS, "Inline representations into the top level components", composite);
		addField(ySpacing);
		addField(xSpacing);
		addField(repIcon);
		addField(repAutoOpen);
		addField(inlineRep);
		addField(xSpacing);
		addField(showHideTransparency);
		addField(zoomToFit);
		return container;
	}
	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.ui.IWorkbenchPreferencePage#init(org.eclipse.ui.IWorkbench)
	 */
	public void init(IWorkbench workbench) {
	}

	protected IPreferenceStore doGetPreferenceStore() {
		return AcmeStudioPlugin.getDefault ().getPreferenceStore ();
	}

	public static void setDefaults(IPreferenceStore store) {
		store.setDefault (DISPLAY_ELEMENT_ERROR, true);
		store.setDefault (DISPLAY_FLOATING_ERROR, false);
		store.setDefault (AUTO_OPEN_REPRESENTATIONS, true);
		store.setDefault (DISPLAY_REPRESENTATION_ICON, true);
		store.setDefault (ZOOMTOFITONOPEN, true);
		store.setDefault (HIDETRANSPARENCY, 0);
		store.setDefault (HIGHLIGHTTRANSPARENCY, 55);
		store.setDefault (RULERS_ENABLED, true);
		store.setDefault (GRID_ENABLED, false);
		store.setDefault (GRID_X_SPACING, SnapToGrid.DEFAULT_GRID_SIZE);
		store.setDefault (GRID_Y_SPACING, SnapToGrid.DEFAULT_GRID_SIZE);
		store.setDefault (SNAP_TO_GEOMETRY, false);
		store.setDefault (ROUNDED_CORNERS, false);
		store.setDefault (JUMP_INTERSECTIONS, false);
		store.setDefault(ORGANIZE_PALETTE, ORGANIZE_PALETTE_FAMILY);
		store.setDefault(INLINE_REPRESENTATIONS, false);
	
	}
	
}
