/*
 * Created on Jan 2, 2004
 *
 */
package AcmeStudio.prefs;

import org.eclipse.jface.preference.PreferencePage;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.TabFolder;
import org.eclipse.swt.widgets.TabItem;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPreferencePage;



/**
 * @author Bradley Schmerl
 * Created Jan 2, 2004
 */
public class DiagramVisPreferences extends PreferencePage implements IWorkbenchPreferencePage {

	private ComponentVisPreferences _componentVisPrefs;
	private ConnectorVisPreferences _connectorVisPrefs;
	private PortVisPreferences _portVisPrefs;
	private RoleVisPreferences _roleVisPrefs;

	/**
	 * 
	 */
	public DiagramVisPreferences() {
		super ();
	}

	/**
	 * @param title
	 */
	public DiagramVisPreferences(String title) {
		super (title);
	}

	/**
	 * @param title
	 * @param image
	 */
	public DiagramVisPreferences(String title, ImageDescriptor image) {
		super (title, image);
	}

	/* (non-Javadoc)
	 * @see org.eclipse.jface.preference.PreferencePage#createContents(org.eclipse.swt.widgets.Composite)
	 */
	protected Control createContents(Composite parent) {
		
		TabFolder folder = new TabFolder (parent, SWT.NONE);
		
		TabItem comp = new TabItem (folder, SWT.NONE);
		comp.setText ("Component");
		_componentVisPrefs = new ComponentVisPreferences ();
		_componentVisPrefs.createControl(folder);
		comp.setData(_componentVisPrefs);
		comp.setControl(_componentVisPrefs.getControl());
		
		
		TabItem conn = new TabItem (folder, SWT.NONE);
		conn.setText("Connector");
		_connectorVisPrefs = new ConnectorVisPreferences ();
		_connectorVisPrefs.createControl (folder);
		conn.setData (_connectorVisPrefs);
		conn.setControl (_connectorVisPrefs.getControl ());
		
		TabItem ports = new TabItem (folder, SWT.NONE);
		ports.setText ("Port");
		_portVisPrefs = new PortVisPreferences ();
		_portVisPrefs.createControl (folder);
		ports.setData (_portVisPrefs);
		ports.setControl (_portVisPrefs.getControl ());
		
		TabItem role = new TabItem (folder, SWT.NONE);
		role.setText ("Role");
		_roleVisPrefs = new RoleVisPreferences ();
		_roleVisPrefs.createControl(folder);
		role.setData (_roleVisPrefs);
		role.setControl (_roleVisPrefs.getControl ());
		return parent;
		
	}

	/* (non-Javadoc)
	 * @see org.eclipse.ui.IWorkbenchPreferencePage#init(org.eclipse.ui.IWorkbench)
	 */
	public void init(IWorkbench workbench) {
	}
	/* (non-Javadoc)
	 * @see org.eclipse.jface.preference.PreferencePage#performApply()
	 */
	protected void performApply() {
		_componentVisPrefs.performApply();
		_connectorVisPrefs.performApply ();
		_roleVisPrefs.performApply ();
		_portVisPrefs.performApply ();
		super.performApply ();
	}
	/* (non-Javadoc)
	 * @see org.eclipse.jface.preference.PreferencePage#performDefaults()
	 */
	protected void performDefaults() {
		super.performDefaults ();
		_componentVisPrefs.performDefaults();
		_connectorVisPrefs.performDefaults ();
		_roleVisPrefs.performDefaults ();
		_portVisPrefs.performDefaults ();	}
	/* (non-Javadoc)
	 * @see org.eclipse.jface.preference.IPreferencePage#performOk()
	 */
	public boolean performOk() {
		_componentVisPrefs.performOk();
		_connectorVisPrefs.performOk ();
		_roleVisPrefs.performOk ();
		_portVisPrefs.performOk ();
		return super.performOk ();
	}
}
