/*
 * Created on Oct 9, 2003
 *
 */
package AcmeStudio.prefs;

import org.eclipse.jface.preference.BooleanFieldEditor;
import org.eclipse.jface.preference.FieldEditorPreferencePage;
import org.eclipse.jface.preference.IPreferenceStore;
import org.eclipse.jface.preference.RadioGroupFieldEditor;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPreferencePage;

import AcmeStudio.AcmeStudioPlugin;
import AcmeStudio.core.resource.ASVisualStyle;

/**
 * @author Bradley Schmerl
 * Created Oct 9, 2003
 */
public class GlobalVisPreferences extends FieldEditorPreferencePage implements IWorkbenchPreferencePage {

	public static final String	KEEP_VIS_SEPARATE			= "DiagramEditor.keepVisSeparate";

	/**
	 * @param style
	 */
	public GlobalVisPreferences() {
		super("Global visual style preferences", GRID);
	}



	/* (non-Javadoc)
	 * @see org.eclipse.jface.preference.FieldEditorPreferencePage#createFieldEditors()
	 */
	protected void createFieldEditors() {
		Composite parent = getFieldEditorParent();
		RadioGroupFieldEditor savingGroup = new RadioGroupFieldEditor ("SaveGlobalVisPref", "Saving global visualizations",1,
				new String [][] {
							  {"Save global visualizations globally (will affect all projects)", ASVisualStyle.SAVEGLOBAL},
							  {"Save global visualizations locally (will only affect individual projects)", ASVisualStyle.SAVELOCAL},
							  {"Do not allow global visualizations to be changed", ASVisualStyle.READONLY}
				},
				parent, true);
		
		addField (savingGroup);
		BooleanFieldEditor separateVis = new BooleanFieldEditor (KEEP_VIS_SEPARATE, "Keep visual properties of diagram in .visInfo file",
				parent);
		addField (separateVis);
	}

	/* (non-Javadoc)
	 * @see org.eclipse.ui.IWorkbenchPreferencePage#init(org.eclipse.ui.IWorkbench)
	 */
	public void init(IWorkbench workbench) {
	}

	/* (non-Javadoc)
	 * @see org.eclipse.jface.preference.PreferencePage#doGetPreferenceStore()
	 */
	protected IPreferenceStore doGetPreferenceStore() {
		return AcmeStudioPlugin.getDefault ().getPreferenceStore();
	}

	public static void setDefaults (IPreferenceStore store) {
		store.setDefault (GlobalVisPreferences.KEEP_VIS_SEPARATE, true);
	}
}
