/*
 * Created on Mar 23, 2003
 *
 */
package AcmeStudio.prefs;

import org.eclipse.jface.preference.BooleanFieldEditor;
import org.eclipse.jface.preference.FieldEditorPreferencePage;
import org.eclipse.jface.preference.IPreferenceStore;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPreferencePage;

import AcmeStudio.AcmeStudioPlugin;

/**
 * @author schmerl
 */
public class TextEditorSynchronizationPreferences
    extends FieldEditorPreferencePage
    implements IWorkbenchPreferencePage {

    public TextEditorSynchronizationPreferences () {
        super ("Text Editor", GRID);
    }
    
    /* (non-Javadoc)
     * @see org.eclipse.jface.preference.FieldEditorPreferencePage#createFieldEditors()
     */
    protected void createFieldEditors() {
        BooleanFieldEditor autoTypecheck = new BooleanFieldEditor (
            "TextEditor.AutoTypecheck",
            "Automatically typecheck design when switching to text editor",
            getFieldEditorParent ());
        BooleanFieldEditor autoFormat = new BooleanFieldEditor (
            "TextEditor.AutoFormat",
            "Format text when document is saved",
            getFieldEditorParent ());
        addField (autoTypecheck);
        addField (autoFormat);    

    }

    /* (non-Javadoc)
     * @see org.eclipse.ui.IWorkbenchPreferencePage#init(org.eclipse.ui.IWorkbench)
     */
    public void init(IWorkbench workbench) {

    }

    /* (non-Javadoc)
     * @see org.eclipse.jface.preference.PreferencePage#doGetPreferenceStore()
     */
    protected IPreferenceStore doGetPreferenceStore() {
        return AcmeStudioPlugin.getDefault ().getPreferenceStore ();
    }

    public static void setDefaults (IPreferenceStore store) {
        store.setDefault ("TextEditor.AutoTypecheck", true);
        store.setDefault ("TextEditor.AutoFormat", false);
    }

}
