package AcmeStudio.ui.editors;

import org.eclipse.jface.action.IToolBarManager;
import org.eclipse.jface.action.SubToolBarManager;
import org.eclipse.ui.IActionBars;
import org.eclipse.ui.IEditorPart;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.part.MultiPageEditorActionBarContributor;

import AcmeStudio.ui.editors.diagram.DiagramActionBarContributor;
import AcmeStudio.ui.editors.style.StyleEditorActionBarContributor;

/**
 * @author schmerl
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class MultiPageStyleEditorActionBarContributor
    extends MultiPageEditorActionBarContributor {

    DiagramActionBarContributor diagramActions;
    StyleEditorActionBarContributor styleActions;
//    DesignAnalysisActionBarContributor analysisActions;

    private SubToolBarManager _styleTBM;
    private SubToolBarManager _diagramTBM;
//    private SubToolBarManager _analysisTBM;
    /**
     * @see org.eclipse.ui.IEditorActionBarContributor#setActiveEditor(IEditorPart)
     */
    public void setActiveEditor(IEditorPart targetEditor) {
        super.setActiveEditor(targetEditor);
    }

    private void configureToolBars (boolean sVis, boolean dVis, boolean aVis) {
        if (_styleTBM != null) _styleTBM.setVisible (sVis);
        if (_diagramTBM != null) _diagramTBM.setVisible (dVis);
        _styleTBM.update(true);
        _diagramTBM.update (true);
        ((SubToolBarManager )_diagramTBM.getParent ()).getParent ().update(true);
        styleActions.getActionBars().updateActionBars();
        diagramActions.getActionBars ().updateActionBars();
//        if (_analysisTBM != null) _analysisTBM.setVisible (aVis);
    }

    public MultiPageStyleEditorActionBarContributor () {
        super ();
        diagramActions = new DiagramActionBarContributor ();
        styleActions = new StyleEditorActionBarContributor ();
//        analysisActions = new DesignAnalysisActionBarContributor ();
    }

    /**
     * @see org.eclipse.ui.part.MultiPageEditorActionBarContributor#setActivePage(IEditorPart)
     */
    public void setActivePage(IEditorPart ae) {
        if (ae instanceof DiagramEditor) {
            configureToolBars (false, true, false);
            diagramActions.setActiveEditor (ae);
        }
        else if (ae instanceof AcmeStyleEditor) {
            configureToolBars (true, false, false);
            styleActions.setActiveEditor (ae);
        }
        else if (ae instanceof DesignAnalysisEditor) {
            configureToolBars (false, false, true);
//            analysisActions.setActiveEditor (ae);
        }
        if (getActionBars () != null)
        getActionBars ().updateActionBars();
    }



    /**
     * @see org.eclipse.ui.part.EditorActionBarContributor#contributeToToolBar(IToolBarManager)
     */
    public void contributeToToolBar(IToolBarManager tbm) {
        _diagramTBM = new SubToolBarManager (tbm);
        _styleTBM = new SubToolBarManager (tbm);
//        _analysisTBM = new SubToolBarManager (tbm);
        
        styleActions.contributeToToolBar (_styleTBM);
//        diagramActions.contributeToToolBar (_diagramTBM);
//        analysisActions.contributeToToolBar (_analysisTBM);
    }

    /* (non-Javadoc)
     * @see org.eclipse.ui.IEditorActionBarContributor#init(org.eclipse.ui.IActionBars, org.eclipse.ui.IWorkbenchPage)
     */
    public void init(IActionBars bars, IWorkbenchPage page) {
        diagramActions.init (bars, page);
        styleActions.init (bars, page);
//        analysisActions.init (bars, page);
        super.init(bars, page);
    }

}
