/*
 * Created on Aug 2, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package AcmeStudio.ui.editors.actions;

import org.eclipse.gef.Request;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.ui.actions.SelectionAction;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.ui.IEditorPart;

import AcmeStudio.model.ModelCommand;
import AcmeStudio.ui.editors.DiagramEditor;
import AcmeStudio.ui.editors.diagram.actions.BrowsePatternsCommand;
import AcmeStudio.util.ImageManager;
import acmeLib.core.exceptions.AcmeDuplicateNameException;

/**
 * This class represents tha ction of adding a new pattern
 * @author Larry Waldman
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class BrowsePatternsAction extends SelectionAction
{
    private static final String BROWSE_PATTERNS_REQUEST = "Browse Connection Rules";
    public static final String BROWSE_PATTERNS = "Browse Connection Rules";
    
    Request request;
    
    public BrowsePatternsAction(IEditorPart editor, String type)
    {
        super(editor);
        if (type.equals(BROWSE_PATTERNS_REQUEST))
        {
            request = new Request(BROWSE_PATTERNS_REQUEST);
            setImageDescriptor(ImageManager.getSmallImageDescriptor(ImageManager.ID_CONN));
        }
        setText(type);
        setId(type);
    }
    
    /* (non-Javadoc)
     * @see org.eclipse.gef.ui.actions.WorkbenchPartAction#calculateEnabled()
     */
    protected boolean calculateEnabled()
    {
        // TODO Auto-generated method stub
        return true;
    }

    /**
     * The getCommand method shows the necessary dialog, gathers the
     * necessary info, and returns the CreateRuleCommand
     * @return
     */
    private Command getCommand()
    {
        DiagramEditor editor = (DiagramEditor) this.getWorkbenchPart();
        BrowsePatternsCommand comm = null;
        
        if (request.getType().equals(BROWSE_PATTERNS_REQUEST))
        {
            comm = new BrowsePatternsCommand(editor.getAcmeSystem());
        }    
        return comm;
    }
    
    /* (non-Javadoc)
     * @see org.eclipse.jface.action.IAction#run()
     */
    public void run()
    {
        ModelCommand command = (ModelCommand) getCommand();
        execute(command);
        if (command != null)
        {
            try
            {
                command.checkError();
            }
            catch (AcmeDuplicateNameException e)
            {
                MessageDialog.openError(Display.getDefault().getActiveShell(),
                        "Duplicate name", e.getMessage());
            }
            catch (Exception e)
            {
                MessageDialog.openError(Display.getDefault().getActiveShell(),
                        "Error", e.getMessage());

            }
        }
    }
}
