package AcmeStudio.ui.editors.actions;

import org.eclipse.gef.ui.actions.SelectionAction;
import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.swt.widgets.Display;
import org.eclipse.ui.IWorkbenchPart;

import AcmeStudio.model.FamilyCommand;
import AcmeStudio.model.ModelCompoundCommand;
import AcmeStudio.model.TypeAssignmentCommand;
import AcmeStudio.ui.editors.DiagramEditor;
import AcmeStudio.ui.views.parts.ImportFamilyDialog;
import acmeLib.elements.AcmeDesign;
import acmeLib.elements.AcmeSystem;

/**
 * @author schmerl
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class ImportFamilyAction extends SelectionAction {


    public ImportFamilyAction (IWorkbenchPart ep) {
        super (ep);
        setText ("Import Family...");
        setId ("$ImportFam$");
    }

    /**
     * @see org.eclipse.gef.ui.actions.EditorPartAction#calculateEnabled()
     */
    protected boolean calculateEnabled() {
        return true;
    }

    /**
     * @see org.eclipse.jface.action.IAction#run()
     */
    public void run() {
        AcmeDesign design = null;
        AcmeSystem system = null;
        if (getWorkbenchPart() instanceof DiagramEditor) {
            system = ((DiagramEditor )getWorkbenchPart ()).getAcmeSystem();
            design = system.getParentDesign();
        }
        ImportFamilyDialog dialog = new ImportFamilyDialog (Display.getDefault().getActiveShell());
        if (dialog.open () == IDialogConstants.OK_ID) {
            if (dialog.getImportingFamilies().length == 1) {
				FamilyCommand command = new FamilyCommand (FamilyCommand.ADD_FAMILY, dialog.getImportingFamilies() [0].getASPath().getPathStr(), design, null);
             	if (dialog.automaticallyAssignFamilies()) {
 					ModelCompoundCommand c = new ModelCompoundCommand ("Import and Assign Family");
 					c.add (command);
 					c.add (new TypeAssignmentCommand (TypeAssignmentCommand.ASSIGN_FAMILY, system, dialog.getImportingFamilies () [0].getFamily().getTypeName(), null));
 					c.execute (design);
             	}
             	else {           	
               		command.execute (design);
             	}
            }
            else if (dialog.getImportingFamilies().length > 1) {
                ModelCompoundCommand command = new ModelCompoundCommand ("Import families");
                for (int i = 0; i < dialog.getImportingFamilies().length; i++) {
                    FamilyCommand c = new FamilyCommand (FamilyCommand.ADD_FAMILY, dialog.getImportingFamilies() [i].getASPath().getPathStr(), design, null);
                    command.add (c);
                    if (dialog.automaticallyAssignFamilies()) {
                    	TypeAssignmentCommand tac = new TypeAssignmentCommand (TypeAssignmentCommand.ASSIGN_FAMILY, system, dialog.getImportingFamilies () [i].getFamily().getTypeName (), null);
                    	command.add (tac);
                    }
                }           
                command.execute(design);
            }
        }
    }

}
