/*
 * Created on Aug 2, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package AcmeStudio.ui.editors.actions;

import org.eclipse.gef.Request;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.ui.actions.SelectionAction;
import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.wizard.WizardDialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.IEditorPart;

import AcmeStudio.model.ModelCommand;
import AcmeStudio.ui.editors.DiagramEditor;
import AcmeStudio.ui.editors.diagram.actions.CreateElementCommand;
import AcmeStudio.ui.editors.diagram.actions.CreateRuleCommand;
import AcmeStudio.ui.editors.diagram.figures.SystemView;
import AcmeStudio.ui.editors.diagram.parts.SystemEditPart;
import AcmeStudio.util.ImageManager;
import AcmeStudio.wizards.ConnectionPatternWizard;
import AcmeStudio.wizards.connection.PortConnectionRule;
import AcmeStudio.wizards.connection.PortRoleAssociation;
import acmeLib.core.exceptions.AcmeDuplicateNameException;
import acmeLib.elements.AcmeFamily;
import acmeLib.elements.AcmeSystem;

/**
 * This class represents tha ction of adding a new pattern
 * @author Larry Waldman
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class NewConnectionPatternAction extends SelectionAction
{
    private static final String NEW_CONNECTION_RULE_REQUEST = "New Connection Rule";
    public static final String NEW_CONNECTION_RULE = "New Connection Rule";
    
    Request request;
    
    public NewConnectionPatternAction(IEditorPart editor, String type)
    {
        super(editor);
        if (type.equals(NEW_CONNECTION_RULE_REQUEST))
        {
            request = new Request(NEW_CONNECTION_RULE_REQUEST);
            setImageDescriptor(ImageManager.getSmallImageDescriptor(ImageManager.ID_CONN));
        }
        setText(type);
        setId(type);
    }
    
    /* (non-Javadoc)
     * @see org.eclipse.gef.ui.actions.WorkbenchPartAction#calculateEnabled()
     */
    protected boolean calculateEnabled()
    {
        // TODO Auto-generated method stub
        return true;
    }

    /**
     * The getCommand method shows the necessary dialog, gathers the
     * necessary info, and returns the CreateRuleCommand
     * @return
     */
    private Command getCommand()
    {
        DiagramEditor editor = (DiagramEditor) this.getWorkbenchPart();
        SystemEditPart rootPart = editor.getRootEditPart();
        CreateElementCommand create = new CreateElementCommand(rootPart);
        CreateRuleCommand createRule = null;
        
        SystemView systemView = (SystemView) rootPart.getFigure();
        create.setSystemView(systemView);

        Shell shell = Display.getDefault().getActiveShell();
        AcmeSystem system = (AcmeSystem) rootPart.getModel();
        if (request.getType().equals(NEW_CONNECTION_RULE_REQUEST))
        {
            //Get the necessary rule information
        	AcmeFamily fam = null;
        	if (system.getDeclaredTypes().getSize () == 1) {
        		fam = (AcmeFamily )system.getDeclaredTypes ().getNextItem ();
        	}
        	if (fam == null) return null;
            
        	//Show the wizard which will gather the info on what to create
            ConnectionPatternWizard wizard = new ConnectionPatternWizard(fam, true);

            WizardDialog dialog = new WizardDialog(Display.getDefault()
                    .getActiveShell(), wizard);
            dialog.create();
            dialog.open();
            if (!(IDialogConstants.CANCEL_ID == dialog.getReturnCode()))
            {
                //Build the rule out of the different parts on the dialog
                PortConnectionRule userChosen = new PortConnectionRule();
                userChosen.setConnectorType(wizard.getTypePage().selectionConn);
                userChosen.addAssociation(new PortRoleAssociation(wizard
                        .getTypePage().selectionPorts[0],
                        wizard.getTypePage().selectionRoles[0], wizard
                                .getNamePage().nameRoles[0], wizard
                                .getNamePage().namePorts[0], wizard
                                .getTypePage().selectionComps[0]));
                userChosen.addAssociation(new PortRoleAssociation(wizard
                        .getTypePage().selectionPorts[1],
                        wizard.getTypePage().selectionRoles[1], wizard
                                .getNamePage().nameRoles[1], wizard
                                .getNamePage().namePorts[0], wizard
                                .getTypePage().selectionComps[1]));

                userChosen.setSource(wizard.getNamePage().ruleBi ? null
                        : wizard.getTypePage().selectionPorts[0]);

                PortConnectionRule rule = userChosen;

                createRule = new CreateRuleCommand(rule, editor.getAcmeSystem());
            }
        }    
        return createRule;
    }
    
    /* (non-Javadoc)
     * @see org.eclipse.jface.action.IAction#run()
     */
    public void run()
    {
        ModelCommand command = (ModelCommand) getCommand();
        execute(command);
        if (command != null)
        {
            try
            {
                command.checkError();
            }
            catch (AcmeDuplicateNameException e)
            {
                MessageDialog.openError(Display.getDefault().getActiveShell(),
                        "Duplicate name", e.getMessage());
            }
            catch (Exception e)
            {
                MessageDialog.openError(Display.getDefault().getActiveShell(),
                        "Error", e.getMessage());

            }
        }
    }
}
