/*
 * Created on Sep 29, 2003
 *
 */
package AcmeStudio.ui.editors.actions;

import org.eclipse.gef.commands.Command;
import org.eclipse.gef.ui.actions.SelectionAction;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.wizard.WizardDialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.ui.IWorkbenchPart;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.IWorkbenchWindowActionDelegate;

import AcmeStudio.model.FunctionCommand;
import AcmeStudio.model.ModelCommand;
import AcmeStudio.ui.views.parts.wizards.functions.NewFunctionWizard;
import acmeLib.designRules.DesignAnalysis;
import acmeLib.elements.AcmeFamily;

/**
 * @author Bradley Schmerl
 * Created Sep 29, 2003
 */
public class NewDesignAnalysisAction extends SelectionAction implements IWorkbenchWindowActionDelegate {

	public static String ID = "$NewFunction$";
	private AcmeFamily _family;

	/**
	 * @param editor
	 */
	public NewDesignAnalysisAction(IWorkbenchPart editor, AcmeFamily context) {
		super(editor);
		_family = context;
		setText ("New Function");
		setId (ID);
	}

	/* (non-Javadoc)
	 * @see org.eclipse.gef.ui.actions.WorkbenchPartAction#calculateEnabled()
	 */
	protected boolean calculateEnabled() {
		return _family != null;
	}

	/* (non-Javadoc)
	 * @see org.eclipse.ui.IWorkbenchWindowActionDelegate#init(org.eclipse.ui.IWorkbenchWindow)
	 */
	public void init(IWorkbenchWindow window) {
	}

	/* (non-Javadoc)
	 * @see org.eclipse.ui.IActionDelegate#run(org.eclipse.jface.action.IAction)
	 */
	public void run(IAction action) {
	}

	/* (non-Javadoc)
	 * @see org.eclipse.ui.IActionDelegate#selectionChanged(org.eclipse.jface.action.IAction, org.eclipse.jface.viewers.ISelection)
	 */
	public void selectionChanged(IAction action, ISelection selection) {
	}

	/* (non-Javadoc)
	 * @see org.eclipse.jface.action.IAction#run()
	 */
	public void run() {
		ModelCommand command = (ModelCommand )getCommand ();
		if (command != null) {
			command.execute();
			try {
				command.checkError ();
			}
			catch (Exception e) {
				MessageDialog.openError (Display.getDefault ().getActiveShell (), "Error", e.getMessage ());   
			}
		}
	}

	/**
	 * @return
	 */
	private Command getCommand() {
		FunctionCommand command = null;
		NewFunctionWizard wizard = null;
		wizard = new NewFunctionWizard (Display.getDefault ().getActiveShell (), _family);
		WizardDialog dialog = new WizardDialog (Display.getDefault().getActiveShell(), wizard);
		dialog.create ();
		if (dialog.open () == WizardDialog.OK) {
			DesignAnalysis newFunction = wizard.getAnalysis ();
			command = new FunctionCommand (FunctionCommand.ADD_FUNCTION, newFunction, _family, null);
			
		}
		return command;
	}

}
