/*
 * Created on May 24, 2005
 *
 */
package AcmeStudio.ui.editors.actions;

import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.wizard.WizardDialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.ui.IWorkbenchPart;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.IWorkbenchWindowActionDelegate;
import AcmeStudio.ui.editors.DiagramEditor;
import AcmeStudio.ui.views.parts.wizards.weaveFamily.WeaveFamilyWizard;
import AcmeStudio.util.Helper;
import acmeLib.core.container.AcmeEnumeration;
import acmeLib.elements.AcmeElement;
import acmeLib.elements.AcmeSystem;


/**
 * @author Bradley Schmerl
 * Created May 24, 2005
 */
public class WeaveInFamilyAction  implements IWorkbenchWindowActionDelegate {

	
	private AcmeSystem	_scope;
	/**
	 * 
	 */
	public WeaveInFamilyAction() {
		super ();
	}
	/**
	 * @param part
	 */
	public WeaveInFamilyAction(IWorkbenchPart part) {
		super ();
	}

	/**
	 * @return
	 * @see org.eclipse.gef.ui.actions.WorkbenchPartAction#calculateEnabled()
	 **/
	protected boolean calculateEnabled() {
		return true;
	}

	/**
	 * @param window
	 * @see org.eclipse.ui.IWorkbenchWindowActionDelegate#init(org.eclipse.ui.IWorkbenchWindow)
	 **/
	public void init(IWorkbenchWindow window) {
	}

	/**
	 * @param action
	 * @see org.eclipse.ui.IActionDelegate#run(org.eclipse.jface.action.IAction)
	 **/
	public void run(IAction action) {
		run ();
	}

	/**
	 * @param action
	 * @param selection
	 * @see org.eclipse.ui.IActionDelegate#selectionChanged(org.eclipse.jface.action.IAction, org.eclipse.jface.viewers.ISelection)
	 **/
	public void selectionChanged(IAction action, ISelection selection) {
		action.setEnabled (false);
		AcmeElement [] elements = Helper.getAcmeElementsFromSelection(selection);
		if (elements != null && elements.length > 0) {
			_scope = Helper.getAcmeSystem(elements [0]);
			action.setEnabled (true);
		}
		else {
			_scope = null;
		}
	}
	
	
	/**
	 * 
	 * @see org.eclipse.jface.action.Action#run()
	 **/
	public void run() {
		WeaveFamilyWizard wizard = new WeaveFamilyWizard (_scope);
		WizardDialog dialog = new WizardDialog (Display.getCurrent().getActiveShell(), wizard);
		dialog.create ();
		if (dialog.open () == WizardDialog.OK) {
			
		}
	}
	/**
	 * 
	 * @see org.eclipse.ui.IWorkbenchWindowActionDelegate#dispose()
	 **/
	public void dispose() {
	}
}
