/*
 * Created on Mar 18, 2003
 *
 */
package AcmeStudio.ui.editors.analysis;

import org.eclipse.jface.action.IToolBarManager;
import org.eclipse.jface.action.SubToolBarManager;
import org.eclipse.ui.IEditorPart;
import org.eclipse.ui.part.EditorActionBarContributor;

import AcmeStudio.core.actions.AcmeStudioRetargetAction;
import AcmeStudio.ui.editors.DesignAnalysisEditor;
import AcmeStudio.ui.editors.analysis.actions.ParseAnalysisAction;
import AcmeStudio.util.ImageManager;

/**
 * @author schmerl
 */
public class DesignAnalysisActionBarContributor extends EditorActionBarContributor {

    private AcmeStudioRetargetAction _parseAnalysisAction;

    /**
     * 
     */
    public DesignAnalysisActionBarContributor() {
        super();
        _parseAnalysisAction = new AcmeStudioRetargetAction ("AcmeStudio.analysis.parse", "Parse Design Analysis");
        _parseAnalysisAction.setImageDescriptor(ImageManager.getImageDescriptor(ImageManager.ID_PARSE));
    }

    /* (non-Javadoc)
     * @see org.eclipse.ui.part.EditorActionBarContributor#contributeToToolBar(org.eclipse.jface.action.IToolBarManager)
     */
    public void contributeToToolBar(IToolBarManager toolBarManager) {
        if (toolBarManager instanceof SubToolBarManager) {
            super.contributeToToolBar(toolBarManager);
            toolBarManager.add (_parseAnalysisAction);
        }
    }

    public void setActiveEditor (IEditorPart ae) {
        if (ae instanceof DesignAnalysisEditor) {
            DesignAnalysisEditor ed = (DesignAnalysisEditor )ae;
            _parseAnalysisAction.setAction (ed.getAction (ParseAnalysisAction.PARSE));
        }
    }
}
