/*
 * Created on Aug 17, 2004
 *
 */
package AcmeStudio.ui.editors.diagram;

import org.eclipse.jface.action.Action;

import AcmeStudio.AcmeStudioPlugin;
import AcmeStudio.prefs.ConnectionPatternPreferences;
import AcmeStudio.prefs.DiagramEditorPreferences;
import AcmeStudio.ui.editors.diagram.palette.PaletteManager;


/**
 * @author Bradley Schmerl
 * Created Aug 17, 2004
 */
public class AcmePaletteChangeLayoutAction extends Action {

	public static final  String	BY_FAMILIES = "$Family$";
	public static final String	BY_ELEMENT	= "$Element$";
	public static final String	SHOW_CONNECTION_PATTERNS	= "$Connection$";
	private final PaletteManager	_manager;
	private final String	_layout;

	
	/**
	 * @param manager
	 * @param by_families2
	 */
	public AcmePaletteChangeLayoutAction(PaletteManager manager, String layout, int style) {
		super ("",style);
		_manager = manager;
		_layout = layout;
		if (BY_FAMILIES.equals (layout)) {
			setText ("Organize by family");
			setChecked(AcmeStudioPlugin.getDefault().getPreferenceStore().getString(DiagramEditorPreferences.ORGANIZE_PALETTE).equals (DiagramEditorPreferences.ORGANIZE_PALETTE_FAMILY));
		}
		else if (BY_ELEMENT.equals (layout)) {
			setText ("Organize by element type");
			setChecked (AcmeStudioPlugin.getDefault().getPreferenceStore().getString(DiagramEditorPreferences.ORGANIZE_PALETTE).equals (DiagramEditorPreferences.ORGANIZE_PALETTE_ELEMENT));
		}
		else if (SHOW_CONNECTION_PATTERNS.equals (layout)) {
			setText ("Show connection patterns");
			setChecked (AcmeStudioPlugin.getDefault().getPreferenceStore().getBoolean(ConnectionPatternPreferences.SHOW_PALETTE_TREE));
		}
	}
	
	
	/**
	 * 
	 * @see org.eclipse.jface.action.IAction#run()
	 **/
	public void run() {
		if (BY_FAMILIES.equals (_layout)) {
			if (this.isChecked()) {
				AcmeStudioPlugin.getDefault().getPreferenceStore().setValue(DiagramEditorPreferences.ORGANIZE_PALETTE, DiagramEditorPreferences.ORGANIZE_PALETTE_FAMILY);
			}	
			else this.setChecked (false);
		}
		else if (BY_ELEMENT.equals (_layout)) {
			if (this.isChecked ()) {
				AcmeStudioPlugin.getDefault().getPreferenceStore().setValue(DiagramEditorPreferences.ORGANIZE_PALETTE, DiagramEditorPreferences.ORGANIZE_PALETTE_ELEMENT);
			}
			else this.setChecked (false);
		}
		else if (SHOW_CONNECTION_PATTERNS.equals (_layout)) {
			boolean show = AcmeStudioPlugin.getDefault().getPreferenceStore().getBoolean (ConnectionPatternPreferences.SHOW_PALETTE_TREE);
			AcmeStudioPlugin.getDefault().getPreferenceStore().setValue(ConnectionPatternPreferences.SHOW_PALETTE_TREE, !show);
			this.setChecked (!show);
		}
		_manager.reset();
	}
}
