/*
 * Created on Aug 17, 2004
 *
 */
package AcmeStudio.ui.editors.diagram;

import org.eclipse.gef.ContextMenuProvider;
import org.eclipse.gef.EditPartViewer;
import org.eclipse.gef.ui.actions.GEFActionConstants;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.action.IMenuManager;
import AcmeStudio.ui.editors.diagram.palette.PaletteManager;


/**
 * @author Bradley Schmerl
 * Created Aug 17, 2004
 */
public class AcmePaletteContextMenuProvider extends ContextMenuProvider {

	private final PaletteManager	_manager;

	/**
	 * @param viewer
	 * @param manager
	 */
	public AcmePaletteContextMenuProvider(EditPartViewer viewer, PaletteManager manager) {
		super (viewer);
		_manager = manager;
	}

	/**
	 * @param menu
	 * @see org.eclipse.gef.ContextMenuProvider#buildContextMenu(org.eclipse.jface.action.IMenuManager)
	 **/
	public void buildContextMenu(IMenuManager menu) {
		GEFActionConstants.addStandardActionGroups(menu);
		menu.appendToGroup(GEFActionConstants.GROUP_VIEW, new AcmePaletteChangeLayoutAction (_manager, AcmePaletteChangeLayoutAction.BY_FAMILIES, IAction.AS_RADIO_BUTTON));
		menu.appendToGroup(GEFActionConstants.GROUP_VIEW, new AcmePaletteChangeLayoutAction (_manager, AcmePaletteChangeLayoutAction.BY_ELEMENT, IAction.AS_RADIO_BUTTON));
		menu.appendToGroup(GEFActionConstants.GROUP_REST, new AcmePaletteChangeLayoutAction (_manager, AcmePaletteChangeLayoutAction.SHOW_CONNECTION_PATTERNS, IAction.AS_CHECK_BOX));
	}
}
