package AcmeStudio.ui.editors.diagram.actions;

import org.eclipse.gef.requests.CreateRequest;
import org.eclipse.gef.requests.CreationFactory;

import acmeLib.elements.*;

/**
 * @author schmerl
 *
 */
public class AcmeCreateRequest extends CreateRequest {

	private Object _type;
	private AcmeElement _element;
    /**
     * Constructor for AcmeCreateRequest.
     * @param arg0
     */
    public AcmeCreateRequest(AcmeElementType arg0) {
        super();
        _type = arg0;
    }
    
    public AcmeCreateRequest (Class clazz) {
    	super ();
    	_type = clazz;	
    }

    /**
     * @see org.eclipse.gef.requests.CreateRequest#getNewObjectType()
     */
    public Object getNewObjectType() {
        return _type;
    }

    /**
     * @see org.eclipse.gef.requests.CreateRequest.Factory#getObjectType()
     */
    public Object getObjectType() {
        return _type;
    }

    /**
     * @see org.eclipse.gef.requests.CreateRequest#getNewObject()
     */
    public Object getNewObject() {
 //       if (_element == null) {
			if (_type instanceof AcmeElementType) {			
				AcmeElementType newType = (AcmeElementType )_type;
				// BugFix 184: New name based on type name
				String name = newType.getTypeName() + "0";
				if (newType instanceof AcmeComponentType) {
					_element = new AcmeComponent (name,(AcmeComponentType )newType);
	
				}
				else if (newType instanceof AcmeConnectorType) {
					_element = new AcmeConnector (name, (AcmeConnectorType )newType);
				}
				else if (newType instanceof AcmePortType) {
					_element = new AcmePort (name, (AcmePortType )newType);
				}
				else if (newType instanceof AcmeRoleType) {
					_element = new AcmeRole (name, (AcmeRoleType )newType);
				}
				
				_element.addInstantiatedType(newType);			
				_element.instantiateElements ();			
			}
			else {
	
				Class objType = (Class )_type;
				String className = objType.getName();
	
				if (className.endsWith("AcmeComponent")) {
					_element = new AcmeComponent("comp0");
				}
				else if (className.endsWith("AcmeConnector")) {
					_element = new AcmeConnector("conn0");
		
				}
				else if (className.endsWith("AcmePort")) {
					_element = new AcmePort("port0");
		
				}
				else if (className.endsWith("AcmeRole")) {
					_element = new AcmeRole("role0");
		
				}
	        }
 //       }
        return _element;
    }

	/* (non-Javadoc)
	 * @see org.eclipse.gef.requests.CreateRequest#getFactory()
	 */
	public CreationFactory getFactory() {
		return super.getFactory();
	}

}
