package AcmeStudio.ui.editors.diagram.actions;

import org.eclipse.swt.widgets.Shell;

import AcmeStudio.AcmeStudioPlugin;
import AcmeStudio.ui.editors.diagram.styles.PatternBrowser;
import acmeLib.elements.AcmeSystem;

/**
 * This class represents the command object for creating a connection
 * pattern
 * 
 * @author LFW
 *
 */
public class BrowsePatternsCommand
	extends AcmeStudio.model.ModelCommand {
    
	//The relevant system
	private AcmeSystem _sys;
	
	public BrowsePatternsCommand(AcmeSystem sys) {
		super("BrowsePatternsCommand");
		_sys = sys;
	}

/**
 * Execute method which adds the rule
 */
	public synchronized void execute() {
	    
	    Shell shell = AcmeStudioPlugin.getDefault().getWorkbench().getActiveWorkbenchWindow().getShell();
	    
        PatternBrowser dialog = new PatternBrowser(_sys, shell);
        // Open the dialog
        int retCode = dialog.open();
	}

	public void redo() {
        execute ();
	}


	public void undo() {
        super.undo();
	}

	/**
	 * @see org.eclipse.gef.commands.Command#canUndo()
	 */
	public boolean canUndo() {
		return false;
	}

	/**
	 * @see org.eclipse.gef.commands.Command#canExecute()
	 */
	public boolean canExecute() {
	    	//For now, return true
	    return true;
	}
}
