/*
 * Created on Jan 5, 2005
 *
 */
package AcmeStudio.ui.editors.diagram.actions;

import java.util.Iterator;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.commands.CompoundCommand;
import org.eclipse.gef.ui.actions.SelectionAction;
import org.eclipse.ui.actions.ActionFactory;
import AcmeStudio.ui.editors.DiagramEditor;
import AcmeStudio.ui.editors.actions.CopyAcmeElementAction;


/**
 * @author Bradley Schmerl
 * Created Jan 5, 2005
 */
public class CutElementsAction extends SelectionAction {

	public static final String ID = ActionFactory.CUT.getId ();
	
	/**
	 * @param part
	 */
	public CutElementsAction(DiagramEditor part) {
		super (part);
	}

	/**
	 * @return
	 * @see org.eclipse.gef.ui.actions.WorkbenchPartAction#calculateEnabled()
	 **/
	protected boolean calculateEnabled() {
		return !getSelectedObjects ().isEmpty ();
	}
	
	
	/**
	 * 
	 * @see org.eclipse.jface.action.Action#run()
	 **/
	public void run() {
		CompoundCommand comm = new CompoundCommand ("Cut elements");
		comm.add(CopyAcmeElementAction.createCopyCommand(getSelectedObjects ()));
		for (Iterator iter = getSelectedObjects ().iterator (); iter.hasNext ();) {
			Object obj = iter.next ();
			if (obj instanceof EditPart) {
				comm.add (new DeleteElementCommand ((EditPart )obj));
			}
		}
		execute(comm);
	}
}
