package AcmeStudio.ui.editors.diagram.actions;

import org.eclipse.draw2d.geometry.Point;
import org.eclipse.draw2d.geometry.PointList;
import AcmeStudio.ui.editors.diagram.figures.RoleView;
import AcmeStudio.ui.editors.diagram.figures.SystemView;
import AcmeStudio.ui.editors.diagram.parts.RoleEditPart;
import AcmeStudio.util.Helper;
import acmeLib.elements.AcmeRole;

	

public class DeleteBendpointCommand 
	extends BendpointCommand 
{

	private RoleEditPart _editPart = null;
	private SystemView _sv = null;
	private Point	_bendpoint;
	private AcmeRole	role;
	private Point	_roleStart;
	private Point	_roleEnd;
	
	public void setEditPart (RoleEditPart editPart) {
		_editPart = editPart;
		_sv = (SystemView )editPart.getFigure ().getParent ();
	}
public void execute() {
	 role = (AcmeRole )_editPart.getModel ();
	_bendpoint = Helper.getBendpoints(role).getPoint(getIndex());
	Helper.removeBendpoint(role, getIndex (), _roleStart, _roleEnd);
	PointList bendpoints = _sv.getBendpoints (role, _roleStart, _roleEnd, null);
	bendpoints = _sv.layoutBendpoints (role, bendpoints, _roleStart, _roleEnd);
	SystemView.cleanBendpoints (bendpoints, _roleStart, _roleEnd);
	Helper.setBendpoints (role, bendpoints);
	_editPart.refresh ();
}

public void undo() {
	RoleView rv = (RoleView )_editPart.getFigure ();
	rv._isBendpointBeingCreated = true;
	rv._isBendpointMoving = false;
	PointList bendpoints = _sv.getBendpoints(role, _roleStart, _roleEnd, null);
	bendpoints = _sv.layoutBendpoints (role, bendpoints, _roleStart, _roleEnd);
	SystemView.cleanBendpoints(bendpoints, _roleStart, _roleEnd);
	Helper.setBendpoints (role, bendpoints);
	_editPart.refresh ();
	rv._isBendpointBeingCreated = false;
}
/**
 * @param start
 */
public void setRoleStart(Point start) {
	_roleStart = start;
}
/**
 * @param end
 */
public void setRoleEnd(Point end) {
	_roleEnd = end;
}

}


