package AcmeStudio.ui.editors.diagram.actions;

import org.eclipse.gef.EditPart;
import acmeLib.elements.*;
import acmeLib.representations.AcmeBinding;

public class DeleteElementCommand extends AcmeStudio.model.DeleteElementCommand {


	private EditPart editPart;

	public DeleteElementCommand(EditPart editPart) {
		super();
		if (editPart.getModel () instanceof AcmeElement) {
			AcmeElement element = (AcmeElement )editPart.getModel ();
			_child = element;
		}
		this.editPart = editPart.getParent();
		if (this.editPart instanceof AcmeElement) {
			AcmeElement element = (AcmeElement )this.editPart;
			_parent = element;
		}
	}

	public void execute() {
		super.execute ();
        editPart.refresh ();
	}




	public void redo() {
		super.redo ();
        editPart.refresh ();
	}


	public void undo() {
        super.undo();
        editPart.refresh ();
	}

	/**
	 * @see org.eclipse.gef.commands.Command#canUndo()
	 */
	public boolean canUndo() {
		return true;
	}

    
    /**
     * @see org.eclipse.gef.commands.Command#canExecute()
     */
    public boolean canExecute() {
        return super.canExecute();
    }

	/**
	 * @param model
	 * @return
	 */
	public static boolean appliesTo(Object model) {
		return model instanceof AcmeComponent ||
			model instanceof AcmeConnector ||
			model instanceof AcmePort ||
			model instanceof AcmeRole ||
			model instanceof AcmeBinding;
	}

}
