/*
 * Created on Jul 7, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package AcmeStudio.ui.editors.diagram.actions;

import java.util.List;

import org.eclipse.gef.ui.actions.SelectionAction;
import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.ui.IEditorPart;
import org.eclipse.ui.IWorkbenchPart;

import AcmeStudio.model.SetElementNameCommand;
import AcmeStudio.ui.editors.diagram.parts.ElementEditPart;
import AcmeStudio.ui.views.parts.EditNameDialog;
import AcmeStudio.util.Helper;
import acmeLib.elements.AcmeElement;

/**
 * @author Bradley Schmerl
 * 
 * An action to pop up a dialog to edit a name
 * 
 * TODO: Create an undoable command to change the name
 */
public class EditNamePopupAction extends SelectionAction {

	/** The ID of this action **/
	public static final String ID = "$EDITNAME$";

	/** The initial character of the new name **/
	private char initialChar;

	/**
	 * Sets the initial character
	 * @param initialChar
	 */
	public void setInitialChar(char initialChar) {
		this.initialChar = initialChar;
	}

	/**
	 * @param arg0
	 */
	public EditNamePopupAction(IEditorPart arg0) {
		super(arg0);
	}

	/**
	 * @param arg0
	 */
	public EditNamePopupAction(IWorkbenchPart arg0) {
		super(arg0);
	}

	/**
	 * Only enabled if there is exactly one selection
	 */
	protected boolean calculateEnabled() {
		return getSelectedObjects().size() == 1;
	}

	/* (non-Javadoc)
	 * @see org.eclipse.jface.action.IAction#run()
	 */
	public void run() {
		List selection = getSelectedObjects();
		if (selection.size() == 1) {
			if (selection.get(0) instanceof ElementEditPart) {
				EditNameDialog end =
					new EditNameDialog(Display.getCurrent().getActiveShell());
				end.setStartCharacter(initialChar);
				if (end.open() == IDialogConstants.OK_ID) {
					AcmeElement el =
						(AcmeElement) ((ElementEditPart) selection.get(0))
							.getModel();
					String newName =
						Helper.getUniqueName(el.getParent(), end.getNewName());
					SetElementNameCommand cmd =
						new SetElementNameCommand(
							"Change name",
							newName,
							el.getName(),
							el);
					cmd.execute(el.getParentDesign());
					try {
						cmd.checkError();
					}
					catch (Exception e) {
						// Need to tell the user if the name is illegal
						MessageDialog.openError(Display.getDefault().getActiveShell(), "Naming error", e.getMessage());
					}
				}
			}
		}
	}

}
