/*
 * Created on Oct 15, 2003
 * 
 * To change the template for this generated file go to Window - Preferences -
 * Java - Code Generation - Code and Comments
 */
package AcmeStudio.ui.editors.diagram.actions;

import java.util.Iterator;
import java.util.List;

import org.eclipse.draw2d.IFigure;
import org.eclipse.gef.GraphicalEditPart;
import org.eclipse.gef.ui.actions.SelectionAction;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.IWorkbenchWindowActionDelegate;

import AcmeStudio.AcmeStudioPlugin;
import AcmeStudio.ui.editors.DiagramEditor;
import AcmeStudio.ui.editors.diagram.figures.AcmeVisElement;
import AcmeStudio.ui.editors.diagram.figures.RoleView;
import AcmeStudio.ui.editors.diagram.parts.ComponentEditPart;
import AcmeStudio.ui.editors.diagram.parts.ConnectorEditPart;
import AcmeStudio.ui.editors.diagram.parts.SystemEditPart;
import acmeLib.core.container.AcmeEnumeration;
import acmeLib.core.exceptions.AcmeIllegalNameException;
import acmeLib.elements.AcmeComponent;
import acmeLib.elements.AcmeConnector;
import acmeLib.elements.AcmeElement;
import acmeLib.elements.AcmeGroup;
import acmeLib.elements.AcmePort;
import acmeLib.elements.AcmeRole;

/**
 * @author schmerl
 * 
 * To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Generation - Code and Comments
 */
public class HideSelectionAction
    extends SelectionAction
    implements IWorkbenchWindowActionDelegate {

    DiagramEditor _editor;
    public static final String ID = "$HideSelection$";
    /**
	 * @param editor
	 */
    public HideSelectionAction(DiagramEditor editor) {
        super(editor);
        _editor = editor;
        setText("Hide Selected Elements");
    }

    /*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.gef.ui.actions.WorkbenchPartAction#calculateEnabled()
	 */
    protected boolean calculateEnabled() {
        if (getSelectedObjects().isEmpty())
            return false;
        if (getSelectedObjects().get(0) instanceof SystemEditPart)
            return false;
        
        if (!(getSelectedObjects ().get (0) instanceof GraphicalEditPart)) 
        	return false;
        
        if (!((GraphicalEditPart )getSelectedObjects ().get (0) instanceof AcmeElement)) 
            return false;
        
        if (getSelectedObjects ().size () == 1) {
            setText ("Hide " + ((AcmeElement )((GraphicalEditPart )getSelectedObjects ().get (0)).getModel()).getName ());
        }
        else {
            setText ("Hide selected elements");
        }
        return true;
    }

    /*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.ui.IWorkbenchWindowActionDelegate#init(org.eclipse.ui.IWorkbenchWindow)
	 */
    public void init(IWorkbenchWindow window) {
        // TODO Auto-generated method stub

    }

    /*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.ui.IActionDelegate#run(org.eclipse.jface.action.IAction)
	 */
    public void run(IAction action) {
        // TODO Auto-generated method stub

    }

    /*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.ui.IActionDelegate#selectionChanged(org.eclipse.jface.action.IAction,
	 *           org.eclipse.jface.viewers.ISelection)
	 */
    public void selectionChanged(IAction action, ISelection selection) {
        // TODO Auto-generated method stub

    }

    /*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.action.IAction#run()
	 */
    public void run() {
        List selectedEditParts = getSelectedObjects();

        AcmeGroup hiddenGroup = new AcmeGroup("anonymous");

        for (Iterator iter = selectedEditParts.iterator(); iter.hasNext();) {
            GraphicalEditPart part = (GraphicalEditPart) iter.next();
            IFigure f = part.getFigure();
            try {
                hiddenGroup.addMember((AcmeElement) part.getModel());
            } catch (AcmeIllegalNameException e) {
                e.printStackTrace();
            }
            hideFigure(f);
            if (part instanceof ComponentEditPart) {
                AcmeEnumeration ports =
                    ((AcmeComponent) part.getModel()).getPorts();
                while (ports.moreItems()) {
                    AcmePort port = (AcmePort) ports.getNextItem();
                    IFigure figure = _editor.getFigure(port);
                    if (figure != null) {
                        hideFigure (figure);
                    }
                }
            } else if (part instanceof ConnectorEditPart) {
                AcmeEnumeration roles =
                    ((AcmeConnector) part.getModel()).getRoles();
                while (roles.moreItems()) {
                    AcmeRole role = (AcmeRole) roles.getNextItem();
                    IFigure figure = _editor.getFigure(role);
                    if (figure != null) {
                        hideFigure (figure);
                    }
                }
            }

        }
        _editor.getGraphicalViewer().deselectAll();
        _editor.addHiddentFigureGroup(hiddenGroup);

    }

    private void hideFigure(IFigure f) {
        
        int transparency = AcmeStudioPlugin.getDefault().getPreferenceStore().getInt("DiagramEditor.hideTransparency");
        if (transparency == 0) {
            f.setVisible(false);
        }
        else {
            if (f instanceof AcmeVisElement) {
                AcmeVisElement ve = (AcmeVisElement) f;
                ve.setTransparent(transparency);
            }
            else if (f instanceof RoleView) {
                RoleView rv = (RoleView) f;
                rv.setTransparent (transparency);
            }
            else {
                f.setVisible(false);
            }
        }
    }

}
