package AcmeStudio.ui.editors.diagram.actions;

import org.eclipse.gef.Request;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.ui.actions.SelectionAction;
import org.eclipse.ui.IEditorPart;

import AcmeStudio.ui.editors.DiagramEditor;

/**
 * @author Hong Yan (yh@cs.cmu.edu)
 *
 */
public class ResetSystemLayoutAction extends SelectionAction {

    private Request _request;

    private DiagramEditor _editor;

    public ResetSystemLayoutAction(IEditorPart editor, String type) {
        super(editor);
        if (type.equals(ResetSystemLayoutCommand.RESET_SYSTEMLAYOUT)) {
            setText("Reset System Layout");
        }
        _editor = (DiagramEditor) editor;
        setId(type);
        _request = new Request(type);
    }

    /**
     * @see org.eclipse.gef.ui.actions.EditorPartAction#calculateEnabled()
     */
    protected boolean calculateEnabled() {
        return true;
    }

    /**
     * @see org.eclipse.jface.action.IAction#run()
     */
    public void run() {
        execute(getCommand());
    }

    protected Command getCommand() {
        return new ResetSystemLayoutCommand(
            (String) _request.getType(),
            _editor.getSystemView());
    }

}
