/*
 * Created on May 11, 2005
 *
 */
package AcmeStudio.ui.editors.diagram.actions;

import java.util.Iterator;
import java.util.List;
import org.eclipse.gef.ui.actions.SelectionAction;
import org.eclipse.ui.IWorkbenchPart;
import AcmeStudio.ui.editors.diagram.figures.AcmeVisElement;
import AcmeStudio.ui.editors.diagram.parts.ElementEditPart;


/**
 * @author Bradley Schmerl
 * Created May 11, 2005
 */
public class ShowRepInlineAction extends SelectionAction {

	/**
	 * @param part
	 */
	public ShowRepInlineAction(IWorkbenchPart part) {
		super (part);
	}
	
	
	/**
	 * @return
	 * @see org.eclipse.gef.ui.actions.WorkbenchPartAction#calculateEnabled()
	 **/
	protected boolean calculateEnabled() {
		return !getSelectedObjects ().isEmpty ();
	}
	
	
	/**
	 * 
	 * @see org.eclipse.jface.action.Action#run()
	 **/
	public void run() {
		List selection = getSelectedObjects();
		
		for (Iterator iter = selection.iterator (); iter.hasNext ();) {
			Object o = (Object )iter.next ();
			if (o instanceof ElementEditPart) {
				ElementEditPart ep = (ElementEditPart )o;
				AcmeVisElement ave = (AcmeVisElement )ep.getFigure ();
				ave.setInlineRep (true);
			}
		}
	}
	
	
}
