/*
 * Created on Oct 20, 2003
 * 
 */
package AcmeStudio.ui.editors.diagram.actions;

import org.eclipse.draw2d.IFigure;
import org.eclipse.gef.GraphicalEditPart;
import org.eclipse.jface.action.Action;

import AcmeStudio.ui.editors.DiagramEditor;
import AcmeStudio.ui.editors.diagram.figures.AcmeVisElement;
import AcmeStudio.ui.editors.diagram.figures.RoleView;
import acmeLib.elements.AcmeElement;
import acmeLib.elements.AcmeGroup;
import acmeLib.elements.AcmeSystem;
import acmeLib.tools.GraphWalker;
import acmeLib.tools.WalkerElementOperation;

/**
 * @author schmerl
 */
public class UnhighlightAllAction extends Action {

    public final static String ID = "$UnHighlightAll$";
    
    private DiagramEditor _editor;

    public UnhighlightAllAction (DiagramEditor editor) {
        super ();
        _editor = editor;
        setId (ID);
        setText ("Unhighlight all");
    }
    
    /* (non-Javadoc)
     * @see org.eclipse.jface.action.IAction#run()
     */
    public void run() {
        WalkerElementOperation op = new WalkerElementOperation () {
            public void doElementOp (AcmeElement elt) {
                if (elt instanceof AcmeSystem || elt instanceof AcmeGroup) return;
                
                GraphicalEditPart ep = (GraphicalEditPart )_editor.getEditPart (elt);
                if (ep != null) {
                    IFigure figure = ep.getFigure ();
                    if (figure instanceof AcmeVisElement) {
                        AcmeVisElement ave = (AcmeVisElement) figure;
                       ave.setTransparent (100);
                    }
                    else if (figure instanceof RoleView) {
                        RoleView rv = (RoleView) figure;
                        rv.setTransparent(100);
                    }
                }
            }
        };
        
        GraphWalker.WalkOverAllElements (_editor.getAcmeSystem (), op, GraphWalker.WALK_TOP_DOWN);
        _editor.setHighlightMode(false);
    }

    /* (non-Javadoc)
     * @see org.eclipse.jface.action.IAction#isEnabled()
     */
    public boolean isEnabled() {
        return _editor.getHighlightMode ();
    }

}
