/*
 * Created on Jul 24, 2003
 *
 */
package AcmeStudio.ui.editors.diagram.actions;

import org.eclipse.gef.editparts.ZoomManager;
import org.eclipse.jface.action.Action;

import AcmeStudio.ui.editors.DiagramEditor;
import AcmeStudio.util.ImageManager;

/**
 * @author Bradley Schmerl
 * Created Jul 24, 2003
 * Implements an action to zoom the diagram so that all of it fits in the window
 */
public class ZoomToFitAction extends Action {

	/** The ID of the action **/
	public static final String ID = "$ZoomTF$";
	/** The editor that action is associated with **/
	private DiagramEditor _editor;

	/** 
	 * Constructs the action
	 * @param editor The editor that the action is associated with
	 */
	public ZoomToFitAction (DiagramEditor editor) {
		super ("Zoom to fit");
		setId (ID);
		setImageDescriptor (ImageManager.getImageDescriptor(ImageManager.ID_ZOOM_TO_FIT));
		setToolTipText ("Zoom to fit");
		_editor = editor;
	}

	
	/**
	 * Executes the action.
	 */
	public void run() {
		ZoomManager zm = _editor.getZoomManager();
		zm.setZoomAsText(ZoomManager.FIT_ALL);
	}

}
