package AcmeStudio.ui.editors.diagram.figures;

import org.eclipse.draw2d.IFigure;

import AcmeStudio.ui.editors.diagram.styles.ElementVisualization;
import acmeLib.elements.AcmeElement;

/**
 * @author Hong Yan (yh@cs.cmu.edu)
 *
 * This interface is to be implemented by all element figures
 * representing acme models.
 * 
 */
public interface IAcmeElementFigure extends IFigure   {


    /**
     * Set the model
     * @param The acme model to be represented by this figure
     */
	public void setModel(AcmeElement model);

    /**
     * Get the model
     * @return The acme model this figure is representing
     */
	public AcmeElement getModel();
	
	public ElementVisualization getVisualization ();
}