/*
 * Created on Jan 9, 2005
 *
 */
package AcmeStudio.ui.editors.diagram.figures;

import org.eclipse.draw2d.Graphics;
import org.eclipse.draw2d.Shape;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.swt.graphics.Color;
import AcmeStudio.ui.editors.diagram.styles.ElementVisualization;
import AcmeStudio.ui.editors.diagram.styles.constants.LabelOptions;
import com.swtdesigner.SWTResourceManager;


public class VisualizationFeedbackFigure extends Shape {
	
	
	private final ElementVisualization	_vis;
	private double	_rotation;
	private static Color greyColor = SWTResourceManager.getColor (31, 31, 31);

	/**
	 * 
	 */
	public VisualizationFeedbackFigure(ElementVisualization vis) {
		_vis = vis.copy();
		_vis.setLabelSource(LabelOptions.NOLABEL);
		_vis.setOutlineWidth (1);
		_vis.setOutlineStyle (Graphics.LINE_DOT);
		_vis.setFillColor(greyColor);
	}
	
	public VisualizationFeedbackFigure (ElementVisualization vis, double rotation) {
		this (vis);
		_rotation = rotation;
	}
	
	
	/**
	 * @param graphics
	 * @see org.eclipse.draw2d.Shape#fillShape(org.eclipse.draw2d.Graphics)
	 **/
	protected void fillShape(Graphics graphics) {
		Rectangle bounds = getBounds ().getCopy ();
		bounds.width -= 1;
		bounds.height -=1;
		
		_vis.fillShape (graphics, bounds, null, _rotation);
	}
	
	
	/**
	 * @param graphics
	 * @see org.eclipse.draw2d.Shape#outlineShape(org.eclipse.draw2d.Graphics)
	 **/
	protected void outlineShape(Graphics graphics) {
		Rectangle bounds = getBounds ().getCopy ();
		bounds.height -= 2;
		bounds.height -= 2;
		
		_vis.outlineShape (graphics, bounds);
	}
	
	/**
	 * 
	 * @see org.eclipse.draw2d.Figure#removeNotify()
	 **/
	public void removeNotify() {
		super.removeNotify ();
		_vis.dispose ();
	}
}