/*
 * Created on Jul 28, 2004
 * 
 */
package AcmeStudio.ui.editors.diagram.palette;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.eclipse.gef.DefaultEditDomain;
import org.eclipse.gef.ui.palette.PaletteViewer;
import org.eclipse.ui.IEditorPart;

/**
 * @author Bradley Schmerl
 * A class that allows changes in palette viewer to be watched.
 * This allows some tools to update their label based on with 
 * width of the tool
 *
 */
public class AcmeStudioEditDomain extends DefaultEditDomain {

	private List _listeners;

	/**
	 * @param editorPart
	 */
	public AcmeStudioEditDomain(IEditorPart editorPart) {
		super(editorPart);
		_listeners = new ArrayList ();
	}

	public void addPaletteViewerListener (IPaletteViewerListener l) {
		_listeners.add (l);
	}
	
	/**
	 * @param palette
	 * @see org.eclipse.gef.EditDomain#setPaletteViewer(org.eclipse.gef.ui.palette.PaletteViewer)
	 */
	public void setPaletteViewer(PaletteViewer palette) {
		super.setPaletteViewer(palette);
		firePaletteChanged ();
	}

	/**
	 * Let all listeners know that the palette has changed
	 */
	private void firePaletteChanged() {
		for (Iterator iter = _listeners.iterator(); iter.hasNext();) {
			IPaletteViewerListener l = (IPaletteViewerListener) iter.next();
			l.setPaletteViewer (this.getPaletteViewer());
		}
	}
}
