/*
 * Created on Feb 14, 2003
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code Template
 */
package AcmeStudio.ui.editors.diagram.palette;

import java.util.HashMap;
import java.util.Map;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.swt.graphics.Device;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.ImageData;
import AcmeStudio.util.ImageManager;
import AcmeStudio.util.ManagedImage;

/**
 * @author schmerl
 */
public class PaletteImageDescriptor extends ImageDescriptor {

    protected ManagedImage _image;
    protected String _key;
    
    public static Map existingDescriptors = new HashMap ();
    
    
    public static PaletteImageDescriptor createDescriptor (String key, Image image) {
        
//        if (existingDescriptors.containsKey (key)) {
//            return (PaletteImageDescriptor )existingDescriptors.get (key);   
//        }   
//        else {
    	ManagedImage mim = ManagedImage.get(key);
    	if (mim == null) {
    		mim = new ManagedImage (image, null);
    	}
    		
            PaletteImageDescriptor ret = new PaletteImageDescriptor (mim);
            ret._key = key;
//            existingDescriptors.put (key, ret);
            return ret;
//        }
    }
    
    public PaletteImageDescriptor (ManagedImage image) {
        super ();
        _image = image;
        image.reference (this);
    }

    /* (non-Javadoc)
     * @see org.eclipse.jface.resource.ImageDescriptor#getImageData()
     */
    public ImageData getImageData() {
        return _image.getImageData();
    }

    /* (non-Javadoc)
     * @see org.eclipse.jface.resource.ImageDescriptor#createImage()
     */
    public Image createImage() {
        return getImage ().getImage ();
    }

    /* (non-Javadoc)
     * @see org.eclipse.jface.resource.ImageDescriptor#createImage(boolean, org.eclipse.swt.graphics.Device)
     */
    public Image createImage(boolean returnMissingImageOnError, Device device) {
        return getImage ().getImage ();
    }

    /* (non-Javadoc)
     * @see org.eclipse.jface.resource.ImageDescriptor#createImage(boolean)
     */
    public Image createImage(boolean returnMissingImageOnError) {
        return getImage ().getImage ();
    }

    /* (non-Javadoc)
     * @see org.eclipse.jface.resource.ImageDescriptor#createImage(org.eclipse.swt.graphics.Device)
     */
    public Image createImage(Device device) {
        return getImage ().getImage ();
    }


    public void dispose () {
        if (_image != null) {
//            AcmeStudio.util.Debug.diagnoseln("Disposing image in image descriptor");
            ImageManager.imageDisposed ("PaletteImageDescriptor.dispose." + _key, _image.getImage ());
            _image.dispose (this);
        }
    }
    
    public boolean isDisposed () {
        return _image.isDisposed ();
    }
    
    public ManagedImage getImage () {
        return _image;
    }
   
    public void setImage (ManagedImage image) {
//        if (_image != null) {
////            AcmeStudio.util.Debug.diagnoseln("(2) Disposing image in image descriptor");
//ImageManager.imageDisposed("PaletteImageDescriptor.dispose." + _key, _image);           
//            _image.dispose();
//         }
    	if (_image != null) {
    		_image.dispose (this);
    	}
        _image = image;
        _image.reference (this);
    }
    
    
    /* (non-Javadoc)
     * @see java.lang.Object#equals(java.lang.Object)
     */
    public boolean equals(Object arg0) {
        return arg0 instanceof PaletteImageDescriptor && _image != null &&
            _image.equals (((PaletteImageDescriptor )arg0)._image);
    }

}
