/*
 * Created on Jun 15, 2004
 *
 */
package AcmeStudio.ui.editors.diagram.palette.extension;

import org.eclipse.gef.EditPart;



/**
 * @author Bradley Schmerl
 * Created Jun 15, 2004
 */
public class AcmeStudioPaletteEditPartFactory extends org.eclipse.gef.ui.palette.PaletteEditPartFactory {

	/**
	 *  Constructs a PaletteEditPartFactory object
	 */
	public AcmeStudioPaletteEditPartFactory() {
		super ();
	}
	/**
	 * Overrides super class to handle the PaletteTree model
	 * @see org.eclipse.gef.EditPartFactory#createEditPart(org.eclipse.gef.EditPart, java.lang.Object)
	 *
	 */
	public EditPart createEditPart (EditPart parentEditPart, Object model) {
		if (model instanceof PaletteTree) {
			return createPaletteTreeEditPart (parentEditPart, model);
		}
		else if (model instanceof AcmeStudioPaletteSeparator) {
			return createSeparatorEditPart(parentEditPart, model);
		}
		else if (model instanceof PaletteTab) {
			return createPaletteTabEditPart (parentEditPart, model);
		}
		else {
			return super.createEditPart(parentEditPart, model);
		}
	}

	/**
	 * Creates a PaletteTreeEditPart for the PaletteTree model
	 * @param parentEditPart
	 * @param model
	 * @return
	 */
	protected EditPart createPaletteTreeEditPart(EditPart parentEditPart, Object model) {
		return new PaletteTreeEditPart ((PaletteTree )model);
	}
	
	/**
	 * Creates a PaletteTabEditPart for the PaletteTab model
	 * @param parent
	 * @param model
	 * @return
	 */
	protected EditPart createPaletteTabEditPart (EditPart parent, Object model) {
		return new PaletteTabEditPart ((PaletteTab) model);
	}
	
	
	/**
	 * @param parentEditPart
	 * @param model
	 * @return
	 * @see org.eclipse.gef.ui.palette.PaletteEditPartFactory#createSeparatorEditPart(org.eclipse.gef.EditPart, java.lang.Object)
	 */
	protected EditPart createSeparatorEditPart(EditPart parentEditPart,
			Object model) {
		if (model instanceof AcmeStudioPaletteSeparator)
			return new AcmeStudioPaletteSeparatorEditPart ((AcmeStudioPaletteSeparator )model);
		else
			return super.createSeparatorEditPart(parentEditPart, model);
	}
}
