/*
 * Created on Jan 4, 2004
 */
package AcmeStudio.ui.editors.diagram.palette.extension;

import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import org.eclipse.gef.palette.PaletteEntry;

/**
 * @author Bradley Schmerl
 * The model for the AcmeStudio-specific separator, that must
 * contain a label
 */
public class AcmeStudioPaletteSeparator extends PaletteEntry {

	public static final String
	PROPERTY_OPEN                          = "Open";      //$NON-NLS-1$
	protected List _manages = new LinkedList ();
	protected boolean open = true;
	
	public boolean isOpen() {
		return open;
	}
	public void setOpen(boolean open) {
		if (open == this.open) return;
		this.open = open;
		for (Iterator iter = _manages.iterator (); iter.hasNext ();) {
			PaletteEntry e = (PaletteEntry )iter.next ();
			e.setVisible(open);
		}
		listeners.firePropertyChange(PROPERTY_OPEN, !open, open);
		
	}
	/**
	 * @param id The id of the separator
	 * @param label The label for the separator
	 */
	public AcmeStudioPaletteSeparator(String id, String label) {
		super (label, "", new Integer (1));
		setId(id);
		setLabel (label);
	}
	
	public void addManaged (PaletteEntry entry) {
		_manages.add (entry);
	}
	
	public void addAllManaged (List l) {
		_manages.addAll (l);
	}
	
	public void removeManaged (PaletteEntry entry) {
		_manages.remove (entry);
	}
	
	public void clearManaged () {
		_manages.clear ();
	}

	/* package */ List getManaged () {
		return _manages;
	}
}
