/*
 * Created on Dec 15, 2004
 *
 */
package AcmeStudio.ui.editors.diagram.palette.extension;

import org.eclipse.gef.palette.PaletteContainer;
import org.eclipse.gef.palette.PaletteEntry;


/**
 * @author Bradley Schmerl
 * Created Dec 15, 2004
 * 
 * Allows tabs to be added to the palette. Tabs are drawn down the side of the palette and allow for additional
 * organization of the palette
 */
public class PaletteTab extends PaletteContainer {

	/** The entry that is active in the tab **/
	protected PaletteEntry _activeEntry;
	
	public static final String PALETTE_TAB = "$PaletteTab";
	public static final String PROPERTY_ACTIVE_TAB = "$ActiveTab";

	private static final String	PALETTE_TAB_TYPE	= "PaletteTab";
	
	/**
	 * Creates the palette tab
	 *
	 */
	public PaletteTab() {
		super ("Tab", null, null, PALETTE_TAB_TYPE);
		setUserModificationPermission(PERMISSION_LIMITED_MODIFICATION);
	}
	
	/**
	 * 
	 * @return the entry that is displayed in the tab
	 */
	public PaletteEntry getActiveEntry() {
		return _activeEntry;
	}
	
	/**
	 * Set the entry to be displayed in the tab
	 * @param activeEntry The new active entry
	 */
	public void setActiveEntry(PaletteEntry activeEntry) {
		PaletteEntry oldEntry = _activeEntry;
		if (!getChildren ().contains(activeEntry)) return;
		if (_activeEntry != null && _activeEntry.equals (activeEntry)) return;
		_activeEntry = activeEntry;
		listeners.firePropertyChange(PROPERTY_ACTIVE_TAB, oldEntry, _activeEntry);
	}
}
