/*
 * Created on Aug 27, 2004
 *
 */
package AcmeStudio.ui.editors.diagram.parts;

import java.util.LinkedList;
import java.util.List;
import org.eclipse.draw2d.*;
import org.eclipse.draw2d.geometry.Point;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.EditPartViewer;
import org.eclipse.gef.editparts.AbstractGraphicalEditPart;
import AcmeStudio.ui.editors.diagram.figures.SystemView;
import acmeLib.representations.AcmeRepresentation;


/**
 * @author Bradley Schmerl
 * Created Aug 27, 2004
 */
public class AcmeRepresentationEditPart extends AbstractGraphicalEditPart {

	private ScalableFreeformLayeredPane	_pane;
	/**
	 * 
	 */
	public AcmeRepresentationEditPart() {
		super ();
	}
	/**
	 * @return
	 * @see org.eclipse.gef.editparts.AbstractEditPart#getModelChildren()
	 **/
	protected List getModelChildren() {
		LinkedList children = new LinkedList ();
		children.add (((AcmeRepresentation )getModel ()).getSystem());
		return children;
	}
	
	
	
	/**
	 * @return
	 * @see org.eclipse.gef.editparts.AbstractGraphicalEditPart#getContentPane()
	 **/
	public IFigure getContentPane() {
		return _pane;
	}
	/**
	 * @return
	 * @see org.eclipse.gef.editparts.FreeformGraphicalRootEditPart#getViewer()
	 **/
	public EditPartViewer getViewer() {
		return getParent ().getViewer();
	}
	/**
	 * @return
	 * @see org.eclipse.gef.editparts.AbstractGraphicalEditPart#createFigure()
	 **/
	protected IFigure createFigure() {
//		Figure figure = new Figure ();
//		figure.setBorder (new AbstractBorder () {
//			private  Insets INSETS = new Insets (6, 6, 6, 6);
//
//			public Insets getInsets(IFigure figure) {
//				return INSETS;
//			}
//
//			public void paint(IFigure figure, Graphics graphics, Insets insets) {
//				Rectangle r = figure.getBounds ().getCropped(insets);
//				graphics.drawRectangle(r);
//			}
//			
//		});
		FreeformViewport port = new FreeformViewport ();
		port.setLayoutManager(new StackLayout ());
		 _pane = new ScalableFreeformLayeredPane ();
		 _pane.setScale (0.25);
		 _pane.setLayoutManager(new FreeformLayout ());
		port.setContents (_pane);
		port.setBackgroundColor(ColorConstants.listBackground);
		port.setOpaque(true);
		return port;
//		figure.add (port);
//		return figure;
	}
	/**
	 * 
	 * @see org.eclipse.gef.editparts.AbstractEditPart#createEditPolicies()
	 **/
	protected void createEditPolicies() {
	}
	/**
	 * 
	 * @see org.eclipse.gef.editparts.AbstractEditPart#refreshVisuals()
	 **/
	protected void refreshVisuals() {
		super.refreshVisuals ();
		Rectangle innerBounds = SystemView.getSystemBounds(((AcmeRepresentation )getModel ()).getSystem());
		Rectangle myBounds = getFigure ().getBounds ();
		double aspectRatio = 1;
		if (innerBounds.height > myBounds.height) {
			aspectRatio = (double )myBounds.height/(double )innerBounds.height;
		}
		if (innerBounds.width > myBounds.width) {
			double ar =  (double )myBounds.width/ (double )innerBounds.width;
			aspectRatio = Math.min (aspectRatio, ar);
		}
		_pane.setScale (aspectRatio);
		_pane.setLocation(new Point (0,0));
	}
}
