package AcmeStudio.ui.editors.diagram.parts;

import java.util.Iterator;
import java.util.Map;
import java.util.Set;

import org.eclipse.draw2d.IFigure;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.editparts.AbstractConnectionEditPart;

import AcmeStudio.ui.editors.diagram.figures.BindingView;
import AcmeStudio.ui.editors.diagram.figures.ElementFigureFactory;
import AcmeStudio.ui.editors.diagram.figures.SystemView;
import AcmeStudio.ui.editors.diagram.policies.ElementEditPolicy;

/**
 * @author schmerl
 *
 */
public class BindingEditPart extends AbstractConnectionEditPart {

    /**
     * Constructor for BindingEditPart.
     */
    public BindingEditPart() {
        super();
    }

    /**
     * @see org.eclipse.gef.editparts.AbstractEditPart#createEditPolicies()
     */
    protected void createEditPolicies() {
        installEditPolicy(EditPolicy.COMPONENT_ROLE, new ElementEditPolicy());
    }

	/**


	/**
	 * @see org.eclipse.gef.editparts.AbstractGraphicalEditPart#createFigure()
	 */
	protected IFigure createFigure() {
		if (getModel () == null) return null;
		if (((SystemEditPart.Binding )getModel ())._binding.getInner() == null) return null;
        
		BindingView f = (BindingView )ElementFigureFactory.createBindingView ();
        f.setSystemView((SystemView)((SystemEditPart)this.getParent()).getFigure());

        SystemEditPart.Binding binding = (SystemEditPart.Binding)getModel();
        SystemEditPart.BindingPoint outer = binding._outer;
        Map editPartMap = this.getRoot().getViewer().getEditPartRegistry();
        Set modelSet = editPartMap.keySet();
        Iterator iter = modelSet.iterator();
        while (iter.hasNext()) {
            Object obj = iter.next();
           if (obj.equals(outer)) {
                binding._outer = (SystemEditPart.BindingPoint)obj;
                break;
            }
        }
      
		f.setModel (binding);
		return f;		
	}

    /**
     * @see org.eclipse.gef.editparts.AbstractConnectionEditPart.deactivateFigure()
     */
    protected void deactivateFigure() {
    }

    /**
     * @see org.eclipse.gef.editparts.AbstractConnectionEditPart.activateFigure()
     */
    protected void activateFigure() {
    }

}
