package AcmeStudio.ui.editors.diagram.parts;

import org.eclipse.draw2d.IFigure;
import org.eclipse.gef.AccessibleEditPart;
import org.eclipse.gef.RootEditPart;
import org.eclipse.swt.accessibility.AccessibleEvent;
import AcmeStudio.ui.editors.diagram.figures.BindingPointView;
import AcmeStudio.ui.editors.diagram.figures.ElementFigureFactory;
import AcmeStudio.ui.editors.diagram.parts.SystemEditPart.BindingPoint;
import AcmeStudio.util.Helper;
import acmeLib.elements.AcmeSystem;

/**
 * @author schmerl
 *
 */
public class BindingPointEditPart extends /*AbstractConnectionEditPart*/ElementEditPart  {

	
	
	/**
	 * 
	 * @see AcmeStudio.ui.editors.diagram.parts.ElementEditPart#createEditPolicies()
	 **/
	protected void createEditPolicies() {
		super.createEditPolicies();
		
	}
	/**
	 * @see AcmeStudio.editors.diagram.controller.ElementEditPart#createAccessible()
	 */
	protected AccessibleEditPart createAccessible() {
		return new AccessibleGraphicalEditPart () {
			public void getName (AccessibleEvent e) {
				e.result = "Binding point";
			}
		};
	}

	/**
	 * @see org.eclipse.gef.editparts.AbstractGraphicalEditPart#createFigure()
	 */
	protected IFigure createFigure() {
		if (getModel () == null)
			return null;
		BindingPointView f = (BindingPointView )ElementFigureFactory.createBindingPointView();
		f.setModel ((SystemEditPart.BindingPoint )getModel ());
		return f;
	}

    /**
     * @see org.eclipse.core.runtime.IAdaptable#getAdapter(Class)
     */
    public Object getAdapter(Class adapter) {
        return super.getAdapter(adapter);
    }
    
    public BindingPointEditPart () {
    	super ();
    }
    
    public void deactivate () {
    	super.deactivate ();
    }
    
    
	/**
	 * 
	 * @see AcmeStudio.ui.editors.diagram.parts.ElementEditPart#refreshVisuals()
	 **/
	protected void refreshVisuals() {
		SystemEditPart.BindingPoint bp = (BindingPoint )getModel ();
		AcmeSystem sys = bp._parentRep.getSystem ();
//		RootEditPart rep = Helper.getDiagramEditorForSystem(sys).getGraphicalViewer().getRootEditPart();
//		if (rep.getModel () == Boolean.FALSE) getFigure ().setVisible(false);
//		else getFigure ().setVisible (true);
		super.refreshVisuals ();
	}
}
