/*
 * Created on Feb 22, 2005
 *
 */
package AcmeStudio.ui.editors.diagram.parts;

import AcmeStudio.util.AcmeModelChangeListener;
import AcmeStudio.util.AcmeStudioChangeManager;
import AcmeStudio.util.AcmeStudioChangeManager.AcmeStudioChangeEvent;


/**
 * @author Bradley Schmerl
 * Created Feb 22, 2005
 */
public class MovableEditPart extends ElementEditPart implements AcmeModelChangeListener {
	
	/**
	 * 
	 * @see org.eclipse.gef.EditPart#addNotify()
	 **/
    public void addNotify() {
		AcmeStudioChangeManager.registerListener(this);
		super.addNotify ();
	}
    


	public void removeNotify() {
		AcmeStudioChangeManager.removeListener(this);
		super.removeNotify ();
	}
	
	
	/**
	 * @param eventType
	 * @return
	 * @see AcmeStudio.util.AcmeModelChangeListener#interestedInEvent(int)
	 **/
	public boolean interestedInEvent(int et) {
		return	et == AcmeStudioChangeManager.SET_PROPERTY ||
		et == AcmeStudioChangeManager.UPDATE_VIS_INFO;
	}
	
	
	/**
	 * @param evt
	 * @see AcmeStudio.util.AcmeModelChangeListener#changeModel(AcmeStudio.util.AcmeStudioChangeManager.AcmeStudioChangeEvent)
	 **/
	public void changeModel(AcmeStudioChangeEvent evt) {
		if (evt.getTarget() == this.getModel ()) {
			this.refresh ();
		}
	}
}
