/*
 * Created on Jan 19, 2004
 *
 */
package AcmeStudio.ui.editors.diagram.policies;

import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.DirectEditPolicy;
import org.eclipse.gef.requests.DirectEditRequest;

import AcmeStudio.model.SetElementNameCommand;
import AcmeStudio.ui.editors.diagram.parts.ElementEditPart;
import acmeLib.core.globals.LanguageConfig;
import acmeLib.elements.AcmeElement;



/**
 * @author Bradley Schmerl
 * Created Jan 19, 2004
 */
public class ElementDirectEditPolicy extends DirectEditPolicy {

	/**
	 * 
	 */
	public ElementDirectEditPolicy() {
		super ();
	}

/* (non-Javadoc)
	 * @see org.eclipse.gef.editpolicies.DirectEditPolicy#getDirectEditCommand(org.eclipse.gef.requests.DirectEditRequest)
	 */
	protected Command getDirectEditCommand(DirectEditRequest request) {
		String newName = (String )request.getCellEditor().getValue ();
		ElementEditPart part = (ElementEditPart )getHost ();
		AcmeElement element = (AcmeElement) part.getModel();
        
        if (!newName.equals (element.getName ()) && element.getParent().lookupName(newName, false) == null) {
        	if (newName.length () == 0 || LanguageConfig.isArmaniKeyword(newName) || LanguageConfig.isAcmeKeyword(newName)) {
        		return null;
        	}
            else {
            	return new SetElementNameCommand ("Change name", newName, element.getName (), element);
            }
        }
        else {
            return null;
        }
     
	}

	/* (non-Javadoc)
	 * @see org.eclipse.gef.editpolicies.DirectEditPolicy#showCurrentEditValue(org.eclipse.gef.requests.DirectEditRequest)
	 */
	protected void showCurrentEditValue(DirectEditRequest request) {
		String value = (String )request.getCellEditor ().getValue ();
		getHostFigure().getUpdateManager().performUpdate();
	}
}
