package AcmeStudio.ui.editors.diagram.policies;
/*
 * Licensed Material - Property of IBM
 * (C) Copyright IBM Corp. 2001, 2002 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 */

import java.util.Iterator;

import org.eclipse.gef.EditPart;
import org.eclipse.gef.Request;
import org.eclipse.gef.commands.Command;

import AcmeStudio.ui.editors.diagram.IElementFactory;
import AcmeStudio.ui.editors.diagram.actions.DeleteElementCommand;
import AcmeStudio.ui.editors.diagram.parts.SystemEditPart;
import acmeLib.elements.AcmeElement;

public class ElementEditPolicy
	extends org.eclipse.gef.editpolicies.ComponentEditPolicy
{

//protected Command createDeleteCommand(DeleteRequest request) {
//	DeleteElementCommand deleteCmd = new DeleteElementCommand(getHost());
//	deleteCmd.setChild((AcmeElement)getHost().getModel());
//	return deleteCmd;
//}

    /**
     * @see org.eclipse.gef.EditPolicy#getCommand(Request)
     */
    public Command getCommand(Request request) {
        if (REQ_DELETE.equals (request.getType())) {
            EditPart part = getHost();
            Object model = part.getModel();
            if (DeleteElementCommand.appliesTo (model)) {// instanceof AcmeElement) {
                DeleteElementCommand deleteCmd = 
                    new DeleteElementCommand (getHost ());
                deleteCmd.setChild ((AcmeElement )getHost ().getModel ());
                return deleteCmd;
            } else if (model instanceof SystemEditPart.Binding) {
                DeleteElementCommand deleteCmd = 
                    new DeleteElementCommand (part);
                SystemEditPart.Binding binding = (SystemEditPart.Binding)model;
                deleteCmd.setChild (binding._binding);
                return deleteCmd;
            }
            else {
            	Iterator i = SystemEditPart.factories.iterator();
            	Command cmd = null;
            	while (i.hasNext ()) {
            		IElementFactory factory = (IElementFactory )i.next ();
            		if ((cmd = factory.getDeleteCommand (model)) != null) {
            			break;
            		} 
            		
            	}	
            	return cmd;
            	
            }
//            return null;
        }
        return super.getCommand(request);
    }

}