/*
 * Created on Jun 29, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package AcmeStudio.ui.editors.diagram.policies;

import org.eclipse.draw2d.AbstractBorder;
import org.eclipse.draw2d.Graphics;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.geometry.Insets;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.RGB;
import com.swtdesigner.SWTResourceManager;

/**
 * This class is used with ItemOutlineEditPolicy to provide feedback when
 * the user is rolled over an item in their work area.  It represents
 * the border used to highlight a figure
 * 
 * @author Larry Waldman
 *
 */
public class HighlightBorder extends AbstractBorder
{
    private Rectangle r;
    private Color highlight;
    private int width;
	private RGB rgb;
    
    HighlightBorder(Rectangle bounds, int borderWidth, Color bcolor)
    {
        this.r = bounds;
        width = borderWidth;
        highlight = bcolor;
        rgb = highlight.getRGB ();
    }

    /* (non-Javadoc)
     * @see org.eclipse.draw2d.Border#getInsets(org.eclipse.draw2d.IFigure)
     */
    public Insets getInsets(IFigure figure)
    {
        return null;
    }
    /* (non-Javadoc)
     * @see org.eclipse.draw2d.Border#paint(org.eclipse.draw2d.IFigure, org.eclipse.draw2d.Graphics, org.eclipse.draw2d.geometry.Insets)
     */
    public void paint(IFigure figure, Graphics g, Insets insets)
    {	
    		if (highlight.isDisposed()) 
    			highlight = SWTResourceManager.getColor (rgb);
            g.setForegroundColor(highlight);
        	g.setBackgroundColor(highlight);
        	
        	//Draw the sides of the border as defined by the parameters passed
        	//in to the c'tor
        	g.fillRectangle(r.x, r.y - (width-1), r.width + 1, width);
        	g.fillRectangle(r.x, r.bottom() - 1, r.width + 1, width);
        	g.fillRectangle(r.x - (width-1), r.y - (width-1), width, r.height + (2*(width-1)));
        	g.fillRectangle(r.right(), r.y - (width-1), width, r.height + (2*(width-1)));
    }
}
