/*
 * Created on May 12, 2005
 *
 */
package AcmeStudio.ui.editors.diagram.policies;

import java.util.List;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.StackLayout;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.draw2d.geometry.Rectangle;


/**
 * @author Bradley Schmerl
 * Created May 12, 2005
 */
public class InlineRepresentationLayout extends StackLayout {
	
	
	/**
	 * @param figure
	 * @see org.eclipse.draw2d.StackLayout#layout(org.eclipse.draw2d.IFigure)
	 **/
	public void layout(IFigure figure) {
		Rectangle area = figure.getClientArea ();
		Dimension childSize;
		
		List children = figure.getChildren ();
		IFigure child;
		for (int i = 0; i < children.size (); i++) {
			child = (IFigure )children.get (i);
			childSize = child.getPreferredSize (Math.max (0, area.width), Math.max (0, area.height));
			int widthDiff = Math.abs (childSize.width - area.width);
			int heightDiff = Math.abs (childSize.height - area.height);
			area.x += (area.width - childSize.width)/2;
			area.y += (area.height - childSize.height)/2;
			
		
//			if (childSize.width < area.width) {
//				area.x += (area.width - childSize.width)/2;
//				area.width = childSize.width;
//			}
			
			child.setBounds (area);
		}
		
//		super.layout (figure);
	}
}
