/*
 * Created on Aug 6, 2004
 * 
 */
package AcmeStudio.ui.editors.diagram.policies;

import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.draw2d.geometry.Point;
import org.eclipse.gef.tools.ResizeTracker;

import AcmeStudio.ui.editors.diagram.figures.RoleView;
import AcmeStudio.ui.editors.diagram.parts.RoleEditPart;

/**
 * @author Bradley Schmerl
 *
 */
public class ResizeRoleTracker extends ResizeTracker {

	private double _rotation;
	private Point _center;

	/**
	 * @param owner
	 * @param direction
	 */
	public ResizeRoleTracker(RoleEditPart owner, int direction) {
		super(owner, direction);
		RoleView roleView = ((RoleView )owner.getFigure());
		_rotation = roleView.getDecoration().getRotation();
		_center = roleView.getEnd();
		roleView.translateToAbsolute(_center);
	}
	
	/**
	 * @return
	 * @see org.eclipse.gef.tools.AbstractTool#getDragMoveDelta()
	 */
	protected Dimension getDragMoveDelta() {
		Point location = getLocation().getCopy ();
		Point startLocation = getStartLocation().getCopy ();
		double theta = - Math.atan2 (_center.y - location.y, _center.x - location.x) - _rotation;
		double r = _center.getDistance (location);
		
		location.x = (int )(_center.x + r * Math.cos (theta));
		location.y = (int )(_center.y + r * Math.sin (theta));
		
		r = _center.getDistance (startLocation);
		theta = - Math.atan2 (_center.y - startLocation.y, _center.x - startLocation.y) - _rotation;
		startLocation.x = (int )(_center.x + r * Math.cos(theta));
		startLocation.y = (int )(_center.y + r * Math.sin (theta));
		return location.getDifference(startLocation);
	}

}
