/*
 * Created on Feb 22, 2004
 *
 */
package AcmeStudio.ui.editors.diagram.policies;

import java.util.*;

import org.eclipse.draw2d.geometry.PrecisionRectangle;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.GraphicalEditPart;
import org.eclipse.gef.Request;
import org.eclipse.gef.requests.ChangeBoundsRequest;

import AcmeStudio.ui.editors.diagram.parts.SystemEditPart;
import acmeLib.elements.AcmeComponent;
import acmeLib.elements.AcmeConnector;
import acmeLib.elements.AcmePort;


/**
 * @author Bradley Schmerl
 * Created Feb 22, 2004
 */
public class SnapToGeometry extends org.eclipse.gef.SnapToGeometry {

	/**
	 * @param container
	 */
	public SnapToGeometry(GraphicalEditPart container) {
		super (container);
	}
	/* (non-Javadoc)
	 * @see org.eclipse.gef.SnapToStrategy#snapMoveRequest(org.eclipse.gef.requests.ChangeBoundsRequest, org.eclipse.draw2d.geometry.PrecisionRectangle, org.eclipse.draw2d.geometry.PrecisionRectangle, int)
	 */
	
	public int snapRectangle (Request request, int snapOrientation, PrecisionRectangle baseRect, PrecisionRectangle result) {
		/*List editParts = super.generateSnapPartsList(Collections.EMPTY_LIST);
		populateWithDisimilar(editParts);*/
		// TODO: Need to update this to only snap to dissimilare objects (like snapMoveRequest and snapResizeRequest below)
		return super.snapRectangle(request, snapOrientation, baseRect, result);
		
	}
	
	/*public int snapMoveRequest(ChangeBoundsRequest request, PrecisionRectangle baseRect, PrecisionRectangle selectionRect,
			int snapOrientation) {
		List editParts = new ArrayList (request.getEditParts ());
		populateWithDisimilar (editParts);
		ChangeBoundsRequest interceptedRequest = new ChangeBoundsRequest ();
		interceptedRequest.setEditParts(editParts);
		copyRequest (request, interceptedRequest);
		int snap = super.snapMoveRequest(interceptedRequest, baseRect, selectionRect, snapOrientation);
		copyRequest (interceptedRequest, request);
		return snap;
		
	}*/
	private void copyRequest(ChangeBoundsRequest request, ChangeBoundsRequest interceptedRequest) {
		interceptedRequest.setExtendedData(request.getExtendedData ());
		interceptedRequest.setLocation(request.getLocation ());
		interceptedRequest.setLocation(request.getLocation());
		interceptedRequest.setMoveDelta(request.getMoveDelta ());
		interceptedRequest.setResizeDirection(request.getResizeDirection());
		interceptedRequest.setSizeDelta(request.getSizeDelta());
		interceptedRequest.setType(request.getType ());
	}
	/* (non-Javadoc)
	 * @see org.eclipse.gef.SnapToStrategy#snapResizeRequest(org.eclipse.gef.requests.ChangeBoundsRequest, org.eclipse.draw2d.geometry.PrecisionRectangle, int)
	 */
/*	public int snapResizeRequest(ChangeBoundsRequest request, PrecisionRectangle baseRect, int snapOrientation) {
		List editParts = new ArrayList (request.getEditParts ());
		populateWithDisimilar (editParts);
		ChangeBoundsRequest interceptedRequest = new ChangeBoundsRequest ();
		interceptedRequest.setEditParts(editParts);
		copyRequest (request, interceptedRequest);
		int snap = super.snapResizeRequest(interceptedRequest, baseRect, snapOrientation);
		copyRequest (interceptedRequest, request);
		return snap;
	}*/
	/**
	 * @param editParts
	 */
	private void populateWithDisimilar(List editParts) {
		Set containedElements = new HashSet ();
		Set ports = new HashSet ();
		Set eps = new HashSet ();
		eps.addAll(editParts);
//		boolean containsComponents = false;
//		boolean containsPorts = false;
//		boolean containsRoles = false;
//		boolean containsConnectors = false;
		for (Iterator iter = eps.iterator (); iter.hasNext ();) {
			EditPart part = (EditPart )iter.next ();
			
			Object	model	= part.getModel ();
			containedElements.add (model.getClass ());
			if (model instanceof AcmeComponent) {
				containedElements.add (AcmeConnector.class);
			}
			else if (model instanceof AcmeConnector) {
				containedElements.add (AcmeComponent.class);
			}
			else if (model instanceof AcmePort) {
				ports.add (model);
			}
			/*if (model instanceof AcmeComponent) {
				containsComponents = true;
			}
			else if (model instanceof AcmeConnector) {
				containsConnectors = true;
			}
			else if (model instanceof AcmeRole) {
				containsRoles = true;
			}
			else if (model instanceof AcmePort) {
				containsPorts = true;
			}*/
			
		}
		
		EditPart sysEditPart = (EditPart )editParts.get(0);
		while (!(sysEditPart instanceof SystemEditPart)) {
			sysEditPart = sysEditPart.getParent();
		}
		
		for (Iterator iter = sysEditPart.getChildren().iterator (); iter.hasNext ();) {
			EditPart part = (EditPart )iter.next ();
			Object model = part.getModel ();
			if (!containedElements.contains (model.getClass ())) {
				eps.add(part);
			}
		}
		
		for (Iterator iter = ports.iterator (); iter.hasNext ();) {
			AcmePort port = (AcmePort )iter.next ();
			AcmeComponent parent = (AcmeComponent )port.getParent ();
			eps.add (parent);
		}
		
		editParts.clear();
		editParts.addAll (eps);
		
	}
}
