/*
 * Created on Feb 22, 2004
 *
 */
package AcmeStudio.ui.editors.diagram.policies;

import org.eclipse.draw2d.Figure;
import org.eclipse.draw2d.Graphics;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.geometry.Point;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.GraphicalEditPart;
import org.eclipse.gef.LayerConstants;
import org.eclipse.gef.editpolicies.SnapFeedbackPolicy;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Color;


/**
 * @author Bradley Schmerl
 * Created Feb 22, 2004
 */
public class UnobtrusiveSnapFeedbackPolicy extends SnapFeedbackPolicy {


	/**
	 * @author Bradley Schmerl
	 * Created Feb 22, 2004
	 */
	public class HighlightFigure extends Figure {

		/**
		 * 
		 */
		public HighlightFigure() {
			super ();
		}
		
		
		/* (non-Javadoc)
		 * @see org.eclipse.draw2d.Figure#paintFigure(org.eclipse.draw2d.Graphics)
		 */
		protected void paintFigure(Graphics graphics) {
			graphics.setLineStyle (SWT.LINE_DOT);
			if (getBounds ().width > 1) {
				graphics.drawLine (getBounds ().x, getBounds ().y, getBounds ().x + getBounds ().width, getBounds ().y);
			}
			else 
				graphics.drawLine (getBounds ().x, getBounds ().y, getBounds ().x, getBounds ().y + getBounds ().height);
		}
	}
	/**
	 * 
	 */
	public UnobtrusiveSnapFeedbackPolicy() {
		super ();
	}
	
	
	/* (non-Javadoc)
	 * @see org.eclipse.gef.editpolicies.SnapFeedbackPolicy#highlightGuide(java.lang.Integer, org.eclipse.swt.graphics.Color, boolean)
	 */
	protected void highlightGuide(Integer pos, Color color, boolean horizontal) {
		if (pos == null) return;
		
		int position = pos.intValue ();
		Point loc = new Point (position, position);
		IFigure contentPane = ((GraphicalEditPart )getHost ()).getContentPane ();
		contentPane.translateToParent (loc);
		contentPane.translateToAbsolute (loc);
		
		IFigure fig = new HighlightFigure ();
		fig.setForegroundColor (color);
		addFeedback (fig);
		fig.translateToRelative (loc);
		position = horizontal ? loc.y : loc.x;
		
		Rectangle diagramBounds = getLayer (LayerConstants.FEEDBACK_LAYER).getBounds ();
		Rectangle figBounds = new Rectangle ();
		figBounds.setBounds (diagramBounds);
		if (horizontal) {
			figBounds.height = 1;
			figBounds.y = position;
		}
		else {
			figBounds.width = 1;
			figBounds.x = position;
		}
		fig.setBounds (figBounds);
		// Removed because GEF does things kind of unobtrusively now.
//		figures.add (fig);
	}
}
