/*
 * Created on Dec 8, 2003
 *
 */
package AcmeStudio.ui.editors.diagram.ruler.commands;

import org.eclipse.gef.commands.Command;

import AcmeStudio.ui.editors.diagram.ruler.model.DiagramGuide;
import AcmeStudio.ui.editors.diagram.ruler.model.DiagramRuler;

/**
 * @author Bradley Schmerl
 * Created Dec 8, 2003
 */
public class CreateGuideCommand extends Command {

	private DiagramGuide _guide;
	private DiagramRuler _parent;
	private int _position;
	/**
	 * 
	 */
	public CreateGuideCommand(DiagramRuler parent, int position) {
		super("Create Guide");
		_parent = parent;
		_position = position;
	}

	public boolean canUndo () {
		return true;
	}
	
	public void execute () {
		_guide = new DiagramGuide (!_parent.isHorizontal ());
		_guide.setPosition (_position);
		_parent.addGuide (_guide);
	}

	public void undo () {
		_parent.removeGuide (_guide);
	}

}
