/*
 * Created on Dec 8, 2003
 *
 */
package AcmeStudio.ui.editors.diagram.ruler.commands;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

import org.eclipse.gef.commands.Command;

import AcmeStudio.ui.editors.diagram.ruler.model.DiagramGuide;
import AcmeStudio.ui.editors.diagram.ruler.model.DiagramRuler;
import acmeLib.elements.AcmeElement;

/**
 * @author Bradley Schmerl
 * Created Dec 8, 2003
 */
public class DeleteGuideCommand extends Command {

	private DiagramRuler _parent;
	private DiagramGuide _guide;
	private Map _oldParts;
	
	/**
	 * 
	 */
	public DeleteGuideCommand(DiagramGuide guide, DiagramRuler parent) {
		super ("Delete Guide");
		_guide = guide;
		_parent = parent;
	}

	public boolean canUndo () {
		return true;
	}

	public void execute () {
		_oldParts = new HashMap (_guide.getMap ());
		Iterator i = _oldParts.keySet().iterator ();
		while (i.hasNext()) {
			AcmeElement element = (AcmeElement) i.next();
			_guide.detachElement(element);
		}
		_parent.removeGuide(_guide);
	}
	
	public void undo () {
		_parent.addGuide (_guide);
		Iterator i = _oldParts.keySet().iterator ();
		while (i.hasNext()) {
			AcmeElement element = (AcmeElement) i.next();
			_guide.attachElement(element, ((Integer )_oldParts.get (element)).intValue ());
		}
	}
}
