package AcmeStudio.ui.editors.diagram.styles;

import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import AcmeStudio.AcmeStudioPlugin;
import com.swtdesigner.SWTResourceManager;

/*
 * Created on 7/11/04
 * 
 * @author Larry Waldman
 * 
 * This class is a simple alert dialog box which displays a message
 * to the user with only an ok button, ideal for an alert type message
 */
public class AlertNotificationDialog extends Dialog
{
    private String alertText;
    
    /*
     * C'Tor
     */
    public AlertNotificationDialog(Shell parentShell, String alertText)
    {
        super(parentShell);
        this.alertText = alertText;
    }

  

    protected Control createDialogArea(Composite parent)
    {
        Composite container = (Composite) super.createDialogArea(parent);
        final GridLayout gridLayout = new GridLayout();
        gridLayout.makeColumnsEqualWidth = true;
        gridLayout.numColumns = 1;
        container.setLayout(gridLayout);
        {
            final Label label = new Label(container, SWT.NONE);
            label.setFont(SWTResourceManager.getFont ( AcmeStudioPlugin.getDefaultFontName(), 10, SWT.NONE));
            final GridData gridData = new GridData(
                    GridData.HORIZONTAL_ALIGN_CENTER
                            | GridData.VERTICAL_ALIGN_END);
            gridData.verticalSpan = 2;
            gridData.horizontalSpan = 5;
            label.setLayoutData(gridData);
            label.setText(alertText);
        }
        return container;
    }

    protected void createButtonsForButtonBar(Composite parent)
    {
        createButton(parent, IDialogConstants.OK_ID, IDialogConstants.OK_LABEL,
                true);
    }

    protected void configureShell(Shell newShell)
    {
        super.configureShell(newShell);
        newShell.setText("Application Alert");
    }
}


