/*
 * Created on Aug 18, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package AcmeStudio.ui.editors.diagram.styles;

import java.util.*;
import java.util.List;
import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.jface.viewers.*;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.*;
import AcmeStudio.model.ModelHelper;
import AcmeStudio.util.Helper;
import AcmeStudio.util.ITipInformer;
import AcmeStudio.util.ImageManager;
import AcmeStudio.wizards.connection.PortConnectionRule;
import AcmeStudio.wizards.connection.PortRoleAssociation;
import acmeLib.core.container.AcmeVector;
import acmeLib.core.filters.ComponentTypeEnumFilter;
import acmeLib.core.filters.ConnectorTypeEnumFilter;
import acmeLib.core.filters.PortTypeEnumFilter;
import acmeLib.core.filters.RoleTypeEnumFilter;
import acmeLib.elements.*;
import acmeLib.properties.AcmeProperty;

/**
 * @author LFW
 *
 */
public class PatternBrowser extends Dialog
{
    private Label _lblTgtCompEnd;
    private Label _lblTgtPort;
    private Label _lblTgtComp;
    private Label _lblTgtRole;
    private Label _lblSrcRole;
    private Label _lblSrcCompEnd;
    private Label _lblSrcPort;
    private Label _LblSrcCompBegin;
    private Combo tgtItem;
    private Combo secondRole;
    private Combo connector;
    private Combo firstRole;
    private Combo srcItem;
    private Combo srcComp;
    private Combo tgtComp;
    
    private TableViewer _displayTable;
    private AcmeSystem _system;
    
    private PropertySorter	_propertySorter;
    
    public PatternBrowser(AcmeSystem sys, Shell parentShell)
    {
        super(parentShell);
        _system = sys;
    }
    
    Listener resizeListener = new Listener () {

		public void handleEvent(Event event) {
			resizeColumns (event.item);
		}
    	
    };
    
    
    protected Control createDialogArea(Composite parent)
    {
        Composite container = (Composite) super.createDialogArea(parent);
        final GridLayout gridLayout = new GridLayout();
        gridLayout.verticalSpacing = 0;
        gridLayout.marginWidth = 1;
        gridLayout.numColumns = 22;
        container.setLayout(gridLayout);
        {
            final Label label = new Label(container, SWT.NONE);
            final GridData gridData = new GridData(GridData.HORIZONTAL_ALIGN_CENTER | GridData.VERTICAL_ALIGN_END);
            gridData.verticalSpan = 2;
            gridData.horizontalSpan = 21;
            label.setLayoutData(gridData);
            label.setText("Pattern Browser");
        }
	        {
	            final Label label = new Label(container, SWT.NONE);
	            final GridData gridDataLbl = new GridData(GridData.HORIZONTAL_ALIGN_CENTER | GridData.VERTICAL_ALIGN_END);
	            gridDataLbl.horizontalSpan = 3;
	            label.setLayoutData(gridDataLbl);
	            label.setText("Source Component");
	        }
            {
                final Label label = new Label(container, SWT.NONE);
                final GridData gridDataLbl = new GridData(GridData.HORIZONTAL_ALIGN_CENTER | GridData.VERTICAL_ALIGN_END);
                gridDataLbl.horizontalSpan = 3;
                label.setLayoutData(gridDataLbl);
                label.setText("Source Port");
            }
            {
                final Label label = new Label(container, SWT.NONE);
                final GridData gridDataLbl = new GridData(GridData.HORIZONTAL_ALIGN_CENTER | GridData.VERTICAL_ALIGN_END);
                gridDataLbl.horizontalSpan = 3;
                label.setLayoutData(gridDataLbl);
                label.setText("First Role");
            }
            {
                final Label label = new Label(container, SWT.NONE);
                final GridData gridDataLbl = new GridData(GridData.HORIZONTAL_ALIGN_CENTER | GridData.VERTICAL_ALIGN_END);
                gridDataLbl.horizontalSpan = 3;
                label.setLayoutData(gridDataLbl);
                label.setText("Connector");
            }
            {
                final Label label = new Label(container, SWT.NONE);
                final GridData gridDataLbl = new GridData(GridData.HORIZONTAL_ALIGN_CENTER | GridData.VERTICAL_ALIGN_END);
                gridDataLbl.horizontalSpan = 3;
                label.setLayoutData(gridDataLbl);
                label.setText("Second Role");
            }
            {
                final Label label = new Label(container, SWT.NONE);
                final GridData gridDataLbl = new GridData(GridData.HORIZONTAL_ALIGN_CENTER | GridData.VERTICAL_ALIGN_END);
                gridDataLbl.horizontalSpan = 3;
                label.setLayoutData(gridDataLbl);
                label.setText("Target Port");
            }
            {
                final Label label = new Label(container, SWT.NONE);
                final GridData gridDataLbl = new GridData(GridData.HORIZONTAL_ALIGN_CENTER | GridData.VERTICAL_ALIGN_END);
                gridDataLbl.horizontalSpan = 3;
                label.setLayoutData(gridDataLbl);
                label.setText("Target Component");
            }

        {
        	Label spacer = new Label(container, SWT.NONE);
        }
            {
                _LblSrcCompBegin = new Label(container, SWT.NONE);
                final GridData gridDataLbl = new GridData(GridData.HORIZONTAL_ALIGN_CENTER);
                gridDataLbl.horizontalSpan = 1;
                _LblSrcCompBegin.setLayoutData(gridDataLbl);
                _LblSrcCompBegin.setText("[");
            }
            {
                srcComp = new Combo(container, SWT.READ_ONLY);
                srcComp.setLayoutData(new GridData(GridData.HORIZONTAL_ALIGN_CENTER));
                srcComp.addSelectionListener(new SelectionAdapter()
                {
                    public void widgetSelected(SelectionEvent e)
                    {
                        displayValidRules();
                    }
                });
                srcComp.addListener(SWT.Resize, resizeListener);
            }
            {
                _lblSrcPort = new Label(container, SWT.NONE);
                final GridData gridDataLbl = new GridData(GridData.HORIZONTAL_ALIGN_CENTER);
                gridDataLbl.horizontalSpan = 2;
                _lblSrcPort.setLayoutData(gridDataLbl);
                _lblSrcPort.setText("-");
            }
            {
                srcItem = new Combo(container, SWT.READ_ONLY);
                srcItem.setLayoutData(new GridData(GridData.HORIZONTAL_ALIGN_CENTER));
                srcItem.addSelectionListener(new SelectionAdapter()
                        {
                    public void widgetSelected(SelectionEvent e)
                    {
                        displayValidRules();
                    }
                });
                srcItem.addListener (SWT.Resize, resizeListener);
            }
            {
                _lblSrcCompEnd = new Label(container, SWT.NONE);
                final GridData gridDataLbl = new GridData(GridData.HORIZONTAL_ALIGN_CENTER);
                gridDataLbl.horizontalSpan = 2;
                _lblSrcCompEnd.setLayoutData(gridDataLbl);
                _lblSrcCompEnd.setText("] | ");
            }
            {
                firstRole = new Combo(container, SWT.READ_ONLY);
                firstRole.setLayoutData(new GridData(GridData.HORIZONTAL_ALIGN_CENTER));
                firstRole.addSelectionListener(new SelectionAdapter()
                {
                    public void widgetSelected(SelectionEvent e)
                    {
                        displayValidRules();
                    }
                });
                firstRole.addListener (SWT.Resize, resizeListener);
            }
            {
                _lblSrcRole = new Label(container, SWT.NONE);
                final GridData gridDataLbl = new GridData(GridData.HORIZONTAL_ALIGN_CENTER);
                gridDataLbl.horizontalSpan = 2;
                _lblSrcRole.setLayoutData(gridDataLbl);
                _lblSrcRole.setText("->");
            }
            {
                connector = new Combo(container, SWT.READ_ONLY);
                connector.setLayoutData(new GridData(GridData.HORIZONTAL_ALIGN_CENTER));
                connector.addSelectionListener(new SelectionAdapter()
                {
                    public void widgetSelected(SelectionEvent e)
                    {
                        displayValidRules();
                    }
                });
                connector.addListener (SWT.Resize, resizeListener);
            }
            {
                _lblTgtRole = new Label(container, SWT.NONE);
                final GridData gridDataLbl = new GridData(GridData.HORIZONTAL_ALIGN_CENTER);
                gridDataLbl.horizontalSpan = 2;
                _lblTgtRole.setLayoutData(gridDataLbl);
                _lblTgtRole.setText("->");
            }
            {
                secondRole = new Combo(container, SWT.READ_ONLY);
                secondRole.setLayoutData(new GridData(GridData.HORIZONTAL_ALIGN_CENTER));
                secondRole.addSelectionListener(new SelectionAdapter()
                {
                    public void widgetSelected(SelectionEvent e)
                    {
                        displayValidRules();
                    }
                });
                secondRole.addListener(SWT.Resize, resizeListener);
            }
            {
                _lblTgtComp = new Label(container, SWT.NONE);
                final GridData gridDataLbl = new GridData(GridData.HORIZONTAL_ALIGN_CENTER);
                gridDataLbl.horizontalSpan = 2;
                _lblTgtComp.setLayoutData(gridDataLbl);
                _lblTgtComp.setText("| [");
            }
            {
                tgtItem = new Combo(container, SWT.READ_ONLY);
                tgtItem.setLayoutData(new GridData(GridData.HORIZONTAL_ALIGN_CENTER));
                tgtItem.addSelectionListener(new SelectionAdapter()
                {
                    public void widgetSelected(SelectionEvent e)
                    {
                        displayValidRules();
                    }
                });
                tgtItem.addListener(SWT.Resize, resizeListener);
            }
            {
                _lblTgtPort = new Label(container, SWT.NONE);
                final GridData gridDataLbl = new GridData(GridData.HORIZONTAL_ALIGN_CENTER);
                gridDataLbl.horizontalSpan = 2;
                _lblTgtPort.setLayoutData(gridDataLbl);
                _lblTgtPort.setText("-");
            }
            {
                tgtComp = new Combo(container, SWT.READ_ONLY);
                tgtComp.setLayoutData(new GridData(GridData.HORIZONTAL_ALIGN_CENTER));
                tgtComp.addSelectionListener(new SelectionAdapter()
                {
                    public void widgetSelected(SelectionEvent e)
                    {
                        displayValidRules();
                    }
                });
                tgtComp.addListener (SWT.Resize, resizeListener);
            }
            {
                _lblTgtCompEnd = new Label(container, SWT.NONE);
                final GridData gridDataLbl = new GridData(GridData.HORIZONTAL_ALIGN_CENTER);
                gridDataLbl.horizontalSpan = 1;
                _lblTgtCompEnd.setLayoutData(gridDataLbl);
                _lblTgtCompEnd.setText("]");
            }

        Label label = new Label(container, SWT.NONE);
        GridData gridData = new GridData();
        gridData.widthHint = 150;
        label.setLayoutData(gridData);
        {
            _displayTable = new TableViewer(container, SWT.FULL_SELECTION | SWT.BORDER
                | SWT.H_SCROLL | SWT.V_SCROLL | SWT.MULTI);
            _displayTable.setContentProvider(new RuleContentProvider());
            _displayTable.setLabelProvider(new RuleLabelProvider());
    		
            //define the sorter for the table
            _propertySorter = new PropertySorter ();
    		_displayTable.setSorter(_propertySorter);
    		
            Table table = _displayTable.getTable();
            GridData data = new GridData(GridData.FILL_HORIZONTAL
                    | GridData.FILL_VERTICAL);
            data.horizontalSpan = 22;
            table.setLayoutData(data);
            table.setHeaderVisible(true);
            table.setLinesVisible(true);
            TableLayout layout = new TableLayout();
            TableColumn p1Col = new TableColumn(table, SWT.CENTER, 0);
            p1Col.setText("Src Comp:");
    		p1Col.addSelectionListener(new SelectionAdapter () {
    			public void widgetSelected (SelectionEvent evt) {
    			    _propertySorter.setCol(0);
    				_propertySorter.cycleState();
    				_displayTable.refresh();
    			}
    		});
            ColumnLayoutData p1Data = new ColumnWeightData(30, true);
            layout.addColumnData(p1Data);
            TableColumn p2Col = new TableColumn(table, SWT.CENTER, 1);
            p2Col.setText("Src Port:");
            p2Col.addSelectionListener(new SelectionAdapter () {
    			public void widgetSelected (SelectionEvent evt) {
    			    _propertySorter.setCol(1);
    				_propertySorter.cycleState();
    				_displayTable.refresh();
    			}
    		});
            ColumnLayoutData p2Data = new ColumnWeightData(30, true);
            layout.addColumnData(p2Data);
            TableColumn p3Col = new TableColumn(table, SWT.CENTER, 2);
            p3Col.setText("Src Role:");
            p3Col.addSelectionListener(new SelectionAdapter () {
    			public void widgetSelected (SelectionEvent evt) {
    			    _propertySorter.setCol(2);
    				_propertySorter.cycleState();
    				_displayTable.refresh();
    			}
    		});
            ColumnLayoutData p3Data = new ColumnWeightData(30, true);
            layout.addColumnData(p3Data);
            TableColumn p4Col = new TableColumn(table, SWT.CENTER, 3);
            p4Col.setText("Connector:");
            p4Col.addSelectionListener(new SelectionAdapter () {
    			public void widgetSelected (SelectionEvent evt) {
    			    _propertySorter.setCol(3);
    				_propertySorter.cycleState();
    				_displayTable.refresh();
    			}
    		});
            ColumnLayoutData p4Data = new ColumnWeightData(30, true);
            layout.addColumnData(p4Data);
            TableColumn p5Col = new TableColumn(table, SWT.CENTER, 4);
            p5Col.setText("Tgt Role:");
            p5Col.addSelectionListener(new SelectionAdapter () {
    			public void widgetSelected (SelectionEvent evt) {
    			    _propertySorter.setCol(4);
    				_propertySorter.cycleState();
    				_displayTable.refresh();
    			}
    		});
            ColumnLayoutData p5Data = new ColumnWeightData(30, true);
            layout.addColumnData(p5Data);
            TableColumn p6Col = new TableColumn(table, SWT.CENTER, 5);
            p6Col.setText("Tgt Port:");
            p6Col.addSelectionListener(new SelectionAdapter () {
    			public void widgetSelected (SelectionEvent evt) {
    			    _propertySorter.setCol(5);
    				_propertySorter.cycleState();
    				_displayTable.refresh();
    			}
    		});
            ColumnLayoutData p6Data = new ColumnWeightData(30, true);
            layout.addColumnData(p6Data);
            TableColumn p7Col = new TableColumn(table, SWT.CENTER, 6);
            p7Col.setText("Tgt Component:");
            p7Col.addSelectionListener(new SelectionAdapter () {
    			public void widgetSelected (SelectionEvent evt) {
    			    _propertySorter.setCol(6);
    				_propertySorter.cycleState();
    				_displayTable.refresh();
    			}
    		});
            ColumnLayoutData p7Data = new ColumnWeightData(30, true);
            layout.addColumnData(p7Data);
            TableColumn p8Col = new TableColumn (table, SWT.CENTER, 7);
            ColumnLayoutData p8Data = new ColumnPixelData (150, true);
            layout.addColumnData(p8Data);
            table.setLayout(layout);
        }
        
        _displayTable.refresh();
        
        populateDDs();
        displayValidRules();
        
        return container;
    }
    
    /**
	 * 
	 */
	protected void resizeColumns(Widget w) {
		Table table = _displayTable.getTable();
		if (w == srcComp) {
			TableColumn  tc = table.getColumn (0);
			tc.setWidth (_LblSrcCompBegin.getBounds().width + srcComp.getBounds ().width + _lblSrcPort.getBounds ().width);
		}
		else if (w == srcItem) {
			TableColumn tc = table.getColumn (1);
			tc.setWidth (srcItem.getBounds ().width + _lblSrcCompEnd.getBounds ().width);
		}
		else if (w == firstRole) {
			TableColumn tc = table.getColumn (2);
			tc.setWidth (firstRole.getBounds ().width + _lblSrcRole.getBounds ().width);
		}
		else if (w == connector) {
			TableColumn tc = table.getColumn (3);
			tc.setWidth (connector.getBounds ().width);
		}
		else if (w == secondRole) {
			TableColumn tc = table.getColumn (4);
			tc.setWidth (secondRole.getBounds ().width + _lblTgtRole.getBounds ().width);
		}
		else if (w == tgtItem) {
			TableColumn tc = table.getColumn(5);
			tc.setWidth (tgtItem.getBounds ().width + _lblTgtComp.getBounds ().width);
		}
		else if (w == tgtComp) {
			TableColumn tc = table.getColumn (6);
			tc.setWidth (tgtComp.getBounds ().width + _lblTgtPort.getBounds ().width + _lblTgtCompEnd.getBounds ().width);
		}
	}

	private void populateDDs()
    {
        //first get the type info for all the boxes
        AcmeVector allPorts = _system.getAvailableTypes()
        	.castToAcmeSetVector().enumerate(new PortTypeEnumFilter())
        	.castToAcmeVector();
        
        AcmeVector allComps = _system.getAvailableTypes()
        	.castToAcmeSetVector().enumerate(new ComponentTypeEnumFilter())
        	.castToAcmeVector();
        
        AcmeVector allRoles = _system.getAvailableTypes()
        	.castToAcmeSetVector().enumerate(new RoleTypeEnumFilter())
        	.castToAcmeVector();
        
        AcmeVector allConns = _system.getAvailableTypes()
        	.castToAcmeSetVector().enumerate(new ConnectorTypeEnumFilter())
        	.castToAcmeVector();
        
        //get the strings out of the type objects
        List ports = ExtractTypeStrings(allPorts);
        List comps = ExtractTypeStrings(allComps);
        List roles = ExtractTypeStrings(allRoles);
        List conns = ExtractTypeStrings(allConns);

        Collections.sort(ports);
        Collections.sort(comps);
        Collections.sort(roles);
        Collections.sort(conns);
        
        //populate the boxes
        srcComp.add("All");
        srcItem.add("All");
        firstRole.add("All");
        connector.add("All");
        secondRole.add("All");
        tgtItem.add("All");
        tgtComp.add("All");
        
        for (Iterator iter = comps.iterator(); iter.hasNext();)
        {
            String type = (String) iter.next();
            srcComp.add(type);
            tgtComp.add(type);
        }
        
        for (Iterator iter = ports.iterator(); iter.hasNext();)
        {
            String type = (String) iter.next();
            srcItem.add(type);
            tgtItem.add(type);
        }
        
        for (Iterator iter = roles.iterator(); iter.hasNext();)
        {
            String type = (String) iter.next();
            firstRole.add(type);
            secondRole.add(type);
        }
        for (Iterator iter = conns.iterator(); iter.hasNext();)
        {
            String type = (String) iter.next();
            connector.add(type);
        }
        
        srcComp.select(0);
        srcItem.select(0);
        firstRole.select(0);
        connector.select(0);
        secondRole.select(0);
        tgtItem.select(0);
        tgtComp.select(0);
    }
    
    private void displayValidRules()
    {
        List allMatchingRules;
        
        //first, get all the selections
        String srcCompString = srcComp.getText().equals("All") ? "" : srcComp.getText();
        String srcPortString = srcItem.getText().equals("All") ? "" : srcItem.getText();
        String srcRoleString = firstRole.getText().equals("All") ? "" : firstRole.getText();
        String connString = connector.getText().equals("All") ? "" : connector.getText();
        String tgtRoleString = secondRole.getText().equals("All") ? "" : secondRole.getText();
        String tgtPortString = tgtItem.getText().equals("All") ? "" : tgtItem.getText();
        String tgtCompString = tgtComp.getText().equals("All") ? "" : tgtComp.getText();
        
        //get an instance of the appropriate systemvisualization
        SystemVisualization thisSysVis = VisualStyleRegistry.getSysVis(_system); 
        
        //get all portconnection rules, so we can see if any match the currently chosen rule
        List allRules = thisSysVis.getAllPortConnectionRules(null);
        
        //construct the chosenRule
        PortConnectionRule chosenRule = new PortConnectionRule();
        chosenRule.setConnectorType(connString);
        chosenRule.addAssociation(new PortRoleAssociation(srcPortString, srcRoleString, "", "", srcCompString));
        chosenRule.addAssociation(new PortRoleAssociation(tgtPortString, tgtRoleString, "", "", tgtCompString));
        
        allMatchingRules = SystemVisualization.getEqualsRulesInList(chosenRule.generateKey(), allRules);
        
        allMatchingRules = filterRoleTypes(allMatchingRules, srcRoleString, tgtRoleString);
        
/*        if (allMatchingRules.size() == 0)
            displayLabel.setText("There are no rules matching this configuration of types");
        else
        {
            //clear the label
            displayLabel.setText("");
            for (Iterator iter = allMatchingRules.iterator(); iter.hasNext();)
            {
                PortConnectionRule element = (PortConnectionRule) iter.next();
                displayLabel.setText(displayLabel.getText() + "\n" + element.toString());
            }
        }*/
        
        if (allMatchingRules.size() == 0)
        {
            allMatchingRules.add("There are no rules matching this configuration of types");
            _displayTable.setInput(allMatchingRules);
            _displayTable.refresh();
        }
        else
        {
            _displayTable.setInput(allMatchingRules);
            _displayTable.refresh();
        }
    }
    
    /**
     * This method goes through a list of rules and checks them
     * against the role type passed in, filtering as it goes
     * 
     * @author LFW
     * 
     * @param List the list of rules to filter on
     * @param AcmeRole the role to filter the list against
     */
    private List filterRoleTypes(List matchRule, String role1, String role2)
    {
        List ret = new ArrayList();
        // TODO Auto-generated method stub
        for (Iterator iter = matchRule.iterator(); iter.hasNext(); )
        {
            PortConnectionRule r = (PortConnectionRule)iter.next();
            if ((role1.equals("") || r.getAssociations()[0].getRoleType().equals(role1)) &&
                    (role2.equals("") || r.getAssociations()[1].getRoleType().equals(role2)))
                ret.add(r);
        }
        return ret;
    }
    
    /**
     * Grab the type strings out of an AcmeVector of AcmeType objects
     */
    private List ExtractTypeStrings(AcmeVector allItems)
    {
        List ret = new Vector();
        for (int i = 0; i < allItems.getSize(); i++)
        {
            if (allItems.getItemAt(i) instanceof AcmePortType)
                ret.add(((AcmePortType) allItems.getItemAt(i)).getTypeName());
            else if (allItems.getItemAt(i) instanceof AcmeComponentType)
                ret.add(((AcmeComponentType) allItems.getItemAt(i)).getTypeName());
            else if (allItems.getItemAt(i) instanceof AcmeRoleType)
                ret.add(((AcmeRoleType) allItems.getItemAt(i)).getTypeName());
            else if (allItems.getItemAt(i) instanceof AcmeConnectorType)
                ret.add(((AcmeConnectorType) allItems.getItemAt(i)).getTypeName());
        }
        return ret;
    }
    
    protected void createButtonsForButtonBar(Composite parent)
    {
        createButton(parent, IDialogConstants.OK_ID, IDialogConstants.OK_LABEL,
                true);
    }
    protected void configureShell(Shell newShell) {
        super.configureShell(newShell);
        newShell.setText("Choose Desired Pattern");
    }
    
    private class RuleContentProvider implements IStructuredContentProvider
    {

        /*
         * (non-Javadoc)
         * 
         * @see org.eclipse.jface.viewers.IContentProvider#dispose()
         */
        public void dispose()
        {
        }

        /*
         * (non-Javadoc)
         * 
         * @see org.eclipse.jface.viewers.IContentProvider#inputChanged(org.eclipse.jface.viewers.Viewer,
         *         java.lang.Object, java.lang.Object)
         */
        public void inputChanged(Viewer viewer, Object oldInput, Object newInput)
        {
        }

        /*
         * (non-Javadoc)
         * 
         * @see org.eclipse.jface.viewers.IStructuredContentProvider#getElements(java.lang.Object)
         */
        public Object[] getElements(Object inputElement)
        {
            if (inputElement instanceof List)
            {
                List items = (List) inputElement;
                Object[] children = new Object[items.size()];
                int index = 0;
                for (Iterator i = items.iterator(); i.hasNext();)
                {
                    PortConnectionRule rule = (PortConnectionRule) i.next();
                    children[index++] = rule;
                }
                return children;
            }
            return new Object[0];
        }
    }

    private class RuleLabelProvider extends LabelProvider implements
            ITableLabelProvider
    {

        /*
         * (non-Javadoc)
         * 
         * @see org.eclipse.jface.viewers.ITableLabelProvider#getColumnImage(java.lang.Object,
         *         int)
         */
        public Image getColumnImage(Object element, int columnIndex)
        {
            if (columnIndex == 7) {
            	PortConnectionRule rule = (PortConnectionRule )element;
            	Image image = ImageManager.getExistingImage(rule.toString());
        		if (image == null) {
        			image = Helper.generateConnectionRuleImage(rule, _system);
        			
        		}
        		return image;
            }
            return null;
        }

        /*
         * (non-Javadoc)
         * 
         * @see org.eclipse.jface.viewers.ITableLabelProvider#getColumnText(java.lang.Object,
         *         int)
         */
        public String getColumnText(Object element, int columnIndex)
        {
            if (element instanceof PortConnectionRule)
            {
                PortConnectionRule rule = (PortConnectionRule) element;
                switch (columnIndex)
                {
                    case 0:
                        return rule.getAssociations()[0].getComponentType();
                    case 1:
                        return rule.getAssociations()[0].getPortType();
                    case 2:
                        return rule.getAssociations()[0].getRoleType();
                    case 3:
                        return rule.getConnectorType();
                    case 4:
                        return rule.getAssociations()[1].getRoleType();
                    case 5:
                        return rule.getAssociations()[1].getPortType();
                    case 6:
                        return rule.getAssociations()[1].getComponentType();
                }
            }
            return "";
        }
    }
    
	private class PropertySorter extends ViewerSorter {
		
		public static final int SORT_A_Z = 0;
		public static final int SORT_Z_A = 1;
		
		private int state = SORT_A_Z;
		
		private int col = 0;
		/**
		 * @see org.eclipse.jface.viewers.ViewerSorter#compare(Viewer, Object,
		 *      Object)
		 */
		public int compare(Viewer viewer, Object e1, Object e2) {
			PortConnectionRule rule1 = (PortConnectionRule)e1;
			PortConnectionRule rule2 = (PortConnectionRule)e2;
			String name1 = "";
			String name2 = "";
			if (state == SORT_A_Z) {
			    switch (col)
                {
                    case 0:
                        name1 = rule1.getAssociations()[0].getComponentType();
        				name2 = rule2.getAssociations()[0].getComponentType();     
                        break;
                    case 1:
                        name1 = rule1.getAssociations()[0].getPortType();
        				name2 = rule2.getAssociations()[0].getPortType();
                        break;
                    case 2:
                        name1 = rule1.getAssociations()[0].getRoleType();
        				name2 = rule2.getAssociations()[0].getRoleType();
                        break;
                    case 3:
                        name1 = rule1.getConnectorType();
        				name2 = rule2.getConnectorType();
                        break;
                    case 4:
                        name1 = rule1.getAssociations()[1].getRoleType();
        				name2 = rule2.getAssociations()[1].getRoleType();
                        break;
                    case 5:
                        name1 = rule1.getAssociations()[1].getPortType();
        				name2 = rule2.getAssociations()[1].getPortType();
                        break;
                    case 6:
                        name1 = rule1.getAssociations()[1].getComponentType();
        				name2 = rule2.getAssociations()[1].getComponentType();
                        break;
                    default:
                        break;
                } 
			}
			else {
			    switch (col)
                {
                    case 0:
                        name2 = rule1.getAssociations()[0].getComponentType();
        				name1 = rule2.getAssociations()[0].getComponentType();     
                        break;
                    case 1:
                        name2 = rule1.getAssociations()[0].getPortType();
        				name1 = rule2.getAssociations()[0].getPortType();
                        break;
                    case 2:
                        name2 = rule1.getAssociations()[0].getRoleType();
        				name1 = rule2.getAssociations()[0].getRoleType();
                        break;
                    case 3:
                        name2 = rule1.getConnectorType();
        				name1 = rule2.getConnectorType();
                        break;
                    case 4:
                        name2 = rule1.getAssociations()[1].getRoleType();
        				name1 = rule2.getAssociations()[1].getRoleType();
                        break;
                    case 5:
                        name2 = rule1.getAssociations()[1].getPortType();
        				name1 = rule2.getAssociations()[1].getPortType();
                        break;
                    case 6:
                        name2 = rule1.getAssociations()[1].getComponentType();
        				name1 = rule2.getAssociations()[1].getComponentType();
                        break;
                    default:
                        break;
                } 
			}
			return name2.compareTo(name1);
		}
		
		public void cycleState () {
			state = (state + 1)  % 2;
		}
		
		public void setCol(int i)
		{
		    if (i != col)
		        state = SORT_A_Z;
		    col = i;
		}
	}
	
	/**
	 * Will be an indirection if values fail to parse or names already exist in
	 * the the current scope.
	 */
	private class AcmePropertyHolder implements ITipInformer {
		/** The name of the property if it is in error */
		private String erroneousName = null;
		/** The string value of the property if it doesn't parse or */
		private String erroneousValue = null;
		/**The property being held by the holder */
		private AcmeProperty property = null;

		/** The exception that caused the name to erroneous */
		public Exception nameException = null;
		/** The exception that caused the value to be erroneous */
		public Exception valueException = null;

		/**
		 * Returns the name of the property. If the name is erroneous, return
		 * that, otherwise return the property's name
		 * 
		 * @return the name of the property
		 */
		public String getName() {
			return erroneousName == null ? property.getName() : erroneousName;
		}
		/**
		 * Gets the tip information for the current property holder. The tip
		 * information shows the causes of errors in names, etc
		 * 
		 * @see AcmeStudio.util.ITipInformer#getTipInformation()
		 */
		public String getTipInformation() {
			String tip = "";
			if (ModelHelper.isInheritedProperty(property, null)) {
				tip = "Inherited from " + ((AcmeElement )ModelHelper.getInheritedProperty(property, null).getScope()).getQualifiedName ();
			}
			if (erroneousName != null) {
				tip += nameException.getMessage();
			}
			if (erroneousValue != null) {
				if (!tip.equals("")) {
					tip += "\n---------------------\n";
				}
				tip += valueException.getMessage();
			}
			return tip;
		}

		/**
		 * If the value or name are erroneous, then there is an error, so there
		 * is tip information
		 * 
		 * @return whether this AcmeProperyHolder has an error and therefore a
		 *         tip
		 * @see AcmeStudio.util.ITipInformer#hasTipInformation()
		 */
		public boolean hasTipInformation() {
			return (erroneousValue != null) || (erroneousName != null) || (ModelHelper.isInheritedProperty(property, null));
		}
		/* (non-Javadoc) @see AcmeStudio.util.ITipInformer#getTipImage() */
		public Image getTipImage() {
			return null;
		}

	}
}
