/*
 * Created on Mar 24, 2004
 *
 */
package AcmeStudio.ui.editors.diagram.styles.constants;

import java.util.ArrayList;
import java.util.List;

import AcmeStudio.util.ImageManager;


/**
 * Enumeration of shapes.
 */
public class Shape {
    public static final int DEFAULT = 0,
        RECTANGLE = 1,
        OVAL = 2,
        FILTER = 3,
        REPOSITORY = 4,
        PAGE = 5,
        ROUNDEDRECT = 6,
        TRIANGLE = 7,
        DIAMOND = 8,
        FOLDER = 9,
        NONE = 10;
    public static final String[] LABELS =
        new String[] {
            "Rectangle",
            "Oval",
            "Filter",
            "Repository",
            "Page",
            "Rounded Rectangle",
            "Triangle",
            "Diamond",
            "Folder",
            "[No Shape]" };
    public static final List SHAPENAMES = new ArrayList();
    public static final List SHAPEIMAGES = new ArrayList ();
    static {
        SHAPENAMES.add(DEFAULT, "Default");
        SHAPENAMES.add(RECTANGLE, "Rectangle");
        SHAPENAMES.add(OVAL, "Oval");
        SHAPENAMES.add(FILTER, "Filter");
        SHAPENAMES.add(REPOSITORY, "Repository");
        SHAPENAMES.add(PAGE, "Page");
        SHAPENAMES.add(ROUNDEDRECT, "Rounded Rectangle");
        SHAPENAMES.add(TRIANGLE, "Triangle");
        SHAPENAMES.add(DIAMOND, "Diamond");
        SHAPENAMES.add(FOLDER, "Folder");
        SHAPENAMES.add(NONE, "[No shape]");
        
        ImageManager.loadIcons();
        SHAPEIMAGES.add (DEFAULT, null);
        SHAPEIMAGES.add (RECTANGLE, ImageManager.getIcon(ImageManager.ID_SHAPE_RECTANGLE));
        SHAPEIMAGES.add (OVAL, ImageManager.getIcon (ImageManager.ID_SHAPE_OVAL));
        SHAPEIMAGES.add (FILTER, ImageManager.getIcon (ImageManager.ID_SHAPE_FILTER));
        SHAPEIMAGES.add (REPOSITORY, ImageManager.getIcon (ImageManager.ID_SHAPE_REPOSITORY));
        SHAPEIMAGES.add (PAGE, ImageManager.getIcon (ImageManager.ID_SHAPE_PAGE));
        SHAPEIMAGES.add (ROUNDEDRECT, ImageManager.getIcon (ImageManager.ID_SHAPE_ROUNDRECTANGLE));
        SHAPEIMAGES.add(TRIANGLE, ImageManager.getIcon (ImageManager.ID_SHAPE_TRIANGLE));
        SHAPEIMAGES.add(DIAMOND, ImageManager.getIcon (ImageManager.ID_SHAPE_DIAMOND));
        SHAPEIMAGES.add(FOLDER, ImageManager.getIcon (ImageManager.ID_SHAPE_FOLDER));
        SHAPEIMAGES.add (NONE, null);
    }
}