package AcmeStudio.ui.editors.diagram.templates;

import acmeLib.elements.*;

/**
 * @author schmerl
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class SystemTemplateFactory implements org.eclipse.gef.requests.CreationFactory {
    
    private Object _template;
    private AcmeElement _element;
    
    public SystemTemplateFactory (Class clazz) {
        _template = clazz;
    }
    
    public SystemTemplateFactory (AcmeElementType type) {
        _template = type;
    }
    /**
     * @see org.eclipse.gef.requests.CreateRequest.Factory#getNewObject()
     */
    public Object getNewObject() {
//    	if (_element != null) return _element;
        if (_template instanceof AcmeElementType) {         
            AcmeElementType newType = (AcmeElementType )_template;
   			// BugFix 184: Base name on type
   			String name = newType.getTypeName() + "0";
            if (newType instanceof AcmeComponentType) {
                _element = new AcmeComponent (name,(AcmeComponentType )newType);
   
            }
            else if (newType instanceof AcmeConnectorType) {
                _element = new AcmeConnector (name, (AcmeConnectorType )newType);
            }
            else if (newType instanceof AcmePortType) {
                _element = new AcmePort (name, (AcmePortType )newType);
            }
            else if (newType instanceof AcmeRoleType) {
                _element = new AcmeRole (name, (AcmeRoleType )newType);
            }
              
            _element.addInstantiatedType(newType);          
            _element.instantiateElements ();            
        }
        else {
    
            Class objType = (Class )_template;
            String className = objType.getName();
 
            if (className.endsWith("AcmeComponent")) {
                _element = new AcmeComponent("comp0");
            }
            else if (className.endsWith("AcmeConnector")) {
                _element = new AcmeConnector("conn0");
       
            }
            else if (className.endsWith("AcmePort")) {
                _element = new AcmePort("p0");
        
            }
            else if (className.endsWith("AcmeRole")) {
                _element = new AcmeRole("r0");
        
            }
            else {
            	try {
            		return objType.newInstance ();
				}
				catch (InstantiationException e) {
					e.printStackTrace();
				}
				catch (IllegalAccessException e) {
					e.printStackTrace();
				}
            }
        }
        return _element;
    }

    /**
     * @see org.eclipse.gef.requests.CreateRequest.Factory#getObjectType()
     */
    public Object getObjectType() {
        return _template;
    }

}
