/*
 * Created on Aug 2, 2004
 * 
 */
package AcmeStudio.ui.editors.diagram.visualInfo;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

import AcmeStudio.wizards.connection.PortConnectionRule;
import acmeLib.core.extensions.IElementExtension;
import acmeLib.elements.AcmeElement;

/**
 * @author Bradley Schmerl
 *
 */
public class ConnectionPatternInformation implements IElementExtension {

	public List _connectionPatterns = new ArrayList ();
	public static final String CONNECTION_PATTERNS_KEY = "connection-patterns";
	
	
	/**
	 * @return
	 * @see acmeLib.core.extensions.IElementExtension#isPersistent()
	 */
	public boolean isPersistent() {
		return false;
	}

	/**
	 * @param element
	 * @see acmeLib.core.extensions.IElementExtension#injectIntoElement(acmeLib.elements.AcmeElement)
	 */
	public void injectIntoElement(AcmeElement element) {
	}

	/**
	 * @param element
	 * @see acmeLib.core.extensions.IElementExtension#extractFromElement(acmeLib.elements.AcmeElement)
	 */
	public void extractFromElement(AcmeElement element) {
	}

	/**
	 * @param element
	 * @return
	 * @see acmeLib.core.extensions.IElementExtension#isInjected(acmeLib.elements.AcmeElement)
	 */
	public boolean isInjected(AcmeElement element) {
		return false;
	}

	/**
	 * @return Returns the connectionPatterns.
	 */
	public List getConnectionPatterns() {
		return _connectionPatterns;
	}
	
	public void addConnectionPattern (PortConnectionRule rule) {
		_connectionPatterns.add (rule);
	}

	/**
	 * @param doc
	 * @return
	 */
	public Element exportAsXMLElement(Document doc) {
		if (!_connectionPatterns.isEmpty()) {
			Element portConnRulesElt = doc.createElement("portConnectionRules");
			for (Iterator iter = _connectionPatterns.iterator(); iter.hasNext();) {
				PortConnectionRule rule = (PortConnectionRule) iter.next();
				Element e = rule.exportAsXMLElement(doc);
				portConnRulesElt.appendChild(e);
			}
			return portConnRulesElt;
		}
		return null;
	}

	

	/**
	 * @param elem
	 * @return
	 */
	public static ConnectionPatternInformation importFromXMLElement(Element elem) {
		ConnectionPatternInformation info = new ConnectionPatternInformation ();
		NodeList children = elem.getChildNodes();
		for (int i = 0; i < children.getLength (); i++) {
			Element ruleElem = (Element) children.item(i);
			PortConnectionRule rule = PortConnectionRule.importFromXMLElement(ruleElem);
			info.addConnectionPattern(rule);
		}
		return info;
	}
}
