/*
 * Created on Mar 31, 2004
 *
 */
package AcmeStudio.ui.editors.diagram.visualInfo;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import acmeLib.elements.AcmeElement;
import acmeLib.properties.AcmeProperty;

/**
 * @author Bradley Schmerl
 * Created Mar 31, 2004
 */
public class PortVisualInformation extends VisualInformation {
	
	int _order = -1;
	
	/**
	 * 
	 */
	public PortVisualInformation(VisualInformation vis) {
		super();
		if (vis != null) {
			this.setHeight(vis.getHeight ());
			this.setWidth (vis.getWidth ());
			this.setX (vis.getX ());
			this.setY (vis.getY ());
		}
	}
	/**
	 * @return Returns the order.
	 */
	public int getOrder() {
		return _order;
	}
	/**
	 * @param order The order to set.
	 */
	public void setOrder(int order) {
		_order = order;
	}
	/* (non-Javadoc)
	 * @see acmeLib.core.extensions.IElementExtension#extractFromElement(acmeLib.elements.AcmeElement)
	 */
	public void extractFromElement(AcmeElement element) {
		super.extractFromElement(element);
		AcmeProperty visO = element.getProperty ("vis-order");
		if (visO != null) {
			setOrder (getVisualValue(visO));
			element.removeProperty (visO);
		}
	}
	/* (non-Javadoc)
	 * @see AcmeStudio.util.VisualInformation#exportAsXMLElement(org.w3c.dom.Document)
	 */
	public Element exportAsXMLElement(Document doc) {
		Element elem = super.exportAsXMLElement(doc);
		if (_order != -1) {
			elem.setAttribute ("order", Integer.toString (_order));
			elem.setAttribute ("type", "PORT");
		}
		return elem;
	}
	/* (non-Javadoc)
	 * @see AcmeStudio.util.VisualInformation#importFromXML(org.w3c.dom.Element)
	 */
	public void importFromXML(Element element) {
		super.importFromXML(element);
		String order = element.getAttribute("order");
		if (order != null) setOrder (Integer.parseInt (order));
	}
}
