/*
 * Created on Apr 1, 2004
 *
 */
package AcmeStudio.ui.editors.diagram.visualInfo;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import acmeLib.elements.AcmeElement;
import acmeLib.elements.AcmeSystem;
import acmeLib.tools.WalkerElementOperation;

/**
 * @author Bradley Schmerl
 * Created Apr 1, 2004
 */
public class VisualizationSaveWalkerOp implements WalkerElementOperation {

	private Element _domElement;
	private Document _doc;

	/**
	 * @param elem
	 */
	public VisualizationSaveWalkerOp(Element elem, Document doc) {
		 _domElement = elem;
		 _doc = doc;
	}

	/* (non-Javadoc)
	 * @see acmeLib.tools.WalkerElementOperation#doElementOp(acmeLib.elements.AcmeElement)
	 */
	public void doElementOp(AcmeElement elt) {
		if (elt instanceof AcmeSystem) {
			ConnectionPatternInformation connectionInfo = (ConnectionPatternInformation) elt.getUserData (ConnectionPatternInformation.CONNECTION_PATTERNS_KEY);
			if (connectionInfo != null) {
				Element connectionElem = connectionInfo.exportAsXMLElement (_doc);
				if (connectionElem != null) {
					connectionElem.setAttribute("element", elt.getQualifiedName());
					_domElement.appendChild (connectionElem);
				}
			}
		}
		VisualInformation visInfo = (VisualInformation) elt.getUserData("vis-information");
		if (visInfo != null) {
			Element visElem= visInfo.exportAsXMLElement (_doc);
			visElem.setAttribute("element", elt.getQualifiedName ());
			_domElement.appendChild(visElem);
		}
	}
}
