package AcmeStudio.ui.editors.style.parts;

import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.*;

public class DecorationPrefDialog extends MessageDialog {

    private int _selection = 1;
    private String _text = null;
    private Button radio1;
    private Button radio2;
    private Text input1;
    
    final public static int IMAGE = 1; 
    final public static int TEXT = 2;
    
    public DecorationPrefDialog(Shell parentShell) {
        super(parentShell, getTitle(), null,
        // accept the default window icon
        getMessage(),
            MessageDialog.QUESTION,
            new String[] {
                IDialogConstants.OK_LABEL,
                IDialogConstants.CANCEL_LABEL },
            0);
    }

    private static String getTitle() {
        return "Confirm";
    }

    private static String getMessage() {
        return "Select from the following decoration options:";
    }

    protected Control createCustomArea(Composite parent) {
        Composite composite = new Composite(parent, SWT.NONE);
        GridLayout gl = new GridLayout();
        gl.marginWidth = 60;
        composite.setLayout(gl);

        gl = new GridLayout(1, false);
        Composite imageGroup = new Composite(composite, SWT.NONE);
        imageGroup.setLayout(gl);
        radio1 = new Button(imageGroup, SWT.RADIO);
        radio1.addSelectionListener(selectionListener);
        String text1 = "Image";
        radio1.setText(text1);

        gl = new GridLayout(2, false);
        Composite textGroup = new Composite(composite, SWT.NONE);
        textGroup.setLayout(gl);
        radio2 = new Button(textGroup, SWT.RADIO);
        radio2.addSelectionListener(selectionListener);
        String text2 = "Text";
        radio2.setText(text2);

        input1 = new Text(textGroup, SWT.BORDER);
        input1.setEnabled(false);
        
        // set initial state
        updateSelection();

        return composite;
    }
    
    private void updateSelection() {
        radio1.setSelection(_selection == 1);
        radio2.setSelection(_selection == 2);
    }

    private SelectionListener selectionListener = new SelectionAdapter() {
        public void widgetSelected(SelectionEvent e) {
            Button button = (Button) e.widget;
            if (button.getSelection()) {
                _selection = (button == radio1) ? 1 : 2;
                if (_selection == TEXT) {
                    input1.setEnabled(true);
                } else {
                    input1.setEnabled(false);
                }
            }
            updateSelection();
        }
    };

    public int getSelection() {
        return _selection;
    }
    
    public String getText() {
        return _text;
    }

    /* (non-Javadoc)
     * @see org.eclipse.jface.dialogs.Dialog#buttonPressed(int)
     */
    protected void buttonPressed(int buttonId) {
        _text = input1.getText();
        super.buttonPressed(buttonId);
    }

}
