/*
 * Created on Jun 4, 2004
 *
 */
package AcmeStudio.ui.editors.style.parts;

import java.util.Vector;

import org.eclipse.jface.action.IMenuListener;
import org.eclipse.jface.action.IMenuManager;
import org.eclipse.jface.action.MenuManager;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.MouseListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.ui.forms.SectionPart;
import org.eclipse.ui.forms.widgets.FormToolkit;
import org.eclipse.ui.forms.widgets.Section;

import AcmeStudio.ui.editors.AcmeStyleEditor;
import AcmeStudio.util.Helper;
import acmeLib.elements.AcmeFamily;


/**
 * @author Bradley Schmerl
 * Created Jun 4, 2004
 */
public class PropertyTypeListSection extends SectionPart implements MouseListener {

	private TypesPage	_page;
	private AcmeStyleEditor	_styleEditor;
	private static final int	CLIENT_VSPACING	= 4;
	private PropertyStyleList	_styleList;

	/**
	 * @param page
	 * @param body
	 */
	public PropertyTypeListSection(TypesPage page, Composite parent) {
		super (parent, page.getManagedForm().getToolkit(), Section.TITLE_BAR | Section.TWISTIE | Section.EXPANDED);
		_page = page;
		_styleEditor = (AcmeStyleEditor )page.getStyleEditor ();
		getSection ().clientVerticalSpacing = CLIENT_VSPACING;
		getSection ().setData ("part", this);
		createClient (getSection (), page.getEditor ().getToolkit ());
	}

	/**
	 * @param section
	 * @param toolkit
	 */
	private void createClient(Section section, FormToolkit toolkit) {
		AcmeFamily family = _styleEditor.getFamily ();
		Vector acmeTypes = Helper.getTypes (family);
		
		Composite client = toolkit.createComposite (section);
		  GridLayout layout = new GridLayout();
	        layout.numColumns = 1;
	        layout.marginWidth = 8;
	        layout.verticalSpacing = 7;
	        layout.horizontalSpacing = 6;
	        client.setLayout(layout);
	        section.setClient(client);
	        
	        MenuManager popupMenuManager = new MenuManager();
	        IMenuListener listener = new IMenuListener() {
	            public void menuAboutToShow(IMenuManager mng) {
	                fillContextMenu(mng);
	            }
	        };
	        popupMenuManager.addMenuListener(listener);
	        popupMenuManager.setRemoveAllWhenShown(true);
	        Menu menu = popupMenuManager.createContextMenu(client);
	        client.setMenu(menu);
	        GridData gd = new GridData(GridData.FILL_HORIZONTAL);
	        _styleList = new PropertyStyleList (client, SWT.NONE,  _styleEditor);
	        _styleList.setLayoutData (gd);
	        _styleList.setInput (family);
	        _styleList.setMenu (menu);
	        toolkit.paintBordersFor(client);
	}

	/**
	 * @param mng
	 */
	protected void fillContextMenu(IMenuManager mng) {
	}

	/* (non-Javadoc)
	 * @see org.eclipse.swt.events.MouseListener#mouseDoubleClick(org.eclipse.swt.events.MouseEvent)
	 */
	public void mouseDoubleClick(MouseEvent e) {
	}

	/* (non-Javadoc)
	 * @see org.eclipse.swt.events.MouseListener#mouseDown(org.eclipse.swt.events.MouseEvent)
	 */
	public void mouseDown(MouseEvent e) {
	}

	/* (non-Javadoc)
	 * @see org.eclipse.swt.events.MouseListener#mouseUp(org.eclipse.swt.events.MouseEvent)
	 */
	public void mouseUp(MouseEvent e) {
	}

	public void refresh () {
		_styleList.refresh();
	}
}
