package AcmeStudio.ui.editors.style.parts;

import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Shell;

public class StyleEditPrefDialog extends MessageDialog {

    private int _selection = 1;
    private Button radio1;
    private Button radio2;

    public StyleEditPrefDialog(Shell parentShell) {
        super(parentShell, getTitle(), null,
        // accept the default window icon
        getMessage(),
            MessageDialog.QUESTION,
            new String[] {
                IDialogConstants.OK_LABEL,
                IDialogConstants.CANCEL_LABEL },
            0);
    }

    private static String getTitle() {
        return "Confirm";
    }

    private static String getMessage() {
        return "The family does not have an associated visual style or inherits it.\nSelect from the following options:";
    }

    protected Control createCustomArea(Composite parent) {
        Composite composite = new Composite(parent, SWT.NONE);
        GridLayout gl = new GridLayout();
        gl.marginWidth = 60;
        composite.setLayout(gl);
        radio1 = new Button(composite, SWT.RADIO);
        radio1.addSelectionListener(selectionListener);
        String text1 = "Create new visual style";
        radio1.setText(text1);

        radio2 = new Button(composite, SWT.RADIO);
        radio2.addSelectionListener(selectionListener);
        String text2 = "Edit current visual style";
        radio2.setText(text2);

        // set initial state
        radio1.setSelection(_selection == 1);
        radio2.setSelection(_selection == 2);

        return composite;
    }

    private SelectionListener selectionListener = new SelectionAdapter() {
        public void widgetSelected(SelectionEvent e) {
            Button button = (Button) e.widget;
            if (button.getSelection()) {
                _selection = (button == radio1) ? 1 : 2;
            }
        }
    };

    public int getSelection() {
        return _selection;
    }
}
