/*
 * Created on Jun 3, 2004
 *
 */
package AcmeStudio.ui.editors.style.parts;

import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.forms.IManagedForm;
import org.eclipse.ui.forms.editor.FormEditor;
import org.eclipse.ui.forms.editor.FormPage;
import org.eclipse.ui.forms.widgets.FormToolkit;
import org.eclipse.ui.forms.widgets.ScrolledForm;
import org.eclipse.ui.forms.widgets.TableWrapData;
import org.eclipse.ui.forms.widgets.TableWrapLayout;

import acmeLib.elements.AcmeComponent;
import acmeLib.elements.AcmeConnector;
import acmeLib.elements.AcmePort;
import acmeLib.elements.AcmeRole;


/**
 * @author Bradley Schmerl
 * Created Jun 3, 2004
 */
public class TypesPage extends FormPage {

	private FormEditor	_styleEditor;
	private FamilySection	_familySection;
	private ElementTypeListSection	_componentsSection;
	private ElementTypeListSection	_connectorsSection;
	private ElementTypeListSection	_portsSection;
	private ElementTypeListSection	_rolesSection;
	private PropertyTypeListSection	_propertiesSection;

	/**
	 * @param editor
	 * @param mpe
	 * @param id
	 * @param title
	 */
	public TypesPage(FormEditor editor) {
		super (editor, "types", "Acme Types");
		_styleEditor = editor;
	}

	/**
	 * @param id
	 * @param title
	 */
	public TypesPage(String id, String title) {
		super (id, title);
	}

	/* (non-Javadoc)
	 * @see org.eclipse.ui.forms.editor.FormPage#createFormContent(org.eclipse.ui.forms.IManagedForm)
	 */
	protected void createFormContent(IManagedForm managedForm) {
		super.createFormContent (managedForm);
		ScrolledForm form = managedForm.getForm ();
		FormToolkit toolkit = managedForm.getToolkit();
		form.setText ("Acme Types");
		Composite body = managedForm.getForm ().getBody ();
		TableWrapLayout layout = new TableWrapLayout ();
		layout.bottomMargin = 10;
		layout.topMargin = 5;
		layout.leftMargin = 10;
		layout.rightMargin = 10;
		layout.numColumns = 1;
		layout.verticalSpacing = 20;
		layout.horizontalSpacing = 10;
		body.setLayout(layout);
		
		_familySection = new FamilySection (this, body);
		managedForm.addPart (_familySection);
		TableWrapData fwd = new TableWrapData (TableWrapData.FILL_GRAB);
		_familySection.getSection ().setLayoutData (fwd);
		
		_componentsSection = new ElementTypeListSection (this, body, AcmeComponent.class);
		_componentsSection.getSection ().setText("Component Types");
		managedForm.addPart (_componentsSection);
		TableWrapData compwd = new TableWrapData (TableWrapData.FILL_GRAB);
		_componentsSection.getSection ().setLayoutData (compwd);
		
		_connectorsSection = new ElementTypeListSection (this, body, AcmeConnector.class);
		_connectorsSection.getSection().setText ("Connector Types");
		managedForm.addPart (_connectorsSection);
		TableWrapData connwd = new TableWrapData (TableWrapData.FILL_GRAB);
		_connectorsSection.getSection ().setLayoutData (connwd);
		
		_portsSection = new ElementTypeListSection (this, body, AcmePort.class);
		_portsSection.getSection ().setText ("Port Types");
		managedForm.addPart (_portsSection);
		TableWrapData portwd = new TableWrapData (TableWrapData.FILL_GRAB);
		_portsSection.getSection ().setLayoutData (portwd);
		
		_rolesSection = new ElementTypeListSection (this, body, AcmeRole.class);
		_rolesSection.getSection ().setText("Role Types");
		managedForm.addPart (_rolesSection);
		TableWrapData rolewd = new TableWrapData (TableWrapData.FILL_GRAB);
		_rolesSection.getSection ().setLayoutData (rolewd);
		
		_propertiesSection = new PropertyTypeListSection (this, body);
		_propertiesSection.getSection ().setText ("Property Types");
		managedForm.addPart (_propertiesSection);
		TableWrapData propwd = new TableWrapData (TableWrapData.FILL_GRAB);
		_propertiesSection.getSection ().setLayoutData (propwd);
		
	}
	/**
	 * @return Returns the styleEditor.
	 */
	public FormEditor getStyleEditor() {
		return _styleEditor;
	}

	/**
	 * @param iss
	 */
	public void setSelection(IStructuredSelection iss) {
	}
	/**
	 * @return Returns the componentsSection.
	 */
	public ElementTypeListSection getComponentsSection() {
		return _componentsSection;
	}
	/**
	 * @return Returns the connectorsSection.
	 */
	public ElementTypeListSection getConnectorsSection() {
		return _connectorsSection;
	}
	/**
	 * @return Returns the familySection.
	 */
	public FamilySection getFamilySection() {
		return _familySection;
	}
	/**
	 * @return Returns the portsSection.
	 */
	public ElementTypeListSection getPortsSection() {
		return _portsSection;
	}
	/**
	 * @return Returns the propertiesSection.
	 */
	public PropertyTypeListSection getPropertiesSection() {
		return _propertiesSection;
	}
	/**
	 * @return Returns the rolesSection.
	 */
	public ElementTypeListSection getRolesSection() {
		return _rolesSection;
	}
}
