package AcmeStudio.ui.editors.text;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.RGB;
import com.swtdesigner.SWTResourceManager;

/**
 * @author schmerl
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class AcmeColorProvider {
    
    public static final RGB MULTI_LINE_COMMENT = new RGB (128, 0, 0);
    public static final RGB SINGLE_LINE_COMMENT = MULTI_LINE_COMMENT;
    public static final RGB KEYWORD = new RGB (0, 0, 128);
    public static final RGB TYPE = new RGB (0, 0, 128);
    public static final RGB STRING = new RGB (0, 128, 0);
    public static final RGB DEFAULT = new RGB (0, 0, 0);
    public static final RGB BACKGROUND = new RGB (255, 255, 255);
    
    protected Map _colorTable = new HashMap (10);
    
    public void dispose () {
        Iterator e = _colorTable.values ().iterator ();
        while (e.hasNext ()) {
            ((Color )e.next ()).dispose ();
        }
    }
    
    public Color getColor (RGB rgb) {
        Color color = (Color )_colorTable.get (rgb);
        if (color == null) {
            color = SWTResourceManager.getColor (rgb);
            _colorTable.put (rgb, color);
        }
        return color;
    }
    
    
}
