package AcmeStudio.ui.editors.text;

import org.eclipse.jface.action.IMenuManager;
import org.eclipse.jface.action.IToolBarManager;
import org.eclipse.jface.action.SubToolBarManager;
import org.eclipse.ui.IActionBars;
import org.eclipse.ui.IEditorPart;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.texteditor.BasicTextEditorActionContributor;

import AcmeStudio.core.actions.AcmeStudioRetargetAction;
import AcmeStudio.ui.editors.AcmeTextEditor;
import AcmeStudio.ui.editors.text.filters.FilterOutVisAction;
import AcmeStudio.util.ImageManager;

/**
 * @author schmerl
 *
 */
public class TextActionBarContributor extends BasicTextEditorActionContributor {


    AcmeStudioRetargetAction _filterOutVisPropsAction;

    /**
     * Constructor for DiagramActionBarContributor.
     */
    public TextActionBarContributor() {
        super();
        _filterOutVisPropsAction = new AcmeStudioRetargetAction (FilterOutVisAction.ID, "Filter out visual properties", true);
        
    }


    /* (non-Javadoc)
     * @see org.eclipse.ui.part.EditorActionBarContributor#contributeToMenu(org.eclipse.jface.action.IMenuManager)
     */
    public void contributeToMenu(IMenuManager menu) {
       super.contributeToMenu(menu);
    }

    /* (non-Javadoc)
     * @see org.eclipse.ui.part.EditorActionBarContributor#contributeToToolBar(org.eclipse.jface.action.IToolBarManager)
     */
    public void contributeToToolBar(IToolBarManager tbm) {
        if (!(tbm instanceof SubToolBarManager)) return;
        super.contributeToToolBar(tbm);

        _filterOutVisPropsAction.setImageDescriptor (ImageManager.getImageDescriptor (ImageManager.ID_NO_VIS));
        _filterOutVisPropsAction.setToolTipText("Filters out visual info");
        tbm.add (_filterOutVisPropsAction);
        
    }

    /* (non-Javadoc)
     * @see org.eclipse.ui.IEditorActionBarContributor#init(org.eclipse.ui.IActionBars, org.eclipse.ui.IWorkbenchPage)
     */
    public void init(IActionBars bars, IWorkbenchPage page) {
        super.init(bars, page);
    }

	/* (non-Javadoc)
	 * @see org.eclipse.ui.IEditorActionBarContributor#setActiveEditor(org.eclipse.ui.IEditorPart)
	 */
	public void setActiveEditor(IEditorPart part) {
		super.setActiveEditor(part);
		if (part instanceof AcmeTextEditor) {
			_filterOutVisPropsAction.setAction(((AcmeTextEditor )part).getAction(FilterOutVisAction.ID));
		}
		else {
			_filterOutVisPropsAction.setAction (null);
		}
	}

}
