/*
 * Created on May 16, 2003
 *
 */
package AcmeStudio.ui.editors.text.actions;

import java.util.ResourceBundle;

import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.ui.texteditor.ITextEditor;
import org.eclipse.ui.texteditor.TextEditorAction;

import AcmeStudio.ui.editors.AcmeTextEditor;
import acmeLib.AcmeObject;

/**
 * @author Bradley Schmerl
 * This is the root class of actions to do with Acme selections in the text editor
 */
public abstract class AcmeTextEditorAction extends TextEditorAction {

    /** The selected object **/
    protected AcmeObject _selection;

    /**
     * @param bundle
     * @param prefix
     * @param editor
     */
    public AcmeTextEditorAction(ResourceBundle bundle, String prefix, ITextEditor editor) {
        super(bundle, prefix, editor);
        update ();
    }
    
    

    /* (non-Javadoc)
     * @see org.eclipse.ui.texteditor.IUpdate#update()
     */
    public void update() {
        super.update();
        
        AcmeTextEditor editor = (AcmeTextEditor )this.getTextEditor();
        ISelection sel = editor.getSelection();
        if (sel instanceof IStructuredSelection) {
            _selection = (AcmeObject )((IStructuredSelection )sel).getFirstElement();   
        }
    }

}
