/*
 * Created on May 16, 2003
 *
 */
package AcmeStudio.ui.editors.text.actions;

import java.util.ResourceBundle;

import org.eclipse.ui.texteditor.ITextEditor;

import AcmeStudio.core.actions.OpenTypeHierarchyAction;
import acmeLib.elements.AcmeElement;

/**
 * @author Bradley Schmerl
 * This Action opens a type (or element) selected in the text editor region
 * in the type browser.
 */
public class TextEditorTypeHierarchyAction extends AcmeTextEditorAction {

    private OpenTypeHierarchyAction action;

    /**
     * @param bundle The bundle to get images
     * @param prefix
     * @param editor The editor this action is associated with
     */
    public TextEditorTypeHierarchyAction(ResourceBundle bundle, String prefix, ITextEditor editor) {
        super(bundle, prefix, editor);
        action = new OpenTypeHierarchyAction();
        setText(action.getText());
        setId(action.getId());
        setToolTipText(action.getToolTipText());
    }

    /**
     * Set the element of type browser action to the selected object in
     * the editor.
     */
    public void run() {
        if (_selection instanceof AcmeElement) {
            action.setElement((AcmeElement) _selection);
            action.run();
            action.setElement(null);
        }
    }

    /**
     * Only enable if the selection is an AcmeElement
     */
    public boolean isEnabled() {
        return (_selection instanceof AcmeElement) && super.isEnabled();
    }

}
