/*
 * Created on Apr 16, 2003
 *
 * To change the template for this generated file go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package AcmeStudio.ui.editors.text.filters;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.jface.action.Action;

import AcmeStudio.core.resource.provider.ASResourceProvider;
import AcmeStudio.core.resource.provider.IResourceProviderListener;
import AcmeStudio.core.resource.provider.ResourceProviderEvent;
import AcmeStudio.ui.editors.AcmeTextEditor;
import AcmeStudio.util.Debug;
import AcmeStudio.util.ImageManager;
import acmeLib.tools.WalkerElementOperation;

/**
 * @author schmerl
 *
 */
public class FilterOutVisAction extends Action implements IResourceProviderListener {
	private boolean _wasEditable = false;

	public static final String ID = "$FOUTVIS$";
	
	AcmeTextEditor _editor = null;
	
	public FilterOutVisAction (AcmeTextEditor ed) {
		_editor = ed;
		if (_editor != null) {
			ASResourceProvider provider = (ASResourceProvider )_editor.getDocumentProvider();
			provider.addResourceProviderListener(this);
			setEnabled (provider.isSynchedWithText());
		}
		setId (ID);
		setImageDescriptor (ImageManager.getImageDescriptor(ImageManager.ID_NO_VIS));
			
	}

    /* (non-Javadoc)
     * @see java.lang.Object#finalize()
     */
    protected void finalize() throws Throwable {
        if (_editor != null) {
            ASResourceProvider provider = (ASResourceProvider )_editor.getDocumentProvider();
            if (provider != null) {
                provider.removeResourceProviderListener(this);
            }
            _editor = null;
        }
        super.finalize();
    }

	/* (non-Javadoc)
	 * @see org.eclipse.jface.action.IAction#run()
	 */
	public void run() {
		if (_editor != null) {
			try {
				if (!isChecked ()) {
					// Already filtered out
					((ASResourceProvider )_editor.getDocumentProvider()).restoreDesign();
					_editor.setEditable (_wasEditable);
				}
				else {
					ASResourceProvider provider = (ASResourceProvider )_editor.getDocumentProvider();
					provider.filterDesign(new WalkerElementOperation [] {new VisualizationWalker ()});
					_wasEditable = _editor.isEditable ();
					_editor.setEditable (false);
				}
			} catch (CoreException e) {
				Debug.errorln(e);
			}
				
		}
	}

	/* (non-Javadoc)
	 * @see AcmeStudio.core.resource.provider.IResourceProviderListener#providerChanged(AcmeStudio.core.resource.provider.ResourceProviderEvent)
	 */
	public void providerChanged(ResourceProviderEvent event) {
		setEnabled (event.getProvider().isSynchedWithText());
	}

}
