/*
 * Created on Mar 31, 2003
 *
 * To change this generated comment go to 
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
package AcmeStudio.ui.views;

import org.eclipse.ui.part.IPageSite;
import org.eclipse.ui.views.contentoutline.IContentOutlinePage;

/**
 * @author Shang-Wen Cheng (zensoul@cs.cmu.edu)
 *
 * Marker-style interface for an element view page.  This interface defines
 * the minimum requirement for pages within the element view, namely they
 * must be pages (implement <code>IPage</code>) and provide selections
 * (implement <code>ISelectionProvider</code>).
 * <p>
 * Access to a element view page begins when an editor is activated. When
 * activation occurs, the element view will ask the editor for its element
 * view page. This is done by invoking 
 * <code>getAdapter(IElementViewPage.class)</code> on the editor.  
 * If the editor returns a page, the view then creates the controls for that
 * page (using <code>createControl</code>) and makes the page visible.
 * </p>
 * <p>
 * Clients may implement this interface from scratch, or subclass the
 * abstract base class <code>ElementViewPage</code>.
 * </p>
 * <p> 
 * Note that this interface extends <code>ISelectionProvider</code>.
 * This is no longer required in the case of implementors who also 
 * implement <code>IPageBookViewPage</code> (or extend <code>Page</code>)
 * as they are now passed an <code>IPageSite</code> during their initialization
 * and this site can be configured with a selection provider. 
 * However to avoid a breaking change 
 *  1) this interface will continue to extend ISelectionProvider 
 *  2) if an IElementViewPage does not set a selection provider for its 
 * site, the ElementView will continue to use the page itself for this purpose.
 * </p> 
 *
 * @see ElementViewPage
 */
public interface IElementViewPage extends IContentOutlinePage {
    public IPageSite getSite();
}
