/*
 * Created on Oct 22, 2003
 * 
 */
package AcmeStudio.ui.views.groups.wizards;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;

import AcmeStudio.ui.views.AcmeGroupView;
import acmeLib.core.globals.ConstantTypes;
import acmeLib.elements.AcmeGroup;
import acmeLib.properties.AcmeBoolean;

/**
 * @author Bradley Schmerl
 * 
 * Defines the rules for components or connectors
 */
public class ComponentConnectorSelectionCriteriaPage
    extends SelectionCriteriaPage {

    /** The type of child (role or port) **/
    private String _child;
    /** The button indicating whether children should be included **/
    private Button _btnChildren;

    /**
     * Constructs the page
     * @param category "Component" or "Connector"
     * @param group The group to apply the rule to
     */
    protected ComponentConnectorSelectionCriteriaPage(String category, AcmeGroup group) {
        super(category, group);
        
   
    }
    

    /* (non-Javadoc)
     * @see org.eclipse.jface.dialogs.IDialogPage#createControl(org.eclipse.swt.widgets.Composite)
     */
    public void createControl(Composite parent) {
        super.createControl(parent);
        {
        	_btnChildren = new Button (_top, SWT.CHECK);
        	
        	_btnChildren.setText ("Include child " + _child);
        	_btnChildren.addSelectionListener(new SelectionAdapter () {
        		public void widgetSelected (SelectionEvent evt) {
        			if (_ruleRep.getField (AcmeGroupView.INCLUDECHILDREN) == null) {
        				_ruleRep.addField (AcmeGroupView.INCLUDECHILDREN, ConstantTypes.BOOLEAN_TYPE, new AcmeBoolean (_btnChildren.getSelection()));
        			}
        			else {
        				_ruleRep.setField (AcmeGroupView.INCLUDECHILDREN,  new AcmeBoolean (_btnChildren.getSelection ()));
        			}
        		}
        	});
        }
        fillMyValues ();
    }

    /**
     * Sets up the defaults for the inclusion rule
     */
    private void fillMyValues() {
        if (_ruleRep.getField (AcmeGroupView.INCLUDECHILDREN) != null) {
            _btnChildren.setSelection (((AcmeBoolean )_ruleRep.getFieldValue (AcmeGroupView.INCLUDECHILDREN)).getValue ());
        }
    }


    /* (non-Javadoc)
     * @see AcmeStudio.ui.views.groups.wizards.SelectionCriteriaPage#setupCategory()
     */
    protected void setupCategory() {
        super.setupCategory();
        if (_category.equals ("Component")) {
            _child = "ports";
        }
        else if (_category.equals ("Connector")) {
            _child = "roles";
        }
    }

}
