package AcmeStudio.ui.views.parts;

/**
 * @author Bradley Schmerl (schmerl@cs.cmu.edu)
 * Creates a filter that filters out Armani properties
 * This is for backwards compatibility with old Acme files that
 * contain rules etc. in properties of the types Armani-AnalysisT,
 * Armani-InvariantT, Armani-HeuristicT
 * 
 */
public class ArmaniRulesFilter extends PropertyFilter {

	/**
	 * Constructor for NoArmaniRulesFilter.
	 * @param filterOut whether to filter the properties out or in
	 */
	public ArmaniRulesFilter(boolean filterOut) {
		super(
			new String[] {
				"Armani-AnalysisT",
				"Armani-InvariantT",
				"Armani-HeuristicT" },
			filterOut,
			true);
	}

}
