package AcmeStudio.ui.views.parts;


import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;
import java.util.Vector;

import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Shell;

import AcmeStudio.ui.widgets.TypeSelectionWidget;
import AcmeStudio.util.ImageManager;
import acmeLib.AcmeObject;
import acmeLib.core.container.AcmeEnumeration;
import acmeLib.core.filters.AcmeObjectFilter;
import acmeLib.core.filters.ComponentTypeEnumFilter;
import acmeLib.core.filters.ConnectorTypeEnumFilter;
import acmeLib.core.filters.PortTypeEnumFilter;
import acmeLib.core.filters.RoleTypeEnumFilter;
import acmeLib.elements.AcmeComponent;
import acmeLib.elements.AcmeComponentType;
import acmeLib.elements.AcmeConnector;
import acmeLib.elements.AcmeConnectorType;
import acmeLib.elements.AcmeElement;
import acmeLib.elements.AcmeElementType;
import acmeLib.elements.AcmePort;
import acmeLib.elements.AcmePortType;
import acmeLib.elements.AcmeRole;
import acmeLib.elements.AcmeRoleType;
/**
 * @author schmerl
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class AssignTypeDialog extends Dialog {

    private Button _btnSynch;
    AcmeElement _targetElement = null;
    AcmeElementType _targetElementType = null;
    
    AcmeElement _scope;
//    org.eclipse.swt.widgets.List _availableTypeList;
    Button _copyIntoButton;
    Button _moveOutOfButton;
//    Tree _currentTypeList;
    
    Vector _declared;
    Vector _instantiated;
    
    public Set declAdditions = new HashSet ();
    public Set declDeletions = new HashSet ();
    public Set instAdditions = new HashSet ();
    public Set instDeletions = new HashSet ();
	private TypeSelectionWidget	_wgtDeclaredTypes;
	private TypeSelectionWidget	_wgtInstantiatedTypes;
	protected boolean	_shouldSynch;
    
    private AcmeObjectFilter getFilterForElement (AcmeElement element) {
    	if (element instanceof AcmeComponent) return new ComponentTypeEnumFilter ();
    	else if (element instanceof AcmeConnector) return new ConnectorTypeEnumFilter ();
    	else if (element instanceof AcmePort) return new PortTypeEnumFilter ();
    	else if (element instanceof AcmeRole) return new RoleTypeEnumFilter ();
    	return null;
    }
    
    
    private AcmeObjectFilter getFilterForElement (AcmeElementType element) {
    	if (element instanceof AcmeComponentType) return new ComponentTypeEnumFilter ();
    	else if (element instanceof AcmeConnectorType) return new ConnectorTypeEnumFilter ();
    	else if (element instanceof AcmePortType) return new PortTypeEnumFilter ();
    	else if (element instanceof AcmeRoleType) return new RoleTypeEnumFilter ();
    	return null;
    }
    
//    private void addAvailableTypes (AcmeElement element) {
//        AcmeEnumeration types = null;
// 
//        types = _scope.getAvailableTypes();  
// 
//        if (element instanceof AcmeComponent) {
//           types = types.castToAcmeVector ().enumerate (new ComponentTypeEnumFilter ());
//              
//        }
//        else if (element instanceof AcmeConnector) {
//            types = types.castToAcmeVector ().enumerate (new ConnectorTypeEnumFilter ());
//        }
//        else if (element instanceof AcmePort) {
//            types = types.castToAcmeVector().enumerate(new PortTypeEnumFilter ());
//        }
//        else if (element instanceof AcmeRole) {
//            types = types.castToAcmeVector().enumerate( new RoleTypeEnumFilter ());
//        }
//  
//        while (types.moreItems()) {
//            AcmeElementType type = (AcmeElementType )types.getNextItem();
//            _availableTypeList.add (type.getTypeName ());
//            _availableTypeList.setData (type.getTypeName (), type);
//        }
//  
//    }
//
//
//    private void addAvailableTypes (final AcmeElementType type) {
//        AcmeEnumeration types = type.getAvailableTypes();
//        
//        if (type instanceof AcmeComponentType) {
//            types = types.castToAcmeVector ().enumerate  (new ComponentTypeEnumFilter ());
//              
//        }
//        else if (type instanceof AcmeConnectorType) {
//            types = types.castToAcmeVector ().enumerate (new ConnectorTypeEnumFilter ());
//        }
//        else if (type instanceof AcmePortType) {
//            types = types.castToAcmeVector().enumerate(new PortTypeEnumFilter ());
//        }
//        else if (type instanceof AcmeRoleType) {
//            types = types.castToAcmeVector().enumerate( new RoleTypeEnumFilter ());
//        }
//  
//        types = types.castToAcmeVector().enumerate (new AcmeObjectFilter () {
//            public boolean test (AcmeObject o) {
//                return o == type;
//            } 
//        });
//  
//        while (types.moreItems()) {
//            AcmeElementType t = (AcmeElementType )types.getNextItem();
//            _availableTypeList.add (t.getTypeName ());
//            _availableTypeList.setData (t.getTypeName (), t);
//        }
//    
//    }

    private void addCurrentTypes () {
        Iterator i = _declared.iterator();
        String [] selectedTypes = new String [_declared.size()];
        int index = 0;
        while (i.hasNext ()) {
            AcmeElementType type = (AcmeElementType )i.next();
            selectedTypes [index++] = type.getTypeName();
        }
        _wgtDeclaredTypes.updateSelectedTypes(selectedTypes);
        
        i = _instantiated.iterator ();
        String [] instantiatedTypes = new String [_instantiated.size ()];
        index = 0;
        while (i.hasNext ()) {
        	AcmeElementType type = (AcmeElementType )i.next ();
        	instantiatedTypes [index++] = type.getTypeName ();
        }
        _wgtInstantiatedTypes.updateSelectedTypes(instantiatedTypes);
    }
    
    
//    private void copyTypesInto () {
//        String selection [] = _availableTypeList.getSelection ();
//   
//        for (int i = 0; i < selection.length; i++) {
//            _declared.add (_availableTypeList.getData(selection [i]));          
//
//        }    
//        _currentTypeList.removeAll ();
//        addCurrentTypes ();
//    }
//    
//    private void moveTypesOutOf () {
//        TreeItem selection [] = _currentTypeList.getSelection ();
//        for (int i = 0; i < selection.length; i++) {
//            if (_targetElement != null) {
//                _declared.remove (selection[i].getData ());
//                _targetElement.removeDeclaredType((AcmeElementType )selection [i].getData ());
//                if (selection [i].getChecked()) {
//                    _targetElement.removeInstantiatedType((AcmeElementType )selection [i].getData ());
//                }
//            }
//            else if (_targetElementType != null) {
//                _targetElementType.removeSuperType ((AcmeElementType )selection [i].getData ());
//            }
//        }   
//        _availableTypeList.removeAll ();
//        _currentTypeList.removeAll ();
//        if (_targetElement != null) {
//            addAvailableTypes(_targetElement);
//        }
//        else if (_targetElementType != null) {
//            addAvailableTypes (_targetElementType);
//        }
//        addCurrentTypes();
//    }
//    

    public AssignTypeDialog (Shell parentShell, AcmeElement element) {
        super (parentShell);
        _targetElementType = null;
        _targetElement = element;
        _scope = element;
    }
    
    public AssignTypeDialog (Shell parentShell, AcmeElementType type) {
        super (parentShell);
        _targetElement = null;
        _targetElementType = type;
        _scope = null;   
    }
    /**
     * @see org.eclipse.jface.window.Window#createDialogArea(Composite)
     */
    protected Control createDialogArea(Composite parent) {
        Composite _parent =  (Composite )super.createDialogArea(parent);
//        _parent.setLayout(new FillLayout());
    
           
          final GridLayout gridLayout = new GridLayout (1, false);
          _parent.setLayout (gridLayout);
       
        GridData lgd = new GridData (GridData.FILL_BOTH);
        lgd.widthHint = 400;
        lgd.heightHint = 200;
//        lgd.horizontalSpan = 3;
        
        AcmeObjectFilter filter = null;
        if (_targetElement != null) filter = getFilterForElement (_targetElement);
        else if (_targetElementType != null) filter = getFilterForElement(_targetElementType);
        
         _wgtDeclaredTypes = new TypeSelectionWidget (_parent, _targetElement, filter, "Declared types:");
        _wgtDeclaredTypes.setLayoutData(lgd);
        _wgtDeclaredTypes.addAddSelectionListener(new SelectionAdapter () {
        	public void widgetSelected (SelectionEvent e) {	
        		synchTypes (_wgtDeclaredTypes, _wgtInstantiatedTypes);
        	}
        });
        
        _wgtDeclaredTypes.addRemoveSelectionListener(new SelectionAdapter () {
        	public void widgetSelected (SelectionEvent e) {	
        		synchTypes (_wgtDeclaredTypes, _wgtInstantiatedTypes);
        	}
        });
        {
        	_btnSynch = new Button(_parent, SWT.TOGGLE);
        	_btnSynch.addSelectionListener(new SelectionAdapter() {
        		public void widgetDefaultSelected(SelectionEvent e) {
        			_shouldSynch = _btnSynch.getSelection();
        		}
        	});
        	_btnSynch.setImage(ImageManager.getIcon(ImageManager.ID_SYNCH_UP));
        	_btnSynch.setSelection(true);
        	_shouldSynch = true;
        	_btnSynch.setToolTipText("Synchronizes the instantiated and declared types");
        	_btnSynch.setLayoutData(new GridData(GridData.HORIZONTAL_ALIGN_CENTER));
        }
        
        _wgtInstantiatedTypes = new TypeSelectionWidget (_parent, _targetElement, filter, "Instantiated types:");
        _wgtInstantiatedTypes.setLayoutData(new GridData(GridData.FILL_BOTH));
        _wgtInstantiatedTypes.addAddSelectionListener(new SelectionAdapter () {
        	public void widgetSelected (SelectionEvent e) {
        		synchTypes (_wgtInstantiatedTypes, _wgtDeclaredTypes);
        	}
        });
        _wgtInstantiatedTypes.addRemoveSelectionListener(new SelectionAdapter () {
        	public void widgetSelected (SelectionEvent e) {
        		synchTypes (_wgtInstantiatedTypes, _wgtDeclaredTypes);
        	}
        });
        _declared = new Vector ();
        _instantiated = new Vector ();
        if (_targetElement != null) {
            AcmeEnumeration declared = _targetElement.getDeclaredTypes();
            while (declared.moreItems ()) {
                _declared.add (declared.getNextItem ());
            }
            
            
            AcmeEnumeration instantiated = _targetElement.getInstantiatedTypes();
            while (instantiated.moreItems ()) {
                _instantiated.add (instantiated.getNextItem ());
            }
        }
        else if (_targetElementType != null) {
            AcmeEnumeration supers = _targetElementType.getSuperTypes().enumerate ();
            while (supers.moreItems ()) {
                _declared.add (supers.getNextItem ());
            }   
        }
        _wgtDeclaredTypes.updateAvailableTypes();
        _wgtInstantiatedTypes.updateAvailableTypes();
        addCurrentTypes();
//        Label typeLabel = new Label (ret, SWT.NONE);
//        typeLabel.setText ("Available types:");
//        
//        Label space = new Label (ret, SWT.NONE);
//        
//        Label curTypeLabel = new Label (ret, SWT.NONE);
//        curTypeLabel.setText ("Current types:");
//        
//        int flags = SWT.MULTI | SWT.V_SCROLL | SWT.V_SCROLL |SWT.BORDER;
//        if (_targetElement != null && _targetElementType == null) {
//            flags |= SWT.CHECK;
//        }
//        _availableTypeList = new org.eclipse.swt.widgets.List (ret, flags);
//        GridData atgd = new GridData (GridData.FILL_BOTH | GridData.GRAB_HORIZONTAL | GridData.GRAB_VERTICAL);
//        atgd.horizontalAlignment = GridData.FILL;
//        atgd.verticalAlignment = GridData.FILL;
////        atgd.grabExcessHorizontalSpace = true;
////        atgd.grabExcessVerticalSpace = true;
//        _availableTypeList.setLayoutData (atgd);
//        if (_targetElement != null) {
//            addAvailableTypes (_targetElement);
//        }
//        else if (_targetElementType != null) {
//            addAvailableTypes (_targetElementType);
//        }
//            
//        Composite buttons = new Composite (ret, SWT.NONE);
//        buttons.setLayout (new RowLayout (SWT.VERTICAL));
//        
//        _copyIntoButton = new Button (buttons, SWT.PUSH);
//        _copyIntoButton.setText (">>");
//        _copyIntoButton.addSelectionListener (new SelectionAdapter () {
//             public void widgetSelected (SelectionEvent evt) {
//                  copyTypesInto ();
//             }
//        });
//        
//        _moveOutOfButton = new Button (buttons, SWT.PUSH);
//        _moveOutOfButton.setText ("<<");
//        _moveOutOfButton.addSelectionListener (new SelectionAdapter () {
//            public void widgetSelected (SelectionEvent evt) {
//                moveTypesOutOf ();
//            }
//        });
//        
// 
//        _currentTypeList = new Tree (ret, SWT.CHECK | SWT.MULTI | SWT.BORDER);
//        addCurrentTypes ();
//       GridData vtgd = new GridData (GridData.FILL_BOTH | GridData.GRAB_HORIZONTAL | GridData.GRAB_VERTICAL);
//       vtgd.horizontalAlignment = GridData.FILL;
//       vtgd.verticalAlignment = GridData.FILL;
////       vtgd.grabExcessHorizontalSpace = true;
////       vtgd.grabExcessVerticalSpace = true;
//        _currentTypeList.setLayoutData (vtgd);
//      _currentTypeList.addSelectionListener(new SelectionListener () {
//            public void widgetSelected (SelectionEvent evt) {
//                if (evt.item instanceof TreeItem) {
//                    if (((TreeItem )evt.item).getChecked()) {
//                        _instantiated.add (evt.item.getData());
//                    }
//                    else {
//                        _instantiated.remove (evt.item.getData ());
//                    }
//                }  
//            }
//            
//            public void widgetDefaultSelected (SelectionEvent evt) {
//                
//            }
//            
//        });
        
       return _parent;
        
    }

    
	private void synchTypes(TypeSelectionWidget from, TypeSelectionWidget to) {
		if (_shouldSynch) {
			to.clearSelectedTypes();
			Set types = from.getSelectedTypes();
			String [] synchedTypes = new String [types.size ()];
			int index = 0;
			for (Iterator iter = types.iterator (); iter.hasNext ();) {
				AcmeElementType type = (AcmeElementType )iter.next ();
				synchedTypes [index++] = type.getTypeName();
			}
			to.updateSelectedTypes(synchedTypes);
		}
	}
    /**
     * @see org.eclipse.jface.dialogs.Dialog#okPressed()
     */
    protected void okPressed() {
         
        if (_targetElement != null) {
         
            Iterator d = _wgtDeclaredTypes.getSelectedTypes().iterator ();
            while (d.hasNext()) {
                AcmeElementType type = (AcmeElementType )d.next ();
                if (!_targetElement.declaresType (type)) {
                    declAdditions.add (type);
                }
            }
            
            Iterator i = _wgtInstantiatedTypes.getSelectedTypes().iterator ();
            while (i.hasNext ()) {
                AcmeElementType type = (AcmeElementType )i.next ();
                if (!_targetElement.instantiatesType (type)) {
                    instAdditions.add (type);
                }
            }
            
            AcmeEnumeration de = _targetElement.getDeclaredTypes();
            while (de.moreItems ()) {
                Object type = de.getNextItem ();
                if (!_wgtDeclaredTypes.getSelectedTypes().contains (type)) {
                    declDeletions.add (type);
                }
            }
             AcmeEnumeration in = _targetElement.getInstantiatedTypes();
            while (in.moreItems ()) {
                Object type = in.getNextItem ();
                if (!_wgtInstantiatedTypes.getSelectedTypes().contains (type)) {
                    instDeletions.add (type);
                }
            }
        }
        else if (_targetElementType != null) {
            Iterator d = _declared.iterator();
            while (d.hasNext ()) {
                AcmeElementType type = (AcmeElementType )d.next ();
                if (!_targetElementType.getSuperTypes ().contains ((AcmeObject )type)) {
                    declAdditions.add (type);
                }
            }
            
            AcmeEnumeration de = _targetElementType.getSuperTypes().enumerate ();
            while (de.moreItems()) {
                Object type = de.getNextItem();
                if (!_declared.contains (type)) {
                    declDeletions.add (type);
                }
            }
        }
            
        
       
        super.okPressed();
        
        
    }

    public void setScope (AcmeElement scope) {
        _scope = scope;
    }
	protected void configureShell(Shell newShell) {
		super.configureShell(newShell);
		newShell.setText("Type assignment");
	}

}
