/*
 * Created on Jul 7, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package AcmeStudio.ui.views.parts;

import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.*;

import AcmeStudio.util.Listeners;

/**
 * @author Bradley Schmerl
 * 
 * Implements a dialog to change the name of an element
 */
public class EditNameDialog extends Dialog {

	/** The text for the new name **/
	private Text _txtName;
	/** The new name **/
	private String newName = "";
	
	/**
	 * @param arg0
	 */
	public EditNameDialog(Shell arg0) {
		super(arg0);
	}

	/**
	 * Sets the character to be placed initially in the _txtName
	 * This used so that the keypressed event can forward the key that
	 * was pressed to raise this dialog to the dialog
	 * @param c The initial character
	 */
	public void setStartCharacter(char c) {
		newName += c;
		
	}

	/* (non-Javadoc)
	 * @see org.eclipse.jface.dialogs.Dialog#createDialogArea(org.eclipse.swt.widgets.Composite)
	 */
	protected Control createDialogArea(Composite arg0) {
		Composite parent = (Composite )super.createDialogArea (arg0);
		parent.setLayout (new GridLayout (2, false));
		Label l = new Label (parent, SWT.NONE);
		l.setText ("Name:");
		_txtName = new Text (parent, SWT.BORDER);
		_txtName.setText (newName);
		_txtName.setSelection(newName.length());
		GridData gd = new GridData ();
		gd.horizontalAlignment = GridData.FILL;
		gd.grabExcessHorizontalSpace = true;
		_txtName.setLayoutData (gd);
		_txtName.addVerifyListener(Listeners.VERIFY_ACMEID);
		return parent;
	}

	/**
	 * @return the new name
	 */
	public String getNewName() {
		return newName;
	}

	/* (non-Javadoc)
	 * @see org.eclipse.jface.dialogs.Dialog#okPressed()
	 */
	protected void okPressed() {
		newName = _txtName.getText ();
		super.okPressed();
	}

}
