// $Header$
package AcmeStudio.ui.views.parts;

import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.*;

import AcmeStudio.util.ImageManager;
import acmeLib.elements.AcmeElementType;

/**
 * @author schmerl
 *
 */
public class ModifyStyleDialog extends Dialog {

	/** The parent where this dialog is to be displayed **/
	private Composite _parent;
	
	/** The text editor for editing the rule **/
	private Text _descText;
	
    /** The message to show **/
    private String _msg;

	/**
	 * Constructor for ModifyRuleDialog.
	 * @param parentShell
	 */
	public ModifyStyleDialog(Shell parentShell, AcmeElementType elementType, String msg) {
		super(parentShell);
		_msg = msg;
	}

	/**
	 * Returns the _designRule.
	 * @return DesignRule
	 */
	public String getDescription() {
		return _descText.getText();
	}
	
	
	/**
	 * Sets the _designRule.
	 * @param _designRule The _designRule to set
	 */
	public void setDescription(String desc) {
		this._descText.setText(desc);
	}



	/**
	 * Creates the rule dialog, which has two text editors and a 
	 * parse button (in addition to OK and Cancel buttons)
	 * @param parent the dialog's parent
	 * @return the Control for the dialog
	 * @see org.eclipse.jface.dialogs.Dialog#createDialogArea(Composite)
	 */
	protected Control createDialogArea(Composite parent) {
		_parent = (Composite) super.createDialogArea(parent);

		// Make sure that the dialog is big enough to display everything
		_parent.setSize(500, 500);
		GridLayout gl = new GridLayout(2, false);
		_parent.setLayout(gl);

        Label imgLabel = new Label(_parent, SWT.LEFT);
        imgLabel.setImage(ImageManager.getIcon (ImageManager.ID_WARNING));
        imgLabel.setLayoutData(new GridData());
        
		Label msgLabel = new Label(_parent, SWT.LEFT);
		msgLabel.setText(_msg);
		msgLabel.setLayoutData(new GridData());

		return _parent;

	}


	/**
	 * Creates the OK and Cancel button and button area of the dialog
	 * If the rule that is being modified by the dialog has pre-existing
	 * errors, then disable the OK button.
	 * @see org.eclipse.jface.dialogs.Dialog#createButtonBar(Composite)
	 */
	protected Control createButtonBar(Composite parent) {
		Control buttonBar = super.createButtonBar(parent);
        //ModifyStyleDialog.this.getButton(IDialogConstants.OK_ID).setEnabled (false);
		return buttonBar;
	}

}
