package AcmeStudio.ui.views.parts;

import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.*;

import acmeLib.core.container.AcmeEnumeration;
import acmeLib.elements.AcmeElement;

/**
 * @author schmerl
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class RemoveElementDialog extends Dialog {

    List _elementList;
    AcmeElement [] _elements;
    AcmeEnumeration _candidates;
    
    public RemoveElementDialog (Shell shell, AcmeEnumeration el) {
        super (shell);
        _candidates = el;
    }

    /**
     * @see org.eclipse.jface.dialogs.Dialog#createDialogArea(Composite)
     */
    protected Control createDialogArea(Composite parent) {
        Composite p = (Composite ) super.createDialogArea(parent);      
        
        Label l = new Label (p, SWT.NONE);
        l.setText ("Selections:");
        
        _elementList = new List (p, SWT.H_SCROLL | SWT.MULTI | SWT.BORDER);
        while (_candidates.moreItems ()) {
            AcmeElement el = (AcmeElement )_candidates.getNextItem ();
            _elementList.add (el.getName ());
            _elementList.setData (el.getName (), el);   
        }
        
        return p;
    }

    /**
     * @see org.eclipse.jface.dialogs.Dialog#okPressed()
     */
    protected void okPressed() {
        String [] selections = _elementList.getSelection();
        _elements = new AcmeElement [selections.length];
        for (int i = 0; i < selections.length; i++) {
            _elements [i] = (AcmeElement )_elementList.getData (selections [i]);   
        }

        super.okPressed();
    }

    public AcmeElement [] getSelections () {
        return _elements;
    }
}
