/*
 * Created on Feb 20, 2004
 *  
 */
package AcmeStudio.ui.views.parts.propertyEditors;

import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Shell;
import acmeLib.designRules.Scope;
import acmeLib.properties.AcmeRecord;
/**
 * @author Bradley Schmerl Created Feb 20, 2004
 */
public class RecordValueEditorDialog extends Dialog {
	private RecordValueEditor	_editor;
	private AcmeRecord			_record;

	private Scope				_scope;

	protected RecordValueEditorDialog(Shell parentShell, Scope scope) {
		super (parentShell);
		_scope = scope;
	}

	protected void createButtonsForButtonBar(Composite parent) {
		createButton (parent, IDialogConstants.OK_ID, IDialogConstants.OK_LABEL, true);
		createButton (parent, IDialogConstants.CANCEL_ID, IDialogConstants.CANCEL_LABEL, false);
	}

	protected Control createDialogArea(Composite parent) {
		Composite area = (Composite )super.createDialogArea (parent);
		area.setLayout (new FillLayout ());
		_editor = new RecordValueEditor (area, SWT.NONE, _scope);
		_editor.setInput (_record, _scope);
		return area;
	}

	/**
	 * @return
	 */
	public Object getValue() {
		return _record;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.dialogs.Dialog#okPressed()
	 */
	protected void okPressed() {
		_record = _editor.getRecord ();
		super.okPressed ();
	}

	/**
	 * @param record
	 */
	public void setValue(AcmeRecord record) {
		_record = record;
	}
}
