/*
 * Created on Feb 22, 2004
 *  
 */
package AcmeStudio.ui.views.parts.propertyEditors;

import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Shell;
import acmeLib.properties.AcmePropertyType;
import acmeLib.properties.AcmeSequence;
/**
 * @author Bradley Schmerl Created Feb 22, 2004
 */
public class SequenceValueEditorDialog extends Dialog {
	private SequenceValueEditor	_editor;
	private AcmeSequence		_seq;
	private AcmePropertyType	_type;

	/**
	 * @param parentShell
	 */
	public SequenceValueEditorDialog(Shell parentShell, AcmePropertyType type) {
		super (parentShell);
		_type = type;
	}

	protected void createButtonsForButtonBar(Composite parent) {
		createButton (parent, IDialogConstants.OK_ID, IDialogConstants.OK_LABEL, true);
		createButton (parent, IDialogConstants.CANCEL_ID, IDialogConstants.CANCEL_LABEL, false);
	}

	protected Control createDialogArea(Composite parent) {
		Composite area = (Composite )super.createDialogArea (parent);
		area.setLayout (new FillLayout ());
		_editor = new SequenceValueEditor (area, SWT.NONE);
		_editor.setInput (_seq, _type);
		return area;
	}

	/**
	 * @return
	 */
	public Object getValue() {
		return _seq;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.dialogs.Dialog#okPressed()
	 */
	protected void okPressed() {
		_seq = _editor.getSeq ();
		super.okPressed ();
	}

	/**
	 * @param record
	 */
	public void setValue(AcmeSequence set) {
		_seq = set;
	}
}
