/*
 * Created on Feb 20, 2004
 *  
 */
package AcmeStudio.ui.views.parts.propertyEditors;

import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Shell;
import acmeLib.properties.AcmePropertyType;
import acmeLib.properties.AcmeSet;
/**
 * @author Bradley Schmerl Created Feb 20, 2004
 */
public class SetValueEditorDialog extends Dialog {
	private SetValueEditor		_editor;
	private AcmeSet				_set;
	private AcmePropertyType	_type;

	/**
	 * @param parentShell
	 */
	public SetValueEditorDialog(Shell parentShell, AcmePropertyType type) {
		super (parentShell);
		_type = type;
	}

	protected void createButtonsForButtonBar(Composite parent) {
		createButton (parent, IDialogConstants.OK_ID, IDialogConstants.OK_LABEL, true);
		createButton (parent, IDialogConstants.CANCEL_ID, IDialogConstants.CANCEL_LABEL, false);
	}

	protected Control createDialogArea(Composite parent) {
		Composite area = (Composite )super.createDialogArea (parent);
		area.setLayout (new FillLayout ());
		_editor = new SetValueEditor (area, SWT.NONE);
		_editor.setInput (_set, _type);
		return area;
	}

	/**
	 * @return
	 */
	public Object getValue() {
		return _set;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.dialogs.Dialog#okPressed()
	 */
	protected void okPressed() {
		_set = _editor.getSet ();
		super.okPressed ();
	}

	/**
	 * @param record
	 */
	public void setValue(AcmeSet set) {
		_set = set;
	}
}
