/*
 * Created on Oct 2, 2003
 *
 */
package AcmeStudio.ui.views.parts.wizards.newTypes;

import org.eclipse.jface.action.ActionContributionItem;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.jface.wizard.IWizardPage;
import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;

import AcmeStudio.ui.views.parts.PropertyList;
import acmeLib.elements.AcmeElement;
import acmeLib.elements.AcmeElementType;
import acmeLib.elements.AcmeFamily;

/**
 * @author Bradley Schmerl
 * Created Oct 2, 2003
 */
public class PropertyPage extends WizardPage implements Listener {

	private AcmeElementType _protoType;
	private PropertyList _properties;
	private Button _btnNew;
	private Button _btnRemove;
	
	/**
	 * @param pageName
	 */
	public PropertyPage(AcmeFamily fam) {
		super("Define properties for the type");
	}

	
	public void setPrototype (AcmeElementType type) {
		_protoType = type;
		_properties.setInput((AcmeElement )_protoType);
	}
	/**
	 * @param pageName
	 * @param title
	 * @param titleImage
	 */
	public PropertyPage(String pageName, String title, ImageDescriptor titleImage) {
		super(pageName, title, titleImage);
	}

	/* (non-Javadoc)
	 * @see org.eclipse.swt.widgets.Listener#handleEvent(org.eclipse.swt.widgets.Event)
	 */
	public void handleEvent(Event event) {
	}

	/* (non-Javadoc)
	 * @see org.eclipse.jface.dialogs.IDialogPage#createControl(org.eclipse.swt.widgets.Composite)
	 */
	public void createControl(Composite parent) {
		Composite top = new Composite (parent, SWT.NONE);
		top.setLayout (new GridLayout (2, false));
		_properties = new PropertyList ();
		_properties.createControl(top, SWT.BORDER, null);
		
		GridData pgd = new GridData ();
		pgd.verticalSpan = GridData.FILL;
		pgd.verticalAlignment = GridData.FILL;
		pgd.horizontalAlignment = GridData.FILL;
		pgd.grabExcessHorizontalSpace = true;
		_properties.getComposite().setLayoutData(pgd);
		
		_btnNew = new Button (top, SWT.PUSH);
		_btnNew.setText ("New...");
		_btnNew.addSelectionListener(new SelectionAdapter () {
			public void widgetSelected (SelectionEvent e) {
				((ActionContributionItem )_properties.getContributions() [PropertyList.NEWPROPERTY]).getAction().run();
			}
		});
		
		_btnRemove = new Button (top, SWT.PUSH);
		_btnRemove.setText ("Remove");
		_btnRemove.addSelectionListener(new SelectionAdapter () {
			public void widgetSelected (SelectionEvent e) {
				((ActionContributionItem )_properties.getContributions() [PropertyList.DELPROPERTY]).getAction().run();
			}
		});
				
		setTitle ("Enter properties for this type");
		setControl (top);
	}

	/* (non-Javadoc)
	 * @see org.eclipse.jface.wizard.IWizardPage#getNextPage()
	 */
	public IWizardPage getNextPage() {
		IWizardPage next =  super.getNextPage();
		if (next instanceof RulesPage) {
			RulesPage page = (RulesPage) next;
			page.setPrototype (_protoType);
		}
		return next;
	}

}
