/*
 * Created on Oct 2, 2003
 *
 */
package AcmeStudio.ui.views.parts.wizards.newTypes;

import org.eclipse.jface.action.ActionContributionItem;
import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;

import AcmeStudio.ui.views.parts.RuleList;
import acmeLib.elements.AcmeElement;
import acmeLib.elements.AcmeElementType;
import acmeLib.elements.AcmeFamily;

/**
 * Allows a user to enter rules for a new type
 * @author Bradley Schmerl 
 * Created Oct 2, 2003 
 **/
public class RulesPage extends WizardPage {
	/** Widget containing the rules currently defined **/
	private RuleList _rules;
	/** Button to add new rules **/
	private Button _btnNew;
	/** Buton to remove rules **/
	private Button _btnRemove;
	/**
	 * Constructs teh page
	 * @param family The family that a type will be added to
	 **/
	public RulesPage(AcmeFamily family) {
		super("Enter new rules");
	}

	/*
	 * (non-Javadoc) @see
	 * org.eclipse.jface.dialogs.IDialogPage#createControl(org.eclipse.swt.widgets.Composite)
	 */
	public void createControl(Composite parent) {
		Composite top = new Composite(parent, SWT.NONE);
		setControl(top);
		top.setLayout(new GridLayout(2, false));
		
		// Create the rules
		_rules = new RuleList();
		_rules.createControl(top, SWT.BORDER, null);

		GridData pgd = new GridData();
		pgd.verticalSpan = GridData.FILL;
		pgd.verticalAlignment = GridData.FILL;
		pgd.horizontalAlignment = GridData.FILL;
		pgd.grabExcessHorizontalSpace = true;
		_rules.getComposite().setLayoutData(pgd);

		// Create the buttons
		_btnNew = new Button(top, SWT.PUSH);
		_btnNew.setText("New...");
		_btnNew.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				((ActionContributionItem) _rules.getContributions()[RuleList.NEWRULE]).getAction().run();
			}
		});

		_btnRemove = new Button(top, SWT.PUSH);
		_btnRemove.setText("Remove");
		_btnRemove.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				((ActionContributionItem) _rules.getContributions()[RuleList.DELRULE]).getAction().run();
			}
		});

		setTitle ("Enter rules for this type:");
	}

	/**
	 * @param type The new type, to which rules can be added
	 */
	public void setPrototype(AcmeElementType type) {
		_rules.setInput((AcmeElement )type);
	}

}
