/*
 * Created on May 16, 2005
 *
 */
package AcmeStudio.ui.views.parts.wizards.weaveFamily;

import java.util.Collection;
import org.eclipse.jface.wizard.Wizard;
import AcmeStudio.core.resource.ASFamily;
import AcmeStudio.model.ModelCommand;
import AcmeStudio.model.ModelCompoundCommand;
import AcmeStudio.model.TypeAssignmentCommand;
import acmeLib.elements.AcmeElement;
import acmeLib.elements.AcmeSystem;


/**
 * @author Bradley Schmerl
 * Created May 16, 2005
 */
public class WeaveFamilyWizard extends Wizard {

	private AcmeElement _system;
	private ChooseFamilyWizardPage _chooseFamily;
	private DefinePointCutPage _definePointcut;
	
	
	/**
	 * @param system
	 */
	public WeaveFamilyWizard(AcmeSystem system) {
		_system = system;
	}
	/**
	 * 
	 * @see org.eclipse.jface.wizard.Wizard#addPages()
	 **/
	public void addPages() {
		_chooseFamily = new ChooseFamilyWizardPage (this, _system);
		_definePointcut = new DefinePointCutPage (this, _system);
		addPage (_chooseFamily);
		addPage (_definePointcut);
	}
	/**
	 * @return
	 * @see org.eclipse.jface.wizard.IWizard#performFinish()
	 **/
	public boolean performFinish() {
		Collection weavingInstructions = _definePointcut.getWeavingInstructions();
		ModelCommand command = null;
		if (!_system.declaresType(getSelectedFamily().getFamily())) {
			ModelCompoundCommand cmd = new ModelCompoundCommand ("Weave in " + getSelectedFamily ().getFamily().getTypeName());
			cmd.add(new TypeAssignmentCommand (TypeAssignmentCommand.ASSIGN_FAMILY, (AcmeSystem )_system, getSelectedFamily ().getFamily (), this ));
			cmd.add (new WeaveInFamilyCommand ((AcmeSystem )_system, weavingInstructions));
			cmd.execute(_system.getParentDesign());
			try {
				cmd.checkError ();
				return true;
			}
			catch (Exception e) {
				return false;
			}
		}
		else {
			command = new WeaveInFamilyCommand ((AcmeSystem )_system, weavingInstructions);
			command.execute(_system.getParentDesign ());
			try {
				command.checkError ();
				return true;
			}
			catch (Exception e) {
				return false;
			}
		}
	}
	
	ASFamily getSelectedFamily () {
		return _chooseFamily.getFamily();
	}
}
