/*
 * Created on May 24, 2005
 *
 */
package AcmeStudio.ui.views.parts.wizards.weaveFamily;

import java.util.ArrayList;
import java.util.List;
import acmeLib.elements.AcmeElementType;


/**
 * @author Bradley Schmerl
 * Created May 24, 2005
 */
public class WeavingInstruction {
	public static final int APPLY_TO_ALL = 0;
	public static final int APPLY_TO_SELECTED = 1;
	public static final int APPLY_TO_PATTERN = 2;
	public static final int	APPLY_TO_NONE	= 3;
	
	private final AcmeElementType	_type;
	private int _instruction = -1;
	private List _selectedTypes = null;
	private String _pattern = "";
	private List applyToTypes = new ArrayList ();
	
	/**
	 * @param type
	 */
	public WeavingInstruction(AcmeElementType type) {
		_type = type;
	}
	
	public int getInstruction() {
		return _instruction;
	}
	public void setInstruction(int instruction) {
		_instruction = instruction;
	}
	public String getPattern() {
		return _pattern;
	}
	public void setPattern(String pattern) {
		_pattern = pattern;
		if (pattern != null && pattern.length () != 0) {
			setInstruction (APPLY_TO_PATTERN);
			setSelectedTypes (null);
		}
	}
	public List getSelectedTypes() {
		return _selectedTypes;
	}
	public void setSelectedTypes(List selectedTypes) {
		_selectedTypes = selectedTypes;
		if (selectedTypes != null) {
			setInstruction(APPLY_TO_SELECTED);
			setPattern ("");
		}
	}
	public AcmeElementType getType() {
		return _type;
	}
	public List getApplyToTypes() {
		return applyToTypes;
	}
	public void setApplyToTypes(List applyToTypes) {
		this.applyToTypes = applyToTypes;
	}
}
