/*
 * Created on Aug 5, 2003
 *
 */
package AcmeStudio.ui.views.providers;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.eclipse.jface.viewers.IStructuredContentProvider;
import org.eclipse.jface.viewers.Viewer;

import acmeLib.core.container.AcmeEnumeration;
import acmeLib.elements.AcmeElement;

/**
 * @author Bradley Schmerl
 * Created Aug 5, 2003
 */
public class AcmeElementContentProvider implements IStructuredContentProvider {
	protected static final Object [] EMPTY = new Object [0];

	/* (non-Javadoc)
	 * @see org.eclipse.jface.viewers.IContentProvider#dispose()
	 */
	public void dispose() {
	}

	/* (non-Javadoc)
	 * @see org.eclipse.jface.viewers.IContentProvider#inputChanged(org.eclipse.jface.viewers.Viewer, java.lang.Object, java.lang.Object)
	 */
	public void inputChanged(Viewer viewer, Object oldInput, Object newInput) {
	}

	/* (non-Javadoc)
	 * @see org.eclipse.jface.viewers.IStructuredContentProvider#getElements(java.lang.Object)
	 */
	public Object[] getElements(Object inputElement) {
		if (inputElement instanceof List) {
			List elements = (List) inputElement;
			List copy = new ArrayList ();
			for (Iterator i = elements.iterator(); i.hasNext();) {
				Object element = i.next();
				if (element instanceof AcmeElement) {
					AcmeElement aEl = (AcmeElement) element;
					copy.add (aEl);
				}
			}
			return copy.toArray();
			
		}
		else if (inputElement instanceof AcmeEnumeration) {
			AcmeEnumeration elements = (AcmeEnumeration) inputElement;
			List copy = new ArrayList ();
			while (elements.moreItems ()) {
				Object o = elements.getNextItem ();
				if (o instanceof AcmeElement) {
					AcmeElement aEl = (AcmeElement) o;
					copy.add (aEl);
				}
			}
			return copy.toArray ();
		}
		return EMPTY;
			
		
	}

}
