/*
 * Created on May 21, 2003
 *
 */
package AcmeStudio.ui.views.providers;

import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.swt.graphics.Image;

import AcmeStudio.util.ImageManager;
import acmeLib.AcmeType;
import acmeLib.designRules.DesignAnalysis;
import acmeLib.elements.AcmeElement;
import acmeLib.properties.AcmeProperty;
import acmeLib.representations.AcmeRepresentation;

/**
   * Provides the label information for elements in the tree
   **/
public class AcmeViewLabelProvider extends LabelProvider {

	/** 
	 * Returns the string label of the element 
	 * @param obj the object to return the label for
	 * @return the label
	 * */
	public String getText(Object obj) {
		return getLabel(obj);
	}

	public static String getLabel(Object obj) {
		String label = "";
		if (obj instanceof AcmeElement) {
			label = ((AcmeElement) obj).getName();
		} else if (obj instanceof AcmeType) {
			label = ((AcmeType) obj).getTypeName();
		} else if (obj instanceof AcmeProperty) {
			label = ((AcmeProperty) obj).getName();
		} else if (obj instanceof AcmeRepresentation) {
			label = ((AcmeRepresentation) obj).getName();
		} else if (obj instanceof DesignAnalysis) {
			label = ((DesignAnalysis) obj).getName();
		}
		return label;
	}

	/**
	 * Returns the image corresponding the object
	 * This is a small icon that goes to the left of the label
	 * @param obj the object to return the image for
	 * @return the image
	 */
	public Image getImage(Object obj) {
		Image img = null;
//		if (!(obj instanceof AcmeFamily) && obj instanceof AcmeElementType) {
//			img = VisualStyleRegistry.getVisualization ((AcmeElementType )obj).getSmallImage((AcmeElementType )obj);
//		}
//		else if (obj instanceof AcmeElement) {
//			AcmeElement element = (AcmeElement )obj;
//			if (element.getDeclaredTypes().getSize() > 0) {
//				img = VisualStyleRegistry.getVisualization((AcmeElement )obj).getSmallImage((AcmeElementType )element.getDeclaredTypes().getNextItem());
//			}
//		}
		if (img == null) 
			// The ImageManager handles all images, so defer to it
			 img = ImageManager.getSmallImageByType(obj);
		return img;
	}
}
