/*
 * Created on Sep 29, 2003
 *
 */
package AcmeStudio.ui.views.providers;

import java.util.Vector;

import org.eclipse.jface.viewers.IStructuredContentProvider;
import org.eclipse.jface.viewers.Viewer;

import AcmeStudio.util.Constants;
import acmeLib.designRules.DesignAnalysis;

/**
 * @author Bradley Schmerl
 * Created Sep 29, 2003
 */
public class ParameterContentProvider implements IStructuredContentProvider {

	
	/**
	 * 
	 */
	public ParameterContentProvider() {
		super();
	}

	/* (non-Javadoc)
	 * @see org.eclipse.jface.viewers.IStructuredContentProvider#getElements(java.lang.Object)
	 */
	public Object[] getElements(Object inputElement) {
		if (inputElement == null) {
			return Constants.EMPTY_ELEMENTS;
		}
		if (inputElement instanceof DesignAnalysis) {
			DesignAnalysis analysis = (DesignAnalysis) inputElement;
			Vector params = analysis.getFormalParams();
			if (params != null) 
				return params.toArray();
			else 
				return Constants.EMPTY_ELEMENTS;
		}
		else if (inputElement instanceof Vector) {
			return ((Vector )inputElement).toArray ();
		}
		return Constants.EMPTY_ELEMENTS;
	}

	/* (non-Javadoc)
	 * @see org.eclipse.jface.viewers.IContentProvider#dispose()
	 */
	public void dispose() {
	}

	/* (non-Javadoc)
	 * @see org.eclipse.jface.viewers.IContentProvider#inputChanged(org.eclipse.jface.viewers.Viewer, java.lang.Object, java.lang.Object)
	 */
	public void inputChanged(Viewer viewer, Object oldInput, Object newInput) {
	}

}
