/*
 * Created on Mar 30, 2004
 *
 */
package AcmeStudio.ui.views.ruleErrors;

import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;

import acmeLib.elements.AcmeElement;


public class AcmeElementTree {
	protected AcmeElement root;
	protected Map children = new HashMap ();
	
	public AcmeElementTree (AcmeElement rootNode) {
		root = rootNode;
	}
	
	public void insertChild (AcmeElement child) {
		children.put (child, new AcmeElementTree (child));
	}
	
	public void deleteChild (AcmeElement child) {
		children.remove(child);
	}
	
	public Set getChildren () {
		return children.keySet();
	}
	
	public AcmeElementTree getChildTree (AcmeElement child) {
		return (AcmeElementTree )children.get (child);
	}
	
	public AcmeElement getRootElement () {
		return root;
	}

	/**
	 * @return
	 */
	public Set getAllElements() {
		Set set = new HashSet ();
		set.add (root);
		for (Iterator iter = getChildren ().iterator(); iter.hasNext();) {
			AcmeElement element = (AcmeElement) iter.next();
			set.addAll(getChildTree (element).getAllElements());
		}
		return set;
	}
}