/*
 * Created on Nov 3, 2003
 *
 */
package AcmeStudio.util;

import org.eclipse.jface.viewers.LabelProvider;

import acmeLib.AcmeObject;
import acmeLib.AcmeType;
import acmeLib.core.container.AcmeEnumeration;
import acmeLib.elements.AcmeComponentType;
import acmeLib.elements.AcmeConnectorType;
import acmeLib.elements.AcmePortType;
import acmeLib.elements.AcmeRoleType;
import acmeLib.properties.AcmePropertyType;

/**
 * @author Bradley Schmerl
 * Created Nov 3, 2003
 */
public class FamilyDetailLabelProvider extends LabelProvider {

	/**
	 * 
	 */
	public FamilyDetailLabelProvider() {
		super();
	}

	/* (non-Javadoc)
	 * @see org.eclipse.jface.viewers.ILabelProvider#getText(java.lang.Object)
	 */
	public String getText(Object element) {
		if (element instanceof AcmeEnumeration) {
			AcmeEnumeration enum = (AcmeEnumeration) element;
			AcmeObject el = enum.getNextItem ();
			if (el instanceof AcmeComponentType) return "Component Types";
			else if (el instanceof AcmeConnectorType) return "Connector Types";
			else if (el instanceof AcmePortType) return "Port Types";
			else if (el instanceof AcmeRoleType) return "Role Types";
			else if (el instanceof AcmePropertyType) return "Property Types";
		}
		else if (element instanceof AcmeType) {
			AcmeType type = (AcmeType) element;
			return type.getTypeName();
		}
		return "";
	}
}
