/*
 * Created on Oct 7, 2003
 *
 */
package AcmeStudio.wizards.convertFromVersion1;

import org.eclipse.jface.viewers.ColumnPixelData;
import org.eclipse.jface.viewers.TableLayout;
import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.*;

import AcmeStudio.util.Helper;

/**
 * @author Bradley Schmerl
 * Created Oct 7, 2003
 */
public class OpenClarificationPage extends WizardPage {

	private SplitPage[] _pages;
	private Table _tblOpenFiles;

	/**
	 * @param pageName
	 */
	public OpenClarificationPage(SplitPage [] pages) {
		super("Confirm everything");
		_pages = pages;
	}

	/* (non-Javadoc)
	 * @see org.eclipse.jface.dialogs.IDialogPage#createControl(org.eclipse.swt.widgets.Composite)
	 */
	public void createControl(Composite parent) {
		Composite top = new Composite (parent, SWT.NONE);
		setControl (top);
		top.setLayout (new GridLayout (1, false));
		Label l = new Label (top, SWT.NONE);
		l.setText ("Check to open the following families:");
		
		_tblOpenFiles = new Table (top, SWT.FULL_SELECTION | SWT.BORDER | SWT.H_SCROLL | SWT.V_SCROLL | SWT.CHECK);
		_tblOpenFiles.setLayoutData(new GridData (GridData.HORIZONTAL_ALIGN_FILL | GridData.VERTICAL_ALIGN_FILL));
		
		TableColumn col1 = new TableColumn (_tblOpenFiles, SWT.LEFT, 0);
		col1.setText("Family/System");
		TableColumn col2 = new TableColumn (_tblOpenFiles, SWT.LEFT, 0);
		col2.setText ("File to open");
		TableLayout tl = new TableLayout ();
		tl.addColumnData (new ColumnPixelData (150));
		tl.addColumnData (new ColumnPixelData (400));
		_tblOpenFiles.setLayout(tl);
		_tblOpenFiles.setHeaderVisible(true);
		_tblOpenFiles.setLinesVisible(true);
		refreshTable();
		// Make sure that if an item has been checked, that it is also selected
		_tblOpenFiles.addMouseListener(new MouseAdapter () {
			public void mouseUp (MouseEvent evt) {
				if (evt.widget == _tblOpenFiles) {
					TableItem item = _tblOpenFiles.getItem (new Point (evt.x, evt.y));
					if (item != null) {
						if (item.getChecked ()) {
							((SplitPage )item.getData ()).setOpen (true);
						}
						else {
							((SplitPage )item.getData ()).setOpen (false);
						}
					}
				}
			}
 
		});
	}

	public void refreshTable() {
		_tblOpenFiles.removeAll();
		for (int i = 0; i < _pages.length; i++) {
			TableItem famItem = new TableItem (_tblOpenFiles, SWT.NONE);
			famItem.setText (new String [] {_pages [i].getFamily ().getName(),_pages [i].getContainerName() + "/" + Helper.convertToAcmeFilename (_pages [i].getFilename())});
			famItem.setData (_pages [i]);
			if (_pages [i].willOpen ()) {
				famItem.setChecked(true);
			}
		}
	}

}
