package AcmeStudioShapeExtension;

import org.eclipse.jface.preference.IPreferenceStore;
import org.eclipse.ui.plugin.*;
import org.osgi.framework.BundleContext;
import AcmeStudioShapeExtension.model.AcmeAnnotations;
import acmeLib.elements.AcmeSystem;
import java.util.*;

/**
 * The main plugin class to be used in the desktop.
 */
public class AcmeStudioShapeExtensionPlugin extends AbstractUIPlugin {
	//The shared instance.
	private static AcmeStudioShapeExtensionPlugin plugin;
	//Resource bundle.
	private ResourceBundle resourceBundle;
	
	/**
	 * The constructor.
	 */
	public AcmeStudioShapeExtensionPlugin() {
		super();
		plugin = this;
		try {
			resourceBundle = ResourceBundle.getBundle("AcmeStudioShapeExtension.AcmeStudioShapeExtensionPluginResources");
		} catch (MissingResourceException x) {
			resourceBundle = null;
		}
	}

	/**
	 * This method is called upon plug-in activation
	 */
	public void start(BundleContext context) throws Exception {
		super.start(context);
	}

	/**
	 * This method is called when the plug-in is stopped
	 */
	public void stop(BundleContext context) throws Exception {
		super.stop(context);
	}

	/**
	 * Returns the shared instance.
	 */
	public static AcmeStudioShapeExtensionPlugin getDefault() {
		return plugin;
	}

	/**
	 * Returns the string from the plugin's resource bundle,
	 * or 'key' if not found.
	 */
	public static String getResourceString(String key) {
		ResourceBundle bundle = AcmeStudioShapeExtensionPlugin.getDefault().getResourceBundle();
		try {
			return (bundle != null) ? bundle.getString(key) : key;
		} catch (MissingResourceException e) {
			return key;
		}
	}

	/**
	 * Returns the plugin's resource bundle,
	 */
	public ResourceBundle getResourceBundle() {
		return resourceBundle;
	}

	/**
	 * @param system TODO
	 * @return
	 */
	public static  AcmeAnnotations getAnnotations(AcmeSystem system) {
		AcmeAnnotations annotations = (AcmeAnnotations )system.getUserData(AcmeStudioShapeExtensionPlugin.class);
		if (annotations == null) {
			annotations = new AcmeAnnotations ();
			system.setUserData (AcmeStudioShapeExtensionPlugin.class, annotations);
		}
		return annotations;
	}
	
	
	/**
	 * @param store
	 * @see org.eclipse.ui.plugin.AbstractUIPlugin#initializeDefaultPreferences(org.eclipse.jface.preference.IPreferenceStore)
	 **/
	protected void initializeDefaultPreferences(IPreferenceStore store) {
		AnnotationPrefs.setDefaults(store);
	}
}
