/*
 * Created on Oct 12, 2004
 *
 */
package AcmeStudioShapeExtension;

import java.util.HashMap;
import java.util.Map;
import org.eclipse.draw2d.ColorConstants;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.FontData;
import org.eclipse.swt.graphics.RGB;


/**
 * @author Bradley Schmerl
 * Created Oct 12, 2004
 */
public class AnnotationConstants {

	public static final Color	DEFAULT_BACKGROUND_COLOR	= ColorConstants.white;
	public static final Color 	DEFAULT_FOREGROUND_COLOR	= ColorConstants.black;
	public static final Color DEFAULT_NOTE_BACKGROUND = ColorConstants.tooltipBackground;
	public static final boolean	DEFAULT_FILL_MODE	= false;
	private  static final Map	COLOR_REGISTRY	= new HashMap ();
	private static final Map FONT_REGISTRY = new HashMap ();
	
	public static Color getColor (RGB rgb) {
		Color color = (Color )COLOR_REGISTRY.get(rgb);
		if (color == null) {
			color = new Color (null, rgb);
			COLOR_REGISTRY.put (rgb, color);
		}
		return color;
	}

	/**
	 * Returns a font from the font registry, or adds it to the registry if it is not there
	 * @param fontData
	 * @return
	 */
	public static Font getFont(FontData fontData) {
		Font font = (Font )FONT_REGISTRY.get (fontData);
		if (font == null) {
			font = new Font (null, fontData);
			FONT_REGISTRY.put (fontData, font);
		}
		return font;
	}

	/**
	 * Returns a string representation of a font data object
	 * @param fd
	 * @return
	 */
	public static String getFontDataString(FontData fd) {
		String styleString = "";
		switch (fd.getStyle()) {
			case SWT.BOLD : 
				styleString = "Bold"; break;
			case SWT.ITALIC:
				styleString = "Italic"; break;
		}
		return fd.getName() + " " + fd.getHeight() + " " + styleString;
	}
}
