/*
 * Created on Jan 5, 2005
 *
 */
package AcmeStudioShapeExtension;

import org.eclipse.jface.preference.FieldEditorPreferencePage;
import org.eclipse.jface.preference.IPreferenceStore;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPreferencePage;
import org.eclipse.jface.preference.BooleanFieldEditor;


/**
 * @author Bradley Schmerl
 * Created Jan 5, 2005
 */
public class AnnotationPrefs extends FieldEditorPreferencePage implements IWorkbenchPreferencePage {

	private BooleanFieldEditor _annotationsEnabled;
	public static String ENABLE_ANNOTATIONS_PREF = "EnableAnnotations";
	
	public AnnotationPrefs() {
		super (FLAT);
		setTitle("Diagram Annotation Preferences");
	}

	protected void createFieldEditors() {

		{
			_annotationsEnabled = new BooleanFieldEditor(ENABLE_ANNOTATIONS_PREF, "Enable annotations in diagrams", getFieldEditorParent());
			addField(_annotationsEnabled);
		}
	}

	public void init(IWorkbench workbench) {
	}
	
	
	
	/**
	 * @return
	 * @see org.eclipse.jface.preference.PreferencePage#doGetPreferenceStore()
	 **/
	protected IPreferenceStore doGetPreferenceStore() {
		return AcmeStudioShapeExtensionPlugin.getDefault ().getPreferenceStore ();
	}
	
	public static void setDefaults (IPreferenceStore store) {
		store.setDefault(ENABLE_ANNOTATIONS_PREF, true);
	}
}
