/*
 * Created on Oct 12, 2004
 *
 */
package AcmeStudioShapeExtension;

import java.util.Collections;
import java.util.List;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.ConnectionEndpointEditPolicy;
import org.eclipse.gef.editpolicies.ResizableEditPolicy;
import org.eclipse.gef.editpolicies.SelectionEditPolicy;
import AcmeStudio.ui.editors.diagram.IElementFactory;
import AcmeStudioShapeExtension.model.*;
import AcmeStudioShapeExtension.parts.LabelEditPart;
import AcmeStudioShapeExtension.parts.LineEditPart;
import AcmeStudioShapeExtension.parts.NoteEditPart;
import AcmeStudioShapeExtension.parts.ShapeEditPart;
import acmeLib.elements.AcmeSystem;


/**
 * @author Bradley Schmerl
 * Created Oct 12, 2004
 */
public class ShapeFactory implements IElementFactory {

	/**
	 * @param parent
	 * @return
	 * @see AcmeStudio.ui.editors.diagram.IElementFactory#getModels(acmeLib.elements.AcmeSystem)
	 **/
	public List getModels(AcmeSystem parent) {
		AcmeAnnotations annotations = (AcmeAnnotations )parent.getUserData (AcmeStudioShapeExtensionPlugin.class);
		if (annotations == null) return Collections.EMPTY_LIST;
		else {
			return annotations;
		}
	}

	/**
	 * @param child
	 * @return
	 * @see AcmeStudio.ui.editors.diagram.IElementFactory#getEditPart(java.lang.Object)
	 **/
	public EditPart getEditPart(Object child) {
		if (child instanceof EllipseAnnotation) {
			return new ShapeEditPart ();
		}
		else if (child instanceof RectangleAnnotation) {
			return new ShapeEditPart ();
		}
		else if (child instanceof RoundedRectangleAnnotation) {
			return new ShapeEditPart ();
		}
		else if (child instanceof LabelAnnotation) {
			return new LabelEditPart ();
		}
		else if (child instanceof NoteAnnotation) {
			return new NoteEditPart ();
		}
		else if (child instanceof LineAnnotation) {
			return new LineEditPart ();
		}
		return null;
	}

	/**
	 * @param target
	 * @return
	 * @see AcmeStudio.ui.editors.diagram.IElementFactory#getSelectionPolicy(java.lang.Object)
	 **/
	public SelectionEditPolicy getSelectionPolicy(Object target) {
		if (target instanceof ShapeEditPart) return new ResizableEditPolicy ();
		else if (target instanceof LabelEditPart) return new ResizableEditPolicy ();
		else if (target instanceof LineEditPart) return new ConnectionEndpointEditPolicy ();
		else return null;
	}

	/**
	 * @param model
	 * @return
	 * @see AcmeStudio.ui.editors.diagram.IElementFactory#getDeleteCommand(java.lang.Object)
	 **/
	public Command getDeleteCommand(Object model) {
		
		return null;
	}
}
