/*
 * Created on Jan 3, 2005
 *
 */
package AcmeStudioShapeExtension.actions;

import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.ui.*;
import AcmeStudio.AcmeStudioPlugin;
import AcmeStudioShapeExtension.parts.IAnnotationEditPart;


/**
 * @author Bradley Schmerl
 * Created Jan 3, 2005
 */
public class EditPropertiesAction implements IEditorActionDelegate, IObjectActionDelegate {

	/**
	 * @param action
	 * @param targetEditor
	 * @see org.eclipse.ui.IEditorActionDelegate#setActiveEditor(org.eclipse.jface.action.IAction, org.eclipse.ui.IEditorPart)
	 **/
	public void setActiveEditor(IAction action, IEditorPart targetEditor) {
	}

	/**
	 * @param action
	 * @param targetPart
	 * @see org.eclipse.ui.IObjectActionDelegate#setActivePart(org.eclipse.jface.action.IAction, org.eclipse.ui.IWorkbenchPart)
	 **/
	public void setActivePart(IAction action, IWorkbenchPart targetPart) {
	}

	/**
	 * @param action
	 * @see org.eclipse.ui.IActionDelegate#run(org.eclipse.jface.action.IAction)
	 **/
	public void run(IAction action) {
		IWorkbench workbench = AcmeStudioPlugin.getDefault().getWorkbench();
		IWorkbenchWindow window = workbench.getActiveWorkbenchWindow();
		try {
			IWorkbenchPage page = workbench.showPerspective("AcmeStudio.perspective", window);
			page.showView("org.eclipse.ui.views.PropertySheet");
		}
		catch (PartInitException e) {
			e.printStackTrace();
		}
		catch (WorkbenchException e) {
			e.printStackTrace();
		}
	}

	/**
	 * @param action
	 * @param selection
	 * @see org.eclipse.ui.IActionDelegate#selectionChanged(org.eclipse.jface.action.IAction, org.eclipse.jface.viewers.ISelection)
	 **/
	public void selectionChanged(IAction action, ISelection selection) {
		if (!(selection instanceof IStructuredSelection)) {
			action.setEnabled (false);
			return;
		}
		IStructuredSelection ssel = (IStructuredSelection )selection;
		if (ssel.size() == 1) {
			Object sel = ssel.getFirstElement();
			if (sel instanceof IAnnotationEditPart) {
				action.setEnabled (true);
			}
			else {
				action.setEnabled (false);
			}
		}
	}
}
