/*
 * Created on Oct 15, 2004
 *
 */
package AcmeStudioShapeExtension.editors;

import org.eclipse.jface.viewers.DialogCellEditor;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.*;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.FontDialog;
import org.eclipse.swt.widgets.Label;
import AcmeStudioShapeExtension.AnnotationConstants;


/**
 * @author Bradley Schmerl
 * Created Oct 15, 2004
 */
public class FontCellEditor extends DialogCellEditor {

	private Composite	_composite;
	private Label	_fontLabel;
	private Image	_image;


	public FontCellEditor (Composite control) {
		super (control);
	}
	/**
	 * @param cellEditorWindow
	 * @return
	 * @see org.eclipse.jface.viewers.DialogCellEditor#openDialogBox(org.eclipse.swt.widgets.Control)
	 **/
	protected Object openDialogBox(Control cellEditorWindow) {
		FontDialog dialog = new FontDialog (cellEditorWindow.getShell ());
		Object value = getValue ();
		if (value != null) {
			if (value instanceof FontData []) {
				FontData [] fd = (FontData [] )value;
				dialog.setFontList(fd);
			}
			else if (value instanceof FontData) {
				FontData[] fd = { (FontData )value };
				dialog.setFontList(fd);
			}
		}
		value = dialog.open();
		return dialog.getFontList ();
	}
	
	
	/**
	 * @param value
	 * @see org.eclipse.jface.viewers.DialogCellEditor#updateContents(java.lang.Object)
	 **/
	protected void updateContents(Object value) {
		Font font = null;
		FontData fontData = null;
		if (value instanceof FontData []) 
			fontData = ((FontData [])value) [0];
		else if (value instanceof FontData) {
			 fontData = (FontData )value;
		}
		if (fontData == null) font = _fontLabel.getFont();
		else font = AnnotationConstants.getFont (fontData);
		
		if (_image != null) 
			_image.dispose ();
	
		_fontLabel.setFont (font);
		FontData fontData2 = font.getFontData() [0];
		_fontLabel.setText(AnnotationConstants.getFontDataString(fontData2));
	}
	
	
	/**
	 * @param parent
	 * @param fontData
	 * @return
	 */

	/**
	 * @param cell
	 * @return
	 * @see org.eclipse.jface.viewers.DialogCellEditor#createContents(org.eclipse.swt.widgets.Composite)
	 **/
	protected Control createContents(Composite cell) {
		Color bg = cell.getBackground();
		_fontLabel = new Label (cell, SWT.LEFT);
		_fontLabel.setBackground(bg);
		return _fontLabel;
	}
}
