/*
 * Created on Oct 20, 2004
 *
 */
package AcmeStudioShapeExtension.figures;

import org.eclipse.draw2d.Figure;
import org.eclipse.draw2d.MarginBorder;
import org.eclipse.draw2d.StackLayout;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.draw2d.text.FlowPage;
import org.eclipse.draw2d.text.ParagraphTextLayout;
import org.eclipse.draw2d.text.TextFlow;


/**
 * @author Bradley Schmerl
 * Created Oct 20, 2004
 */
public class LabelFigure extends Figure implements IAnnotationTextProvider {
	
	private TextFlow _textFlow;
	private FlowPage _flowPage;
	private final String	_label;
	
	
	/**
	 * @param string
	 */
	public LabelFigure(String label) {
		_label = label;
		setBorder (new MarginBorder (1));
		_flowPage = new FlowPage () {
			
			/**
			 * 
			 * @see org.eclipse.draw2d.text.FlowPage#validate()
			 **/
			public void validate() {
				try {
				super.validate ();
				} 
				catch (Exception e) {}
			}
		};
		_textFlow = new TextFlow ();
		_textFlow.setLayoutManager(new ParagraphTextLayout (_textFlow, ParagraphTextLayout.WORD_WRAP_SOFT));
		_flowPage.add (_textFlow);
		setLayoutManager (new StackLayout ());
		add (_flowPage);
	}
	
	
	/**
	 * 
	 * @see org.eclipse.draw2d.Figure#invalidate()
	 **/
	public void invalidate() {
		Dimension oldPrefSize = prefSize;
		super.invalidate ();
		prefSize = oldPrefSize;
	}
	
	public String getText () {
		return _textFlow.getText ();
	}
	
	public void setText (String text) {
		if (text == null || text == "") {
			_textFlow.setVisible (false);
			return;
		}
		_textFlow.setVisible (true);
		_textFlow.setText (text);
	}
}
