/*
 * Created on Jan 8, 2005
 *
 */
package AcmeStudioShapeExtension.figures;

import org.eclipse.draw2d.ColorConstants;
import org.eclipse.draw2d.Graphics;
import org.eclipse.draw2d.Shape;
import org.eclipse.draw2d.geometry.Rectangle;
import AcmeStudioShapeExtension.model.Annotation;
import AcmeStudioShapeExtension.model.EllipseAnnotation;
import AcmeStudioShapeExtension.model.RectangleAnnotation;
import AcmeStudioShapeExtension.model.RoundedRectangleAnnotation;


public class ShapeFeedbackFigure extends Shape {
	
	
	private final Annotation	_shape;

	/**
	 * 
	 */
	public ShapeFeedbackFigure(Annotation shape) {
		_shape = shape;
	}
	
	
	/**
	 * @param graphics
	 * @see org.eclipse.draw2d.Shape#fillShape(org.eclipse.draw2d.Graphics)
	 **/
	protected void fillShape(Graphics graphics) {
		Rectangle bounds = getBounds ().getCopy ();
		bounds.width -=1;
		bounds.height -=1;

	
		
		if (_shape instanceof RectangleAnnotation) {
			graphics.fillRectangle(bounds);
		}
		else if (_shape instanceof RoundedRectangleAnnotation) {
			graphics.fillRoundRectangle(bounds, 6, 6);
		}
		else if (_shape instanceof EllipseAnnotation) {
			graphics.fillOval(bounds);
		}
	}
	
	
	/**
	 * @param graphics
	 * @see org.eclipse.draw2d.Shape#outlineShape(org.eclipse.draw2d.Graphics)
	 **/
	protected void outlineShape(Graphics graphics) {
		Rectangle bounds = getBounds ().getCopy ();
		bounds.height -= 1;
		bounds.width -= 1;
		graphics.setXORMode(true);
		graphics.setForegroundColor(ColorConstants.white);
		graphics.setBackgroundColor(ColorConstants.black);
		graphics.setLineStyle(Graphics.LINE_DOT);
		
		graphics.setBackgroundColor(ColorConstants.black);
		
		if (_shape instanceof RectangleAnnotation) {
			graphics.drawRectangle(bounds);
		}
		else if (_shape instanceof RoundedRectangleAnnotation) {
			graphics.drawRoundRectangle(bounds, 6, 6);
		}
		else if (_shape instanceof EllipseAnnotation) {
			graphics.drawOval(bounds);
		}
}
	
}