/*******************************************************************************
 * Copyright (c) 2004 Elias Volanakis.
* All rights reserved. This program and the accompanying materials
* are made available under the terms of the Common Public License v1.0
* which accompanies this distribution, and is available at
* http://www.eclipse.org/legal/cpl-v10.html
*
* Contributors:
*Elias Volanakis - initial API and implementation
*******************************************************************************/
package AcmeStudioShapeExtension.model;

import org.eclipse.swt.graphics.Image;
import AcmeStudioShapeExtension.AcmeStudioShapeExtensionPlugin;

/**
 * An elliptical shape.
 * @author Elias Volanakis
 */
public class EllipseAnnotation extends Annotation {
/** A 16x16 pictogram of an elliptical shape. */
public static final Image ELLIPSE_ICON 
	= new Image(null, AcmeStudioShapeExtensionPlugin.class.getResourceAsStream("icons/ellipse16.gif"));

private static final long serialVersionUID = 1;

public Image getIcon() {
	return ELLIPSE_ICON;
}

public String toString() {
	return "Ellipse " + hashCode();
}

public EllipseAnnotation () {
	super ();
}
}
