/*
 * Created on Oct 12, 2004
 *
 */
package AcmeStudioShapeExtension.model.command;

import org.eclipse.gef.requests.CreateRequest;
import AcmeStudioShapeExtension.model.*;
import AcmeStudioShapeExtension.model.EllipseAnnotation;
import AcmeStudioShapeExtension.model.RectangleAnnotation;
import AcmeStudioShapeExtension.model.RoundedRectangleAnnotation;
import AcmeStudioShapeExtension.model.LabelAnnotation;


/**
 * @author Bradley Schmerl
 * Created Oct 12, 2004
 */
public class AnnotationCreateRequest extends CreateRequest {
	
	
	private final String	_type;

	/**
	 * 
	 */
	public AnnotationCreateRequest(String type) {
		super ();
		_type = type;
	}
	
	
	/**
	 * @return
	 * @see org.eclipse.gef.requests.CreateRequest#getNewObject()
	 **/
	public Object getNewObject() {
		if (_type.equals("Rectangle")) {
			RectangleAnnotation rectangle = new RectangleAnnotation ();
			return rectangle;
		}
		else if (_type.equals ("Ellipse")) {
			EllipseAnnotation ellipse = new EllipseAnnotation ();
			return ellipse;
		}
		else if (_type.equals ("RoundedRectangle")) {
			RoundedRectangleAnnotation rr = new RoundedRectangleAnnotation ();
			return rr;
		}
		else if (_type.equals ("Label")) {
			LabelAnnotation la = new LabelAnnotation ();
			la.setLabel("label");
			return la;
		}
		else if (_type.equals ("Note")) {
			NoteAnnotation na = new NoteAnnotation ();
			na.setLabel("note");
			return na;
		}
		else if (_type.equals ("Line")) {
			LineAnnotation line = new LineAnnotation ();
			return line;
		}
		return null;
	}
}
