/*
 * Created on Oct 12, 2004
 *
 */
package AcmeStudioShapeExtension.model.command;

import org.eclipse.gef.commands.Command;
import AcmeStudio.ui.editors.diagram.parts.SystemEditPart;
import AcmeStudioShapeExtension.AcmeStudioShapeExtensionPlugin;
import AcmeStudioShapeExtension.model.AcmeAnnotations;
import AcmeStudioShapeExtension.model.AnnotationElement;
import acmeLib.elements.AcmeSystem;


/**
 * @author Bradley Schmerl
 * Created Oct 12, 2004
 */
public class AnnotationDeleteCommand extends Command {

	private final SystemEditPart	_parent;
	private final AnnotationElement	_child;
	private boolean	_wasRemoved;

	/**
	 * @param part
	 * @param element
	 */
	public AnnotationDeleteCommand(SystemEditPart parent, AnnotationElement child) {
		if (parent == null || child == null) throw new IllegalArgumentException ();
		setLabel ("Delete annotation");
		_parent = parent;
		_child = child;
	}
	
	
	/**
	 * 
	 * @see org.eclipse.gef.commands.Command#execute()
	 **/
	public void execute() {
		redo ();
	}
	
	
	/**
	 * 
	 * @see org.eclipse.gef.commands.Command#redo()
	 **/
	public void redo() {
		AcmeAnnotations annotation = (AcmeAnnotations )((AcmeSystem )_parent.getModel ()). getUserData(AcmeStudioShapeExtensionPlugin.class);
		if (annotation == null) _wasRemoved = false;
		_wasRemoved = true;
		_wasRemoved = annotation.remove(_child);
		_parent.refresh ();
	}
	
	
	/**
	 * @return
	 * @see org.eclipse.gef.commands.Command#canUndo()
	 **/
	public boolean canUndo() {
		return _wasRemoved;
	}
	
	
	/**
	 * 
	 * @see org.eclipse.gef.commands.Command#undo()
	 **/
	public void undo() {
		AcmeAnnotations annotation = (AcmeAnnotations )((AcmeSystem )_parent.getModel()).getUserData(AcmeStudioShapeExtensionPlugin.class);
		annotation.add(_child);
		_parent.refresh ();
	}
	
}
