/*
 * Created on Oct 19, 2004
 *
 */
package AcmeStudioShapeExtension.model.command;

import org.eclipse.gef.commands.Command;
import AcmeStudioShapeExtension.model.LabelAnnotation;


/**
 * @author Bradley Schmerl
 * Created Oct 19, 2004
 */
public class LabelCommand extends Command {
	
	private final LabelAnnotation	_label;
	private final String	_newName;
	private String	_oldName;

	public LabelCommand (LabelAnnotation l, String s) {
		_label = l;
		if (s != null)
			_newName = s;
		else
			_newName = "";
		
	}
	
	
	/**
	 * 
	 * @see org.eclipse.gef.commands.Command#execute()
	 **/
	public void execute() {
		_oldName = _label.getLabel();
		_label.setLabel(_newName);
	}
	
	
	/**
	 * 
	 * @see org.eclipse.gef.commands.Command#undo()
	 **/
	public void undo() {
		_label.setLabel (_oldName);
	}
}
