/*
 * Created on Oct 20, 2004
 *
 */
package AcmeStudioShapeExtension.model.command;

import org.eclipse.gef.requests.LocationRequest;
import AcmeStudioShapeExtension.parts.LineEditPart;


/**
 * @author Bradley Schmerl
 * Created Oct 20, 2004
 */
public class LinePointRequest extends LocationRequest {
	private int index;
	private LineEditPart source;

	/**
	 * Returns the index of the bendpoint to be changed.
	 * @return the bendpoint index
	 */
	public int getIndex() {
		return index;
	}

	/**
	 * Returns the ConnectionEditPart that the bendpoint belongs to.
	 * @return the bendpoint's ConnectionEditPart
	 */
	public LineEditPart getSource() {
		return source;
	}

	/**
	 * Sets the index of the bendpoint to be changed.
	 * @param i the bendpoint's index
	 */
	public void setIndex(int i) {
		if (i != ChangeLineCommand.END && i != ChangeLineCommand.START) throw new IllegalArgumentException ();
		index = i;
	}

	/**
	 * Sets the ConnectionEditPart the bendpoint belongs to.
	 * @param s the bendpoint's ConnectionEditPart
	 */
	public void setSource(LineEditPart s) {
		source = s;
	}

}
