/*******************************************************************************
 * Copyright (c) 2000, 2003 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials 
 * are made available under the terms of the Common Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/cpl-v10.html
 * 
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/
package AcmeStudioShapeExtension.model.command;

import org.eclipse.draw2d.Bendpoint;
import AcmeStudioShapeExtension.model.LineBendpoint;

public class MoveLineBendpointCommand
	extends BendpointCommand 
{

private Bendpoint oldBendpoint;

public void execute() {
	LineBendpoint bp = new LineBendpoint();
	bp.setLocation (getLocation ());
//	bp.setRelativeDimensions(getFirstRelativeDimension(), 
//					getSecondRelativeDimension());
	setOldBendpoint((Bendpoint)getLine().getBendpoints().get(getIndex()));
	getLine().setBendpoint(getIndex(), bp);
	super.execute();
}

protected Bendpoint getOldBendpoint() {
	return oldBendpoint;
}

public void setOldBendpoint(Bendpoint bp) {
	oldBendpoint = bp;
}

public void undo() {
	super.undo();
	getLine().setBendpoint(getIndex(), getOldBendpoint());
}

}


