/*
 * Created on Oct 12, 2004
 *
 */
package AcmeStudioShapeExtension.model.command;

import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.GraphicalEditPart;
import org.eclipse.gef.commands.Command;
import AcmeStudioShapeExtension.model.Annotation;


/**
 * @author Bradley Schmerl
 * Created Oct 12, 2004
 */
public class SetAnnotationConstraintCommand extends Command {

	private final GraphicalEditPart	_part;
	private Annotation	_annotation;
	private Rectangle	_bounds;
	private Rectangle	_origBounds;

	/**
	 * @param part
	 */
	public SetAnnotationConstraintCommand(GraphicalEditPart part) {
		_part = part;
	}

	/**
	 * @param annotation
	 */
	public void setElement(Annotation annotation) {
		_annotation = annotation;
	}

	/**
	 * @param rectangle
	 */
	public void setLocation(Rectangle bounds) {
		_bounds = bounds;
	}
	
	
	/**
	 * @return
	 * @see org.eclipse.gef.commands.Command#canUndo()
	 **/
	public boolean canUndo() {
		return true;
	}
	
	
	/**
	 * 
	 * @see org.eclipse.gef.commands.Command#execute()
	 **/
	public void execute() {
		redo ();
	}
	
	
	/**
	 * 
	 * @see org.eclipse.gef.commands.Command#redo()
	 **/
	public void redo() {
		_origBounds = new Rectangle (_annotation.getLocation(), _annotation.getSize ());
		_annotation.setLocation(_bounds.getLocation ());
		_annotation.setSize (_bounds.getSize ());
	}
	
	
	/**
	 * 
	 * @see org.eclipse.gef.commands.Command#undo()
	 **/
	public void undo() {
		_annotation.setLocation (_origBounds.getLocation ());
		_annotation.setSize (_origBounds.getSize());
	}
}
