/*
 * Created on Jan 3, 2005
 *
 */
package AcmeStudioShapeExtension.parts;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import org.eclipse.draw2d.ConnectionAnchor;
import org.eclipse.draw2d.IFigure;
import org.eclipse.gef.ConnectionEditPart;
import org.eclipse.gef.NodeEditPart;
import org.eclipse.gef.Request;
import org.eclipse.gef.editparts.AbstractGraphicalEditPart;


/**
 * @author Bradley Schmerl
 * Created Jan 3, 2005
 */
public abstract class AnnotationEditPart extends AbstractGraphicalEditPart implements IAnnotationEditPart,PropertyChangeListener, NodeEditPart {

	/**
	 * @return
	 * @see org.eclipse.gef.editparts.AbstractGraphicalEditPart#createFigure()
	 **/
	abstract protected IFigure createFigure() ;

	/**
	 * 
	 * @see org.eclipse.gef.editparts.AbstractEditPart#createEditPolicies()
	 **/
	abstract protected void createEditPolicies() ;

	/**
	 * @param evt
	 * @see java.beans.PropertyChangeListener#propertyChange(java.beans.PropertyChangeEvent)
	 **/
	abstract public void propertyChange(PropertyChangeEvent evt);

	/**
	 * @param connection
	 * @return
	 * @see org.eclipse.gef.NodeEditPart#getSourceConnectionAnchor(org.eclipse.gef.ConnectionEditPart)
	 **/
	abstract public ConnectionAnchor getSourceConnectionAnchor(ConnectionEditPart connection) ;

	/**
	 * @param connection
	 * @return
	 * @see org.eclipse.gef.NodeEditPart#getTargetConnectionAnchor(org.eclipse.gef.ConnectionEditPart)
	 **/
	abstract public ConnectionAnchor getTargetConnectionAnchor(ConnectionEditPart connection);

	/**
	 * @param request
	 * @return
	 * @see org.eclipse.gef.NodeEditPart#getSourceConnectionAnchor(org.eclipse.gef.Request)
	 **/
	abstract public ConnectionAnchor getSourceConnectionAnchor(Request request);

	/**
	 * @param request
	 * @return
	 * @see org.eclipse.gef.NodeEditPart#getTargetConnectionAnchor(org.eclipse.gef.Request)
	 **/
	abstract public ConnectionAnchor getTargetConnectionAnchor(Request request);
}
