/*
 * Created on Oct 15, 2004
 *
 */
package AcmeStudioShapeExtension.parts;

import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.gef.tools.CellEditorLocator;
import org.eclipse.gef.tools.DirectEditManager;
import org.eclipse.jface.viewers.CellEditor;
import org.eclipse.jface.viewers.TextCellEditor;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.FontData;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Text;
import AcmeStudioShapeExtension.figures.IAnnotationTextProvider;


/**
 * @author Bradley Schmerl
 * Created Oct 15, 2004
 */
public class LabelEditManager extends DirectEditManager {

	Font scaledFont;
	/**
	 * @param part
	 * @param class1
	 * @param object
	 */
	public LabelEditManager(LabelEditPart source, Class editorType, CellEditorLocator locator) {
		super (source, editorType, locator);
	}
	
	/**
	 * 
	 * @see org.eclipse.gef.tools.DirectEditManager#initCellEditor()
	 **/
	protected void initCellEditor() {
		Text text = (Text )getCellEditor ().getControl ();
		
		IFigure label = (IFigure )getEditPart ().getFigure ();
		
		String initialLabelText = ((IAnnotationTextProvider )label).getText();
		getCellEditor ().setValue (initialLabelText);
		
		scaledFont = label.getFont ();
		FontData data = scaledFont.getFontData () [0];
		Dimension fontSize = new Dimension (0, data.getHeight ());
		label.translateToAbsolute(fontSize);
		data.setHeight(fontSize.height);
		scaledFont = new Font (null, data);
		
		text.setFont (scaledFont);
		text.selectAll ();
	}
	
	
	/**
	 * 
	 * @see org.eclipse.gef.tools.DirectEditManager#bringDown()
	 **/
	protected void bringDown() {
		Font disposeFont = scaledFont;
		scaledFont = null;
		super.bringDown ();
		if (disposeFont != null) 
			disposeFont.dispose ();
	}
	
	
	/**
	 * @param composite
	 * @return
	 * @see org.eclipse.gef.tools.DirectEditManager#createCellEditorOn(org.eclipse.swt.widgets.Composite)
	 **/
	protected CellEditor createCellEditorOn(Composite composite) {
		return new TextCellEditor (composite, SWT.MULTI | SWT.WRAP);
	}
}
