/*
 * Created on Oct 25, 2004
 *
 */
package AcmeStudioShapeExtension.parts;

import org.eclipse.draw2d.ConnectionAnchorBase;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.geometry.Point;


/**
 * @author Bradley Schmerl
 * Created Oct 25, 2004
 */
public class RelativeXYAnchor extends ConnectionAnchorBase {

	
	
	private final IFigure	_parent;
	private final Point	_location;

	/**
	 * 
	 */
	public RelativeXYAnchor(IFigure parent, Point location) {
		_parent = parent.getParent();
		_location = location.getCopy();
		
	}
	/**
	 * @param reference
	 * @return
	 * @see org.eclipse.draw2d.ConnectionAnchor#getLocation(org.eclipse.draw2d.geometry.Point)
	 **/
	public Point getLocation(Point reference) {
		Point copy = _location.getCopy ();
		if (reference != null)
		copy = reference.getCopy ();
		 _parent.translateToAbsolute(copy);
		 return _location;
	}

	/**
	 * @return
	 * @see org.eclipse.draw2d.ConnectionAnchor#getOwner()
	 **/
	public IFigure getOwner() {
		return _parent;
	}

	/**
	 * @return
	 * @see org.eclipse.draw2d.ConnectionAnchor#getReferencePoint()
	 **/
	public Point getReferencePoint() {
		return getLocation (_location);
//		return _location;
	}
}
