/*
 * Created on Oct 19, 2004
 *
 */
package AcmeStudioShapeExtension.policies;

import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.DirectEditPolicy;
import org.eclipse.gef.requests.DirectEditRequest;
import AcmeStudioShapeExtension.figures.IAnnotationTextProvider;
import AcmeStudioShapeExtension.model.LabelAnnotation;
import AcmeStudioShapeExtension.model.command.LabelCommand;
import AcmeStudioShapeExtension.parts.LabelEditPart;


/**
 * @author Bradley Schmerl
 * Created Oct 19, 2004
 */
public class LabelDirectEditPolicy extends DirectEditPolicy {

	/**
	 * @param request
	 * @return
	 * @see org.eclipse.gef.editpolicies.DirectEditPolicy#getDirectEditCommand(org.eclipse.gef.requests.DirectEditRequest)
	 **/
	protected Command getDirectEditCommand(DirectEditRequest request) {
		String labelText = (String )request.getCellEditor().getValue ();
		LabelEditPart labelEP = (LabelEditPart )getHost ();
		LabelCommand command = new LabelCommand ((LabelAnnotation )labelEP.getModel (), labelText);
		return command;
	}

	/**
	 * @param request
	 * @see org.eclipse.gef.editpolicies.DirectEditPolicy#showCurrentEditValue(org.eclipse.gef.requests.DirectEditRequest)
	 **/
	protected void showCurrentEditValue(DirectEditRequest request) {
		String value = (String )request.getCellEditor().getValue ();
		((IAnnotationTextProvider )getHostFigure()).setText(value);
		getHostFigure ().getUpdateManager().performUpdate ();
	}
}
