/*
 * Created on Oct 21, 2004
 *
 */
package AcmeStudioShapeExtension.policies;

import org.eclipse.draw2d.Connection;
import org.eclipse.draw2d.geometry.Point;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.BendpointEditPolicy;
import org.eclipse.gef.requests.BendpointRequest;
import AcmeStudioShapeExtension.model.LineAnnotation;
import AcmeStudioShapeExtension.model.command.CreateLineBendpointCommand;
import AcmeStudioShapeExtension.model.command.DeleteLineBendpointCommand;
import AcmeStudioShapeExtension.model.command.MoveLineBendpointCommand;


/**
 * @author Bradley Schmerl
 * Created Oct 21, 2004
 */
public class LineBendpointEditPolicy extends BendpointEditPolicy {

	/**
	 * @param request
	 * @return
	 * @see org.eclipse.gef.editpolicies.BendpointEditPolicy#getCreateBendpointCommand(org.eclipse.gef.requests.BendpointRequest)
	 **/
	protected Command getCreateBendpointCommand(BendpointRequest request) {
		CreateLineBendpointCommand comm = new CreateLineBendpointCommand ();
		Point p = request.getLocation ();
		Connection conn = getConnection ();
		
		conn.getParent ().translateToRelative (p);
		
		comm.setLocation (p);
		
		LineAnnotation lineAnnotation = (LineAnnotation )request.getSource ().getModel ();
		Point ref1 = lineAnnotation.getStart().getCopy ();
		Point ref2 = lineAnnotation.getEnd ().getCopy ();
		conn.getParent ().translateToAbsolute (ref1);
		conn.getParent ().translateToAbsolute (ref2);
		
//		Point ref1 = getConnection ().getSourceAnchor ().getLocation (null);
//		Point ref2 = getConnection ().getTargetAnchor().getLocation (null);
		
		conn.getParent ().translateToRelative (ref1);
		conn.getParent ().translateToRelative(ref2);
		
//		comm.setRelativeDimensions (p.getDifference (ref1), p.getDifference (ref2));
		comm.setLine (lineAnnotation);
		comm.setIndex (request.getIndex ());
		
		return comm;
	}

	/**
	 * @param request
	 * @return
	 * @see org.eclipse.gef.editpolicies.BendpointEditPolicy#getDeleteBendpointCommand(org.eclipse.gef.requests.BendpointRequest)
	 **/
	protected Command getDeleteBendpointCommand(BendpointRequest request) {
		DeleteLineBendpointCommand comm = new DeleteLineBendpointCommand ();
		Point p = request.getLocation();
		comm.setLocation (p);
		comm.setLine ((LineAnnotation )request.getSource ().getModel ());
		comm.setIndex (request.getIndex ());
		return comm;
	}

	/**
	 * @param request
	 * @return
	 * @see org.eclipse.gef.editpolicies.BendpointEditPolicy#getMoveBendpointCommand(org.eclipse.gef.requests.BendpointRequest)
	 **/
	protected Command getMoveBendpointCommand(BendpointRequest request) {
		MoveLineBendpointCommand comm = new MoveLineBendpointCommand ();
		Point p = request.getLocation ();
		Connection conn = getConnection ();
		conn.translateToRelative (p);
		comm.setLocation (p);
		LineAnnotation lineAnnotation = (LineAnnotation )request.getSource ().getModel ();
		Point ref1 = lineAnnotation.getStart().getCopy ();
		Point ref2 = lineAnnotation.getEnd ().getCopy ();
		conn.getParent ().translateToAbsolute (ref1);
		conn.getParent ().translateToAbsolute (ref2);
		conn.getParent ().translateToRelative (ref1);
		conn.getParent ().translateToRelative (ref2);
//		comm.setRelativeDimensions (p.getDifference (ref1), p.getDifference (ref2));
		comm.setLine (lineAnnotation);
		comm.setIndex (request.getIndex ());
		return comm;
		
//		return null;
//		MoveLineBendpointCommand com = new MoveLineBendpointCommand ();
//		Point p = request.getLocation ();
//		Connection conn = getConnection ();
//		
//		conn.translateToRelative(p);
//		com.setLocation (p);
//		
//		Point ref1 = getConnection ().getSourceAnchor ().getReferencePoint ();
//		Point ref2 = getConnection ().getTargetAnchor ().getReferencePoint();
//		
//		conn.translateToRelative(ref1);
//		conn.translateToRelative(ref2);
//		
//		com.setRelativeDimensions (p.getDifference (ref1), p.getDifference (ref2));
//		com.setLine ((LineAnnotation )request.getSource ().getModel ());
//		com.setIndex (request.getIndex ());
//		return com;
	}
	
	

}
