/*
 * Created on Oct 12, 2004
 *
 */
package AcmeStudioShapeExtension.policies;

import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.ComponentEditPolicy;
import org.eclipse.gef.requests.GroupRequest;
import AcmeStudio.ui.editors.diagram.parts.SystemEditPart;
import AcmeStudioShapeExtension.model.AnnotationElement;
import AcmeStudioShapeExtension.model.command.AnnotationDeleteCommand;


/**
 * @author Bradley Schmerl
 * Created Oct 12, 2004
 */
public class ShapeComponentEditPolicy extends ComponentEditPolicy {
	
	
	/**
	 * @param deleteRequest
	 * @return
	 * @see org.eclipse.gef.editpolicies.ComponentEditPolicy#createDeleteCommand(org.eclipse.gef.requests.GroupRequest)
	 **/
	protected Command createDeleteCommand(GroupRequest deleteRequest) {
		Object parent = getHost ().getParent ();
		Object child = getHost ().getModel ();
		if (parent instanceof SystemEditPart && child instanceof AnnotationElement) {
			return new AnnotationDeleteCommand ((SystemEditPart )parent, (AnnotationElement )child);
		}
		return super.createDeleteCommand (deleteRequest);
	}
}
