/*
 * Created on Oct 11, 2004
 *
 */
package AcmeStudioShapeExtension.views;

import org.eclipse.gef.dnd.TemplateTransfer;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.swt.dnd.DragSource;
import org.eclipse.swt.dnd.DragSourceEvent;
import org.eclipse.swt.dnd.DragSourceListener;
import org.eclipse.swt.dnd.Transfer;
import org.eclipse.ui.part.PluginTransferData;


/**
 * @author Bradley Schmerl
 * Created Oct 11, 2004
 */
public class AnnotationDragListener implements DragSourceListener {

	private final AnnotationPaletteView	_view;

	/**
	 * @param view
	 */
	public AnnotationDragListener(AnnotationPaletteView view) {
		_view = view;
	}

	/**
	 * @param event
	 * @see org.eclipse.swt.dnd.DragSourceListener#dragStart(org.eclipse.swt.dnd.DragSourceEvent)
	 **/
	public void dragStart(DragSourceEvent event) {
		Transfer [] transfers = new Transfer [1];
		TemplateTransfer tt = TemplateTransfer.getInstance ();
		tt.setObject (new PluginTransferData (AnnotationDropAction.ID, null));
		transfers [0] = tt;
		((DragSource )event.getSource ()).setTransfer (transfers);
	}

	/**
	 * @param event
	 * @see org.eclipse.swt.dnd.DragSourceListener#dragSetData(org.eclipse.swt.dnd.DragSourceEvent)
	 **/
	public void dragSetData(DragSourceEvent event) {
		Transfer [] transfers  = new Transfer [1];
		TemplateTransfer tt = TemplateTransfer.getInstance ();
		StructuredSelection ss = (StructuredSelection )_view.getSelection ();
		String name = (String )ss.getFirstElement ();
		byte [] segmentData = name.getBytes ();
		event.data = new PluginTransferData (AnnotationDropAction.ID, segmentData);
		tt.setObject (event.data);
		transfers [0] = tt;
		((DragSource )event.widget).setTransfer (transfers);
	}

	/**
	 * @param event
	 * @see org.eclipse.swt.dnd.DragSourceListener#dragFinished(org.eclipse.swt.dnd.DragSourceEvent)
	 **/
	public void dragFinished(DragSourceEvent event) {
	}
}
