/*
 * Created on Oct 11, 2004
 *
 */
package AcmeStudioShapeExtension.views;

import java.util.List;
import org.eclipse.draw2d.geometry.Point;
import org.eclipse.gef.GraphicalEditPart;
import org.eclipse.gef.editparts.ScalableFreeformRootEditPart;
import org.eclipse.ui.part.IDropActionDelegate;
import AcmeStudio.ui.editors.diagram.parts.SystemEditPart;
import acmeLib.elements.AcmeSystem;


/**
 * @author Bradley Schmerl
 * Created Oct 11, 2004
 */
public class AnnotationDropAction implements IDropActionDelegate {

	public static final String ID = "annotation_drop_actions";
	/**
	 * @param source
	 * @param target
	 * @return
	 * @see org.eclipse.ui.part.IDropActionDelegate#run(java.lang.Object, java.lang.Object)
	 **/
	public boolean run(Object source, Object target) {
		if (source instanceof byte [] && target instanceof List) {
			List list = (List )target;
			Object o = list.get (0);
			SystemEditPart sep = null;
			if (o instanceof SystemEditPart) sep = (SystemEditPart )o;
			else if (o instanceof ScalableFreeformRootEditPart) sep = (SystemEditPart )((ScalableFreeformRootEditPart )o).getContents();
			else if (o instanceof GraphicalEditPart) {
				GraphicalEditPart gep = (GraphicalEditPart )o;
				ScalableFreeformRootEditPart sfp = (ScalableFreeformRootEditPart )gep.getRoot();
				sep = (SystemEditPart )((ScalableFreeformRootEditPart )o).getContents();
			}
			String name = new String ((byte [] )source);
			AcmeSystem system = (AcmeSystem )sep.getModel ();
			Point location = (Point )list.get (1);
			sep.getFigure().translateToRelative(location);
			
			AnnotationPaletteView.createAnnotation (name, system, location);
			return true;
		}
		return false;
	}
}
