/*
 * Created on Jul 8, 2003
 */
package AcmeTranslator.wizards;

import java.util.List;

import org.eclipse.core.resources.IFile;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.jface.wizard.Wizard;
import org.eclipse.ui.IExportWizard;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.ide.IDE;

import AcmeStudio.core.ASContext;

/**
 * @author Bradley Schmerl
 * 
 * Implements the wizard for exporting Acme files to XML
 */
public class XMLExportWizard extends Wizard implements IExportWizard {

	private IWorkbench _workbench;
	private IStructuredSelection _selection;
	private XMLExportFileSystemResourcePage1 _mainPage;

	/* (non-Javadoc)
	 * @see org.eclipse.jface.wizard.IWizard#performFinish()
	 */
	public boolean performFinish() {
		return _mainPage.finish ();
	}

	/* (non-Javadoc)
	 * @see org.eclipse.ui.IWorkbenchWizard#init(org.eclipse.ui.IWorkbench, org.eclipse.jface.viewers.IStructuredSelection)
	 */
	public void init(IWorkbench workbench, IStructuredSelection selection) {
		_workbench = workbench;
		_selection = null;
		List selectedResources = IDE.computeSelectedResources(selection);
		if (!selectedResources.isEmpty ()) 
			_selection = new StructuredSelection (selectedResources);
		else {
			try {
			Object file = ASContext.current ().getActiveEditor ().getDesign ().getFile ();
			if (file instanceof IFile) {
				_selection = new StructuredSelection (file);
			}
			}
			catch (NullPointerException e) {
				// Do nothing
			}
		}
		setWindowTitle ("Export Acme to XML");
		setNeedsProgressMonitor (true);
	}

	/* (non-Javadoc)
	 * @see org.eclipse.jface.wizard.IWizard#addPages()
	 */
	public void addPages() {
		super.addPages();
		_mainPage = new XMLExportFileSystemResourcePage1 (_selection);
		addPage (_mainPage);
		
	}

}
