/*
 * Created on Jul 7, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package AcmeTranslator.wizards;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.FactoryConfigurationError;
import javax.xml.parsers.ParserConfigurationException;
import org.eclipse.core.resources.*;
import org.eclipse.core.runtime.IPath;
import org.eclipse.core.runtime.Path;
import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.*;
import org.eclipse.ui.dialogs.ContainerSelectionDialog;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.xml.sax.SAXException;
import AcmeStudio.AcmeStudioPlugin;
import AcmeStudio.core.ASContext;
import AcmeStudio.core.resource.ASDesign;
import acme.translators.ADMLImporter;
import acme.translators.XAcmeImporter;

/**
 * @author Bradley Schmerl
 * 
 * The page to handle import options
 */
public class XMLImportWizardPage extends WizardPage {

	protected boolean _mustImportFamiliesToo = true;
	private Document _xmlDocument;
	private DocumentBuilder parser;
	private Button _btnImportFamiliesToo;
	private Button _btnResolveReferencesInProject;
	private Group _familiesGroup;
	private boolean _needToRefreshXMLFile;
	// Widgets containing the options
	private Text _txtImportName;
	private Text _txtContainer;
	private Text _txtAcmeName;
	private IStructuredSelection selection;
	IProject _project;
	/**
	 * @param pageName
	 */
	protected XMLImportWizardPage(IStructuredSelection selection) {
		super("Details");
		_project = ASContext.current ().getActiveProject ();
		try {
			parser = DocumentBuilderFactory.newInstance().newDocumentBuilder();
		}
		catch (ParserConfigurationException e) {
			e.printStackTrace();
		}
		catch (FactoryConfigurationError e) {
			e.printStackTrace();
		}
	}

	/* (non-Javadoc)
	 * @see org.eclipse.jface.dialogs.IDialogPage#createControl(org.eclipse.swt.widgets.Composite)
	 */
	public void createControl(Composite parent) {
		Composite container = new Composite (parent, SWT.NULL);
		GridLayout layout = new GridLayout (3, false);
		container.setLayout (layout);
		Label cLabel = new Label (container, SWT.NULL);
		cLabel.setText ("&Container:");
		
		_txtContainer = new Text (container, SWT.BORDER | SWT.SINGLE);
		_txtContainer.setLayoutData (new GridData (GridData.FILL_HORIZONTAL));
		_txtContainer.addModifyListener (new ModifyListener () {
			public void modifyText (ModifyEvent e) {
				dialogChanged ();	
			}
		});
		
		
		Button btnBrowse = new Button (container, SWT.PUSH);
		btnBrowse.setText ("&Browse...");
		btnBrowse.addSelectionListener (new SelectionAdapter () {
			public void widgeSelected (SelectionEvent e) {
				handleBrowse ();	
				
			}
		});
		
		Label oLabel = new Label (container, SWT.NULL);
		oLabel.setText ("&Import file:");
		
		_txtImportName = new Text (container, SWT.BORDER | SWT.SINGLE);
		_txtImportName.setLayoutData (new GridData (GridData.FILL_HORIZONTAL));
		_txtImportName.addModifyListener(new ModifyListener () {
			public void modifyText (ModifyEvent e) {
				_needToRefreshXMLFile = true;
				dialogChanged ();
			}
		});
		
		Button btnImportName = new Button (container, SWT.PUSH);
		btnImportName.setText ("Browse...");
		btnImportName.addSelectionListener(new SelectionAdapter () {
			public void widgetSelected (SelectionEvent evt) {
				handleBrowseImport ();
			}
		});
		
		Label acmeLabel = new Label (container, SWT.NONE);
		acmeLabel.setText ("&Acme name:");
		_txtAcmeName = new Text (container, SWT.BORDER | SWT.SINGLE);
		_txtAcmeName.setLayoutData (new GridData (GridData.FILL_HORIZONTAL));
		_txtAcmeName.addModifyListener(new ModifyListener () {
		public void modifyText (ModifyEvent e) {
			dialogChanged ();
		}
	});
		// for space
		new Label (container, SWT.NONE);
		
		_familiesGroup = new Group (container, SWT.NONE);
		_familiesGroup.setText ("Imported family actions:");
		_familiesGroup.setLayout(new FillLayout (SWT.VERTICAL));
		_familiesGroup.setVisible (false);
		GridData gd = new GridData ();
		gd.horizontalSpan = GridData.FILL;
		_familiesGroup.setLayoutData(gd);
		
		Label familyLabel = new Label (_familiesGroup, SWT.NONE);
		familyLabel.setText ("The XML file contains references to other families. Please choose one of the following options");
		_btnResolveReferencesInProject = new Button (_familiesGroup, SWT.RADIO);
		_btnResolveReferencesInProject.setText ("Ignore referenced families and try to resolve in existing project");
		_btnResolveReferencesInProject.setSelection(false);
		_btnResolveReferencesInProject.addSelectionListener(new SelectionAdapter () {
			public void widgetSelected (SelectionEvent evt) {
				_mustImportFamiliesToo = !_btnResolveReferencesInProject.getSelection();
			}
		});
		
		_btnImportFamiliesToo = new Button (_familiesGroup, SWT.RADIO);
		_btnImportFamiliesToo.setText("Import all referenced families, overwriting existing families.");
		_btnImportFamiliesToo.setSelection(true);
		_btnImportFamiliesToo.addSelectionListener(new SelectionAdapter () {
			public void widgetSelected (SelectionEvent evt) {
				_mustImportFamiliesToo = _btnImportFamiliesToo.getSelection();
			}
		});		
		
		initialize ();
		dialogChanged ();
		setControl (container);
	}

	/**
	 * Handles browsing to a file to import
	 */
	protected void handleBrowseImport() {
		FileDialog dialog = new FileDialog (getShell (), SWT.OPEN);
		dialog.setFilterExtensions(new String [] {"*.xml"});
		String filename = dialog.open ();
		if (filename != null) {
			_txtImportName.setText (filename);
		}
		
		
	}

	/**
	 * Checks validity of options
	 */
	protected void dialogChanged() {
		String container = _txtContainer.getText ();
		String filename = _txtImportName.getText ();
		
		if (container.length () == 0) {
			updateStatus ("Target project must be specified");
			return;
		}
		if (filename.length () == 0) {
			updateStatus ("Must specify file to import");
			return;
		}
	
		IPath contPath = new Path (container);
		if (contPath.segmentCount() == 0) return;
		IContainer cont = AcmeStudioPlugin.getRoot ().getProject(contPath.segment (0));
		if (cont == null || !cont.exists ()) {
			updateStatus ("The project \"" + contPath.segment (0) + "\" does not exist");
			return;
		}
		else {
			ASContext.current ().setActiveProject (cont.getProject());
			
		}
//		IFile f = cont.getFile (new Path (filename));
		File f = new File (filename);
		if (!f.exists ()) {
			updateStatus ("File " + f.getAbsolutePath() + " does not exist.");
			return;
		}
		
		if (_needToRefreshXMLFile) {
			_needToRefreshXMLFile = false;
			try {
				FileInputStream is = new FileInputStream (f);

				_xmlDocument = parser.parse (is);
				Element design = _xmlDocument.getDocumentElement ();
				if (!isXAcme (design) && !isADML (design)) {
					updateStatus ("File " + f.getAbsolutePath() + " is not valid xAcme or ADML");
					return;
				}
				if (isXAcme (design) && XAcmeImporter.referencesFamilies (design)) {
					_familiesGroup.setVisible (true);
				}
				if (isADML (design) && ADMLImporter.referencesFamilies (design)) {
					_familiesGroup.setVisible (true);
				}
			} catch (FileNotFoundException e) {
				updateStatus ("File " + f.getAbsolutePath() + " could not be found.");
				return;
			} catch (SAXException e) {
				updateStatus ("File " + f.getAbsolutePath() + " does not seem to be valid XML");
				return;
			} catch (IOException e) {
				updateStatus (e.getMessage ());
				return;
			}
			

		}
		if (_txtAcmeName.getText ().length () == 0) {
			updateStatus ("Enter an Acme name to import as");
			return;
		}
		IFile af = cont.getFile (new Path (_txtAcmeName.getText () + "." + ASDesign.FILE_EXT));
		if (af.exists ()) {
			updateStatus ("File " + af.getFullPath() + " already exists.");
			return;
		}
		updateStatus (null);
		
	}
	public boolean isXAcme(Element design) {
		String xAcmeTest = design.getAttribute ("xmlns:families");
		return  xAcmeTest != null && xAcmeTest.equals (XAcmeImporter.FAMILY_NS);
	}

	public boolean isADML (Element design) {
		return design.getNodeName().equals ("Design");
	
	}
	/**
	 * @param object
	 */
	private void updateStatus(String message) {
		setErrorMessage(message);
		setPageComplete(message == null);
		
	}

	/**
	 * 
	 */
	private void initialize() {
		IProject proj = ASContext.current ().getActiveProject ();
		if (proj != null) {
			_txtContainer.setText (proj.getFullPath().toString());
		}
		if (selection != null && !selection.isEmpty () ) {
			if (selection.size() > 1) return;
			Object obj = selection.getFirstElement();
			if (obj instanceof IResource) {
				IContainer container;
				if (obj instanceof IContainer) {
					container = (IContainer )obj;
				}
				else {
					container = ((IResource )obj).getParent ();
				}
				_txtContainer.setText (container.getFullPath().toString());
			}
		}
	}

	/**
	 * 
	 */
	protected void handleBrowse() {
		ContainerSelectionDialog dialog = new ContainerSelectionDialog (getShell(), ResourcesPlugin.getWorkspace().getRoot(), false, "Select new container");
		if (dialog.open () == IDialogConstants.OK_ID) {
			Object [] result = dialog.getResult ();
			if (result.length == 1) {
				Object obj = result [0];
				if (obj instanceof Path) {
					Path path = (Path )obj;
					_txtContainer.setText (path.toString ());
				}
				else if (obj instanceof IContainer) {
					IContainer container = (IContainer )result [0];
					_txtContainer.setText (container.getFullPath().toString());
				}
			}
		}
		
	}

	/**
	 * @return
	 */
	public String getContainerName() {
		if (_txtContainer != null) {
			return _txtContainer.getText ();
		}
		return null;
	}

	/**
	 * @return
	 */
	public String getFileName() {
		if (_txtImportName != null) {
			return _txtImportName.getText ();
		}
		return null;
	}

	public String getAcmeFilename () {
		if (_txtAcmeName != null) {
			return _txtAcmeName.getText () + "." + ASDesign.FILE_EXT;
		}
		return null;
	}
	/**
	 * @return
	 */
	public Document getXmlDocument() {
		return _xmlDocument;
	}

	public boolean mustImportFamilies () {
		return _mustImportFamiliesToo;
	}

}
