package acme.translators.RoseRTTypes;

/**
 * Class: RoseRTBoolean <br>
 * Purpose: Provides a boolean object with static methods for printing
 *   boolean value according to Petal format (all caps). <br>
 * <br>
 * Revision History: <br>
 *   Date    Person    Change: <br>
 * 5/23/01    SWC      Created initial version <br>
 * <br>
 * Known bugs/omissions:<br>
 *   - <br>
 * @author Owen Cheng (SWC)
 */

public class RoseRTBoolean extends RoseRTObject {

    private boolean value;

    /**
     * Default class constructor.
     */
    public RoseRTBoolean() {
	super();

	this.value = false;
    }

    /**
     * Class constructor for initializing boolean value.
     *
     * @param value initial boolean value
     */
    public RoseRTBoolean(boolean value) {
	super();
	this.value = value;
    }

    /**
     * Returns this boolean value.
     *
     * @return boolean
     */
    public boolean getBoolean() {
	return this.value;
    }

    /**
     * Sets this boolean value.
     *
     * @param value boolean value to set to
     */
    public void setBoolean(boolean value) {
	this.value = value;
    }

    /**
     * Returns this boolean value as an all-cap string.
     *
     * @return String
     */
    public String toString() {
	if (this.value) {
	    return "TRUE";
	} else {
	    return "FALSE";
	}
    }
}
