package acme.translators.RoseRTTypes;

/**
 * Class: RoseRTCapsuleRoleRelVw <br>
 * Purpose: Provides a Rose RT capsule role relationship view object. <br>
 * <br>
 * Revision History: <br>
 *   Date    Person    Change: <br>
 * 5/25/01    SWC      Created initial version <br>
 * <br>
 * Known bugs/omissions:<br>
 *   - <br>
 * @author Owen Cheng (SWC)
 */

public class RoseRTCapsuleRoleRelVw extends RoseRTInheritVw {

    static private final String OBJ = "CapsuleRoleRelVw";

    protected RoseRTSegLabel objLabel2 = null;

    /**
     * Default class constructor.
     */
    public RoseRTCapsuleRoleRelVw() {
	super();

	this.setType(OBJ);
    }

    /**
     * Class constructor for initializing name.
     *
     * @param name the given name of this object
     */
    public RoseRTCapsuleRoleRelVw(String name) {
	this();

	this.setName(name);
    }

    /**
     * Returns the second label of this View object.
     *
     * @return RoseRTSegLabel
     */
    public RoseRTSegLabel getObjLabel2() {
	return this.objLabel2;
    }

    /**
     * Sets the second label of this View object.
     *
     * @param objLabel new label to set to
     */
    public void setObjLabel2(RoseRTSegLabel objLabel) {
	this.objLabel2 = objLabel;
    }

    /**
     * Returns the string representation of this object, basically generating
     * all the content.
     *
     * @param leftMarg amount of spaces to indent for all lines
     * @param indIncr amount of increment spaces to indent for subsequent lines
     * @return String
     */
    public String toString(int leftMarg, int indIncr) {
	String str = "";
	int ind = leftMarg + indIncr;
	String verStr = vertices.toString(ind, indIncr);
	str += Util.indent(leftMarg) + "(object " + this.getType() + " \""
	    + this.getName() + "\" @" + this.getID() +
	    "\n" + Util.indent(ind) + "uses_fill_color "
	    + Util.printBool(usesFillColor) +
	    ((objLabel != null) ?
	     ("\n" + objLabel.toString(ind, indIncr)) : "") +
	    "\n" + Util.indent(ind) + "positionBySuperclass "
	    + Util.printBool(positionBySuperclass) +
	    "\n" + Util.indent(ind) + "client @" + client +
	    "\n" + Util.indent(ind) + "supplier @" + supplier +
	    (verStr.equals("") ? "" : ("\n" + verStr)) +
	    "\n" + Util.indent(ind) + "line_style " + lineStyle +
	    ((orig.isSet()) ? ("\n" + Util.indent(ind) + "origPos "
			       + getOrigPos().toString()) : "") +
	    ((term.isSet()) ? ("\n" + Util.indent(ind) + "termPos "
			       + getTermPos().toString()) : "") +
	    ((objLabel2 != null) ?
	     ("\n" + objLabel2.toString(ind, indIncr)) : "") +
	    ")";

	return str;
    }

    /**
     * Returns the string representation of this object, basically generating
     * all the content.
     *
     * @return String
     */
    public String toString() {
	return this.toString(0, 8);
    }
}
