package acme.translators.RoseRTTypes;

/**
 * Class: RoseRTConnectionPtVw <br>
 * Purpose: Provides a Rose RT connection point view object. <br>
 * <br>
 * Revision History: <br>
 *   Date    Person    Change: <br>
 * 5/23/01    SWC      Created initial version <br>
 * <br>
 * Known bugs/omissions:<br>
 *   - <br>
 * @author Owen Cheng (SWC)
 */

public class RoseRTConnectionPtVw extends RoseRTView {

    static private final String OBJ = "ConnectionPtVw";

    /**
     * Default class constructor.
     */
    public RoseRTConnectionPtVw() {
	super();

	this.setType(OBJ);
    }

    /**
     * Class constructor for initializing name.
     *
     * @param name the given name of this object
     */
    public RoseRTConnectionPtVw(String name) {
	this();

	this.setName(name);
    }

    /**
     * Returns the string representation of this object, basically generating
     * all the content.
     *
     * @param leftMarg amount of spaces to indent for all lines
     * @param indIncr amount of increment spaces to indent for subsequent lines
     * @return String
     */
    public String toString(int leftMarg, int indIncr) {
	String str = "";
	int ind = leftMarg + indIncr;
	str += Util.indent(leftMarg) + "(object " + this.getType() + " \""
	    + this.getName() + "\" @" + this.getID() +
	    ((isSet()) ?
	     ("\n" + Util.indent(ind) + "pos " + getPos().toString()) : "") +
	    ((objLabel != null) ?
	     ("\n" + objLabel.toString(ind, indIncr)) : "") +
	    "\n" + Util.indent(ind) + "positionBySuperclass "
	    + Util.printBool(positionBySuperclass) +
	    ")";

	return str;
    }

    /**
     * Returns the string representation of this object, basically generating
     * all the content.
     *
     * @return String
     */
    public String toString() {
	return this.toString(0, 8);
    }
}
