package acme.translators.RoseRTTypes;

/**
 * Class: RoseRTInheritanceRel <br>
 * Purpose: Provides a Rose RT inheritance relationship object. <br>
 * <br>
 * Revision History: <br>
 *   Date    Person    Change: <br>
 * 5/25/01    SWC      Created initial version <br>
 * <br>
 * Known bugs/omissions:<br>
 *   - <br>
 * @author Owen Cheng (SWC)
 */

public class RoseRTInheritanceRel extends RoseRTObject {

    static private final String OBJ = "Inheritance_Relationship";

    protected String supplier = null;

    /**
     * Default class constructor.
     */
    public RoseRTInheritanceRel() {
	super();

	this.setType(OBJ);
    }

    /**
     * Returns the supplier of this relationship.
     *
     * @return String
     */
    public String getSupplier() {
	return this.supplier;
    }

    /**
     * Sets the supplier of this relationship.
     *
     * @param name supplier name to avoid into
     */
    public void setSupplier(String name) {
	this.supplier = name;
    }

    /**
     * Returns the string representation of this object, basically generating
     * all the content.
     *
     * @param leftMarg amount of spaces to indent for all lines
     * @param indIncr amount of increment spaces to indent for subsequent lines
     * @return String
     */
    public String toString(int leftMarg, int indIncr) {
	String str = "";
	int ind = leftMarg + indIncr;
	str += Util.indent(leftMarg) + "(object " + this.getType() +
	    "\n" + Util.indent(ind) + "supplier \"" + supplier + "\"" +
	    ")";

	return str;
    }

    /**
     * Returns the string representation of this object, basically generating
     * all the content.
     *
     * @return String
     */
    public String toString() {
	return this.toString(0, 8);
    }
}
