package acme.translators.RoseRTTypes;

/**
 * Class: RoseRTString <br>
 * Purpose: Provides a Rose RT string object. <br>
 * <br>
 * Revision History: <br>
 *   Date    Person    Change: <br>
 * 5/25/01    SWC      Created initial version <br>
 * <br>
 * Known bugs/omissions:<br>
 *   - <br>
 * @author Owen Cheng (SWC)
 */

public class RoseRTString extends RoseRTObject {

    private String str = null;

    /**
     * Default class constructor.
     */
    public RoseRTString() {
	super();
    }

    /**
     * Class constructor for initializing this string.
     *
     * @param str the string to initialize to
     */
    public RoseRTString(String str) {
	this();

	this.str = str;
    }

    /**
     * Sets this string to a different one.
     *
     * @param str new string to set to
     */
    public void setString(String str) {
	this.str = str;
    }

    /**
     * Returns the string representation of this object.
     *
     * @param leftMarg amount of spaces to indent for all lines
     * @param indIncr amount of increment spaces to indent for subsequent lines
     * @return String
     */
    public String toString(int leftMarg, int indIncr) {
	String tstr = "";
	tstr += Util.indent(leftMarg) + this.str;
	return tstr;
    }

    /**
     * Returns the string representation of this object.
     *
     * @return String
     */
    public String toString() {
	return this.toString(0, 8);
    }
}
