package acmeLib;
// import java.awt.*;
import java.io.IOException;
import acmeLib.core.globals.*;
import acmeLib.core.container.*;
import acmeLib.properties.*;

public class AcmeLib {

    public static void main(String args[]) {
        System.out.println("simple console application");
        System.out.println("");

        // test the CategoryT enumerated type
        testCategory(CategoryT.ACME_UNKNOWN_CATEGORY);
        testCategory(CategoryT.ACME_SYSTEM);
        testCategory(CategoryT.ACME_PORT);

        System.out.println("");

        testPropertyCategory(PropertyCategoryT.ACME_UNKNOWN_PROPERTY_CATEGORY);
        testPropertyCategory(PropertyCategoryT.ACME_SET);
        testPropertyCategory(PropertyCategoryT.ACME_SEQUENCE);

        System.out.println("");
        System.out.println("Testing enumerations.");
        AcmeEnumeration e1 = new AcmeEnumeration();
        AcmeEnumeration e2 = new AcmeEnumeration();
        // add five items to e1 and ten items to e2 to start with:
        for (int i = 0; i < 4; i++) {
            e1.insertItem(new AcmeInt(i));
        };

        for (int i = 10; i < 25; i++) {
            e2.insertItem(new AcmeInt(i));
        };

        System.out.println(" e1 = " + e1.toString());
        System.out.println(" e2 = " + e2.toString());

        System.out.println("");
        System.out.println("Testing concatentation.  concatenating e1 to e1.");
        e1.concatenate(e1);
        System.out.println(" e1 = " + e1.toString());
        System.out.println(" e2 = " + e2.toString());

        System.out.println("");
        System.out.println("Testing concatentation again.  concatenating e2 to e1.");
        e1.concatenate(e2);
        System.out.println(" e1 = " + e1.toString());
        System.out.println(" e2 = " + e2.toString());

        System.out.println("");
        System.out.println("Testing concatentation again. ");
        System.out.println("Creating new enumeration e3 = [ 100, 101, 102 ] ");
        System.out.println("concatenating e3 to e2");
        AcmeEnumeration e3 = new AcmeEnumeration();
        for (int i = 100; i < 103; i++) {
            e3.insertItem(new AcmeInt(i));
        };
        e2.concatenate(e3);
        System.out.println(" e2 = " + e2.toString());
        System.out.println(" e3 = " + e3.toString());

        System.out.println("(press Enter to exit)");
        try {
            System.in.read();
        } catch (IOException e) {
            return;
        }
    };

    // create some CategoryT objects and compare them
    public static void testCategory(CategoryT myCategory) {
        if(myCategory == CategoryT.ACME_UNKNOWN_CATEGORY)
            System.out.println("this is an ACME_UNKNOWN_CATEGORY");
        else
            System.out.println("this is not an ACME_UNKNOWN_CATEGORY");

        if(myCategory == CategoryT.ACME_SYSTEM)
            System.out.println("this is an ACME_SYSTEM");
        else
            System.out.println("this is not an ACME_SYSTEM");
    }

    // create some PropertyCategoryT objects and compare them
    public static void testPropertyCategory(PropertyCategoryT myCategory) {
        if(myCategory == PropertyCategoryT.ACME_UNKNOWN_PROPERTY_CATEGORY)
            System.out.println("this is an ACME_UNKNOWN_PROPERTY_CATEGORY");
        else
            System.out.println("this is not an ACME_UNKNOWN_PROPERTY_CATEGORY");

        if(myCategory == PropertyCategoryT.ACME_SEQUENCE)
            System.out.println("this is an ACME_SEQUENCE");
        else
            System.out.println("this is not an ACME_SEQUENCE");
    }


};
