// Class: AcmeUnresolvedType
// Purpose: Simple class that temporarily stores a reference to an AcmeType
//          whose name can not be resolved into the type object that the
//          name is supposed to reference.  This is useful when it is not
//          known from the context whether the type should be a property type
//          or an element type.
//
// Revision History:
//    Date:   Person    Change
//    1/27/98  RTM       created class

package acmeLib;

public class AcmeUnresolvedType implements AcmeType
{
    protected String typeName;

    public AcmeUnresolvedType(String newTypeName) {
        this.typeName = newTypeName;
    };

    public String getTypeName() { return this.typeName; }
    public void setTypeName(String newTypeName) { this.typeName = newTypeName; }
    public boolean equals (Object o) {
    	if (o instanceof AcmeUnresolvedType) {
			AcmeUnresolvedType t = (AcmeUnresolvedType) o;
			return t.typeName.equals (typeName);
		}
		return false;
    }

}