// Class: Editable
// Purpose: Interface for all things that can request that they be
//          edited by a user via some UI mechanism (which UI mechanism
//          is determined by the implementation).
//
// Revision History:
//    Date:   Person    Change
//    3/2/98   RTM       Created

package acmeLib;

public interface Editable {

    // request to allow a person to edit this entity.
    public void edit();

    // request to display this entity to a user, but do not allow
    // modifications to it.
    public void view();
}