
package acmeLib.core.exceptions;


/** 
 *  Class:   AcmeDuplicateNameException
<BR>
 *  Purpose: Exception thrown when attempting to add an element or property
<BR>
 *           in a typespace where that name is already in use.
<BR>
 *           E.g. trying to add two components to a system, both of which
<BR>
 *                are named "filter"
<BR><BR>
 *
 *  Revision History:
<BR>
 *    Date:     Person    Change
<BR>
 *    7/15/97   RTM       Created
<BR><BR>
 *
 *  @author Bob Monroe<BR>
 */


public class AcmeDuplicateNameException extends AcmeIllegalNameException {

  /**
   * This is a constructor for this class
   */
    public AcmeDuplicateNameException() {
        super("Acme Duplicate Name Exception");
    };

  /**
   * This is a constructor for this class
   * @param errMsg the messages to be printed when this exception occurs
   */
    public AcmeDuplicateNameException(String errMsg) {
        super(errMsg);
    };
};
