
package acmeLib.core.exceptions;


/** 
 *  Class:    AcmeIllegalNameException
<BR>
 *  Purpose:  Exception thrown when attempting to add a nameable entity
<BR>
 *            with an illegal name to some scope
<BR><BR>
 *
 *  Revision History:
<BR>
 *    Date:     Person    Change
<BR>
 *    7/15/97    RTM     Created
<BR><BR>
 *
 *  @author Bob Monroe<BR>
 */


public class AcmeIllegalNameException extends AcmeException {

    String illegalName = null;

  /** 
   * This is a constructor for this class
   */
    public AcmeIllegalNameException() {
        super("Acme Illegal Name Exception");
    };

  /** 
   * This is a constructor for this class
   * @param errMsg the messages to be printed when this exception occurs
   */
    public AcmeIllegalNameException(String errMsg) {
        super(errMsg);
    };

  /**
   * @return illegalName
   */
    public String getIllegalName() { return this.illegalName; };
  /**
   * @param name the String used to set the value of illegalName
   */
    public void setIllegalName(String name) { this.illegalName = name; };
};
