
package acmeLib.core.exceptions;


/** 
 *  Class:   AcmeKeywordNameException
<BR>
 *  Purpose: exception thrown when attempting to add an element or property
<BR>
 *          whose name is an Acme keyword to an element.
<BR>
 *          E.g. trying to add a port named "system" to a component.
<BR><BR>
 *
 *  Revision History:
<BR>
 *    Date:     Person    Change
<BR>
 *    7/15/97    RTM     Created
 <BR><BR>
 *
 *  @author Bob Monroe<BR>
 */


public class AcmeKeywordNameException extends AcmeIllegalNameException {

  /**
   * This is the constructor for this class
   */
    public AcmeKeywordNameException() {
        super("Acme Keyword Name Exception");
    };

  /**
   * This is the constructor for this class
   * @param errMsg the message to be printed when this exception occurs
   */
    public AcmeKeywordNameException(String errMsg) {
        super(errMsg);
    };
};
