
package acmeLib.core.exceptions;

/** 
 *  Class:    AcmeRepMismatchException
<BR>
 *  Purpose:  Exception thrown when attempting to add a representation to
<BR>
 *            an element such that the representation is an incompatible
<BR>
 *            category with the element's category.  E.g. trying to add
<BR>
 *            a port representation of a connector.
<BR><BR>
 *
 *  Revision History:
<BR>
 *    Date:     Person    Change
<BR>
 *    4/22/97    RTM     Created
<BR><BR>
 *
 *  @author Bob Monroe<BR>
 */
public class AcmeRepMismatchException extends AcmeException {

  /**
   * This is the constructor for this class
   */
    public AcmeRepMismatchException() {
        super("Rep Mismatch Exception");
    };

  /**
   * This is the constructor for this class
   * @param errMsg the message to be printed when this exception occurs
   */
    public AcmeRepMismatchException(String errMsg) {
        super(errMsg);
    };
};
