
package acmeLib.core.exceptions;

/** 
 *  Class:   AcmeTypeCategoryMismatchException
 <BR>
 *  Purpose:   Exception thrown when a type operation is done on
<BR>
 *             and the type and category of an element don't match.
<BR><BR>
 *
 *  Revision History:
<BR>
 *    Date:     Person    Change
<BR>
 *    6/04/97   RTM     Created
<BR><BR>
 *
 *  @author Bob Monroe<BR>
 */
public class AcmeTypeCategoryMismatchException extends AcmeException {

  /**
   * This is the constructor for this class
   */
    public AcmeTypeCategoryMismatchException() {
        super("Type/Category Mismatch Exception");
    };

  /**
   * This is the constructor for this class
   * @param errMsg the message to be printed when this exception occurs
   */
    public AcmeTypeCategoryMismatchException(String errMsg) {
        super(errMsg);
    };
};
