
package acmeLib.core.exceptions;

/** 
 *  Class:    AcmePropertyLookupFailedException
 <BR>
 *  Purpose:  Exception that is raised when somebody tries to get a
<BR>
 *            non-existent property from an element.
<BR><BR>
 *
 *  Revision History:
<BR>
 *    Date:     Person    Change
<BR>
 *     4/22/97    RTM     Created
<BR><BR>
 *
 *  @author Bob Monroe<BR>
 */
public class AcmeUnnamedPropertyException extends AcmeIllegalNameException {

  /**
   * This is the constructor for this class
   */
    public AcmeUnnamedPropertyException() {
        super("Acme Unnamed Property Exception");
    };

  /**
   * This is the constructor for this class
   * @param errMsg the message to be printed when this exception occurs
   */
    public AcmeUnnamedPropertyException(String errMsg) {
        super(errMsg);
    };
};
