
package acmeLib.core.exceptions;

/** 
 *  Class:   NotBooleanExpressionException
 <BR>
 *  Purpose: Exception thrown when a trying to evaluate a non-boolean
<BR>
 *           expression with the boolean
<BR>
 *           acmeLib.designRules.ExpressionNode.evaluate() method
<BR><BR>
 *
 *  Revision History:
<BR>
 *    Date:     Person    Change
<BR>
 *   10/7/97    RTM     Created
<BR><BR>
 *
 *  @author Bob Monroe<BR>
 */

public class NotBooleanExpressionException extends AcmeException {

  /**
   * This is the constructor for this class
   */
    public NotBooleanExpressionException() {
        super("Attempted to do a boolean evaluation on a non-boolean expression");
    };

  /**
   * This is the constructor for this class
   * @param errMsg the message to be printed when this exception occurs
   */
    public NotBooleanExpressionException(String errMsg) {
        super(errMsg);
    };
};

