
package acmeLib.core.filters;

import acmeLib.AcmeObject;

// class AcmeObjectFilter
// author Bob Monroe<BR>
// Revision History:
// Date:     Person    Change
// ?/?/97    DK        Created C++ version
// 4/9/97    RTM       Translated to Java


/**
 *  Allows a client to send a filter when creating an enumeration
 *  (or another type of object that makes use of the filter concept)
 *          that allows a finer-grained specification of what items meet the
 *          requirements specified by "test".  Effectively the "test"
 *          method performs a test on "obj" and returns "true" if the
 *          object meets the criteria, or false otherwise.  The client can
 *          decide which action to take based on the result of that test.
 */


abstract public class AcmeObjectFilter extends acmeLib.AcmeObject {
  /**
   * @param obj AcmeObject to be tested
   * @return whether obj meets requirements of the test
   */
  abstract public boolean test (AcmeObject obj);
};
