
package acmeLib.core.filters;

import acmeLib.AcmeObject;
import acmeLib.core.globals.ConstantTypes;

/**
 * Filter that removes all BaseClasse objects.  These are the basic
 * element type's constant objects.
 */
public class NoBaseClassesEnumFilter extends AcmeObjectFilter {
  /**
   * @param obj the object to be tested
   * @return whether obj is not any of COMPONENT_BASE_TYPE,
   *            CONNECTOR_BASE_TYPE, PORT_BASE_TYPE, ROLE_BASE_TYPE,
   *            SYSTEM_BASE_TYPE, ELEMENT_BASE_TYPE
   */

    public boolean test(AcmeObject obj) {
        return ( (obj != ConstantTypes.COMPONENT_BASE_TYPE)
                 && (obj != ConstantTypes.CONNECTOR_BASE_TYPE)
                 && (obj != ConstantTypes.PORT_BASE_TYPE)
                 && (obj != ConstantTypes.ROLE_BASE_TYPE)
                 && (obj != ConstantTypes.SYSTEM_BASE_TYPE)
                 && (obj != ConstantTypes.ELEMENT_BASE_TYPE) );
    };
};
