/** Class:  ConversionConstants<BR>
 *  Purpose: Class that holds a set of constant definitions to determine
 *           how to do conversions between various Acme flavors, dialects,
 *           and Acme-compliant "native" ADL's. <BR>
 *
 *  Revision History:<BR>
 *    Date:     Person    Change<BR>
 *    6/15/98    RTM      * created initial class & file<BR><BR>
 *
 *  @author Bob Monroe<BR>
 */

package acmeLib.core.globals;

final public class ConversionConstants {

    // constants for exporting Armani as Acme, and importing Acme as Armani
    // the type name's are for the type definitions, prop names are prefixes
    // for the names of the actual properties storing the Armani constructs
    // as Acme properties.
    public static final String ARMANI_INVARIANT_TYPE_NAME_AS_ACME_PROP = "Armani-InvariantT";
    public static final String ARMANI_HEURISTIC_TYPE_NAME_AS_ACME_PROP = "Armani-HeuristicT";
    public static final String ARMANI_ANALYSIS_TYPE_NAME_AS_ACME_PROP  = "Armani-AnalysisT";

    public static final String ARMANI_INVARIANT_PROP_NAME_AS_ACME_PROP = "Armani-InvariantProp";
    public static final String ARMANI_HEURISTIC_PROP_NAME_AS_ACME_PROP = "Armani-HeuristicProp";
    public static final String ARMANI_ANALYSIS_PROP_NAME_AS_ACME_PROP  = "Armani-AnalysisProp";

    // meta-property name to indicate which type declaration this design rule
    // originally comes from, for tools to decide whether to perform the conversion
    // directly in the instance or to simply refer to a type's design rule
    public static final String DECLARED_IN_TYPENAME  = "Armani-TypeDeclaredIn";
    public static final String DECLARED_IN_TYPENAME_METAPROP  = DECLARED_IN_TYPENAME + " : String";

};
