
package acmeLib.core.globals;


/** 
 *  Class:  ExportLanguage
 <BR>
 *  Purpose:Class that holds a set of constant definitions to determine
 <BR>
 *          the language in which the design description should be export.
 <BR> <BR>
 * 
 *
 *  Revision History:
 <BR>
 *    Date:     Person    Change
 <BR>
 *   4/27/98    RTM      * created initial class & file
 <BR> <BR>
 *
 *  @author Bob Monroe <BR>
 */
final public class ExportLanguage {

    // Export this as Acme or as another language (such as Armani)?
    public static final ExportLanguage ACME = new ExportLanguage(0);
    public static final ExportLanguage ARMANI = new ExportLanguage(1);

    private int state;
  /**
   * This is the constructor for this class
   * @param i the value to be given to state
   */
    private ExportLanguage(int i) { this.state = i; };
  /**
   * This method string of the corresponding language
   * @return String representation of the language
   */
    public String toString() {
        if (this.state == 0)
            return "Acme";
        else if (this.state == 1)
            return "Armani";
        else
            return "Unknown Export Language";
    };
};
