
package acmeLib.core.globals;

/* class PropertyCategoryT

     The PropertyCategoryT class replaces the enumerated type
     PropertyCategoryT in the original C++ implementation of ACME-Lib.
     It's purpose is to declare a set of values that indicate the
     category of an AcmeProperty.

*/


/** 
 *  Class: PropertyCategoryT
 <BR>
 *  Purpose: Class that holds constant values indicating the set of
<BR>
 *           valid ACME property categories.
<BR>
 *  Description:   The PropertyCategoryT class replaces the enumerated type
<BR>
 *           PropertyCategoryT in the original C++ implementation of ACME-Lib.
<BR>
 *           It's purpose is to declare a set of values that indicate the
<BR>
 *           category of an AcmeProperty.
<BR><BR>
 *
 *
 *  Revision History:
<BR>
 *    Date:     Person    Change
<BR>
 *     ?/?/97    DK      Created C++ version
<BR>
 *     4/7/97    RTM     Translated to Java
<BR><BR>
 *
 *  @author Bob Monroe<BR>
 */

final public class PropertyCategoryT {

    public static final PropertyCategoryT ACME_UNKNOWN_PROPERTY_CATEGORY =
        new PropertyCategoryT(0);
    public static final PropertyCategoryT ACME_STRING =
        new PropertyCategoryT(1);
    public static final PropertyCategoryT ACME_INTEGER =
        new PropertyCategoryT(2);
    public static final PropertyCategoryT ACME_FLOAT =
        new PropertyCategoryT(3);
    public static final PropertyCategoryT ACME_SEQUENCE =
        new PropertyCategoryT(4);
    public static final PropertyCategoryT ACME_SET =
        new PropertyCategoryT(5);
    public static final PropertyCategoryT ACME_RECORD =
        new PropertyCategoryT(6);
    public static final PropertyCategoryT ACME_ENUM =
        new PropertyCategoryT(7);
    public static final PropertyCategoryT ACME_BOOLEAN =
        new PropertyCategoryT(8);
    public static final PropertyCategoryT ACME_ANY =
        new PropertyCategoryT(9);

  /**
   * This is the constructor for this class
   * @param state the value this.state will take
   */
    private PropertyCategoryT(int state) { this.state = (byte) state; }
    private byte state;

  /**
   * This method returns the string representation of this category's state
   * @return the string representation of this category's state
   */
    public String toString() {
        switch(state) {
            case 0:  return new String("ACME_UNKNOWN_PROPERTY_CATEGORY");
            case 1:  return new String("ACME_STRING");
            case 2:  return new String("ACME_INTEGER");
            case 3:  return new String("ACME_FLOAT");
            case 4:  return new String("ACME_SEQUENCE");
            case 5:  return new String("ACME_SET");
            case 6:  return new String("ACME_RECORD");
            case 7:  return new String("ACME_ENUM");
            case 8:  return new String("ACME_BOOLEAN");
            case 9:  return new String("ACME_ANY");
            default:
              return "UNKNOWN_PROPERTY_CATEGORY";
        }
    };

}

