
package acmeLib.core.globals;


/** 
 *  Class:   StringConstants
 <BR>
 *  Purpose: Class that holds constant string values used throughout the
<BR>
 *           AcmeLib and Aramni.
<BR><BR>
 *
 *  Revision History:
<BR>
 *    Date:     Person    Change
<BR>
 *    1/24/98   RTM      created file
<BR><BR>
 *
 *  @author Bob Monroe<BR>
 */

final public class StringConstants {

    // instance categories
    public static final StringConstants UNRESOLVED_BINDING =
                            new StringConstants("!!UNRESOLVED_BINDING!!");
    public static final StringConstants INFERRED_ELEMENT =
                            new StringConstants("!!INFERRED_ELEMENT!!");

  /**
   * This is the constructor for this class
   * @param state the value this.state will take
   */
    private StringConstants(String state) { this.state = state; }
    private String state;

  /**
   * This method returns the string representation of this string constant
   * @return  the string representation of this string constant
   */
    public String toString() { return this.state; };
}

