
package acmeLib.core.io;


/**
 *  Class:   Exportable
<BR>
 *  Purpose: Interface that specifies methods for exporting an object
<BR>
 *           as an Armani
<BR><BR>
 *
 *  Revision History:
<BR>
 *    Date:     Person    Change
<BR>
 *   10/24/97    RTM     Created
<BR><BR>
 *
 *  @author Bob Monroe<BR>
 */
public interface ArmaniExportable extends Exportable {

  /**
   * This method writes an Acme textual description of this object to
   * AcmeOutputStream s.
   * @param s AcmeOutputStream
   * @exception java.io.IOException when error occurs when writing
   * @exception acmeLib.core.exceptions.AcmeException for Acme Exception
   */
  public void exportArmani(AcmeOutputStream s)
        throws java.io.IOException, acmeLib.core.exceptions.AcmeException;
};
