
package acmeLib.core.io;



/** <BR>
 *  Class:   Exportable
<BR>
 *  Purpose:  Interface that specifies methods for exporting an object.
<BR>
 *            The only top-level guaranteed exportable method is exportAcme.
<BR>
 *            When extending Acme, this should be subclassed to add additional
<BR>
 *            exporting methods (cf. ArmaniExportable).
<BR><BR>
 *
 *  Revision History:
<BR>
 *    Date:     Person    Change
<BR>
 *   10/24/97    RTM     Created
<BR><BR>
 *
 *  @author Bob Monroe<BR>
 */
public interface Exportable {

  /**
   * This method writes an Acme textual description of this object to
   * AcmeOutputStream s.
   * @param s AcmeOutputStream
   * @exception java.io.IOException when error occurs when writing
   * @exception acmeLib.core.exceptions.AcmeException for acme exception
   */
  public void exportAcme(AcmeOutputStream s)
        throws java.io.IOException, acmeLib.core.exceptions.AcmeException;
};
