package acmeLib.designRules;

/**
 * Class: DesignRuleEvalException<br>
 * Purpose: Base class for all exceptions thrown during the evaluation<br>
 *          of an Armani design rule.<br>
 *<br>
 * Revision History:<br>
 *    Date:     Person    Change<br>
 *    10/27/97    RTM     Created<br>
 *<br>
 * @author Bob Monroe
 */
public class DesignRuleEvalException
              extends acmeLib.core.exceptions.AcmeException
{

  /** 
   * This is the constructor for this class
   */
    public DesignRuleEvalException() {
        super("Error during design rule evaluation");
    };

  /** 
   * This is the constructor for this class
   * @param errMsg The error message
   */
    public DesignRuleEvalException(String errMsg) {
        super(errMsg);
    };
};

