package acmeLib.designRules;


/**
 * Class: ParameterSet<br>
 * Purpose: A set of parameter binding records that can be retrieved<br>
 *          by parameter name.<br>
 *<br>
 * Revision History:<br>
 *    Date:     Person    Change<br>
 *    10/20/97    RTM     Created prototype for this class<br>
 *<br>
 * @author Bob Monroe
 */
public class ParameterSet {

    //
    // protected members
    //

    protected java.util.Hashtable params;

    //
    // public members
    //

  /**
   * This is the constructor for this class
   */
    public ParameterSet() {
        this.params = new java.util.Hashtable();
    };


    // accessor and settor methods
  /** 
   * Get the enumeration of the parameters
   * @return The enumeration of the parameters
   */
    public java.util.Enumeration enumerateParams() {
        return params.elements();
    };

  /**
   * Add paramters
   * @param param The parameter added
   */
    public void addParam(DesignRuleParameter param) {
        params.put(param.getName(), param);
    };

  /**
   * Remove parameters
   * @param paramName The parameter removed
   */
    public void removeParam(String paramName) {
        params.remove(paramName);
    };

  /**
   * Lookup paramater
   * @param paramName The parameter name
   * @return The paramter
   */
    public DesignRuleParameter lookupParam(String paramName) {
        return (DesignRuleParameter) params.get(paramName);
    };
}