package acmeLib.designRules;

/**
 * Interface: TypedEntity<br>
 * Purpose: A class that implements the TypedEntity interface provides<br>
 *          methods for typechecking.<br>
 *<br>
 * Revision History:<br>
 *    Date:     Person    Change<br>
 *    1/6/98     RTM      Created initial interface definition<br>
 *<br>
 * @author Bob Monroe
 */
public interface TypedEntity {

    //
    // public members
    //

  /** 
   * The TypedEntity interface provides the boolean method typecheck()
   * which returns true iff "this" entity is type correct.  typecheck()
   * is also used to calculate the type of an entity and it will assign
   * a type to itself, and perhaps to its substructure (whether it does
   * so depends on the class implementing the method).  If it encounters
   * errors in the process of computing the type it returns false.
   * @return true if type is correct
   */

    public boolean typecheck();
}