package acmeLib.designRules;

import acmeLib.*;

/**
 * Class: VolatileVariable
 * Purpose: stores the value of a reference to a volatile variable (that is,
 *          a variable that is a design analysis in this scope, or a quantified
 *          variable in a quantified expression).
 *
 * Revision History:
 *    Date:     Person  Change
 *     2/2/98    RTM     created class & file.
 * @author Bob Monroe
 */
public class VolatileVariable extends AcmeObject {

  // this class is overly simplified because it's only purpose is to
  // be a record that is passed between identifierNodes' and the scope
  // in which those identifiers are looking up values.  It doesn't
  // use accessor/settor methods intentionally, to keep it as simple as
  // possible.

  //
  // public members
  //

  public Object     referentObject;
  public AcmeType   refObjectType;
  public Scope      declarationScope;

/**
 * This is the constructor for this class
 */
  public VolatileVariable() {
    this.referentObject = null;
    this.refObjectType = null;
    this.declarationScope = null;
  };


/**
 * Check if the tested object is equal to this object
 * @param test The tested object
 * @return true if the tested object is equal to this object
 */
  public boolean equals(Object test) {
    if (test instanceof VolatileVariable) {
        if (referentObject == null) {
            return (((VolatileVariable) test).referentObject == null);
        }
            return referentObject.equals(((VolatileVariable) test).referentObject);
    }
        return referentObject.equals(test);
  };
};