/*
 * Created on Jul 9, 2004
 *
 */
package acmeLib.designRules.feedback;

import acmeLib.elements.AcmeElement;
import acmeLib.elements.AcmeElementType;


/**
 * @author Bradley Schmerl
 * Created Jul 9, 2004
 */
public class ElementEvaluationFeedback extends EvaluationFeedback {

	private final Object	_elementVisited;

	/**
	 * @param result
	 * @param elementVisited
	 * 
	 */
	public ElementEvaluationFeedback (Object elementVisited, Object result) {
		super (result);
		_elementVisited = elementVisited;
	}
	/**
	 * @return Returns the objectVisited.
	 */
	public Object getElementVisited () {
		return _elementVisited;
	}
	/**
	 * @return
	 * @see acmeLib.designRules.feedback.EvaluationFeedback#getVisitedString()
	 **/
	public String getVisitedString() {
		if (_elementVisited instanceof AcmeElementType) {
			AcmeElementType type = (AcmeElementType )_elementVisited;
			return type.getTypeName();
		}
		else if (_elementVisited instanceof AcmeElement) {
			AcmeElement element = (AcmeElement )_elementVisited;
			return element.getQualifiedName ();
		}
		else {
			return _elementVisited.toString ();
		}
	}
	
}
