
package acmeLib.elements;

import acmeLib.core.container.AcmeVector;
import acmeLib.core.exceptions.AcmeIllegalNameException;


/**
 *  Class:  AcmeSequenceType
 *
 *  Purpose:the type object for a sequence
 *
 *  Revision History:
 *    Date:     Person    Change
 *	11/5/99		JH		Created
 */
public class AcmeSequenceType extends AcmeSequenceValue 
	implements AcmeCompoundElementType
{
	protected AcmeElementType contentType;
	//
	// public members
	//
	/**
	 * This is the constructor for this class
	 * @param name the name of the sequence type being created
	 */
	public AcmeSequenceType (String name) throws AcmeIllegalNameException{
		setTypeName(name);
	}
	
	public AcmeSequenceType(String name, AcmeElementType contentType) throws AcmeIllegalNameException{
                if (name == null || name == "") name = "sequence<"+contentType.getTypeName()+">";
		setTypeName("sequence<"+contentType.getTypeName()+">");
		System.err.println(name);
                this.contentType = contentType;
	}
	
	public void setContentType(AcmeElementType contentType){
		this.contentType = contentType;
	}
	
	public AcmeElementType getContentType(){
		return contentType;
	}
	
	/**
	 * @return the name of the type
	 */
	public String getTypeName() {return this.getName();}

	/**
	 * @param typeName used to set the name of the type
	 * @exception AcmeIllegalNameException type name is illegal
	 */
	public void setTypeName(String typeName) throws AcmeIllegalNameException{
		this.setName(typeName);
	}
	
	public void addSuperType(AcmeElementType superType){}
	
	public void removeSuperType(AcmeElementType superType){}
	
	public AcmeVector getSuperTypes(){return null;}
	
	/**
	 * This method makes a deep copy of AcmeRecordType
	 */
	public AcmeElementType copyType(){
   		AcmeSequenceType new_seq_type = null;
   		try{
       		new_seq_type = new AcmeSequenceType(this.type.getTypeName());
    	}catch (AcmeIllegalNameException e){}
    	new_seq_type.setContentType(this.contentType);
	    
   		return new_seq_type;
	}

	/**
	 * This method returns a deep-copy of "this" AcmeRecordType object
	 * @return a copy of this AcmeRecordType object
	 */
	public AcmeElement copy() {
		return (AcmeElement)copyType();
	}

	/**
	 * @param s AcmeOutputStream
	 * @exception java.io.IOException when an error occurs while writing
	 */
/*	public void exportAcme (AcmeOutputStream s) throws java.io.IOException {
		this.export(s);
	}*/

	/**
	 * @param s AcmeOutputStream
	 * @exception java.io.IOException when an error occurs while writing
	 */
/*	public void exportArmani(AcmeOutputStream s) throws java.io.IOException {
		this.export(s);
	}*/
}
