
package acmeLib.elements;

import acmeLib.core.container.AcmeVector;
import acmeLib.core.exceptions.AcmeIllegalNameException;


/**
 *  Class:  AcmeSetType
 *
 *  Purpose:the type object for a set
 *
 *  Revision History:
 *    Date:     Person    Change
 *	11/5/99		JH		Created
 */
public class AcmeSetType extends AcmeSetValue 
	implements AcmeCompoundElementType
{
	protected AcmeElementType contentType;
	//
	// public members
	//
	/**
	 * This is the constructor for this class
	 * @param name the name of the sequence type being created
	 */
	public AcmeSetType (String name) throws AcmeIllegalNameException{
		setTypeName(name);
	}
	
	public AcmeSetType(String name, AcmeElementType type) throws AcmeIllegalNameException{
		setTypeName(name);
		contentType = type;
	}
	
	/**
	 * @return the name of the type
	 */
	public String getTypeName() {return this.getName();}

	/**
	 * @param typeName used to set the name of the type
	 * @exception AcmeIllegalNameException type name is illegal
	 */
	public void setTypeName(String typeName) throws AcmeIllegalNameException{
		this.setName(typeName);
	}
	
	public void setContentType(AcmeElementType contentType){
		this.contentType = contentType;
	}
	
	public AcmeElementType getContentType(){
		return this.contentType;
	}
	
	public void addSuperType(AcmeElementType superType){}
	
	public void removeSuperType(AcmeElementType superType){}
	
	public AcmeVector getSuperTypes(){return null;}
	
	/**
	 * This method makes a deep copy of AcmeRecordType
	 */
	public AcmeElementType copyType(){
		AcmeSetType new_set_type = null;
		try{
		    new AcmeSetType(this.type.getTypeName());
    	}catch (AcmeIllegalNameException e){}
		new_set_type.setContentType(contentType);
		
		return new_set_type;
	}

	/**
	 * @param s AcmeOutputStream
	 * @exception java.io.IOException when an error occurs while writing
	 */
/*	public void exportAcme (AcmeOutputStream s) throws java.io.IOException {
		this.export(s);
	}*/

	/**
	 * @param s AcmeOutputStream
	 * @exception java.io.IOException when an error occurs while writing
	 */
/*	public void exportArmani(AcmeOutputStream s) throws java.io.IOException {
		this.export(s);
	}*/
}
