package acmeLib.elements;

import acmeLib.errorManagement.AcmeErrorManager;
import acmeLib.errorManagement.InstanceRefResolutionError;

public class AcmeUnresolvedElement extends AcmeElement{
    public AcmeUnresolvedElement(String name){
        super(name);
    }
    // Looks up the name of the element in the
    public void resolveInstanceReferences(){
        super.resolveInstanceReferences();
        System.err.println("AcmeUnresolvedElement.resolveInstanceReferences() not fully implemented");
    }
    
    public AcmeElement getResolvedInstanceReference(){
        java.util.StringTokenizer names = new java.util.StringTokenizer(name,".");
        AcmeElement result = null;
        Object tempResult = null;
        AcmeElement curScope = this.getParent();
        while (names.hasMoreElements()){
            String curName = names.nextToken();
            tempResult = curScope.lookupName(curName,true);
            if (!(tempResult instanceof AcmeElement)){
                InstanceRefResolutionError error =
                new InstanceRefResolutionError(this.getParent(),
                        "unable to resolve element reference " , this.getName());
                error.setUnresolvedRef(this);
                AcmeErrorManager.errorDetected(error);
                System.err.println("unable to resolve element "+this.getName());
                result = null;
                break;
            }
            result = (AcmeElement)tempResult;
            curScope = result;
        }
        return result;
    }

	public Object lookupName(String name, boolean bubbleUp) {
	    System.out.println("Looking up in a unresolved element "+getName()+" for "+name);
	    return null;
	}
    /* (non-Javadoc)
     * @see acmeLib.elements.AcmeElement#copy()
     */
    public AcmeElement copy() {
        AcmeUnresolvedElement new_el = new AcmeUnresolvedElement (this.getName ());
        this.copyCommonEltStructure(new_el);
        return new_el;
    }
}