/*
 * Created on Aug 1, 2003
 *
 */
package acmeLib.elements;

import acmeLib.representations.AcmeBinding;
import acmeLib.tools.WalkerElementOperation;

/**
 * @author Bradley Schmerl
 * Created Aug 1, 2003
 */
public class StitchElementOperation implements WalkerElementOperation {

	AcmeDesign oldDesign;
	AcmeDesign newDesign;
	/**
	 * 
	 */
	public StitchElementOperation(AcmeDesign nD, AcmeDesign oD) {
		oldDesign = oD;
		newDesign = nD;
	}

	/* (non-Javadoc)
	 * @see acmeLib.tools.WalkerElementOperation#doElementOp(acmeLib.elements.AcmeElement)
	 */
	public void doElementOp(AcmeElement elt) {
		if (elt.getParentDesign() != newDesign) {
			elt.setParentDesign(newDesign);
		}
		if (elt instanceof AcmeAttachment) {
			AcmeAttachment att = (AcmeAttachment) elt;
			AcmePort port = att.getPort ();
			AcmeRole role = att.getRole ();
			att.setPort ((AcmePort )newDesign.lookupQualifiedName(port.getQualifiedName ()));
			att.setRole ((AcmeRole )newDesign.lookupQualifiedName(role.getQualifiedName()));
		}
		else if (elt instanceof AcmeBinding) {
			AcmeBinding binding = (AcmeBinding) elt;
			binding.setInner((AcmeElement )newDesign.lookupQualifiedName(binding.getInner().getQualifiedName()));
			binding.setOuter ((AcmeElement )newDesign.lookupQualifiedName(binding.getOuter ().getQualifiedName()));
		}
	}

}
