package acmeLib.errorManagement;

import acmeLib.armaniParser.ParseException;
import acmeLib.armaniParser.Token;
import acmeLib.core.io.Region;

/**
 * @author schmerl
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
public class AcmeParseError extends AcmeError {

	public static boolean reportLineNumber = false;
	
    protected int lineNumber = -1;
    protected Region region = null;
	private ParseException _exception = null;
    
    public int getLineNumber () {
        return lineNumber;
    }
    
    /**
     * Returns the region (in the line that has the error) of the
     * error token.
     * @return Region
     */
    public Region getRegion () {
        return region;
    }

    public AcmeParseError (acmeLib.armaniParser.ParseException e) {
    	super ();
    	_exception = e;
    	String errMsg = "";
    	String expected = "";
    	
    	int maxSize = 0;
    	if (e.expectedTokenSequences != null) {
    		
    		for (int i = 0; i < e.expectedTokenSequences.length; i++) {
    			if (maxSize < e.expectedTokenSequences [i].length) {
    				maxSize = e.expectedTokenSequences [i].length;
    			}
    			for (int j = 0; j < e.expectedTokenSequences[i].length; j++) {
    				expected += e.tokenImage [e.expectedTokenSequences [i][j]] + " ";
    				
    			}
    			if (e.expectedTokenSequences [i][e.expectedTokenSequences [i].length - 1] != 0) {
    				expected += "... or ";          
    			}
    		}
    		expected = "Was expecting" + expected.substring (0, expected.length () - 3);
    	}
    	String encountered = "";
    	if (e.currentToken != null) {
    		
    		encountered = "Encountered \"";
    		Token tok = e.currentToken.next;
    		for (int i = 0; i < maxSize; i++) {
    			if (i != 0) encountered += " ";;
    			if (tok.kind == 0) {
    				encountered += e.tokenImage [0];
    				break;
    			}
    			encountered += e.add_escapes(tok.image);
    			tok = tok.next;
    		}
    	}

    	
    	errMsg = e.getMessageString ()+ " " + encountered + ". " + expected;
    	
    	//        setErrorMessage (e.getMessage());
    	lineNumber = e.currentToken.beginLine;
    	if (reportLineNumber) {
    		errMsg = "Line " + lineNumber + ": " + errMsg;
    	}
    	setErrorMessage (errMsg);
    	setSource (encountered + lineNumber);
    	region = new Region ();
    	region.setBeginIndex(e.currentToken.beginColumn);
    	region.setEndIndex (e.currentToken.endColumn);
    }

	/**
	 * @return Returns the exception.
	 */
	public ParseException getException() {
		return _exception;
	}
} 
