package acmeLib.errorManagement;

import acmeLib.representations.AcmeBinding;

/**
 * Class: BindingTypecheckError<br>
 * Purpose: Describes an error that occured because a binding<br>
 *          of a representation did not typecheck.<br>
 *<br>
 * Revision History:<br>
 *    Date:   Person    Change<br>
 *    2/13/98  RTM       created initial class<br>
 * @author Bob Monroe
 */

public class BindingTypecheckError extends AcmeError {

    //
    // protected members
    //

  /**
   * stores the representation that doesn't typecheck.
   */
    protected AcmeBinding errorBinding;

    //
    // public members
    //

  /**
   * default constructors that primarily make use of super-class constructors
   */
    public BindingTypecheckError() {
        super();
        this.errorMessage = "Unspecified BindingTypecheckError";
    };


  /**
   * This is the constructor of this class
   * @param errorSource The source of error
   * @param msg The error message
   */
    public BindingTypecheckError(Object errorSource, String msg) {
        super(errorSource, msg);
        if (errorSource instanceof AcmeBinding)
            this.setErrorBinding((AcmeBinding) errorSource);
    };


    // accessors/settors
  /**
   * Get the error binding
   * @return The AcmeBinding
   */
    public AcmeBinding getErrorBinding() { return this.errorBinding; };

  /**
   * Set the error binding
   * @param problemBinding The AcmeBinding
   */
    public void setErrorBinding(AcmeBinding problemBinding) {
        this.errorBinding = problemBinding;
    };
};