package acmeLib.errorManagement;

import acmeLib.elements.AcmeElement;

/**
 * Class: ElementTypecheckError<br>
 * Purpose: Describes an error that occured because an element (ccrps)<br>
 *          does not typecheck for some reason.<br>
 *<br>
 * Revision History:<br>
 *    Date:   Person    Change<br>
 *    2/13/98  RTM       created initial class<br>
 * @author Bob Monroe
 */

public class ElementTypecheckError extends AcmeError {

    //
    // protected members
    //

  /**
   * stores the element that doesn't typecheck
   */
    protected AcmeElement errorElement;

    //
    // public members
    //

  /**
   * default constructors that primarily make use of super-class constructor
   */
    public ElementTypecheckError() {
        super();
        this.errorMessage = "Unspecified ElementTypecheckError";
    };


  /**
   * This is the constructor for this class
   * @param errorSource The source of error
   * @param msg The error message
   */
    public ElementTypecheckError(Object errorSource, String msg) {
        super(errorSource, msg);
    };



  /**
   * This is the constructor for this class
   * @param errorSource The source of error
   * @param msg The error message
   * @param elt The AcmeElement
   */
    public ElementTypecheckError(Object errorSource, String msg,
                                 AcmeElement elt)
    {
        super(errorSource, msg);
        this.setElement(elt);
    };



    // accessors and settors
  /**
   * Get the element
   * @return The element
   */
    public AcmeElement getElement() { return this.errorElement; };
  /**
   * Set the element
   * @param newElement The new element
   */
    public void setElement(AcmeElement newElement) {
        this.errorElement = newElement;
    };

};