package acmeLib.errorManagement;

import acmeLib.designRules.DesignRule;
import acmeLib.designRules.Scope;

/**
 * Class: InvariantViolationError<br>
 * Purpose: Describes an error that occured because a Design Invariant<br>
 *          was violated.<br>
 *<br>
 * Revision History:<br>
 *    Date:   Person    Change<br>
 *    2/13/98  RTM       created initial class<br>
 *<br>
 * @author Bob Monroe
 */
public class InvariantViolationError extends DesignRuleViolationError {

  /**
   * default constructors that primarily make use of super-class constructors
   */
    public InvariantViolationError() {
        super();
        this.errorMessage = "Unspecified InvariantViolationError";
    };


  /**
   * This is the constructor for this class
   * @param errorSource The source of error
   * @param msg The error message
   */
    public InvariantViolationError(Object errorSource, String msg) {
        super(errorSource, msg);
    };


  /**
   * This is the constructor for this class
   * @param errorSource The source of error
   * @param msg The error message
   * @param problemDesignRule The problemed design rule
   * @param evaluationScope The evaluation scope
   */
    public InvariantViolationError(Object errorSource, String msg,
                                    DesignRule problemDesignRule,
                                    Scope evaluationScope)
    {
        super(errorSource, msg, problemDesignRule, evaluationScope);
    };

};