package acmeLib.errorManagement;

import acmeLib.representations.AcmeRepresentation;

/**
 * Class: RepTypecheckError<br>
 * Purpose: Describes an error that occured because a representation<br>
 *          of an element did not typecheck.<br>
 *<br>
 * Revision History:<br>
 *    Date:   Person    Change<br>
 *    2/13/98  RTM       created initial class<br>
 *<br>
 * @author Bob Monroe
 */
public class RepTypecheckError extends AcmeError {

    //
    // protected members
    //

  /**
   * stores the representation that doesn't typecheck.
   */
    protected AcmeRepresentation errorRep;

    //
    // public members
    //

  /**
   * default constructors that primarily make use of super-class constructors
   */
    public RepTypecheckError() {
        super();
        this.errorMessage = "Unspecified RepTypecheckError";
    };


  /**
   * This is the constructor for this class
   * @param errorSource The source of error
   * @param msg The error message
   */
    public RepTypecheckError(Object errorSource, String msg) {
        super(errorSource, msg);
        if (errorSource instanceof AcmeRepresentation)
            this.setErrorRep((AcmeRepresentation) errorSource);
    };


    // accessors/settors
  /**
   * Get the error representation
   * @return the error representation
   */
    public AcmeRepresentation getErrorRep() { return this.errorRep; };
  /**
   * Set the error representation
   * @param problemRep The new error representation
   */
    public void setErrorRep(AcmeRepresentation problemRep) {
        this.errorRep = problemRep;
    };
};