
package acmeLib.properties;

import acmeLib.core.io.AcmeOutputStream;


/**
 *  Class:EnumValue
<BR><BR>
 *
 *  Purpose: stores a string value used in an enumerated type.
 <BR><BR>
 *
 *  Revision History:
<BR>
 *    Date:     Person    Change
<BR>
 *    ?/?/97    DK      Created C++ version
<BR>
 *    6/1/97    RTM     Translated to Java
<BR><BR>

 *
 *  @author Bob Monroe<BR>
 */
public class EnumValue extends acmeLib.AcmeObject {

  //
  // public methods
  //
  public String value;
 /**
   * This is the constructor for this class
   * @param val the value of the enumerated value being created
   */
  public EnumValue(String val) { this.value = val; };

  /**
   * @return the String representaion for the value of the enumerated value
   */
  public String toString() {
    return this.value;
  };

  /**
   * @param s AcmeOutputStream
   * @exception java.io.IOException when error occurs when writing
   */
  public void exportAcme (AcmeOutputStream s) throws java.io.IOException {
      s.beginRegion (this);
    s.write (value);
    s.endRegion (this);
  };

  /**
   * @param s AcmeOutputStream
   * @exception java.io.IOException when error occurs when writing
   */
  public void exportArmani (AcmeOutputStream s) throws java.io.IOException {
      s.beginRegion (this);
    s.write (value);
    s.endRegion (this);
  };

 /**
   * This method checks whether two enumerated values are equal
   * @param testValue the integer to be compared
   * @return whether "this" and testValue are equal
   */
  public boolean equals(Object testValue) {
    if (testValue instanceof EnumValue) {
        if (this.value == null) {
            return (((EnumValue) testValue).value == null);
        }
            return (this.value.equals(((EnumValue) testValue).value));
    }
    if (testValue instanceof String) {
        return ((String) testValue).equals(this.value);
    }
        return false;
  };

};


