package acmeLib.representations;

import acmeLib.*;
import acmeLib.core.io.*;

/**
 * Class: AcmeAbstractionMap<br>
 * Purpose: abstract base class for Acme abstraction maps<br>
 * <br>
 * Revision History:<br>
 *    Date:   Person    Change<br>
 *    ?/?/97    DK      Created C++ version<br>
 *    6/5/97    RTM     Translated to Java (stubs)<br>
 *    6/20/97   RTM     changed to AcmeAbstractionMap from AbstractionMap<br>
 * <br>
 * @author Bob Monroe
 */

public abstract class AcmeAbstractionMap extends AcmeObject
                                         implements Exportable, ArmaniExportable
{
 /**
  * This is an abstract method
  * @param s AcmeOutputStream
  * @exception java.io.IOException For I/O exception
  */
   public abstract void exportAcme (AcmeOutputStream s)
                            throws java.io.IOException;
 /**
  * This is an abstract method
  * @param s AcmeOutputStream
  * @exception java.io.IOException For I/O exception
  */
   public abstract void exportArmani (AcmeOutputStream s)
                            throws java.io.IOException;
 /**
  * This is an abstract method
  * @return AcmeAbstractionMap
  */
   public abstract AcmeAbstractionMap copy();
 /**
  * This is an abstract method
  * @return AcmeAbstractionMap
  */
   public abstract AcmeAbstractionMap copyAsUnresolvedAbsMap();
 /**
  * This is an abstract method
  */
   public abstract void resolveInstanceReferences();
 /**
  * This is an abstract method
  */
   public abstract void resolveTypeReferences();

 /**
  * resets all entities stored in the Abstraction map to point
  * at newParentRep as appropriate.
  * @param newParentRep AcmeRepresentation
  */
   public abstract void setParentRep(AcmeRepresentation newParentRep);
};
