/*
 * Created on Mar 21, 2005
 */
package acmeLib.tools;

import acmeLib.elements.AcmeDesign;

/**
 * @author Shang-Wen Cheng (zensoul@cs.cmu.edu)
 * 
 * Event object to indicate changes in an AcmeDesign object.
 */
public class AcmeDesignChangeEvent {
    private String _canonPath = null;
    private AcmeDesign _oldDesign = null;
    private AcmeDesign _newDesign = null;

    public AcmeDesignChangeEvent (String canonPath, AcmeDesign oldDesign, AcmeDesign newDesign) {
        _canonPath = canonPath;
        _oldDesign = oldDesign;
        _newDesign = newDesign;
    }

    public String getCanonicalPath () {
        return _canonPath;
    }

    public AcmeDesign getOldDesign () {
        return _oldDesign;
    }

    public AcmeDesign getNewDesign () {
        return _newDesign;
    }
}
