package acmeLib.tools.converters;

import acmeLib.core.container.AcmeEnumeration;
import acmeLib.elements.AcmeElement;
import acmeLib.properties.AcmeProperty;
import acmeLib.tools.WalkerElementOperation;

/**
 * @author schmerl
 *
 */
public class AcmeStudioPropertyStripper implements WalkerElementOperation {

	/**
	 * Constructor for AcmeStudioPropertyStripper.
	 */
	public AcmeStudioPropertyStripper() {
		super();
	}

	/**
	 * @see acmeLib.tools.WalkerElementOperation#doElementOp(AcmeElement)
	 */
	public void doElementOp(AcmeElement elt) {
		AcmeEnumeration props = elt.getProperties();
		while (props.moreItems ()) {
			AcmeProperty currProp = (AcmeProperty )props.getNextItem ();
			String name = currProp.getName ();
			if (name.indexOf ("vis-") != -1) {
				// property is an AcmeStudio property, so delete it
				elt.removeProperty (name);	
			}
				
		}
	}

}
