
package acmeLib.tools.junli;

import acmeLib.*;
import acmeLib.core.filters.*;
import acmeLib.elements.*;

/**
 * Filter that removes all objects that are not AcmePortTypes
 */
public class ArcTypeEnumFilter extends AcmeObjectFilter {
    /**
     * @param obj the object to be tested
     * @return whether obj is an instance of the Arc Component Type
     */
    public boolean test(AcmeObject obj) {
        if (!(obj instanceof AcmeComponent)) {
            return false;
        } else {
            return ArcAnalyzer.compIsArc((AcmeComponent) obj);
        }
    };

};

