

package acmeLib.tools.junli;

 import acmeLib.core.container.AcmeEnumeration;
import acmeLib.designRules.DesignRuleEvalException;
import acmeLib.designRules.ExpressionNode;
import acmeLib.elements.AcmeComponent;
import acmeLib.elements.AcmeElement;
import acmeLib.elements.AcmePort;
import acmeLib.representations.AcmeBinding;
import acmeLib.representations.AcmeBindingsMap;
import acmeLib.representations.AcmeRepresentation;


public class ExtendedPredicates {


/**to determine whether two ports are associated by a binding or not
   the first element is the outer port and the second element is the inner port
*/
public static boolean isBinding(ExpressionNode  elementNode1,
     ExpressionNode elementNode2) throws DesignRuleEvalException {
  AcmeElement element1 = null;
  AcmeElement element2 = null;

  try {
      element1 = elementNode1.evaluateAsElement();
  }
  catch (ClassCastException ccExc) {
      throw new DesignRuleEvalException("Unable to cast the Element 1 Argument"
          + " passed to isBinding(.) External Analysis");
  }
  catch (DesignRuleEvalException drExc) {
      throw new DesignRuleEvalException("Unable to evaluate the Element 1 Argument"
   + " passed to isBinding(.) Extenal Analysis");
  }

  try {
        element2 = elementNode2.evaluateAsElement();
  }
  catch (ClassCastException ccExc) {
      throw new DesignRuleEvalException("Unable to cast the Element 2 Argument"
          + " passed to isBinding(.) External Analysis");
  }
  catch (DesignRuleEvalException drExc) {
      throw new DesignRuleEvalException("Unalbe to evaluate the Element 2 Argument"
   + " passed to isBinding(.) Extenal Analysis");
  }

  boolean result = false;

  if ( (element1 instanceof AcmePort) &&
         (element2 instanceof AcmePort) ) {
       AcmePort port1 = (AcmePort)element1;
       AcmePort port2 = (AcmePort)element2;

       AcmeComponent component = (AcmeComponent)port1.getParent();
       AcmeEnumeration reps = component.getRepresentations();
       //since one one representation can be supported in our system modeling
       AcmeRepresentation representation =
(AcmeRepresentation)reps.getNextItem();
       AcmeEnumeration bindings =
          ( (AcmeBindingsMap)representation.getAbstractionMap()).getBindings();
       while (bindings.moreItems()) {
         AcmeBinding aBinding = (AcmeBinding)bindings.getNextItem();
         AcmePort outerPort = (AcmePort)aBinding.getOuter();
         AcmePort innerPort = (AcmePort)aBinding.getInner();
         if  ( (outerPort.equals(port1)) && (innerPort.equals(port2) )) {
            result = true;
            break;
         }
       }

       return result;
  }
  else {
     throw new DesignRuleEvalException("Arguments passed in do not have required types"
        + " in isBinding(.) External Analysis");
  }

 }


}