/**some kinds of misc testing */

package acmeLib.tools.junli;

import acmeLib.AcmeType;
import acmeLib.core.container.AcmeEnumeration;
import acmeLib.designRules.*;
import acmeLib.elements.*;
import acmeLib.properties.SetType;
import acmeLib.typeManagement.AcmeTypeManager;

public class MiscTesting {

	public static boolean isSafety(ExpressionNode ElementNode) throws DesignRuleEvalException {

		AcmeElement element = null;

		try {
			element = ElementNode.evaluateAsElement();
		}
		catch (ClassCastException ccExc) {
			throw new DesignRuleEvalException(
				"unable to cast the element argument" + "passed to isSafety(.) external analysis");
		}
		catch (DesignRuleEvalException drExc) {
			throw new DesignRuleEvalException(
				"unable to evalue the element argument" + "passed to isSafety(.) external analyss");
		}

		if (!(element instanceof AcmeSystem)) {
			throw new DesignRuleEvalException("unable to evaluate the element argument as AcmeSystem in isSafety(.) external analysis");
		}
		else {
			AcmeSystem sys = (AcmeSystem) element;
			AcmeEnumeration candidateComps = new AcmeEnumeration();
			AcmeEnumeration components = sys.getComponents();
			while (components.moreItems()) {
				AcmeComponent comp = (AcmeComponent) components.getNextItem();
				AcmeEnumeration declTypes = comp.getDeclaredTypes();
				while (declTypes.moreItems()) {
					AcmeComponentType aType = (AcmeComponentType) declTypes.getNextItem();
					if (aType.getTypeName().equalsIgnoreCase("SafetyVariant")) {
						candidateComps.insertItem(comp);
						break;
					}
				}
			} //end for all components

			/*
			       TransientSet retValSet = new TransientSet(candidateComps.castToAcmeVector());
			       AcmeType unionedType = AcmeTypeManager.inferLeastCommonSupertype(
			          candidateComps.castToAcmeVector());
			       retValSet.setType(new SetType (unionedType.getTypeName(), unionedType));
			       retValSet.setSetType(unionedType);
			
			       return retValSet;
			       */
			return (candidateComps.getSize() == 1);

		}
	} //end of method: portsConnectedFromPort(.)

	//-------------------------------------
	public static SetExpressionNode ARC_inputs(ExpressionNode ElementNode) throws DesignRuleEvalException {

		AcmeElement element = null;

		try {
			element = ElementNode.evaluateAsElement();
		}
		catch (ClassCastException ccExc) {
			throw new DesignRuleEvalException(
				"unable to cast the element argument" + "passed to ARC_inputs(.) external analysis");
		}
		catch (DesignRuleEvalException drExc) {
			throw new DesignRuleEvalException(
				"unable to evalue the element argument" + "passed to ARC_inputs(.) external analyss");
		}

		if (!(element instanceof AcmeComponent)) {
			throw new DesignRuleEvalException("unable to evaluate the element argument as AcmeComponent in isSafety(.) external analysis");
		}
		else {
			AcmeComponent comp = (AcmeComponent) element;
			AcmeEnumeration ports = comp.getPorts();
			AcmeEnumeration result = new AcmeEnumeration();

			//get the MSInputPort type first
			AcmeSystem sys = (AcmeSystem) comp.getParent();
			Object foundObj = sys.lookupName("MSInputPort", true);
			AcmePortType MSInputPortType = (AcmePortType) foundObj;

			while (ports.moreItems()) {
				AcmePort port = (AcmePort) ports.getNextItem();
				AcmeEnumeration declTypes = port.getDeclaredTypes();
				while (declTypes.moreItems()) {
					AcmeElementType theType = (AcmeElementType) declTypes.getNextItem();
					if (theType instanceof AcmeElementTypeRef) {
						theType = ((AcmeElementTypeRef) theType).getReferentType();
					}
					if (AcmeTypeManager.isDeclaredSubtype(theType, MSInputPortType)) {
						result.insertItem(port);
						break;
					}
				}
			}

			TransientSet retValSet = new TransientSet(result.castToAcmeVector());
			AcmeType unionedType = AcmeTypeManager.inferLeastCommonSupertype(result.castToAcmeVector());
			retValSet.setType(new SetType(unionedType.getTypeName(), unionedType));
			retValSet.setSetType(unionedType);
			System.out.println("component: " + comp.getName() + "has number of MSInputPort : " + result.getSize());

			return retValSet;

			// return (candidateComps.getSize() ==1 );

		}
	}

}