/* Generated By:JavaCC: Do not edit this line. AcmeParser.java */
package acmeLib.acmeParser;

// imports to work with AcmeLib.
import acmeLib.*;
import acmeLib.core.container.*;
import acmeLib.core.exceptions.*;
import acmeLib.core.globals.*;
import acmeLib.core.io.AcmeOutputStream;
import acmeLib.designRules.*;
import acmeLib.elements.*;
import acmeLib.errorManagement.*;
import acmeLib.properties.*;
import acmeLib.typeManagement.*;
import acmeLib.representations.*;
import acmeLib.gui.*;

import java.util.*;
import java.io.*;

/**
 * 
 * @author Bradley Schmerl
 * Created Jun 30, 2003
 * @deprecated
 */
public class AcmeParser implements AcmeParserConstants {

    // protected globals available during parsing
    protected static AcmeDesign global_design;
    protected static AcmeDesign toplevel_design;

    protected static Stack warning_stack = new Stack();
    protected static Stack error_stack = new Stack();

    // kludgy way of dealing with jjtree expression parser's parenthesization
    protected static int parenDepth = 0;

    public static void main(String args[]) {
        String ParserID = new String("Acme v3.0 Parser (release 0.1)");
        String canonicalInputFilename = null;
        OutputStream oStream = null;
        AcmeParser parser;
        if (args.length == 0) {
            System.out.println(ParserID + ":  Reading from standard input . . .");
            parser = new AcmeParser(System.in);
            canonicalInputFilename = "System.in";
            oStream = System.out;
        } else if (args.length == 1) {
            System.out.println(ParserID + ":  Reading from file " +
                             args[0] + " . . .");
          try {
            parser = new AcmeParser(new java.io.FileInputStream(args[0]));
            java.io.File inputFile = new java.io.File(args[0]);
            try {
                canonicalInputFilename = inputFile.getCanonicalPath();
            } catch (java.io.IOException ioExc) {
                canonicalInputFilename = args[0];
            };
            oStream = System.out;
          } catch (java.io.FileNotFoundException e) {
                System.out.println(ParserID + ":  File " + args[0] + " not found.");
                return;
          }
        } else if (args.length == 2) {
            System.out.println(ParserID + ":  Reading from file "
                               + args[0] + " . . .\n"
                               + "Writing to file " + args[1] + " . . .");
            try {
               parser = new AcmeParser(new java.io.FileInputStream(args[0]));
               java.io.File inputFile = new java.io.File(args[0]);
               try {
                    canonicalInputFilename = inputFile.getCanonicalPath();
               } catch (java.io.IOException ioExc) {
                    canonicalInputFilename = args[0];
               };
               oStream = new FileOutputStream(args[1]);
            } catch (java.io.IOException e) {
                System.out.println(ParserID + ":  File " + args[1] + " not found.");
                return;
            }
        } else {
            System.out.println("Acme v3.0 Parser (release 0.1):  " +
                             "Usage is one of:");
            System.out.println("         java AcmeParser");
            System.out.println("            -- for command-line interpreter from stdin");
            System.out.println("OR");
            System.out.println("         java AcmeParser < inputfile");
            System.out.println("            -- for batch-style command-line interpretation");
            System.out.println("OR");
            System.out.println("         java AcmeParser inputfile");
            System.out.println("            -- to directly parse the Acme file inputfile");
            System.out.println("               or for batch-style command-line interpretation");            System.out.println("OR");
            System.out.println("         java AcmeParser inputfile outputfile");
            System.out.println("            -- to directly parse the Acme file inputfile\n"
                              +"               and export the Acme design to the file outputfile");
            return;
        }

        // initialize the design and start the command interpreter.
        try {
            // set the parser up to tracing and debugging off unless
            // the user explicitly turns it on.
            parser.disable_tracing();

            // initialize the design (by default)
            initDesign();
            global_design.setCanonicalFilename(canonicalInputFilename);
            global_design = parser.parse_AcmeDesign();
            System.out.println(ParserID +
                          ":  Acme specification parsed successfully.");

            // store the toplevel design, so that the parser can be run
            // on any "imported" design files.
            toplevel_design = global_design;

            // clear all errors from the AcmeErrorManager so that we have
            // a clean slate from which to do processing.
            AcmeErrorManager.clearAllErrors();

            // resolve all imported designs.
            System.err.print("--> Resolving Imported Designs ...");
            global_design.resolveImportedDesigns();
            // check whether any errors were encountered, if so then bail.
            if (AcmeErrorManager.getNumErrorsReported() != 0) {
                System.err.println(" ** Errors found: ** ");
                AcmeErrorManager.printAllErrors(System.err);
                System.err.flush();
                throw new acmeLib.acmeParser.ParseError("import statement error");
            };
            System.err.println(" done.");

            // resolve all names
            System.err.print("--> Resolving Type Names ...");
            toplevel_design.resolveTypeReferences();
            // check whether any errors were encountered, if so then bail.
            if (AcmeErrorManager.getNumErrorsReported() != 0) {
                System.err.println(" ** Errors found: ** ");
                AcmeErrorManager.printAllErrors(System.err);
                System.err.flush();
                throw new acmeLib.acmeParser.ParseError("typename resolution error");
            };
            System.err.println(" done.");

            // instantiate uninstantiated instances of types
            System.err.print("--> Instantiating elements ...");
            // check whether any errors were encountered, if so then bail.
            if (AcmeErrorManager.getNumErrorsReported() != 0) {
                System.err.println(" ** Errors found: ** ");
                AcmeErrorManager.printAllErrors(System.err);
                System.err.flush();
                throw new acmeLib.acmeParser.ParseError("element instantiation error");
            };
            toplevel_design.instantiateElements();
            System.err.println(" done.");

            // resolve instance names/references
            System.err.print("--> Resolving Instance Names ...");
            toplevel_design.resolveInstanceReferences();
            // check whether any errors were encountered, if so then bail.
            if (AcmeErrorManager.getNumErrorsReported() != 0) {
                System.err.println(" ** Errors found: ** ");
                AcmeErrorManager.printAllErrors(System.err);
                System.err.flush();
                throw new acmeLib.acmeParser.ParseError("instance name resolution error");
            };
            System.err.println(" done.");
            System.err.flush();

            // export
            export_AcmeDesign(oStream, toplevel_design);

            // typecheck
            typecheckDesign(toplevel_design);

            // view any errors generated
//            viewErrors();

            // repeat
            pause_for_input();
        } catch (acmeLib.acmeParser.ParseError e) {
            System.out.println(ParserID +
                         ":  Encountered errors during Acme specification parse.");
            e.printStackTrace();
            printWarningMsgs();
            printErrorMsgs();
            pause_for_input();

        } catch (acmeLib.armaniParser.ParseError e) {
            System.out.println(ParserID +
                         ":  Encountered errors during Acme specification parse.");
            e.printStackTrace();
            printWarningMsgs();
            printErrorMsgs();
            pause_for_input();
        }


    }   // end main method


    //
    // print out warning and error statements
    //
    public static void printWarningMsgs() {
        String cur_msg;
        try {
            while(!warning_stack.empty()) {
                cur_msg = (String) warning_stack.pop();
                if (cur_msg != null)
                    System.err.println("Warning: " + cur_msg);
            };
        } catch (EmptyStackException e) {
            // fall through, all warnings were printed
        };
    }


    public static void printErrorMsgs() {
        String cur_msg;
        try {
            while(!error_stack.empty()) {
                cur_msg = (String) error_stack.pop();
                if (cur_msg != null)
                    System.err.println("Error: " + cur_msg);
            };
        } catch (EmptyStackException e) {
            // fall through, all errors were printed
        };
    }


    public static java.util.Vector getWarningMsgs() {
        String cur_msg;
        java.util.Vector msgs = new java.util.Vector();
        try {
            while(!warning_stack.empty()) {
                cur_msg = (String) warning_stack.pop();
                if (cur_msg != null) {
                    msgs.addElement(new String("Warning: " + cur_msg));
                };
            };
        } catch (EmptyStackException e) {
            // fall through, all warnings were printed
        };
        return msgs;
    }


    public static java.util.Vector getErrorMsgs() {
        String cur_msg;
        java.util.Vector msgs = new java.util.Vector();
        try {
            while(!error_stack.empty()) {
                cur_msg = (String) error_stack.pop();
                if (cur_msg != null) {
                    msgs.addElement(new String("Error: " + cur_msg));
                };
            };
        } catch (EmptyStackException e) {
            // fall through, all warnings were printed
        };
        return msgs;
    }


    //
    // retrieve and initialize warning and error stacks.
    //
    public static java.util.Stack getWarningStack() {
        return warning_stack;
    }

    public static java.util.Stack getErrorStack() {
        return error_stack;
    }

    public static void initErrorStack() {
        error_stack = new java.util.Stack();
    }

    public static void initWarningStack() {
        warning_stack = new java.util.Stack();
    }



    public static void pause_for_input() {
        System.out.println("Please press enter to continue");
        try {
            System.in.read();
        } catch (java.io.IOException e) {
            return;
        }
    }


    //
    // typechecking methods for various parts of the design
    //
    public static void typecheckSystemComponents(AcmeSystem sys) {
        AcmeEnumeration comps = sys.getComponents();
        while (comps.moreItems()) {
            AcmeComponent c = (AcmeComponent) comps.getNextItem();
            boolean typechecks = c.typecheck();
            System.out.println("Component " + c.getName()  + " typechecks = "
                               + c.typecheck());
        };
    }


    public static void typecheckSystemConnectors(AcmeSystem sys) {
        AcmeEnumeration conns = sys.getConnectors();
        while (conns.moreItems()) {
            AcmeConnector c = (AcmeConnector) conns.getNextItem();
            if (c.getDeclaredTypes().getSize() == 0) {
                System.out.println("Connector " + c.getName()
                   + " claims only to be of type Connector");
            } else {
                System.out.println("Connector " + c.getName()  + " typechecks = "
                                   + AcmeTypeManager.typecheckConnector(c));
            }
        };
    }



    public static void typecheckSystemPorts(AcmeSystem sys) {
        AcmeEnumeration ports = sys.getPorts();
        while (ports.moreItems()) {
            AcmePort p = (AcmePort) ports.getNextItem();
            if (p.getDeclaredTypes().getSize() == 0) {
                System.out.println("Port " + p.getName()
                   + " claims only to be of type Port");
            } else {
                System.out.println("Port " + p.getName()  + " typechecks = "
                                   + AcmeTypeManager.typecheckPort(p));
            }
        };
    }


    public static void typecheckSystemRoles(AcmeSystem sys) {
        AcmeEnumeration roles = sys.getRoles();
        while (roles.moreItems()) {
            AcmeRole r = (AcmeRole) roles.getNextItem();
            if (r.getDeclaredTypes().getSize() == 0) {
                System.out.println("Role " + r.getName()
                   + " claims only to be of type Role");
            } else {
                System.out.println("Role " + r.getName()  + " typechecks = "
                                   + AcmeTypeManager.typecheckRole(r));
            }
        };
    }



    //
    // publicly available methods for manipulating the parser
    //

    public static void initDesign() {

        // instantiate a new AcmeDesign and envt. support.
        global_design = new AcmeDesign();

        // clear up space for the parse, as we'll probably need it :-)
        System.gc();

        // if the toplevel design is null, set it to the current global_design.
        // if it is not null, then we are (probably) reinitializing the parser
        // to parse an imported design so don't change the toplevel design.
        if (toplevel_design == null) {
            toplevel_design = global_design;
        };

    }


    public static void export_AcmeDesign(OutputStream out_stream)
    {
        export_AcmeDesign(out_stream, toplevel_design);
    }

    public static void export_AcmeDesign(OutputStream out_stream, AcmeDesign design)
    {
        AcmeOutputStream s = new AcmeOutputStream();
        try {
            design.exportAcme(s);

            if (out_stream == null) {
                s.writeTo(System.out);
                s.flush();
            } else {
                s.writeTo(out_stream);
                s.flush();
            };
        } catch (Exception ex) {
            System.out.println("Caught Exception in AcmeDesign.exportAcme");
            ex.printStackTrace();
            pause_for_input();
        };
    }


    // view the errors generated by this parsing.
    public static void viewErrors() {
/*        ErrorWorkshopFrame errorWks = new ErrorWorkshopFrame("Error Viewer");
        errorWks.setErrorManager(new AcmeErrorManager());
        errorWks.setVisible(true);
        errorWks.toFront();
*/
    }


    // typecheck the entire design
    public static boolean typecheckDesign(AcmeDesign design) {
        // typecheck the whole dang shootin' match:
        System.out.print("--> Typechecking ...");
        boolean designTypechecks = design.typecheck();
        if (designTypechecks) {
            System.out.println(" done. Design typechecks.");
            return true;
        }
            // dump any errors that resulted from typechecking the design
            System.out.println(" done. Design _does_not_ typecheck.");
            AcmeEnumeration e = AcmeErrorManager.getErrors();
            int i = 1;
            while(e.moreItems()) {
                AcmeError err = (AcmeError) e.getNextItem();
                System.out.println(i + ") " + err.toString());
                i++;
            };
            return false;
    }


    public static void test_copyAsPrototype(String typeName)
      throws ParseError
    {
        AcmeComponent test_comp = ComponentDeclaration();
        AcmeComponentType gen_type =
                    (AcmeComponentType) test_comp.copyAsPrototype(typeName);

        AcmeOutputStream s = new AcmeOutputStream();
        try {
            System.out.println("\n" + "Original component declaration:\n");
            test_comp.exportAcme(s);

            System.out.println("\n" + "Copied type declaration:\n");
            gen_type.exportAcme(s);

            s.writeTo(System.out);
            s.flush();
        } catch (Exception ex) {
            System.out.println("Caught Exception while exporting Acme");
            ex.printStackTrace();
            pause_for_input();
        };

    }

    // accessor/settor methods
    public static AcmeDesign getGlobalDesign() { return global_design; }
    public static AcmeDesign getToplevelDesign() { return toplevel_design; }
    public static void setToplevelDesign(AcmeDesign newToplevelDesign) {
        toplevel_design = newToplevelDesign;
    }

/*****************************************
 * ACME grammar starts here              *
 *****************************************/

/*
 *  design productions (toplevel production)
 */
  static final public AcmeDesign parse_AcmeDesign() throws ParseException {
    trace_call("parse_AcmeDesign");
    try {
    String filename;
    Token filenameToken;
    AcmeType new_type;
    AcmeSystem new_system;
    AcmeFamily new_family;
    DesignAnalysis new_designAnalysis;
    AcmeProperty new_prop = null;
    AcmeEnumeration child_enum = null;
      label_1:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case IMPORT:
          ;
          break;
        default:
          jj_la1[0] = jj_gen;
          break label_1;
        }
        jj_consume_token(IMPORT);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case IDENTIFIER:
        case REM:
        case 97:
          filename = Filename();
          jj_consume_token(SEMICOLON);
          break;
        case STRING_LITERAL:
          filenameToken = jj_consume_token(STRING_LITERAL);
          jj_consume_token(SEMICOLON);
                filename = filenameToken.image;
          break;
        default:
          jj_la1[1] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
            // make sure that we have the appropriate separator character
            // for either Unix or Windows (don't know about other file systems...)
            filename = filename.replace('\\',java.io.File.separatorChar);
            filename = filename.replace('/',java.io.File.separatorChar);

            global_design.addDesignToImport(filename);
      }
      label_2:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SYSTEM:
        case COMPONENT:
        case CONNECTOR:
        case PORT:
        case ROLE:
        case ELEMENT:
        case PROPERTY:
        case PROPERTIES:
        case FAMILY:
          ;
          break;
        default:
          jj_la1[2] = jj_gen;
          break label_2;
        }
        if (jj_2_1(2)) {
          new_type = TypeDeclaration();
            if (new_type instanceof AcmePropertyType) {
                ((AcmePropertyType) new_type).setDeclarationScope(global_design);
            } else if (new_type instanceof AcmeElementType) {
                ((AcmeElement) new_type).setParentDesign(global_design);
                ((AcmeElement) new_type).setParent(global_design);
            } else {
                error_stack.push(new String("Line " + /*error_line +*/
                        ": Type " + new_type.getTypeName()
                        + " is neither a property type nor an element type."));
                {if (true) throw new ParseException();}
            };

            try {
                global_design.addType(new_type);
            }
            catch (AcmeIllegalNameException ainExc) {
                error_stack.push(new String("Line " + /*error_line +*/
                        ": " + ainExc.getMessage()));
                {if (true) throw new ParseException();}
            };
        } else if (jj_2_2(2)) {
          new_family = FamilyDeclaration();
            try {
                global_design.addFamily(new_family);
                new_family.setParentDesign(global_design);
                new_family.setParent(global_design);
            }
            catch (AcmeIllegalNameException ainExc) {
                error_stack.push(new String("Line " + /*error_line +*/
                        ": " + ainExc.getMessage()));
                {if (true) throw new ParseException();}
            };
        } else {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case PROPERTY:
            new_prop = PropertyDeclaration(global_design);
          try {
            global_design.addProperty(new_prop);
          }
          catch (AcmeDuplicateNameException dupExc) {
                // there is already a property with the same name as
                // new_prop in this component.  attempt to unify new_prop
                // with the one that already exists.  If it's a duplicate
                // name, but it's not a property that has the name, just
                // rethrow the error.
                try {
                    AcmeProperty targetProp =
                                    global_design.getProperty(new_prop.getName());
                    if (targetProp == null) {
                        error_stack.push("(line " + /*error_line +*/ ") "
                                         + dupExc.getMessage());
                        {if (true) throw new ParseException();}
                    } else {
                        // attempt to unify the new_port with the existing one.
                        AcmeTypeManager.extendProperty(new_prop, targetProp);
                    };
                } catch (AcmePropertyExtensionFailedException pefExc) {
                    error_stack.push("(line " + /*error_line +*/ ") "
                                     + pefExc.getMessage());
                    {if (true) throw new ParseException();}
                };
          } catch (AcmeIllegalNameException e) {
                error_stack.push("(line " + /*error_line +*/ ") "
                                 + e.getMessage());
                {if (true) throw new ParseException();}
          };
            break;
          case PROPERTIES:
            child_enum = PropertiesBlock(global_design);
          while (child_enum.moreItems()) {
            new_prop = (AcmeProperty) child_enum.getNextItem();
            try {
                global_design.addProperty(new_prop);
            }
            catch (AcmeDuplicateNameException dupExc) {
                // there is already a property with the same name as
                // new_prop in this component.  attempt to unify new_prop
                // with the one that already exists.  If it's a duplicate
                // name, but it's not a property that has the name, just
                // rethrow the error.
                try {
                    AcmeProperty targetProp =
                                    global_design.getProperty(new_prop.getName());
                    if (targetProp == null) {
                        error_stack.push("(line " + /*error_line +*/ ") "
                                         + dupExc.getMessage());
                        {if (true) throw new ParseException();}
                    } else {
                        // attempt to unify the new_port with the existing one.
                        AcmeTypeManager.extendProperty(new_prop, targetProp);
                    };
                } catch (AcmePropertyExtensionFailedException pefExc) {
                    error_stack.push("(line " + /*error_line +*/ ") "
                                     + pefExc.getMessage());
                    {if (true) throw new ParseException();}
                };
            } catch (AcmeIllegalNameException e) {
                error_stack.push("(line " + /*error_line +*/ ") "
                                 + e.getMessage());
                {if (true) throw new ParseException();}
            };
          }
          // mark the enumeration for gc.
          child_enum = null;
            break;
          case SYSTEM:
            new_system = SystemDeclaration();
          try {
              global_design.addSystem(new_system);
          } catch (AcmeIllegalNameException e) {
                error_stack.push("(line " + /*error_line +*/ ") "
                                 + e.getMessage());
                {if (true) throw new ParseException();}
          };
            break;
          default:
            jj_la1[3] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
      }
      jj_consume_token(0);
        {if (true) return global_design;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("parse_AcmeDesign");
    }
  }

  static final public String Filename() throws ParseException {
    trace_call("Filename");
    try {
    Token curIdToken, curSeparator;
    String tokenStr = null;
    StringBuffer buf = new StringBuffer();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case REM:
      case 97:
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case 97:
          jj_consume_token(97);
            buf.append("$");
          break;
        case REM:
          jj_consume_token(REM);
                                       buf.append("%");
          break;
        default:
          jj_la1[4] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        break;
      default:
        jj_la1[5] = jj_gen;
        ;
      }
      curIdToken = jj_consume_token(IDENTIFIER);
        buf.setLength(0);
        buf.append(curIdToken.image);
      label_3:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case DOT:
        case COLON:
        case PLUS:
        case MINUS:
        case SLASH:
        case REM:
        case 97:
        case 98:
        case 99:
          ;
          break;
        default:
          jj_la1[6] = jj_gen;
          break label_3;
        }
        label_4:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case DOT:
            curSeparator = jj_consume_token(DOT);
            break;
          case COLON:
            curSeparator = jj_consume_token(COLON);
            break;
          case MINUS:
            curSeparator = jj_consume_token(MINUS);
            break;
          case PLUS:
            curSeparator = jj_consume_token(PLUS);
            break;
          case 98:
            curSeparator = jj_consume_token(98);
            break;
          case 99:
            curSeparator = jj_consume_token(99);
            break;
          case SLASH:
            curSeparator = jj_consume_token(SLASH);
            break;
          case 97:
            curSeparator = jj_consume_token(97);
            break;
          case REM:
            curSeparator = jj_consume_token(REM);
            break;
          default:
            jj_la1[7] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
                buf.append(curSeparator.image);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case DOT:
          case COLON:
          case PLUS:
          case MINUS:
          case SLASH:
          case REM:
          case 97:
          case 98:
          case 99:
            ;
            break;
          default:
            jj_la1[8] = jj_gen;
            break label_4;
          }
        }
        curIdToken = jj_consume_token(IDENTIFIER);
            buf.append(curIdToken.image);
      }
        {if (true) return buf.toString();}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("Filename");
    }
  }

  static final public AcmeFamily FamilyDeclaration() throws ParseException {
    trace_call("FamilyDeclaration");
    try {
    AcmeFamily new_family;
    Token cur_token;
    AcmeElementType cur_super_type;
      jj_consume_token(FAMILY);
      cur_token = jj_consume_token(IDENTIFIER);
        new_family = new AcmeFamily(cur_token.image);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SEMICOLON:
        jj_consume_token(SEMICOLON);
        break;
      case ASSIGN:
        jj_consume_token(ASSIGN);
        FamilyBody(new_family);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SEMICOLON:
          jj_consume_token(SEMICOLON);
          break;
        default:
          jj_la1[9] = jj_gen;
          ;
        }
        break;
      case EXTENDS:
        jj_consume_token(EXTENDS);
        cur_super_type = lookup_SystemTypeByName();
            new_family.addSuperType(cur_super_type);
        label_5:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMMA:
            ;
            break;
          default:
            jj_la1[10] = jj_gen;
            break label_5;
          }
          jj_consume_token(COMMA);
          cur_super_type = lookup_SystemTypeByName();
                new_family.addSuperType(cur_super_type);
        }
        jj_consume_token(WITH);
        FamilyBody(new_family);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SEMICOLON:
          jj_consume_token(SEMICOLON);
          break;
        default:
          jj_la1[11] = jj_gen;
          ;
        }
        break;
      default:
        jj_la1[12] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    new_family.setParentDesign(global_design);
    // make every family be a subtype of the base "family" type.
    new_family.addSuperType(
                    acmeLib.core.globals.ConstantTypes.SYSTEM_BASE_TYPE);
    {if (true) return new_family;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("FamilyDeclaration");
    }
  }

  static final public void FamilyBody(AcmeFamily fam) throws ParseException {
    trace_call("FamilyBody");
    try {
    AcmeType new_type = null;
    DesignAnalysis new_designAnalysis = null;
    String new_type_name;
      if (jj_2_5(2)) {
        jj_consume_token(LBRACE);
        jj_consume_token(RBRACE);
      } else if (jj_2_6(2)) {
        jj_consume_token(LBRACE);
        label_6:
        while (true) {
          if (jj_2_3(2)) {
            new_type = TypeDeclaration();
          if (new_type != null) {
            if (new_type.getTypeName() != null) {
                if (fam.getType(new_type.getTypeName()) == null)  {
                    try {
                        fam.addType(new_type);
                    }
                    catch (AcmeIllegalNameException ainExc) {
                        error_stack.push(new String("Line " + /*error_line +*/
                                ": " + ainExc.getMessage()));
                        {if (true) throw new ParseException();}
                    };

                    if (new_type instanceof AcmeElement) {
                        // then new_type is an AcmeElementType
                        ((AcmeElement) new_type).setParent(fam);
                        ((AcmeElement) new_type).setParentDesign(global_design);
                    } else if (new_type instanceof AcmePropertyType) {
                        ((AcmePropertyType) new_type).setDeclarationScope(fam);
                    };
                } else {
                    // error, can't redefine a type within a family definition
                    error_stack.push(new String("Illegal redefinition of type "
                        + new_type.getTypeName() + " in family "
                        + fam.getName()));
                    {if (true) throw new ParseException();}
                };
            };
          };
          } else if (jj_2_4(2)) {
            SystemStructure(fam);
          } else {
            jj_consume_token(-1);
            throw new ParseException();
          }
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMPONENT:
          case COMPONENTS:
          case CONNECTOR:
          case CONNECTORS:
          case PORT:
          case PORTS:
          case ROLE:
          case ROLES:
          case ELEMENT:
          case ATTACHMENT:
          case ATTACHMENTS:
          case PROPERTY:
          case PROPERTIES:
          case REPRESENTATION:
            ;
            break;
          default:
            jj_la1[13] = jj_gen;
            break label_6;
          }
        }
        jj_consume_token(RBRACE);
      } else {
        jj_consume_token(-1);
        throw new ParseException();
      }
    } finally {
      trace_return("FamilyBody");
    }
  }

  static final public AcmeType TypeDeclaration() throws ParseException {
    trace_call("TypeDeclaration");
    try {
    AcmeType new_type;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMPONENT:
      case CONNECTOR:
      case PORT:
      case ROLE:
      case ELEMENT:
        new_type = ElementTypeDeclaration();
                                          {if (true) return new_type;}
        break;
      case PROPERTY:
        new_type = PropertyTypeDeclaration();
                                           {if (true) return new_type;}
        break;
      default:
        jj_la1[14] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("TypeDeclaration");
    }
  }

/*
 * Architectural element types
 */
  static final public AcmeElementType ElementTypeDeclaration() throws ParseException {
    trace_call("ElementTypeDeclaration");
    try {
    AcmeElementType new_type;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ELEMENT:
        new_type = ElementProtoTypeDeclaration();
        {if (true) return new_type;}
        break;
      case COMPONENT:
        new_type = ComponentTypeDeclaration();
        {if (true) return new_type;}
        break;
      case CONNECTOR:
        new_type = ConnectorTypeDeclaration();
        {if (true) return new_type;}
        break;
      case PORT:
        new_type = PortTypeDeclaration();
        {if (true) return new_type;}
        break;
      case ROLE:
        new_type = RoleTypeDeclaration();
        {if (true) return new_type;}
        break;
      default:
        jj_la1[15] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("ElementTypeDeclaration");
    }
  }

  static final public AcmeElementProtoType ElementProtoTypeDeclaration() throws ParseException {
    trace_call("ElementProtoTypeDeclaration");
    try {
    Token id_token;
    AcmeElementProtoType new_elt_type;
    AcmeElementType cur_super_type;
      if (jj_2_7(4)) {
        jj_consume_token(ELEMENT);
        jj_consume_token(TYPE);
        id_token = jj_consume_token(IDENTIFIER);
        new_elt_type = new AcmeElementProtoType(id_token.image);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ASSIGN:
          jj_consume_token(ASSIGN);
          parse_ElementProtoTypeDescription(new_elt_type);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case SEMICOLON:
            jj_consume_token(SEMICOLON);
            break;
          default:
            jj_la1[16] = jj_gen;
            ;
          }
          break;
        case SEMICOLON:
          jj_consume_token(SEMICOLON);
          break;
        default:
          jj_la1[17] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      } else if (jj_2_8(4)) {
        jj_consume_token(ELEMENT);
        jj_consume_token(TYPE);
        id_token = jj_consume_token(IDENTIFIER);
        new_elt_type = new AcmeElementProtoType(id_token.image);
        jj_consume_token(EXTENDS);
        cur_super_type = lookup_ComponentTypeByName();
        new_elt_type.addSuperType(cur_super_type);
        label_7:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMMA:
            ;
            break;
          default:
            jj_la1[18] = jj_gen;
            break label_7;
          }
          jj_consume_token(COMMA);
          cur_super_type = lookup_ComponentTypeByName();
            new_elt_type.addSuperType(cur_super_type);
        }
        jj_consume_token(WITH);
        parse_ElementProtoTypeDescription(new_elt_type);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SEMICOLON:
          jj_consume_token(SEMICOLON);
          break;
        default:
          jj_la1[19] = jj_gen;
          ;
        }
      } else {
        jj_consume_token(-1);
        throw new ParseException();
      }
    new_elt_type.setParentDesign(global_design);
    // make every element type be a subtype of the basic "element" type.
    new_elt_type.addSuperType(
                    acmeLib.core.globals.ConstantTypes.ELEMENT_BASE_TYPE);
    {if (true) return new_elt_type;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("ElementProtoTypeDeclaration");
    }
  }

  static final public AcmeComponentType ComponentTypeDeclaration() throws ParseException {
    trace_call("ComponentTypeDeclaration");
    try {
    Token id_token;
    AcmeComponentType new_comp_type;
    AcmeElementType cur_super_type;
      if (jj_2_9(4)) {
        jj_consume_token(COMPONENT);
        jj_consume_token(TYPE);
        id_token = jj_consume_token(IDENTIFIER);
        new_comp_type = new AcmeComponentType(id_token.image);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ASSIGN:
          jj_consume_token(ASSIGN);
          parse_ComponentDescription(new_comp_type);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case SEMICOLON:
            jj_consume_token(SEMICOLON);
            break;
          default:
            jj_la1[20] = jj_gen;
            ;
          }
          break;
        case SEMICOLON:
          jj_consume_token(SEMICOLON);
          break;
        default:
          jj_la1[21] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      } else if (jj_2_10(4)) {
        jj_consume_token(COMPONENT);
        jj_consume_token(TYPE);
        id_token = jj_consume_token(IDENTIFIER);
        new_comp_type = new AcmeComponentType(id_token.image);
        jj_consume_token(EXTENDS);
        cur_super_type = lookup_ComponentTypeByName();
        new_comp_type.addSuperType(cur_super_type);
        label_8:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMMA:
            ;
            break;
          default:
            jj_la1[22] = jj_gen;
            break label_8;
          }
          jj_consume_token(COMMA);
          cur_super_type = lookup_ComponentTypeByName();
            new_comp_type.addSuperType(cur_super_type);
        }
        jj_consume_token(WITH);
        parse_ComponentDescription(new_comp_type);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SEMICOLON:
          jj_consume_token(SEMICOLON);
          break;
        default:
          jj_la1[23] = jj_gen;
          ;
        }
      } else {
        jj_consume_token(-1);
        throw new ParseException();
      }
    new_comp_type.setParentDesign(global_design);
    // make every component type be a subtype of the basic "component" type.
    new_comp_type.addSuperType(
                    acmeLib.core.globals.ConstantTypes.COMPONENT_BASE_TYPE);
    {if (true) return new_comp_type;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("ComponentTypeDeclaration");
    }
  }

  static final public AcmeConnectorType ConnectorTypeDeclaration() throws ParseException {
    trace_call("ConnectorTypeDeclaration");
    try {
    Token id_token;
    AcmeConnectorType new_conn_type;
    AcmeElementType cur_super_type;
      if (jj_2_11(4)) {
        jj_consume_token(CONNECTOR);
        jj_consume_token(TYPE);
        id_token = jj_consume_token(IDENTIFIER);
        new_conn_type = new AcmeConnectorType(id_token.image);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ASSIGN:
          jj_consume_token(ASSIGN);
          parse_ConnectorDescription(new_conn_type);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case SEMICOLON:
            jj_consume_token(SEMICOLON);
            break;
          default:
            jj_la1[24] = jj_gen;
            ;
          }
          break;
        case SEMICOLON:
          jj_consume_token(SEMICOLON);
          break;
        default:
          jj_la1[25] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      } else if (jj_2_12(4)) {
        jj_consume_token(CONNECTOR);
        jj_consume_token(TYPE);
        id_token = jj_consume_token(IDENTIFIER);
        new_conn_type = new AcmeConnectorType(id_token.image);
        jj_consume_token(EXTENDS);
        cur_super_type = lookup_ConnectorTypeByName();
        new_conn_type.addSuperType(cur_super_type);
        label_9:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMMA:
            ;
            break;
          default:
            jj_la1[26] = jj_gen;
            break label_9;
          }
          jj_consume_token(COMMA);
          cur_super_type = lookup_ConnectorTypeByName();
            new_conn_type.addSuperType(cur_super_type);
        }
        jj_consume_token(WITH);
        parse_ConnectorDescription(new_conn_type);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SEMICOLON:
          jj_consume_token(SEMICOLON);
          break;
        default:
          jj_la1[27] = jj_gen;
          ;
        }
      } else {
        jj_consume_token(-1);
        throw new ParseException();
      }
    new_conn_type.setParentDesign(global_design);
    // make every connector type be a subtype of the basic "connector" type.
    new_conn_type.addSuperType(
                    acmeLib.core.globals.ConstantTypes.CONNECTOR_BASE_TYPE);
    {if (true) return new_conn_type;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("ConnectorTypeDeclaration");
    }
  }

  static final public AcmePortType PortTypeDeclaration() throws ParseException {
    trace_call("PortTypeDeclaration");
    try {
    Token id_token;
    AcmePortType new_port_type;
    AcmeElementType cur_super_type;
      if (jj_2_13(4)) {
        jj_consume_token(PORT);
        jj_consume_token(TYPE);
        id_token = jj_consume_token(IDENTIFIER);
        new_port_type = new AcmePortType(id_token.image);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ASSIGN:
          jj_consume_token(ASSIGN);
          parse_PortDescription(new_port_type);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case SEMICOLON:
            jj_consume_token(SEMICOLON);
            break;
          default:
            jj_la1[28] = jj_gen;
            ;
          }
          break;
        case SEMICOLON:
          jj_consume_token(SEMICOLON);
          break;
        default:
          jj_la1[29] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      } else if (jj_2_14(4)) {
        jj_consume_token(PORT);
        jj_consume_token(TYPE);
        id_token = jj_consume_token(IDENTIFIER);
        new_port_type = new AcmePortType(id_token.image);
        jj_consume_token(EXTENDS);
        cur_super_type = lookup_PortTypeByName();
        new_port_type.addSuperType(cur_super_type);
        label_10:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMMA:
            ;
            break;
          default:
            jj_la1[30] = jj_gen;
            break label_10;
          }
          jj_consume_token(COMMA);
          cur_super_type = lookup_PortTypeByName();
            new_port_type.addSuperType(cur_super_type);
        }
        jj_consume_token(WITH);
        parse_PortDescription(new_port_type);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SEMICOLON:
          jj_consume_token(SEMICOLON);
          break;
        default:
          jj_la1[31] = jj_gen;
          ;
        }
      } else {
        jj_consume_token(-1);
        throw new ParseException();
      }
    new_port_type.setParentDesign(global_design);
    // make every port type be a subtype of the basic "port" type.
    new_port_type.addSuperType(
                    acmeLib.core.globals.ConstantTypes.PORT_BASE_TYPE);
    {if (true) return new_port_type;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("PortTypeDeclaration");
    }
  }

  static final public AcmeRoleType RoleTypeDeclaration() throws ParseException {
    trace_call("RoleTypeDeclaration");
    try {
    Token id_token;
    AcmeRoleType new_role_type;
    AcmeElementType cur_super_type;
      if (jj_2_15(4)) {
        jj_consume_token(ROLE);
        jj_consume_token(TYPE);
        id_token = jj_consume_token(IDENTIFIER);
        new_role_type = new AcmeRoleType(id_token.image);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ASSIGN:
          jj_consume_token(ASSIGN);
          parse_RoleDescription(new_role_type);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case SEMICOLON:
            jj_consume_token(SEMICOLON);
            break;
          default:
            jj_la1[32] = jj_gen;
            ;
          }
          break;
        case SEMICOLON:
          jj_consume_token(SEMICOLON);
          break;
        default:
          jj_la1[33] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      } else if (jj_2_16(4)) {
        jj_consume_token(ROLE);
        jj_consume_token(TYPE);
        id_token = jj_consume_token(IDENTIFIER);
        new_role_type = new AcmeRoleType(id_token.image);
        jj_consume_token(EXTENDS);
        cur_super_type = lookup_RoleTypeByName();
        new_role_type.addSuperType(cur_super_type);
        label_11:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMMA:
            ;
            break;
          default:
            jj_la1[34] = jj_gen;
            break label_11;
          }
          jj_consume_token(COMMA);
          cur_super_type = lookup_RoleTypeByName();
            new_role_type.addSuperType(cur_super_type);
        }
        jj_consume_token(WITH);
        parse_RoleDescription(new_role_type);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SEMICOLON:
          jj_consume_token(SEMICOLON);
          break;
        default:
          jj_la1[35] = jj_gen;
          ;
        }
      } else {
        jj_consume_token(-1);
        throw new ParseException();
      }
    new_role_type.setParentDesign(global_design);
    // make every port type be a subtype of the basic "port" type.
    new_role_type.addSuperType(
                    acmeLib.core.globals.ConstantTypes.ROLE_BASE_TYPE);
    {if (true) return new_role_type;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("RoleTypeDeclaration");
    }
  }

//
// Type lookup productions
//
  static final public AcmeElementType lookup_SystemTypeByName() throws ParseException {
    trace_call("lookup_SystemTypeByName");
    try {
    Token id_token;
      id_token = jj_consume_token(IDENTIFIER);
        AcmeElementType newType = global_design.getFamily(id_token.image);
        if (newType == null)
            newType = new AcmeUnresolvedElementType(id_token.image);
        {if (true) return newType;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("lookup_SystemTypeByName");
    }
  }

  static final public AcmeElementType lookup_ComponentTypeByName() throws ParseException {
    trace_call("lookup_ComponentTypeByName");
    try {
    Token id_token;
      id_token = jj_consume_token(IDENTIFIER);
        {if (true) return new AcmeUnresolvedElementType(id_token.image);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("lookup_ComponentTypeByName");
    }
  }

  static final public AcmeElementType lookup_ConnectorTypeByName() throws ParseException {
    trace_call("lookup_ConnectorTypeByName");
    try {
    Token id_token;
      id_token = jj_consume_token(IDENTIFIER);
        {if (true) return new AcmeUnresolvedElementType(id_token.image);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("lookup_ConnectorTypeByName");
    }
  }

  static final public AcmeElementType lookup_PortTypeByName() throws ParseException {
    trace_call("lookup_PortTypeByName");
    try {
    Token id_token;
      id_token = jj_consume_token(IDENTIFIER);
        {if (true) return new AcmeUnresolvedElementType(id_token.image);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("lookup_PortTypeByName");
    }
  }

  static final public AcmeElementType lookup_RoleTypeByName() throws ParseException {
    trace_call("lookup_RoleTypeByName");
    try {
    Token id_token;
      id_token = jj_consume_token(IDENTIFIER);
        {if (true) return new AcmeUnresolvedElementType(id_token.image);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("lookup_RoleTypeByName");
    }
  }

  static final public AcmePropertyType lookup_PropertyTypeByName() throws ParseException {
    trace_call("lookup_PropertyTypeByName");
    try {
    Token id_token;
      id_token = jj_consume_token(IDENTIFIER);
        {if (true) return new AcmeUnresolvedPropertyType(id_token.image);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("lookup_PropertyTypeByName");
    }
  }

/** production for finding types that can be either elements or properties */
  static final public AcmeType lookup_arbitraryTypeByName() throws ParseException {
    trace_call("lookup_arbitraryTypeByName");
    try {
    Token id_token;
    AcmePropertyType propType = null;
    AcmeType returnType = null;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case FLOAT:
      case INT:
      case STRING:
      case BOOLEAN:
      case SET:
      case SEQUENCE:
      case RECORD:
      case ENUM:
      case ANY:
      case IDENTIFIER:
        propType = PropertyTypeDescription();
            if (!(propType instanceof AcmeUnresolvedPropertyType)) {
                returnType = propType;
            } else {
                returnType = new AcmeUnresolvedType(propType.getTypeName());
            };
        break;
      case SYSTEM:
        jj_consume_token(SYSTEM);
            returnType = acmeLib.core.globals.ConstantTypes.SYSTEM_BASE_TYPE;
        break;
      case COMPONENT:
        jj_consume_token(COMPONENT);
            returnType = acmeLib.core.globals.ConstantTypes.COMPONENT_BASE_TYPE;
        break;
      case CONNECTOR:
        jj_consume_token(CONNECTOR);
            returnType = acmeLib.core.globals.ConstantTypes.CONNECTOR_BASE_TYPE;
        break;
      case PORT:
        jj_consume_token(PORT);
            returnType = acmeLib.core.globals.ConstantTypes.PORT_BASE_TYPE;
        break;
      case ROLE:
        jj_consume_token(ROLE);
            returnType = acmeLib.core.globals.ConstantTypes.ROLE_BASE_TYPE;
        break;
      default:
        jj_la1[36] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
        {if (true) return returnType;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("lookup_arbitraryTypeByName");
    }
  }

/*
 * System declaration
 */
  static final public AcmeSystem SystemDeclaration() throws ParseException {
    trace_call("SystemDeclaration");
    try {
  AcmeSystem new_sys;
  AcmeElementType sys_type = null;
  Token system_name_id;
      jj_consume_token(SYSTEM);
      system_name_id = jj_consume_token(IDENTIFIER);
    new_sys = new AcmeSystem(system_name_id.image);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COLON:
        jj_consume_token(COLON);
        sys_type = lookup_SystemTypeByName();
        new_sys.addDeclaredType(sys_type);
        label_12:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMMA:
            ;
            break;
          default:
            jj_la1[37] = jj_gen;
            break label_12;
          }
          jj_consume_token(COMMA);
          sys_type = lookup_SystemTypeByName();
            new_sys.addDeclaredType(sys_type);
        }
        break;
      default:
        jj_la1[38] = jj_gen;
        ;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ASSIGN:
        jj_consume_token(ASSIGN);
        SystemBody(new_sys);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SEMICOLON:
          jj_consume_token(SEMICOLON);
          break;
        default:
          jj_la1[39] = jj_gen;
          ;
        }
        break;
      case SEMICOLON:
        jj_consume_token(SEMICOLON);
          // the declaration System foo : F;  is syntactic sugaring for
          // the declaration System foo : F = new F;
          // Likewise,
          // the declaration System foo : F1, ..., Fn; is equivalent to
          // the declaration System foo : F1, ..., Fn = new T1 extended with T2
          //                                                extended with ... TN.

          // so walk over the list of declared types, and add each one to the
          // list of instantiated types.  They will be properly instantiated
          // later.
          AcmeEnumeration e = new_sys.getDeclaredTypes();
          while (e.moreItems()) {
            new_sys.addInstantiatedType((AcmeElementType) e.getNextItem());
          };
        break;
      default:
        jj_la1[40] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
     new_sys.setParentDesign(global_design);
     {if (true) return new_sys;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("SystemDeclaration");
    }
  }

  static final public void SystemBody(AcmeSystem parent_sys) throws ParseException {
    trace_call("SystemBody");
    try {
    AcmeElementType new_type;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case NEW:
        jj_consume_token(NEW);
        new_type = lookup_SystemTypeByName();
        parent_sys.addInstantiatedType(new_type);
        label_13:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMMA:
            ;
            break;
          default:
            jj_la1[41] = jj_gen;
            break label_13;
          }
          jj_consume_token(COMMA);
          new_type = lookup_SystemTypeByName();
        parent_sys.addInstantiatedType(new_type);
        }
        break;
      default:
        jj_la1[43] = jj_gen;
        if (jj_2_17(2)) {
          jj_consume_token(LBRACE);
          jj_consume_token(RBRACE);
        } else if (jj_2_18(2)) {
          jj_consume_token(LBRACE);
          label_14:
          while (true) {
            SystemStructure(parent_sys);
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case COMPONENT:
            case COMPONENTS:
            case CONNECTOR:
            case CONNECTORS:
            case PORT:
            case PORTS:
            case ROLE:
            case ROLES:
            case ATTACHMENT:
            case ATTACHMENTS:
            case PROPERTY:
            case PROPERTIES:
            case REPRESENTATION:
              ;
              break;
            default:
              jj_la1[42] = jj_gen;
              break label_14;
            }
          }
          jj_consume_token(RBRACE);
        } else {
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case EXTENDED:
        jj_consume_token(EXTENDED);
        jj_consume_token(WITH);
        SystemBody(parent_sys);
        break;
      default:
        jj_la1[44] = jj_gen;
        ;
      }
    } finally {
      trace_return("SystemBody");
    }
  }

  static final public void SystemStructure(AcmeSystem parent_sys) throws ParseException {
    trace_call("SystemStructure");
    try {
    AcmeComponent comp = null;
    AcmeConnector conn = null;
    AcmePort port = null;
    AcmeRole role = null;
    AcmeAttachment attachment = null;
    AcmeProperty new_prop = null;
    AcmeRepresentation new_rep = null;
    AcmeEnumeration child_enum = null;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMPONENT:
        comp = ComponentDeclaration();
        try {
            parent_sys.addComponent(comp);
        }
        catch (AcmeDuplicateNameException dupExc) {
            // there is already a component with the same name as
            // comp in this system.  attempt to unify comp
            // with the one that already exists.  If it's a duplicate
            // name, but it's not a component that has the name, just
            // rethrow the error.
            AcmeComponent unifyTargetComp =
                                parent_sys.getComponent(comp.getName());
            if (unifyTargetComp == null) {
                error_stack.push("(line " + /*error_line +*/ ") "
                                 + dupExc.getMessage());
                {if (true) throw new ParseException();}
            } else {
                // attempt to unify the new_port with the existing one.
                AcmeTypeManager.unifyComponent(comp, unifyTargetComp);
            };
        }
        catch (AcmeIllegalNameException e) {
            error_stack.push("(line " + /*error_line +*/ ") "
                             + e.getMessage());
            {if (true) throw new ParseException();}
        };
        break;
      case COMPONENTS:
        child_enum = ComponentsBlock();
          while (child_enum.moreItems()) {
            comp = (AcmeComponent) child_enum.getNextItem();
            try {
                parent_sys.addComponent(comp);
            }
            catch (AcmeDuplicateNameException dupExc) {
                // there is already a component with the same name as
                // comp in this system.  attempt to unify comp
                // with the one that already exists.  If it's a duplicate
                // name, but it's not a component that has the name, just
                // rethrow the error.
                AcmeComponent unifyTargetComp =
                                    parent_sys.getComponent(comp.getName());
                if (unifyTargetComp == null) {
                    error_stack.push("(line " + /*error_line +*/ ") "
                                     + dupExc.getMessage());
                    {if (true) throw new ParseException();}
                } else {
                    // attempt to unify the new_port with the existing one.
                    AcmeTypeManager.unifyComponent(comp, unifyTargetComp);
                };
            }
            catch (AcmeIllegalNameException e) {
                error_stack.push("(line " + /*error_line +*/ ") "
                                 + e.getMessage());
                {if (true) throw new ParseException();}
            };
          }
          // mark the enumeration for gc.
          child_enum = null;
        break;
      case CONNECTOR:
        conn = ConnectorDeclaration();
        try {
            parent_sys.addConnector(conn);
        }
        catch (AcmeDuplicateNameException dupExc) {
            // there is already a connector with the same name as
            // conn in this system.  attempt to unify conn
            // with the one that already exists.  If it's a duplicate
            // name, but it's not a connector that has the name, just
            // rethrow the error.
            AcmeConnector unifyTargetConn =
                                parent_sys.getConnector(conn.getName());
            if (unifyTargetConn == null) {
                error_stack.push("(line " + /*error_line +*/ ") "
                                 + dupExc.getMessage());
                {if (true) throw new ParseException();}
            } else {
                // attempt to unify the new_port with the existing one.
                AcmeTypeManager.unifyConnector(conn, unifyTargetConn);
            };
        }
        catch (AcmeIllegalNameException e) {
            error_stack.push("(line " + /*error_line +*/ ") "
                             + e.getMessage());
            {if (true) throw new ParseException();}
        };
        break;
      case CONNECTORS:
        child_enum = ConnectorsBlock();
          while (child_enum.moreItems()) {
            conn = (AcmeConnector) child_enum.getNextItem();
            try {
                parent_sys.addConnector(conn);
            }
            catch (AcmeDuplicateNameException dupExc) {
                // there is already a connector with the same name as
                // conn in this system.  attempt to unify conn
                // with the one that already exists.  If it's a duplicate
                // name, but it's not a connector that has the name, just
                // rethrow the error.
                AcmeConnector unifyTargetConn =
                                    parent_sys.getConnector(conn.getName());
                if (unifyTargetConn == null) {
                    error_stack.push("(line " + /*error_line +*/ ") "
                                     + dupExc.getMessage());
                    {if (true) throw new ParseException();}
                } else {
                    // attempt to unify the new_port with the existing one.
                    AcmeTypeManager.unifyConnector(conn, unifyTargetConn);
                };
            }
            catch (AcmeIllegalNameException e) {
                error_stack.push("(line " + /*error_line +*/ ") "
                                 + e.getMessage());
                {if (true) throw new ParseException();}
            };
          }
          // mark the enumeration for gc.
          child_enum = null;
        break;
      case PORT:
        port = PortDeclaration();
        try {
            parent_sys.addPort(port);
        }
        catch (AcmeDuplicateNameException dupExc) {
            // there is already a port with the same name as
            // new_port in this component.  attempt to unify new_port
            // with the one that already exists.  If it's a duplicate
            // name, but it's not a port that has the name, just rethrow
            // the error.
            AcmePort unifyTargetPort = comp.getPort(port.getName());
            if (unifyTargetPort == null) {
                error_stack.push("(line " + /*error_line +*/ ") "
                                 + dupExc.getMessage());
                {if (true) throw new ParseException();}
            } else {
                // attempt to unify the new_port with the existing one.
                AcmeTypeManager.unifyPort(port, unifyTargetPort);
            };
        }
        catch (AcmeIllegalNameException e) {
            error_stack.push("(line " + /*error_line +*/ ") "
                             + e.getMessage());
            {if (true) throw new ParseException();}
        };
        break;
      case PORTS:
        child_enum = PortsBlock();
          while (child_enum.moreItems()) {
            port = (AcmePort) child_enum.getNextItem();
            try {
                parent_sys.addPort(port);
            }
            catch (AcmeDuplicateNameException dupExc) {
                // there is already a port with the same name as
                // new_port in this component.  attempt to unify new_port
                // with the one that already exists.  If it's a duplicate
                // name, but it's not a port that has the name, just rethrow
                // the error.
                AcmePort unifyTargetPort = comp.getPort(port.getName());
                if (unifyTargetPort == null) {
                    error_stack.push("(line " + /*error_line +*/ ") "
                                     + dupExc.getMessage());
                    {if (true) throw new ParseException();}
                } else {
                    // attempt to unify the new_port with the existing one.
                    AcmeTypeManager.unifyPort(port, unifyTargetPort);
                };
            }
            catch (AcmeIllegalNameException e) {
                error_stack.push("(line " + /*error_line +*/ ") "
                                 + e.getMessage());
                {if (true) throw new ParseException();}
            };
          }
          // mark the enumeration for gc.
          child_enum = null;
        break;
      case ROLE:
        role = RoleDeclaration();
        try {
            parent_sys.addRole(role);
        }
        catch (AcmeDuplicateNameException dupExc) {
            // there is already a role with the same name as
            // new_role in this connector.  attempt to unify new_role
            // with the one that already exists.  If it's a duplicate
            // name, but it's not a role that has the name, rethrow
            // the error.
            AcmeRole unifyTargetRole = conn.getRole(role.getName());
            if (unifyTargetRole == null) {
                error_stack.push("(line " + /*error_line +*/ ") "
                                 + dupExc.getMessage());
                {if (true) throw new ParseException();}
            } else {
                // attempt to unify the new_port with the existing one.
                AcmeTypeManager.unifyRole(role, unifyTargetRole);
            };
        }
        catch (AcmeIllegalNameException e) {
            error_stack.push("(line " + /*error_line +*/ ") "
                             + e.getMessage());
            {if (true) throw new ParseException();}
        };
        break;
      case ROLES:
        child_enum = RolesBlock();
          while (child_enum.moreItems()) {
            role = (AcmeRole) child_enum.getNextItem();
            try {
                parent_sys.addRole(role);
            }
            catch (AcmeDuplicateNameException dupExc) {
                // there is already a role with the same name as
                // new_role in this connector.  attempt to unify new_role
                // with the one that already exists.  If it's a duplicate
                // name, but it's not a role that has the name, rethrow
                // the error.
                AcmeRole unifyTargetRole = conn.getRole(role.getName());
                if (unifyTargetRole == null) {
                    error_stack.push("(line " + /*error_line +*/ ") "
                                     + dupExc.getMessage());
                    {if (true) throw new ParseException();}
                } else {
                    // attempt to unify the new_port with the existing one.
                    AcmeTypeManager.unifyRole(role, unifyTargetRole);
                };
            }
            catch (AcmeIllegalNameException e) {
                error_stack.push("(line " + /*error_line +*/ ") "
                                 + e.getMessage());
                {if (true) throw new ParseException();}
            };
          }
          // mark the enumeration for gc.
          child_enum = null;
        break;
      case PROPERTY:
        new_prop = PropertyDeclaration(parent_sys);
          try {
            parent_sys.addProperty(new_prop);
          }
          catch (AcmeDuplicateNameException dupExc) {
              // there is already a property with the same name as
              // new_prop in this component.  attempt to unify new_prop
              // with the one that already exists.  If it's a duplicate
              // name, but it's not a property that has the name, just
              // rethrow the error.
              try {
                    AcmeProperty targetProp =
                                    parent_sys.getProperty(new_prop.getName());
                    if (targetProp == null) {
                        error_stack.push("(line " + /*error_line +*/ ") "
                                         + dupExc.getMessage());
                        {if (true) throw new ParseException();}
                    } else {
                        // attempt to unify the new_port with the existing one.
                        AcmeTypeManager.extendProperty(new_prop, targetProp);
                    };
              } catch (AcmePropertyExtensionFailedException pefExc) {
                    error_stack.push("(line " + /*error_line +*/ ") "
                                     + pefExc.getMessage());
                    {if (true) throw new ParseException();}
              };
          } catch (AcmeIllegalNameException e) {
                error_stack.push("(line " + /*error_line +*/ ") "
                                 + e.getMessage());
                {if (true) throw new ParseException();}
          };
        break;
      case PROPERTIES:
        child_enum = PropertiesBlock(parent_sys);
          while (child_enum.moreItems()) {
            new_prop = (AcmeProperty) child_enum.getNextItem();
            try {
                parent_sys.addProperty(new_prop);
            }
            catch (AcmeDuplicateNameException dupExc) {
                // there is already a property with the same name as
                // new_prop in this component.  attempt to unify new_prop
                // with the one that already exists.  If it's a duplicate
                // name, but it's not a property that has the name, just
                // rethrow the error.
                try {
                    AcmeProperty targetProp =
                                    parent_sys.getProperty(new_prop.getName());
                    if (targetProp == null) {
                        error_stack.push("(line " + /*error_line +*/ ") "
                                         + dupExc.getMessage());
                        {if (true) throw new ParseException();}
                    } else {
                        // attempt to unify the new_port with the existing one.
                        AcmeTypeManager.extendProperty(new_prop, targetProp);
                    };
                } catch (AcmePropertyExtensionFailedException pefExc) {
                    error_stack.push("(line " + /*error_line +*/ ") "
                                     + pefExc.getMessage());
                    {if (true) throw new ParseException();}
                };
            } catch (AcmeIllegalNameException e) {
                error_stack.push("(line " + /*error_line +*/ ") "
                                 + e.getMessage());
                {if (true) throw new ParseException();}
            };
          }
          // mark the enumeration for gc.
          child_enum = null;
        break;
      case REPRESENTATION:
        new_rep = RepresentationDeclaration(parent_sys);
            try {
                parent_sys.addRepresentation(new_rep);
            } catch (AcmeIllegalNameException e) {
                error_stack.push("(line " + /*error_line +*/ ") "
                                 + e.getMessage());
                {if (true) throw new ParseException();}
            };
        break;
      case ATTACHMENT:
      case ATTACHMENTS:
        AttachmentsDeclaration(parent_sys);
        break;
      default:
        jj_la1[45] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    } finally {
      trace_return("SystemStructure");
    }
  }

////////////////////////////////////
//
// element declaration productions
//
////////////////////////////////////


/////////////////////////
// ElementProtoTypes
/////////////////////////


// parse_ElementProtoTypeDescription adds the properties and representations
// of an element type description to the element prototype object it describes
// (passed in as a parameter).
//
// Unlike the other parse_* methods, this only works with element
// prototypes and not with element instances because it is not
// possible to directly establish an Element instance.  This is simply
// used as a generic predicate to check against all categories of
// element instances (and also for instantiation of all categories)
  static final public void parse_ElementProtoTypeDescription(AcmeElementProtoType elt) throws ParseException {
    trace_call("parse_ElementProtoTypeDescription");
    try {
    Token new_type_id_token;
    AcmeProperty new_prop;
    AcmeElementType new_type;
    AcmeRepresentation new_rep;
    AcmeEnumeration child_enum;
    DesignRule new_designRule = null;
      jj_consume_token(LBRACE);
      label_15:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case PROPERTY:
        case PROPERTIES:
        case REPRESENTATION:
          ;
          break;
        default:
          jj_la1[46] = jj_gen;
          break label_15;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case PROPERTY:
          new_prop = PropertyDeclaration(elt);
                try {
                    elt.addProperty(new_prop);
                } catch (AcmeDuplicateNameException dupExc) {
                    try {
                        AcmeProperty targetProp =
                                        elt.getProperty(new_prop.getName());
                        if (targetProp == null) {
                            error_stack.push("(line " + /*error_line +*/ ") "
                                             + dupExc.getMessage());
                            {if (true) throw new ParseException();}
                        } else {
                            // attempt to unify the new_elt with the existing one.
                            AcmeTypeManager.extendProperty(new_prop, targetProp);
                        };
                    } catch (AcmePropertyExtensionFailedException pefExc) {
                        error_stack.push("(line " + /*error_line +*/ ") "
                                         + pefExc.getMessage());
                        {if (true) throw new ParseException();}
                    };
                } catch (AcmeIllegalNameException e) {
                    error_stack.push("(line " + /*error_line +*/ ") "
                                     + e.getMessage());
                    {if (true) throw new ParseException();}
                };
          break;
        case PROPERTIES:
          child_enum = PropertiesBlock(elt);
              while (child_enum.moreItems()) {
                new_prop = (AcmeProperty) child_enum.getNextItem();
                try {
                    elt.addProperty(new_prop);
                } catch (AcmeDuplicateNameException dupExc) {
                    try {
                        AcmeProperty targetProp =
                                    elt.getProperty(new_prop.getName());
                        if (targetProp == null) {
                            error_stack.push("(line " + /*error_line +*/ ") "
                                             + dupExc.getMessage());
                            {if (true) throw new ParseException();}
                        } else {
                            // attempt to unify the new_elt with the existing one.
                            AcmeTypeManager.extendProperty(new_prop, targetProp);
                        };
                    } catch (AcmePropertyExtensionFailedException pefExc) {
                        error_stack.push("(line " + /*error_line +*/ ") "
                                         + pefExc.getMessage());
                        {if (true) throw new ParseException();}
                    };
                } catch (AcmeIllegalNameException e) {
                    error_stack.push("(line " + /*error_line +*/ ") "
                                     + e.getMessage());
                    {if (true) throw new ParseException();}
                };
              }
              // mark the enumeration for gc.
              child_enum = null;
          break;
        case REPRESENTATION:
          new_rep = RepresentationDeclaration(elt);
               try {
                   elt.addRepresentation(new_rep);
               } catch (AcmeIllegalNameException e) {
                   error_stack.push("(line " + /*error_line +*/ ") "
                                     + e.getMessage());
                   {if (true) throw new ParseException();}
               };
          break;
        default:
          jj_la1[47] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
      jj_consume_token(RBRACE);
    } finally {
      trace_return("parse_ElementProtoTypeDescription");
    }
  }

/////////////////////////
// Components
/////////////////////////
  static final public AcmeComponent ComponentDeclaration() throws ParseException {
    trace_call("ComponentDeclaration");
    try {
    Token comp_id_token;
    AcmeComponent new_comp;
    AcmePort new_port;
    AcmeProperty new_prop;
    AcmeElementType comp_type = null;
      jj_consume_token(COMPONENT);
      comp_id_token = jj_consume_token(IDENTIFIER);
        new_comp = new AcmeComponent(comp_id_token.image);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COLON:
        jj_consume_token(COLON);
        comp_type = lookup_ComponentTypeByName();
        new_comp.addDeclaredType(comp_type);
        label_16:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMMA:
            ;
            break;
          default:
            jj_la1[48] = jj_gen;
            break label_16;
          }
          jj_consume_token(COMMA);
          comp_type = lookup_ComponentTypeByName();
           new_comp.addDeclaredType(comp_type);
        }
        break;
      default:
        jj_la1[49] = jj_gen;
        ;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ASSIGN:
        jj_consume_token(ASSIGN);
        parse_ComponentDescription(new_comp);
        jj_consume_token(SEMICOLON);
        break;
      case SEMICOLON:
        jj_consume_token(SEMICOLON);
          // the declaration Component foo : T;  is syntactic sugaring for
          // the declaration Component foo : T = new T.
          // Likewise,
          // the declaration Component foo : T1, ..., TN; is equivalent to
          // the declaration Component foo : T1, ..., TN = new T1 extended with T2
          //                                                extended with ... TN.

          // so walk over the list of declared types, and add each one to the
          // list of instantiated types.  They will be properly instantiated
          // later.
          AcmeEnumeration e = new_comp.getDeclaredTypes();
          while (e.moreItems()) {
            new_comp.addInstantiatedType((AcmeElementType) e.getNextItem());
          };
        break;
      default:
        jj_la1[50] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
        new_comp.setParentDesign(global_design);
        {if (true) return new_comp;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("ComponentDeclaration");
    }
  }

  static final public AcmeEnumeration ComponentsBlock() throws ParseException {
    trace_call("ComponentsBlock");
    try {
    Token comp_id_token;
    Token new_type_id_token;
    AcmeComponent new_comp;
    AcmeElementType comp_type = null;
    AcmeEnumeration comp_enum;
      jj_consume_token(COMPONENTS);
      jj_consume_token(LBRACE);
                        comp_enum = new AcmeEnumeration();
      label_17:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case IDENTIFIER:
          ;
          break;
        default:
          jj_la1[51] = jj_gen;
          break label_17;
        }
        comp_id_token = jj_consume_token(IDENTIFIER);
            new_comp = new AcmeComponent(comp_id_token.image);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COLON:
          jj_consume_token(COLON);
          comp_type = lookup_ComponentTypeByName();
            new_comp.addDeclaredType(comp_type);
          label_18:
          while (true) {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case COMMA:
              ;
              break;
            default:
              jj_la1[52] = jj_gen;
              break label_18;
            }
            jj_consume_token(COMMA);
            comp_type = lookup_ComponentTypeByName();
               new_comp.addDeclaredType(comp_type);
          }
          break;
        default:
          jj_la1[53] = jj_gen;
          ;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ASSIGN:
          jj_consume_token(ASSIGN);
          parse_ComponentDescription(new_comp);
          jj_consume_token(SEMICOLON);
          break;
        case SEMICOLON:
          jj_consume_token(SEMICOLON);
              // walk over the list of declared types, and add each one to the
              // list of instantiated types.  They will be properly instantiated
              // later.
              AcmeEnumeration e = new_comp.getDeclaredTypes();
              while (e.moreItems()) {
                new_comp.addInstantiatedType((AcmeElementType) e.getNextItem());
              };
          break;
        default:
          jj_la1[54] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
            comp_enum.insertItem(new_comp);
            new_comp.setParentDesign(global_design);
      }
      jj_consume_token(RBRACE);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SEMICOLON:
        jj_consume_token(SEMICOLON);
        break;
      default:
        jj_la1[55] = jj_gen;
        ;
      }
        {if (true) return comp_enum;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("ComponentsBlock");
    }
  }

/////////////////////
// parse_ComponentDescription adds the ports, properties, and
// representations in a component description to the component
// object it describes (passed in as comp).
//
// It works on both AcmeComponents and AcmeComponentTypes, due
// to the subclassing relationship between the two.
  static final public void parse_ComponentDescription(AcmeComponent comp) throws ParseException {
    trace_call("parse_ComponentDescription");
    try {
    Token new_type_id_token;
    AcmeProperty new_prop;
    AcmePort new_port;
    AcmeEnumeration child_enum;
    AcmeElementType new_type;
    AcmeRepresentation new_rep;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case NEW:
        jj_consume_token(NEW);
        new_type = lookup_ComponentTypeByName();
        comp.addInstantiatedType(new_type);
        label_19:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMMA:
            ;
            break;
          default:
            jj_la1[56] = jj_gen;
            break label_19;
          }
          jj_consume_token(COMMA);
          new_type = lookup_ComponentTypeByName();
        comp.addInstantiatedType(new_type);
        }
        break;
      case LBRACE:
        jj_consume_token(LBRACE);
        label_20:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case PORT:
          case PORTS:
          case PROPERTY:
          case PROPERTIES:
          case REPRESENTATION:
            ;
            break;
          default:
            jj_la1[57] = jj_gen;
            break label_20;
          }
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case PORT:
            new_port = PortDeclaration();
              try {
                comp.addPort(new_port);
              }
              catch (AcmeDuplicateNameException dupExc) {
                // there is already a port with the same name as
                // new_port in this component.  attempt to unify new_port
                // with the one that already exists.  If it's a duplicate
                // name, but it's not a port that has the name, just rethrow
                // the error.
                AcmePort unifyTargetPort = comp.getPort(new_port.getName());
                if (unifyTargetPort == null) {
                    error_stack.push("(line " + /*error_line +*/ ") "
                                     + dupExc.getMessage());
                    {if (true) throw new ParseException();}
                } else {
                    // attempt to unify the new_port with the existing one.
                    AcmeTypeManager.unifyPort(new_port, unifyTargetPort);
                };
              }
              catch (AcmeIllegalNameException e) {
                error_stack.push("(line " + /*error_line +*/ ") " + e.getMessage());
                {if (true) throw new ParseException();}
              };
            break;
          case PORTS:
            child_enum = PortsBlock();
              while (child_enum.moreItems()) {
                  new_port = (AcmePort) child_enum.getNextItem();
                  try {
                    comp.addPort(new_port);
                  }
                  catch (AcmeDuplicateNameException dupExc) {
                    // there is already a port with the same name as
                    // new_port in this component.  attempt to unify new_port
                    // with the one that already exists.  If it's a duplicate
                    // name, but it's not a port that has the name, just rethrow
                    // the error.
                    AcmePort unifyTargetPort = comp.getPort(new_port.getName());
                    if (unifyTargetPort == null) {
                        error_stack.push("(line " + /*error_line +*/ ") "
                                         + dupExc.getMessage());
                        {if (true) throw new ParseException();}
                    } else {
                        // attempt to unify the new_port with the existing one.
                        AcmeTypeManager.unifyPort(new_port, unifyTargetPort);
                    };
                  }
                  catch (AcmeIllegalNameException e) {
                        error_stack.push("(line " + /*error_line +*/ ") "
                                         + e.getMessage());
                        {if (true) throw new ParseException();}
                  };
              };
              // mark the enumeration for gc.
              child_enum = null;
            break;
          case PROPERTY:
            new_prop = PropertyDeclaration(comp);
              try {
                comp.addProperty(new_prop);
              }
              catch (AcmeDuplicateNameException dupExc) {
                // there is already a property with the same name as
                // new_prop in this component.  attempt to unify new_prop
                // with the one that already exists.  If it's a duplicate
                // name, but it's not a property that has the name, just
                // rethrow the error.
                try {
                    AcmeProperty targetProp = comp.getProperty(new_prop.getName());
                    if (targetProp == null) {
                        error_stack.push("(line " + /*error_line +*/ ") "
                                         + dupExc.getMessage());
                        {if (true) throw new ParseException();}
                    } else {
                        // attempt to unify the new_port with the existing one.
                        AcmeTypeManager.extendProperty(new_prop, targetProp);
                    };
                } catch (AcmePropertyExtensionFailedException pefExc) {
                    error_stack.push("(line " + /*error_line +*/ ") "
                                     + pefExc.getMessage());
                    {if (true) throw new ParseException();}
                };
              } catch (AcmeIllegalNameException e) {
                    error_stack.push("(line " + /*error_line +*/ ") "
                                     + e.getMessage());
                    {if (true) throw new ParseException();}
              };
            break;
          case PROPERTIES:
            child_enum = PropertiesBlock(comp);
              while (child_enum.moreItems()) {
                new_prop = (AcmeProperty) child_enum.getNextItem();
                try {
                    comp.addProperty(new_prop);
                }
                catch (AcmeDuplicateNameException dupExc) {
                    // there is already a property with the same name as
                    // new_prop in this component.  attempt to unify new_prop
                    // with the one that already exists.  If it's a duplicate
                    // name, but it's not a property that has the name, just
                    // rethrow the error.
                    try {
                        AcmeProperty targetProp = comp.getProperty(new_prop.getName());
                        if (targetProp == null) {
                            error_stack.push("(line " + /*error_line +*/ ") "
                                             + dupExc.getMessage());
                            {if (true) throw new ParseException();}
                        } else {
                            // attempt to unify the new_port with the existing one.
                            AcmeTypeManager.extendProperty(new_prop, targetProp);
                        };
                    } catch (AcmePropertyExtensionFailedException pefExc) {
                        error_stack.push("(line " + /*error_line +*/ ") "
                                         + pefExc.getMessage());
                        {if (true) throw new ParseException();}
                    };
                } catch (AcmeIllegalNameException e) {
                    error_stack.push("(line " + /*error_line +*/ ") "
                                     + e.getMessage());
                    {if (true) throw new ParseException();}
                };
              }
              // mark the enumeration for gc.
              child_enum = null;
            break;
          case REPRESENTATION:
            new_rep = RepresentationDeclaration(comp);
                try {
                    comp.addRepresentation(new_rep);
                } catch (AcmeIllegalNameException e) {
                    error_stack.push("(line " + /*error_line +*/ ") "
                                     + e.getMessage());
                    {if (true) throw new ParseException();}
                };
            break;
          default:
            jj_la1[58] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
        jj_consume_token(RBRACE);
        break;
      default:
        jj_la1[59] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case EXTENDED:
        jj_consume_token(EXTENDED);
        jj_consume_token(WITH);
        parse_ComponentDescription(comp);
        break;
      default:
        jj_la1[60] = jj_gen;
        ;
      }
    } finally {
      trace_return("parse_ComponentDescription");
    }
  }

/////////////////////////
// Connectors
/////////////////////////
  static final public AcmeConnector ConnectorDeclaration() throws ParseException {
    trace_call("ConnectorDeclaration");
    try {
    Token conn_id_token;
    AcmeConnector new_conn;
    AcmeRole new_role;
    AcmeProperty new_prop;
    AcmeElementType conn_type = null;
      jj_consume_token(CONNECTOR);
      conn_id_token = jj_consume_token(IDENTIFIER);
        new_conn = new AcmeConnector(conn_id_token.image);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COLON:
        jj_consume_token(COLON);
        conn_type = lookup_ConnectorTypeByName();
           new_conn.addDeclaredType(conn_type);
        label_21:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMMA:
            ;
            break;
          default:
            jj_la1[61] = jj_gen;
            break label_21;
          }
          jj_consume_token(COMMA);
          conn_type = lookup_ConnectorTypeByName();
           new_conn.addDeclaredType(conn_type);
        }
        break;
      default:
        jj_la1[62] = jj_gen;
        ;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ASSIGN:
        jj_consume_token(ASSIGN);
        parse_ConnectorDescription(new_conn);
        jj_consume_token(SEMICOLON);
        break;
      case SEMICOLON:
        jj_consume_token(SEMICOLON);
          // walk over the list of declared types, and add each one to the
          // list of instantiated types.  They will be properly instantiated
          // later.
          AcmeEnumeration e = new_conn.getDeclaredTypes();
          while (e.moreItems()) {
            new_conn.addInstantiatedType((AcmeElementType) e.getNextItem());
          };
        break;
      default:
        jj_la1[63] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
        new_conn.setParentDesign(global_design);
        {if (true) return new_conn;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("ConnectorDeclaration");
    }
  }

//
// parse multiple connectors in a Connectors {...} block
//
  static final public AcmeEnumeration ConnectorsBlock() throws ParseException {
    trace_call("ConnectorsBlock");
    try {
    Token conn_id_token;
    AcmeConnector new_conn;
    AcmeElementType conn_type = null;
    AcmeEnumeration conn_enum;
      jj_consume_token(CONNECTORS);
      jj_consume_token(LBRACE);
                        conn_enum = new AcmeEnumeration();
      label_22:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case IDENTIFIER:
          ;
          break;
        default:
          jj_la1[64] = jj_gen;
          break label_22;
        }
        conn_id_token = jj_consume_token(IDENTIFIER);
            new_conn = new AcmeConnector(conn_id_token.image);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COLON:
          jj_consume_token(COLON);
          conn_type = lookup_ConnectorTypeByName();
               new_conn.addDeclaredType(conn_type);
          label_23:
          while (true) {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case COMMA:
              ;
              break;
            default:
              jj_la1[65] = jj_gen;
              break label_23;
            }
            jj_consume_token(COMMA);
            conn_type = lookup_ConnectorTypeByName();
               new_conn.addDeclaredType(conn_type);
          }
          break;
        default:
          jj_la1[66] = jj_gen;
          ;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ASSIGN:
          jj_consume_token(ASSIGN);
          parse_ConnectorDescription(new_conn);
          jj_consume_token(SEMICOLON);
          break;
        case SEMICOLON:
          jj_consume_token(SEMICOLON);
              AcmeEnumeration e = new_conn.getDeclaredTypes();
              while (e.moreItems()) {
                new_conn.addInstantiatedType((AcmeElementType) e.getNextItem());
              };
          break;
        default:
          jj_la1[67] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
            conn_enum.insertItem(new_conn);
            new_conn.setParentDesign(global_design);
      }
      jj_consume_token(RBRACE);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SEMICOLON:
        jj_consume_token(SEMICOLON);
        break;
      default:
        jj_la1[68] = jj_gen;
        ;
      }
        {if (true) return conn_enum;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("ConnectorsBlock");
    }
  }

/////////////////////
// parse_ConnectorDescription adds the roles, properties, and
// representations in a connector description to the connector
// object it describes (passed in as conn).
//
// It works on both AcmeConnectors and AcmeConnectorTypes, due
// to the subclassing relationship between the two.
  static final public void parse_ConnectorDescription(AcmeConnector conn) throws ParseException {
    trace_call("parse_ConnectorDescription");
    try {
    Token new_type_id_token;
    AcmeProperty new_prop;
    AcmeRole new_role;
    AcmeEnumeration child_enum;
    AcmeElementType new_type;
    AcmeRepresentation new_rep;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case NEW:
        jj_consume_token(NEW);
        new_type = lookup_ConnectorTypeByName();
        conn.addInstantiatedType(new_type);
        label_24:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMMA:
            ;
            break;
          default:
            jj_la1[69] = jj_gen;
            break label_24;
          }
          jj_consume_token(COMMA);
          new_type = lookup_ConnectorTypeByName();
        conn.addInstantiatedType(new_type);
        }
        break;
      case LBRACE:
        jj_consume_token(LBRACE);
        label_25:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case ROLE:
          case ROLES:
          case PROPERTY:
          case PROPERTIES:
          case REPRESENTATION:
            ;
            break;
          default:
            jj_la1[70] = jj_gen;
            break label_25;
          }
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case ROLE:
            new_role = RoleDeclaration();
              try {
                conn.addRole(new_role);
              }
              catch (AcmeDuplicateNameException dupExc) {
                // there is already a role with the same name as
                // new_role in this connector.  attempt to unify new_role
                // with the one that already exists.  If it's a duplicate
                // name, but it's not a role that has the name, rethrow
                // the error.
                AcmeRole unifyTargetRole = conn.getRole(new_role.getName());
                if (unifyTargetRole == null) {
                    error_stack.push("(line " + /*error_line +*/ ") "
                                     + dupExc.getMessage());
                    {if (true) throw new ParseException();}
                } else {
                    // attempt to unify the new_port with the existing one.
                    AcmeTypeManager.unifyRole(new_role, unifyTargetRole);
                };
              }
              catch (AcmeIllegalNameException e) {
                    error_stack.push("(line " + /*error_line +*/ ") "
                                     + e.getMessage());
                    {if (true) throw new ParseException();}
              };
            break;
          case ROLES:
            child_enum = RolesBlock();
              while (child_enum.moreItems()) {
                  new_role = (AcmeRole) child_enum.getNextItem();
                  try {
                    conn.addRole(new_role);
                  }
                  catch (AcmeDuplicateNameException dupExc) {
                    // there is already a role with the same name as
                    // new_role in this connector.  attempt to unify new_role
                    // with the one that already exists.  If it's a duplicate
                    // name, but it's not a role that has the name, rethrow
                    // the error.
                    AcmeRole unifyTargetRole = conn.getRole(new_role.getName());
                    if (unifyTargetRole == null) {
                        error_stack.push("(line " + /*error_line +*/ ") "
                                         + dupExc.getMessage());
                        {if (true) throw new ParseException();}
                    } else {
                        // attempt to unify the new_port with the existing one.
                        AcmeTypeManager.unifyRole(new_role, unifyTargetRole);
                    };
                  }
                  catch (AcmeIllegalNameException e) {
                        error_stack.push("(line " + /*error_line +*/ ") "
                                         + e.getMessage());
                        {if (true) throw new ParseException();}
                  };
              }
              // mark the enumeration for gc.
              child_enum = null;
            break;
          case PROPERTY:
            new_prop = PropertyDeclaration(conn);
              try {
                conn.addProperty(new_prop);
              } catch (AcmeDuplicateNameException dupExc) {
                  try {
                    AcmeProperty targetProp = conn.getProperty(new_prop.getName());
                    if (targetProp == null) {
                        error_stack.push("(line " + /*error_line +*/ ") "
                                         + dupExc.getMessage());
                        {if (true) throw new ParseException();}
                    } else {
                        // attempt to unify the new_port with the existing one.
                        AcmeTypeManager.extendProperty(new_prop, targetProp);
                    };
                  } catch (AcmePropertyExtensionFailedException pefExc) {
                    error_stack.push("(line " + /*error_line +*/ ") "
                                     + pefExc.getMessage());
                    {if (true) throw new ParseException();}
                  };
              } catch (AcmeIllegalNameException e) {
                error_stack.push("(line " + /*error_line +*/ ") "
                                  + e.getMessage());
                {if (true) throw new ParseException();}
              };
            break;
          case PROPERTIES:
            child_enum = PropertiesBlock(conn);
              while (child_enum.moreItems()) {
                new_prop = (AcmeProperty) child_enum.getNextItem();
                try {
                    conn.addProperty(new_prop);
                }
                catch (AcmeDuplicateNameException dupExc) {
                    try {
                        AcmeProperty targetProp = conn.getProperty(new_prop.getName());
                        if (targetProp == null) {
                            error_stack.push("(line " + /*error_line +*/ ") "
                                             + dupExc.getMessage());
                            {if (true) throw new ParseException();}
                        } else {
                            // attempt to unify the new_port with the existing one.
                            AcmeTypeManager.extendProperty(new_prop, targetProp);
                        };
                    } catch (AcmePropertyExtensionFailedException pefExc) {
                        error_stack.push("(line " + /*error_line +*/ ") "
                                         + pefExc.getMessage());
                        {if (true) throw new ParseException();}
                    };
                } catch (AcmeIllegalNameException e) {
                    error_stack.push("(line " + /*error_line +*/ ") "
                                     + e.getMessage());
                    {if (true) throw new ParseException();}
                };
              }
              // mark the enumeration for gc.
              child_enum = null;
            break;
          case REPRESENTATION:
            new_rep = RepresentationDeclaration(conn);
               try {
                   conn.addRepresentation(new_rep);
               } catch (AcmeIllegalNameException e) {
                   error_stack.push("(line " + /*error_line +*/ ") "
                                     + e.getMessage());
                   {if (true) throw new ParseException();}
               };
            break;
          default:
            jj_la1[71] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
        jj_consume_token(RBRACE);
        break;
      default:
        jj_la1[72] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case EXTENDED:
        jj_consume_token(EXTENDED);
        jj_consume_token(WITH);
        parse_ConnectorDescription(conn);
        break;
      default:
        jj_la1[73] = jj_gen;
        ;
      }
    } finally {
      trace_return("parse_ConnectorDescription");
    }
  }

////////////////////
// Ports
////////////////////
  static final public AcmePort PortDeclaration() throws ParseException {
    trace_call("PortDeclaration");
    try {
    Token port_id_token;
    AcmePort new_port;
    AcmeElementType port_type = null;
      jj_consume_token(PORT);
      port_id_token = jj_consume_token(IDENTIFIER);
        new_port = new AcmePort(port_id_token.image);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COLON:
        jj_consume_token(COLON);
        port_type = lookup_PortTypeByName();
          new_port.addDeclaredType(port_type);
        label_26:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMMA:
            ;
            break;
          default:
            jj_la1[74] = jj_gen;
            break label_26;
          }
          jj_consume_token(COMMA);
          port_type = lookup_PortTypeByName();
           new_port.addDeclaredType(port_type);
        }
        break;
      default:
        jj_la1[75] = jj_gen;
        ;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ASSIGN:
        jj_consume_token(ASSIGN);
        parse_PortDescription(new_port);
        jj_consume_token(SEMICOLON);
        break;
      case SEMICOLON:
        jj_consume_token(SEMICOLON);
          // walk over the list of declared types, and add each one to the
          // list of instantiated types.  They will be properly instantiated
          // later.
          AcmeEnumeration e = new_port.getDeclaredTypes();
          while (e.moreItems()) {
            new_port.addInstantiatedType((AcmeElementType) e.getNextItem());
          };
        break;
      default:
        jj_la1[76] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
        new_port.setParentDesign(global_design);
        {if (true) return new_port;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("PortDeclaration");
    }
  }

//
// parse multiple ports in a Ports {...} block
//
  static final public AcmeEnumeration PortsBlock() throws ParseException {
    trace_call("PortsBlock");
    try {
    Token port_id_token;
    AcmePort new_port;
    AcmeElementType port_type = null;
    AcmeEnumeration port_enum;
      jj_consume_token(PORTS);
      jj_consume_token(LBRACE);
                   port_enum = new AcmeEnumeration();
      label_27:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case IDENTIFIER:
          ;
          break;
        default:
          jj_la1[77] = jj_gen;
          break label_27;
        }
        port_id_token = jj_consume_token(IDENTIFIER);
            new_port = new AcmePort(port_id_token.image);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COLON:
          jj_consume_token(COLON);
          port_type = lookup_PortTypeByName();
              new_port.addDeclaredType(port_type);
          label_28:
          while (true) {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case COMMA:
              ;
              break;
            default:
              jj_la1[78] = jj_gen;
              break label_28;
            }
            jj_consume_token(COMMA);
            port_type = lookup_PortTypeByName();
               new_port.addDeclaredType(port_type);
          }
          break;
        default:
          jj_la1[79] = jj_gen;
          ;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ASSIGN:
          jj_consume_token(ASSIGN);
          parse_PortDescription(new_port);
          jj_consume_token(SEMICOLON);
          break;
        case SEMICOLON:
          jj_consume_token(SEMICOLON);
              AcmeEnumeration e = new_port.getDeclaredTypes();
              while (e.moreItems()) {
                new_port.addInstantiatedType((AcmeElementType) e.getNextItem());
              };
          break;
        default:
          jj_la1[80] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
            new_port.setParentDesign(global_design);
            port_enum.insertItem(new_port);
      }
      jj_consume_token(RBRACE);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SEMICOLON:
        jj_consume_token(SEMICOLON);
        break;
      default:
        jj_la1[81] = jj_gen;
        ;
      }
        {if (true) return port_enum;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("PortsBlock");
    }
  }

// parse_PortDescription adds the properties, and representations
// in a port description to the port object it describes
// (passed in as port).
//
// It works on both AcmePorts and AcmePortTypes, due
// to the subclassing relationship between the two.
  static final public void parse_PortDescription(AcmePort port) throws ParseException {
    trace_call("parse_PortDescription");
    try {
    Token new_type_id_token;
    AcmeProperty new_prop;
    AcmeElementType new_type;
    AcmeRepresentation new_rep;
    AcmeEnumeration child_enum;
    DesignRule new_designRule = null;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case NEW:
        jj_consume_token(NEW);
        new_type = lookup_PortTypeByName();
        port.addInstantiatedType(new_type);
        label_29:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMMA:
            ;
            break;
          default:
            jj_la1[82] = jj_gen;
            break label_29;
          }
          jj_consume_token(COMMA);
          new_type = lookup_PortTypeByName();
        port.addInstantiatedType(new_type);
        }
        break;
      case LBRACE:
        jj_consume_token(LBRACE);
        label_30:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case PROPERTY:
          case PROPERTIES:
          case REPRESENTATION:
            ;
            break;
          default:
            jj_la1[83] = jj_gen;
            break label_30;
          }
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case PROPERTY:
            new_prop = PropertyDeclaration(port);
                try {
                    port.addProperty(new_prop);
                } catch (AcmeDuplicateNameException dupExc) {
                    try {
                        AcmeProperty targetProp =
                                        port.getProperty(new_prop.getName());
                        if (targetProp == null) {
                            error_stack.push("(line " + /*error_line +*/ ") "
                                             + dupExc.getMessage());
                            {if (true) throw new ParseException();}
                        } else {
                            // attempt to unify the new_port with the existing one.
                            AcmeTypeManager.extendProperty(new_prop, targetProp);
                        };
                    } catch (AcmePropertyExtensionFailedException pefExc) {
                        error_stack.push("(line " + /*error_line +*/ ") "
                                         + pefExc.getMessage());
                        {if (true) throw new ParseException();}
                    };
                } catch (AcmeIllegalNameException e) {
                    error_stack.push("(line " + /*error_line +*/ ") "
                                     + e.getMessage());
                    {if (true) throw new ParseException();}
                };
            break;
          case PROPERTIES:
            child_enum = PropertiesBlock(port);
              while (child_enum.moreItems()) {
                new_prop = (AcmeProperty) child_enum.getNextItem();
                try {
                    port.addProperty(new_prop);
                } catch (AcmeDuplicateNameException dupExc) {
                    try {
                        AcmeProperty targetProp =
                                    port.getProperty(new_prop.getName());
                        if (targetProp == null) {
                            error_stack.push("(line " + /*error_line +*/ ") "
                                             + dupExc.getMessage());
                            {if (true) throw new ParseException();}
                        } else {
                            // attempt to unify the new_port with the existing one.
                            AcmeTypeManager.extendProperty(new_prop, targetProp);
                        };
                    } catch (AcmePropertyExtensionFailedException pefExc) {
                        error_stack.push("(line " + /*error_line +*/ ") "
                                         + pefExc.getMessage());
                        {if (true) throw new ParseException();}
                    };
                } catch (AcmeIllegalNameException e) {
                    error_stack.push("(line " + /*error_line +*/ ") "
                                     + e.getMessage());
                    {if (true) throw new ParseException();}
                };
              }
              // mark the enumeration for gc.
              child_enum = null;
            break;
          case REPRESENTATION:
            new_rep = RepresentationDeclaration(port);
               try {
                   port.addRepresentation(new_rep);
               } catch (AcmeIllegalNameException e) {
                   error_stack.push("(line " + /*error_line +*/ ") "
                                     + e.getMessage());
                   {if (true) throw new ParseException();}
               };
            break;
          default:
            jj_la1[84] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
        jj_consume_token(RBRACE);
        break;
      default:
        jj_la1[85] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case EXTENDED:
        jj_consume_token(EXTENDED);
        jj_consume_token(WITH);
        parse_PortDescription(port);
        break;
      default:
        jj_la1[86] = jj_gen;
        ;
      }
    } finally {
      trace_return("parse_PortDescription");
    }
  }

////////////////////
// Roles
////////////////////
  static final public AcmeRole RoleDeclaration() throws ParseException {
    trace_call("RoleDeclaration");
    try {
    Token role_id_token;
    AcmeRole new_role;
    AcmeProperty new_prop;
    AcmeElementType role_type = null;
      jj_consume_token(ROLE);
      role_id_token = jj_consume_token(IDENTIFIER);
        new_role = new AcmeRole(role_id_token.image);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COLON:
        jj_consume_token(COLON);
        role_type = lookup_RoleTypeByName();
           new_role.addDeclaredType(role_type);
        label_31:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMMA:
            ;
            break;
          default:
            jj_la1[87] = jj_gen;
            break label_31;
          }
          jj_consume_token(COMMA);
          role_type = lookup_RoleTypeByName();
           new_role.addDeclaredType(role_type);
        }
        break;
      default:
        jj_la1[88] = jj_gen;
        ;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ASSIGN:
        jj_consume_token(ASSIGN);
        parse_RoleDescription(new_role);
        jj_consume_token(SEMICOLON);
        break;
      case SEMICOLON:
        jj_consume_token(SEMICOLON);
          // walk over the list of declared types, and add each one to the
          // list of instantiated types.  They will be properly instantiated
          // later.
          AcmeEnumeration e = new_role.getDeclaredTypes();
          while (e.moreItems()) {
            new_role.addInstantiatedType((AcmeElementType) e.getNextItem());
          };
        break;
      default:
        jj_la1[89] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
        new_role.setParentDesign(global_design);
        {if (true) return new_role;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("RoleDeclaration");
    }
  }

//
// parse multiple roles in a Roles {...} block
//
  static final public AcmeEnumeration RolesBlock() throws ParseException {
    trace_call("RolesBlock");
    try {
    Token role_id_token;
    AcmeRole new_role;
    AcmeElementType role_type = null;
    AcmeEnumeration role_enum;
      jj_consume_token(ROLES);
      jj_consume_token(LBRACE);
                   role_enum = new AcmeEnumeration();
      label_32:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case IDENTIFIER:
          ;
          break;
        default:
          jj_la1[90] = jj_gen;
          break label_32;
        }
        role_id_token = jj_consume_token(IDENTIFIER);
            new_role = new AcmeRole(role_id_token.image);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COLON:
          jj_consume_token(COLON);
          role_type = lookup_RoleTypeByName();
               new_role.addDeclaredType(role_type);
          label_33:
          while (true) {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case COMMA:
              ;
              break;
            default:
              jj_la1[91] = jj_gen;
              break label_33;
            }
            jj_consume_token(COMMA);
            role_type = lookup_RoleTypeByName();
               new_role.addDeclaredType(role_type);
          }
          break;
        default:
          jj_la1[92] = jj_gen;
          ;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ASSIGN:
          jj_consume_token(ASSIGN);
          parse_RoleDescription(new_role);
          jj_consume_token(SEMICOLON);
          break;
        case SEMICOLON:
          jj_consume_token(SEMICOLON);
              AcmeEnumeration e = new_role.getDeclaredTypes();
              while (e.moreItems()) {
                new_role.addInstantiatedType((AcmeElementType) e.getNextItem());
              };
          break;
        default:
          jj_la1[93] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
            role_enum.insertItem(new_role);
            new_role.setParentDesign(global_design);
      }
      jj_consume_token(RBRACE);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SEMICOLON:
        jj_consume_token(SEMICOLON);
        break;
      default:
        jj_la1[94] = jj_gen;
        ;
      }
        {if (true) return role_enum;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("RolesBlock");
    }
  }

// parse_RoleDescription adds the properties, and representations
// in a role description to the role object it describes
// (passed in as role).
//
// It works on both AcmeRoles and AcmeRoleTypes, due
// to the subclassing relationship between the two.
  static final public void parse_RoleDescription(AcmeRole role) throws ParseException {
    trace_call("parse_RoleDescription");
    try {
    Token new_type_id_token;
    AcmeProperty new_prop;
    AcmeElementType new_type;
    AcmeRepresentation new_rep;
    AcmeEnumeration child_enum;
    DesignRule new_designRule = null;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case NEW:
        jj_consume_token(NEW);
        new_type = lookup_RoleTypeByName();
        role.addInstantiatedType(new_type);
        label_34:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMMA:
            ;
            break;
          default:
            jj_la1[95] = jj_gen;
            break label_34;
          }
          jj_consume_token(COMMA);
          new_type = lookup_RoleTypeByName();
        role.addInstantiatedType(new_type);
        }
        break;
      case LBRACE:
        jj_consume_token(LBRACE);
        label_35:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case PROPERTY:
          case PROPERTIES:
          case REPRESENTATION:
            ;
            break;
          default:
            jj_la1[96] = jj_gen;
            break label_35;
          }
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case PROPERTY:
            new_prop = PropertyDeclaration(role);
                try {
                    role.addProperty(new_prop);
                } catch (AcmeDuplicateNameException dupExc) {
                    try {
                        AcmeProperty targetProp =
                                        role.getProperty(new_prop.getName());
                        if (targetProp == null) {
                            error_stack.push("(line " + /*error_line +*/ ") "
                                             + dupExc.getMessage());
                            {if (true) throw new ParseException();}
                        } else {
                            // attempt to unify the new_port with the existing one.
                            AcmeTypeManager.extendProperty(new_prop, targetProp);
                        };
                    } catch (AcmePropertyExtensionFailedException pefExc) {
                        error_stack.push("(line " + /*error_line +*/ ") "
                                         + pefExc.getMessage());
                        {if (true) throw new ParseException();}
                    };
                } catch (AcmeIllegalNameException e) {
                    error_stack.push("(line " + /*error_line +*/ ") "
                                     + e.getMessage());
                    {if (true) throw new ParseException();}
                };
            break;
          case PROPERTIES:
            child_enum = PropertiesBlock(role);
              while (child_enum.moreItems()) {
                new_prop = (AcmeProperty) child_enum.getNextItem();
                try {
                    role.addProperty(new_prop);
                } catch (AcmeDuplicateNameException dupExc) {
                    try {
                        AcmeProperty targetProp =
                                        role.getProperty(new_prop.getName());
                        if (targetProp == null) {
                            error_stack.push("(line " + /*error_line +*/ ") "
                                             + dupExc.getMessage());
                            {if (true) throw new ParseException();}
                        } else {
                            // attempt to unify the new_port with the existing one.
                            AcmeTypeManager.extendProperty(new_prop, targetProp);
                        };
                    } catch (AcmePropertyExtensionFailedException pefExc) {
                        error_stack.push("(line " + /*error_line +*/ ") "
                                         + pefExc.getMessage());
                        {if (true) throw new ParseException();}
                    };
                } catch (AcmeIllegalNameException e) {
                    error_stack.push("(line " + /*error_line +*/ ") "
                                     + e.getMessage());
                    {if (true) throw new ParseException();}
                };
              }
              // mark the enumeration for gc.
              child_enum = null;
            break;
          case REPRESENTATION:
            new_rep = RepresentationDeclaration(role);
               try {
                   role.addRepresentation(new_rep);
               } catch (AcmeIllegalNameException e) {
                   error_stack.push("(line " + /*error_line +*/ ") "
                                     + e.getMessage());
                   {if (true) throw new ParseException();}
               };
            break;
          default:
            jj_la1[97] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
        jj_consume_token(RBRACE);
        break;
      default:
        jj_la1[98] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case EXTENDED:
        jj_consume_token(EXTENDED);
        jj_consume_token(WITH);
        parse_RoleDescription(role);
        break;
      default:
        jj_la1[99] = jj_gen;
        ;
      }
    } finally {
      trace_return("parse_RoleDescription");
    }
  }

////////////////
// Attachments
////////////////
  static final public void AttachmentsDeclaration(AcmeSystem parent_sys) throws ParseException {
    trace_call("AttachmentsDeclaration");
    try {
    Token first_outer_token, first_inner_token;
    Token second_outer_token, second_inner_token;
    AcmeUnresolvedAttachment attachment = null;
    AcmeProperty property = null;
    AcmeEnumeration child_enum = null;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ATTACHMENTS:
        jj_consume_token(ATTACHMENTS);
        jj_consume_token(LBRACE);
        label_36:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case IDENTIFIER:
            ;
            break;
          default:
            jj_la1[100] = jj_gen;
            break label_36;
          }
          first_outer_token = jj_consume_token(IDENTIFIER);
          jj_consume_token(DOT);
          first_inner_token = jj_consume_token(IDENTIFIER);
          jj_consume_token(TO);
          second_outer_token = jj_consume_token(IDENTIFIER);
          jj_consume_token(DOT);
          second_inner_token = jj_consume_token(IDENTIFIER);
            attachment = new AcmeUnresolvedAttachment(
                first_outer_token.image, first_inner_token.image,
                second_outer_token.image, second_inner_token.image);
            attachment.setParent(parent_sys);
            parent_sys.addAttachment(attachment);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case LBRACE:
            jj_consume_token(LBRACE);
            label_37:
            while (true) {
              switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
              case PROPERTY:
              case PROPERTIES:
                ;
                break;
              default:
                jj_la1[101] = jj_gen;
                break label_37;
              }
              switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
              case PROPERTY:
                property = PropertyDeclaration(parent_sys);
                    try {
                        attachment.addProperty(property);
                    } catch (AcmeIllegalNameException e) {
                        error_stack.push("(line " + /*error_line +*/ ") "
                                     + e.getMessage());
                        {if (true) throw new ParseException();}
                    };
                break;
              case PROPERTIES:
                child_enum = PropertiesBlock(parent_sys);
                    while (child_enum.moreItems()) {
                        property = (AcmeProperty) child_enum.getNextItem();
                        try {
                            attachment.addProperty(property);
                        } catch (AcmeIllegalNameException e) {
                            error_stack.push("(line " + /*error_line +*/ ") "
                                     + e.getMessage());
                            {if (true) throw new ParseException();}
                        };
                    }
                    // mark the enumeration for gc.
                    child_enum = null;
                break;
              default:
                jj_la1[102] = jj_gen;
                jj_consume_token(-1);
                throw new ParseException();
              }
            }
            jj_consume_token(RBRACE);
            break;
          default:
            jj_la1[103] = jj_gen;
            ;
          }
          jj_consume_token(SEMICOLON);
        }
        jj_consume_token(RBRACE);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SEMICOLON:
          jj_consume_token(SEMICOLON);
          break;
        default:
          jj_la1[104] = jj_gen;
          ;
        }
        break;
      case ATTACHMENT:
        jj_consume_token(ATTACHMENT);
        first_outer_token = jj_consume_token(IDENTIFIER);
        jj_consume_token(DOT);
        first_inner_token = jj_consume_token(IDENTIFIER);
        jj_consume_token(TO);
        second_outer_token = jj_consume_token(IDENTIFIER);
        jj_consume_token(DOT);
        second_inner_token = jj_consume_token(IDENTIFIER);
        attachment = new AcmeUnresolvedAttachment(
            first_outer_token.image, first_inner_token.image,
            second_outer_token.image, second_inner_token.image);
        attachment.setParent(parent_sys);
        parent_sys.addAttachment(attachment);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case LBRACE:
          jj_consume_token(LBRACE);
          label_38:
          while (true) {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case PROPERTY:
            case PROPERTIES:
              ;
              break;
            default:
              jj_la1[105] = jj_gen;
              break label_38;
            }
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case PROPERTY:
              property = PropertyDeclaration(parent_sys);
                try {
                    attachment.addProperty(property);
                } catch (AcmeIllegalNameException e) {
                    error_stack.push("(line " + /*error_line +*/ ") "
                                 + e.getMessage());
                    {if (true) throw new ParseException();}
                };
              break;
            case PROPERTIES:
              child_enum = PropertiesBlock(parent_sys);
                while (child_enum.moreItems()) {
                    property = (AcmeProperty) child_enum.getNextItem();
                    try {
                        attachment.addProperty(property);
                    } catch (AcmeIllegalNameException e) {
                        error_stack.push("(line " + /*error_line +*/ ") "
                                 + e.getMessage());
                        {if (true) throw new ParseException();}
                    };
                }
                // mark the enumeration for gc.
                child_enum = null;
              break;
            default:
              jj_la1[106] = jj_gen;
              jj_consume_token(-1);
              throw new ParseException();
            }
          }
          jj_consume_token(RBRACE);
          break;
        default:
          jj_la1[107] = jj_gen;
          ;
        }
        jj_consume_token(SEMICOLON);
        break;
      default:
        jj_la1[108] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    } finally {
      trace_return("AttachmentsDeclaration");
    }
  }

////////////////
// Properties
////////////////

// single property = PropertyDeclaration
// block of properties = PropertiesBlock
// single description = parse_PropertyDescription

//
// parse a single property declaration
//
  static final public AcmeProperty PropertyDeclaration(acmeLib.designRules.Scope curScope) throws ParseException {
    trace_call("PropertyDeclaration");
    try {
    AcmeProperty new_prop;
      jj_consume_token(PROPERTY);
      new_prop = parse_PropertyDescription(curScope);
      jj_consume_token(SEMICOLON);
        new_prop.setScope(curScope);
        {if (true) return new_prop;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("PropertyDeclaration");
    }
  }

//
// parse a block of multiple property declarations
//
  static final public AcmeEnumeration PropertiesBlock(acmeLib.designRules.Scope curScope) throws ParseException {
    trace_call("PropertiesBlock");
    try {
    Token property_id_token;
    AcmeProperty new_property;
    AcmeEnumeration property_enum;
      jj_consume_token(PROPERTIES);
      jj_consume_token(LBRACE);
        property_enum = new AcmeEnumeration();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PROPERTY:
      case IDENTIFIER:
        new_property = parse_PropertyDescription(curScope);
            new_property.setScope(curScope);
            property_enum.insertItem(new_property);
        label_39:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case SEMICOLON:
            ;
            break;
          default:
            jj_la1[109] = jj_gen;
            break label_39;
          }
          if (jj_2_19(2)) {
            jj_consume_token(SEMICOLON);
            new_property = parse_PropertyDescription(curScope);
                new_property.setScope(curScope);
                property_enum.insertItem(new_property);
          } else {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case SEMICOLON:
              jj_consume_token(SEMICOLON);
              break;
            default:
              jj_la1[110] = jj_gen;
              jj_consume_token(-1);
              throw new ParseException();
            }
          }
        }
        break;
      default:
        jj_la1[111] = jj_gen;
        ;
      }
      jj_consume_token(RBRACE);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SEMICOLON:
        jj_consume_token(SEMICOLON);
        break;
      default:
        jj_la1[112] = jj_gen;
        ;
      }
        {if (true) return property_enum;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("PropertiesBlock");
    }
  }

  static final public AcmeProperty parse_PropertyDescription(acmeLib.designRules.Scope curScope) throws ParseException {
    trace_call("parse_PropertyDescription");
    try {
    Token prop_id;
    AcmeProperty new_prop;
    AcmeProperty new_meta_prop;
    AcmePropertyType prop_type = ConstantTypes.UNSPECIFIED_TYPE;
    AcmePropertyValue new_prop_value = null;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PROPERTY:
        jj_consume_token(PROPERTY);
        break;
      default:
        jj_la1[113] = jj_gen;
        ;
      }
      // should you be able to embed a "property" statement
                          // within a Properties {...} block?  This production allows it.
      
          prop_id = jj_consume_token(IDENTIFIER);
        new_prop = new AcmeProperty(prop_id.image, prop_type, new_prop_value);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COLON:
        jj_consume_token(COLON);
        prop_type = PropertyTypeDescription();
            new_prop.setType(prop_type);
        break;
      default:
        jj_la1[114] = jj_gen;
        ;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ASSIGN:
        jj_consume_token(ASSIGN);
        new_prop_value = PropertyValueDeclaration();
                new_prop.setValue(new_prop_value);
                // should I try to match the types of the value objects
                // up with the type objects in the previous setType
                // operation?  it's unclear how to do this in a general
                // way, so I might want to just special case it for
                // sets, sequences, records, and enums.
                if ( (new_prop_value instanceof AcmeEnum)
                     && (prop_type instanceof EnumType))
                    ((AcmeEnum) new_prop_value).setType((EnumType)prop_type);
                else if ((new_prop_value instanceof AcmeSequence)
                            && (prop_type instanceof SequenceType))
                    ((AcmeSequence) new_prop_value).setType((SequenceType)prop_type);
                else if ((new_prop_value instanceof AcmeSet)
                            && (prop_type instanceof SetType))
                    ((AcmeSet) new_prop_value).setType((SetType) prop_type);
        break;
      default:
        jj_la1[115] = jj_gen;
        ;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LANGLE:
        if (jj_2_21(3)) {
          jj_consume_token(LANGLE);
          jj_consume_token(LANGLE);
          new_meta_prop = parse_PropertyDescription(new_prop);
                 try {
                    new_prop.addProperty(new_meta_prop);
                    // meta-properties values are always defaults that
                    // can be overriden later
                    if (new_meta_prop.getValue() != null) {
                        if (curScope instanceof AcmeElementType) {
                            // meta-properties on properties in types
                            // are set as defaults to allow proper overriding.
                            // meta-properties on properties of concrete
                            // element declarations are not default, and have
                            // to take precedence.
                            new_meta_prop.getValue().setIsDefaultValue(true);
                        };
                    };
                 } catch (AcmeIllegalNameException e) {
                    error_stack.push("(line " + /*error_line +*/ ") "
                             + e.getMessage());
                    {if (true) throw new ParseException();}
                 };
          label_40:
          while (true) {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case SEMICOLON:
              ;
              break;
            default:
              jj_la1[116] = jj_gen;
              break label_40;
            }
            if (jj_2_20(2)) {
              jj_consume_token(SEMICOLON);
              new_meta_prop = parse_PropertyDescription(new_prop);
                 try {
                    new_prop.addProperty(new_meta_prop);
                    if (new_meta_prop.getValue() != null) {
                        if (curScope instanceof AcmeElementType) {
                            // meta-properties on properties in types
                            // are set as defaults to allow proper overriding.
                            // meta-properties on properties of concrete
                            // element declarations are not default, and have
                            // to take precedence.
                            new_meta_prop.getValue().setIsDefaultValue(true);
                        };

                    };
                 } catch (AcmeIllegalNameException e) {
                    error_stack.push("(line " + /*error_line +*/ ") "
                             + e.getMessage());
                    {if (true) throw new ParseException();}
                 };
            } else {
              switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
              case SEMICOLON:
                jj_consume_token(SEMICOLON);
                break;
              default:
                jj_la1[117] = jj_gen;
                jj_consume_token(-1);
                throw new ParseException();
              }
            }
          }
          jj_consume_token(RANGLE);
          jj_consume_token(RANGLE);
        } else {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case LANGLE:
            jj_consume_token(LANGLE);
            jj_consume_token(LANGLE);
            jj_consume_token(RANGLE);
            jj_consume_token(RANGLE);
            break;
          default:
            jj_la1[118] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
        break;
      default:
        jj_la1[119] = jj_gen;
        ;
      }
        // override the inferred type with the declared type,
        // if a type was declared (abstract base class doesn't have "setType"
        // RTM: commented out because it seems that we want to keep the type
        //      of a property value independent of the type of a property
        //      because they describe different things. This is not clearly
        //      a good idea, though.
        // if (prop_type != null) new_prop_value.setType(prop_type);
        {if (true) return new_prop;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("parse_PropertyDescription");
    }
  }

//
// Property types
//

/*************************************************************************
 ** This is the "official" Popart specification of Property types in ACME
 *************************************************************************
  PROPERTY-TYPE :=  PRIMITIVE-PROPERTY-TYPE
                     | PROPERTY-TYPE-DESCRIPTION
                     | NAME || ;
   ATTRIBUTE := NAME || ;
   ATT-VALUE :=  STRING | NUMBER | NAME | SET | RECORD | SEQUENCE || ;

   PRIMITIVE-PROPERTY-TYPE := float | int | char | string | boolean | any ;

  PROPERTY-TYPE-DESCRIPTION := RECORD-DECLARATION
                               | SET-DECLARATION
                               | SEQUENCE-DECLARATION
                               | ENUM-DECLARATION || ;
    RECORD-DECLARATION := { 'Open } 'Record '[ RECORD-PARAMETER ^ '; '] ;
    RECORD-PARAMETER := IDENTIFIER ^ ', ': TYPE-NAME ;

    SET-DECLARATION := 'Set { '{ TYPE-NAME '} } ;
    SEQUENCE-DECLARATION := 'Sequence { '< TYPE-NAME '> } ;
    ENUM-DECLARATION := 'Enum '{ NAME ^ ', '} ;

 RECORD := '[ RAW-PROPERTY ^ '; '] ;
 SET := '{ ATT-VALUE ^ ', '} ;
 SEQUENCE := '< ATT-VALUE ^ ', '> ;
 NAME := < ('. | '^ ) > IDENTIFIER || ;
 IDENTIFIER := LEXEME <| architectural-entity ;
 STRING := LEXEME <| is-string ;
 NUMBER := LEXEME <| is-number ;

****************************************************************************
** End Property types specification in Popart
****************************************************************************/

//
// Property types
//
  static final public AcmePropertyType PropertyTypeDeclaration() throws ParseException {
    trace_call("PropertyTypeDeclaration");
    try {
    Token typename_token;
    Token original_typename_token;
    Token enum_value_token;
    AcmePropertyType contained_property_type = null;
    RecordType new_record_type = null;
    EnumType new_enum = null;
      jj_consume_token(PROPERTY);
      jj_consume_token(TYPE);
      typename_token = jj_consume_token(IDENTIFIER);
      jj_consume_token(ASSIGN);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case INT:
        jj_consume_token(INT);
        jj_consume_token(SEMICOLON);
          {if (true) return new IntType(typename_token.image);}
        break;
      case FLOAT:
        jj_consume_token(FLOAT);
        jj_consume_token(SEMICOLON);
          {if (true) return new FloatType(typename_token.image);}
        break;
      case STRING:
        jj_consume_token(STRING);
        jj_consume_token(SEMICOLON);
          {if (true) return new StringType(typename_token.image);}
        break;
      case BOOLEAN:
        jj_consume_token(BOOLEAN);
        jj_consume_token(SEMICOLON);
          {if (true) return new BooleanType(typename_token.image);}
        break;
      case ANY:
        jj_consume_token(ANY);
        jj_consume_token(SEMICOLON);
          {if (true) return new AnyType(typename_token.image);}
        break;
      case ENUM:
        jj_consume_token(ENUM);
         new_enum = new EnumType(typename_token.image);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case LBRACE:
          jj_consume_token(LBRACE);
          enum_value_token = jj_consume_token(IDENTIFIER);
                new_enum.addValue(enum_value_token.image);
          label_41:
          while (true) {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case COMMA:
              ;
              break;
            default:
              jj_la1[120] = jj_gen;
              break label_41;
            }
            jj_consume_token(COMMA);
            enum_value_token = jj_consume_token(IDENTIFIER);
                     new_enum.addValue(enum_value_token.image);
          }
          jj_consume_token(RBRACE);
          break;
        default:
          jj_la1[121] = jj_gen;
          ;
        }
        jj_consume_token(SEMICOLON);
         {if (true) return new_enum;}
        break;
      default:
        jj_la1[127] = jj_gen;
        if (jj_2_23(4)) {
          jj_consume_token(SET);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case LBRACE:
            jj_consume_token(LBRACE);
            jj_consume_token(RBRACE);
            break;
          default:
            jj_la1[122] = jj_gen;
            ;
          }
          jj_consume_token(SEMICOLON);
          {if (true) return new SetType(typename_token.image,
                             ConstantTypes.UNSPECIFIED_TYPE);}
        } else if (jj_2_24(4)) {
          jj_consume_token(SET);
          jj_consume_token(LBRACE);
          contained_property_type = PropertyTypeDescription();
          jj_consume_token(RBRACE);
          jj_consume_token(SEMICOLON);
          {if (true) return new SetType(typename_token.image, contained_property_type);}
        } else if (jj_2_25(4)) {
          jj_consume_token(SEQUENCE);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case LANGLE:
            jj_consume_token(LANGLE);
            jj_consume_token(RANGLE);
            break;
          default:
            jj_la1[123] = jj_gen;
            ;
          }
          jj_consume_token(SEMICOLON);
          {if (true) return new SequenceType(typename_token.image,
                                  ConstantTypes.UNSPECIFIED_TYPE);}
        } else if (jj_2_26(4)) {
          jj_consume_token(SEQUENCE);
          jj_consume_token(LANGLE);
          contained_property_type = PropertyTypeDescription();
          jj_consume_token(RANGLE);
          jj_consume_token(SEMICOLON);
          {if (true) return new SequenceType(typename_token.image,
                                  contained_property_type);}
        } else if (jj_2_27(4)) {
          jj_consume_token(RECORD);
                 new_record_type = new RecordType(typename_token.image);
          jj_consume_token(LBRACKET);
          parse_RecordFieldDescription(new_record_type);
          label_42:
          while (true) {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case SEMICOLON:
              ;
              break;
            default:
              jj_la1[124] = jj_gen;
              break label_42;
            }
            if (jj_2_22(2)) {
              jj_consume_token(SEMICOLON);
              parse_RecordFieldDescription(new_record_type);
            } else {
              switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
              case SEMICOLON:
                jj_consume_token(SEMICOLON);
                break;
              default:
                jj_la1[125] = jj_gen;
                jj_consume_token(-1);
                throw new ParseException();
              }
            }
          }
          jj_consume_token(RBRACKET);
          jj_consume_token(SEMICOLON);
            {if (true) return new_record_type;}
        } else if (jj_2_28(4)) {
          jj_consume_token(RECORD);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case LBRACKET:
            jj_consume_token(LBRACKET);
            jj_consume_token(RBRACKET);
            break;
          default:
            jj_la1[126] = jj_gen;
            ;
          }
          jj_consume_token(SEMICOLON);
            {if (true) return new RecordType(typename_token.image);}
        } else {
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("PropertyTypeDeclaration");
    }
  }

/////////////////////////////
// PropertyTypeDescription parses a type description and returns
// that type description's PropertyType object.  If it finds a
// type name then it looks the name up with the type manager and returns
// the appropriate type object.  If it is a primitive type declaration
// then it returns the appropriate static type object for that primitive.
// If it finds an "anonymous" compound type it creates an object for
// that type, gensyming an "anonymous" name for the type, and returns
// that object.  This may return an UnresolvedPropertyType.  If it does
// so then that property type will need to be resolved in post-parsing
// processing.
//
//
  static final public AcmePropertyType PropertyTypeDescription() throws ParseException {
    trace_call("PropertyTypeDescription");
    try {
    Token cur_token;
    AcmePropertyType return_type = null;
    AcmePropertyType interior_property_type = ConstantTypes.UNSPECIFIED_TYPE;
    RecordType new_record = null;
    EnumType new_enum = null;
    String enum_symbol = null;
    StringBuffer name_buf = null;
    String type_name;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case INT:
        jj_consume_token(INT);
        {if (true) return acmeLib.core.globals.ConstantTypes.INT_TYPE;}
        break;
      case FLOAT:
        jj_consume_token(FLOAT);
        {if (true) return acmeLib.core.globals.ConstantTypes.FLOAT_TYPE;}
        break;
      case STRING:
        jj_consume_token(STRING);
        {if (true) return acmeLib.core.globals.ConstantTypes.STRING_TYPE;}
        break;
      case BOOLEAN:
        jj_consume_token(BOOLEAN);
        {if (true) return acmeLib.core.globals.ConstantTypes.BOOLEAN_TYPE;}
        break;
      case ANY:
        jj_consume_token(ANY);
        {if (true) return acmeLib.core.globals.ConstantTypes.EXPLICIT_ANY_TYPE;}
        break;
      case SET:
        jj_consume_token(SET);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case LBRACE:
          jj_consume_token(LBRACE);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case FLOAT:
          case INT:
          case STRING:
          case BOOLEAN:
          case SET:
          case SEQUENCE:
          case RECORD:
          case ENUM:
          case ANY:
          case IDENTIFIER:
            interior_property_type = PropertyTypeDescription();
            break;
          default:
            jj_la1[128] = jj_gen;
            ;
          }
          jj_consume_token(RBRACE);
          break;
        default:
          jj_la1[129] = jj_gen;
          ;
        }
            if (interior_property_type == ConstantTypes.UNSPECIFIED_TYPE) {
                type_name = new String("Set{}");
                return_type = ConstantTypes.ANY_SET_TYPE;
            }
            else if (interior_property_type.getTypeName() == null) {
                type_name = new String("Set{}");
                return_type = ConstantTypes.ANY_SET_TYPE;
            }
            else {
                type_name = new String("Set{"
                                  + interior_property_type.getTypeName() + "}");
            }

            if (return_type == null)
                return_type = new SetType(type_name, interior_property_type);

            // this was an inline definition, or else it would have been
            // just an identifier.
            return_type.setInlineTypeSpec(true);

            {if (true) return return_type;}
        break;
      case SEQUENCE:
        jj_consume_token(SEQUENCE);
        if (jj_2_29(3)) {
          jj_consume_token(LANGLE);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case FLOAT:
          case INT:
          case STRING:
          case BOOLEAN:
          case SET:
          case SEQUENCE:
          case RECORD:
          case ENUM:
          case ANY:
          case IDENTIFIER:
            interior_property_type = PropertyTypeDescription();
            break;
          default:
            jj_la1[130] = jj_gen;
            ;
          }
          jj_consume_token(RANGLE);
        } else {
          ;
        }
            if (interior_property_type == ConstantTypes.UNSPECIFIED_TYPE) {
                type_name = new String("sequence<>");
                return_type = ConstantTypes.ANY_SEQUENCE_TYPE;
            }
            else if (interior_property_type.getTypeName() == null) {
                type_name = new String("sequence<>");
                return_type = ConstantTypes.ANY_SEQUENCE_TYPE;
            }
            else {
                type_name = new String("sequence<"
                                 + interior_property_type.getTypeName() + ">");
            }

            if (return_type == null)
                return_type = new SequenceType(type_name, interior_property_type);

            // this was an inline definition, or else it would have been
            // just an identifier.
            return_type.setInlineTypeSpec(true);

            {if (true) return return_type;}
        break;
      default:
        jj_la1[137] = jj_gen;
        if (jj_2_31(3)) {
          jj_consume_token(RECORD);
                            new_record = new RecordType("__inline_record_");
          jj_consume_token(LBRACKET);
          parse_RecordFieldDescription(new_record);
          label_43:
          while (true) {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case SEMICOLON:
              ;
              break;
            default:
              jj_la1[131] = jj_gen;
              break label_43;
            }
            if (jj_2_30(2)) {
              jj_consume_token(SEMICOLON);
              parse_RecordFieldDescription(new_record);
            } else {
              switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
              case SEMICOLON:
                jj_consume_token(SEMICOLON);
                break;
              default:
                jj_la1[132] = jj_gen;
                jj_consume_token(-1);
                throw new ParseException();
              }
            }
          }
          jj_consume_token(RBRACKET);
            // generate a name based on the fields and their types
            // the anonymous record name is the string that should be
            // exported to declare the inline type directly.  That is,
            // when it's name is exported it will look like an appropriate
            // inline type description.
            name_buf = new StringBuffer("Record[");
            AcmeEnumeration rec_fields = new_record.getFields();
            AcmeRecordField f;
            while (rec_fields.moreItems()) {
                f = (AcmeRecordField) rec_fields.getNextItem();
                if (f.getName() != null) {
                    name_buf.append(f.getName());
                };
                if (f.getType() != null) {
                    if (f.getType().getTypeName() != null)
                        name_buf.append(" : " + f.getType().getTypeName());
                };
                name_buf.append("; ");
            };
            name_buf.append("]");

            // (re)set the name of this type to the gensymed name
            new_record.setTypeName(name_buf.toString());

            // this was an inline definition, or else it would have been
            // just an identifier.
            new_record.setInlineTypeSpec(true);

            {if (true) return new_record;}
        } else if (jj_2_32(3)) {
          jj_consume_token(RECORD);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case LBRACKET:
            jj_consume_token(LBRACKET);
            jj_consume_token(RBRACKET);
            break;
          default:
            jj_la1[133] = jj_gen;
            ;
          }
            {if (true) return ConstantTypes.ANY_RECORD_TYPE;}
        } else if (jj_2_33(3)) {
          jj_consume_token(ENUM);
        name_buf = new StringBuffer("Enum { ");
        new_enum = new EnumType(name_buf.toString());
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case LBRACE:
            jj_consume_token(LBRACE);
            cur_token = jj_consume_token(IDENTIFIER);
              name_buf.append(cur_token.image);
              new_enum.addValue(cur_token.image);
            label_44:
            while (true) {
              switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
              case COMMA:
                ;
                break;
              default:
                jj_la1[134] = jj_gen;
                break label_44;
              }
              jj_consume_token(COMMA);
              cur_token = jj_consume_token(IDENTIFIER);
                   if (!new_enum.hasValue(cur_token.image)) {
                        name_buf.append(", " + cur_token.image);
                        new_enum.addValue(cur_token.image);
                   } else {
                        // else warn that this is a repeat value.
                        warning_stack.push(new String("Repeated "
                        + " enum value \"" + cur_token.image
                        + "\""));
                   };
            }
            jj_consume_token(RBRACE);
            break;
          default:
            jj_la1[135] = jj_gen;
            ;
          }
        name_buf.append(" }");
        new_enum.setTypeName(name_buf.toString());
        new_enum.setInlineTypeSpec(true);
        {if (true) return new_enum;}
        } else if (jj_2_34(3)) {
          jj_consume_token(ENUM);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case LBRACE:
            jj_consume_token(LBRACE);
            jj_consume_token(RBRACE);
            break;
          default:
            jj_la1[136] = jj_gen;
            ;
          }
        {if (true) return ConstantTypes.EMPTY_ENUM_TYPE;}
        } else {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case IDENTIFIER:
            return_type = lookup_PropertyTypeByName();
        {if (true) return return_type;}
            break;
          default:
            jj_la1[138] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
      }
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("PropertyTypeDescription");
    }
  }

  static final public void parse_RecordFieldDescription(RecordType parent_record) throws ParseException {
    trace_call("parse_RecordFieldDescription");
    try {
    Token cur_token;
    java.util.Vector id_v = new java.util.Vector();
    AcmePropertyType prop_type = ConstantTypes.UNSPECIFIED_TYPE;
      // basic algorithm here is to add the identifiers to a temp vector
          // until we see a type definition, then add a new field of that type
          // to the parent_record for each identifier.
          cur_token = jj_consume_token(IDENTIFIER);
                               id_v.addElement(cur_token.image);
      label_45:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[139] = jj_gen;
          break label_45;
        }
        jj_consume_token(COMMA);
        cur_token = jj_consume_token(IDENTIFIER);
                                       id_v.addElement(cur_token.image);
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COLON:
        jj_consume_token(COLON);
        prop_type = PropertyTypeDescription();
        break;
      default:
        jj_la1[140] = jj_gen;
        ;
      }
          // pull each identifier from the stack and add a field for it
          // to the parent_record
          java.util.Enumeration e = id_v.elements();
          while(e.hasMoreElements()) {
              parent_record.addField( (String) e.nextElement(),
                                       prop_type,
                                       null );
          }
    } finally {
      trace_return("parse_RecordFieldDescription");
    }
  }

  static final public AcmePropertyValue PropertyValueDeclaration() throws ParseException {
    trace_call("PropertyValueDeclaration");
    try {
    Token cur_token;
    AcmePropertyValue new_val = null;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case INTEGER_LITERAL:
        cur_token = jj_consume_token(INTEGER_LITERAL);
           // this is an integer, give it a default int type.
           IntType new_inttype_decl = new IntType("int");
           // parse the value
           {if (true) return new AcmeInt(new_inttype_decl,
                              Integer.parseInt(cur_token.image));}
        break;
      case FLOATING_POINT_LITERAL:
        cur_token = jj_consume_token(FLOATING_POINT_LITERAL);
           FloatType new_floattype_decl = new FloatType("float");
           {if (true) return new AcmeFloat(new_floattype_decl,
                 (Float.valueOf(cur_token.image)).floatValue());}
        break;
      case STRING_LITERAL:
        cur_token = jj_consume_token(STRING_LITERAL);
           StringType new_stringtype_decl = new StringType("string");
           AcmeString new_string = new AcmeString(new_stringtype_decl, "");

           // convert the new string to a quote-compliant
           // internal representation
           new_string.setValue(new_string.massageForInternalStorage(
                                  cur_token.image));
           {if (true) return new_string;}
        break;
      case FALSE:
        cur_token = jj_consume_token(FALSE);
                          {if (true) return new AcmeBoolean(false);}
        break;
      case TRUE:
        cur_token = jj_consume_token(TRUE);
                         {if (true) return new AcmeBoolean(true);}
        break;
      case LBRACE:
        new_val = AcmeSetValue();
                                {if (true) return new_val;}
        break;
      case LANGLE:
        new_val = AcmeSequenceValue();
                                    {if (true) return new_val;}
        break;
      case LBRACKET:
        new_val = AcmeRecordValue();
                                   {if (true) return new_val;}
        break;
      case IDENTIFIER:
        cur_token = jj_consume_token(IDENTIFIER);
        // RTM: what to do with an identifier is a bit tricky.
        // for the moment, let's assume that it is an enum and
        // return it as an enum value.  In Armani it will
        // probably have meaning in referring to specific
        // architectural entities or properties.
        {if (true) return new AcmeEnum(cur_token.image);}
        break;
      default:
        jj_la1[141] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("PropertyValueDeclaration");
    }
  }

//
// Productions for compound property value types.
//
  static final public AcmeSet AcmeSetValue() throws ParseException {
    trace_call("AcmeSetValue");
    try {
    AcmePropertyValue new_val;
    AcmeSet new_set = null;
      if (jj_2_35(2)) {
        jj_consume_token(LBRACE);
        jj_consume_token(RBRACE);
        new_set = new AcmeSet();
        {if (true) return new_set;}
      } else if (jj_2_36(2)) {
        jj_consume_token(LBRACE);
        new_val = PropertyValueDeclaration();
             new_set = new AcmeSet();
             new_set.addValue(new_val);
        label_46:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMMA:
            ;
            break;
          default:
            jj_la1[142] = jj_gen;
            break label_46;
          }
          jj_consume_token(COMMA);
          new_val = PropertyValueDeclaration();
                           new_set.addValue(new_val);
        }
        jj_consume_token(RBRACE);
      {if (true) return new_set;}
      } else {
        jj_consume_token(-1);
        throw new ParseException();
      }
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("AcmeSetValue");
    }
  }

  static final public AcmeSequence AcmeSequenceValue() throws ParseException {
    trace_call("AcmeSequenceValue");
    try {
    AcmePropertyValue new_val;
    AcmeSequence new_sequence = null;
      if (jj_2_37(3)) {
        jj_consume_token(LANGLE);
        jj_consume_token(RANGLE);
        new_sequence = new AcmeSequence();
        {if (true) return new_sequence;}
      } else if (jj_2_38(3)) {
        jj_consume_token(LANGLE);
        new_val = PropertyValueDeclaration();
             new_sequence = new AcmeSequence();
             new_sequence.addValue(new_val);
        label_47:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMMA:
            ;
            break;
          default:
            jj_la1[143] = jj_gen;
            break label_47;
          }
          jj_consume_token(COMMA);
          new_val = PropertyValueDeclaration();
                           new_sequence.addValue(new_val);
        }
        jj_consume_token(RANGLE);
      {if (true) return new_sequence;}
      } else {
        jj_consume_token(-1);
        throw new ParseException();
      }
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("AcmeSequenceValue");
    }
  }

  static final public AcmeRecord AcmeRecordValue() throws ParseException {
    trace_call("AcmeRecordValue");
    try {
    AcmeRecordField new_field;
    AcmeRecord new_record = null;
      if (jj_2_40(3)) {
        jj_consume_token(LBRACKET);
        new_field = RecordFieldValue();
            new_record = new AcmeRecord();
            new_record.addField(new_field);
        label_48:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case SEMICOLON:
            ;
            break;
          default:
            jj_la1[144] = jj_gen;
            break label_48;
          }
          if (jj_2_39(2)) {
            jj_consume_token(SEMICOLON);
            new_field = RecordFieldValue();
            new_record.addField(new_field);
          } else {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case SEMICOLON:
              jj_consume_token(SEMICOLON);
              break;
            default:
              jj_la1[145] = jj_gen;
              jj_consume_token(-1);
              throw new ParseException();
            }
          }
        }
        jj_consume_token(RBRACKET);
        {if (true) return new_record;}
      } else if (jj_2_41(3)) {
        jj_consume_token(LBRACKET);
        jj_consume_token(RBRACKET);
        new_record = new AcmeRecord();
        {if (true) return new_record;}
      } else {
        jj_consume_token(-1);
        throw new ParseException();
      }
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("AcmeRecordValue");
    }
  }

  static final public AcmeRecordField RecordFieldValue() throws ParseException {
    trace_call("RecordFieldValue");
    try {
    Token cur_token;
    AcmePropertyValue value = null;
    AcmePropertyType type = ConstantTypes.UNSPECIFIED_TYPE;
      cur_token = jj_consume_token(IDENTIFIER);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COLON:
        jj_consume_token(COLON);
        type = PropertyTypeDescription();
        break;
      default:
        jj_la1[146] = jj_gen;
        ;
      }
      jj_consume_token(ASSIGN);
      value = PropertyValueDeclaration();
        {if (true) return new AcmeRecordField(cur_token.image, type, value);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("RecordFieldValue");
    }
  }

/////////////////////
//                 //
// Representations //
//                 //
/////////////////////
  static final public AcmeRepresentation RepresentationDeclaration(AcmeElement parent) throws ParseException {
    trace_call("RepresentationDeclaration");
    try {
    AcmeSystem repSystem;
    AcmeBindingsMap bindingsMap = null;
    AcmeRepresentation newRep = null;
    Token repName = null;
      jj_consume_token(REPRESENTATION);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IDENTIFIER:
        repName = jj_consume_token(IDENTIFIER);
        jj_consume_token(ASSIGN);
        break;
      default:
        jj_la1[147] = jj_gen;
        ;
      }
      jj_consume_token(LBRACE);
      repSystem = SystemDeclaration();
        newRep = new AcmeRepresentation();
        newRep.setSystem(repSystem);
        try {
            if (repName != null) {
                newRep.setName(repName.image);
            } else {
                newRep.setName(repSystem.getName());
                newRep.setRepNameIsAnonymous(true);
            };
        } catch (AcmeIllegalNameException e) {
            error_stack.push("(line " + /*error_line +*/ ") "
                     + e.getMessage());
            {if (true) throw new ParseException();}
        };
        repSystem.setParent(parent);
        repSystem.setParentRepresentation(newRep);
        repSystem.setParentDesign(global_design);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case BINDINGS:
        bindingsMap = BindingsMapDeclaration(newRep);
        newRep.setAbstractionMap(bindingsMap);
        break;
      default:
        jj_la1[148] = jj_gen;
        ;
      }
      jj_consume_token(RBRACE);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SEMICOLON:
        jj_consume_token(SEMICOLON);
        break;
      default:
        jj_la1[149] = jj_gen;
        ;
      }
        {if (true) return newRep;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("RepresentationDeclaration");
    }
  }

  static final public AcmeBindingsMap BindingsMapDeclaration(AcmeRepresentation boundRep) throws ParseException {
    trace_call("BindingsMapDeclaration");
    try {
    AcmeBindingsMap bindings_map;
    AcmeBinding cur_binding;
      jj_consume_token(BINDINGS);
      jj_consume_token(LBRACE);
        bindings_map = new AcmeBindingsMap();
      label_49:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case IDENTIFIER:
          ;
          break;
        default:
          jj_la1[150] = jj_gen;
          break label_49;
        }
        cur_binding = BindingDeclaration(boundRep);
        bindings_map.addBinding(cur_binding);
      }
      jj_consume_token(RBRACE);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SEMICOLON:
        jj_consume_token(SEMICOLON);
        break;
      default:
        jj_la1[151] = jj_gen;
        ;
      }
        {if (true) return bindings_map;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("BindingsMapDeclaration");
    }
  }

  static final public AcmeBinding BindingDeclaration(AcmeRepresentation parent_rep) throws ParseException {
    trace_call("BindingDeclaration");
    try {
    Token first_qualifier = null;
    Token first_id = null;
    Token second_qualifier = null;
    Token second_id = null;

    AcmeBinding new_binding = null;
    AcmeProperty property = null;
    AcmeEnumeration child_enum = null;
      if (jj_2_42(2)) {
        first_qualifier = jj_consume_token(IDENTIFIER);
        jj_consume_token(DOT);
      } else {
        ;
      }
      first_id = jj_consume_token(IDENTIFIER);
      jj_consume_token(TO);
      if (jj_2_43(2)) {
        second_qualifier = jj_consume_token(IDENTIFIER);
        jj_consume_token(DOT);
      } else {
        ;
      }
      second_id = jj_consume_token(IDENTIFIER);
        // first set up the generic error message buffer
        StringBuffer err_buf = new StringBuffer("(line "
                + first_id.beginLine + ") Binding \"");
        if (first_qualifier != null)
            err_buf.append(first_qualifier.image + ".");
        err_buf.append(first_id.image + " to ");

        if (second_qualifier != null)
            err_buf.append(second_qualifier.image + ".");
        err_buf.append(second_id.image + "\": ");

        // try to find the elements referred to by the binding.
        if ((first_qualifier == null) && (second_qualifier == null)) {
            // You need at least one qualifier for the inner half of the binding
            err_buf.append("Neither bound element has fully qualified name.");
            error_stack.push(err_buf.toString());
            {if (true) throw new ParseException();}
        }

        // the qualifier tokens are optional, so check that they are
        // not null before dereferencing them.
        String first_qualifier_str = null;
        String second_qualifier_str = null;
        if (first_qualifier != null)
            first_qualifier_str = first_qualifier.image;
        if (second_qualifier != null)
            second_qualifier_str = second_qualifier.image;

        // create an unresolved binding object and return it.
        new_binding = new AcmeUnresolvedBinding(first_qualifier_str,
                                                first_id.image,
                                                second_qualifier_str,
                                                second_id.image);
        new_binding.setParentRep(parent_rep);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LBRACE:
        jj_consume_token(LBRACE);
        label_50:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case PROPERTY:
          case PROPERTIES:
            ;
            break;
          default:
            jj_la1[152] = jj_gen;
            break label_50;
          }
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case PROPERTY:
            property = PropertyDeclaration(new_binding);
                try {
                    new_binding.addProperty(property);
                } catch (AcmeIllegalNameException e) {
                    error_stack.push("(line " + /*error_line +*/ ") "
                                 + e.getMessage());
                    {if (true) throw new ParseException();}
                };
            break;
          case PROPERTIES:
            child_enum = PropertiesBlock(new_binding);
                while (child_enum.moreItems()) {
                    property = (AcmeProperty) child_enum.getNextItem();
                    try {
                        new_binding.addProperty(property);
                    } catch (AcmeIllegalNameException e) {
                        error_stack.push("(line " + /*error_line +*/ ") "
                                 + e.getMessage());
                        {if (true) throw new ParseException();}
                    };
                }
                // mark the enumeration for gc.
                child_enum = null;
            break;
          default:
            jj_la1[153] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
        jj_consume_token(RBRACE);
        break;
      default:
        jj_la1[154] = jj_gen;
        ;
      }
      jj_consume_token(SEMICOLON);
        {if (true) return new_binding;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("BindingDeclaration");
    }
  }

  static final private boolean jj_2_1(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_1();
    jj_save(0, xla);
    return retval;
  }

  static final private boolean jj_2_2(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_2();
    jj_save(1, xla);
    return retval;
  }

  static final private boolean jj_2_3(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_3();
    jj_save(2, xla);
    return retval;
  }

  static final private boolean jj_2_4(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_4();
    jj_save(3, xla);
    return retval;
  }

  static final private boolean jj_2_5(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_5();
    jj_save(4, xla);
    return retval;
  }

  static final private boolean jj_2_6(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_6();
    jj_save(5, xla);
    return retval;
  }

  static final private boolean jj_2_7(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_7();
    jj_save(6, xla);
    return retval;
  }

  static final private boolean jj_2_8(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_8();
    jj_save(7, xla);
    return retval;
  }

  static final private boolean jj_2_9(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_9();
    jj_save(8, xla);
    return retval;
  }

  static final private boolean jj_2_10(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_10();
    jj_save(9, xla);
    return retval;
  }

  static final private boolean jj_2_11(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_11();
    jj_save(10, xla);
    return retval;
  }

  static final private boolean jj_2_12(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_12();
    jj_save(11, xla);
    return retval;
  }

  static final private boolean jj_2_13(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_13();
    jj_save(12, xla);
    return retval;
  }

  static final private boolean jj_2_14(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_14();
    jj_save(13, xla);
    return retval;
  }

  static final private boolean jj_2_15(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_15();
    jj_save(14, xla);
    return retval;
  }

  static final private boolean jj_2_16(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_16();
    jj_save(15, xla);
    return retval;
  }

  static final private boolean jj_2_17(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_17();
    jj_save(16, xla);
    return retval;
  }

  static final private boolean jj_2_18(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_18();
    jj_save(17, xla);
    return retval;
  }

  static final private boolean jj_2_19(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_19();
    jj_save(18, xla);
    return retval;
  }

  static final private boolean jj_2_20(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_20();
    jj_save(19, xla);
    return retval;
  }

  static final private boolean jj_2_21(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_21();
    jj_save(20, xla);
    return retval;
  }

  static final private boolean jj_2_22(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_22();
    jj_save(21, xla);
    return retval;
  }

  static final private boolean jj_2_23(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_23();
    jj_save(22, xla);
    return retval;
  }

  static final private boolean jj_2_24(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_24();
    jj_save(23, xla);
    return retval;
  }

  static final private boolean jj_2_25(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_25();
    jj_save(24, xla);
    return retval;
  }

  static final private boolean jj_2_26(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_26();
    jj_save(25, xla);
    return retval;
  }

  static final private boolean jj_2_27(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_27();
    jj_save(26, xla);
    return retval;
  }

  static final private boolean jj_2_28(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_28();
    jj_save(27, xla);
    return retval;
  }

  static final private boolean jj_2_29(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_29();
    jj_save(28, xla);
    return retval;
  }

  static final private boolean jj_2_30(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_30();
    jj_save(29, xla);
    return retval;
  }

  static final private boolean jj_2_31(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_31();
    jj_save(30, xla);
    return retval;
  }

  static final private boolean jj_2_32(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_32();
    jj_save(31, xla);
    return retval;
  }

  static final private boolean jj_2_33(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_33();
    jj_save(32, xla);
    return retval;
  }

  static final private boolean jj_2_34(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_34();
    jj_save(33, xla);
    return retval;
  }

  static final private boolean jj_2_35(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_35();
    jj_save(34, xla);
    return retval;
  }

  static final private boolean jj_2_36(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_36();
    jj_save(35, xla);
    return retval;
  }

  static final private boolean jj_2_37(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_37();
    jj_save(36, xla);
    return retval;
  }

  static final private boolean jj_2_38(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_38();
    jj_save(37, xla);
    return retval;
  }

  static final private boolean jj_2_39(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_39();
    jj_save(38, xla);
    return retval;
  }

  static final private boolean jj_2_40(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_40();
    jj_save(39, xla);
    return retval;
  }

  static final private boolean jj_2_41(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_41();
    jj_save(40, xla);
    return retval;
  }

  static final private boolean jj_2_42(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_42();
    jj_save(41, xla);
    return retval;
  }

  static final private boolean jj_2_43(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_43();
    jj_save(42, xla);
    return retval;
  }

  static final private boolean jj_3R_64() {
    if (jj_scan_token(SEMICOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_63() {
    if (jj_scan_token(ASSIGN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_16() {
    if (jj_scan_token(ROLE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(TYPE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(EXTENDS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_122() {
    if (jj_scan_token(PORT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_134() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_40()) {
    jj_scanpos = xsp;
    if (jj_3_41()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_40() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_79()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_74() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RBRACKET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_91() {
    if (jj_3R_127()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_85() {
    if (jj_3R_121()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_78() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_52() {
    if (jj_scan_token(FAMILY)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_15() {
    if (jj_scan_token(ROLE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(TYPE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_63()) {
    jj_scanpos = xsp;
    if (jj_3R_64()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_1() {
    if (jj_3R_51()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_75() {
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_147() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_15()) {
    jj_scanpos = xsp;
    if (jj_3_16()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_118() {
    if (jj_scan_token(COMPONENT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_72() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RBRACKET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_38() {
    if (jj_scan_token(LANGLE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_77()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_78()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    if (jj_scan_token(RANGLE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_33() {
    if (jj_scan_token(ENUM)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_75()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_133() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_37()) {
    jj_scanpos = xsp;
    if (jj_3_38()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_32() {
    if (jj_scan_token(RECORD)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_74()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_37() {
    if (jj_scan_token(LANGLE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RANGLE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_56() {
    if (jj_scan_token(SEMICOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_55() {
    if (jj_scan_token(ASSIGN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_8() {
    if (jj_scan_token(ELEMENT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(TYPE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(EXTENDS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_84() {
    if (jj_3R_120()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_121() {
    if (jj_scan_token(CONNECTORS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_43() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(DOT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_90() {
    if (jj_3R_126()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_20() {
    if (jj_scan_token(SEMICOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_66()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_28() {
    if (jj_scan_token(RECORD)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_72()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(SEMICOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_42() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(DOT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_105() {
    if (jj_scan_token(SEMICOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_22() {
    if (jj_scan_token(SEMICOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_67()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_71() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_22()) {
    jj_scanpos = xsp;
    if (jj_3R_105()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_7() {
    if (jj_scan_token(ELEMENT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(TYPE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_55()) {
    jj_scanpos = xsp;
    if (jj_3R_56()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_62() {
    if (jj_scan_token(SEMICOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_70() {
    if (jj_scan_token(LANGLE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RANGLE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_143() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_7()) {
    jj_scanpos = xsp;
    if (jj_3_8()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_61() {
    if (jj_scan_token(ASSIGN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_14() {
    if (jj_scan_token(PORT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(TYPE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(EXTENDS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_142() {
    if (jj_scan_token(ATTACHMENT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_30() {
    if (jj_scan_token(SEMICOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_67()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_36() {
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_77()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_132() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_35()) {
    jj_scanpos = xsp;
    if (jj_3_36()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_27() {
    if (jj_scan_token(RECORD)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_67()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_71()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    if (jj_scan_token(RBRACKET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_35() {
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_139() {
    if (jj_3R_147()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_13() {
    if (jj_scan_token(PORT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(TYPE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_61()) {
    jj_scanpos = xsp;
    if (jj_3R_62()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_68() {
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_138() {
    if (jj_3R_146()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_83() {
    if (jj_3R_119()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_26() {
    if (jj_scan_token(SEQUENCE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LANGLE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_69()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RANGLE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_146() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_13()) {
    jj_scanpos = xsp;
    if (jj_3_14()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_31() {
    if (jj_scan_token(RECORD)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_67()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_89() {
    if (jj_3R_125()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_21() {
    if (jj_scan_token(LANGLE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LANGLE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_66()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_137() {
    if (jj_3R_145()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_25() {
    if (jj_scan_token(SEQUENCE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_70()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(SEMICOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_136() {
    if (jj_3R_144()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_73() {
    if (jj_3R_69()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_131() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_24() {
    if (jj_scan_token(SET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_69()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_135() {
    if (jj_3R_143()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_116() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_135()) {
    jj_scanpos = xsp;
    if (jj_3R_136()) {
    jj_scanpos = xsp;
    if (jj_3R_137()) {
    jj_scanpos = xsp;
    if (jj_3R_138()) {
    jj_scanpos = xsp;
    if (jj_3R_139()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_29() {
    if (jj_scan_token(LANGLE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_73()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RANGLE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_23() {
    if (jj_scan_token(SET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_68()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(SEMICOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_114() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_120() {
    if (jj_scan_token(CONNECTOR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_113() {
    if (jj_3R_134()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_112() {
    if (jj_3R_133()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_125() {
    if (jj_scan_token(ROLES)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_111() {
    if (jj_3R_132()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_81() {
    if (jj_3R_117()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_110() {
    if (jj_scan_token(TRUE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_140() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_101() {
    if (jj_scan_token(SEQUENCE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_29()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_80() {
    if (jj_3R_116()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_51() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_80()) {
    jj_scanpos = xsp;
    if (jj_3R_81()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_109() {
    if (jj_scan_token(FALSE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_82() {
    if (jj_3R_118()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_53() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_82()) {
    jj_scanpos = xsp;
    if (jj_3R_83()) {
    jj_scanpos = xsp;
    if (jj_3R_84()) {
    jj_scanpos = xsp;
    if (jj_3R_85()) {
    jj_scanpos = xsp;
    if (jj_3R_86()) {
    jj_scanpos = xsp;
    if (jj_3R_87()) {
    jj_scanpos = xsp;
    if (jj_3R_88()) {
    jj_scanpos = xsp;
    if (jj_3R_89()) {
    jj_scanpos = xsp;
    if (jj_3R_90()) {
    jj_scanpos = xsp;
    if (jj_3R_91()) {
    jj_scanpos = xsp;
    if (jj_3R_92()) {
    jj_scanpos = xsp;
    if (jj_3R_93()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_88() {
    if (jj_3R_124()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_60() {
    if (jj_scan_token(SEMICOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_59() {
    if (jj_scan_token(ASSIGN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_12() {
    if (jj_scan_token(CONNECTOR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(TYPE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(EXTENDS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_94() {
    if (jj_scan_token(PROPERTY)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_4() {
    if (jj_3R_53()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_108() {
    if (jj_scan_token(STRING_LITERAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_66() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_94()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_141() {
    if (jj_scan_token(ATTACHMENTS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_129() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_141()) {
    jj_scanpos = xsp;
    if (jj_3R_142()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_130() {
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_107() {
    if (jj_scan_token(FLOATING_POINT_LITERAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_65() {
    if (jj_3R_53()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_128() {
    if (jj_scan_token(REPRESENTATION)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_140()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_11() {
    if (jj_scan_token(CONNECTOR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(TYPE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_59()) {
    jj_scanpos = xsp;
    if (jj_3R_60()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_18() {
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    if (jj_3R_65()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_65()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  static final private boolean jj_3R_145() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_11()) {
    jj_scanpos = xsp;
    if (jj_3_12()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_106() {
    if (jj_scan_token(INTEGER_LITERAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_100() {
    if (jj_scan_token(SET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_130()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_77() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_106()) {
    jj_scanpos = xsp;
    if (jj_3R_107()) {
    jj_scanpos = xsp;
    if (jj_3R_108()) {
    jj_scanpos = xsp;
    if (jj_3R_109()) {
    jj_scanpos = xsp;
    if (jj_3R_110()) {
    jj_scanpos = xsp;
    if (jj_3R_111()) {
    jj_scanpos = xsp;
    if (jj_3R_112()) {
    jj_scanpos = xsp;
    if (jj_3R_113()) {
    jj_scanpos = xsp;
    if (jj_3R_114()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_17() {
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_19() {
    if (jj_scan_token(SEMICOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_66()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_99() {
    if (jj_scan_token(ANY)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_123() {
    if (jj_scan_token(PORTS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_87() {
    if (jj_3R_123()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_98() {
    if (jj_scan_token(BOOLEAN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_104() {
    if (jj_scan_token(COLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_115() {
    if (jj_scan_token(COLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_103() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_93() {
    if (jj_3R_129()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_3() {
    if (jj_3R_51()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_54() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_3()) {
    jj_scanpos = xsp;
    if (jj_3_4()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_97() {
    if (jj_scan_token(STRING)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_117() {
    if (jj_scan_token(PROPERTY)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(TYPE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_79() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_115()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(ASSIGN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_119() {
    if (jj_scan_token(COMPONENTS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_124() {
    if (jj_scan_token(ROLE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_67() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_103()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    xsp = jj_scanpos;
    if (jj_3R_104()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_96() {
    if (jj_scan_token(FLOAT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_6() {
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    if (jj_3R_54()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_54()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  static final private boolean jj_3R_127() {
    if (jj_scan_token(PROPERTIES)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_76() {
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_95() {
    if (jj_scan_token(INT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_5() {
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_69() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_95()) {
    jj_scanpos = xsp;
    if (jj_3R_96()) {
    jj_scanpos = xsp;
    if (jj_3R_97()) {
    jj_scanpos = xsp;
    if (jj_3R_98()) {
    jj_scanpos = xsp;
    if (jj_3R_99()) {
    jj_scanpos = xsp;
    if (jj_3R_100()) {
    jj_scanpos = xsp;
    if (jj_3R_101()) {
    jj_scanpos = xsp;
    if (jj_3_31()) {
    jj_scanpos = xsp;
    if (jj_3_32()) {
    jj_scanpos = xsp;
    if (jj_3_33()) {
    jj_scanpos = xsp;
    if (jj_3_34()) {
    jj_scanpos = xsp;
    if (jj_3R_102()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_92() {
    if (jj_3R_128()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_41() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RBRACKET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_58() {
    if (jj_scan_token(SEMICOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_86() {
    if (jj_3R_122()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_57() {
    if (jj_scan_token(ASSIGN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_10() {
    if (jj_scan_token(COMPONENT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(TYPE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(EXTENDS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_126() {
    if (jj_scan_token(PROPERTY)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_66()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_102() {
    if (jj_3R_131()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_34() {
    if (jj_scan_token(ENUM)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_76()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_39() {
    if (jj_scan_token(SEMICOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_79()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_2() {
    if (jj_3R_52()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_9() {
    if (jj_scan_token(COMPONENT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(TYPE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_57()) {
    jj_scanpos = xsp;
    if (jj_3R_58()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_144() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_9()) {
    jj_scanpos = xsp;
    if (jj_3_10()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static private boolean jj_initialized_once = false;
  static public AcmeParserTokenManager token_source;
  static public JavaCharStream jj_input_stream;
  static public Token token, jj_nt;
  static private int jj_ntk;
  static private Token jj_scanpos, jj_lastpos;
  static private int jj_la;
  static public boolean lookingAhead = false;
  static private boolean jj_semLA;
  static private int jj_gen;
  static final private int[] jj_la1 = new int[155];
  static final private int[] jj_la1_0 = {0x0,0x0,0xc55600,0xc00200,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x40000000,0x1dffc00,0x455400,0x55400,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x15600,0x0,0x0,0x0,0x0,0x0,0x1dbfc00,0x0,0x20000000,0x1dbfc00,0x1c00000,0x1c00000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x1c0c000,0x1c0c000,0x0,0x20000000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x1c30000,0x1c30000,0x0,0x20000000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x1c00000,0x1c00000,0x0,0x20000000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x1c00000,0x1c00000,0x0,0x20000000,0x0,0xc00000,0xc00000,0x0,0x0,0xc00000,0xc00000,0x0,0x180000,0x0,0x0,0x400000,0x0,0x400000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x8000000,0x0,0x0,0x0,0xc00000,0xc00000,0x0,};
  static final private int[] jj_la1_1 = {0x4,0x300000,0x2,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x200ff8,0x0,0x0,0x0,0x0,0x0,0x0,0x1,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x200000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x4000001,0x0,0x0,0x0,0x0,0x200000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x4000001,0x0,0x0,0x0,0x0,0x200000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x4000001,0x0,0x0,0x0,0x0,0x200000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x4000001,0x0,0x200000,0x0,0x0,0x4000000,0x0,0x0,0x0,0x4000000,0x0,0x0,0x0,0x200000,0x0,0x0,0x0,0x0,0x0,0x0,0x40000000,0x40000000,0x0,0x4000000,0x4000000,0x40000000,0x0,0x0,0x10000000,0xc78,0x200ff8,0x4000000,0x200ff8,0x0,0x0,0x10000000,0x0,0x4000000,0x4000000,0x9f8,0x200000,0x0,0x0,0x54347000,0x0,0x0,0x0,0x0,0x0,0x200000,0x0,0x0,0x200000,0x0,0x0,0x0,0x4000000,};
  static final private int[] jj_la1_2 = {0x0,0x1000000,0x0,0x0,0x1000000,0x1000000,0x1160104,0x1160104,0x1160104,0x1,0x2,0x1,0x11,0x0,0x0,0x0,0x1,0x11,0x2,0x1,0x1,0x11,0x2,0x1,0x1,0x11,0x2,0x1,0x1,0x11,0x2,0x1,0x1,0x11,0x2,0x1,0x0,0x2,0x100,0x1,0x11,0x2,0x0,0x0,0x0,0x0,0x0,0x0,0x2,0x100,0x11,0x0,0x2,0x100,0x11,0x1,0x2,0x0,0x0,0x0,0x0,0x2,0x100,0x11,0x0,0x2,0x100,0x11,0x1,0x2,0x0,0x0,0x0,0x0,0x2,0x100,0x11,0x0,0x2,0x100,0x11,0x1,0x2,0x0,0x0,0x0,0x0,0x2,0x100,0x11,0x0,0x2,0x100,0x11,0x1,0x2,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x1,0x0,0x0,0x0,0x0,0x1,0x1,0x0,0x1,0x0,0x100,0x10,0x1,0x1,0x0,0x0,0x2,0x0,0x0,0x0,0x1,0x1,0x0,0x0,0x0,0x0,0x0,0x1,0x1,0x0,0x2,0x0,0x0,0x0,0x0,0x2,0x100,0x0,0x2,0x2,0x1,0x1,0x100,0x0,0x0,0x1,0x0,0x1,0x0,0x0,0x0,};
  static final private int[] jj_la1_3 = {0x0,0x2,0x0,0x0,0x2,0x2,0xe,0xe,0xe,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,};
  static final private JJCalls[] jj_2_rtns = new JJCalls[43];
  static private boolean jj_rescan = false;
  static private int jj_gc = 0;

  public AcmeParser(java.io.InputStream stream) {
    if (jj_initialized_once) {
      System.out.println("ERROR: Second call to constructor of static parser.  You must");
      System.out.println("       either use ReInit() or set the JavaCC option STATIC to false");
      System.out.println("       during parser generation.");
      throw new Error();
    }
    jj_initialized_once = true;
    jj_input_stream = new JavaCharStream(stream, 1, 1);
    token_source = new AcmeParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 155; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  static public void ReInit(java.io.InputStream stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 155; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public AcmeParser(java.io.Reader stream) {
    if (jj_initialized_once) {
      System.out.println("ERROR: Second call to constructor of static parser.  You must");
      System.out.println("       either use ReInit() or set the JavaCC option STATIC to false");
      System.out.println("       during parser generation.");
      throw new Error();
    }
    jj_initialized_once = true;
    jj_input_stream = new JavaCharStream(stream, 1, 1);
    token_source = new AcmeParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 155; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  static public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 155; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public AcmeParser(AcmeParserTokenManager tm) {
    if (jj_initialized_once) {
      System.out.println("ERROR: Second call to constructor of static parser.  You must");
      System.out.println("       either use ReInit() or set the JavaCC option STATIC to false");
      System.out.println("       during parser generation.");
      throw new Error();
    }
    jj_initialized_once = true;
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 155; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(AcmeParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 155; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  static final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      if (++jj_gc > 100) {
        jj_gc = 0;
        for (int i = 0; i < jj_2_rtns.length; i++) {
          JJCalls c = jj_2_rtns[i];
          while (c != null) {
            if (c.gen < jj_gen) c.first = null;
            c = c.next;
          }
        }
      }
      trace_token(token, "");
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  static final private boolean jj_scan_token(int kind) {
    if (jj_scanpos == jj_lastpos) {
      jj_la--;
      if (jj_scanpos.next == null) {
        jj_lastpos = jj_scanpos = jj_scanpos.next = token_source.getNextToken();
      } else {
        jj_lastpos = jj_scanpos = jj_scanpos.next;
      }
    } else {
      jj_scanpos = jj_scanpos.next;
    }
    if (jj_rescan) {
      int i = 0; Token tok = token;
      while (tok != null && tok != jj_scanpos) { i++; tok = tok.next; }
      if (tok != null) jj_add_error_token(kind, i);
    }
    return (jj_scanpos.kind != kind);
  }

  static final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
      trace_token(token, " (in getNextToken)");
    return token;
  }

  static final public Token getToken(int index) {
    Token t = lookingAhead ? jj_scanpos : token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  static final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  static private java.util.Vector jj_expentries = new java.util.Vector();
  static private int[] jj_expentry;
  static private int jj_kind = -1;
  static private int[] jj_lasttokens = new int[100];
  static private int jj_endpos;

  static private void jj_add_error_token(int kind, int pos) {
    if (pos >= 100) return;
    if (pos == jj_endpos + 1) {
      jj_lasttokens[jj_endpos++] = kind;
    } else if (jj_endpos != 0) {
      jj_expentry = new int[jj_endpos];
      for (int i = 0; i < jj_endpos; i++) {
        jj_expentry[i] = jj_lasttokens[i];
      }
      boolean exists = false;
      for (java.util.Enumeration enum = jj_expentries.elements(); enum.hasMoreElements();) {
        int[] oldentry = (int[])(enum.nextElement());
        if (oldentry.length == jj_expentry.length) {
          exists = true;
          for (int i = 0; i < jj_expentry.length; i++) {
            if (oldentry[i] != jj_expentry[i]) {
              exists = false;
              break;
            }
          }
          if (exists) break;
        }
      }
      if (!exists) jj_expentries.addElement(jj_expentry);
      if (pos != 0) jj_lasttokens[(jj_endpos = pos) - 1] = kind;
    }
  }

  static final public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[100];
    for (int i = 0; i < 100; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 155; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
          if ((jj_la1_1[i] & (1<<j)) != 0) {
            la1tokens[32+j] = true;
          }
          if ((jj_la1_2[i] & (1<<j)) != 0) {
            la1tokens[64+j] = true;
          }
          if ((jj_la1_3[i] & (1<<j)) != 0) {
            la1tokens[96+j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 100; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    jj_endpos = 0;
    jj_rescan_token();
    jj_add_error_token(0, 0);
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  static private int trace_indent = 0;
  static private boolean trace_enabled = true;

  static final public void enable_tracing() {
    trace_enabled = true;
  }

  static final public void disable_tracing() {
    trace_enabled = false;
  }

  static final private void trace_call(String s) {
    if (trace_enabled) {
      for (int i = 0; i < trace_indent; i++) { System.out.print(" "); }
      System.out.println("Call:   " + s);
    }
    trace_indent = trace_indent + 2;
  }

  static final private void trace_return(String s) {
    trace_indent = trace_indent - 2;
    if (trace_enabled) {
      for (int i = 0; i < trace_indent; i++) { System.out.print(" "); }
      System.out.println("Return: " + s);
    }
  }

  static final private void trace_token(Token t, String where) {
    if (trace_enabled) {
      for (int i = 0; i < trace_indent; i++) { System.out.print(" "); }
      System.out.print("Consumed token: <" + tokenImage[t.kind]);
      if (t.kind != 0 && !tokenImage[t.kind].equals("\"" + t.image + "\"")) {
        System.out.print(": \"" + t.image + "\"");
      }
      System.out.println(">" + where);
    }
  }

  static final private void trace_scan(Token t1, int t2) {
    if (trace_enabled) {
      for (int i = 0; i < trace_indent; i++) { System.out.print(" "); }
      System.out.print("Visited token: <" + tokenImage[t1.kind]);
      if (t1.kind != 0 && !tokenImage[t1.kind].equals("\"" + t1.image + "\"")) {
        System.out.print(": \"" + t1.image + "\"");
      }
      System.out.println(">; Expected token: <" + tokenImage[t2] + ">");
    }
  }

  static final private void jj_rescan_token() {
    jj_rescan = true;
    for (int i = 0; i < 43; i++) {
      JJCalls p = jj_2_rtns[i];
      do {
        if (p.gen > jj_gen) {
          jj_la = p.arg; jj_lastpos = jj_scanpos = p.first;
          switch (i) {
            case 0: jj_3_1(); break;
            case 1: jj_3_2(); break;
            case 2: jj_3_3(); break;
            case 3: jj_3_4(); break;
            case 4: jj_3_5(); break;
            case 5: jj_3_6(); break;
            case 6: jj_3_7(); break;
            case 7: jj_3_8(); break;
            case 8: jj_3_9(); break;
            case 9: jj_3_10(); break;
            case 10: jj_3_11(); break;
            case 11: jj_3_12(); break;
            case 12: jj_3_13(); break;
            case 13: jj_3_14(); break;
            case 14: jj_3_15(); break;
            case 15: jj_3_16(); break;
            case 16: jj_3_17(); break;
            case 17: jj_3_18(); break;
            case 18: jj_3_19(); break;
            case 19: jj_3_20(); break;
            case 20: jj_3_21(); break;
            case 21: jj_3_22(); break;
            case 22: jj_3_23(); break;
            case 23: jj_3_24(); break;
            case 24: jj_3_25(); break;
            case 25: jj_3_26(); break;
            case 26: jj_3_27(); break;
            case 27: jj_3_28(); break;
            case 28: jj_3_29(); break;
            case 29: jj_3_30(); break;
            case 30: jj_3_31(); break;
            case 31: jj_3_32(); break;
            case 32: jj_3_33(); break;
            case 33: jj_3_34(); break;
            case 34: jj_3_35(); break;
            case 35: jj_3_36(); break;
            case 36: jj_3_37(); break;
            case 37: jj_3_38(); break;
            case 38: jj_3_39(); break;
            case 39: jj_3_40(); break;
            case 40: jj_3_41(); break;
            case 41: jj_3_42(); break;
            case 42: jj_3_43(); break;
          }
        }
        p = p.next;
      } while (p != null);
    }
    jj_rescan = false;
  }

  static final private void jj_save(int index, int xla) {
    JJCalls p = jj_2_rtns[index];
    while (p.gen > jj_gen) {
      if (p.next == null) { p = p.next = new JJCalls(); break; }
      p = p.next;
    }
    p.gen = jj_gen + xla - jj_la; p.first = token; p.arg = xla;
  }

  static final class JJCalls {
    int gen;
    Token first;
    int arg;
    JJCalls next;
  }

}
