/* Generated By:JJTree&JavaCC: Do not edit this line. ArmaniParser.java */
package acmeLib.armaniParser;

// imports to work with AcmeLib.
import acmeLib.*;
import acmeLib.core.container.*;
import acmeLib.core.exceptions.*;
import acmeLib.core.globals.*;
import acmeLib.core.io.AcmeOutputStream;
import acmeLib.designRules.*;
import acmeLib.designRules.JJTArmaniParserState;
import acmeLib.designRules.ArmaniParserTreeConstants;
import acmeLib.elements.*;
import acmeLib.errorManagement.*;
import acmeLib.properties.*;
import acmeLib.typeManagement.*;
import acmeLib.representations.*;

import java.util.*;
import java.io.*;


public class ArmaniParser/*@bgen(jjtree)*/implements ArmaniParserTreeConstants, ArmaniParserConstants {/*@bgen(jjtree)*/
  protected static JJTArmaniParserState jjtree = new JJTArmaniParserState();
    // protected globals available during parsing
    protected static AcmeDesign global_design = null;
    protected static AcmeDesign toplevel_design = null;
    protected static AcmeDesign builtInAnalysisDesign = null;

    protected static Stack warning_stack = new Stack();
    protected static Stack error_stack = new Stack();

    // kludgy way of dealing with jjtree expression parser's parenthesization
    protected static int parenDepth = 0;

    // tracing (debug) on; modified by enable|disable_tracing
    protected static boolean isTracingEnabled = false;
    // analysis argument ref obj printing on; modified by enable|disable_argPrinting
    protected static boolean isArgPrintingEnabled = false;

    public static void main(String args[]) {
        String ParserID = new String("Armani Parser (release 0.5) with mapping extensions");
        String canonicalInputFilename = null;
        InputStream  inStream = null;
        OutputStream outStream = null;
        ArmaniParser parser;

        if (args.length == 0) {
            System.out.println(ParserID + ":  Reading from standard input . . .");
            inStream = System.in;
            parser = new ArmaniParser(inStream);
            canonicalInputFilename = "System.in";
            outStream = System.out;
        } else if (args.length == 1) {
            System.out.println(ParserID + ":  Reading from file " +
                             args[0] + " . . .");
          try {
            inStream = new java.io.FileInputStream(args[0]);
            parser = new ArmaniParser(inStream);
            java.io.File inputFile = new java.io.File(args[0]);
            try {
                canonicalInputFilename = inputFile.getCanonicalPath();
            } catch (java.io.IOException ioExc) {
                canonicalInputFilename = args[0];
            }
            outStream = System.out;
          } catch (java.io.FileNotFoundException e) {
                System.out.println(ParserID + ":  File " + args[0] + " not found.");
                return;
          }
        } else if (args.length == 2) {
            System.out.println(ParserID + ":  Reading from file "
                               + args[0] + " . . .\n"
                               + "Writing to file " + args[1] + " . . .");
            try {
               inStream = new java.io.FileInputStream(args[0]);
               parser = new ArmaniParser(inStream);
               java.io.File inputFile = new java.io.File(args[0]);
               try {
                    canonicalInputFilename = inputFile.getCanonicalPath();
               } catch (java.io.IOException ioExc) {
                    canonicalInputFilename = args[0];
               }
               outStream = new FileOutputStream(args[1]);
            } catch (java.io.IOException e) {
                System.out.println(ParserID + ":  File " + args[1] + " not found.");
                return;
            }
        } else {
            System.out.println("Acme v3.0 Parser (release 0.1):  " +
                             "Usage is one of:");
            System.out.println("         java ArmaniParser");
            System.out.println("            -- for command-line interpreter from stdin");
            System.out.println("OR");
            System.out.println("         java ArmaniParser < inputfile");
            System.out.println("            -- for batch-style command-line interpretation");
            System.out.println("OR");
            System.out.println("         java ArmaniParser inputfile");
            System.out.println("            -- to directly parse the Acme file inputfile");
            System.out.println("               or for batch-style command-line interpretation");            System.out.println("OR");
            System.out.println("         java ArmaniParser inputfile outputfile");
            System.out.println("            -- to directly parse the Acme file inputfile\n"
                              +"               and export the Acme design to the file outputfile");
            return;
        }

        // initialize the design and start the command interpreter.
        try {

            // set the parser up to tracing and debugging off unless
            // the user explicitly turns it on.
            parser.disable_tracing();

            // initialize the design (by default)
            initDesign();
            global_design.setCanonicalFilename(canonicalInputFilename);

            // it's possible that the initDesign() method will ReInit the
            // parser to parse the builtInAnalysisDesign, so ReInit the
            // parser with the calculated input stream.
            ArmaniParser.ReInit(inStream);

            // clear all errors from the AcmeErrorManager so that we have
            // a clean slate from which to do processing.
            AcmeErrorManager.clearAllErrors();
            global_design = parser.parse_AcmeDesign();

            // store the toplevel design, so that the parser can be run
            // on any "imported" design files.
            toplevel_design = global_design;

                        if (AcmeErrorManager.getNumErrorsReported () != 0) {
                                System.err.println (" ** Errors found: ** ");
                                AcmeErrorManager.printAllErrors (System.err);
                                System.err.flush ();
                                throw new acmeLib.armaniParser.ParseException ("parse error");
                        }


            // resolve all imported designs.
            System.err.print("--> Resolving Imported Designs ...");
            global_design.resolveImportedDesigns();
            // check whether any errors were encountered, if so then bail.
            if (AcmeErrorManager.getNumErrorsReported() != 0) {
                System.err.println(" ** Errors found: ** ");
                AcmeErrorManager.printAllErrors(System.err);
                System.err.flush();
                throw new acmeLib.armaniParser.ParseException("import statement error");
            };
            System.err.println(" done.");

            // resolve all names
            System.err.print("--> Resolving Type Names ...");
            toplevel_design.resolveTypeReferences();
            // check whether any errors were encountered, if so then bail.
            if (AcmeErrorManager.getNumErrorsReported() != 0) {
                System.err.println(" ** Errors found: ** ");
                AcmeErrorManager.printAllErrors(System.err);
                System.err.flush();
                throw new acmeLib.armaniParser.ParseException("typename resolution error");
            };
            System.err.println(" done.");

            // instantiate uninstantiated instances of types
            System.err.print("--> Instantiating elements ...");
            // check whether any errors were encountered, if so then bail.
            if (AcmeErrorManager.getNumErrorsReported() != 0) {
                System.err.println(" ** Errors found: ** ");
                AcmeErrorManager.printAllErrors(System.err);
                System.err.flush();
                throw new acmeLib.armaniParser.ParseException("element instantiation error");
            };
            toplevel_design.instantiateElements();
            System.err.println(" done.");

            // resolve instance names/references
            System.err.print("--> Resolving Instance Names ...");
            toplevel_design.resolveInstanceReferences();
            // check whether any errors were encountered, if so then bail.
            if (AcmeErrorManager.getNumErrorsReported() != 0) {
                System.err.println(" ** Errors found: ** ");
                AcmeErrorManager.printAllErrors(System.err);
                System.err.flush();
                throw new acmeLib.armaniParser.ParseException("instance name resolution error");
            };
            System.err.println(" done.");
            System.err.flush();

            // Announce parsing success if we get to here.
            System.out.println(ParserID +
                          ":  Armani specification parsed successfully.");

            // export
            export_ArmaniDesign(outStream, toplevel_design);

            // typecheck
            typecheckDesign(toplevel_design);

            // view any errors generated
            // viewErrors();

            // repeat
            //pause_for_input();
        }

        catch (acmeLib.armaniParser.ParseException e) {
            System.out.println(ParserID +
                         ":  Encountered errors during Acme specification parse.");
            e.printStackTrace();
            printWarningMsgs();
            printErrorMsgs();
            pause_for_input();
        }

        catch (acmeLib.acmeParser.ParseException e) {
            // RTM 4/14/98 -- client classes and methods such as
            //                AcmeElement.resolveImportedDesigns() sometimes
            //                explicitly throw acmeParser-package ParseException
            //                errors, deal with these here instead of
            //                forcing all clients to throw both kinds of errors,
            //                or change the code base between Acme and Armani...
            System.out.println(ParserID +
                         ":  Encountered errors during Acme specification parse.");
            e.printStackTrace();
            printWarningMsgs();
            printErrorMsgs();
            pause_for_input();
        }


        // close the files we opened
        try {
            if (outStream != null) {
                outStream.close();
            };
        } catch (java.io.IOException ioExc) {};

        try {
            if (inStream != null) {
                inStream.close();
            };
        } catch (java.io.IOException ioExc) {}


    }   // end main method


    //
    // print out warning and error statements
    //
    public static void printWarningMsgs() {
        String cur_msg;
        try {
            while(!warning_stack.empty()) {
                cur_msg = (String) warning_stack.pop();
                if (cur_msg != null)
                    System.err.println("Warning: " + cur_msg);
            }
        } catch (EmptyStackException e) {
            // fall through, all warnings were printed
        }
    }


    public static void printErrorMsgs() {
        String cur_msg;
        try {
            while(!error_stack.empty()) {
                cur_msg = (String) error_stack.pop();
                if (cur_msg != null)
                    System.err.println("Error: " + cur_msg);
            }
        } catch (EmptyStackException e) {
            // fall through, all errors were printed
        }
    }


    public static java.util.Vector getWarningMsgs() {
        String cur_msg;
        java.util.Vector msgs = new java.util.Vector();
        try {
            while(!warning_stack.empty()) {
                cur_msg = (String) warning_stack.pop();
                if (cur_msg != null) {
                    msgs.addElement(new String("Warning: " + cur_msg));
                }
            }
        } catch (EmptyStackException e) {
            // fall through, all warnings were printed
        }
        return msgs;
    }


    public static java.util.Vector getErrorMsgs() {
        String cur_msg;
        java.util.Vector msgs = new java.util.Vector();
        try {
            while(!error_stack.empty()) {
                cur_msg = (String) error_stack.pop();
                if (cur_msg != null) {
                    msgs.addElement(new String("Error: " + cur_msg));
                }
            }
        } catch (EmptyStackException e) {
            // fall through, all warnings were printed
        }
        return msgs;
    }


    //
    // retrieve and initialize warning and error stacks.
    //
    public static java.util.Stack getWarningStack() {
        return warning_stack;
    }

    public static java.util.Stack getErrorStack() {
        return error_stack;
    }

    public static void initErrorStack() {
        error_stack = new java.util.Stack();
    }

    public static void initWarningStack() {
        warning_stack = new java.util.Stack();
    }



    public static void pause_for_input() {
        System.out.println("Please press enter to continue");
        try {
            System.in.read();
        } catch (java.io.IOException e) {
            return;
        }
    }


    //
    // typechecking methods for various parts of the design
    //
    public static void typecheckSystemComponents(AcmeSystem sys) {
        AcmeEnumeration comps = sys.getComponents();
        while (comps.moreItems()) {
            AcmeComponent c = (AcmeComponent) comps.getNextItem();
            boolean typechecks = c.typecheck();
            System.out.println("Component " + c.getName()  + " typechecks = "
                               + c.typecheck());
        }
    }


    public static void typecheckSystemConnectors(AcmeSystem sys) {
        AcmeEnumeration conns = sys.getConnectors();
        while (conns.moreItems()) {
            AcmeConnector c = (AcmeConnector) conns.getNextItem();
            if (c.getDeclaredTypes().getSize() == 0) {
                System.out.println("Connector " + c.getName()
                   + " claims only to be of type Connector");
            } else {
                System.out.println("Connector " + c.getName()  + " typechecks = "
                                   + AcmeTypeManager.typecheckConnector(c));
            }
        }
    }



    public static void typecheckSystemPorts(AcmeSystem sys) {
        AcmeEnumeration ports = sys.getPorts();
        while (ports.moreItems()) {
            AcmePort p = (AcmePort) ports.getNextItem();
            if (p.getDeclaredTypes().getSize() == 0) {
                System.out.println("Port " + p.getName()
                   + " claims only to be of type Port");
            } else {
                System.out.println("Port " + p.getName()  + " typechecks = "
                                   + AcmeTypeManager.typecheckPort(p));
            }
        }
    }


    public static void typecheckSystemRoles(AcmeSystem sys) {
        AcmeEnumeration roles = sys.getRoles();
        while (roles.moreItems()) {
            AcmeRole r = (AcmeRole) roles.getNextItem();
            if (r.getDeclaredTypes().getSize() == 0) {
                System.out.println("Role " + r.getName()
                   + " claims only to be of type Role");
            } else {
                System.out.println("Role " + r.getName()  + " typechecks = "
                                   + AcmeTypeManager.typecheckRole(r));
            }
        }
    }



    //
    // publicly available methods for manipulating the parser
    //

    public static void initDesign() {

        // instantiate a new AcmeDesign and envt. support.
        global_design = new AcmeDesign();

        // clear up space for the parse, as we'll probably need it :-)
        System.gc();

        // if the toplevel design is null, set it to the current global_design.
        // if it is not null, then we are (probably) reinitializing the parser
        // to parse an imported design so don't change the toplevel design.
        if (toplevel_design == null) {
            toplevel_design = global_design;
        }

    }


    // initialize the design with a specific design.
    public static void initDesign(AcmeDesign newGlobalDesign) {

        // set the global design
        global_design = newGlobalDesign;

        // clear up space for the parse, as we'll probably need it :-)
        System.gc();

        // if the toplevel design is null, set it to the current global_design.
        // if it is not null, then we are (probably) reinitializing the parser
        // to parse an imported design so don't change the toplevel design.
        if (toplevel_design == null) {
            toplevel_design = global_design;
        }

    }




    // translate this Armani description into Acme
    public static void export_AcmeDesign(OutputStream out_stream)
    {
        export_AcmeDesign(out_stream, toplevel_design);
    }

    public static void export_AcmeDesign(OutputStream out_stream, AcmeDesign design)
    {
        AcmeOutputStream s = new AcmeOutputStream();
        try {
            design.exportAcme(s);

            if (out_stream == null) {
                s.writeTo(System.out);
                s.flush();
            } else {
                s.writeTo(out_stream);
                s.flush();
            }
        } catch (Exception ex) {
            System.out.println("Caught Exception in AcmeDesign.exportAcme");
            ex.printStackTrace();
            pause_for_input();
        }
    }



    // export the toplevel design as an Armani design.
    public static void export_ArmaniDesign(OutputStream out_stream)
    {
        export_ArmaniDesign(out_stream, toplevel_design);
    }

    public static void export_ArmaniDesign(OutputStream out_stream,
                                           AcmeDesign design)
    {
        AcmeOutputStream s = new AcmeOutputStream();
        try {
            design.exportArmani(s);

            if (out_stream == null) {
                s.writeTo(System.out);
                s.flush();
            } else {
                s.writeTo(out_stream);
                s.flush();
            }
        } catch (Exception ex) {
            System.out.println("Caught Exception in AcmeDesign.exportArmani");
            ex.printStackTrace();
            pause_for_input();
        }
    }



    // view the errors generated by this parsing.
    public static void viewErrors() {
//            ErrorWorkshopFrame errorWks = new ErrorWorkshopFrame("Error Viewer");
//            errorWks.setErrorManager(new AcmeErrorManager());
//            errorWks.setVisible(true);
//            errorWks.toFront();
    }


    // typecheck the entire design
    public static boolean typecheckDesign(AcmeDesign design) {
        // typecheck the whole dang shootin' match:
        System.out.print("--> Typechecking ...");
        boolean designTypechecks = design.typecheck();
        if (designTypechecks) {
            System.out.println(" done. Design typechecks.");
            return true;
        } else {
            // dump any errors that resulted from typechecking the design
            System.out.println(" done. Design _does_not_ typecheck.");
            AcmeEnumeration e = AcmeErrorManager.getErrors();
            int i = 1;
            while(e.moreItems()) {
                AcmeError err = (AcmeError) e.getNextItem();
                System.out.println(i + ") " + err.toString());
                i++;
            }
            return false;
        }
    }


    public static void test_copyAsPrototype(String typeName)
      throws ParseException
    {
        AcmeComponent test_comp = ComponentDeclaration();
        AcmeComponentType gen_type =
                    (AcmeComponentType) test_comp.copyAsPrototype(typeName);

        AcmeOutputStream s = new AcmeOutputStream();
        try {
            System.out.println("\n" + "Original component declaration:\n");
            test_comp.exportAcme(s);

            System.out.println("\n" + "Copied type declaration:\n");
            gen_type.exportAcme(s);

            s.writeTo(System.out);
            s.flush();
        } catch (Exception ex) {
            System.out.println("Caught Exception while exporting Acme");
            ex.printStackTrace();
            pause_for_input();
        }

    }

    // accessor/settor methods
    public static AcmeDesign getGlobalDesign() { return global_design; }
    public static AcmeDesign getToplevelDesign() { return toplevel_design; }

    public static void setGlobalDesign(AcmeDesign newGlobalDesign) {
        global_design = newGlobalDesign;
    }
    public static void setToplevelDesign(AcmeDesign newToplevelDesign) {
        toplevel_design = newToplevelDesign;
    }

        public static void processComment (Token t, AcmeObject o) {
            if (t == null) return;
                Token spec = t.specialToken;
                String comment = "";
                while (spec != null) {
                        comment = spec.image + "\n" + comment;
                        spec = spec.specialToken;
                }
                if (!comment.equals ("")) {
                        comment = comment.substring (0, comment.length () - 1); // string trailing \n
                        o.setComment (comment);
                }

        }


  static final public boolean isTracingEnabled() {
    return isTracingEnabled;
  }

  /* Turns on printing of the referenced objects of the analysis arguments.
   */
  static final public void enable_argPrinting() {
    isArgPrintingEnabled = true;
  }

  /* Turns off printing of the referenced objects of the analysis arguments.
   */
  static final public void disable_argPrinting() {
    isArgPrintingEnabled = false;
  }

  static final public boolean isArgPrintingEnabled() {
    return isArgPrintingEnabled;
  }


        static protected void reportError (ParseException e) {
                AcmeParseError error = new AcmeParseError (e);
                AcmeErrorManager.errorDetected (error);
        }

        static protected void skip_to (int kind) {
                Token t;
                do {
                        t = getNextToken();
                } while (t.kind != kind && t.kind != EOF);

        }

        static protected ParseException createArmaniParseException (String message) {
                ParseException e = new ParseException (message);
                e.currentToken = token;
                return e;
        }

        static public boolean parserConstructed () {
                return token_source != null;
        }

    static public JJTArmaniParserState getJJTree () {
        return jjtree;
    }

        private static final AcmeElementProtoType MT_ET = new AcmeElementProtoType ("Unknown");
        private static final AcmeRoleType MT_ROLE_TYPE = new AcmeRoleType ("Unknown");
        private static final AcmeGroupType MT_GROUP_TYPE = new AcmeGroupType ("Unknown");
        private static final AcmeComponentType MT_COMPONENT_TYPE = new AcmeComponentType ("Unknown");
        private static final AcmeConnectorType MT_CONNECTOR_TYPE = new AcmeConnectorType ("Unknown");
        private static final AcmePortType MT_PORT_TYPE = new AcmePortType ("Unknown");
        private static final AcmeRole MT_ROLE = new AcmeRole ("Unknown");
        private static final AcmeGroup MT_GROUP = new AcmeGroup ("Unknown");
        private static final AcmeComponent MT_COMPONENT = new AcmeComponent ("Unknown");
        private static final AcmeConnector MT_CONNECTOR = new AcmeConnector ("Unknown");
        private static final AcmePort MT_PORT = new AcmePort ("Unknown");

/*****************************************
 * ACME grammar starts here              *
 *****************************************/

/*
 *  design productions (toplevel production)
 */
  static final public AcmeDesign parse_AcmeDesign() throws ParseException {
    trace_call("parse_AcmeDesign");
    try {
    String filename;
    Token filenameToken;
    AcmeType new_type;
    AcmeMapInstance     new_map;
    AcmeSystem new_system;
    AcmeFamily new_family;
    DesignAnalysis new_designAnalysis;
    AcmeProperty new_prop = null;
    AcmeEnumeration child_enum = null;
    Token start = null;
      try {
        label_1:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case IMPORT:
            ;
            break;
          default:
            jj_la1[0] = jj_gen;
            break label_1;
          }
          start = jj_consume_token(IMPORT);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case IDENTIFIER:
          case REM:
          case 125:
            filename = Filename();
            jj_consume_token(SEMICOLON);
            break;
          case STRING_LITERAL:
            filenameToken = jj_consume_token(STRING_LITERAL);
            jj_consume_token(SEMICOLON);
                filename = filenameToken.image;
            break;
          default:
            jj_la1[1] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
            // make sure that we have the appropriate separator character
            // for either Unix or Windows (don't know about other file systems...)
            filename = filename.replace('\\',java.io.File.separatorChar);
            filename = filename.replace('/',java.io.File.separatorChar);

            global_design.addDesignToImport(filename);
            processComment (start, global_design);
        }
        label_2:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case SYSTEM:
          case COMPONENT:
          case GROUP:
          case CONNECTOR:
          case PORT:
          case ROLE:
          case ELEMENT:
          case PROPERTY:
          case PROPERTIES:
          case FAMILY:
          case STYLE:
          case EXTERNAL:
          case DESIGN:
          case ANALYSIS:
            ;
            break;
          default:
            jj_la1[2] = jj_gen;
            break label_2;
          }
          if (jj_2_1(2)) {
            new_type = TypeDeclaration();
            if (new_type instanceof AcmePropertyType) {
                ((AcmePropertyType) new_type).setDeclarationScope(global_design);
            } else if (new_type instanceof AcmeElementType) {
                ((AcmeElement) new_type).setParentDesign(global_design);
                ((AcmeElement) new_type).setParent(global_design);
                //hujn add AcmeMapInstanceType
            } else {
                {if (true) throw createArmaniParseException ("Line " /* error_line */ +
                        ": Type " + new_type.getTypeName()
                        + " is neither a property type nor an element type.");}

            }

            try {
                global_design.addType(new_type);
            }
            catch (acmeLib.core.exceptions.AcmeIllegalNameException ainExc) {
                {if (true) throw createArmaniParseException ("Line " /* error_line */ +
                        ": " + ainExc.getMessage());}

            }
          } else if (jj_2_2(2)) {
            new_family = FamilyDeclaration();
            try {
                global_design.addFamily(new_family);
                new_family.setParentDesign(global_design);
                new_family.setParent(global_design);
            }
            catch (acmeLib.core.exceptions.AcmeIllegalNameException ainExc) {
                {if (true) throw createArmaniParseException ("Line " /* error_line */ +
                        ": " + ainExc.getMessage());}
            }
          } else if (jj_2_3(2)) {
            new_designAnalysis = DesignAnalysisDeclaration(global_design);
            try {
                global_design.addDesignAnalysis(new_designAnalysis);
            } catch (acmeLib.core.exceptions.AcmeIllegalNameException ainExc) {
                {if (true) throw createArmaniParseException ("Line " /* error_line */ +
                        ": " + ainExc.getMessage());}
            }
          } else {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case PROPERTY:
              new_prop = PropertyDeclaration(global_design);
          try {
            global_design.addProperty(new_prop);
          }
          catch (AcmeDuplicateNameException dupExc) {
                // there is already a property with the same name as
                // new_prop in this component.  attempt to unify new_prop
                // with the one that already exists.  If it's a duplicate
                // name, but it's not a property that has the name, just
                // rethrow the error.
                try {
                    AcmeProperty targetProp =
                                    global_design.getProperty(new_prop.getName());
                    if (targetProp == null) {
                        {if (true) throw createArmaniParseException("(line " /* error_line */ + ") "
                                         + dupExc.getMessage());}

                    } else {
                        // attempt to unify the new_port with the existing one.
                        AcmeTypeManager.extendProperty(new_prop, targetProp);
                    }
                } catch (AcmePropertyExtensionFailedException pefExc) {
                    {if (true) throw createArmaniParseException("(line " /* error_line */ + ") "
                                     + pefExc.getMessage());}

                }
          } catch (acmeLib.core.exceptions.AcmeIllegalNameException e) {
                {if (true) throw createArmaniParseException("(line " /* error_line */ + ") "
                                 + e.getMessage());}

          }
              break;
            case PROPERTIES:
              child_enum = PropertiesBlock(global_design);
          while (child_enum.moreItems()) {
            new_prop = (AcmeProperty) child_enum.getNextItem();
            try {
                global_design.addProperty(new_prop);
            }
            catch (AcmeDuplicateNameException dupExc) {
                // there is already a property with the same name as
                // new_prop in this component.  attempt to unify new_prop
                // with the one that already exists.  If it's a duplicate
                // name, but it's not a property that has the name, just
                // rethrow the error.
                try {
                    AcmeProperty targetProp =
                                    global_design.getProperty(new_prop.getName());
                    if (targetProp == null) {
                        {if (true) throw createArmaniParseException("(line " /* error_line */ + ") "
                                         + dupExc.getMessage());}

                    } else {
                        // attempt to unify the new_port with the existing one.
                        AcmeTypeManager.extendProperty(new_prop, targetProp);
                    }
                } catch (AcmePropertyExtensionFailedException pefExc) {
                    {if (true) throw createArmaniParseException("(line " /* error_line */ + ") "
                                     + pefExc.getMessage());}

                }
            } catch (acmeLib.core.exceptions.AcmeIllegalNameException e) {
                {if (true) throw createArmaniParseException(e.getMessage());}

            }
          }
          // mark the enumeration for gc.
          child_enum = null;
              break;
            case SYSTEM:
              new_system = SystemDeclaration();
          try {
              global_design.addSystem(new_system);
          } catch (acmeLib.core.exceptions.AcmeIllegalNameException e) {
                {if (true) throw createArmaniParseException (e.getMessage());}

          }
              break;
            default:
              jj_la1[3] = jj_gen;
              jj_consume_token(-1);
              throw new ParseException();
            }
          }
        }
        jj_consume_token(0);
      } catch (ParseException e) {
                reportError (e);
      }
        {if (true) return global_design;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("parse_AcmeDesign");
    }
  }

  static final public String Filename() throws ParseException {
    trace_call("Filename");
    try {
    Token curIdToken, curSeparator;
    StringBuffer buf = new StringBuffer();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case REM:
      case 125:
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case 125:
          jj_consume_token(125);
            buf.append("$");
          break;
        case REM:
          jj_consume_token(REM);
                                       buf.append("%");
          break;
        default:
          jj_la1[4] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        break;
      default:
        jj_la1[5] = jj_gen;
        ;
      }
      curIdToken = jj_consume_token(IDENTIFIER);
//        buf.setLength(0);
        buf.append(curIdToken.image);
      label_3:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case DOT:
        case COLON:
        case PLUS:
        case MINUS:
        case SLASH:
        case REM:
        case 125:
        case 126:
        case 127:
          ;
          break;
        default:
          jj_la1[6] = jj_gen;
          break label_3;
        }
        label_4:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case DOT:
            curSeparator = jj_consume_token(DOT);
            break;
          case COLON:
            curSeparator = jj_consume_token(COLON);
            break;
          case MINUS:
            curSeparator = jj_consume_token(MINUS);
            break;
          case PLUS:
            curSeparator = jj_consume_token(PLUS);
            break;
          case 126:
            curSeparator = jj_consume_token(126);
            break;
          case 127:
            curSeparator = jj_consume_token(127);
            break;
          case SLASH:
            curSeparator = jj_consume_token(SLASH);
            break;
          case 125:
            curSeparator = jj_consume_token(125);
            break;
          case REM:
            curSeparator = jj_consume_token(REM);
            break;
          default:
            jj_la1[7] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
                buf.append(curSeparator.image);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case DOT:
          case COLON:
          case PLUS:
          case MINUS:
          case SLASH:
          case REM:
          case 125:
          case 126:
          case 127:
            ;
            break;
          default:
            jj_la1[8] = jj_gen;
            break label_4;
          }
        }
        curIdToken = jj_consume_token(IDENTIFIER);
            buf.append(curIdToken.image);
      }
        {if (true) return buf.toString();}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("Filename");
    }
  }

  static final public AcmeFamily FamilyDeclaration() throws ParseException {
    trace_call("FamilyDeclaration");
    try {
    AcmeFamily new_family = new AcmeFamily ();
    Token cur_token;
    AcmeElementType cur_super_type;
    Token start = null;
      try {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case FAMILY:
          start = jj_consume_token(FAMILY);
          break;
        case STYLE:
          start = jj_consume_token(STYLE);
          break;
        default:
          jj_la1[9] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        cur_token = jj_consume_token(IDENTIFIER);
        new_family = new AcmeFamily(cur_token.image);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SEMICOLON:
          jj_consume_token(SEMICOLON);
          break;
        case ASSIGN:
          jj_consume_token(ASSIGN);
          FamilyBody(new_family);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case SEMICOLON:
            jj_consume_token(SEMICOLON);
            break;
          default:
            jj_la1[10] = jj_gen;
            ;
          }
          break;
        case EXTENDS:
          jj_consume_token(EXTENDS);
          cur_super_type = lookup_SystemTypeByName();
            new_family.addSuperType(cur_super_type);
          label_5:
          while (true) {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case COMMA:
              ;
              break;
            default:
              jj_la1[11] = jj_gen;
              break label_5;
            }
            jj_consume_token(COMMA);
            cur_super_type = lookup_SystemTypeByName();
                new_family.addSuperType(cur_super_type);
          }
          jj_consume_token(WITH);
          FamilyBody(new_family);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case SEMICOLON:
            jj_consume_token(SEMICOLON);
            break;
          default:
            jj_la1[12] = jj_gen;
            ;
          }
          break;
        default:
          jj_la1[13] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      } catch (ParseException e) {
        reportError (e);
        skip_to (SEMICOLON);
        if (new_family == null) {
          {if (true) return new AcmeFamily ();}
        }
      }
    new_family.setParentDesign(global_design);
    // make every family be a subtype of the base "family" type.
    processComment (start, new_family);
    new_family.addSuperType(
                    acmeLib.core.globals.ConstantTypes.SYSTEM_BASE_TYPE);
    {if (true) return new_family;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("FamilyDeclaration");
    }
  }

  static final public void FamilyBody(AcmeFamily fam) throws ParseException {
    trace_call("FamilyBody");
    try {
    AcmeType new_type = null;
    String new_type_name;
      if (jj_2_6(2)) {
        jj_consume_token(LBRACE);
        jj_consume_token(RBRACE);
      } else if (jj_2_7(2)) {
        jj_consume_token(LBRACE);
        label_6:
        while (true) {
          if (jj_2_4(2)) {
            new_type = TypeDeclaration();
          if (new_type != null) {
            if (new_type.getTypeName() != null) {
                if (fam.getType(new_type.getTypeName()) == null)  {
                    try {
                        fam.addType(new_type);
                    }
                    catch (acmeLib.core.exceptions.AcmeIllegalNameException ainExc) {
                        {if (true) throw createArmaniParseException ( ainExc.getMessage());}
                    }

                    if (new_type instanceof AcmeElement) {
                        // then new_type is an AcmeElementType
                        ((AcmeElement) new_type).setParent(fam);
                        ((AcmeElement) new_type).setParentDesign(global_design);
                    } else if (new_type instanceof AcmePropertyType) {
                        ((AcmePropertyType) new_type).setDeclarationScope(fam);
                    }
                    //hujn add something for map type decl
                    // seems it can be handled properly.

                } else {
                    // error, can't redefine a type within a family definition
                    {if (true) throw createArmaniParseException ("Illegal redefinition of type "
                        + new_type.getTypeName() + " in family "
                        + fam.getName());}

                }
            }
          }
          } else if (jj_2_5(2)) {
            SystemStructure(fam);
          } else {
            jj_consume_token(-1);
            throw new ParseException();
          }
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMPONENT:
          case GROUP:
          case COMPONENTS:
          case CONNECTOR:
          case CONNECTORS:
          case PORT:
          case PORTS:
          case ROLE:
          case ROLES:
          case ELEMENT:
          case ATTACHMENT:
          case ATTACHMENTS:
          case PROPERTY:
          case PROPERTIES:
          case REPRESENTATION:
          case EXTERNAL:
          case DESIGN:
          case ANALYSIS:
          case INVARIANT:
          case HEURISTIC:
            ;
            break;
          default:
            jj_la1[14] = jj_gen;
            break label_6;
          }
        }
        jj_consume_token(RBRACE);
      } else {
        jj_consume_token(-1);
        throw new ParseException();
      }
    } finally {
      trace_return("FamilyBody");
    }
  }

  static final public AcmeType TypeDeclaration() throws ParseException {
    trace_call("TypeDeclaration");
    try {
    AcmeType new_type;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMPONENT:
      case GROUP:
      case CONNECTOR:
      case PORT:
      case ROLE:
      case ELEMENT:
        new_type = ElementTypeDeclaration();
                                          {if (true) return new_type;}
        break;
      case PROPERTY:
        new_type = PropertyTypeDeclaration();
                                           {if (true) return new_type;}
        break;
      default:
        jj_la1[15] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("TypeDeclaration");
    }
  }

/*
 * Architectural element types
 */
  static final public AcmeElementType ElementTypeDeclaration() throws ParseException {
    trace_call("ElementTypeDeclaration");
    try {
    AcmeElementType new_type;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ELEMENT:
        new_type = ElementProtoTypeDeclaration();
        {if (true) return new_type;}
        break;
      case COMPONENT:
        new_type = ComponentTypeDeclaration();
        {if (true) return new_type;}
        break;
      case GROUP:
        new_type = GroupTypeDeclaration();
        {if (true) return new_type;}
        break;
      case CONNECTOR:
        new_type = ConnectorTypeDeclaration();
        {if (true) return new_type;}
        break;
      case PORT:
        new_type = PortTypeDeclaration();
        {if (true) return new_type;}
        break;
      case ROLE:
        new_type = RoleTypeDeclaration();
        {if (true) return new_type;}
        break;
      default:
        jj_la1[16] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("ElementTypeDeclaration");
    }
  }

  static final public AcmeElementProtoType ElementProtoTypeDeclaration() throws ParseException {
    trace_call("ElementProtoTypeDeclaration");
    try {
    Token id_token;
    AcmeElementProtoType new_elt_type = MT_ET;
    AcmeElementType cur_super_type;
    Token start = null;
      try {
        if (jj_2_8(4)) {
          start = jj_consume_token(ELEMENT);
          jj_consume_token(TYPE);
          id_token = jj_consume_token(IDENTIFIER);
        new_elt_type = new AcmeElementProtoType(id_token.image);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case ASSIGN:
            jj_consume_token(ASSIGN);
            parse_ElementProtoTypeDescription(new_elt_type);
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case SEMICOLON:
              jj_consume_token(SEMICOLON);
              break;
            default:
              jj_la1[17] = jj_gen;
              ;
            }
            break;
          case SEMICOLON:
            jj_consume_token(SEMICOLON);
            break;
          default:
            jj_la1[18] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        } else if (jj_2_9(4)) {
          start = jj_consume_token(ELEMENT);
          jj_consume_token(TYPE);
          id_token = jj_consume_token(IDENTIFIER);
        new_elt_type = new AcmeElementProtoType(id_token.image);
          jj_consume_token(EXTENDS);
          cur_super_type = lookup_ComponentTypeByName();
        new_elt_type.addSuperType(cur_super_type);
          label_7:
          while (true) {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case COMMA:
              ;
              break;
            default:
              jj_la1[19] = jj_gen;
              break label_7;
            }
            jj_consume_token(COMMA);
            cur_super_type = lookup_ComponentTypeByName();
            new_elt_type.addSuperType(cur_super_type);
          }
          jj_consume_token(WITH);
          parse_ElementProtoTypeDescription(new_elt_type);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case SEMICOLON:
            jj_consume_token(SEMICOLON);
            break;
          default:
            jj_la1[20] = jj_gen;
            ;
          }
        } else {
          jj_consume_token(-1);
          throw new ParseException();
        }
      } catch (ParseException e) {
        reportError (e);
        skip_to (SEMICOLON);
      }
    new_elt_type.setParentDesign(global_design);
    processComment (start, new_elt_type);
    // make every element type be a subtype of the basic "element" type.
    new_elt_type.addSuperType(
                    acmeLib.core.globals.ConstantTypes.ELEMENT_BASE_TYPE);
    {if (true) return new_elt_type;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("ElementProtoTypeDeclaration");
    }
  }

  static final public AcmeComponentType ComponentTypeDeclaration() throws ParseException {
    trace_call("ComponentTypeDeclaration");
    try {
    Token id_token;
    AcmeComponentType new_comp_type = MT_COMPONENT_TYPE;
    AcmeElementType cur_super_type;
    Token start = null;
      try {
        if (jj_2_10(4)) {
          start = jj_consume_token(COMPONENT);
          jj_consume_token(TYPE);
          id_token = jj_consume_token(IDENTIFIER);
        new_comp_type = new AcmeComponentType(id_token.image);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case ASSIGN:
            jj_consume_token(ASSIGN);
            parse_ComponentDescription(new_comp_type);
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case SEMICOLON:
              jj_consume_token(SEMICOLON);
              break;
            default:
              jj_la1[21] = jj_gen;
              ;
            }
            break;
          case SEMICOLON:
            jj_consume_token(SEMICOLON);
            break;
          default:
            jj_la1[22] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        } else if (jj_2_11(4)) {
          start = jj_consume_token(COMPONENT);
          jj_consume_token(TYPE);
          id_token = jj_consume_token(IDENTIFIER);
        new_comp_type = new AcmeComponentType(id_token.image);
          jj_consume_token(EXTENDS);
          cur_super_type = lookup_ComponentTypeByName();
        new_comp_type.addSuperType(cur_super_type);
          label_8:
          while (true) {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case COMMA:
              ;
              break;
            default:
              jj_la1[23] = jj_gen;
              break label_8;
            }
            jj_consume_token(COMMA);
            cur_super_type = lookup_ComponentTypeByName();
            new_comp_type.addSuperType(cur_super_type);
          }
          jj_consume_token(WITH);
          parse_ComponentDescription(new_comp_type);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case SEMICOLON:
            jj_consume_token(SEMICOLON);
            break;
          default:
            jj_la1[24] = jj_gen;
            ;
          }
        } else {
          jj_consume_token(-1);
          throw new ParseException();
        }
      } catch (ParseException e) {
  reportError (e);
  skip_to (SEMICOLON);
      }
    new_comp_type.setParentDesign(global_design);
    processComment (start, new_comp_type);
    // make every component type be a subtype of the basic "component" type.
    new_comp_type.addSuperType(
                    acmeLib.core.globals.ConstantTypes.COMPONENT_BASE_TYPE);
    {if (true) return new_comp_type;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("ComponentTypeDeclaration");
    }
  }

  static final public AcmeGroupType GroupTypeDeclaration() throws ParseException {
    trace_call("GroupTypeDeclaration");
    try {
    Token id_token;
    AcmeGroupType new_group_type = MT_GROUP_TYPE;
    AcmeElementType cur_super_type;
    Token start = null;
      try {
        if (jj_2_12(4)) {
          start = jj_consume_token(GROUP);
          jj_consume_token(TYPE);
          id_token = jj_consume_token(IDENTIFIER);
        new_group_type = new AcmeGroupType(id_token.image);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case ASSIGN:
            jj_consume_token(ASSIGN);
            parse_GroupDescription(new_group_type);
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case SEMICOLON:
              jj_consume_token(SEMICOLON);
              break;
            default:
              jj_la1[25] = jj_gen;
              ;
            }
            break;
          case SEMICOLON:
            jj_consume_token(SEMICOLON);
            break;
          default:
            jj_la1[26] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        } else if (jj_2_13(4)) {
          start = jj_consume_token(GROUP);
          jj_consume_token(TYPE);
          id_token = jj_consume_token(IDENTIFIER);
        new_group_type = new AcmeGroupType(id_token.image);
          jj_consume_token(EXTENDS);
          cur_super_type = lookup_GroupTypeByName();
        new_group_type.addSuperType(cur_super_type);
          label_9:
          while (true) {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case COMMA:
              ;
              break;
            default:
              jj_la1[27] = jj_gen;
              break label_9;
            }
            jj_consume_token(COMMA);
            cur_super_type = lookup_GroupTypeByName();
            new_group_type.addSuperType(cur_super_type);
          }
          jj_consume_token(WITH);
          parse_GroupDescription(new_group_type);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case SEMICOLON:
            jj_consume_token(SEMICOLON);
            break;
          default:
            jj_la1[28] = jj_gen;
            ;
          }
        } else {
          jj_consume_token(-1);
          throw new ParseException();
        }
      } catch (ParseException e) {
  reportError (e);
  skip_to (SEMICOLON);
      }
    new_group_type.setParentDesign(global_design);
    processComment (start, new_group_type);
    // make every group type be a subtype of the basic "group" type.
    new_group_type.addSuperType(
                    acmeLib.core.globals.ConstantTypes.GROUP_BASE_TYPE);
    {if (true) return new_group_type;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("GroupTypeDeclaration");
    }
  }

  static final public AcmeConnectorType ConnectorTypeDeclaration() throws ParseException {
    trace_call("ConnectorTypeDeclaration");
    try {
    Token id_token;
    AcmeConnectorType new_conn_type = MT_CONNECTOR_TYPE;
    AcmeElementType cur_super_type;
    Token start  = null;
      try {
        if (jj_2_14(4)) {
          start = jj_consume_token(CONNECTOR);
          jj_consume_token(TYPE);
          id_token = jj_consume_token(IDENTIFIER);
        new_conn_type = new AcmeConnectorType(id_token.image);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case ASSIGN:
            jj_consume_token(ASSIGN);
            parse_ConnectorDescription(new_conn_type);
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case SEMICOLON:
              jj_consume_token(SEMICOLON);
              break;
            default:
              jj_la1[29] = jj_gen;
              ;
            }
            break;
          case SEMICOLON:
            jj_consume_token(SEMICOLON);
            break;
          default:
            jj_la1[30] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        } else if (jj_2_15(4)) {
          start = jj_consume_token(CONNECTOR);
          jj_consume_token(TYPE);
          id_token = jj_consume_token(IDENTIFIER);
        new_conn_type = new AcmeConnectorType(id_token.image);
          jj_consume_token(EXTENDS);
          cur_super_type = lookup_ConnectorTypeByName();
        new_conn_type.addSuperType(cur_super_type);
          label_10:
          while (true) {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case COMMA:
              ;
              break;
            default:
              jj_la1[31] = jj_gen;
              break label_10;
            }
            jj_consume_token(COMMA);
            cur_super_type = lookup_ConnectorTypeByName();
            new_conn_type.addSuperType(cur_super_type);
          }
          jj_consume_token(WITH);
          parse_ConnectorDescription(new_conn_type);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case SEMICOLON:
            jj_consume_token(SEMICOLON);
            break;
          default:
            jj_la1[32] = jj_gen;
            ;
          }
        } else {
          jj_consume_token(-1);
          throw new ParseException();
        }
      } catch (ParseException e) {
  reportError (e);
  skip_to (SEMICOLON);
      }
    new_conn_type.setParentDesign(global_design);
    processComment (start, new_conn_type);
    // make every connector type be a subtype of the basic "connector" type.
    new_conn_type.addSuperType(
                    acmeLib.core.globals.ConstantTypes.CONNECTOR_BASE_TYPE);
    {if (true) return new_conn_type;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("ConnectorTypeDeclaration");
    }
  }

  static final public AcmePortType PortTypeDeclaration() throws ParseException {
    trace_call("PortTypeDeclaration");
    try {
    Token id_token;
    AcmePortType new_port_type = MT_PORT_TYPE;
    AcmeElementType cur_super_type;
    Token start = null;
      try {
        if (jj_2_16(4)) {
          start = jj_consume_token(PORT);
          jj_consume_token(TYPE);
          id_token = jj_consume_token(IDENTIFIER);
        new_port_type = new AcmePortType(id_token.image);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case ASSIGN:
            jj_consume_token(ASSIGN);
            parse_PortDescription(new_port_type);
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case SEMICOLON:
              jj_consume_token(SEMICOLON);
              break;
            default:
              jj_la1[33] = jj_gen;
              ;
            }
            break;
          case SEMICOLON:
            jj_consume_token(SEMICOLON);
            break;
          default:
            jj_la1[34] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        } else if (jj_2_17(4)) {
          start = jj_consume_token(PORT);
          jj_consume_token(TYPE);
          id_token = jj_consume_token(IDENTIFIER);
        new_port_type = new AcmePortType(id_token.image);
          jj_consume_token(EXTENDS);
          cur_super_type = lookup_PortTypeByName();
        new_port_type.addSuperType(cur_super_type);
          label_11:
          while (true) {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case COMMA:
              ;
              break;
            default:
              jj_la1[35] = jj_gen;
              break label_11;
            }
            jj_consume_token(COMMA);
            cur_super_type = lookup_PortTypeByName();
            new_port_type.addSuperType(cur_super_type);
          }
          jj_consume_token(WITH);
          parse_PortDescription(new_port_type);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case SEMICOLON:
            jj_consume_token(SEMICOLON);
            break;
          default:
            jj_la1[36] = jj_gen;
            ;
          }
        } else {
          jj_consume_token(-1);
          throw new ParseException();
        }
      } catch (ParseException e) {
  reportError (e);
  skip_to (SEMICOLON);
      }
    new_port_type.setParentDesign(global_design);
    processComment (start, new_port_type);
    // make every port type be a subtype of the basic "port" type.
    new_port_type.addSuperType(
                    acmeLib.core.globals.ConstantTypes.PORT_BASE_TYPE);
    {if (true) return new_port_type;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("PortTypeDeclaration");
    }
  }

  static final public AcmeRoleType RoleTypeDeclaration() throws ParseException {
    trace_call("RoleTypeDeclaration");
    try {
    Token id_token;
    AcmeRoleType new_role_type = MT_ROLE_TYPE;
    AcmeElementType cur_super_type;
    Token start = null;
      try {
        if (jj_2_18(4)) {
          start = jj_consume_token(ROLE);
          jj_consume_token(TYPE);
          id_token = jj_consume_token(IDENTIFIER);
        new_role_type = new AcmeRoleType(id_token.image);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case ASSIGN:
            jj_consume_token(ASSIGN);
            parse_RoleDescription(new_role_type);
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case SEMICOLON:
              jj_consume_token(SEMICOLON);
              break;
            default:
              jj_la1[37] = jj_gen;
              ;
            }
            break;
          case SEMICOLON:
            jj_consume_token(SEMICOLON);
            break;
          default:
            jj_la1[38] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        } else if (jj_2_19(4)) {
          start = jj_consume_token(ROLE);
          jj_consume_token(TYPE);
          id_token = jj_consume_token(IDENTIFIER);
        new_role_type = new AcmeRoleType(id_token.image);
          jj_consume_token(EXTENDS);
          cur_super_type = lookup_RoleTypeByName();
        new_role_type.addSuperType(cur_super_type);
          label_12:
          while (true) {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case COMMA:
              ;
              break;
            default:
              jj_la1[39] = jj_gen;
              break label_12;
            }
            jj_consume_token(COMMA);
            cur_super_type = lookup_RoleTypeByName();
            new_role_type.addSuperType(cur_super_type);
          }
          jj_consume_token(WITH);
          parse_RoleDescription(new_role_type);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case SEMICOLON:
            jj_consume_token(SEMICOLON);
            break;
          default:
            jj_la1[40] = jj_gen;
            ;
          }
        } else {
          jj_consume_token(-1);
          throw new ParseException();
        }
      } catch (ParseException e) {
  reportError (e);
  skip_to (SEMICOLON);
      }
    new_role_type.setParentDesign(global_design);
    processComment (start, new_role_type);
    // make every port type be a subtype of the basic "port" type.
    new_role_type.addSuperType(
                    acmeLib.core.globals.ConstantTypes.ROLE_BASE_TYPE);
    {if (true) return new_role_type;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("RoleTypeDeclaration");
    }
  }

//
// Type lookup productions
//
  static final public AcmeElementType lookup_SystemTypeByName() throws ParseException {
    trace_call("lookup_SystemTypeByName");
    try {
    Token id_token;
      id_token = jj_consume_token(IDENTIFIER);
        AcmeElementType newType = global_design.getFamily(id_token.image);
        if (newType == null)
            newType = new AcmeUnresolvedElementType(id_token.image);
        {if (true) return newType;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("lookup_SystemTypeByName");
    }
  }

  static final public AcmeElementType lookup_ComponentTypeByName() throws ParseException {
    trace_call("lookup_ComponentTypeByName");
    try {
    Token id_token;
    Token qualifying_token = null;
      if (jj_2_20(2)) {
        qualifying_token = jj_consume_token(IDENTIFIER);
        jj_consume_token(DOT);
      } else {
        ;
      }
      id_token = jj_consume_token(IDENTIFIER);
        if (qualifying_token == null) {
                {if (true) return new AcmeUnresolvedElementType(id_token.image);}
        }
        else {
                {if (true) return new AcmeUnresolvedElementType(qualifying_token.image, id_token.image);}
        }
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("lookup_ComponentTypeByName");
    }
  }

  static final public AcmeElementType lookup_GroupTypeByName() throws ParseException {
    trace_call("lookup_GroupTypeByName");
    try {
    Token id_token;
    Token qualifying_token = null;
      if (jj_2_21(2)) {
        qualifying_token = jj_consume_token(IDENTIFIER);
        jj_consume_token(DOT);
      } else {
        ;
      }
      id_token = jj_consume_token(IDENTIFIER);
        if (qualifying_token == null) {
                {if (true) return new AcmeUnresolvedElementType(id_token.image);}
        }
        else {
                {if (true) return new AcmeUnresolvedElementType(qualifying_token.image, id_token.image);}
        }
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("lookup_GroupTypeByName");
    }
  }

  static final public AcmeElementType lookup_ConnectorTypeByName() throws ParseException {
    trace_call("lookup_ConnectorTypeByName");
    try {
    Token id_token;
    Token qualifying_token = null;
      if (jj_2_22(2)) {
        qualifying_token = jj_consume_token(IDENTIFIER);
        jj_consume_token(DOT);
      } else {
        ;
      }
      id_token = jj_consume_token(IDENTIFIER);
        if (qualifying_token == null) {
                {if (true) return new AcmeUnresolvedElementType(id_token.image);}
        }
        else {
                {if (true) return new AcmeUnresolvedElementType(qualifying_token.image, id_token.image);}
        }
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("lookup_ConnectorTypeByName");
    }
  }

  static final public AcmeElementType lookup_PortTypeByName() throws ParseException {
    trace_call("lookup_PortTypeByName");
    try {
    Token id_token;
    Token qualifying_token = null;
      if (jj_2_23(2)) {
        qualifying_token = jj_consume_token(IDENTIFIER);
        jj_consume_token(DOT);
      } else {
        ;
      }
      id_token = jj_consume_token(IDENTIFIER);
        if (qualifying_token == null) {
                {if (true) return new AcmeUnresolvedElementType(id_token.image);}
        }
        else {
                {if (true) return new AcmeUnresolvedElementType(qualifying_token.image, id_token.image);}
        }
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("lookup_PortTypeByName");
    }
  }

  static final public AcmeElementType lookup_RoleTypeByName() throws ParseException {
    trace_call("lookup_RoleTypeByName");
    try {
    Token id_token;
    Token qualifying_token = null;
      if (jj_2_24(2)) {
        qualifying_token = jj_consume_token(IDENTIFIER);
        jj_consume_token(DOT);
      } else {
        ;
      }
      id_token = jj_consume_token(IDENTIFIER);
        if (qualifying_token == null) {
                {if (true) return new AcmeUnresolvedElementType(id_token.image);}
        }
        else {
                {if (true) return new AcmeUnresolvedElementType(qualifying_token.image, id_token.image);}
        }
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("lookup_RoleTypeByName");
    }
  }

  static final public AcmePropertyType lookup_PropertyTypeByName() throws ParseException {
    trace_call("lookup_PropertyTypeByName");
    try {
    Token id_token;
    Token qualifying_token = null;
      if (jj_2_25(2)) {
        qualifying_token = jj_consume_token(IDENTIFIER);
        jj_consume_token(DOT);
      } else {
        ;
      }
      id_token = jj_consume_token(IDENTIFIER);
        if (qualifying_token == null) {
                {if (true) return new AcmeUnresolvedPropertyType(id_token.image);}
        }
        else {
                {if (true) return new AcmeUnresolvedPropertyType(qualifying_token.image, id_token.image);}
        }
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("lookup_PropertyTypeByName");
    }
  }

/* MAP EXTENSION - DEFUNCT
AcmeElementType lookup_MapTypeByName() :
{
    Token id_token;
}
{
    id_token = <IDENTIFIER>
    {
        return new AcmeUnresolvedElementType(id_token.image);
    }
}
*/

/** production for finding types that can be either elements or properties */
  static final public AcmeType lookup_arbitraryTypeByName() throws ParseException {
    trace_call("lookup_arbitraryTypeByName");
    try {
    Token id_token;
    AcmePropertyType propType = null;
    AcmeType returnType = null;
      if (jj_2_26(3)) {
        propType = PropertyTypeDescription();
            if (!(propType instanceof AcmeUnresolvedPropertyType)) {
                returnType = propType;
            } else {
                returnType = new AcmeUnresolvedType(propType.getTypeName());
            }
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SYSTEM:
          jj_consume_token(SYSTEM);
            returnType = acmeLib.core.globals.ConstantTypes.SYSTEM_BASE_TYPE;
          break;
        case COMPONENT:
          jj_consume_token(COMPONENT);
            returnType = acmeLib.core.globals.ConstantTypes.COMPONENT_BASE_TYPE;
          break;
        case GROUP:
          jj_consume_token(GROUP);
            returnType = acmeLib.core.globals.ConstantTypes.GROUP_BASE_TYPE;
          break;
        case CONNECTOR:
          jj_consume_token(CONNECTOR);
            returnType = acmeLib.core.globals.ConstantTypes.CONNECTOR_BASE_TYPE;
          break;
        case PORT:
          jj_consume_token(PORT);
            returnType = acmeLib.core.globals.ConstantTypes.PORT_BASE_TYPE;
          break;
        case ROLE:
          jj_consume_token(ROLE);
            returnType = acmeLib.core.globals.ConstantTypes.ROLE_BASE_TYPE;
          break;
        case PROPERTY:
          jj_consume_token(PROPERTY);
            returnType = acmeLib.core.globals.ConstantTypes.PROPERTY_REFERENCE_TYPE;
          break;
        case REPRESENTATION:
          jj_consume_token(REPRESENTATION);
            returnType = acmeLib.core.globals.ConstantTypes.REPRESENTATION_REFERENCE_TYPE;
          break;
        default:
          jj_la1[41] = jj_gen;
          if (jj_2_27(3)) {
            returnType = NonPropertySetTypeExpression();
          } else {
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
      }
        {if (true) return returnType;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("lookup_arbitraryTypeByName");
    }
  }

/*
 * System declaration
 */
  static final public AcmeSystem SystemDeclaration() throws ParseException {
    trace_call("SystemDeclaration");
    try {
  AcmeSystem new_sys = new AcmeSystem ();
  AcmeElementType sys_type = null;
  Token system_name_id;
  Token start = null;
      try {
        start = jj_consume_token(SYSTEM);
        system_name_id = jj_consume_token(IDENTIFIER);
    new_sys = new AcmeSystem(system_name_id.image);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COLON:
          jj_consume_token(COLON);
          sys_type = lookup_SystemTypeByName();
        new_sys.addDeclaredType(sys_type);
          label_13:
          while (true) {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case COMMA:
              ;
              break;
            default:
              jj_la1[42] = jj_gen;
              break label_13;
            }
            jj_consume_token(COMMA);
            sys_type = lookup_SystemTypeByName();
            new_sys.addDeclaredType(sys_type);
          }
          break;
        default:
          jj_la1[43] = jj_gen;
          ;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ASSIGN:
          jj_consume_token(ASSIGN);
          SystemBody(new_sys);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case SEMICOLON:
            jj_consume_token(SEMICOLON);
            break;
          default:
            jj_la1[44] = jj_gen;
            ;
          }
          break;
        case SEMICOLON:
          jj_consume_token(SEMICOLON);
          // the declaration System foo : F;  is syntactic sugaring for
          // the declaration System foo : F = new F;
          // Likewise,
          // the declaration System foo : F1, ..., Fn; is equivalent to
          // the declaration System foo : F1, ..., Fn = new T1 extended with T2
          //                                                extended with ... TN.

          // so walk over the list of declared types, and add each one to the
          // list of instantiated types.  They will be properly instantiated
          // later.
          AcmeEnumeration e = new_sys.getDeclaredTypes();
          while (e.moreItems()) {
            new_sys.addInstantiatedType((AcmeElementType) e.getNextItem());
          }
          break;
        default:
          jj_la1[45] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      } catch (ParseException e) {
  reportError (e);
  skip_to (SEMICOLON);
      }
     new_sys.setParentDesign(global_design);
     processComment (start, new_sys);
     {if (true) return new_sys;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("SystemDeclaration");
    }
  }

  static final public void SystemBody(AcmeSystem parent_sys) throws ParseException {
    trace_call("SystemBody");
    try {
    AcmeElementType new_type;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case NEW:
        jj_consume_token(NEW);
        new_type = lookup_SystemTypeByName();
        parent_sys.addInstantiatedType(new_type);
        label_14:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMMA:
            ;
            break;
          default:
            jj_la1[46] = jj_gen;
            break label_14;
          }
          jj_consume_token(COMMA);
          new_type = lookup_SystemTypeByName();
        parent_sys.addInstantiatedType(new_type);
        }
        break;
      default:
        jj_la1[48] = jj_gen;
        if (jj_2_28(2)) {
          jj_consume_token(LBRACE);
          jj_consume_token(RBRACE);
        } else if (jj_2_29(2)) {
          jj_consume_token(LBRACE);
          label_15:
          while (true) {
            SystemStructure(parent_sys);
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case COMPONENT:
            case GROUP:
            case COMPONENTS:
            case CONNECTOR:
            case CONNECTORS:
            case PORT:
            case PORTS:
            case ROLE:
            case ROLES:
            case ATTACHMENT:
            case ATTACHMENTS:
            case PROPERTY:
            case PROPERTIES:
            case REPRESENTATION:
            case EXTERNAL:
            case DESIGN:
            case ANALYSIS:
            case INVARIANT:
            case HEURISTIC:
              ;
              break;
            default:
              jj_la1[47] = jj_gen;
              break label_15;
            }
          }
          jj_consume_token(RBRACE);
        } else {
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case EXTENDED:
        jj_consume_token(EXTENDED);
        jj_consume_token(WITH);
        SystemBody(parent_sys);
        break;
      default:
        jj_la1[49] = jj_gen;
        ;
      }
    } finally {
      trace_return("SystemBody");
    }
  }

  static final public void SystemStructure(AcmeSystem parent_sys) throws ParseException {
    trace_call("SystemStructure");
    try {
    AcmeComponent comp = null;
    AcmeGroup group = null;
    AcmeConnector conn = null;
    AcmePort port = null;
    AcmeRole role = null;
    AcmeMapInstance new_map = null;
    AcmeAttachment attachment = null;
    AcmeProperty new_prop = null;
    AcmeRepresentation new_rep = null;
    AcmeEnumeration child_enum = null;
    DesignAnalysis new_designAnalysis = null;
    DesignRule new_designRule = null;
      if (jj_2_30(2)) {
        comp = ComponentDeclaration();
        try {
            parent_sys.addComponent(comp);
        }
        catch (AcmeDuplicateNameException dupExc) {
            // there is already a component with the same name as
            // comp in this system.  attempt to unify comp
            // with the one that already exists.  If it's a duplicate
            // name, but it's not a component that has the name, just
            // rethrow the error.
            AcmeComponent unifyTargetComp =
                                parent_sys.getComponent(comp.getName());
            if (unifyTargetComp == null) {
                {if (true) throw createArmaniParseException (dupExc.getMessage());}

            } else {
                // attempt to unify the new_port with the existing one.
                AcmeTypeManager.unifyComponent(comp, unifyTargetComp);
            }
        }
        catch (acmeLib.core.exceptions.AcmeIllegalNameException e) {
            {if (true) throw createArmaniParseException (e.getMessage());}

        }
      } else {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMPONENTS:
          child_enum = ComponentsBlock();
          while (child_enum.moreItems()) {
            comp = (AcmeComponent) child_enum.getNextItem();
            try {
                parent_sys.addComponent(comp);
            }
            catch (AcmeDuplicateNameException dupExc) {
                // there is already a component with the same name as
                // comp in this system.  attempt to unify comp
                // with the one that already exists.  If it's a duplicate
                // name, but it's not a component that has the name, just
                // rethrow the error.
                AcmeComponent unifyTargetComp =
                                    parent_sys.getComponent(comp.getName());
                if (unifyTargetComp == null) {
                    {if (true) throw createArmaniParseException (dupExc.getMessage());}

                } else {
                    // attempt to unify the new_port with the existing one.
                    AcmeTypeManager.unifyComponent(comp, unifyTargetComp);
                }
            }
            catch (acmeLib.core.exceptions.AcmeIllegalNameException e) {
                {if (true) throw createArmaniParseException (e.getMessage());}

            }
          }
          // mark the enumeration for gc.
          child_enum = null;
          break;
        default:
          jj_la1[50] = jj_gen;
          if (jj_2_31(2)) {
            group = GroupDeclaration();
        try {
            parent_sys.addGroup(group);
        }
        catch (acmeLib.core.exceptions.AcmeIllegalNameException e) {
           {if (true) throw createArmaniParseException (e.getMessage());}

        }
          } else if (jj_2_32(2)) {
            conn = ConnectorDeclaration();
        try {
            parent_sys.addConnector(conn);
        }
        catch (AcmeDuplicateNameException dupExc) {
            // there is already a connector with the same name as
            // conn in this system.  attempt to unify conn
            // with the one that already exists.  If it's a duplicate
            // name, but it's not a connector that has the name, just
            // rethrow the error.
            AcmeConnector unifyTargetConn =
                                parent_sys.getConnector(conn.getName());
            if (unifyTargetConn == null) {
                {if (true) throw createArmaniParseException (dupExc.getMessage());}
            } else {
                // attempt to unify the new_port with the existing one.
                AcmeTypeManager.unifyConnector(conn, unifyTargetConn);
            }
        }
        catch (acmeLib.core.exceptions.AcmeIllegalNameException e) {
            {if (true) throw createArmaniParseException (e.getMessage());}
        }
          } else {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case CONNECTORS:
              child_enum = ConnectorsBlock();
          while (child_enum.moreItems()) {
            conn = (AcmeConnector) child_enum.getNextItem();
            try {
                parent_sys.addConnector(conn);
            }
            catch (AcmeDuplicateNameException dupExc) {
                // there is already a connector with the same name as
                // conn in this system.  attempt to unify conn
                // with the one that already exists.  If it's a duplicate
                // name, but it's not a connector that has the name, just
                // rethrow the error.
                AcmeConnector unifyTargetConn =
                                    parent_sys.getConnector(conn.getName());
                if (unifyTargetConn == null) {
                                        {if (true) throw createArmaniParseException (dupExc.getMessage());}
                } else {
                    // attempt to unify the new_port with the existing one.
                    AcmeTypeManager.unifyConnector(conn, unifyTargetConn);
                }
            }
            catch (acmeLib.core.exceptions.AcmeIllegalNameException e) {
                {if (true) throw createArmaniParseException (e.getMessage());}
            }
          }
          // mark the enumeration for gc.
          child_enum = null;
              break;
            default:
              jj_la1[51] = jj_gen;
              if (jj_2_33(2)) {
                port = PortDeclaration();
        try {
            parent_sys.addPort(port);
        }
        catch (AcmeDuplicateNameException dupExc) {
            // there is already a port with the same name as
            // new_port in this component.  attempt to unify new_port
            // with the one that already exists.  If it's a duplicate
            // name, but it's not a port that has the name, just rethrow
            // the error.
            AcmePort unifyTargetPort = comp.getPort(port.getName());
            if (unifyTargetPort == null) {
                                {if (true) throw createArmaniParseException (dupExc.getMessage());}
             } else {
                // attempt to unify the new_port with the existing one.
                AcmeTypeManager.unifyPort(port, unifyTargetPort);
            }
        }
        catch (acmeLib.core.exceptions.AcmeIllegalNameException e) {
            {if (true) throw createArmaniParseException (e.getMessage());}
         }
              } else {
                switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
                case PORTS:
                  child_enum = PortsBlock();
          while (child_enum.moreItems()) {
            port = (AcmePort) child_enum.getNextItem();
            try {
                parent_sys.addPort(port);
            }
            catch (AcmeDuplicateNameException dupExc) {
                // there is already a port with the same name as
                // new_port in this component.  attempt to unify new_port
                // with the one that already exists.  If it's a duplicate
                // name, but it's not a port that has the name, just rethrow
                // the error.
                AcmePort unifyTargetPort = comp.getPort(port.getName());
                if (unifyTargetPort == null) {
                    {if (true) throw createArmaniParseException (dupExc.getMessage());}

                } else {
                    // attempt to unify the new_port with the existing one.
                    AcmeTypeManager.unifyPort(port, unifyTargetPort);
                }
            }
            catch (acmeLib.core.exceptions.AcmeIllegalNameException e) {
                {if (true) throw createArmaniParseException (e.getMessage());}
            }
          }
          // mark the enumeration for gc.
          child_enum = null;
                  break;
                default:
                  jj_la1[52] = jj_gen;
                  if (jj_2_34(2)) {
                    role = RoleDeclaration();
        try {
            parent_sys.addRole(role);
        }
        catch (AcmeDuplicateNameException dupExc) {
            // there is already a role with the same name as
            // new_role in this connector.  attempt to unify new_role
            // with the one that already exists.  If it's a duplicate
            // name, but it's not a role that has the name, rethrow
            // the error.
            AcmeRole unifyTargetRole = conn.getRole(role.getName());
            if (unifyTargetRole == null) {
                {if (true) throw createArmaniParseException (dupExc.getMessage());}
            } else {
                // attempt to unify the new_port with the existing one.
                AcmeTypeManager.unifyRole(role, unifyTargetRole);
            }
        }
        catch (acmeLib.core.exceptions.AcmeIllegalNameException e) {
            {if (true) throw createArmaniParseException (e.getMessage());}
        }
                  } else {
                    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
                    case ROLES:
                      child_enum = RolesBlock();
          while (child_enum.moreItems()) {
            role = (AcmeRole) child_enum.getNextItem();
            try {
                parent_sys.addRole(role);
            }
            catch (AcmeDuplicateNameException dupExc) {
                // there is already a role with the same name as
                // new_role in this connector.  attempt to unify new_role
                // with the one that already exists.  If it's a duplicate
                // name, but it's not a role that has the name, rethrow
                // the error.
                AcmeRole unifyTargetRole = conn.getRole(role.getName());
                if (unifyTargetRole == null) {
                    {if (true) throw createArmaniParseException (dupExc.getMessage());}
                } else {
                    // attempt to unify the new_port with the existing one.
                    AcmeTypeManager.unifyRole(role, unifyTargetRole);
                }
            }
            catch (acmeLib.core.exceptions.AcmeIllegalNameException e) {
                {if (true) throw createArmaniParseException (e.getMessage());}
            }
          }
          // mark the enumeration for gc.
          child_enum = null;
                      break;
                    case PROPERTY:
                      new_prop = PropertyDeclaration(parent_sys);
          try {
            parent_sys.addProperty(new_prop);
          }
          catch (AcmeDuplicateNameException dupExc) {
              // there is already a property with the same name as
              // new_prop in this component.  attempt to unify new_prop
              // with the one that already exists.  If it's a duplicate
              // name, but it's not a property that has the name, just
              // rethrow the error.
              try {
                    AcmeProperty targetProp =
                                    parent_sys.getProperty(new_prop.getName());
                    if (targetProp == null) {
                        {if (true) throw createArmaniParseException (dupExc.getMessage());}
                    } else {
                        // attempt to unify the new_port with the existing one.
                        AcmeTypeManager.extendProperty(new_prop, targetProp);
                    }
              } catch (AcmePropertyExtensionFailedException pefExc) {
                    {if (true) throw createArmaniParseException (pefExc.getMessage());}
              }
          } catch (acmeLib.core.exceptions.AcmeIllegalNameException e) {
                {if (true) throw createArmaniParseException (e.getMessage());}
          }
                      break;
                    case PROPERTIES:
                      child_enum = PropertiesBlock(parent_sys);
          while (child_enum.moreItems()) {
            new_prop = (AcmeProperty) child_enum.getNextItem();
            try {
                parent_sys.addProperty(new_prop);
            }
            catch (AcmeDuplicateNameException dupExc) {
                // there is already a property with the same name as
                // new_prop in this component.  attempt to unify new_prop
                // with the one that already exists.  If it's a duplicate
                // name, but it's not a property that has the name, just
                // rethrow the error.
                try {
                    AcmeProperty targetProp =
                                    parent_sys.getProperty(new_prop.getName());
                    if (targetProp == null) {
                        {if (true) throw createArmaniParseException(dupExc.getMessage());}
                    } else {
                        // attempt to unify the new_port with the existing one.
                        AcmeTypeManager.extendProperty(new_prop, targetProp);
                    }
                } catch (AcmePropertyExtensionFailedException pefExc) {
                    {if (true) throw createArmaniParseException (pefExc.getMessage());}
                 }
            } catch (acmeLib.core.exceptions.AcmeIllegalNameException e) {
                {if (true) throw createArmaniParseException (e.getMessage());}
            }
          }
          // mark the enumeration for gc.
          child_enum = null;
                      break;
                    case ATTACHMENT:
                    case ATTACHMENTS:
                      AttachmentsDeclaration(parent_sys);
                      break;
                    case REPRESENTATION:
                      new_rep = RepresentationDeclaration(parent_sys);
            try {
                parent_sys.addRepresentation(new_rep);
            } catch (acmeLib.core.exceptions.AcmeIllegalNameException e) {
                {if (true) throw createArmaniParseException (e.getMessage());}

            }
                      break;
                    default:
                      jj_la1[53] = jj_gen;
                      if (jj_2_35(2)) {
                        new_designAnalysis = DesignAnalysisDeclaration(parent_sys);
            try {
                parent_sys.addDesignAnalysis(new_designAnalysis);
            } catch (acmeLib.core.exceptions.AcmeIllegalNameException ainExc) {
               {if (true) throw createArmaniParseException ( ainExc.getMessage());}
            }
                      } else if (jj_2_36(2)) {
                        new_designRule = parse_DesignRule(parent_sys);
            if (new_designRule == null)
                {if (true) throw new ParseException();}
            else if (new_designRule.getIsInvariant() == true)
                parent_sys.addInvariant(new_designRule);
            else
                parent_sys.addHeuristic(new_designRule);
                      } else {
                        jj_consume_token(-1);
                        throw new ParseException();
                      }
                    }
                  }
                }
              }
            }
          }
        }
      }
    } finally {
      trace_return("SystemStructure");
    }
  }

////////////////////////////////////
//
// element declaration productions
//
////////////////////////////////////


/////////////////////////
// ElementProtoTypes
/////////////////////////


// parse_ElementProtoTypeDescription adds the properties and representations
// of an element type description to the element prototype object it describes
// (passed in as a parameter).
//
// Unlike the other parse_* methods, this only works with element
// prototypes and not with element instances because it is not
// possible to directly establish an Element instance.  This is simply
// used as a generic predicate to check against all categories of
// element instances (and also for instantiation of all categories)
  static final public void parse_ElementProtoTypeDescription(AcmeElementProtoType elt) throws ParseException {
    trace_call("parse_ElementProtoTypeDescription");
    try {
    Token new_type_id_token;
    AcmeProperty new_prop;
    AcmeElementType new_type;
    AcmeRepresentation new_rep;
    AcmeEnumeration child_enum;
    DesignRule new_designRule = null;
      jj_consume_token(LBRACE);
      label_16:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case PROPERTY:
        case PROPERTIES:
        case REPRESENTATION:
          ;
          break;
        default:
          jj_la1[54] = jj_gen;
          break label_16;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case PROPERTY:
          new_prop = PropertyDeclaration(elt);
                try {
                    elt.addProperty(new_prop);
                } catch (AcmeDuplicateNameException dupExc) {
                    try {
                        AcmeProperty targetProp =
                                        elt.getProperty(new_prop.getName());
                        if (targetProp == null) {
                            {if (true) throw createArmaniParseException ( dupExc.getMessage());}
                        } else {
                            // attempt to unify the new_elt with the existing one.
                            AcmeTypeManager.extendProperty(new_prop, targetProp);
                        }
                    } catch (AcmePropertyExtensionFailedException pefExc) {
                        {if (true) throw createArmaniParseException ( pefExc.getMessage());}
                    }
                } catch (acmeLib.core.exceptions.AcmeIllegalNameException e) {
                    {if (true) throw createArmaniParseException ( e.getMessage());}
                }
          break;
        case PROPERTIES:
          child_enum = PropertiesBlock(elt);
              while (child_enum.moreItems()) {
                new_prop = (AcmeProperty) child_enum.getNextItem();
                try {
                    elt.addProperty(new_prop);
                } catch (AcmeDuplicateNameException dupExc) {
                    try {
                        AcmeProperty targetProp =
                                    elt.getProperty(new_prop.getName());
                        if (targetProp == null) {
                           {if (true) throw createArmaniParseException ( dupExc.getMessage());}
                        } else {
                            // attempt to unify the new_elt with the existing one.
                            AcmeTypeManager.extendProperty(new_prop, targetProp);
                        }
                    } catch (AcmePropertyExtensionFailedException pefExc) {
                        {if (true) throw createArmaniParseException ( pefExc.getMessage());}
                    }
                } catch (acmeLib.core.exceptions.AcmeIllegalNameException e) {
                   {if (true) throw createArmaniParseException ( e.getMessage());}
                }
              }
              // mark the enumeration for gc.
              child_enum = null;
          break;
        case REPRESENTATION:
          new_rep = RepresentationDeclaration(elt);
               try {
                   elt.addRepresentation(new_rep);
               } catch (acmeLib.core.exceptions.AcmeIllegalNameException e) {
                   {if (true) throw createArmaniParseException ( e.getMessage());}
               }
          break;
        default:
          jj_la1[55] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
      jj_consume_token(RBRACE);
    } finally {
      trace_return("parse_ElementProtoTypeDescription");
    }
  }

/////////////////////////
// Groups
/////////////////////////
  static final public AcmeGroup GroupDeclaration() throws ParseException {
    trace_call("GroupDeclaration");
    try {
    Token group_id_token;
    AcmeGroup new_group = new AcmeGroup ("Unknown");
    AcmeProperty new_prop;
    AcmeElementType group_type = null;
    Token start = null;
      try {
        start = jj_consume_token(GROUP);
        group_id_token = jj_consume_token(IDENTIFIER);
        new_group = new AcmeGroup(group_id_token.image);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COLON:
          jj_consume_token(COLON);
          group_type = lookup_GroupTypeByName();
        new_group.addDeclaredType(group_type);
          label_17:
          while (true) {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case COMMA:
              ;
              break;
            default:
              jj_la1[56] = jj_gen;
              break label_17;
            }
            jj_consume_token(COMMA);
            group_type = lookup_GroupTypeByName();
           new_group.addDeclaredType(group_type);
          }
          break;
        default:
          jj_la1[57] = jj_gen;
          ;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ASSIGN:
          jj_consume_token(ASSIGN);
          parse_GroupDescription(new_group);
          jj_consume_token(SEMICOLON);
          break;
        case SEMICOLON:
          jj_consume_token(SEMICOLON);
          // the declaration Component foo : T;  is syntactic sugaring for
          // the declaration Component foo : T = new T.
          // Likewise,
          // the declaration Component foo : T1, ..., TN; is equivalent to
          // the declaration Component foo : T1, ..., TN = new T1 extended with T2
          //                                                extended with ... TN.

          // so walk over the list of declared types, and add each one to the
          // list of instantiated types.  They will be properly instantiated
          // later.
          AcmeEnumeration e = new_group.getDeclaredTypes();
          while (e.moreItems()) {
            new_group.addInstantiatedType((AcmeElementType) e.getNextItem());
          }
          break;
        default:
          jj_la1[58] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      } catch (ParseException e) {
  reportError (e);
  skip_to (SEMICOLON);
      }
        new_group.setParentDesign(global_design);
        processComment (start, new_group);
        {if (true) return new_group;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("GroupDeclaration");
    }
  }

/////////////////////
// parse_GroupDescription adds the properties, and
// representations in a group description to the group
// object it describes (passed in as group).
//
  static final public void parse_GroupDescription(AcmeGroup group) throws ParseException {
    trace_call("parse_GroupDescription");
    try {
    Token new_type_id_token;
    AcmeProperty new_prop;
    AcmeElement new_member;
    AcmeEnumeration child_enum;
    AcmeElementType new_type;
    DesignRule new_designRule = null;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case NEW:
        jj_consume_token(NEW);
        new_type = lookup_GroupTypeByName();
        group.addInstantiatedType(new_type);
        label_18:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMMA:
            ;
            break;
          default:
            jj_la1[59] = jj_gen;
            break label_18;
          }
          jj_consume_token(COMMA);
          new_type = lookup_GroupTypeByName();
        group.addInstantiatedType(new_type);
        }
        break;
      case LBRACE:
        jj_consume_token(LBRACE);
        label_19:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case MEMBERS:
          case PROPERTY:
          case PROPERTIES:
          case DESIGN:
          case INVARIANT:
          case HEURISTIC:
            ;
            break;
          default:
            jj_la1[60] = jj_gen;
            break label_19;
          }
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case MEMBERS:
            child_enum = MembersBlock();
              while (child_enum.moreItems()) {
                  new_member = (AcmeElement) child_enum.getNextItem();
                  try {
                    group.addMember(new_member);
                  }
                  catch (acmeLib.core.exceptions.AcmeIllegalNameException e) {
                    {if (true) throw createArmaniParseException (e.getMessage());}
                  }
              }
              // mark the enumeration for gc.
              child_enum = null;
            break;
          case PROPERTY:
            new_prop = PropertyDeclaration(group);
              try {
                group.addProperty(new_prop);
              }
              catch (acmeLib.core.exceptions.AcmeIllegalNameException e) {
                    {if (true) throw createArmaniParseException ( e.getMessage());}
              }
            break;
          case PROPERTIES:
            child_enum = PropertiesBlock(group);
              while (child_enum.moreItems()) {
                new_prop = (AcmeProperty) child_enum.getNextItem();
                try {
                    group.addProperty(new_prop);
                }
                catch (AcmeDuplicateNameException dupExc) {
                } catch (acmeLib.core.exceptions.AcmeIllegalNameException e) {
                   {if (true) throw createArmaniParseException ( e.getMessage());}
                }
              }
              // mark the enumeration for gc.
              child_enum = null;
            break;
          case DESIGN:
          case INVARIANT:
          case HEURISTIC:
            new_designRule = parse_DesignRule(group);
                if (new_designRule == null)
                    {if (true) throw new ParseException();}
                else if (new_designRule.getIsInvariant() == true)
                    group.addInvariant(new_designRule);
                else
                    group.addHeuristic(new_designRule);
            break;
          default:
            jj_la1[61] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
        jj_consume_token(RBRACE);
        break;
      default:
        jj_la1[62] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case EXTENDED:
        jj_consume_token(EXTENDED);
        jj_consume_token(WITH);
        parse_GroupDescription(group);
        break;
      default:
        jj_la1[63] = jj_gen;
        ;
      }
    } finally {
      trace_return("parse_GroupDescription");
    }
  }

/////////////////////////
// Components
/////////////////////////
  static final public AcmeComponent ComponentDeclaration() throws ParseException {
    trace_call("ComponentDeclaration");
    try {
    Token comp_id_token;
    AcmeComponent new_comp = new AcmeComponent ("Unknown");
    AcmePort new_port;
    AcmeProperty new_prop;
    AcmeElementType comp_type = null;
    Token start = null;
      try {
        start = jj_consume_token(COMPONENT);
        comp_id_token = jj_consume_token(IDENTIFIER);
        new_comp = new AcmeComponent(comp_id_token.image);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COLON:
          jj_consume_token(COLON);
          comp_type = lookup_ComponentTypeByName();
        new_comp.addDeclaredType(comp_type);
          label_20:
          while (true) {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case COMMA:
              ;
              break;
            default:
              jj_la1[64] = jj_gen;
              break label_20;
            }
            jj_consume_token(COMMA);
            comp_type = lookup_ComponentTypeByName();
           new_comp.addDeclaredType(comp_type);
          }
          break;
        default:
          jj_la1[65] = jj_gen;
          ;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ASSIGN:
          jj_consume_token(ASSIGN);
          parse_ComponentDescription(new_comp);
          jj_consume_token(SEMICOLON);
          break;
        case SEMICOLON:
          jj_consume_token(SEMICOLON);
          // the declaration Component foo : T;  is syntactic sugaring for
          // the declaration Component foo : T = new T.
          // Likewise,
          // the declaration Component foo : T1, ..., TN; is equivalent to
          // the declaration Component foo : T1, ..., TN = new T1 extended with T2
          //                                                extended with ... TN.

          // so walk over the list of declared types, and add each one to the
          // list of instantiated types.  They will be properly instantiated
          // later.
          AcmeEnumeration e = new_comp.getDeclaredTypes();
          while (e.moreItems()) {
            new_comp.addInstantiatedType((AcmeElementType) e.getNextItem());
          }
          break;
        default:
          jj_la1[66] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      } catch (ParseException e) {
  reportError (e);
  skip_to (SEMICOLON);
      }
        new_comp.setParentDesign(global_design);
        processComment (token, new_comp);
        {if (true) return new_comp;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("ComponentDeclaration");
    }
  }

  static final public AcmeEnumeration ComponentsBlock() throws ParseException {
    trace_call("ComponentsBlock");
    try {
    Token comp_id_token;
    Token new_type_id_token;
    AcmeComponent new_comp;
    AcmeElementType comp_type = null;
    AcmeEnumeration comp_enum = new AcmeEnumeration ();
      try {
        jj_consume_token(COMPONENTS);
        jj_consume_token(LBRACE);
        label_21:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case IDENTIFIER:
            ;
            break;
          default:
            jj_la1[67] = jj_gen;
            break label_21;
          }
          comp_id_token = jj_consume_token(IDENTIFIER);
            new_comp = new AcmeComponent(comp_id_token.image);
            processComment (comp_id_token, new_comp);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COLON:
            jj_consume_token(COLON);
            comp_type = lookup_ComponentTypeByName();
            new_comp.addDeclaredType(comp_type);
            label_22:
            while (true) {
              switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
              case COMMA:
                ;
                break;
              default:
                jj_la1[68] = jj_gen;
                break label_22;
              }
              jj_consume_token(COMMA);
              comp_type = lookup_ComponentTypeByName();
               new_comp.addDeclaredType(comp_type);
            }
            break;
          default:
            jj_la1[69] = jj_gen;
            ;
          }
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case ASSIGN:
            jj_consume_token(ASSIGN);
            parse_ComponentDescription(new_comp);
            jj_consume_token(SEMICOLON);
            break;
          case SEMICOLON:
            jj_consume_token(SEMICOLON);
              // walk over the list of declared types, and add each one to the
              // list of instantiated types.  They will be properly instantiated
              // later.
              AcmeEnumeration e = new_comp.getDeclaredTypes();
              while (e.moreItems()) {
                new_comp.addInstantiatedType((AcmeElementType) e.getNextItem());
              }
            break;
          default:
            jj_la1[70] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
            comp_enum.insertItem(new_comp);
            new_comp.setParentDesign(global_design);
        }
        jj_consume_token(RBRACE);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SEMICOLON:
          jj_consume_token(SEMICOLON);
          break;
        default:
          jj_la1[71] = jj_gen;
          ;
        }
      } catch (ParseException e) {
        reportError (e);
        skip_to (SEMICOLON);
      }
        {if (true) return comp_enum;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("ComponentsBlock");
    }
  }

/////////////////////
// parse_ComponentDescription adds the ports, properties, and
// representations in a component description to the component
// object it describes (passed in as comp).
//
// It works on both AcmeComponents and AcmeComponentTypes, due
// to the subclassing relationship between the two.
  static final public void parse_ComponentDescription(AcmeComponent comp) throws ParseException {
    trace_call("parse_ComponentDescription");
    try {
    Token new_type_id_token;
    AcmeProperty new_prop;
    AcmePort new_port;
    AcmeMapInstance new_map;
    AcmeEnumeration child_enum;
    AcmeElementType new_type;
    AcmeRepresentation new_rep;
    DesignRule new_designRule = null;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case NEW:
        jj_consume_token(NEW);
        new_type = lookup_ComponentTypeByName();
        comp.addInstantiatedType(new_type);
        label_23:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMMA:
            ;
            break;
          default:
            jj_la1[72] = jj_gen;
            break label_23;
          }
          jj_consume_token(COMMA);
          new_type = lookup_ComponentTypeByName();
        comp.addInstantiatedType(new_type);
        }
        break;
      case LBRACE:
        jj_consume_token(LBRACE);
        label_24:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case PORT:
          case PORTS:
          case PROPERTY:
          case PROPERTIES:
          case REPRESENTATION:
          case DESIGN:
          case INVARIANT:
          case HEURISTIC:
            ;
            break;
          default:
            jj_la1[73] = jj_gen;
            break label_24;
          }
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case PORT:
            new_port = PortDeclaration();
              try {
                comp.addPort(new_port);
              }
              catch (AcmeDuplicateNameException dupExc) {
                // there is already a port with the same name as
                // new_port in this component.  attempt to unify new_port
                // with the one that already exists.  If it's a duplicate
                // name, but it's not a port that has the name, just rethrow
                // the error.
                AcmePort unifyTargetPort = comp.getPort(new_port.getName());
                if (unifyTargetPort == null) {
                    {if (true) throw createArmaniParseException ( dupExc.getMessage());}
                } else {
                    // attempt to unify the new_port with the existing one.
                    AcmeTypeManager.unifyPort(new_port, unifyTargetPort);
                }
              }
              catch (acmeLib.core.exceptions.AcmeIllegalNameException e) {
                {if (true) throw createArmaniParseException ( e.getMessage());}
              }
            break;
          case PORTS:
            child_enum = PortsBlock();
              while (child_enum.moreItems()) {
                  new_port = (AcmePort) child_enum.getNextItem();
                  try {
                    comp.addPort(new_port);
                  }
                  catch (AcmeDuplicateNameException dupExc) {
                    // there is already a port with the same name as
                    // new_port in this component.  attempt to unify new_port
                    // with the one that already exists.  If it's a duplicate
                    // name, but it's not a port that has the name, just rethrow
                    // the error.
                    AcmePort unifyTargetPort = comp.getPort(new_port.getName());
                    if (unifyTargetPort == null) {
                        {if (true) throw createArmaniParseException (dupExc.getMessage());}
                    } else {
                        // attempt to unify the new_port with the existing one.
                        AcmeTypeManager.unifyPort(new_port, unifyTargetPort);
                    }
                  }
                  catch (acmeLib.core.exceptions.AcmeIllegalNameException e) {
                        {if (true) throw createArmaniParseException ( e.getMessage());}
                  }
              }
              // mark the enumeration for gc.
              child_enum = null;
            break;
          case PROPERTY:
            new_prop = PropertyDeclaration(comp);
              try {
                comp.addProperty(new_prop);
              }
              catch (AcmeDuplicateNameException dupExc) {
                // there is already a property with the same name as
                // new_prop in this component.  attempt to unify new_prop
                // with the one that already exists.  If it's a duplicate
                // name, but it's not a property that has the name, just
                // rethrow the error.
                try {
                    AcmeProperty targetProp = comp.getProperty(new_prop.getName());
                    if (targetProp == null) {
                        {if (true) throw createArmaniParseException ( dupExc.getMessage());}
                    } else {
                        // attempt to unify the new_port with the existing one.
                        AcmeTypeManager.extendProperty(new_prop, targetProp);
                    }
                } catch (AcmePropertyExtensionFailedException pefExc) {
                    {if (true) throw createArmaniParseException ( pefExc.getMessage());}
                }
              } catch (acmeLib.core.exceptions.AcmeIllegalNameException e) {
                    {if (true) throw createArmaniParseException ( e.getMessage());}
              }
            break;
          case PROPERTIES:
            child_enum = PropertiesBlock(comp);
              while (child_enum.moreItems()) {
                new_prop = (AcmeProperty) child_enum.getNextItem();
                try {
                    comp.addProperty(new_prop);
                }
                catch (AcmeDuplicateNameException dupExc) {
                    // there is already a property with the same name as
                    // new_prop in this component.  attempt to unify new_prop
                    // with the one that already exists.  If it's a duplicate
                    // name, but it's not a property that has the name, just
                    // rethrow the error.
                    try {
                        AcmeProperty targetProp = comp.getProperty(new_prop.getName());
                        if (targetProp == null) {
                            {if (true) throw createArmaniParseException ( dupExc.getMessage());}
                        } else {
                            // attempt to unify the new_port with the existing one.
                            AcmeTypeManager.extendProperty(new_prop, targetProp);
                        }
                    } catch (AcmePropertyExtensionFailedException pefExc) {
                        {if (true) throw createArmaniParseException ( pefExc.getMessage());}
                    }
                } catch (acmeLib.core.exceptions.AcmeIllegalNameException e) {
                    {if (true) throw createArmaniParseException ( e.getMessage());}
                }
              }
              // mark the enumeration for gc.
              child_enum = null;
            break;
          case REPRESENTATION:
            new_rep = RepresentationDeclaration(comp);
                try {
                    comp.addRepresentation(new_rep);
                } catch (acmeLib.core.exceptions.AcmeIllegalNameException e) {
                    {if (true) throw createArmaniParseException ( e.getMessage());}
                }
            break;
          case DESIGN:
          case INVARIANT:
          case HEURISTIC:
            new_designRule = parse_DesignRule(comp);
                if (new_designRule == null)
                    {if (true) throw new ParseException();}
                else if (new_designRule.getIsInvariant() == true)
                    comp.addInvariant(new_designRule);
                else
                    comp.addHeuristic(new_designRule);
            break;
          default:
            jj_la1[74] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
        jj_consume_token(RBRACE);
        break;
      default:
        jj_la1[75] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case EXTENDED:
        jj_consume_token(EXTENDED);
        jj_consume_token(WITH);
        parse_ComponentDescription(comp);
        break;
      default:
        jj_la1[76] = jj_gen;
        ;
      }
    } finally {
      trace_return("parse_ComponentDescription");
    }
  }

/////////////////////////
// Connectors
/////////////////////////
  static final public AcmeConnector ConnectorDeclaration() throws ParseException {
    trace_call("ConnectorDeclaration");
    try {
    Token conn_id_token;
    AcmeConnector new_conn = new AcmeConnector ("Unknown");
    AcmeRole new_role;
    AcmeProperty new_prop;
    AcmeElementType conn_type = null;
    Token start = null;
      try {
        start = jj_consume_token(CONNECTOR);
        conn_id_token = jj_consume_token(IDENTIFIER);
        new_conn = new AcmeConnector(conn_id_token.image);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COLON:
          jj_consume_token(COLON);
          conn_type = lookup_ConnectorTypeByName();
           new_conn.addDeclaredType(conn_type);
          label_25:
          while (true) {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case COMMA:
              ;
              break;
            default:
              jj_la1[77] = jj_gen;
              break label_25;
            }
            jj_consume_token(COMMA);
            conn_type = lookup_ConnectorTypeByName();
           new_conn.addDeclaredType(conn_type);
          }
          break;
        default:
          jj_la1[78] = jj_gen;
          ;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ASSIGN:
          jj_consume_token(ASSIGN);
          parse_ConnectorDescription(new_conn);
          jj_consume_token(SEMICOLON);
          break;
        case SEMICOLON:
          jj_consume_token(SEMICOLON);
          // walk over the list of declared types, and add each one to the
          // list of instantiated types.  They will be properly instantiated
          // later.
          AcmeEnumeration e = new_conn.getDeclaredTypes();
          while (e.moreItems()) {
            new_conn.addInstantiatedType((AcmeElementType) e.getNextItem());
          }
          break;
        default:
          jj_la1[79] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      } catch (ParseException e) {
  reportError (e);
  skip_to (SEMICOLON);
      }
        new_conn.setParentDesign(global_design);
        processComment (start, new_conn);
        {if (true) return new_conn;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("ConnectorDeclaration");
    }
  }

//
// parse multiple connectors in a Connectors {...} block
//
  static final public AcmeEnumeration ConnectorsBlock() throws ParseException {
    trace_call("ConnectorsBlock");
    try {
    Token conn_id_token;
    AcmeConnector new_conn;
    AcmeElementType conn_type = null;
    AcmeEnumeration conn_enum = new AcmeEnumeration ();
      try {
        jj_consume_token(CONNECTORS);
        jj_consume_token(LBRACE);
        label_26:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case IDENTIFIER:
            ;
            break;
          default:
            jj_la1[80] = jj_gen;
            break label_26;
          }
          conn_id_token = jj_consume_token(IDENTIFIER);
            new_conn = new AcmeConnector(conn_id_token.image);
            processComment (conn_id_token, new_conn);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COLON:
            jj_consume_token(COLON);
            conn_type = lookup_ConnectorTypeByName();
               new_conn.addDeclaredType(conn_type);
            label_27:
            while (true) {
              switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
              case COMMA:
                ;
                break;
              default:
                jj_la1[81] = jj_gen;
                break label_27;
              }
              jj_consume_token(COMMA);
              conn_type = lookup_ConnectorTypeByName();
               new_conn.addDeclaredType(conn_type);
            }
            break;
          default:
            jj_la1[82] = jj_gen;
            ;
          }
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case ASSIGN:
            jj_consume_token(ASSIGN);
            parse_ConnectorDescription(new_conn);
            jj_consume_token(SEMICOLON);
            break;
          case SEMICOLON:
            jj_consume_token(SEMICOLON);
              AcmeEnumeration e = new_conn.getDeclaredTypes();
              while (e.moreItems()) {
                new_conn.addInstantiatedType((AcmeElementType) e.getNextItem());
              }
            break;
          default:
            jj_la1[83] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
            conn_enum.insertItem(new_conn);
            new_conn.setParentDesign(global_design);
        }
        jj_consume_token(RBRACE);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SEMICOLON:
          jj_consume_token(SEMICOLON);
          break;
        default:
          jj_la1[84] = jj_gen;
          ;
        }
      } catch (ParseException e) {
  reportError (e);
  skip_to (SEMICOLON);
      }
        {if (true) return conn_enum;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("ConnectorsBlock");
    }
  }

/////////////////////
// parse_ConnectorDescription adds the roles, properties, and
// representations in a connector description to the connector
// object it describes (passed in as conn).
//
// It works on both AcmeConnectors and AcmeConnectorTypes, due
// to the subclassing relationship between the two.
  static final public void parse_ConnectorDescription(AcmeConnector conn) throws ParseException {
    trace_call("parse_ConnectorDescription");
    try {
    Token new_type_id_token;
    AcmeProperty new_prop;
    AcmeRole new_role;
    AcmeMapInstance     new_map;
    AcmeEnumeration child_enum;
    AcmeElementType new_type;
    AcmeRepresentation new_rep;
    DesignRule new_designRule = null;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case NEW:
        jj_consume_token(NEW);
        new_type = lookup_ConnectorTypeByName();
        conn.addInstantiatedType(new_type);
        label_28:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMMA:
            ;
            break;
          default:
            jj_la1[85] = jj_gen;
            break label_28;
          }
          jj_consume_token(COMMA);
          new_type = lookup_ConnectorTypeByName();
        conn.addInstantiatedType(new_type);
        }
        break;
      case LBRACE:
        jj_consume_token(LBRACE);
        label_29:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case ROLE:
          case ROLES:
          case PROPERTY:
          case PROPERTIES:
          case REPRESENTATION:
          case DESIGN:
          case INVARIANT:
          case HEURISTIC:
            ;
            break;
          default:
            jj_la1[86] = jj_gen;
            break label_29;
          }
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case ROLE:
            new_role = RoleDeclaration();
              try {
                conn.addRole(new_role);
              }
              catch (AcmeDuplicateNameException dupExc) {
                // there is already a role with the same name as
                // new_role in this connector.  attempt to unify new_role
                // with the one that already exists.  If it's a duplicate
                // name, but it's not a role that has the name, rethrow
                // the error.
                AcmeRole unifyTargetRole = conn.getRole(new_role.getName());
                if (unifyTargetRole == null) {
                    {if (true) throw createArmaniParseException ( dupExc.getMessage());}
                } else {
                    // attempt to unify the new_port with the existing one.
                    AcmeTypeManager.unifyRole(new_role, unifyTargetRole);
                }
              }
              catch (acmeLib.core.exceptions.AcmeIllegalNameException e) {
                    {if (true) throw createArmaniParseException ( e.getMessage());}
              }
            break;
          case ROLES:
            child_enum = RolesBlock();
              while (child_enum.moreItems()) {
                  new_role = (AcmeRole) child_enum.getNextItem();
                  try {
                    conn.addRole(new_role);
                  }
                  catch (AcmeDuplicateNameException dupExc) {
                    // there is already a role with the same name as
                    // new_role in this connector.  attempt to unify new_role
                    // with the one that already exists.  If it's a duplicate
                    // name, but it's not a role that has the name, rethrow
                    // the error.
                    AcmeRole unifyTargetRole = conn.getRole(new_role.getName());
                    if (unifyTargetRole == null) {
                        {if (true) throw createArmaniParseException ( dupExc.getMessage());}
                    } else {
                        // attempt to unify the new_port with the existing one.
                        AcmeTypeManager.unifyRole(new_role, unifyTargetRole);
                    }
                  }
                  catch (acmeLib.core.exceptions.AcmeIllegalNameException e) {
                        {if (true) throw createArmaniParseException ( e.getMessage());}
                  }
              }
              // mark the enumeration for gc.
              child_enum = null;
            break;
          case PROPERTY:
            new_prop = PropertyDeclaration(conn);
              try {
                conn.addProperty(new_prop);
              } catch (AcmeDuplicateNameException dupExc) {
                  try {
                    AcmeProperty targetProp = conn.getProperty(new_prop.getName());
                    if (targetProp == null) {
                        {if (true) throw createArmaniParseException ( dupExc.getMessage());}
                    } else {
                        // attempt to unify the new_port with the existing one.
                        AcmeTypeManager.extendProperty(new_prop, targetProp);
                    }
                  } catch (AcmePropertyExtensionFailedException pefExc) {
                    {if (true) throw createArmaniParseException ( pefExc.getMessage());}
                  }
              } catch (acmeLib.core.exceptions.AcmeIllegalNameException e) {
                {if (true) throw createArmaniParseException ( e.getMessage());}
              }
            break;
          case PROPERTIES:
            child_enum = PropertiesBlock(conn);
              while (child_enum.moreItems()) {
                new_prop = (AcmeProperty) child_enum.getNextItem();
                try {
                    conn.addProperty(new_prop);
                }
                catch (AcmeDuplicateNameException dupExc) {
                    try {
                        AcmeProperty targetProp = conn.getProperty(new_prop.getName());
                        if (targetProp == null) {
                            {if (true) throw createArmaniParseException ( dupExc.getMessage());}
                        } else {
                            // attempt to unify the new_port with the existing one.
                            AcmeTypeManager.extendProperty(new_prop, targetProp);
                        }
                    } catch (AcmePropertyExtensionFailedException pefExc) {
                        {if (true) throw createArmaniParseException ( pefExc.getMessage());}
                    }
                } catch (acmeLib.core.exceptions.AcmeIllegalNameException e) {
                    {if (true) throw createArmaniParseException ( e.getMessage());}
                }
              }
              // mark the enumeration for gc.
              child_enum = null;
            break;
          case REPRESENTATION:
            new_rep = RepresentationDeclaration(conn);
               try {
                   conn.addRepresentation(new_rep);
               } catch (acmeLib.core.exceptions.AcmeIllegalNameException e) {
                   {if (true) throw createArmaniParseException ( e.getMessage());}
               }
            break;
          case DESIGN:
          case INVARIANT:
          case HEURISTIC:
            new_designRule = parse_DesignRule(conn);
                if (new_designRule == null)
                    {if (true) throw new ParseException();}
                else if (new_designRule.getIsInvariant() == true)
                    conn.addInvariant(new_designRule);
                else
                    conn.addHeuristic(new_designRule);
            break;
          default:
            jj_la1[87] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
        jj_consume_token(RBRACE);
        break;
      default:
        jj_la1[88] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case EXTENDED:
        jj_consume_token(EXTENDED);
        jj_consume_token(WITH);
        parse_ConnectorDescription(conn);
        break;
      default:
        jj_la1[89] = jj_gen;
        ;
      }
    } finally {
      trace_return("parse_ConnectorDescription");
    }
  }

////////////////////
// Ports
////////////////////
  static final public AcmePort PortDeclaration() throws ParseException {
    trace_call("PortDeclaration");
    try {
    Token port_id_token;
    AcmePort new_port = new AcmePort ("Unknown");
    AcmeElementType port_type = null;
    Token start = null;
      try {
        start = jj_consume_token(PORT);
        port_id_token = jj_consume_token(IDENTIFIER);
        new_port = new AcmePort(port_id_token.image);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COLON:
          jj_consume_token(COLON);
          port_type = lookup_PortTypeByName();
          new_port.addDeclaredType(port_type);
          label_30:
          while (true) {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case COMMA:
              ;
              break;
            default:
              jj_la1[90] = jj_gen;
              break label_30;
            }
            jj_consume_token(COMMA);
            port_type = lookup_PortTypeByName();
           new_port.addDeclaredType(port_type);
          }
          break;
        default:
          jj_la1[91] = jj_gen;
          ;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ASSIGN:
          jj_consume_token(ASSIGN);
          parse_PortDescription(new_port);
          jj_consume_token(SEMICOLON);
          break;
        case SEMICOLON:
          jj_consume_token(SEMICOLON);
          // walk over the list of declared types, and add each one to the
          // list of instantiated types.  They will be properly instantiated
          // later.
          AcmeEnumeration e = new_port.getDeclaredTypes();
          while (e.moreItems()) {
            new_port.addInstantiatedType((AcmeElementType) e.getNextItem());
          }
          break;
        default:
          jj_la1[92] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      } catch (ParseException e) {
  reportError (e);
  skip_to (SEMICOLON);
      }
        new_port.setParentDesign(global_design);
        processComment (start, new_port);
        {if (true) return new_port;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("PortDeclaration");
    }
  }

//
// parse multiple ports in a Ports {...} block
//
  static final public AcmeEnumeration PortsBlock() throws ParseException {
    trace_call("PortsBlock");
    try {
    Token port_id_token;
    AcmePort new_port;
    AcmeElementType port_type = null;
    AcmeEnumeration port_enum = new AcmeEnumeration ();
      try {
        jj_consume_token(PORTS);
        jj_consume_token(LBRACE);
        label_31:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case IDENTIFIER:
            ;
            break;
          default:
            jj_la1[93] = jj_gen;
            break label_31;
          }
          port_id_token = jj_consume_token(IDENTIFIER);
            new_port = new AcmePort(port_id_token.image);
            processComment (port_id_token, new_port);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COLON:
            jj_consume_token(COLON);
            port_type = lookup_PortTypeByName();
              new_port.addDeclaredType(port_type);
            label_32:
            while (true) {
              switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
              case COMMA:
                ;
                break;
              default:
                jj_la1[94] = jj_gen;
                break label_32;
              }
              jj_consume_token(COMMA);
              port_type = lookup_PortTypeByName();
               new_port.addDeclaredType(port_type);
            }
            break;
          default:
            jj_la1[95] = jj_gen;
            ;
          }
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case ASSIGN:
            jj_consume_token(ASSIGN);
            parse_PortDescription(new_port);
            jj_consume_token(SEMICOLON);
            break;
          case SEMICOLON:
            jj_consume_token(SEMICOLON);
              AcmeEnumeration e = new_port.getDeclaredTypes();
              while (e.moreItems()) {
                new_port.addInstantiatedType((AcmeElementType) e.getNextItem());
              }
            break;
          default:
            jj_la1[96] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
            new_port.setParentDesign(global_design);
            port_enum.insertItem(new_port);
        }
        jj_consume_token(RBRACE);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SEMICOLON:
          jj_consume_token(SEMICOLON);
          break;
        default:
          jj_la1[97] = jj_gen;
          ;
        }
      } catch (ParseException e) {
  reportError (e);
  skip_to (SEMICOLON);
      }
        {if (true) return port_enum;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("PortsBlock");
    }
  }

// parse_PortDescription adds the properties, and representations
// in a port description to the port object it describes
// (passed in as port).
//
// It works on both AcmePorts and AcmePortTypes, due
// to the subclassing relationship between the two.
  static final public void parse_PortDescription(AcmePort port) throws ParseException {
    trace_call("parse_PortDescription");
    try {
    Token new_type_id_token;
    AcmeProperty new_prop;
    AcmeMapInstance     new_map;
    AcmeElementType new_type;
    AcmeRepresentation new_rep;
    AcmeEnumeration child_enum;
    DesignRule new_designRule = null;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case NEW:
        jj_consume_token(NEW);
        new_type = lookup_PortTypeByName();
        port.addInstantiatedType(new_type);
        label_33:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMMA:
            ;
            break;
          default:
            jj_la1[98] = jj_gen;
            break label_33;
          }
          jj_consume_token(COMMA);
          new_type = lookup_PortTypeByName();
        port.addInstantiatedType(new_type);
        }
        break;
      case LBRACE:
        jj_consume_token(LBRACE);
        label_34:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case PROPERTY:
          case PROPERTIES:
          case REPRESENTATION:
          case DESIGN:
          case INVARIANT:
          case HEURISTIC:
            ;
            break;
          default:
            jj_la1[99] = jj_gen;
            break label_34;
          }
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case PROPERTY:
            new_prop = PropertyDeclaration(port);
                try {
                    port.addProperty(new_prop);
                } catch (AcmeDuplicateNameException dupExc) {
                    try {
                        AcmeProperty targetProp =
                                        port.getProperty(new_prop.getName());
                        if (targetProp == null) {
                            {if (true) throw createArmaniParseException ( dupExc.getMessage());}
                        } else {
                            // attempt to unify the new_port with the existing one.
                            AcmeTypeManager.extendProperty(new_prop, targetProp);
                        }
                    } catch (AcmePropertyExtensionFailedException pefExc) {
                        {if (true) throw createArmaniParseException ( pefExc.getMessage());}
                    }
                } catch (acmeLib.core.exceptions.AcmeIllegalNameException e) {
                    {if (true) throw createArmaniParseException ( e.getMessage());}
                }
            break;
          case PROPERTIES:
            child_enum = PropertiesBlock(port);
              while (child_enum.moreItems()) {
                new_prop = (AcmeProperty) child_enum.getNextItem();
                try {
                    port.addProperty(new_prop);
                } catch (AcmeDuplicateNameException dupExc) {
                    try {
                        AcmeProperty targetProp =
                                    port.getProperty(new_prop.getName());
                        if (targetProp == null) {
                            {if (true) throw createArmaniParseException ( dupExc.getMessage());}
                        } else {
                            // attempt to unify the new_port with the existing one.
                            AcmeTypeManager.extendProperty(new_prop, targetProp);
                        }
                    } catch (AcmePropertyExtensionFailedException pefExc) {
                        {if (true) throw createArmaniParseException ( pefExc.getMessage());}
                    }
                } catch (acmeLib.core.exceptions.AcmeIllegalNameException e) {
                    {if (true) throw createArmaniParseException ( e.getMessage());}
                }
              }
              // mark the enumeration for gc.
              child_enum = null;
            break;
          case REPRESENTATION:
            new_rep = RepresentationDeclaration(port);
               try {
                   port.addRepresentation(new_rep);
               } catch (acmeLib.core.exceptions.AcmeIllegalNameException e) {
                   {if (true) throw createArmaniParseException ( e.getMessage());}
               }
            break;
          case DESIGN:
          case INVARIANT:
          case HEURISTIC:
            new_designRule = parse_DesignRule(port);
                if (new_designRule == null)
                    {if (true) throw new ParseException();}
                else if (new_designRule.getIsInvariant() == true)
                    port.addInvariant(new_designRule);
                else
                    port.addHeuristic(new_designRule);
            break;
          default:
            jj_la1[100] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
        jj_consume_token(RBRACE);
        break;
      default:
        jj_la1[101] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case EXTENDED:
        jj_consume_token(EXTENDED);
        jj_consume_token(WITH);
        parse_PortDescription(port);
        break;
      default:
        jj_la1[102] = jj_gen;
        ;
      }
    } finally {
      trace_return("parse_PortDescription");
    }
  }

////////////////////
// Roles
////////////////////
  static final public AcmeRole RoleDeclaration() throws ParseException {
    trace_call("RoleDeclaration");
    try {
    Token role_id_token;
    AcmeRole new_role = new AcmeRole ("Unknown");
    AcmeProperty new_prop;
    AcmeElementType role_type = null;
    Token start = null;
      try {
        start = jj_consume_token(ROLE);
        role_id_token = jj_consume_token(IDENTIFIER);
        new_role = new AcmeRole(role_id_token.image);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COLON:
          jj_consume_token(COLON);
          role_type = lookup_RoleTypeByName();
           new_role.addDeclaredType(role_type);
          label_35:
          while (true) {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case COMMA:
              ;
              break;
            default:
              jj_la1[103] = jj_gen;
              break label_35;
            }
            jj_consume_token(COMMA);
            role_type = lookup_RoleTypeByName();
           new_role.addDeclaredType(role_type);
          }
          break;
        default:
          jj_la1[104] = jj_gen;
          ;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ASSIGN:
          jj_consume_token(ASSIGN);
          parse_RoleDescription(new_role);
          jj_consume_token(SEMICOLON);
          break;
        case SEMICOLON:
          jj_consume_token(SEMICOLON);
          // walk over the list of declared types, and add each one to the
          // list of instantiated types.  They will be properly instantiated
          // later.
          AcmeEnumeration e = new_role.getDeclaredTypes();
          while (e.moreItems()) {
            new_role.addInstantiatedType((AcmeElementType) e.getNextItem());
          }
          break;
        default:
          jj_la1[105] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      } catch (ParseException e) {
  reportError (e);
  skip_to (SEMICOLON);
      }
        new_role.setParentDesign(global_design);
        processComment (start, new_role);
        {if (true) return new_role;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("RoleDeclaration");
    }
  }

//
// parse multiple members in a Members {...} block
//
  static final public AcmeEnumeration MembersBlock() throws ParseException {
    trace_call("MembersBlock");
    try {
    String member_id;
    AcmeElement new_member;
    AcmeElementType member_type = null;
    AcmeEnumeration member_enum = new AcmeEnumeration ();
      try {
        jj_consume_token(MEMBERS);
        jj_consume_token(LBRACE);
        label_36:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case IDENTIFIER:
            ;
            break;
          default:
            jj_la1[106] = jj_gen;
            break label_36;
          }
          member_id = QualifiedReference();
            new_member = new AcmeUnresolvedElement(member_id);
          jj_consume_token(SEMICOLON);
              AcmeEnumeration e = new_member.getDeclaredTypes();
              while (e.moreItems()) {
                new_member.addInstantiatedType((AcmeElementType) e.getNextItem());
              }
            member_enum.insertItem(new_member);
            new_member.setParentDesign(global_design);
        }
        jj_consume_token(RBRACE);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SEMICOLON:
          jj_consume_token(SEMICOLON);
          break;
        default:
          jj_la1[107] = jj_gen;
          ;
        }
      } catch (ParseException e) {
  reportError (e);
  skip_to (SEMICOLON);
      }
        {if (true) return member_enum;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("MembersBlock");
    }
  }

  static final public String QualifiedReference() throws ParseException {
    trace_call("QualifiedReference");
    try {
    Token curToken;
    StringBuffer buf = new StringBuffer();
      curToken = jj_consume_token(IDENTIFIER);
        buf.setLength(0);
        buf.append(curToken.image);
      label_37:
      while (true) {
        if (jj_2_37(2)) {
          ;
        } else {
          break label_37;
        }
        jj_consume_token(DOT);
        curToken = jj_consume_token(IDENTIFIER);
            buf.append(".");
            buf.append(curToken.image);
      }
    {if (true) return buf.toString ();}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("QualifiedReference");
    }
  }

//
// parse multiple roles in a Roles {...} block
//
  static final public AcmeEnumeration RolesBlock() throws ParseException {
    trace_call("RolesBlock");
    try {
    Token role_id_token;
    AcmeRole new_role;
    AcmeElementType role_type = null;
    AcmeEnumeration role_enum = new AcmeEnumeration ();
      try {
        jj_consume_token(ROLES);
        jj_consume_token(LBRACE);
        label_38:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case IDENTIFIER:
            ;
            break;
          default:
            jj_la1[108] = jj_gen;
            break label_38;
          }
          role_id_token = jj_consume_token(IDENTIFIER);
            new_role = new AcmeRole(role_id_token.image);
            processComment (role_id_token, new_role);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COLON:
            jj_consume_token(COLON);
            role_type = lookup_RoleTypeByName();
               new_role.addDeclaredType(role_type);
            label_39:
            while (true) {
              switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
              case COMMA:
                ;
                break;
              default:
                jj_la1[109] = jj_gen;
                break label_39;
              }
              jj_consume_token(COMMA);
              role_type = lookup_RoleTypeByName();
               new_role.addDeclaredType(role_type);
            }
            break;
          default:
            jj_la1[110] = jj_gen;
            ;
          }
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case ASSIGN:
            jj_consume_token(ASSIGN);
            parse_RoleDescription(new_role);
            jj_consume_token(SEMICOLON);
            break;
          case SEMICOLON:
            jj_consume_token(SEMICOLON);
              AcmeEnumeration e = new_role.getDeclaredTypes();
              while (e.moreItems()) {
                new_role.addInstantiatedType((AcmeElementType) e.getNextItem());
              }
            break;
          default:
            jj_la1[111] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
            role_enum.insertItem(new_role);
            new_role.setParentDesign(global_design);
        }
        jj_consume_token(RBRACE);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SEMICOLON:
          jj_consume_token(SEMICOLON);
          break;
        default:
          jj_la1[112] = jj_gen;
          ;
        }
      } catch (ParseException e) {
  reportError (e);
  skip_to (SEMICOLON);
      }
        {if (true) return role_enum;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("RolesBlock");
    }
  }

// parse_RoleDescription adds the properties, and representations
// in a role description to the role object it describes
// (passed in as role).
//
// It works on both AcmeRoles and AcmeRoleTypes, due
// to the subclassing relationship between the two.
  static final public void parse_RoleDescription(AcmeRole role) throws ParseException {
    trace_call("parse_RoleDescription");
    try {
    Token new_type_id_token;
    AcmeProperty new_prop;
    AcmeMapInstance     new_map;
    AcmeElementType new_type;
    AcmeRepresentation new_rep;
    AcmeEnumeration child_enum;
    DesignRule new_designRule = null;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case NEW:
        jj_consume_token(NEW);
        new_type = lookup_RoleTypeByName();
        role.addInstantiatedType(new_type);
        label_40:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMMA:
            ;
            break;
          default:
            jj_la1[113] = jj_gen;
            break label_40;
          }
          jj_consume_token(COMMA);
          new_type = lookup_RoleTypeByName();
        role.addInstantiatedType(new_type);
        }
        break;
      case LBRACE:
        jj_consume_token(LBRACE);
        label_41:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case PROPERTY:
          case PROPERTIES:
          case REPRESENTATION:
          case DESIGN:
          case INVARIANT:
          case HEURISTIC:
            ;
            break;
          default:
            jj_la1[114] = jj_gen;
            break label_41;
          }
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case PROPERTY:
            new_prop = PropertyDeclaration(role);
                try {
                    role.addProperty(new_prop);
                } catch (AcmeDuplicateNameException dupExc) {
                    try {
                        AcmeProperty targetProp =
                                        role.getProperty(new_prop.getName());
                        if (targetProp == null) {
                            {if (true) throw createArmaniParseException ( dupExc.getMessage());}
                        } else {
                            // attempt to unify the new_port with the existing one.
                            AcmeTypeManager.extendProperty(new_prop, targetProp);
                        }
                    } catch (AcmePropertyExtensionFailedException pefExc) {
                        {if (true) throw createArmaniParseException ( pefExc.getMessage());}
                    }
                } catch (acmeLib.core.exceptions.AcmeIllegalNameException e) {
                    {if (true) throw createArmaniParseException ( e.getMessage());}
                }
            break;
          case PROPERTIES:
            child_enum = PropertiesBlock(role);
              while (child_enum.moreItems()) {
                new_prop = (AcmeProperty) child_enum.getNextItem();
                try {
                    role.addProperty(new_prop);
                } catch (AcmeDuplicateNameException dupExc) {
                    try {
                        AcmeProperty targetProp =
                                        role.getProperty(new_prop.getName());
                        if (targetProp == null) {
                            {if (true) throw createArmaniParseException ( dupExc.getMessage());}
                        } else {
                            // attempt to unify the new_port with the existing one.
                            AcmeTypeManager.extendProperty(new_prop, targetProp);
                        }
                    } catch (AcmePropertyExtensionFailedException pefExc) {
                        {if (true) throw createArmaniParseException ( pefExc.getMessage());}
                    }
                } catch (acmeLib.core.exceptions.AcmeIllegalNameException e) {
                    {if (true) throw createArmaniParseException ( e.getMessage());}
                }
              }
              // mark the enumeration for gc.
              child_enum = null;
            break;
          case REPRESENTATION:
            new_rep = RepresentationDeclaration(role);
               try {
                   role.addRepresentation(new_rep);
               } catch (acmeLib.core.exceptions.AcmeIllegalNameException e) {
                   {if (true) throw createArmaniParseException ( e.getMessage());}
               }
            break;
          case DESIGN:
          case INVARIANT:
          case HEURISTIC:
            new_designRule = parse_DesignRule(role);
                if (new_designRule == null)
                    {if (true) throw new ParseException();}
                else if (new_designRule.getIsInvariant() == true)
                    role.addInvariant(new_designRule);
                else
                    role.addHeuristic(new_designRule);
            break;
          default:
            jj_la1[115] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
        jj_consume_token(RBRACE);
        break;
      default:
        jj_la1[116] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case EXTENDED:
        jj_consume_token(EXTENDED);
        jj_consume_token(WITH);
        parse_RoleDescription(role);
        break;
      default:
        jj_la1[117] = jj_gen;
        ;
      }
    } finally {
      trace_return("parse_RoleDescription");
    }
  }

////////////////
// Attachments
////////////////
  static final public void AttachmentsDeclaration(AcmeSystem parent_sys) throws ParseException {
    trace_call("AttachmentsDeclaration");
    try {
    Token first_outer_token, first_inner_token;
    Token second_outer_token, second_inner_token;
    AcmeUnresolvedAttachment attachment = null;
    AcmeProperty property = null;
    AcmeEnumeration child_enum;
      try {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case ATTACHMENTS:
          jj_consume_token(ATTACHMENTS);
          jj_consume_token(LBRACE);
          label_42:
          while (true) {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case IDENTIFIER:
              ;
              break;
            default:
              jj_la1[118] = jj_gen;
              break label_42;
            }
            first_outer_token = jj_consume_token(IDENTIFIER);
            jj_consume_token(DOT);
            first_inner_token = jj_consume_token(IDENTIFIER);
            jj_consume_token(TO);
            second_outer_token = jj_consume_token(IDENTIFIER);
            jj_consume_token(DOT);
            second_inner_token = jj_consume_token(IDENTIFIER);
            attachment = new AcmeUnresolvedAttachment(
                first_outer_token.image, first_inner_token.image,
                second_outer_token.image, second_inner_token.image);
            attachment.setParent(parent_sys);
            parent_sys.addAttachment(attachment);
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case LBRACE:
              jj_consume_token(LBRACE);
              label_43:
              while (true) {
                switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
                case PROPERTY:
                case PROPERTIES:
                  ;
                  break;
                default:
                  jj_la1[119] = jj_gen;
                  break label_43;
                }
                switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
                case PROPERTY:
                  property = PropertyDeclaration(parent_sys);
                    try {
                        attachment.addProperty(property);
                    } catch (acmeLib.core.exceptions.AcmeIllegalNameException e) {
                        {if (true) throw createArmaniParseException ( e.getMessage());}
                    }
                  break;
                case PROPERTIES:
                  child_enum = PropertiesBlock(parent_sys);
                    while (child_enum.moreItems()) {
                        property = (AcmeProperty) child_enum.getNextItem();
                        try {
                            attachment.addProperty(property);
                        } catch (acmeLib.core.exceptions.AcmeIllegalNameException e) {
                            {if (true) throw createArmaniParseException ( e.getMessage());}
                        }
                    }
                    // mark the enumeration for gc.
                    child_enum = null;
                  break;
                default:
                  jj_la1[120] = jj_gen;
                  jj_consume_token(-1);
                  throw new ParseException();
                }
              }
              jj_consume_token(RBRACE);
              break;
            default:
              jj_la1[121] = jj_gen;
              ;
            }
            jj_consume_token(SEMICOLON);
          }
          jj_consume_token(RBRACE);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case SEMICOLON:
            jj_consume_token(SEMICOLON);
            break;
          default:
            jj_la1[122] = jj_gen;
            ;
          }
          break;
        case ATTACHMENT:
          jj_consume_token(ATTACHMENT);
          first_outer_token = jj_consume_token(IDENTIFIER);
          jj_consume_token(DOT);
          first_inner_token = jj_consume_token(IDENTIFIER);
          jj_consume_token(TO);
          second_outer_token = jj_consume_token(IDENTIFIER);
          jj_consume_token(DOT);
          second_inner_token = jj_consume_token(IDENTIFIER);
        attachment = new AcmeUnresolvedAttachment(
            first_outer_token.image, first_inner_token.image,
            second_outer_token.image, second_inner_token.image);
        attachment.setParent(parent_sys);
        parent_sys.addAttachment(attachment);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case LBRACE:
            jj_consume_token(LBRACE);
            label_44:
            while (true) {
              switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
              case PROPERTY:
              case PROPERTIES:
                ;
                break;
              default:
                jj_la1[123] = jj_gen;
                break label_44;
              }
              switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
              case PROPERTY:
                property = PropertyDeclaration(parent_sys);
                try {
                    attachment.addProperty(property);
                } catch (acmeLib.core.exceptions.AcmeIllegalNameException e) {
                    {if (true) throw createArmaniParseException ( e.getMessage());}
                }
                break;
              case PROPERTIES:
                child_enum = PropertiesBlock(parent_sys);
                while (child_enum.moreItems()) {
                    property = (AcmeProperty) child_enum.getNextItem();
                    try {
                        attachment.addProperty(property);
                    } catch (acmeLib.core.exceptions.AcmeIllegalNameException e) {
                        {if (true) throw createArmaniParseException ( e.getMessage());}
                    }
                }
                // mark the enumeration for gc.
                child_enum = null;
                break;
              default:
                jj_la1[124] = jj_gen;
                jj_consume_token(-1);
                throw new ParseException();
              }
            }
            jj_consume_token(RBRACE);
            break;
          default:
            jj_la1[125] = jj_gen;
            ;
          }
          jj_consume_token(SEMICOLON);
          break;
        default:
          jj_la1[126] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      } catch (ParseException e) {
  reportError (e);
  skip_to (SEMICOLON);
      }
    } finally {
      trace_return("AttachmentsDeclaration");
    }
  }

////////////////
// Properties
////////////////

// single property = PropertyDeclaration
// block of properties = PropertiesBlock
// single description = parse_PropertyDescription

//
// parse a single property declaration
//
  static final public AcmeProperty PropertyDeclaration(acmeLib.designRules.Scope curScope) throws ParseException {
    trace_call("PropertyDeclaration");
    try {
    AcmeProperty new_prop = new AcmeProperty ();
    Token start = null;
      try {
        start = jj_consume_token(PROPERTY);
        new_prop = parse_PropertyDescription(curScope);
        jj_consume_token(SEMICOLON);
      } catch (ParseException e) {
  reportError (e);
  skip_to (SEMICOLON);
      }
        new_prop.setScope(curScope);
        processComment (start, new_prop);
        {if (true) return new_prop;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("PropertyDeclaration");
    }
  }

//
// parse a block of multiple property declarations
//
  static final public AcmeEnumeration PropertiesBlock(acmeLib.designRules.Scope curScope) throws ParseException {
    trace_call("PropertiesBlock");
    try {
    Token property_id_token;
    AcmeProperty new_property;
    AcmeEnumeration property_enum = new AcmeEnumeration ();
      try {
        jj_consume_token(PROPERTIES);
        jj_consume_token(LBRACE);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case PROPERTY:
        case IDENTIFIER:
          new_property = parse_PropertyDescription(curScope);
            new_property.setScope(curScope);
            property_enum.insertItem(new_property);
          label_45:
          while (true) {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case SEMICOLON:
              ;
              break;
            default:
              jj_la1[127] = jj_gen;
              break label_45;
            }
            if (jj_2_38(2)) {
              jj_consume_token(SEMICOLON);
              new_property = parse_PropertyDescription(curScope);
                new_property.setScope(curScope);
                property_enum.insertItem(new_property);
            } else {
              switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
              case SEMICOLON:
                jj_consume_token(SEMICOLON);
                break;
              default:
                jj_la1[128] = jj_gen;
                jj_consume_token(-1);
                throw new ParseException();
              }
            }
          }
          break;
        default:
          jj_la1[129] = jj_gen;
          ;
        }
        jj_consume_token(RBRACE);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SEMICOLON:
          jj_consume_token(SEMICOLON);
          break;
        default:
          jj_la1[130] = jj_gen;
          ;
        }
      } catch (ParseException e) {
  reportError (e);
  skip_to (RBRACE);
  skip_to (SEMICOLON);
      }
        {if (true) return property_enum;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("PropertiesBlock");
    }
  }

  static final public AcmeProperty parse_PropertyDescription(acmeLib.designRules.Scope curScope) throws ParseException {
    trace_call("parse_PropertyDescription");
    try {
    Token prop_id;
    AcmeProperty new_prop;
    AcmeProperty new_meta_prop;
    AcmePropertyType prop_type = ConstantTypes.UNSPECIFIED_TYPE;
    AcmePropertyValue new_prop_value = null;
    Token start = null;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PROPERTY:
        start = jj_consume_token(PROPERTY);
        break;
      default:
        jj_la1[131] = jj_gen;
        ;
      }
      // should you be able to embed a "property" statement
                          // within a Properties {...} block?  This production allows it.
      
          prop_id = jj_consume_token(IDENTIFIER);
        new_prop = new AcmeProperty(prop_id.image, prop_type, new_prop_value);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COLON:
        jj_consume_token(COLON);
        prop_type = PropertyTypeDescription();
        new_prop.setType(prop_type);
        break;
      default:
        jj_la1[132] = jj_gen;
        ;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ASSIGN:
        jj_consume_token(ASSIGN);
        new_prop_value = PropertyValueDeclaration();
        new_prop.setValue(new_prop_value);
        // should I try to match the types of the value objects
        // up with the type objects in the previous setType
        // operation?  it's unclear how to do this in a general
        // way, so I might want to just special case it for
        // sets, sequences, records, and enums.
        if ( (new_prop_value instanceof AcmeEnum)
             && (prop_type instanceof EnumType))
            ((AcmeEnum) new_prop_value).setType((EnumType)prop_type);
        else if ((new_prop_value instanceof AcmeSequence)
                    && (prop_type instanceof SequenceType))
            ((AcmeSequence) new_prop_value).setType((SequenceType)prop_type);
        else if ((new_prop_value instanceof AcmeSet)
                    && (prop_type instanceof SetType))
            ((AcmeSet) new_prop_value).setType((SetType) prop_type);
        break;
      default:
        jj_la1[133] = jj_gen;
        ;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case PROPBEGIN:
        if (jj_2_40(3)) {
          jj_consume_token(PROPBEGIN);
          new_meta_prop = parse_PropertyDescription(new_prop);
                 try {
                    new_prop.addProperty(new_meta_prop);
                    // meta-properties values are always defaults that
                    // can be overriden later
                    if (new_meta_prop.getValue() != null) {
                        if (curScope instanceof AcmeElementType) {
                            // meta-properties on properties in types
                            // are set as defaults to allow proper overriding.
                            // meta-properties on properties of concrete
                            // element declarations are not default, and have
                            // to take precedence.
                            new_meta_prop.getValue().setIsDefaultValue(true);
                        }
                    }
                 } catch (acmeLib.core.exceptions.AcmeIllegalNameException e) {
                    {if (true) throw createArmaniParseException ( e.getMessage());}
                 }
          label_46:
          while (true) {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case SEMICOLON:
              ;
              break;
            default:
              jj_la1[134] = jj_gen;
              break label_46;
            }
            if (jj_2_39(2)) {
              jj_consume_token(SEMICOLON);
              new_meta_prop = parse_PropertyDescription(new_prop);
                 try {
                    new_prop.addProperty(new_meta_prop);
                    if (new_meta_prop.getValue() != null) {
                        if (curScope instanceof AcmeElementType) {
                            // meta-properties on properties in types
                            // are set as defaults to allow proper overriding.
                            // meta-properties on properties of concrete
                            // element declarations are not default, and have
                            // to take precedence.
                            new_meta_prop.getValue().setIsDefaultValue(true);
                        }

                    }
                 } catch (acmeLib.core.exceptions.AcmeIllegalNameException e) {
                    {if (true) throw createArmaniParseException ( e.getMessage());}
                 }
            } else {
              switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
              case SEMICOLON:
                jj_consume_token(SEMICOLON);
                break;
              default:
                jj_la1[135] = jj_gen;
                jj_consume_token(-1);
                throw new ParseException();
              }
            }
          }
          jj_consume_token(PROPEND);
        } else {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case PROPBEGIN:
            jj_consume_token(PROPBEGIN);
            jj_consume_token(PROPEND);
            break;
          default:
            jj_la1[136] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
        break;
      default:
        jj_la1[137] = jj_gen;
        ;
      }
        // override the inferred type with the declared type,
        // if a type was declared (abstract base class doesn't have "setType"
        // RTM: commented out because it seems that we want to keep the type
        //      of a property value independent of the type of a property
        //      because they describe different things. This is not clearly
        //      a good idea, though.
        // if (prop_type != null) new_prop_value.setType(prop_type);
        processComment (start, new_prop);
        processComment (prop_id, new_prop);
        {if (true) return new_prop;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("parse_PropertyDescription");
    }
  }

//
// Property types
//
  static final public AcmePropertyType PropertyTypeDeclaration() throws ParseException {
    trace_call("PropertyTypeDeclaration");
    try {
    Token typename_token= null;
    Token original_typename_token;
    Token enum_value_token;
    AcmePropertyType contained_property_type = null;
    RecordType new_record_type = null;
    EnumType new_enum = null;
    AcmePropertyType new_type = new IntType ("int");
    Token start = null;
      try {
        start = jj_consume_token(PROPERTY);
        jj_consume_token(TYPE);
        typename_token = jj_consume_token(IDENTIFIER);
        jj_consume_token(ASSIGN);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case INT:
          jj_consume_token(INT);
          jj_consume_token(SEMICOLON);
          new_type = new IntType(typename_token.image);
          processComment (start, new_type);
          {if (true) return new_type;}
          break;
        case FLOAT:
          jj_consume_token(FLOAT);
          jj_consume_token(SEMICOLON);
          new_type = new FloatType(typename_token.image);
          processComment (start, new_type);
          {if (true) return new_type;}
          break;
        case STRING:
          jj_consume_token(STRING);
          jj_consume_token(SEMICOLON);
          new_type = new StringType(typename_token.image);
          processComment (start, new_type);
          {if (true) return new_type;}
          break;
        case BOOLEAN:
          jj_consume_token(BOOLEAN);
          jj_consume_token(SEMICOLON);
          new_type = new BooleanType(typename_token.image);
          processComment (start, new_type);
          {if (true) return new_type;}
          break;
        case ENUM:
          jj_consume_token(ENUM);
         new_enum = new EnumType(typename_token.image);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case LBRACE:
            jj_consume_token(LBRACE);
            enum_value_token = jj_consume_token(IDENTIFIER);
                new_enum.addValue(enum_value_token.image);
            label_47:
            while (true) {
              switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
              case COMMA:
                ;
                break;
              default:
                jj_la1[138] = jj_gen;
                break label_47;
              }
              jj_consume_token(COMMA);
              enum_value_token = jj_consume_token(IDENTIFIER);
                     new_enum.addValue(enum_value_token.image);
            }
            jj_consume_token(RBRACE);
            break;
          default:
            jj_la1[139] = jj_gen;
            ;
          }
          jj_consume_token(SEMICOLON);
        processComment (start, new_enum);
         {if (true) return new_enum;}
          break;
        default:
          jj_la1[145] = jj_gen;
          if (jj_2_42(4)) {
            jj_consume_token(SET);
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case LBRACE:
              jj_consume_token(LBRACE);
              jj_consume_token(RBRACE);
              break;
            default:
              jj_la1[140] = jj_gen;
              ;
            }
            jj_consume_token(SEMICOLON);
          new_type = new SetType(typename_token.image,
                             ConstantTypes.UNSPECIFIED_TYPE);
          processComment (start, new_type);
          {if (true) return new_type;}
          } else if (jj_2_43(4)) {
            jj_consume_token(SET);
            jj_consume_token(LBRACE);
            contained_property_type = PropertyTypeDescription();
            jj_consume_token(RBRACE);
            jj_consume_token(SEMICOLON);
          new_type = new SetType(typename_token.image, contained_property_type);
          processComment (start, new_type);
          {if (true) return new_type;}
          } else if (jj_2_44(4)) {
            jj_consume_token(SEQUENCE);
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case LANGLE:
              jj_consume_token(LANGLE);
              jj_consume_token(RANGLE);
              break;
            default:
              jj_la1[141] = jj_gen;
              ;
            }
            jj_consume_token(SEMICOLON);
          new_type = new SequenceType(typename_token.image,
                                  ConstantTypes.UNSPECIFIED_TYPE);
          processComment (start, new_type);
          {if (true) return new_type;}
          } else if (jj_2_45(4)) {
            jj_consume_token(SEQUENCE);
            jj_consume_token(LANGLE);
            contained_property_type = PropertyTypeDescription();
            jj_consume_token(RANGLE);
            jj_consume_token(SEMICOLON);
          new_type = new SequenceType(typename_token.image,
                                  contained_property_type);
          processComment (start, new_type);
          {if (true) return new_type;}
          } else if (jj_2_46(4)) {
            jj_consume_token(RECORD);
                 new_record_type = new RecordType(typename_token.image);
            jj_consume_token(LBRACKET);
            parse_RecordFieldDescription(new_record_type);
            label_48:
            while (true) {
              switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
              case SEMICOLON:
                ;
                break;
              default:
                jj_la1[142] = jj_gen;
                break label_48;
              }
              if (jj_2_41(2)) {
                jj_consume_token(SEMICOLON);
                parse_RecordFieldDescription(new_record_type);
              } else {
                switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
                case SEMICOLON:
                  jj_consume_token(SEMICOLON);
                  break;
                default:
                  jj_la1[143] = jj_gen;
                  jj_consume_token(-1);
                  throw new ParseException();
                }
              }
            }
            jj_consume_token(RBRACKET);
            jj_consume_token(SEMICOLON);
                processComment (start, new_record_type);
            {if (true) return new_record_type;}
          } else if (jj_2_47(4)) {
            jj_consume_token(RECORD);
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case LBRACKET:
              jj_consume_token(LBRACKET);
              jj_consume_token(RBRACKET);
              break;
            default:
              jj_la1[144] = jj_gen;
              ;
            }
            jj_consume_token(SEMICOLON);
                new_type = new RecordType(typename_token.image);
                processComment (start, new_type);
            {if (true) return new_type;}
          } else {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case IDENTIFIER:
              original_typename_token = jj_consume_token(IDENTIFIER);
              jj_consume_token(SEMICOLON);
        // return an unresolved property type reference
        {if (true) return new AcmeUnresolvedPropertyType(original_typename_token.image);}
              break;
            default:
              jj_la1[146] = jj_gen;
              jj_consume_token(-1);
              throw new ParseException();
            }
          }
        }
      } catch (ParseException e) {
  reportError (e);
  skip_to (SEMICOLON);

  // Bugfix #125 Make sure we return something!
  if (new_type == null) {
    if (typename_token != null)
        {if (true) return new AnyType (typename_token.image);}
        else
                {if (true) return new AnyType ("__UNKNOWN__");}
  }
  else
    {if (true) return new_type;}
      }
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("PropertyTypeDeclaration");
    }
  }

/////////////////////////////
// PropertyTypeDescription parses a type description and returns
// that type description's PropertyType object.  If it finds a
// type name then it looks the name up with the type manager and returns
// the appropriate type object.  If it is a primitive type declaration
// then it returns the appropriate static type object for that primitive.
// If it finds an "anonymous" compound type it creates an object for
// that type, gensyming an "anonymous" name for the type, and returns
// that object.  This may return an UnresolvedPropertyType.  If it does
// so then that property type will need to be resolved in post-parsing
// processing.
//
//
  static final public AcmePropertyType PropertyTypeDescription() throws ParseException {
    trace_call("PropertyTypeDescription");
    try {
    Token cur_token;
    AcmePropertyType return_type = null;
    AcmePropertyType interior_property_type = ConstantTypes.UNSPECIFIED_TYPE;
    RecordType new_record = null;
    EnumType new_enum = null;
    String enum_symbol = null;
    StringBuffer name_buf = null;
    String type_name;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ANY:
        jj_consume_token(ANY);
                {if (true) return acmeLib.core.globals.ConstantTypes.EXPLICIT_ANY_TYPE;}
        break;
      case INT:
        jj_consume_token(INT);
        {if (true) return acmeLib.core.globals.ConstantTypes.INT_TYPE;}
        break;
      case FLOAT:
        jj_consume_token(FLOAT);
        {if (true) return acmeLib.core.globals.ConstantTypes.FLOAT_TYPE;}
        break;
      case STRING:
        jj_consume_token(STRING);
        {if (true) return acmeLib.core.globals.ConstantTypes.STRING_TYPE;}
        break;
      case BOOLEAN:
        jj_consume_token(BOOLEAN);
        {if (true) return acmeLib.core.globals.ConstantTypes.BOOLEAN_TYPE;}
        break;
      case SET:
        jj_consume_token(SET);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case LBRACE:
          jj_consume_token(LBRACE);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case FLOAT:
          case INT:
          case STRING:
          case BOOLEAN:
          case SET:
          case SEQUENCE:
          case RECORD:
          case ENUM:
          case ANY:
          case IDENTIFIER:
            interior_property_type = PropertyTypeDescription();
            break;
          default:
            jj_la1[147] = jj_gen;
            ;
          }
          jj_consume_token(RBRACE);
          break;
        default:
          jj_la1[148] = jj_gen;
          ;
        }
            if (interior_property_type == ConstantTypes.UNSPECIFIED_TYPE) {
                type_name = new String("Set{}");
                return_type = ConstantTypes.ANY_SET_TYPE;
            }
            else if (interior_property_type.getTypeName() == null) {
                type_name = new String("Set{}");
                return_type = ConstantTypes.ANY_SET_TYPE;
            }
            else {
                type_name = new String("Set{"
                                  + interior_property_type.getTypeName() + "}");
            }

            if (return_type == null)
                return_type = new SetType(type_name, interior_property_type);

            // this was an inline definition, or else it would have been
            // just an identifier.
            return_type.setInlineTypeSpec(true);

            {if (true) return return_type;}
        break;
      case SEQUENCE:
        jj_consume_token(SEQUENCE);
        if (jj_2_48(3)) {
          jj_consume_token(LANGLE);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case FLOAT:
          case INT:
          case STRING:
          case BOOLEAN:
          case SET:
          case SEQUENCE:
          case RECORD:
          case ENUM:
          case ANY:
          case IDENTIFIER:
            interior_property_type = PropertyTypeDescription();
            break;
          default:
            jj_la1[149] = jj_gen;
            ;
          }
          jj_consume_token(RANGLE);
        } else {
          ;
        }
            if (interior_property_type == ConstantTypes.UNSPECIFIED_TYPE) {
                type_name = new String("sequence<>");
                return_type = ConstantTypes.ANY_SEQUENCE_TYPE;
            }
            else if (interior_property_type.getTypeName() == null) {
                type_name = new String("sequence<>");
                return_type = ConstantTypes.ANY_SEQUENCE_TYPE;
            }
            else {
                type_name = new String("sequence<"
                                 + interior_property_type.getTypeName() + ">");
            }

            if (return_type == null)
                return_type = new SequenceType(type_name, interior_property_type);

            // this was an inline definition, or else it would have been
            // just an identifier.
            return_type.setInlineTypeSpec(true);

            {if (true) return return_type;}
        break;
      default:
        jj_la1[156] = jj_gen;
        if (jj_2_50(3)) {
          jj_consume_token(RECORD);
                            new_record = new RecordType("__inline_record_");
          jj_consume_token(LBRACKET);
          parse_RecordFieldDescription(new_record);
          label_49:
          while (true) {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case SEMICOLON:
              ;
              break;
            default:
              jj_la1[150] = jj_gen;
              break label_49;
            }
            if (jj_2_49(2)) {
              jj_consume_token(SEMICOLON);
              parse_RecordFieldDescription(new_record);
            } else {
              switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
              case SEMICOLON:
                jj_consume_token(SEMICOLON);
                break;
              default:
                jj_la1[151] = jj_gen;
                jj_consume_token(-1);
                throw new ParseException();
              }
            }
          }
          jj_consume_token(RBRACKET);
            // generate a name based on the fields and their types
            // the anonymous record name is the string that should be
            // exported to declare the inline type directly.  That is,
            // when it's name is exported it will look like an appropriate
            // inline type description.
            name_buf = new StringBuffer("Record[");
            AcmeEnumeration rec_fields = new_record.getFields();
            AcmeRecordField f;
            while (rec_fields.moreItems()) {
                f = (AcmeRecordField) rec_fields.getNextItem();
                if (f.getName() != null) {
                    name_buf.append(f.getName());
                }
                if (f.getType() != null) {
                    if (f.getType().getTypeName() != null)
                        name_buf.append(" : " + f.getType().getTypeName());
                }
                name_buf.append("; ");
            }
            name_buf.append("]");

            // (re)set the name of this type to the gensymed name
            new_record.setTypeName(name_buf.toString());

            // this was an inline definition, or else it would have been
            // just an identifier.
            new_record.setInlineTypeSpec(true);

            {if (true) return new_record;}
        } else if (jj_2_51(3)) {
          jj_consume_token(RECORD);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case LBRACKET:
            jj_consume_token(LBRACKET);
            jj_consume_token(RBRACKET);
            break;
          default:
            jj_la1[152] = jj_gen;
            ;
          }
            {if (true) return ConstantTypes.ANY_RECORD_TYPE;}
        } else if (jj_2_52(3)) {
          jj_consume_token(ENUM);
        name_buf = new StringBuffer("Enum { ");
        new_enum = new EnumType(name_buf.toString());
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case LBRACE:
            jj_consume_token(LBRACE);
            cur_token = jj_consume_token(IDENTIFIER);
              name_buf.append(cur_token.image);
              new_enum.addValue(cur_token.image);
            label_50:
            while (true) {
              switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
              case COMMA:
                ;
                break;
              default:
                jj_la1[153] = jj_gen;
                break label_50;
              }
              jj_consume_token(COMMA);
              cur_token = jj_consume_token(IDENTIFIER);
                   if (!new_enum.hasValue(cur_token.image)) {
                        name_buf.append(", " + cur_token.image);
                        new_enum.addValue(cur_token.image);
                   } else {
                        // else warn that this is a repeat value.
                        warning_stack.push(new String("Repeated "
                        + " enum value \"" + cur_token.image
                        + "\""));
                   }
            }
            jj_consume_token(RBRACE);
            break;
          default:
            jj_la1[154] = jj_gen;
            ;
          }
        name_buf.append(" }");
        new_enum.setTypeName(name_buf.toString());
        new_enum.setInlineTypeSpec(true);
        {if (true) return new_enum;}
        } else if (jj_2_53(3)) {
          jj_consume_token(ENUM);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case LBRACE:
            jj_consume_token(LBRACE);
            jj_consume_token(RBRACE);
            break;
          default:
            jj_la1[155] = jj_gen;
            ;
          }
        {if (true) return ConstantTypes.EMPTY_ENUM_TYPE;}
        } else {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case IDENTIFIER:
            return_type = lookup_PropertyTypeByName();
        {if (true) return return_type;}
            break;
          default:
            jj_la1[157] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
      }
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("PropertyTypeDescription");
    }
  }

  static final public void parse_RecordFieldDescription(RecordType parent_record) throws ParseException {
    trace_call("parse_RecordFieldDescription");
    try {
    Token cur_token;
    java.util.Vector id_v = new java.util.Vector();
    AcmePropertyType prop_type = ConstantTypes.UNSPECIFIED_TYPE;
      // basic algorithm here is to add the identifiers to a temp vector
          // until we see a type definition, then add a new field of that type
          // to the parent_record for each identifier.
          cur_token = jj_consume_token(IDENTIFIER);
                               id_v.addElement(cur_token.image);
      label_51:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[158] = jj_gen;
          break label_51;
        }
        jj_consume_token(COMMA);
        cur_token = jj_consume_token(IDENTIFIER);
                                       id_v.addElement(cur_token.image);
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COLON:
        jj_consume_token(COLON);
        prop_type = PropertyTypeDescription();
        break;
      default:
        jj_la1[159] = jj_gen;
        ;
      }
          // pull each identifier from the stack and add a field for it
          // to the parent_record
          java.util.Enumeration e = id_v.elements();
          while(e.hasMoreElements()) {
              parent_record.addField( (String) e.nextElement(),
                                       prop_type,
                                       null );
          }
    } finally {
      trace_return("parse_RecordFieldDescription");
    }
  }

  static final public AcmePropertyValue PropertyValueDeclaration() throws ParseException {
    trace_call("PropertyValueDeclaration");
    try {
    Token cur_token;
    AcmePropertyValue new_val = null;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case INTEGER_LITERAL:
        cur_token = jj_consume_token(INTEGER_LITERAL);
           // this is an integer, give it a default int type.
           IntType new_Inttype_decl = new IntType("int");
           // parse the value
           {if (true) return new AcmeInt(new_Inttype_decl,
                              Integer.parseInt(cur_token.image));}
        break;
      case FLOATING_POINT_LITERAL:
        cur_token = jj_consume_token(FLOATING_POINT_LITERAL);
           FloatType new_Floattype_decl = new FloatType("float");
           {if (true) return new AcmeFloat(new_Floattype_decl,
                 (Float.valueOf(cur_token.image)).floatValue());}
        break;
      case STRING_LITERAL:
        cur_token = jj_consume_token(STRING_LITERAL);
           StringType new_Stringtype_decl = new StringType("string");
           AcmeString new_string = new AcmeString(new_Stringtype_decl, "");

           // convert the new string to a quote-compliant
           // internal representation
           new_string.setValue(new_string.massageForInternalStorage(
                                  cur_token.image));
           {if (true) return new_string;}
        break;
      case FALSE:
        cur_token = jj_consume_token(FALSE);
                          {if (true) return new AcmeBoolean(false);}
        break;
      case TRUE:
        cur_token = jj_consume_token(TRUE);
                         {if (true) return new AcmeBoolean(true);}
        break;
      case LBRACE:
        new_val = AcmeSetValue();
                                {if (true) return new_val;}
        break;
      case LANGLE:
        new_val = AcmeSequenceValue();
                                    {if (true) return new_val;}
        break;
      case LBRACKET:
        new_val = AcmeRecordValue();
                                   {if (true) return new_val;}
        break;
      case IDENTIFIER:
        cur_token = jj_consume_token(IDENTIFIER);
        // RTM: what to do with an identifier is a bit tricky.
        // for the moment, let's assume that it is an enum and
        // return it as an enum value.  In Armani it will
        // probably have meaning in referring to specific
        // architectural entities or properties.
        {if (true) return new AcmeEnum(cur_token.image);}
        break;
      default:
        jj_la1[160] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("PropertyValueDeclaration");
    }
  }

//
// Productions for compound property value types.
//
  static final public AcmeSet AcmeSetValue() throws ParseException {
    trace_call("AcmeSetValue");
    try {
    AcmePropertyValue new_val;
    AcmeSet new_set = null;
      if (jj_2_54(2)) {
        jj_consume_token(LBRACE);
        jj_consume_token(RBRACE);
        new_set = new AcmeSet();
        {if (true) return new_set;}
      } else if (jj_2_55(2)) {
        jj_consume_token(LBRACE);
        new_val = PropertyValueDeclaration();
             new_set = new AcmeSet();
             new_set.addValue(new_val);
        label_52:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMMA:
            ;
            break;
          default:
            jj_la1[161] = jj_gen;
            break label_52;
          }
          jj_consume_token(COMMA);
          new_val = PropertyValueDeclaration();
                           new_set.addValue(new_val);
        }
        jj_consume_token(RBRACE);
      {if (true) return new_set;}
      } else {
        jj_consume_token(-1);
        throw new ParseException();
      }
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("AcmeSetValue");
    }
  }

  static final public AcmeSequence AcmeSequenceValue() throws ParseException {
    trace_call("AcmeSequenceValue");
    try {
    AcmePropertyValue new_val;
    AcmeSequence new_sequence = null;
      if (jj_2_56(3)) {
        jj_consume_token(LANGLE);
        jj_consume_token(RANGLE);
        new_sequence = new AcmeSequence();
        {if (true) return new_sequence;}
      } else if (jj_2_57(3)) {
        jj_consume_token(LANGLE);
        new_val = PropertyValueDeclaration();
             new_sequence = new AcmeSequence();
             new_sequence.addValue(new_val);
        label_53:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMMA:
            ;
            break;
          default:
            jj_la1[162] = jj_gen;
            break label_53;
          }
          jj_consume_token(COMMA);
          new_val = PropertyValueDeclaration();
                           new_sequence.addValue(new_val);
        }
        jj_consume_token(RANGLE);
      {if (true) return new_sequence;}
      } else {
        jj_consume_token(-1);
        throw new ParseException();
      }
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("AcmeSequenceValue");
    }
  }

  static final public AcmeRecord AcmeRecordValue() throws ParseException {
    trace_call("AcmeRecordValue");
    try {
    AcmeRecordField new_field;
    AcmeRecord new_record = new AcmeRecord ();
      try {
        if (jj_2_59(3)) {
          jj_consume_token(LBRACKET);
          new_field = RecordFieldValue();
            new_record = new AcmeRecord();
            new_record.addField(new_field);
          label_54:
          while (true) {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case SEMICOLON:
              ;
              break;
            default:
              jj_la1[163] = jj_gen;
              break label_54;
            }
            if (jj_2_58(2)) {
              jj_consume_token(SEMICOLON);
              new_field = RecordFieldValue();
            new_record.addField(new_field);
            } else {
              switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
              case SEMICOLON:
                jj_consume_token(SEMICOLON);
                break;
              default:
                jj_la1[164] = jj_gen;
                jj_consume_token(-1);
                throw new ParseException();
              }
            }
          }
          jj_consume_token(RBRACKET);
        {if (true) return new_record;}
        } else if (jj_2_60(3)) {
          jj_consume_token(LBRACKET);
          jj_consume_token(RBRACKET);
        new_record = new AcmeRecord();
        {if (true) return new_record;}
        } else {
          jj_consume_token(-1);
          throw new ParseException();
        }
      } catch (ParseException e) {
        reportError (e);
        skip_to (RBRACKET);
        {if (true) return new_record;}
      }
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("AcmeRecordValue");
    }
  }

  static final public AcmeRecordField RecordFieldValue() throws ParseException {
    trace_call("RecordFieldValue");
    try {
    Token cur_token;
    AcmePropertyValue value = null;
    AcmePropertyType type = ConstantTypes.UNSPECIFIED_TYPE;
      cur_token = jj_consume_token(IDENTIFIER);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COLON:
        jj_consume_token(COLON);
        type = PropertyTypeDescription();
        break;
      default:
        jj_la1[165] = jj_gen;
        ;
      }
      jj_consume_token(ASSIGN);
      value = PropertyValueDeclaration();
        {if (true) return new AcmeRecordField(cur_token.image, type, value);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("RecordFieldValue");
    }
  }

/////////////////////
//                 //
// Representations //
//                 //
/////////////////////
  static final public AcmeRepresentation RepresentationDeclaration(AcmeElement parent) throws ParseException {
    trace_call("RepresentationDeclaration");
    try {
    AcmeSystem repSystem;
    AcmeBindingsMap bindingsMap = null;
    AcmeRepresentation newRep = new AcmeRepresentation ();
    Token repName = null;
    Token start = null;
      try {
        start = jj_consume_token(REPRESENTATION);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case IDENTIFIER:
          repName = jj_consume_token(IDENTIFIER);
          jj_consume_token(ASSIGN);
          break;
        default:
          jj_la1[166] = jj_gen;
          ;
        }
        jj_consume_token(LBRACE);
        repSystem = SystemDeclaration();
        newRep = new AcmeRepresentation();
        newRep.setSystem(repSystem);
        try {
            if (repName != null) {
                newRep.setName(repName.image);
            } else {
                newRep.setName(repSystem.getName());
                newRep.setRepNameIsAnonymous(true);
            }
        } catch (acmeLib.core.exceptions.AcmeIllegalNameException e) {
           {if (true) throw createArmaniParseException ( e.getMessage());}
        }
        repSystem.setParent(parent);
        repSystem.setParentRepresentation(newRep);
        repSystem.setParentDesign(global_design);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case BINDINGS:
          bindingsMap = BindingsMapDeclaration(newRep);
        newRep.setAbstractionMap(bindingsMap);
          break;
        default:
          jj_la1[167] = jj_gen;
          ;
        }
        jj_consume_token(RBRACE);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SEMICOLON:
          jj_consume_token(SEMICOLON);
          break;
        default:
          jj_la1[168] = jj_gen;
          ;
        }
      } catch (ParseException e) {
  reportError (e);
  skip_to (SEMICOLON);
      }
        processComment (start, newRep);
        {if (true) return newRep;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("RepresentationDeclaration");
    }
  }

  static final public AcmeBindingsMap BindingsMapDeclaration(AcmeRepresentation boundRep) throws ParseException {
    trace_call("BindingsMapDeclaration");
    try {
    AcmeBindingsMap bindings_map = new AcmeBindingsMap ();
    AcmeBinding cur_binding;
      try {
        jj_consume_token(BINDINGS);
        jj_consume_token(LBRACE);
        label_55:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case IDENTIFIER:
            ;
            break;
          default:
            jj_la1[169] = jj_gen;
            break label_55;
          }
          cur_binding = BindingDeclaration(boundRep);
        bindings_map.addBinding(cur_binding);
        }
        jj_consume_token(RBRACE);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SEMICOLON:
          jj_consume_token(SEMICOLON);
          break;
        default:
          jj_la1[170] = jj_gen;
          ;
        }
      } catch (ParseException e) {
  reportError (e);
  skip_to (SEMICOLON);
      }
        {if (true) return bindings_map;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("BindingsMapDeclaration");
    }
  }

  static final public AcmeBinding BindingDeclaration(AcmeRepresentation parent_rep) throws ParseException {
    trace_call("BindingDeclaration");
    try {
    Token first_qualifier = null;
    Token first_id = null;
    Token second_qualifier = null;
    Token second_id = null;

    AcmeBinding new_binding = new AcmeBinding (null, null);
    AcmeProperty property = null;
    AcmeEnumeration child_enum = null;
      try {
        if (jj_2_61(2)) {
          first_qualifier = jj_consume_token(IDENTIFIER);
          jj_consume_token(DOT);
        } else {
          ;
        }
        first_id = jj_consume_token(IDENTIFIER);
        jj_consume_token(TO);
        if (jj_2_62(2)) {
          second_qualifier = jj_consume_token(IDENTIFIER);
          jj_consume_token(DOT);
        } else {
          ;
        }
        second_id = jj_consume_token(IDENTIFIER);
        // first set up the generic error message buffer
        StringBuffer err_buf = new StringBuffer("(line "
                + first_id.beginLine + ") Binding \"");
        if (first_qualifier != null)
            err_buf.append(first_qualifier.image + ".");
        err_buf.append(first_id.image + " to ");

        if (second_qualifier != null)
            err_buf.append(second_qualifier.image + ".");
        err_buf.append(second_id.image + "\": ");

        // try to find the elements referred to by the binding.
        if ((first_qualifier == null) && (second_qualifier == null)) {
            // You need at least one qualifier for the inner half of the binding
            err_buf.append("Neither bound element has fully qualified name.");
           {if (true) throw createArmaniParseException (err_buf.toString());}
        }

        // the qualifier tokens are optional, so check that they are
        // not null before dereferencing them.
        String first_qualifier_str = null;
        String second_qualifier_str = null;
        if (first_qualifier != null)
            first_qualifier_str = first_qualifier.image;
        if (second_qualifier != null)
            second_qualifier_str = second_qualifier.image;

        // create an unresolved binding object and return it.
        new_binding = new AcmeUnresolvedBinding(first_qualifier_str,
                                                first_id.image,
                                                second_qualifier_str,
                                                second_id.image);
        new_binding.setParentRep(parent_rep);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case LBRACE:
          jj_consume_token(LBRACE);
          label_56:
          while (true) {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case PROPERTY:
            case PROPERTIES:
              ;
              break;
            default:
              jj_la1[171] = jj_gen;
              break label_56;
            }
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case PROPERTY:
              property = PropertyDeclaration(new_binding);
                try {
                    new_binding.addProperty(property);
                } catch (acmeLib.core.exceptions.AcmeIllegalNameException e) {
                    {if (true) throw createArmaniParseException ( e.getMessage());}
                }
              break;
            case PROPERTIES:
              child_enum = PropertiesBlock(new_binding);
                while (child_enum.moreItems()) {
                    property = (AcmeProperty) child_enum.getNextItem();
                    try {
                        new_binding.addProperty(property);
                    } catch (acmeLib.core.exceptions.AcmeIllegalNameException e) {
                        {if (true) throw createArmaniParseException ( e.getMessage());}
                    }
                }
                // mark the enumeration for gc.
                child_enum = null;
              break;
            default:
              jj_la1[172] = jj_gen;
              jj_consume_token(-1);
              throw new ParseException();
            }
          }
          jj_consume_token(RBRACE);
          break;
        default:
          jj_la1[173] = jj_gen;
          ;
        }
        jj_consume_token(SEMICOLON);
      } catch (ParseException e) {
  reportError (e);
  skip_to (SEMICOLON);
      }
        {if (true) return new_binding;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("BindingDeclaration");
    }
  }

////////////////////
// End ACME grammar
////////////////////


/////////////////////////////////////////
// Begin Design rule grammar productions
/////////////////////////////////////////
  static final public acmeLib.designRules.DesignAnalysis DesignAnalysisDeclaration(Scope curScope) throws ParseException {
    trace_call("DesignAnalysisDeclaration");
    try {
    Token idToken;
    Token returnTypeIdToken;
    AcmeType returnType = null;
    java.util.Vector formalParamVector = new Vector ();
    DesignAnalysis da = new DesignAnalysis ();
    boolean isExternal = false;
    Token start = null;
    Token anal = null;
      try {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case EXTERNAL:
          start = jj_consume_token(EXTERNAL);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case DESIGN:
            jj_consume_token(DESIGN);
            break;
          default:
            jj_la1[174] = jj_gen;
            ;
          }
          jj_consume_token(ANALYSIS);
                                                 isExternal = true;
          idToken = jj_consume_token(IDENTIFIER);
                            da = new DesignAnalysis(idToken.image);
          jj_consume_token(LPAREN);
          formalParamVector = FormalParams(curScope);
          jj_consume_token(RPAREN);
          jj_consume_token(COLON);
          if (jj_2_63(3)) {
            returnType = NonPropertySetTypeExpression();
                                                                            da.setReturnType (returnType);
          } else if (jj_2_64(3)) {
            returnType = PropertyTypeDescription();
                                                              da.setReturnType(returnType);
          } else {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case COMPONENT:
              jj_consume_token(COMPONENT);
                      da.setReturnType(ConstantTypes.COMPONENT_BASE_TYPE);
              break;
            case GROUP:
              jj_consume_token(GROUP);
                  da.setReturnType(ConstantTypes.GROUP_BASE_TYPE);
              break;
            case CONNECTOR:
              jj_consume_token(CONNECTOR);
                      da.setReturnType(ConstantTypes.CONNECTOR_BASE_TYPE);
              break;
            case PORT:
              jj_consume_token(PORT);
                      da.setReturnType(ConstantTypes.PORT_BASE_TYPE);
              break;
            case ROLE:
              jj_consume_token(ROLE);
                      da.setReturnType(ConstantTypes.ROLE_BASE_TYPE);
              break;
            case SYSTEM:
              jj_consume_token(SYSTEM);
                      da.setReturnType(ConstantTypes.SYSTEM_BASE_TYPE);
              break;
            case ELEMENT:
              jj_consume_token(ELEMENT);
                      da.setReturnType(ConstantTypes.ELEMENT_BASE_TYPE);
              break;
            case TYPE:
              jj_consume_token(TYPE);
                      da.setReturnType(ConstantTypes.TYPE_REFERENCE_TYPE);
              break;
            default:
              jj_la1[175] = jj_gen;
              jj_consume_token(-1);
              throw new ParseException();
            }
          }
        // check to see if we retrieved an unresolved property type that was
        // prematurely declared a property type instead of just any old
        // unresolved type.
        if (returnType instanceof AcmeUnresolvedPropertyType)
            da.setReturnType(new AcmeUnresolvedType(returnType.getTypeName()));
          jj_consume_token(ASSIGN);
          JavaMethodCallExpr(da);
          jj_consume_token(SEMICOLON);
          break;
        case DESIGN:
        case ANALYSIS:
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case DESIGN:
            start = jj_consume_token(DESIGN);
            break;
          default:
            jj_la1[176] = jj_gen;
            ;
          }
          anal = jj_consume_token(ANALYSIS);
                                             isExternal = false;
          idToken = jj_consume_token(IDENTIFIER);
                             da = new DesignAnalysis(idToken.image);
          jj_consume_token(LPAREN);
          formalParamVector = FormalParams(curScope);
          jj_consume_token(RPAREN);
          jj_consume_token(COLON);
          if (jj_2_65(3)) {
            returnType = NonPropertySetTypeExpression();
                                                                 da.setReturnType (returnType);
          } else if (jj_2_66(3)) {
            returnType = PropertyTypeDescription();
                                                             da.setReturnType(returnType);
          } else {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case COMPONENT:
              jj_consume_token(COMPONENT);
                      da.setReturnType(ConstantTypes.COMPONENT_BASE_TYPE);
              break;
            case GROUP:
              jj_consume_token(GROUP);
                  da.setReturnType(ConstantTypes.GROUP_BASE_TYPE);
              break;
            case CONNECTOR:
              jj_consume_token(CONNECTOR);
                      da.setReturnType(ConstantTypes.CONNECTOR_BASE_TYPE);
              break;
            case PORT:
              jj_consume_token(PORT);
                      da.setReturnType(ConstantTypes.PORT_BASE_TYPE);
              break;
            case ROLE:
              jj_consume_token(ROLE);
                      da.setReturnType(ConstantTypes.ROLE_BASE_TYPE);
              break;
            case SYSTEM:
              jj_consume_token(SYSTEM);
                      da.setReturnType(ConstantTypes.SYSTEM_BASE_TYPE);
              break;
            case ELEMENT:
              jj_consume_token(ELEMENT);
                      da.setReturnType(ConstantTypes.ELEMENT_BASE_TYPE);
              break;
            case TYPE:
              jj_consume_token(TYPE);
                      da.setReturnType(ConstantTypes.TYPE_REFERENCE_TYPE);
              break;
            default:
              jj_la1[177] = jj_gen;
              jj_consume_token(-1);
              throw new ParseException();
            }
          }
        // check to see if we retrieved an unresolved property type that was
        // prematurely declared a property type instead of just any old
        // unresolved type.
        if (returnType instanceof AcmeUnresolvedPropertyType)
            da.setReturnType(new AcmeUnresolvedType(returnType.getTypeName()));
          jj_consume_token(ASSIGN);
          DesignRuleExpression(da);
          jj_consume_token(SEMICOLON);
          break;
        default:
          jj_la1[178] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      } catch (ParseException e) {
  reportError (e);
  skip_to (SEMICOLON);
       da.setFormalParams(formalParamVector);
        da.setScope(curScope);
        da.setIsExternalAnalysis(isExternal);

                processComment (start, da);
                processComment (anal, da);
        // return the created designAnalysis object.
        {if (true) return da;}
      }
        // if we just completed a DesignRuleExpression production, then
        // a design rule expression should be on the top of the node stack.
        ExpressionNode expression = (ExpressionNode) jjtree.peekNode();

        // fill in the design analysis fields appropriately.
        da.setDesignRuleExpression(expression);
        da.setFormalParams(formalParamVector);
        da.setScope(curScope);
        da.setIsExternalAnalysis(isExternal);

                processComment (start, da);
                processComment (anal, da);
        // return the created designAnalysis object.
        {if (true) return da;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("DesignAnalysisDeclaration");
    }
  }

  static final public acmeLib.designRules.DesignRule parse_DesignRule(Scope curScope) throws ParseException {
    trace_call("parse_DesignRule");
    try {
    DesignRule newDesignRule = new DesignRule ();
    AcmeProperty new_meta_prop;
    Token start = null;
    Token des = null;
      try {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case DESIGN:
          des = jj_consume_token(DESIGN);
          break;
        default:
          jj_la1[179] = jj_gen;
          ;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case INVARIANT:
          start = jj_consume_token(INVARIANT);
          newDesignRule = new DesignRule(curScope,  null, true);
          break;
        case HEURISTIC:
          start = jj_consume_token(HEURISTIC);
          newDesignRule = new DesignRule(curScope,  null, false);
          break;
        default:
          jj_la1[180] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        DesignRuleExpression(newDesignRule);
        if (jj_2_68(3)) {
          jj_consume_token(PROPBEGIN);
          new_meta_prop = parse_PropertyDescription(newDesignRule);
                 try {
                    newDesignRule.addProperty(new_meta_prop);
                    // meta-properties values are always defaults that
                    // can be overriden later
                    if (new_meta_prop.getValue() != null) {
                        if (curScope instanceof AcmeElementType) {
                            // meta-properties on properties in types
                            // are set as defaults to allow proper overriding.
                            // meta-properties on properties of concrete
                            // element declarations are not default, and have
                            // to take precedence.
                            new_meta_prop.getValue().setIsDefaultValue(true);
                        }
                    }
                 } catch (acmeLib.core.exceptions.AcmeIllegalNameException e) {
                    {if (true) throw createArmaniParseException ( e.getMessage());}
                 }
          label_57:
          while (true) {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case SEMICOLON:
              ;
              break;
            default:
              jj_la1[181] = jj_gen;
              break label_57;
            }
            if (jj_2_67(3)) {
              jj_consume_token(SEMICOLON);
              new_meta_prop = parse_PropertyDescription(newDesignRule);
                 try {
                    newDesignRule.addProperty(new_meta_prop);
                    if (new_meta_prop.getValue() != null) {
                        if (curScope instanceof AcmeElementType) {
                            // meta-properties on properties in types
                            // are set as defaults to allow proper overriding.
                            // meta-properties on properties of concrete
                            // element declarations are not default, and have
                            // to take precedence.
                            new_meta_prop.getValue().setIsDefaultValue(true);
                        }

                    }
                 } catch (acmeLib.core.exceptions.AcmeIllegalNameException e) {
                    {if (true) throw createArmaniParseException ( e.getMessage());}
                 }
            } else {
              switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
              case SEMICOLON:
                jj_consume_token(SEMICOLON);
                break;
              default:
                jj_la1[182] = jj_gen;
                jj_consume_token(-1);
                throw new ParseException();
              }
            }
          }
          jj_consume_token(PROPEND);
        } else {
          ;
        }
        jj_consume_token(SEMICOLON);
      } catch (ParseException e) {
  reportError (e);
  skip_to (SEMICOLON);
  {if (true) return newDesignRule;}
      }
        // the expression to maintain should now be at the top of the stack.
        ExpressionNode expression = (ExpressionNode) jjtree.peekNode();
        newDesignRule.setDesignRuleExpression(expression);
                processComment (des, newDesignRule);
                processComment (start, newDesignRule);

        {if (true) return newDesignRule;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("parse_DesignRule");
    }
  }

//
// Here's the hairy expression implementation part
//
  static final public void DesignRuleExpression(Scope curScope) throws ParseException {
    trace_call("DesignRuleExpression");
    try {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case EXISTS:
      case FORALL:
        QuantifiedExpression(curScope);
        break;
      case SYSTEM:
      case COMPONENT:
      case GROUP:
      case CONNECTOR:
      case PORT:
      case ROLE:
      case ELEMENT:
      case PROPERTY:
      case FLOAT:
      case INT:
      case STRING:
      case BOOLEAN:
      case SET:
      case SEQUENCE:
      case RECORD:
      case ENUM:
      case TRUE:
      case FALSE:
      case INTEGER_LITERAL:
      case FLOATING_POINT_LITERAL:
      case STRING_LITERAL:
      case IDENTIFIER:
      case LPAREN:
      case LBRACE:
      case BANG:
      case MINUS:
        BooleanExpression(curScope);
        break;
      default:
        jj_la1[183] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    } finally {
      trace_return("DesignRuleExpression");
    }
  }

  static final public void QuantifiedExpression(Scope curScope) throws ParseException {
    trace_call("QuantifiedExpression");
    try {
 /*@bgen(jjtree) #QuantifiedExpressionNode( 2) */
    QuantifiedExpressionNode jjtn000 = new QuantifiedExpressionNode(JJTQUANTIFIEDEXPRESSIONNODE);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);int quantOp;
    Scope thisNodeScope = null;
    Token varNameToken = null;
    AcmeType varType = ConstantTypes.UNSPECIFIED_TYPE;
    Token unique = null;
    Token declares = null;
      try {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case FORALL:
          jj_consume_token(FORALL);
                 quantOp = QuantifiedExpressionNode.UNIVERSAL_QUANTIFICATION;
          break;
        case EXISTS:
          jj_consume_token(EXISTS);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case UNIQUE:
            unique = jj_consume_token(UNIQUE);
            break;
          default:
            jj_la1[184] = jj_gen;
            ;
          }
      if (unique == null)
        quantOp = QuantifiedExpressionNode.EXISTENTIAL_QUANTIFICATION;
      else
        quantOp = QuantifiedExpressionNode.UNIQUE_EXISTENTIAL_QUANTIFICATION;
          break;
        default:
          jj_la1[185] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      thisNodeScope = (Scope) jjtn000;
        varNameToken = jj_consume_token(IDENTIFIER);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case SET_DECLARE:
        case COLON:
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COLON:
            jj_consume_token(COLON);
            break;
          case SET_DECLARE:
            declares = jj_consume_token(SET_DECLARE);
            break;
          default:
            jj_la1[186] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
          if (jj_2_69(3)) {
            varType = Type();
          } else if (jj_2_70(3)) {
            varType = lookup_arbitraryTypeByName();
          } else {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case TYPE:
              jj_consume_token(TYPE);
                varType = ConstantTypes.TYPE_REFERENCE_TYPE;
              break;
            default:
              jj_la1[187] = jj_gen;
              jj_consume_token(-1);
              throw new ParseException();
            }
          }
          break;
        default:
          jj_la1[188] = jj_gen;
          ;
        }
        jj_consume_token(IN);
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case LBRACE:
          SetExpression(thisNodeScope);
          break;
        case IDENTIFIER:
          Reference(thisNodeScope);
          break;
        default:
          jj_la1[189] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
        jj_consume_token(BIT_OR);
        DesignRuleExpression(thisNodeScope);
      jjtree.closeNodeScope(jjtn000,  2);
      jjtc000 = false;
        // fill in the meaning of the quantified expression node.
        // Child(0) is the set expression,
        // Child(1) is the expression to evaluate
        QuantifiedExpressionNode tmpNode = (QuantifiedExpressionNode) jjtree.peekNode();
        tmpNode.setSatisfies (declares == null);
        tmpNode.setVarName(varNameToken.image);
        tmpNode.setVarType(varType);
        tmpNode.setParentScope(curScope);
        tmpNode.setSetExpression((ExpressionNode) tmpNode.jjtGetChild(0));
        tmpNode.setEvalExpression((ExpressionNode) tmpNode.jjtGetChild(1));
        tmpNode.setQuantOp(quantOp);
      } catch (Throwable jjte000) {
    if (jjtc000) {
      jjtree.clearNodeScope(jjtn000);
      jjtc000 = false;
    } else {
      jjtree.popNode();
    }
    if (jjte000 instanceof RuntimeException) {
      {if (true) throw (RuntimeException)jjte000;}
    }
    if (jjte000 instanceof ParseException) {
      {if (true) throw (ParseException)jjte000;}
    }
    {if (true) throw (Error)jjte000;}
      } finally {
    if (jjtc000) {
      jjtree.closeNodeScope(jjtn000,  2);
    }
      }
    } finally {
      trace_return("QuantifiedExpression");
    }
  }

  static final public void BooleanExpression(Scope curScope) throws ParseException {
    trace_call("BooleanExpression");
    try {
      OrExpression(curScope);
      label_58:
      while (true) {
        if (jj_2_71(2)) {
          ;
        } else {
          break label_58;
        }
        jj_consume_token(AND);
                         BooleanExpressionNode jjtn001 = new BooleanExpressionNode(JJTBOOLEANEXPRESSIONNODE);
                         boolean jjtc001 = true;
                         jjtree.openNodeScope(jjtn001);
        try {
          OrExpression(curScope);
        } catch (Throwable jjte001) {
                         if (jjtc001) {
                           jjtree.clearNodeScope(jjtn001);
                           jjtc001 = false;
                         } else {
                           jjtree.popNode();
                         }
                         if (jjte001 instanceof RuntimeException) {
                           {if (true) throw (RuntimeException)jjte001;}
                         }
                         if (jjte001 instanceof ParseException) {
                           {if (true) throw (ParseException)jjte001;}
                         }
                         {if (true) throw (Error)jjte001;}
        } finally {
                         if (jjtc001) {
                           jjtree.closeNodeScope(jjtn001,  2);
                         }
        }
        ((ExpressionNode) jjtree.peekNode()).setOperator(
                    acmeLib.core.globals.ExpressionOperatorT.AND_OP);
      }
    } finally {
      trace_return("BooleanExpression");
    }
  }

  static final public void OrExpression(Scope curScope) throws ParseException {
    trace_call("OrExpression");
    try {
      ImpliesExpression(curScope);
      label_59:
      while (true) {
        if (jj_2_72(2)) {
          ;
        } else {
          break label_59;
        }
        jj_consume_token(OR);
                        BooleanExpressionNode jjtn001 = new BooleanExpressionNode(JJTBOOLEANEXPRESSIONNODE);
                        boolean jjtc001 = true;
                        jjtree.openNodeScope(jjtn001);
        try {
          ImpliesExpression(curScope);
        } catch (Throwable jjte001) {
                        if (jjtc001) {
                          jjtree.clearNodeScope(jjtn001);
                          jjtc001 = false;
                        } else {
                          jjtree.popNode();
                        }
                        if (jjte001 instanceof RuntimeException) {
                          {if (true) throw (RuntimeException)jjte001;}
                        }
                        if (jjte001 instanceof ParseException) {
                          {if (true) throw (ParseException)jjte001;}
                        }
                        {if (true) throw (Error)jjte001;}
        } finally {
                        if (jjtc001) {
                          jjtree.closeNodeScope(jjtn001,  2);
                        }
        }
        ((ExpressionNode) jjtree.peekNode()).setOperator(
                    acmeLib.core.globals.ExpressionOperatorT.OR_OP);
      }
    } finally {
      trace_return("OrExpression");
    }
  }

  static final public void ImpliesExpression(Scope curScope) throws ParseException {
    trace_call("ImpliesExpression");
    try {
      IffExpression(curScope);
      label_60:
      while (true) {
        if (jj_2_73(2)) {
          ;
        } else {
          break label_60;
        }
        jj_consume_token(IMPLIES);
                             BooleanExpressionNode jjtn001 = new BooleanExpressionNode(JJTBOOLEANEXPRESSIONNODE);
                             boolean jjtc001 = true;
                             jjtree.openNodeScope(jjtn001);
        try {
          IffExpression(curScope);
        } catch (Throwable jjte001) {
                             if (jjtc001) {
                               jjtree.clearNodeScope(jjtn001);
                               jjtc001 = false;
                             } else {
                               jjtree.popNode();
                             }
                             if (jjte001 instanceof RuntimeException) {
                               {if (true) throw (RuntimeException)jjte001;}
                             }
                             if (jjte001 instanceof ParseException) {
                               {if (true) throw (ParseException)jjte001;}
                             }
                             {if (true) throw (Error)jjte001;}
        } finally {
                             if (jjtc001) {
                               jjtree.closeNodeScope(jjtn001,  2);
                             }
        }
        ((ExpressionNode) jjtree.peekNode()).setOperator(
                    acmeLib.core.globals.ExpressionOperatorT.IMPLIES_OP);
      }
    } finally {
      trace_return("ImpliesExpression");
    }
  }

  static final public void IffExpression(Scope curScope) throws ParseException {
    trace_call("IffExpression");
    try {
      EqualityExpression(curScope);
      label_61:
      while (true) {
        if (jj_2_74(2)) {
          ;
        } else {
          break label_61;
        }
        jj_consume_token(IFF);
                         BooleanExpressionNode jjtn001 = new BooleanExpressionNode(JJTBOOLEANEXPRESSIONNODE);
                         boolean jjtc001 = true;
                         jjtree.openNodeScope(jjtn001);
        try {
          EqualityExpression(curScope);
        } catch (Throwable jjte001) {
                         if (jjtc001) {
                           jjtree.clearNodeScope(jjtn001);
                           jjtc001 = false;
                         } else {
                           jjtree.popNode();
                         }
                         if (jjte001 instanceof RuntimeException) {
                           {if (true) throw (RuntimeException)jjte001;}
                         }
                         if (jjte001 instanceof ParseException) {
                           {if (true) throw (ParseException)jjte001;}
                         }
                         {if (true) throw (Error)jjte001;}
        } finally {
                         if (jjtc001) {
                           jjtree.closeNodeScope(jjtn001,  2);
                         }
        }
        ((ExpressionNode) jjtree.peekNode()).setOperator(
                    acmeLib.core.globals.ExpressionOperatorT.IFF_OP);
      }
    } finally {
      trace_return("IffExpression");
    }
  }

  static final public void EqualityExpression(Scope curScope) throws ParseException {
    trace_call("EqualityExpression");
    try {
      RelationalExpression(curScope);
      label_62:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case EQ:
        case NE:
          ;
          break;
        default:
          jj_la1[190] = jj_gen;
          break label_62;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case EQ:
          jj_consume_token(EQ);
            BooleanExpressionNode jjtn001 = new BooleanExpressionNode(JJTBOOLEANEXPRESSIONNODE);
            boolean jjtc001 = true;
            jjtree.openNodeScope(jjtn001);
          try {
            RelationalExpression(curScope);
          } catch (Throwable jjte001) {
            if (jjtc001) {
              jjtree.clearNodeScope(jjtn001);
              jjtc001 = false;
            } else {
              jjtree.popNode();
            }
            if (jjte001 instanceof RuntimeException) {
              {if (true) throw (RuntimeException)jjte001;}
            }
            if (jjte001 instanceof ParseException) {
              {if (true) throw (ParseException)jjte001;}
            }
            {if (true) throw (Error)jjte001;}
          } finally {
            if (jjtc001) {
              jjtree.closeNodeScope(jjtn001,  2);
            }
          }
        ((ExpressionNode) jjtree.peekNode()).setOperator(
                    acmeLib.core.globals.ExpressionOperatorT.EQUALS_OP);
          break;
        case NE:
          jj_consume_token(NE);
            BooleanExpressionNode jjtn002 = new BooleanExpressionNode(JJTBOOLEANEXPRESSIONNODE);
            boolean jjtc002 = true;
            jjtree.openNodeScope(jjtn002);
          try {
            RelationalExpression(curScope);
          } catch (Throwable jjte002) {
            if (jjtc002) {
              jjtree.clearNodeScope(jjtn002);
              jjtc002 = false;
            } else {
              jjtree.popNode();
            }
            if (jjte002 instanceof RuntimeException) {
              {if (true) throw (RuntimeException)jjte002;}
            }
            if (jjte002 instanceof ParseException) {
              {if (true) throw (ParseException)jjte002;}
            }
            {if (true) throw (Error)jjte002;}
          } finally {
            if (jjtc002) {
              jjtree.closeNodeScope(jjtn002,  2);
            }
          }
        ((ExpressionNode) jjtree.peekNode()).setOperator(
                    acmeLib.core.globals.ExpressionOperatorT.NOT_EQUALS_OP);
          break;
        default:
          jj_la1[191] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
    } finally {
      trace_return("EqualityExpression");
    }
  }

  static final public void RelationalExpression(Scope curScope) throws ParseException {
    trace_call("RelationalExpression");
    try {
      AdditiveExpression(curScope);
      label_63:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case LANGLE:
        case RANGLE:
        case LE:
        case GE:
          ;
          break;
        default:
          jj_la1[192] = jj_gen;
          break label_63;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case LANGLE:
          jj_consume_token(LANGLE);
          BooleanExpressionNode jjtn001 = new BooleanExpressionNode(JJTBOOLEANEXPRESSIONNODE);
          boolean jjtc001 = true;
          jjtree.openNodeScope(jjtn001);
          try {
            AdditiveExpression(curScope);
          } catch (Throwable jjte001) {
          if (jjtc001) {
            jjtree.clearNodeScope(jjtn001);
            jjtc001 = false;
          } else {
            jjtree.popNode();
          }
          if (jjte001 instanceof RuntimeException) {
            {if (true) throw (RuntimeException)jjte001;}
          }
          if (jjte001 instanceof ParseException) {
            {if (true) throw (ParseException)jjte001;}
          }
          {if (true) throw (Error)jjte001;}
          } finally {
          if (jjtc001) {
            jjtree.closeNodeScope(jjtn001,  2);
          }
          }
        ((ExpressionNode) jjtree.peekNode()).setOperator(
                    acmeLib.core.globals.ExpressionOperatorT.LESS_THAN_OP);
          break;
        case RANGLE:
          jj_consume_token(RANGLE);
          BooleanExpressionNode jjtn002 = new BooleanExpressionNode(JJTBOOLEANEXPRESSIONNODE);
          boolean jjtc002 = true;
          jjtree.openNodeScope(jjtn002);
          try {
            AdditiveExpression(curScope);
          } catch (Throwable jjte002) {
          if (jjtc002) {
            jjtree.clearNodeScope(jjtn002);
            jjtc002 = false;
          } else {
            jjtree.popNode();
          }
          if (jjte002 instanceof RuntimeException) {
            {if (true) throw (RuntimeException)jjte002;}
          }
          if (jjte002 instanceof ParseException) {
            {if (true) throw (ParseException)jjte002;}
          }
          {if (true) throw (Error)jjte002;}
          } finally {
          if (jjtc002) {
            jjtree.closeNodeScope(jjtn002,  2);
          }
          }
        ((ExpressionNode) jjtree.peekNode()).setOperator(
                    acmeLib.core.globals.ExpressionOperatorT.GREATER_THAN_OP);
          break;
        case LE:
          jj_consume_token(LE);
           BooleanExpressionNode jjtn003 = new BooleanExpressionNode(JJTBOOLEANEXPRESSIONNODE);
           boolean jjtc003 = true;
           jjtree.openNodeScope(jjtn003);
          try {
            AdditiveExpression(curScope);
          } catch (Throwable jjte003) {
           if (jjtc003) {
             jjtree.clearNodeScope(jjtn003);
             jjtc003 = false;
           } else {
             jjtree.popNode();
           }
           if (jjte003 instanceof RuntimeException) {
             {if (true) throw (RuntimeException)jjte003;}
           }
           if (jjte003 instanceof ParseException) {
             {if (true) throw (ParseException)jjte003;}
           }
           {if (true) throw (Error)jjte003;}
          } finally {
           if (jjtc003) {
             jjtree.closeNodeScope(jjtn003,  2);
           }
          }
        ((ExpressionNode) jjtree.peekNode()).setOperator(
                    acmeLib.core.globals.ExpressionOperatorT.LESS_OR_EQUAL_OP);
          break;
        case GE:
          jj_consume_token(GE);
           BooleanExpressionNode jjtn004 = new BooleanExpressionNode(JJTBOOLEANEXPRESSIONNODE);
           boolean jjtc004 = true;
           jjtree.openNodeScope(jjtn004);
          try {
            AdditiveExpression(curScope);
          } catch (Throwable jjte004) {
           if (jjtc004) {
             jjtree.clearNodeScope(jjtn004);
             jjtc004 = false;
           } else {
             jjtree.popNode();
           }
           if (jjte004 instanceof RuntimeException) {
             {if (true) throw (RuntimeException)jjte004;}
           }
           if (jjte004 instanceof ParseException) {
             {if (true) throw (ParseException)jjte004;}
           }
           {if (true) throw (Error)jjte004;}
          } finally {
           if (jjtc004) {
             jjtree.closeNodeScope(jjtn004,  2);
           }
          }
        ((ExpressionNode) jjtree.peekNode()).setOperator(
                    acmeLib.core.globals.ExpressionOperatorT.GREATER_OR_EQUAL_OP);
          break;
        default:
          jj_la1[193] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
    } finally {
      trace_return("RelationalExpression");
    }
  }

  static final public void AdditiveExpression(Scope curScope) throws ParseException {
    trace_call("AdditiveExpression");
    try {
      MultiplicativeExpression(curScope);
      label_64:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case PLUS:
        case MINUS:
          ;
          break;
        default:
          jj_la1[194] = jj_gen;
          break label_64;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case PLUS:
          jj_consume_token(PLUS);
             NumericExpressionNode jjtn001 = new NumericExpressionNode(JJTNUMERICEXPRESSIONNODE);
             boolean jjtc001 = true;
             jjtree.openNodeScope(jjtn001);
          try {
            MultiplicativeExpression(curScope);
          } catch (Throwable jjte001) {
             if (jjtc001) {
               jjtree.clearNodeScope(jjtn001);
               jjtc001 = false;
             } else {
               jjtree.popNode();
             }
             if (jjte001 instanceof RuntimeException) {
               {if (true) throw (RuntimeException)jjte001;}
             }
             if (jjte001 instanceof ParseException) {
               {if (true) throw (ParseException)jjte001;}
             }
             {if (true) throw (Error)jjte001;}
          } finally {
             if (jjtc001) {
               jjtree.closeNodeScope(jjtn001,  2);
             }
          }
        ((ExpressionNode) jjtree.peekNode()).setOperator(
               acmeLib.core.globals.ExpressionOperatorT.PLUS_OP);
          break;
        case MINUS:
          jj_consume_token(MINUS);
              NumericExpressionNode jjtn002 = new NumericExpressionNode(JJTNUMERICEXPRESSIONNODE);
              boolean jjtc002 = true;
              jjtree.openNodeScope(jjtn002);
          try {
            MultiplicativeExpression(curScope);
          } catch (Throwable jjte002) {
              if (jjtc002) {
                jjtree.clearNodeScope(jjtn002);
                jjtc002 = false;
              } else {
                jjtree.popNode();
              }
              if (jjte002 instanceof RuntimeException) {
                {if (true) throw (RuntimeException)jjte002;}
              }
              if (jjte002 instanceof ParseException) {
                {if (true) throw (ParseException)jjte002;}
              }
              {if (true) throw (Error)jjte002;}
          } finally {
              if (jjtc002) {
                jjtree.closeNodeScope(jjtn002,  2);
              }
          }
        ((ExpressionNode) jjtree.peekNode()).setOperator(
               acmeLib.core.globals.ExpressionOperatorT.MINUS_OP);
          break;
        default:
          jj_la1[195] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
    } finally {
      trace_return("AdditiveExpression");
    }
  }

  static final public void MultiplicativeExpression(Scope curScope) throws ParseException {
    trace_call("MultiplicativeExpression");
    try {
      UnaryExpression(curScope);
      label_65:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case STAR:
        case SLASH:
        case REM:
          ;
          break;
        default:
          jj_la1[196] = jj_gen;
          break label_65;
        }
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case STAR:
          jj_consume_token(STAR);
             NumericExpressionNode jjtn001 = new NumericExpressionNode(JJTNUMERICEXPRESSIONNODE);
             boolean jjtc001 = true;
             jjtree.openNodeScope(jjtn001);
          try {
            UnaryExpression(curScope);
          } catch (Throwable jjte001) {
             if (jjtc001) {
               jjtree.clearNodeScope(jjtn001);
               jjtc001 = false;
             } else {
               jjtree.popNode();
             }
             if (jjte001 instanceof RuntimeException) {
               {if (true) throw (RuntimeException)jjte001;}
             }
             if (jjte001 instanceof ParseException) {
               {if (true) throw (ParseException)jjte001;}
             }
             {if (true) throw (Error)jjte001;}
          } finally {
             if (jjtc001) {
               jjtree.closeNodeScope(jjtn001,  2);
             }
          }
        ((ExpressionNode) jjtree.peekNode()).setOperator(
               acmeLib.core.globals.ExpressionOperatorT.MULT_OP);
          break;
        case SLASH:
          jj_consume_token(SLASH);
              NumericExpressionNode jjtn002 = new NumericExpressionNode(JJTNUMERICEXPRESSIONNODE);
              boolean jjtc002 = true;
              jjtree.openNodeScope(jjtn002);
          try {
            UnaryExpression(curScope);
          } catch (Throwable jjte002) {
              if (jjtc002) {
                jjtree.clearNodeScope(jjtn002);
                jjtc002 = false;
              } else {
                jjtree.popNode();
              }
              if (jjte002 instanceof RuntimeException) {
                {if (true) throw (RuntimeException)jjte002;}
              }
              if (jjte002 instanceof ParseException) {
                {if (true) throw (ParseException)jjte002;}
              }
              {if (true) throw (Error)jjte002;}
          } finally {
              if (jjtc002) {
                jjtree.closeNodeScope(jjtn002,  2);
              }
          }
        ((ExpressionNode) jjtree.peekNode()).setOperator(
               acmeLib.core.globals.ExpressionOperatorT.DIVIDE_OP);
          break;
        case REM:
          jj_consume_token(REM);
            NumericExpressionNode jjtn003 = new NumericExpressionNode(JJTNUMERICEXPRESSIONNODE);
            boolean jjtc003 = true;
            jjtree.openNodeScope(jjtn003);
          try {
            UnaryExpression(curScope);
          } catch (Throwable jjte003) {
            if (jjtc003) {
              jjtree.clearNodeScope(jjtn003);
              jjtc003 = false;
            } else {
              jjtree.popNode();
            }
            if (jjte003 instanceof RuntimeException) {
              {if (true) throw (RuntimeException)jjte003;}
            }
            if (jjte003 instanceof ParseException) {
              {if (true) throw (ParseException)jjte003;}
            }
            {if (true) throw (Error)jjte003;}
          } finally {
            if (jjtc003) {
              jjtree.closeNodeScope(jjtn003,  2);
            }
          }
        ((ExpressionNode) jjtree.peekNode()).setOperator(
               acmeLib.core.globals.ExpressionOperatorT.MODULO_OP);
          break;
        default:
          jj_la1[197] = jj_gen;
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
    } finally {
      trace_return("MultiplicativeExpression");
    }
  }

  static final public void UnaryExpression(Scope curScope) throws ParseException {
    trace_call("UnaryExpression");
    try {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case BANG:
        jj_consume_token(BANG);
             BooleanExpressionNode jjtn001 = new BooleanExpressionNode(JJTBOOLEANEXPRESSIONNODE);
             boolean jjtc001 = true;
             jjtree.openNodeScope(jjtn001);
        try {
          UnaryExpression(curScope);
        } catch (Throwable jjte001) {
             if (jjtc001) {
               jjtree.clearNodeScope(jjtn001);
               jjtc001 = false;
             } else {
               jjtree.popNode();
             }
             if (jjte001 instanceof RuntimeException) {
               {if (true) throw (RuntimeException)jjte001;}
             }
             if (jjte001 instanceof ParseException) {
               {if (true) throw (ParseException)jjte001;}
             }
             {if (true) throw (Error)jjte001;}
        } finally {
             if (jjtc001) {
               jjtree.closeNodeScope(jjtn001,  1);
             }
        }
        ((ExpressionNode) jjtree.peekNode()).setOperator(
                    acmeLib.core.globals.ExpressionOperatorT.NOT_OP);
        break;
      case MINUS:
        jj_consume_token(MINUS);
              NumericExpressionNode jjtn002 = new NumericExpressionNode(JJTNUMERICEXPRESSIONNODE);
              boolean jjtc002 = true;
              jjtree.openNodeScope(jjtn002);
        try {
          UnaryExpression(curScope);
        } catch (Throwable jjte002) {
              if (jjtc002) {
                jjtree.clearNodeScope(jjtn002);
                jjtc002 = false;
              } else {
                jjtree.popNode();
              }
              if (jjte002 instanceof RuntimeException) {
                {if (true) throw (RuntimeException)jjte002;}
              }
              if (jjte002 instanceof ParseException) {
                {if (true) throw (ParseException)jjte002;}
              }
              {if (true) throw (Error)jjte002;}
        } finally {
              if (jjtc002) {
                jjtree.closeNodeScope(jjtn002,  1);
              }
        }
        ((ExpressionNode) jjtree.peekNode()).setOperator(
                    acmeLib.core.globals.ExpressionOperatorT.UNARY_MINUS_OP);
        break;
      case SYSTEM:
      case COMPONENT:
      case GROUP:
      case CONNECTOR:
      case PORT:
      case ROLE:
      case ELEMENT:
      case PROPERTY:
      case FLOAT:
      case INT:
      case STRING:
      case BOOLEAN:
      case SET:
      case SEQUENCE:
      case RECORD:
      case ENUM:
      case TRUE:
      case FALSE:
      case INTEGER_LITERAL:
      case FLOATING_POINT_LITERAL:
      case STRING_LITERAL:
      case IDENTIFIER:
      case LPAREN:
      case LBRACE:
        PrimitiveExpression(curScope);
        break;
      default:
        jj_la1[198] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    } finally {
      trace_return("UnaryExpression");
    }
  }

  static final public void PrimitiveExpression(Scope curScope) throws ParseException {
    trace_call("PrimitiveExpression");
    try {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LPAREN:
        jj_consume_token(LPAREN);
        DesignRuleExpression(curScope);
        jj_consume_token(RPAREN);
        ((ExpressionNode) jjtree.peekNode()).setInParentheses(true);
        break;
      case SYSTEM:
      case COMPONENT:
      case GROUP:
      case CONNECTOR:
      case PORT:
      case ROLE:
      case ELEMENT:
      case PROPERTY:
      case FLOAT:
      case INT:
      case STRING:
      case BOOLEAN:
      case SET:
      case SEQUENCE:
      case RECORD:
      case ENUM:
      case TRUE:
      case FALSE:
      case INTEGER_LITERAL:
      case FLOATING_POINT_LITERAL:
      case STRING_LITERAL:
        LiteralConstant(curScope);
        break;
      case IDENTIFIER:
        Reference(curScope);
        break;
      case LBRACE:
        SetExpression(curScope);
        break;
      default:
        jj_la1[199] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    } finally {
      trace_return("PrimitiveExpression");
    }
  }

  static final public void Reference(Scope curScope) throws ParseException {
    trace_call("Reference");
    try {
    Token curToken;
    StringBuffer buf = new StringBuffer();
    boolean isPureIdentifier = true;   // flag to distinguish between
                                       // IdentifierNode (if true)
                                       // from DesignAnalysisNode and
                                       // SetReferenceNode (if false)
    boolean isSetReference = false;
    String keyword = null;
    int keywordsParsed = 0;
    AcmeType setType = ConstantTypes.UNRESOLVED_TYPE;
      curToken = jj_consume_token(IDENTIFIER);
        buf.setLength(0);
        buf.append(curToken.image);
      label_66:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case DOT:
          ;
          break;
        default:
          jj_la1[200] = jj_gen;
          break label_66;
        }
        if (jj_2_75(2)) {
          jj_consume_token(DOT);
          curToken = jj_consume_token(IDENTIFIER);
            buf.append(".");
            buf.append(curToken.image);
        } else if (jj_2_76(2)) {
          jj_consume_token(DOT);
          curToken = jj_consume_token(TYPE);
            buf.append(".");
            buf.append(curToken.image);
            keywordsParsed++;
        } else if (jj_2_77(2)) {
          jj_consume_token(DOT);
          curToken = jj_consume_token(COMPONENTS);
            if (keywordsParsed == 0) {
                buf.append(".");
                buf.append(curToken.image);
                isPureIdentifier = false;
                isSetReference = true;
                keywordsParsed++;
                setType = ConstantTypes.COMPONENT_BASE_TYPE;
            } else {
                {if (true) throw createArmaniParseException ( "Attempted to add the set reference \"components\" to a "                    + "reference that includes a previous set reference.");}
            }
        } else if (jj_2_78(2)) {
          jj_consume_token(DOT);
          curToken = jj_consume_token(CONNECTORS);
            if (keywordsParsed == 0) {
                buf.append(".");
                buf.append(curToken.image);
                isPureIdentifier = false;
                isSetReference = true;
                keywordsParsed++;
                setType = ConstantTypes.CONNECTOR_BASE_TYPE;
            } else {
                {if (true) throw createArmaniParseException ( "attempted to add the set reference \"connectors\" to a "                    + "reference that includes a previous set reference.");}
            }
        } else if (jj_2_79(2)) {
          jj_consume_token(DOT);
          curToken = jj_consume_token(PORTS);
            if (keywordsParsed == 0) {
                buf.append(".");
                buf.append(curToken.image);
                isPureIdentifier = false;
                isSetReference = true;
                keywordsParsed++;
                setType = ConstantTypes.PORT_BASE_TYPE;
            } else {
               {if (true) throw createArmaniParseException ("Attempted to add the set reference \"ports\" to a "                    + "reference that includes a previous set reference.");}
            }
        } else if (jj_2_80(2)) {
          jj_consume_token(DOT);
          curToken = jj_consume_token(ROLES);
            if (keywordsParsed == 0) {
                buf.append(".");
                buf.append(curToken.image);
                isPureIdentifier = false;
                isSetReference = true;
                keywordsParsed++;
                setType = ConstantTypes.ROLE_BASE_TYPE;
            } else {
                {if (true) throw createArmaniParseException ("Attempted to add the set reference \"roles\" to a "                    + "reference that includes a previous set reference.");}
            }
        } else if (jj_2_81(2)) {
          jj_consume_token(DOT);
          curToken = jj_consume_token(MEMBERS);
            if (keywordsParsed == 0) {
                buf.append(".");
                buf.append(curToken.image);
                isPureIdentifier = false;
                isSetReference = true;
                keywordsParsed++;
                setType = ConstantTypes.ELEMENT_BASE_TYPE;
            } else {
                {if (true) throw createArmaniParseException ("Attempted to add the set reference \"elements\" to a "                    + "reference that includes a previous set reference.");}
            }
        } else if (jj_2_82(2)) {
          jj_consume_token(DOT);
          curToken = jj_consume_token(PROPERTIES);
            if (keywordsParsed == 0) {
                buf.append(".");
                buf.append(curToken.image);
                isPureIdentifier = false;
                isSetReference = true;
                keywordsParsed++;
                setType = ConstantTypes.PROPERTY_REFERENCE_TYPE;
            } else {
               {if (true) throw createArmaniParseException ("Attempted to add the set reference \"properties\" to a "                    + "reference that includes a previous set reference.");}
            }
        } else if (jj_2_83(2)) {
          jj_consume_token(DOT);
          curToken = jj_consume_token(REPRESENTATIONS);
            if (keywordsParsed == 0) {
                buf.append(".");
                buf.append(curToken.image);
                isPureIdentifier = false;
                isSetReference = true;
                keywordsParsed++;
                setType = ConstantTypes.REPRESENTATION_REFERENCE_TYPE;
            } else {
                {if (true) throw createArmaniParseException ("Attempted to add the set reference \"representations\" to a "                    + "reference that includes a previous set reference.");}
            }
        } else if (jj_2_84(2)) {
          jj_consume_token(DOT);
          curToken = jj_consume_token(ATTACHEDPORTS);
            if (keywordsParsed == 0) {
              buf.append (".");
              buf.append (curToken.image);
              isPureIdentifier = false;
              isSetReference = true;
              keywordsParsed++;
              setType = ConstantTypes.PORT_BASE_TYPE;
            }
            else {
              {if (true) throw createArmaniParseException ("Attempted to add the set reference \"attachedPorts\" to a " +                                                                          "reference that includes a previous set reference.");}
            }
        } else if (jj_2_85(2)) {
          jj_consume_token(DOT);
          curToken = jj_consume_token(ATTACHEDROLES);
            if (keywordsParsed == 0) {
              buf.append (".");
              buf.append (curToken.image);
              isPureIdentifier = false;
              isSetReference = true;
              keywordsParsed++;
              setType = ConstantTypes.ROLE_BASE_TYPE;
            }
            else {
              {if (true) throw createArmaniParseException ("Attempted to add the set reference \"attachedRoles\" to a " +                                                                          "reference that includes a previous set reference.");}
            }
        } else {
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LPAREN:
        jj_consume_token(LPAREN);
              DesignAnalysisCallNode jjtn001 = new DesignAnalysisCallNode(JJTDESIGNANALYSISCALLNODE);
              boolean jjtc001 = true;
              jjtree.openNodeScope(jjtn001);
        try {
          ActualParams(curScope);
        } catch (Throwable jjte001) {
              if (jjtc001) {
                jjtree.clearNodeScope(jjtn001);
                jjtc001 = false;
              } else {
                jjtree.popNode();
              }
              if (jjte001 instanceof RuntimeException) {
                {if (true) throw (RuntimeException)jjte001;}
              }
              if (jjte001 instanceof ParseException) {
                {if (true) throw (ParseException)jjte001;}
              }
              {if (true) throw (Error)jjte001;}
        } finally {
              if (jjtc001) {
                jjtree.closeNodeScope(jjtn001, true);
              }
        }
        jj_consume_token(RPAREN);
            // flag that this node is a DesignAnalysisCallNode rather than
            // a pure identifier, so that the conditional node creation that
            // follows will not be invoked.
            isPureIdentifier = false;
        break;
      default:
        jj_la1[201] = jj_gen;
        ;
      }
        // if we get to here we may have a DesignAnalysisCallNode on the top of
        // the stack.  If we have not created a DesignAnalysisCallNode then
        // isPureIdentifier will still be true, and we need to create an
        // IdentifierNode to put on the stack by hand.
        if (isPureIdentifier) {
            IdentifierNode inode = (IdentifierNode)
                IdentifierNode.jjtCreate(ArmaniParserTreeConstants.JJTIDENTIFIERNODE);
            jjtree.openNodeScope(inode);
            jjtree.closeNodeScope(inode,true);
            /* obsolete methods
            jjtree.openIndefiniteNode(IdentifierNode.jjtCreate(ArmaniParserTreeConstants.JJTIDENTIFIERNODE));
            jjtree.closeIndefiniteNode();
            jjtree.updateCurrentNode(1);*/
        }

        else if (isSetReference) {
            // then add a set reference to the stack, rather than an IdentifierNode
            // or a DesignAnalysisCallNode.
            SetReferenceNode newSetNode = (SetReferenceNode)
                            SetReferenceNode.jjtCreate(ArmaniParserTreeConstants.JJTSETREFERENCENODE);
            newSetNode.setSetType(setType);
            jjtree.openNodeScope(newSetNode);
            jjtree.closeNodeScope(newSetNode,true);
            /* obsolete methods
            jjtree.openIndefiniteNode(newSetNode);
            jjtree.closeIndefiniteNode();
            jjtree.updateCurrentNode(1);
            */
        }

        // the node on the top of the stack should now be an IdentifierNode,
        // a SetReferenceNode, or a DesignAnalysisCallNode.  Fetch it and
        // set its identifier and reference scope.
        ReferenceNode tmpNode = (ReferenceNode) jjtree.peekNode();
        tmpNode.setIdentifier(buf.toString());
        tmpNode.setReferenceScope(curScope);
    } finally {
      trace_return("Reference");
    }
  }

  static final public void JavaMethodCallExpr(Scope curScope) throws ParseException {
    trace_call("JavaMethodCallExpr");
    try {
 /*@bgen(jjtree) JavaMethodCallNode */
    JavaMethodCallNode jjtn000 = new JavaMethodCallNode(JJTJAVAMETHODCALLNODE);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);Token t;
    StringBuffer buf = new StringBuffer();
    JavaMethodCallNode tmpNode = null;
      try {
        t = jj_consume_token(IDENTIFIER);
        buf.setLength(0);
        buf.append(t.image);
        label_67:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case DOT:
            ;
            break;
          default:
            jj_la1[202] = jj_gen;
            break label_67;
          }
          jj_consume_token(DOT);
          t = jj_consume_token(IDENTIFIER);
          buf.append(".");
          buf.append(t.image);
        }
        jj_consume_token(LPAREN);
        ActualParams(curScope);
        jj_consume_token(RPAREN);
      jjtree.closeNodeScope(jjtn000, true);
      jjtc000 = false;
        // set the name and scope of this design analysis call.
        // ReferenceNode.refreshReferentObject() should fill in the rest...
        // there's a bug because of the incompatibility between jjtree 0.2.5 and 1.0
        // an ugly hack to fix the bug: jjtn000 is the node we want
        // the name is generated by jjtree and might change in a future version of jjtree
        jjtn000.setIdentifier(buf.toString());
        jjtn000.setReferenceScope(curScope);
        /*
        tmpNode = (JavaMethodCallNode) jjtree.peekNode();
        tmpNode.setIdentifier(buf.toString());
        tmpNode.setReferenceScope(curScope);
        */

      } catch (Throwable jjte000) {
      if (jjtc000) {
        jjtree.clearNodeScope(jjtn000);
        jjtc000 = false;
      } else {
        jjtree.popNode();
      }
      if (jjte000 instanceof RuntimeException) {
        {if (true) throw (RuntimeException)jjte000;}
      }
      if (jjte000 instanceof ParseException) {
        {if (true) throw (ParseException)jjte000;}
      }
      {if (true) throw (Error)jjte000;}
      } finally {
      if (jjtc000) {
        jjtree.closeNodeScope(jjtn000, true);
      }
      }
    } finally {
      trace_return("JavaMethodCallExpr");
    }
  }

  static final public void LiteralConstant(Scope curScope) throws ParseException {
    trace_call("LiteralConstant");
    try {
   Token t;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case INTEGER_LITERAL:
      IntLiteralNode jjtn001 = new IntLiteralNode(JJTINTLITERALNODE);
      boolean jjtc001 = true;
      jjtree.openNodeScope(jjtn001);
        try {
          t = jj_consume_token(INTEGER_LITERAL);
          jjtree.closeNodeScope(jjtn001, true);
          jjtc001 = false;
           jjtn001.setValue(Integer.parseInt(t.image));
        } finally {
      if (jjtc001) {
        jjtree.closeNodeScope(jjtn001, true);
      }
        }
        break;
      case FLOATING_POINT_LITERAL:
      FloatLiteralNode jjtn002 = new FloatLiteralNode(JJTFLOATLITERALNODE);
      boolean jjtc002 = true;
      jjtree.openNodeScope(jjtn002);
        try {
          t = jj_consume_token(FLOATING_POINT_LITERAL);
          jjtree.closeNodeScope(jjtn002, true);
          jjtc002 = false;
           jjtn002.setValue(Float.valueOf(t.image).floatValue());
        } finally {
      if (jjtc002) {
        jjtree.closeNodeScope(jjtn002, true);
      }
        }
        break;
      case STRING_LITERAL:
      StringLiteralNode jjtn003 = new StringLiteralNode(JJTSTRINGLITERALNODE);
      boolean jjtc003 = true;
      jjtree.openNodeScope(jjtn003);
        try {
          t = jj_consume_token(STRING_LITERAL);
          jjtree.closeNodeScope(jjtn003, true);
          jjtc003 = false;
           jjtn003.setValue(AcmeString.massageForInternalStorage(t.image));
        } finally {
      if (jjtc003) {
        jjtree.closeNodeScope(jjtn003, true);
      }
        }
        break;
      case TRUE:
      BooleanLiteralNode jjtn004 = new BooleanLiteralNode(JJTBOOLEANLITERALNODE);
      boolean jjtc004 = true;
      jjtree.openNodeScope(jjtn004);
        try {
          t = jj_consume_token(TRUE);
          jjtree.closeNodeScope(jjtn004, true);
          jjtc004 = false;
           jjtn004.setValue(true);
        } finally {
      if (jjtc004) {
        jjtree.closeNodeScope(jjtn004, true);
      }
        }
        break;
      case FALSE:
      BooleanLiteralNode jjtn005 = new BooleanLiteralNode(JJTBOOLEANLITERALNODE);
      boolean jjtc005 = true;
      jjtree.openNodeScope(jjtn005);
        try {
          t = jj_consume_token(FALSE);
          jjtree.closeNodeScope(jjtn005, true);
          jjtc005 = false;
           jjtn005.setValue(false);
        } finally {
      if (jjtc005) {
        jjtree.closeNodeScope(jjtn005, true);
      }
        }
        break;
      case COMPONENT:
      IdentifierNode jjtn006 = new IdentifierNode(JJTIDENTIFIERNODE);
      boolean jjtc006 = true;
      jjtree.openNodeScope(jjtn006);
        try {
          t = jj_consume_token(COMPONENT);
          jjtree.closeNodeScope(jjtn006, true);
          jjtc006 = false;
            jjtn006.setReferenceScope(curScope);
            jjtn006.setIdentifier(t.image);
            jjtn006.setIsVolatile(false);
            jjtn006.setReferentObject(ConstantTypes.COMPONENT_BASE_TYPE);
            jjtn006.setType(ConstantTypes.TYPE_REFERENCE_TYPE);
            jjtn006.setNeverRefresh(true);
        } finally {
      if (jjtc006) {
        jjtree.closeNodeScope(jjtn006, true);
      }
        }
        break;
      case GROUP:
      IdentifierNode jjtn007 = new IdentifierNode(JJTIDENTIFIERNODE);
      boolean jjtc007 = true;
      jjtree.openNodeScope(jjtn007);
        try {
          t = jj_consume_token(GROUP);
          jjtree.closeNodeScope(jjtn007, true);
          jjtc007 = false;
            jjtn007.setReferenceScope(curScope);
            jjtn007.setIdentifier(t.image);
            jjtn007.setIsVolatile(false);
            jjtn007.setReferentObject(ConstantTypes.GROUP_BASE_TYPE);
            jjtn007.setType(ConstantTypes.TYPE_REFERENCE_TYPE);
            jjtn007.setNeverRefresh(true);
        } finally {
      if (jjtc007) {
        jjtree.closeNodeScope(jjtn007, true);
      }
        }
        break;
      case CONNECTOR:
      IdentifierNode jjtn008 = new IdentifierNode(JJTIDENTIFIERNODE);
      boolean jjtc008 = true;
      jjtree.openNodeScope(jjtn008);
        try {
          t = jj_consume_token(CONNECTOR);
          jjtree.closeNodeScope(jjtn008, true);
          jjtc008 = false;
            jjtn008.setReferenceScope(curScope);
            jjtn008.setIdentifier(t.image);
            jjtn008.setIsVolatile(false);
            jjtn008.setReferentObject(ConstantTypes.CONNECTOR_BASE_TYPE);
            jjtn008.setType(ConstantTypes.TYPE_REFERENCE_TYPE);
            jjtn008.setNeverRefresh(true);
        } finally {
      if (jjtc008) {
        jjtree.closeNodeScope(jjtn008, true);
      }
        }
        break;
      case PORT:
      IdentifierNode jjtn009 = new IdentifierNode(JJTIDENTIFIERNODE);
      boolean jjtc009 = true;
      jjtree.openNodeScope(jjtn009);
        try {
          t = jj_consume_token(PORT);
          jjtree.closeNodeScope(jjtn009, true);
          jjtc009 = false;
            jjtn009.setReferenceScope(curScope);
            jjtn009.setIdentifier(t.image);
            jjtn009.setIsVolatile(false);
            jjtn009.setReferentObject(ConstantTypes.PORT_BASE_TYPE);
            jjtn009.setType(ConstantTypes.TYPE_REFERENCE_TYPE);
            jjtn009.setNeverRefresh(true);
        } finally {
      if (jjtc009) {
        jjtree.closeNodeScope(jjtn009, true);
      }
        }
        break;
      case ROLE:
      IdentifierNode jjtn010 = new IdentifierNode(JJTIDENTIFIERNODE);
      boolean jjtc010 = true;
      jjtree.openNodeScope(jjtn010);
        try {
          t = jj_consume_token(ROLE);
          jjtree.closeNodeScope(jjtn010, true);
          jjtc010 = false;
            jjtn010.setReferenceScope(curScope);
            jjtn010.setIdentifier(t.image);
            jjtn010.setIsVolatile(false);
            jjtn010.setReferentObject(ConstantTypes.ROLE_BASE_TYPE);
            jjtn010.setType(ConstantTypes.TYPE_REFERENCE_TYPE);
            jjtn010.setNeverRefresh(true);
        } finally {
      if (jjtc010) {
        jjtree.closeNodeScope(jjtn010, true);
      }
        }
        break;
      case SYSTEM:
      IdentifierNode jjtn011 = new IdentifierNode(JJTIDENTIFIERNODE);
      boolean jjtc011 = true;
      jjtree.openNodeScope(jjtn011);
        try {
          t = jj_consume_token(SYSTEM);
          jjtree.closeNodeScope(jjtn011, true);
          jjtc011 = false;
            jjtn011.setReferenceScope(curScope);
            jjtn011.setIdentifier(t.image);
            jjtn011.setIsVolatile(false);
            jjtn011.setReferentObject(ConstantTypes.SYSTEM_BASE_TYPE);
            jjtn011.setType(ConstantTypes.TYPE_REFERENCE_TYPE);
            jjtn011.setNeverRefresh(true);
        } finally {
      if (jjtc011) {
        jjtree.closeNodeScope(jjtn011, true);
      }
        }
        break;
      case ELEMENT:
      IdentifierNode jjtn012 = new IdentifierNode(JJTIDENTIFIERNODE);
      boolean jjtc012 = true;
      jjtree.openNodeScope(jjtn012);
        try {
          t = jj_consume_token(ELEMENT);
          jjtree.closeNodeScope(jjtn012, true);
          jjtc012 = false;
            jjtn012.setReferenceScope(curScope);
            jjtn012.setIdentifier(t.image);
            jjtn012.setIsVolatile(false);
            jjtn012.setReferentObject(ConstantTypes.ELEMENT_BASE_TYPE);
            jjtn012.setType(ConstantTypes.TYPE_REFERENCE_TYPE);
            jjtn012.setNeverRefresh(true);
        } finally {
      if (jjtc012) {
        jjtree.closeNodeScope(jjtn012, true);
      }
        }
        break;
      case PROPERTY:
      IdentifierNode jjtn013 = new IdentifierNode(JJTIDENTIFIERNODE);
      boolean jjtc013 = true;
      jjtree.openNodeScope(jjtn013);
        try {
          t = jj_consume_token(PROPERTY);
          jjtree.closeNodeScope(jjtn013, true);
          jjtc013 = false;
            jjtn013.setReferenceScope(curScope);
            jjtn013.setIdentifier(t.image);
            jjtn013.setIsVolatile(false);
            jjtn013.setReferentObject(ConstantTypes.PROPERTY_REFERENCE_TYPE);
            jjtn013.setType(ConstantTypes.TYPE_REFERENCE_TYPE);
            jjtn013.setNeverRefresh(true);
        } finally {
      if (jjtc013) {
        jjtree.closeNodeScope(jjtn013, true);
      }
        }
        break;
      case INT:
      IdentifierNode jjtn014 = new IdentifierNode(JJTIDENTIFIERNODE);
      boolean jjtc014 = true;
      jjtree.openNodeScope(jjtn014);
        try {
          t = jj_consume_token(INT);
          jjtree.closeNodeScope(jjtn014, true);
          jjtc014 = false;
            jjtn014.setReferenceScope(curScope);
            jjtn014.setIdentifier(t.image);
            jjtn014.setIsVolatile(false);
            jjtn014.setReferentObject(ConstantTypes.INT_TYPE);
            jjtn014.setType(ConstantTypes.TYPE_REFERENCE_TYPE);
            jjtn014.setNeverRefresh(true);
        } finally {
      if (jjtc014) {
        jjtree.closeNodeScope(jjtn014, true);
      }
        }
        break;
      case FLOAT:
      IdentifierNode jjtn015 = new IdentifierNode(JJTIDENTIFIERNODE);
      boolean jjtc015 = true;
      jjtree.openNodeScope(jjtn015);
        try {
          t = jj_consume_token(FLOAT);
          jjtree.closeNodeScope(jjtn015, true);
          jjtc015 = false;
            jjtn015.setReferenceScope(curScope);
            jjtn015.setIdentifier(t.image);
            jjtn015.setIsVolatile(false);
            jjtn015.setReferentObject(ConstantTypes.FLOAT_TYPE);
            jjtn015.setType(ConstantTypes.TYPE_REFERENCE_TYPE);
            jjtn015.setNeverRefresh(true);
        } finally {
      if (jjtc015) {
        jjtree.closeNodeScope(jjtn015, true);
      }
        }
        break;
      case STRING:
      IdentifierNode jjtn016 = new IdentifierNode(JJTIDENTIFIERNODE);
      boolean jjtc016 = true;
      jjtree.openNodeScope(jjtn016);
        try {
          t = jj_consume_token(STRING);
          jjtree.closeNodeScope(jjtn016, true);
          jjtc016 = false;
            jjtn016.setReferenceScope(curScope);
            jjtn016.setIdentifier(t.image);
            jjtn016.setIsVolatile(false);
            jjtn016.setReferentObject(ConstantTypes.STRING_TYPE);
            jjtn016.setType(ConstantTypes.TYPE_REFERENCE_TYPE);
            jjtn016.setNeverRefresh(true);
        } finally {
      if (jjtc016) {
        jjtree.closeNodeScope(jjtn016, true);
      }
        }
        break;
      case BOOLEAN:
      IdentifierNode jjtn017 = new IdentifierNode(JJTIDENTIFIERNODE);
      boolean jjtc017 = true;
      jjtree.openNodeScope(jjtn017);
        try {
          t = jj_consume_token(BOOLEAN);
          jjtree.closeNodeScope(jjtn017, true);
          jjtc017 = false;
            jjtn017.setReferenceScope(curScope);
            jjtn017.setIdentifier(t.image);
            jjtn017.setIsVolatile(false);
            jjtn017.setReferentObject(ConstantTypes.BOOLEAN_TYPE);
            jjtn017.setType(ConstantTypes.TYPE_REFERENCE_TYPE);
            jjtn017.setNeverRefresh(true);
        } finally {
      if (jjtc017) {
        jjtree.closeNodeScope(jjtn017, true);
      }
        }
        break;
      case ENUM:
      IdentifierNode jjtn018 = new IdentifierNode(JJTIDENTIFIERNODE);
      boolean jjtc018 = true;
      jjtree.openNodeScope(jjtn018);
        try {
          t = jj_consume_token(ENUM);
          jjtree.closeNodeScope(jjtn018, true);
          jjtc018 = false;
            jjtn018.setReferenceScope(curScope);
            jjtn018.setIdentifier(t.image);
            jjtn018.setIsVolatile(false);
            jjtn018.setReferentObject(ConstantTypes.EMPTY_ENUM_TYPE);
            jjtn018.setType(ConstantTypes.TYPE_REFERENCE_TYPE);
            jjtn018.setNeverRefresh(true);
        } finally {
      if (jjtc018) {
        jjtree.closeNodeScope(jjtn018, true);
      }
        }
        break;
      case SET:
      IdentifierNode jjtn019 = new IdentifierNode(JJTIDENTIFIERNODE);
      boolean jjtc019 = true;
      jjtree.openNodeScope(jjtn019);
        try {
          t = jj_consume_token(SET);
          jjtree.closeNodeScope(jjtn019, true);
          jjtc019 = false;
            jjtn019.setReferenceScope(curScope);
            jjtn019.setIdentifier(t.image);
            jjtn019.setIsVolatile(false);
            jjtn019.setReferentObject(ConstantTypes.ANY_SET_TYPE);
            jjtn019.setType(ConstantTypes.TYPE_REFERENCE_TYPE);
            jjtn019.setNeverRefresh(true);
        } finally {
      if (jjtc019) {
        jjtree.closeNodeScope(jjtn019, true);
      }
        }
        break;
      case SEQUENCE:
      IdentifierNode jjtn020 = new IdentifierNode(JJTIDENTIFIERNODE);
      boolean jjtc020 = true;
      jjtree.openNodeScope(jjtn020);
        try {
          t = jj_consume_token(SEQUENCE);
          jjtree.closeNodeScope(jjtn020, true);
          jjtc020 = false;
            jjtn020.setReferenceScope(curScope);
            jjtn020.setIdentifier(t.image);
            jjtn020.setIsVolatile(false);
            jjtn020.setReferentObject(ConstantTypes.ANY_SEQUENCE_TYPE);
            jjtn020.setType(ConstantTypes.TYPE_REFERENCE_TYPE);
            jjtn020.setNeverRefresh(true);
        } finally {
      if (jjtc020) {
        jjtree.closeNodeScope(jjtn020, true);
      }
        }
        break;
      case RECORD:
      IdentifierNode jjtn021 = new IdentifierNode(JJTIDENTIFIERNODE);
      boolean jjtc021 = true;
      jjtree.openNodeScope(jjtn021);
        try {
          t = jj_consume_token(RECORD);
          jjtree.closeNodeScope(jjtn021, true);
          jjtc021 = false;
            jjtn021.setReferenceScope(curScope);
            jjtn021.setIdentifier(t.image);
            jjtn021.setIsVolatile(false);
            jjtn021.setReferentObject(ConstantTypes.ANY_RECORD_TYPE);
            jjtn021.setType(ConstantTypes.TYPE_REFERENCE_TYPE);
            jjtn021.setNeverRefresh(true);
        } finally {
      if (jjtc021) {
        jjtree.closeNodeScope(jjtn021, true);
      }
        }
        break;
      default:
        jj_la1[203] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    } finally {
      trace_return("LiteralConstant");
    }
  }

  static final public void ActualParams(Scope curScope) throws ParseException {
    trace_call("ActualParams");
    try {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case SYSTEM:
      case COMPONENT:
      case GROUP:
      case CONNECTOR:
      case PORT:
      case ROLE:
      case ELEMENT:
      case PROPERTY:
      case FLOAT:
      case INT:
      case STRING:
      case BOOLEAN:
      case SET:
      case SEQUENCE:
      case RECORD:
      case ENUM:
      case TRUE:
      case FALSE:
      case EXISTS:
      case FORALL:
      case INTEGER_LITERAL:
      case FLOATING_POINT_LITERAL:
      case STRING_LITERAL:
      case IDENTIFIER:
      case LPAREN:
      case LBRACE:
      case BANG:
      case MINUS:
        ActualParam(curScope);
        label_68:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMMA:
            ;
            break;
          default:
            jj_la1[204] = jj_gen;
            break label_68;
          }
          jj_consume_token(COMMA);
          ActualParam(curScope);
        }
        break;
      default:
        jj_la1[205] = jj_gen;
        ;
      }
    } finally {
      trace_return("ActualParams");
    }
  }

  static final public java.util.Vector FormalParams(Scope curScope) throws ParseException {
    trace_call("FormalParams");
    try {
    Token idToken;
    java.util.Vector paramVector = new java.util.Vector(1,1);
    java.util.Vector tmpVector;
    int cursor = 0;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IDENTIFIER:
        tmpVector = FormalParam(curScope);
            // transfer the parameter list in tmpVector to paramVector
            cursor = paramVector.size();
            for (int i = 0; i < tmpVector.size(); i++) {
                paramVector.insertElementAt(tmpVector.elementAt(i), cursor);
                cursor++;
            }
        label_69:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COMMA:
            ;
            break;
          default:
            jj_la1[206] = jj_gen;
            break label_69;
          }
          jj_consume_token(COMMA);
          tmpVector = FormalParam(curScope);
            // transfer the parameter list in tmpVector to paramVector
            cursor = paramVector.size();
            for (int i = 0; i < tmpVector.size(); i++) {
                paramVector.insertElementAt(tmpVector.elementAt(i), cursor);
                cursor++;
            }
        }
        break;
      default:
        jj_la1[207] = jj_gen;
        ;
      }
        {if (true) return paramVector;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("FormalParams");
    }
  }

  static final public void ActualParam(Scope curScope) throws ParseException {
    trace_call("ActualParam");
    try {
      DesignRuleExpression(curScope);
    } finally {
      trace_return("ActualParam");
    }
  }

/** FormalParam production */
  static final public java.util.Vector FormalParam(Scope curScope) throws ParseException {
    trace_call("FormalParam");
    try {
    java.util.Vector paramVector = new Vector();
    Token paramNameToken;
    Token typeNameToken;
    int vectorIndex = 0;
    AcmeType paramTypeObj = ConstantTypes.UNRESOLVED_TYPE;
    DesignRuleParameter newParam;
      // "ParamName (, ParamName)* : TypeName"
      
          // parse series of variable names.
          paramNameToken = jj_consume_token(IDENTIFIER);
        newParam = new DesignRuleParameter();
        newParam.setName(paramNameToken.image);
        paramVector.insertElementAt(newParam, vectorIndex);
        vectorIndex++;
      label_70:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[208] = jj_gen;
          break label_70;
        }
        jj_consume_token(COMMA);
        paramNameToken = jj_consume_token(IDENTIFIER);
            newParam = new DesignRuleParameter();
            newParam.setName(paramNameToken.image);
            paramVector.insertElementAt(newParam, vectorIndex);
            vectorIndex++;
      }
      jj_consume_token(COLON);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ELEMENT:
        typeNameToken = jj_consume_token(ELEMENT);
            paramTypeObj = acmeLib.core.globals.ConstantTypes.ELEMENT_BASE_TYPE;
        break;
      case SYSTEM:
        typeNameToken = jj_consume_token(SYSTEM);
            paramTypeObj = acmeLib.core.globals.ConstantTypes.SYSTEM_BASE_TYPE;
        break;
      case COMPONENT:
        typeNameToken = jj_consume_token(COMPONENT);
            paramTypeObj = acmeLib.core.globals.ConstantTypes.COMPONENT_BASE_TYPE;
        break;
      case CONNECTOR:
        typeNameToken = jj_consume_token(CONNECTOR);
            paramTypeObj = acmeLib.core.globals.ConstantTypes.CONNECTOR_BASE_TYPE;
        break;
      case PORT:
        typeNameToken = jj_consume_token(PORT);
            paramTypeObj = acmeLib.core.globals.ConstantTypes.PORT_BASE_TYPE;
        break;
      case ROLE:
        typeNameToken = jj_consume_token(ROLE);
            paramTypeObj = acmeLib.core.globals.ConstantTypes.ROLE_BASE_TYPE;
        break;
      case TYPE:
        typeNameToken = jj_consume_token(TYPE);
            paramTypeObj = acmeLib.core.globals.ConstantTypes.TYPE_REFERENCE_TYPE;
        break;
      case PROPERTY:
        typeNameToken = jj_consume_token(PROPERTY);
            paramTypeObj = acmeLib.core.globals.ConstantTypes.PROPERTY_REFERENCE_TYPE;
        break;
      case REPRESENTATION:
        typeNameToken = jj_consume_token(REPRESENTATION);
            paramTypeObj = acmeLib.core.globals.ConstantTypes.REPRESENTATION_REFERENCE_TYPE;
        break;
      default:
        jj_la1[209] = jj_gen;
        if (jj_2_86(3)) {
          paramTypeObj = NonPropertySetTypeExpression();
        } else if (jj_2_87(3)) {
          paramTypeObj = PropertyTypeDescription();
        } else {
          jj_consume_token(-1);
          throw new ParseException();
        }
      }
        // check to see if we retrieved an unresolved property type that was
        // prematurely declared a property type by the PropertyTypeDescription()
        // production (that declares all identifiers to be UnresolvedPropertyTypes)
        // instead of an arbitrary unresolved type.
        if (paramTypeObj instanceof AcmeUnresolvedPropertyType) {
            paramTypeObj = new AcmeUnresolvedType(paramTypeObj.getTypeName());
        }

        // for each of the design rule parameters created for this type,
        // set the paramTypeObj and paramTypeCategory to those for this type.
        DesignRuleParameter curParam;
        for (int i = 0; i < paramVector.size(); i++) {
            curParam = (DesignRuleParameter) paramVector.elementAt(i);
            curParam.setType(paramTypeObj);
        }


        {if (true) return paramVector;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("FormalParam");
    }
  }

  static final public AcmePropertyType NonPropertySetTypeExpression() throws ParseException {
    trace_call("NonPropertySetTypeExpression");
    try {
    SetType newSetType = new SetType(null);
      jj_consume_token(SET);
      jj_consume_token(LBRACE);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case ELEMENT:
        jj_consume_token(ELEMENT);
            newSetType.setSetType(acmeLib.core.globals.ConstantTypes.ELEMENT_BASE_TYPE);
        break;
      case SYSTEM:
        jj_consume_token(SYSTEM);
            newSetType.setSetType(acmeLib.core.globals.ConstantTypes.SYSTEM_BASE_TYPE);
        break;
      case COMPONENT:
        jj_consume_token(COMPONENT);
            newSetType.setSetType(acmeLib.core.globals.ConstantTypes.COMPONENT_BASE_TYPE);
        break;
      case CONNECTOR:
        jj_consume_token(CONNECTOR);
            newSetType.setSetType(acmeLib.core.globals.ConstantTypes.CONNECTOR_BASE_TYPE);
        break;
      case PORT:
        jj_consume_token(PORT);
            newSetType.setSetType(acmeLib.core.globals.ConstantTypes.PORT_BASE_TYPE);
        break;
      case ROLE:
        jj_consume_token(ROLE);
            newSetType.setSetType(acmeLib.core.globals.ConstantTypes.ROLE_BASE_TYPE);
        break;
      case TYPE:
        jj_consume_token(TYPE);
            newSetType.setSetType(acmeLib.core.globals.ConstantTypes.TYPE_REFERENCE_TYPE);
        break;
      case PROPERTY:
        jj_consume_token(PROPERTY);
            newSetType.setSetType(acmeLib.core.globals.ConstantTypes.PROPERTY_REFERENCE_TYPE);
        break;
      case REPRESENTATION:
        jj_consume_token(REPRESENTATION);
            newSetType.setSetType(acmeLib.core.globals.ConstantTypes.REPRESENTATION_REFERENCE_TYPE);
        break;
      default:
        jj_la1[210] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      jj_consume_token(RBRACE);
        {if (true) return newSetType;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("NonPropertySetTypeExpression");
    }
  }

  static final public void SetExpression(Scope curScope) throws ParseException {
    trace_call("SetExpression");
    try {
      if (jj_2_88(2)) {
        LiteralSet(curScope);
      } else if (jj_2_89(2)) {
        SetConstructor(curScope);
      } else {
        jj_consume_token(-1);
        throw new ParseException();
      }
    SetExpressionNode setNode = ((SetExpressionNode) jjtree.peekNode());
    setNode.setSetScope(curScope);
    } finally {
      trace_return("SetExpression");
    }
  }

  static final public void LiteralSet(Scope curScope) throws ParseException {
    trace_call("LiteralSet");
    try {
 /*@bgen(jjtree) SetLiteralNode */
  SetLiteralNode jjtn000 = new SetLiteralNode(JJTSETLITERALNODE);
  boolean jjtc000 = true;
  jjtree.openNodeScope(jjtn000);
      try {
        if (jj_2_92(2)) {
          jj_consume_token(LBRACE);
          jj_consume_token(RBRACE);
        } else if (jj_2_93(2)) {
          jj_consume_token(LBRACE);
          if (jj_2_90(2)) {
            LiteralConstant(curScope);
          } else {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case IDENTIFIER:
              Reference(curScope);
              break;
            default:
              jj_la1[211] = jj_gen;
              jj_consume_token(-1);
              throw new ParseException();
            }
          }
          label_71:
          while (true) {
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case COMMA:
              ;
              break;
            default:
              jj_la1[212] = jj_gen;
              break label_71;
            }
            jj_consume_token(COMMA);
            if (jj_2_91(2)) {
              LiteralConstant(curScope);
            } else {
              switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
              case IDENTIFIER:
                Reference(curScope);
                break;
              default:
                jj_la1[213] = jj_gen;
                jj_consume_token(-1);
                throw new ParseException();
              }
            }
          }
          jj_consume_token(RBRACE);
        } else {
          jj_consume_token(-1);
          throw new ParseException();
        }
      } catch (Throwable jjte000) {
   if (jjtc000) {
     jjtree.clearNodeScope(jjtn000);
     jjtc000 = false;
   } else {
     jjtree.popNode();
   }
   if (jjte000 instanceof RuntimeException) {
     {if (true) throw (RuntimeException)jjte000;}
   }
   if (jjte000 instanceof ParseException) {
     {if (true) throw (ParseException)jjte000;}
   }
   {if (true) throw (Error)jjte000;}
      } finally {
   if (jjtc000) {
     jjtree.closeNodeScope(jjtn000, true);
   }
      }
    } finally {
      trace_return("LiteralSet");
    }
  }

  static final public void SetConstructor(Scope curScope) throws ParseException {
    trace_call("SetConstructor");
    try {
 /*@bgen(jjtree) SetConstructorNode */
    SetConstructorNode jjtn000 = new SetConstructorNode(JJTSETCONSTRUCTORNODE);
    boolean jjtc000 = true;
    jjtree.openNodeScope(jjtn000);int quantOp;
    Scope thisNodeScope = null;
    Token varNameToken = null;
    Token varSubpartToken = null;
    AcmeType varType = ConstantTypes.UNSPECIFIED_TYPE;
    AcmeType subpartType = ConstantTypes.UNSPECIFIED_TYPE;
      try {
        if (jj_2_94(2)) {
          jj_consume_token(LBRACE);
          jj_consume_token(SELECT);
                quantOp = SetConstructorNode.SELECT;
                // Set the scope for this node's children to be this node.
                thisNodeScope = (Scope) jjtn000;
          varNameToken = jj_consume_token(IDENTIFIER);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case COLON:
            jj_consume_token(COLON);
            varType = lookup_arbitraryTypeByName();
            break;
          default:
            jj_la1[214] = jj_gen;
            ;
          }
          jj_consume_token(IN);
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case LBRACE:
            SetExpression(thisNodeScope);
            break;
          case IDENTIFIER:
            Reference(thisNodeScope);
            break;
          default:
            jj_la1[215] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
          jj_consume_token(BIT_OR);
          DesignRuleExpression(thisNodeScope);
          jj_consume_token(RBRACE);
      jjtree.closeNodeScope(jjtn000, true);
      jjtc000 = false;
        // fill in the meaning of the set constructor node.
        // Child(0) is the set expression,
        // Child(1) is the expression to evaluate
        SetConstructorNode tmpNode = (SetConstructorNode) jjtree.peekNode();
        tmpNode.setVarName(varNameToken.image);
        tmpNode.setVarType(varType);
        tmpNode.setParentScope(curScope);
        tmpNode.setSetExpression((ExpressionNode) tmpNode.jjtGetChild(0));
        tmpNode.setEvalExpression((ExpressionNode) tmpNode.jjtGetChild(1));
        tmpNode.setQuantOp(quantOp);
        } else {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case LBRACE:
            jj_consume_token(LBRACE);
            jj_consume_token(COLLECT);
        quantOp = SetConstructorNode.COLLECT;
        thisNodeScope = (Scope )jjtn000;
            //    Reference (thisNodeScope) ":" varType = lookup_arbitraryTypeByName () "." subpartType = lookup_arbitraryTypeByName ()
            
                varNameToken = jj_consume_token(IDENTIFIER);
            jj_consume_token(DOT);
            varSubpartToken = jj_consume_token(IDENTIFIER);
            jj_consume_token(COLON);
            varType = lookup_arbitraryTypeByName();
            jj_consume_token(DOT);
            subpartType = lookup_arbitraryTypeByName();
            jj_consume_token(IN);
            switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
            case LBRACE:
              SetExpression(thisNodeScope);
              break;
            case IDENTIFIER:
              Reference(thisNodeScope);
              break;
            default:
              jj_la1[216] = jj_gen;
              jj_consume_token(-1);
              throw new ParseException();
            }
            jj_consume_token(BIT_OR);
            DesignRuleExpression(thisNodeScope);
            jj_consume_token(RBRACE);
      jjtree.closeNodeScope(jjtn000, true);
      jjtc000 = false;
        SetConstructorNode colNode = (SetConstructorNode )jjtree.peekNode ();
   // 	colNode.setIdentifier ((IdentifierNode )colNode.jjtGetChild (0));
        colNode.setVarName (varNameToken.image);
        colNode.setVarType (varType);
        colNode.setSubpartName (varSubpartToken.image);
        colNode.setSubpartType (subpartType);
        colNode.setParentScope (curScope);
        colNode.setSetExpression ((ExpressionNode )colNode.jjtGetChild (0));
        colNode.setEvalExpression ((ExpressionNode )colNode.jjtGetChild (1));
        colNode.setQuantOp (quantOp);
            break;
          default:
            jj_la1[217] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
      } catch (Throwable jjte000) {
     if (jjtc000) {
       jjtree.clearNodeScope(jjtn000);
       jjtc000 = false;
     } else {
       jjtree.popNode();
     }
     if (jjte000 instanceof RuntimeException) {
       {if (true) throw (RuntimeException)jjte000;}
     }
     if (jjte000 instanceof ParseException) {
       {if (true) throw (ParseException)jjte000;}
     }
     {if (true) throw (Error)jjte000;}
      } finally {
     if (jjtc000) {
       jjtree.closeNodeScope(jjtn000, true);
     }
      }
    } finally {
      trace_return("SetConstructor");
    }
  }

  static final public AcmeRecordType RecordType(String typeName) throws ParseException {
    trace_call("RecordType");
    try {
    AcmeRecordType newType;
      jj_consume_token(RECORD);
      jj_consume_token(LBRACKET);
            newType = new AcmeRecordType(typeName);
      RecordItem(newType);
      label_72:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[218] = jj_gen;
          break label_72;
        }
        jj_consume_token(COMMA);
        RecordItem(newType);
      }
      jj_consume_token(RBRACKET);
            {if (true) return newType;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("RecordType");
    }
  }

  static final public void RecordItem(AcmeRecordType newType) throws ParseException {
    trace_call("RecordItem");
    try {
    Token token;
    AcmeElementType type;
      token = jj_consume_token(IDENTIFIER);
      jj_consume_token(COLON);
      type = Type();
            newType.addField(token.image,type);
    } finally {
      trace_return("RecordItem");
    }
  }

  static final public AcmeSetType SetType(String typeName) throws ParseException {
    trace_call("SetType");
    try {
    AcmeElementType eltType;
      jj_consume_token(SET);
      jj_consume_token(LBRACE);
      eltType = Type();
      jj_consume_token(RBRACE);
            try{
            {if (true) return new AcmeSetType(typeName,eltType);}
        }catch(AcmeIllegalNameException e){
            e.printStackTrace();
        }
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("SetType");
    }
  }

  static final public AcmeSequenceType SequenceType(String typeName) throws ParseException {
    trace_call("SequenceType");
    try {
    AcmeElementType eltType;
      jj_consume_token(SEQUENCE);
      jj_consume_token(LBRACE);
      eltType = Type();
      jj_consume_token(RBRACE);
            try{
            {if (true) return new AcmeSequenceType(typeName,eltType);}
        }catch(AcmeIllegalNameException e){
            e.printStackTrace();
        }
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("SequenceType");
    }
  }

  static final public acmeLib.elements.AcmeMapSignature Signature() throws ParseException {
    trace_call("Signature");
    try {
    AcmeElementType source;
    AcmeElementType domain;
      source = Type();
      jj_consume_token(IFF);
      domain = Type();
            {if (true) return new acmeLib.elements.AcmeMapSignature(source,domain);}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("Signature");
    }
  }

  static final public AcmeElementType Type() throws ParseException {
    trace_call("Type");
    try {
    AcmeElementType result;
    Token token;
    StringBuffer buf = new StringBuffer();
      token = jj_consume_token(IDENTIFIER);
        buf.setLength(0);
        buf.append(token.image);
      label_73:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case DOT:
          ;
          break;
        default:
          jj_la1[219] = jj_gen;
          break label_73;
        }
        jj_consume_token(DOT);
        token = jj_consume_token(IDENTIFIER);
                               buf.append("."+token.image);
      }
     {if (true) return new AcmeUnresolvedElementType(buf.toString());}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("Type");
    }
  }

  static final public AcmeType PrimitiveType() throws ParseException {
    trace_call("PrimitiveType");
    try {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMPONENT:
        jj_consume_token(COMPONENT);
        break;
      case GROUP:
        jj_consume_token(GROUP);
        break;
      case CONNECTOR:
        jj_consume_token(CONNECTOR);
        break;
      case PORT:
        jj_consume_token(PORT);
        break;
      case ROLE:
        jj_consume_token(ROLE);
        break;
      case SYSTEM:
        jj_consume_token(SYSTEM);
 {if (true) return null;}
        break;
      default:
        jj_la1[220] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("PrimitiveType");
    }
  }

  static final public AcmeElement Element() throws ParseException {
    trace_call("Element");
    try {
    Token token;
    AcmeElement result;
    StringBuffer buf = new StringBuffer();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case IDENTIFIER:
        token = jj_consume_token(IDENTIFIER);
            buf.setLength(0);
            buf.append(token.image);
        label_74:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case DOT:
            ;
            break;
          default:
            jj_la1[221] = jj_gen;
            break label_74;
          }
          jj_consume_token(DOT);
          token = jj_consume_token(IDENTIFIER);
                                   buf.append("."+token.image);
        }
         {if (true) return new AcmeUnresolvedElement(buf.toString());}
        break;
      case LBRACE:
      case LBRACKET:
      case LANGLE:
        result = CompoundElement();
                                   {if (true) return result;}
        break;
      default:
        jj_la1[222] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("Element");
    }
  }

  static final public AcmeElement CompoundElement() throws ParseException {
    trace_call("CompoundElement");
    try {
    AcmeElement result;
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LBRACE:
        result = Set();
                        {if (true) return result;}
        break;
      case LBRACKET:
        result = Record();
                           {if (true) return result;}
        break;
      case LANGLE:
        result = Sequence();
                             {if (true) return result;}
        break;
      default:
        jj_la1[223] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("CompoundElement");
    }
  }

  static final public AcmeSetValue Set() throws ParseException {
    trace_call("Set");
    try {
    AcmeSetValue result = new AcmeSetValue();
    AcmeElement item = null;
      jj_consume_token(LBRACE);
      item = Element();
            result.addValue(item);
      label_75:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[224] = jj_gen;
          break label_75;
        }
        jj_consume_token(COMMA);
        item = Element();
                              result.addValue(item);
      }
      jj_consume_token(RBRACE);
          {if (true) return result;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("Set");
    }
  }

  static final public AcmeRecordValue Record() throws ParseException {
    trace_call("Record");
    try {
    AcmeRecordValue result = new AcmeRecordValue();
    AcmeElement item = null;
    Token token;
      jj_consume_token(LBRACKET);
      token = jj_consume_token(IDENTIFIER);
      jj_consume_token(ASSIGN);
      item = Element();
            result.addField(token.image,item);
      label_76:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[225] = jj_gen;
          break label_76;
        }
        jj_consume_token(COMMA);
        token = jj_consume_token(IDENTIFIER);
        jj_consume_token(ASSIGN);
        item = Element();
            result.addField(token.image,item);
      }
      jj_consume_token(RBRACKET);
          {if (true) return result;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("Record");
    }
  }

  static final public AcmeSequenceValue Sequence() throws ParseException {
    trace_call("Sequence");
    try {
    AcmeSequenceValue result = new AcmeSequenceValue();
    AcmeElement item = null;
      jj_consume_token(LANGLE);
      item = Element();
            result.addValue(item);
      label_77:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[226] = jj_gen;
          break label_77;
        }
        jj_consume_token(COMMA);
        item = Element();
                              result.addValue(item);
      }
      jj_consume_token(RANGLE);
         {if (true) return result;}
    throw new Error("Missing return statement in function");
    } finally {
      trace_return("Sequence");
    }
  }

  static final private boolean jj_2_1(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_1();
    jj_save(0, xla);
    return retval;
  }

  static final private boolean jj_2_2(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_2();
    jj_save(1, xla);
    return retval;
  }

  static final private boolean jj_2_3(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_3();
    jj_save(2, xla);
    return retval;
  }

  static final private boolean jj_2_4(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_4();
    jj_save(3, xla);
    return retval;
  }

  static final private boolean jj_2_5(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_5();
    jj_save(4, xla);
    return retval;
  }

  static final private boolean jj_2_6(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_6();
    jj_save(5, xla);
    return retval;
  }

  static final private boolean jj_2_7(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_7();
    jj_save(6, xla);
    return retval;
  }

  static final private boolean jj_2_8(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_8();
    jj_save(7, xla);
    return retval;
  }

  static final private boolean jj_2_9(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_9();
    jj_save(8, xla);
    return retval;
  }

  static final private boolean jj_2_10(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_10();
    jj_save(9, xla);
    return retval;
  }

  static final private boolean jj_2_11(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_11();
    jj_save(10, xla);
    return retval;
  }

  static final private boolean jj_2_12(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_12();
    jj_save(11, xla);
    return retval;
  }

  static final private boolean jj_2_13(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_13();
    jj_save(12, xla);
    return retval;
  }

  static final private boolean jj_2_14(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_14();
    jj_save(13, xla);
    return retval;
  }

  static final private boolean jj_2_15(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_15();
    jj_save(14, xla);
    return retval;
  }

  static final private boolean jj_2_16(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_16();
    jj_save(15, xla);
    return retval;
  }

  static final private boolean jj_2_17(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_17();
    jj_save(16, xla);
    return retval;
  }

  static final private boolean jj_2_18(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_18();
    jj_save(17, xla);
    return retval;
  }

  static final private boolean jj_2_19(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_19();
    jj_save(18, xla);
    return retval;
  }

  static final private boolean jj_2_20(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_20();
    jj_save(19, xla);
    return retval;
  }

  static final private boolean jj_2_21(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_21();
    jj_save(20, xla);
    return retval;
  }

  static final private boolean jj_2_22(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_22();
    jj_save(21, xla);
    return retval;
  }

  static final private boolean jj_2_23(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_23();
    jj_save(22, xla);
    return retval;
  }

  static final private boolean jj_2_24(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_24();
    jj_save(23, xla);
    return retval;
  }

  static final private boolean jj_2_25(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_25();
    jj_save(24, xla);
    return retval;
  }

  static final private boolean jj_2_26(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_26();
    jj_save(25, xla);
    return retval;
  }

  static final private boolean jj_2_27(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_27();
    jj_save(26, xla);
    return retval;
  }

  static final private boolean jj_2_28(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_28();
    jj_save(27, xla);
    return retval;
  }

  static final private boolean jj_2_29(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_29();
    jj_save(28, xla);
    return retval;
  }

  static final private boolean jj_2_30(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_30();
    jj_save(29, xla);
    return retval;
  }

  static final private boolean jj_2_31(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_31();
    jj_save(30, xla);
    return retval;
  }

  static final private boolean jj_2_32(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_32();
    jj_save(31, xla);
    return retval;
  }

  static final private boolean jj_2_33(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_33();
    jj_save(32, xla);
    return retval;
  }

  static final private boolean jj_2_34(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_34();
    jj_save(33, xla);
    return retval;
  }

  static final private boolean jj_2_35(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_35();
    jj_save(34, xla);
    return retval;
  }

  static final private boolean jj_2_36(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_36();
    jj_save(35, xla);
    return retval;
  }

  static final private boolean jj_2_37(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_37();
    jj_save(36, xla);
    return retval;
  }

  static final private boolean jj_2_38(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_38();
    jj_save(37, xla);
    return retval;
  }

  static final private boolean jj_2_39(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_39();
    jj_save(38, xla);
    return retval;
  }

  static final private boolean jj_2_40(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_40();
    jj_save(39, xla);
    return retval;
  }

  static final private boolean jj_2_41(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_41();
    jj_save(40, xla);
    return retval;
  }

  static final private boolean jj_2_42(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_42();
    jj_save(41, xla);
    return retval;
  }

  static final private boolean jj_2_43(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_43();
    jj_save(42, xla);
    return retval;
  }

  static final private boolean jj_2_44(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_44();
    jj_save(43, xla);
    return retval;
  }

  static final private boolean jj_2_45(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_45();
    jj_save(44, xla);
    return retval;
  }

  static final private boolean jj_2_46(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_46();
    jj_save(45, xla);
    return retval;
  }

  static final private boolean jj_2_47(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_47();
    jj_save(46, xla);
    return retval;
  }

  static final private boolean jj_2_48(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_48();
    jj_save(47, xla);
    return retval;
  }

  static final private boolean jj_2_49(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_49();
    jj_save(48, xla);
    return retval;
  }

  static final private boolean jj_2_50(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_50();
    jj_save(49, xla);
    return retval;
  }

  static final private boolean jj_2_51(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_51();
    jj_save(50, xla);
    return retval;
  }

  static final private boolean jj_2_52(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_52();
    jj_save(51, xla);
    return retval;
  }

  static final private boolean jj_2_53(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_53();
    jj_save(52, xla);
    return retval;
  }

  static final private boolean jj_2_54(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_54();
    jj_save(53, xla);
    return retval;
  }

  static final private boolean jj_2_55(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_55();
    jj_save(54, xla);
    return retval;
  }

  static final private boolean jj_2_56(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_56();
    jj_save(55, xla);
    return retval;
  }

  static final private boolean jj_2_57(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_57();
    jj_save(56, xla);
    return retval;
  }

  static final private boolean jj_2_58(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_58();
    jj_save(57, xla);
    return retval;
  }

  static final private boolean jj_2_59(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_59();
    jj_save(58, xla);
    return retval;
  }

  static final private boolean jj_2_60(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_60();
    jj_save(59, xla);
    return retval;
  }

  static final private boolean jj_2_61(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_61();
    jj_save(60, xla);
    return retval;
  }

  static final private boolean jj_2_62(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_62();
    jj_save(61, xla);
    return retval;
  }

  static final private boolean jj_2_63(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_63();
    jj_save(62, xla);
    return retval;
  }

  static final private boolean jj_2_64(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_64();
    jj_save(63, xla);
    return retval;
  }

  static final private boolean jj_2_65(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_65();
    jj_save(64, xla);
    return retval;
  }

  static final private boolean jj_2_66(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_66();
    jj_save(65, xla);
    return retval;
  }

  static final private boolean jj_2_67(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_67();
    jj_save(66, xla);
    return retval;
  }

  static final private boolean jj_2_68(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_68();
    jj_save(67, xla);
    return retval;
  }

  static final private boolean jj_2_69(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_69();
    jj_save(68, xla);
    return retval;
  }

  static final private boolean jj_2_70(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_70();
    jj_save(69, xla);
    return retval;
  }

  static final private boolean jj_2_71(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_71();
    jj_save(70, xla);
    return retval;
  }

  static final private boolean jj_2_72(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_72();
    jj_save(71, xla);
    return retval;
  }

  static final private boolean jj_2_73(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_73();
    jj_save(72, xla);
    return retval;
  }

  static final private boolean jj_2_74(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_74();
    jj_save(73, xla);
    return retval;
  }

  static final private boolean jj_2_75(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_75();
    jj_save(74, xla);
    return retval;
  }

  static final private boolean jj_2_76(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_76();
    jj_save(75, xla);
    return retval;
  }

  static final private boolean jj_2_77(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_77();
    jj_save(76, xla);
    return retval;
  }

  static final private boolean jj_2_78(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_78();
    jj_save(77, xla);
    return retval;
  }

  static final private boolean jj_2_79(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_79();
    jj_save(78, xla);
    return retval;
  }

  static final private boolean jj_2_80(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_80();
    jj_save(79, xla);
    return retval;
  }

  static final private boolean jj_2_81(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_81();
    jj_save(80, xla);
    return retval;
  }

  static final private boolean jj_2_82(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_82();
    jj_save(81, xla);
    return retval;
  }

  static final private boolean jj_2_83(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_83();
    jj_save(82, xla);
    return retval;
  }

  static final private boolean jj_2_84(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_84();
    jj_save(83, xla);
    return retval;
  }

  static final private boolean jj_2_85(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_85();
    jj_save(84, xla);
    return retval;
  }

  static final private boolean jj_2_86(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_86();
    jj_save(85, xla);
    return retval;
  }

  static final private boolean jj_2_87(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_87();
    jj_save(86, xla);
    return retval;
  }

  static final private boolean jj_2_88(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_88();
    jj_save(87, xla);
    return retval;
  }

  static final private boolean jj_2_89(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_89();
    jj_save(88, xla);
    return retval;
  }

  static final private boolean jj_2_90(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_90();
    jj_save(89, xla);
    return retval;
  }

  static final private boolean jj_2_91(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_91();
    jj_save(90, xla);
    return retval;
  }

  static final private boolean jj_2_92(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_92();
    jj_save(91, xla);
    return retval;
  }

  static final private boolean jj_2_93(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_93();
    jj_save(92, xla);
    return retval;
  }

  static final private boolean jj_2_94(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_94();
    jj_save(93, xla);
    return retval;
  }

  static final private boolean jj_3R_165() {
    if (jj_scan_token(COLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_125() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_92()) {
    jj_scanpos = xsp;
    if (jj_3_93()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_206() {
    if (jj_scan_token(PROPERTY)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_246() {
    if (jj_3R_95()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_164() {
    if (jj_scan_token(PROPERTY)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_182() {
    if (jj_scan_token(SEMICOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_104() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_164()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3R_165()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3R_166()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3R_167()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_227() {
    if (jj_scan_token(REPRESENTATION)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_245()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_78() {
    if (jj_scan_token(DOT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(CONNECTORS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_25() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(DOT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_229() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_25()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_228() {
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_246()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_89() {
    if (jj_3R_126()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_205() {
    if (jj_scan_token(ELEMENT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_88() {
    if (jj_3R_125()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_148() {
    if (jj_scan_token(SET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_228()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_267() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_88()) {
    jj_scanpos = xsp;
    if (jj_3_89()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_137() {
    if (jj_3R_222()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_204() {
    if (jj_scan_token(SYSTEM)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_147() {
    if (jj_scan_token(BOOLEAN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_67() {
    if (jj_scan_token(SEMICOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_104()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_118() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_67()) {
    jj_scanpos = xsp;
    if (jj_3R_182()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_77() {
    if (jj_scan_token(DOT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(COMPONENTS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_24() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(DOT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_181() {
    if (jj_scan_token(COLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_223() {
    if (jj_scan_token(ROLES)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_146() {
    if (jj_scan_token(STRING)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_38() {
    if (jj_scan_token(SEMICOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_104()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_117() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_181()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(ASSIGN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_86() {
    if (jj_scan_token(SEMICOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_11() {
    if (jj_scan_token(COMPONENT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(TYPE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(EXTENDS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_203() {
    if (jj_scan_token(ROLE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_145() {
    if (jj_scan_token(FLOAT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_85() {
    if (jj_scan_token(ASSIGN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_159() {
    if (jj_scan_token(REPRESENTATION)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_144() {
    if (jj_scan_token(INT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_143() {
    if (jj_scan_token(ANY)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_101() {
    if (jj_scan_token(PORT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_95() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_143()) {
    jj_scanpos = xsp;
    if (jj_3R_144()) {
    jj_scanpos = xsp;
    if (jj_3R_145()) {
    jj_scanpos = xsp;
    if (jj_3R_146()) {
    jj_scanpos = xsp;
    if (jj_3R_147()) {
    jj_scanpos = xsp;
    if (jj_3R_148()) {
    jj_scanpos = xsp;
    if (jj_3R_149()) {
    jj_scanpos = xsp;
    if (jj_3_50()) {
    jj_scanpos = xsp;
    if (jj_3_51()) {
    jj_scanpos = xsp;
    if (jj_3_52()) {
    jj_scanpos = xsp;
    if (jj_3_53()) {
    jj_scanpos = xsp;
    if (jj_3R_150()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_158() {
    if (jj_scan_token(PROPERTY)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_23() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(DOT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_33() {
    if (jj_3R_101()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_202() {
    if (jj_scan_token(PORT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_37() {
    if (jj_scan_token(DOT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_157() {
    if (jj_scan_token(TYPE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_10() {
    if (jj_scan_token(COMPONENT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(TYPE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_85()) {
    jj_scanpos = xsp;
    if (jj_3R_86()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_60() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RBRACKET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_156() {
    if (jj_scan_token(ROLE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_68() {
    if (jj_scan_token(PROPBEGIN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_104()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_118()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    if (jj_scan_token(PROPEND)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_251() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_10()) {
    jj_scanpos = xsp;
    if (jj_3_11()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_225() {
    if (jj_scan_token(PROPERTIES)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_155() {
    if (jj_scan_token(PORT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_201() {
    if (jj_scan_token(CONNECTOR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_154() {
    if (jj_scan_token(CONNECTOR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_22() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(DOT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_162() {
    if (jj_scan_token(HEURISTIC)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_58() {
    if (jj_scan_token(SEMICOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_117()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_153() {
    if (jj_scan_token(COMPONENT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_161() {
    if (jj_scan_token(INVARIANT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_76() {
    if (jj_scan_token(DOT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(TYPE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_160() {
    if (jj_scan_token(DESIGN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_200() {
    if (jj_scan_token(GROUP)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_152() {
    if (jj_scan_token(SYSTEM)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_136() {
    if (jj_3R_221()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_224() {
    if (jj_scan_token(PROPERTY)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_104()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_151() {
    if (jj_scan_token(ELEMENT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_59() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_117()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_75() {
    if (jj_scan_token(DOT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_103() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_160()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3R_161()) {
    jj_scanpos = xsp;
    if (jj_3R_162()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_163()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_3() {
    if (jj_3R_80()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_21() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(DOT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_235() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_59()) {
    jj_scanpos = xsp;
    if (jj_3_60()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_99() {
    if (jj_scan_token(GROUP)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_96() {
    if (jj_scan_token(SET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_151()) {
    jj_scanpos = xsp;
    if (jj_3R_152()) {
    jj_scanpos = xsp;
    if (jj_3R_153()) {
    jj_scanpos = xsp;
    if (jj_3R_154()) {
    jj_scanpos = xsp;
    if (jj_3R_155()) {
    jj_scanpos = xsp;
    if (jj_3R_156()) {
    jj_scanpos = xsp;
    if (jj_3R_157()) {
    jj_scanpos = xsp;
    if (jj_3R_158()) {
    jj_scanpos = xsp;
    if (jj_3R_159()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_199() {
    if (jj_scan_token(COMPONENT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_215() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_116() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_84() {
    if (jj_scan_token(SEMICOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_83() {
    if (jj_scan_token(ASSIGN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_198() {
    if (jj_scan_token(FALSE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_9() {
    if (jj_scan_token(ELEMENT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(TYPE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(EXTENDS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_2() {
    if (jj_3R_79()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_32() {
    if (jj_3R_100()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_20() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(DOT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_197() {
    if (jj_scan_token(TRUE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_57() {
    if (jj_scan_token(LANGLE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_115()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_116()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    if (jj_scan_token(RANGLE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_266() {
    if (jj_3R_267()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_234() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_56()) {
    jj_scanpos = xsp;
    if (jj_3_57()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_56() {
    if (jj_scan_token(LANGLE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RANGLE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_196() {
    if (jj_scan_token(STRING_LITERAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_8() {
    if (jj_scan_token(ELEMENT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(TYPE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_83()) {
    jj_scanpos = xsp;
    if (jj_3R_84()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_31() {
    if (jj_3R_99()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_265() {
    if (jj_3R_215()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_264() {
    if (jj_3R_127()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_250() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_8()) {
    jj_scanpos = xsp;
    if (jj_3_9()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_195() {
    if (jj_scan_token(FLOATING_POINT_LITERAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_87() {
    if (jj_3R_95()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_263() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_262() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_263()) {
    jj_scanpos = xsp;
    if (jj_3R_264()) {
    jj_scanpos = xsp;
    if (jj_3R_265()) {
    jj_scanpos = xsp;
    if (jj_3R_266()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_86() {
    if (jj_3R_96()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_110() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RBRACKET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_1() {
    if (jj_3R_78()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_194() {
    if (jj_scan_token(INTEGER_LITERAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_127() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_194()) {
    jj_scanpos = xsp;
    if (jj_3R_195()) {
    jj_scanpos = xsp;
    if (jj_3R_196()) {
    jj_scanpos = xsp;
    if (jj_3R_197()) {
    jj_scanpos = xsp;
    if (jj_3R_198()) {
    jj_scanpos = xsp;
    if (jj_3R_199()) {
    jj_scanpos = xsp;
    if (jj_3R_200()) {
    jj_scanpos = xsp;
    if (jj_3R_201()) {
    jj_scanpos = xsp;
    if (jj_3R_202()) {
    jj_scanpos = xsp;
    if (jj_3R_203()) {
    jj_scanpos = xsp;
    if (jj_3R_204()) {
    jj_scanpos = xsp;
    if (jj_3R_205()) {
    jj_scanpos = xsp;
    if (jj_3R_206()) {
    jj_scanpos = xsp;
    if (jj_3R_207()) {
    jj_scanpos = xsp;
    if (jj_3R_208()) {
    jj_scanpos = xsp;
    if (jj_3R_209()) {
    jj_scanpos = xsp;
    if (jj_3R_210()) {
    jj_scanpos = xsp;
    if (jj_3R_211()) {
    jj_scanpos = xsp;
    if (jj_3R_212()) {
    jj_scanpos = xsp;
    if (jj_3R_213()) {
    jj_scanpos = xsp;
    if (jj_3R_214()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_261() {
    if (jj_3R_262()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_260() {
    if (jj_scan_token(MINUS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_242() {
    if (jj_3R_255()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_55() {
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_115()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_259() {
    if (jj_scan_token(BANG)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_258() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_259()) {
    jj_scanpos = xsp;
    if (jj_3R_260()) {
    jj_scanpos = xsp;
    if (jj_3R_261()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_241() {
    if (jj_3R_254()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_135() {
    if (jj_3R_220()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_233() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_54()) {
    jj_scanpos = xsp;
    if (jj_3_55()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_54() {
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_66() {
    if (jj_3R_95()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_47() {
    if (jj_scan_token(RECORD)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_110()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(SEMICOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_65() {
    if (jj_3R_96()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_240() {
    if (jj_3R_253()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_171() {
    if (jj_scan_token(SEMICOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_244() {
    if (jj_scan_token(ATTACHMENT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_41() {
    if (jj_scan_token(SEMICOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_106()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_109() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_41()) {
    jj_scanpos = xsp;
    if (jj_3R_171()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_239() {
    if (jj_3R_252()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_219() {
    if (jj_scan_token(DESIGN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_238() {
    if (jj_3R_251()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_108() {
    if (jj_scan_token(LANGLE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RANGLE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_134() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_219()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(ANALYSIS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_102() {
    if (jj_scan_token(ROLE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_237() {
    if (jj_3R_250()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_216() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_237()) {
    jj_scanpos = xsp;
    if (jj_3R_238()) {
    jj_scanpos = xsp;
    if (jj_3R_239()) {
    jj_scanpos = xsp;
    if (jj_3R_240()) {
    jj_scanpos = xsp;
    if (jj_3R_241()) {
    jj_scanpos = xsp;
    if (jj_3R_242()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_94() {
    if (jj_scan_token(SEMICOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_93() {
    if (jj_scan_token(ASSIGN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_249() {
    if (jj_3R_258()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_19() {
    if (jj_scan_token(ROLE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(TYPE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(EXTENDS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_46() {
    if (jj_scan_token(RECORD)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_106()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_109()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    if (jj_scan_token(RBRACKET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_180() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_30() {
    if (jj_3R_98()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_81() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_30()) {
    jj_scanpos = xsp;
    if (jj_3R_135()) {
    jj_scanpos = xsp;
    if (jj_3_31()) {
    jj_scanpos = xsp;
    if (jj_3_32()) {
    jj_scanpos = xsp;
    if (jj_3R_136()) {
    jj_scanpos = xsp;
    if (jj_3_33()) {
    jj_scanpos = xsp;
    if (jj_3R_137()) {
    jj_scanpos = xsp;
    if (jj_3_34()) {
    jj_scanpos = xsp;
    if (jj_3R_138()) {
    jj_scanpos = xsp;
    if (jj_3R_139()) {
    jj_scanpos = xsp;
    if (jj_3R_140()) {
    jj_scanpos = xsp;
    if (jj_3R_141()) {
    jj_scanpos = xsp;
    if (jj_3R_142()) {
    jj_scanpos = xsp;
    if (jj_3_35()) {
    jj_scanpos = xsp;
    if (jj_3_36()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_179() {
    if (jj_3R_235()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_130() {
    if (jj_3R_217()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_178() {
    if (jj_3R_234()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_45() {
    if (jj_scan_token(SEQUENCE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LANGLE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_95()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RANGLE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_129() {
    if (jj_3R_216()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_78() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_129()) {
    jj_scanpos = xsp;
    if (jj_3R_130()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_218() {
    if (jj_scan_token(DESIGN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_177() {
    if (jj_3R_233()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_63() {
    if (jj_3R_96()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_18() {
    if (jj_scan_token(ROLE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(TYPE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_93()) {
    jj_scanpos = xsp;
    if (jj_3R_94()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_176() {
    if (jj_scan_token(TRUE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_107() {
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_175() {
    if (jj_scan_token(FALSE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_44() {
    if (jj_scan_token(SEQUENCE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_108()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(SEMICOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_255() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_18()) {
    jj_scanpos = xsp;
    if (jj_3_19()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_64() {
    if (jj_3R_95()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_236() {
    if (jj_3R_249()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_183() {
    if (jj_scan_token(DOT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_5() {
    if (jj_3R_81()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_119() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_183()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  static final private boolean jj_3R_97() {
    if (jj_3R_81()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_174() {
    if (jj_scan_token(STRING_LITERAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_43() {
    if (jj_scan_token(SET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_95()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_173() {
    if (jj_scan_token(FLOATING_POINT_LITERAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_29() {
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    if (jj_3R_97()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_97()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  static final private boolean jj_3_42() {
    if (jj_scan_token(SET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_107()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(SEMICOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_133() {
    if (jj_scan_token(EXTERNAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_218()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(ANALYSIS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_28() {
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_80() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_133()) {
    jj_scanpos = xsp;
    if (jj_3R_134()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_243() {
    if (jj_scan_token(ATTACHMENTS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_172() {
    if (jj_scan_token(INTEGER_LITERAL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_115() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_172()) {
    jj_scanpos = xsp;
    if (jj_3R_173()) {
    jj_scanpos = xsp;
    if (jj_3R_174()) {
    jj_scanpos = xsp;
    if (jj_3R_175()) {
    jj_scanpos = xsp;
    if (jj_3R_176()) {
    jj_scanpos = xsp;
    if (jj_3R_177()) {
    jj_scanpos = xsp;
    if (jj_3R_178()) {
    jj_scanpos = xsp;
    if (jj_3R_179()) {
    jj_scanpos = xsp;
    if (jj_3R_180()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_226() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_243()) {
    jj_scanpos = xsp;
    if (jj_3R_244()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_192() {
    if (jj_3R_236()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_4() {
    if (jj_3R_78()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_82() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_4()) {
    jj_scanpos = xsp;
    if (jj_3_5()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_170() {
    if (jj_scan_token(COLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_169() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_92() {
    if (jj_scan_token(SEMICOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_91() {
    if (jj_scan_token(ASSIGN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_17() {
    if (jj_scan_token(PORT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(TYPE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(EXTENDS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_7() {
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    if (jj_3R_82()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_82()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  static final private boolean jj_3R_106() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_169()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    xsp = jj_scanpos;
    if (jj_3R_170()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_36() {
    if (jj_3R_103()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_6() {
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_114() {
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_124() {
    if (jj_3R_192()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_220() {
    if (jj_scan_token(COMPONENTS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_35() {
    if (jj_3R_80()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_16() {
    if (jj_scan_token(PORT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(TYPE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_91()) {
    jj_scanpos = xsp;
    if (jj_3R_92()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_85() {
    if (jj_scan_token(DOT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(ATTACHEDROLES)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_254() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_16()) {
    jj_scanpos = xsp;
    if (jj_3_17()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_74() {
    if (jj_scan_token(IFF)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_124()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_150() {
    if (jj_3R_229()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_142() {
    if (jj_3R_227()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_123() {
    if (jj_3R_124()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_141() {
    if (jj_3R_226()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_53() {
    if (jj_scan_token(ENUM)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_114()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_73() {
    if (jj_scan_token(IMPLIES)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_123()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_84() {
    if (jj_scan_token(DOT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(ATTACHEDPORTS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_132() {
    if (jj_scan_token(STYLE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_122() {
    if (jj_3R_123()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_217() {
    if (jj_scan_token(PROPERTY)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(TYPE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_72() {
    if (jj_scan_token(OR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_122()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_112() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RBRACKET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_121() {
    if (jj_3R_122()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_131() {
    if (jj_scan_token(FAMILY)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_113() {
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_214() {
    if (jj_scan_token(RECORD)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_71() {
    if (jj_scan_token(AND)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_121()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_248() {
    if (jj_3R_121()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_79() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_131()) {
    jj_scanpos = xsp;
    if (jj_3R_132()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_140() {
    if (jj_3R_225()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_90() {
    if (jj_scan_token(SEMICOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_15() {
    if (jj_scan_token(CONNECTOR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(TYPE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(EXTENDS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_89() {
    if (jj_scan_token(ASSIGN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_52() {
    if (jj_scan_token(ENUM)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_113()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_232() {
    if (jj_scan_token(PROPBEGIN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_168() {
    if (jj_scan_token(SEMICOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_221() {
    if (jj_scan_token(CONNECTORS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_27() {
    if (jj_3R_96()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_213() {
    if (jj_scan_token(SEQUENCE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_51() {
    if (jj_scan_token(RECORD)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_112()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_83() {
    if (jj_scan_token(DOT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(REPRESENTATIONS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_62() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(DOT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_191() {
    if (jj_scan_token(REPRESENTATION)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_61() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(DOT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_98() {
    if (jj_scan_token(COMPONENT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_14() {
    if (jj_scan_token(CONNECTOR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(TYPE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_89()) {
    jj_scanpos = xsp;
    if (jj_3R_90()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_190() {
    if (jj_scan_token(PROPERTY)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_212() {
    if (jj_scan_token(SET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_253() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_14()) {
    jj_scanpos = xsp;
    if (jj_3_15()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_193() {
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(COLLECT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_189() {
    if (jj_scan_token(ROLE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_39() {
    if (jj_scan_token(SEMICOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_104()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_105() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_39()) {
    jj_scanpos = xsp;
    if (jj_3R_168()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_70() {
    if (jj_3R_120()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_188() {
    if (jj_scan_token(PORT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_69() {
    if (jj_3R_119()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_82() {
    if (jj_scan_token(DOT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(PROPERTIES)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_139() {
    if (jj_3R_224()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_211() {
    if (jj_scan_token(ENUM)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_187() {
    if (jj_scan_token(CONNECTOR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_128() {
    if (jj_3R_215()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_186() {
    if (jj_scan_token(GROUP)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_49() {
    if (jj_scan_token(SEMICOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_106()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_185() {
    if (jj_scan_token(COMPONENT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_210() {
    if (jj_scan_token(BOOLEAN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_184() {
    if (jj_scan_token(SYSTEM)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_81() {
    if (jj_scan_token(DOT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(MEMBERS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_257() {
    if (jj_scan_token(EXISTS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_256() {
    if (jj_scan_token(FORALL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_167() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_40()) {
    jj_scanpos = xsp;
    if (jj_3R_232()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_40() {
    if (jj_scan_token(PROPBEGIN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_104()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_105()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    if (jj_scan_token(PROPEND)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_50() {
    if (jj_scan_token(RECORD)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_106()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_247() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_256()) {
    jj_scanpos = xsp;
    if (jj_3R_257()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_209() {
    if (jj_scan_token(STRING)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_26() {
    if (jj_3R_95()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_138() {
    if (jj_3R_223()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_94() {
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(SELECT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_120() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_26()) {
    jj_scanpos = xsp;
    if (jj_3R_184()) {
    jj_scanpos = xsp;
    if (jj_3R_185()) {
    jj_scanpos = xsp;
    if (jj_3R_186()) {
    jj_scanpos = xsp;
    if (jj_3R_187()) {
    jj_scanpos = xsp;
    if (jj_3R_188()) {
    jj_scanpos = xsp;
    if (jj_3R_189()) {
    jj_scanpos = xsp;
    if (jj_3R_190()) {
    jj_scanpos = xsp;
    if (jj_3R_191()) {
    jj_scanpos = xsp;
    if (jj_3_27()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_100() {
    if (jj_scan_token(CONNECTOR)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_111() {
    if (jj_3R_95()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_88() {
    if (jj_scan_token(SEMICOLON)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_13() {
    if (jj_scan_token(GROUP)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(TYPE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(EXTENDS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_80() {
    if (jj_scan_token(DOT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(ROLES)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_126() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_94()) {
    jj_scanpos = xsp;
    if (jj_3R_193()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_245() {
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_87() {
    if (jj_scan_token(ASSIGN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_231() {
    if (jj_3R_248()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_208() {
    if (jj_scan_token(FLOAT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_91() {
    if (jj_3R_127()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_48() {
    if (jj_scan_token(LANGLE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_111()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RANGLE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_230() {
    if (jj_3R_247()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_163() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_230()) {
    jj_scanpos = xsp;
    if (jj_3R_231()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_222() {
    if (jj_scan_token(PORTS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_90() {
    if (jj_3R_127()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_166() {
    if (jj_scan_token(ASSIGN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_12() {
    if (jj_scan_token(GROUP)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(TYPE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(IDENTIFIER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_87()) {
    jj_scanpos = xsp;
    if (jj_3R_88()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_207() {
    if (jj_scan_token(INT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_149() {
    if (jj_scan_token(SEQUENCE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_48()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_79() {
    if (jj_scan_token(DOT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(PORTS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_93() {
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_90()) {
    jj_scanpos = xsp;
    if (jj_3R_128()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_34() {
    if (jj_3R_102()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_252() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_12()) {
    jj_scanpos = xsp;
    if (jj_3_13()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3_92() {
    if (jj_scan_token(LBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RBRACE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static private boolean jj_initialized_once = false;
  static public ArmaniParserTokenManager token_source;
  static ASCII_UCodeESC_CharStream jj_input_stream;
  static public Token token, jj_nt;
  static private int jj_ntk;
  static private Token jj_scanpos, jj_lastpos;
  static private int jj_la;
  static public boolean lookingAhead = false;
  static private boolean jj_semLA;
  static private int jj_gen;
  static final private int[] jj_la1 = new int[227];
  static final private int[] jj_la1_0 = {0x0,0x0,0xc154e000,0xc0002000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xc7fec000,0x4154c000,0x154c000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x4054e000,0x0,0x0,0x0,0x0,0x0,0xc6fec000,0x0,0x0,0x20000,0x80000,0x200000,0xc6800000,0xc0000000,0xc0000000,0x0,0x0,0x0,0x0,0xc0010000,0xc0010000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xc0300000,0xc0300000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xc0c00000,0xc0c00000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xc0000000,0xc0000000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xc0000000,0xc0000000,0x0,0x0,0x0,0xc0000000,0xc0000000,0x0,0x0,0xc0000000,0xc0000000,0x0,0x6000000,0x0,0x0,0x40000000,0x0,0x40000000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xc0000000,0xc0000000,0x0,0x0,0x154e000,0x0,0x154e000,0x0,0x0,0x0,0x0,0x0,0x4154e000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x4154e000,0x4154e000,0x0,0x0,0x0,0x4154e000,0x0,0x4154e000,0x0,0x0,0x0,0x41546000,0x41546000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x54e000,0x0,0x0,0x0,0x0,0x0,0x0,};
  static final private int[] jj_la1_1 = {0x800,0x0,0x1c000600,0x0,0x0,0x0,0x0,0x0,0x0,0x600,0x0,0x0,0x0,0x40,0x7c000001,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x1,0x0,0x0,0x0,0x0,0x0,0x7c000001,0x100,0x20,0x0,0x0,0x0,0x1,0x1,0x1,0x0,0x0,0x0,0x0,0x68000000,0x68000000,0x100,0x20,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x68000001,0x68000001,0x100,0x20,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x68000001,0x68000001,0x100,0x20,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x68000001,0x68000001,0x100,0x20,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x68000001,0x68000001,0x100,0x20,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x8f000,0x0,0x1ff000,0x0,0x1ff000,0x0,0x0,0x0,0x0,0x0,0x0,0x13f000,0x0,0x0,0x0,0x600000,0x0,0x0,0x0,0x0,0x0,0x0,0x8,0x0,0x0,0x0,0x0,0x0,0x0,0x8000000,0x10,0x8000000,0x10,0x1c000000,0x8000000,0x60000000,0x0,0x0,0x2eff000,0x1000000,0x2800000,0x0,0x10,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x6ff000,0x6ff000,0x0,0x0,0x0,0x6ff000,0x0,0x2eff000,0x0,0x0,0x0,0x11,0x11,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,};
  static final private int[] jj_la1_2 = {0x0,0x1800,0x0,0x0,0x0,0x0,0x2000000,0x2000000,0x2000000,0x0,0x800000,0x1000000,0x800000,0x8800000,0x0,0x0,0x0,0x800000,0x8800000,0x1000000,0x800000,0x800000,0x8800000,0x1000000,0x800000,0x800000,0x8800000,0x1000000,0x800000,0x800000,0x8800000,0x1000000,0x800000,0x800000,0x8800000,0x1000000,0x800000,0x800000,0x8800000,0x1000000,0x800000,0x0,0x1000000,0x0,0x800000,0x8800000,0x1000000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x1000000,0x0,0x8800000,0x1000000,0x0,0x0,0x20000,0x0,0x1000000,0x0,0x8800000,0x1000,0x1000000,0x0,0x8800000,0x800000,0x1000000,0x0,0x0,0x20000,0x0,0x1000000,0x0,0x8800000,0x1000,0x1000000,0x0,0x8800000,0x800000,0x1000000,0x0,0x0,0x20000,0x0,0x1000000,0x0,0x8800000,0x1000,0x1000000,0x0,0x8800000,0x800000,0x1000000,0x0,0x0,0x20000,0x0,0x1000000,0x0,0x8800000,0x1000,0x800000,0x1000,0x1000000,0x0,0x8800000,0x800000,0x1000000,0x0,0x0,0x20000,0x0,0x1000,0x0,0x0,0x20000,0x800000,0x0,0x0,0x20000,0x0,0x800000,0x800000,0x1000,0x800000,0x0,0x0,0x8000000,0x800000,0x800000,0x0,0x0,0x1000000,0x20000,0x20000,0x200000,0x800000,0x800000,0x80000,0x0,0x1000,0x1000,0x20000,0x1000,0x800000,0x800000,0x80000,0x1000000,0x20000,0x20000,0x0,0x1000,0x1000000,0x0,0x2a1a20,0x1000000,0x1000000,0x800000,0x800000,0x0,0x1000,0x0,0x800000,0x1000,0x800000,0x0,0x0,0x20000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x800000,0x800000,0x20029a20,0x0,0x0,0x10000000,0x0,0x10000000,0x21000,0x0,0x0,0x600000,0x600000,0x0,0x0,0x0,0x0,0x20029a20,0x29a20,0x2000000,0x8000,0x2000000,0xa20,0x1000000,0x20029a20,0x1000000,0x1000,0x1000000,0x0,0x0,0x1000,0x1000000,0x1000,0x0,0x21000,0x21000,0x20000,0x1000000,0x2000000,0x0,0x2000000,0x2a1000,0x2a0000,0x1000000,0x1000000,0x1000000,};
  static final private int[] jj_la1_3 = {0x0,0x20010000,0x0,0x0,0x20010000,0x20010000,0xe0011601,0xe0011601,0xe0011601,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x1,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x1,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x1,0x0,0x0,0x0,0x1,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x1,0x0,0x0,0x0,0x1,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x1,0x0,0x0,0x0,0x1,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x1,0x0,0x0,0x0,0x0,0x0,0x1,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x1,0x0,0x0,0x0,0x20000,0x20000,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x1,0x0,0x0,0x0,0x0,0x0,0x1,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x400,0x0,0x0,0x1,0x0,0x1,0x0,0x12,0x12,0xc,0xc,0x600,0x600,0x11800,0x11800,0x400,0x0,0x0,0x0,0x0,0x0,0x0,0x400,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x1,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,};
  static final private JJCalls[] jj_2_rtns = new JJCalls[94];
  static private boolean jj_rescan = false;
  static private int jj_gc = 0;

  public ArmaniParser(java.io.InputStream stream) {
    if (jj_initialized_once) {
      System.out.println("ERROR: Second call to constructor of static parser.  You must");
      System.out.println("       either use ReInit() or set the JavaCC option STATIC to false");
      System.out.println("       during parser generation.");
      throw new Error();
    }
    jj_initialized_once = true;
    jj_input_stream = new ASCII_UCodeESC_CharStream(stream, 1, 1);
    token_source = new ArmaniParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 227; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  static public void ReInit(java.io.InputStream stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jjtree.reset();
    jj_gen = 0;
    for (int i = 0; i < 227; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public ArmaniParser(java.io.Reader stream) {
    if (jj_initialized_once) {
      System.out.println("ERROR: Second call to constructor of static parser.  You must");
      System.out.println("       either use ReInit() or set the JavaCC option STATIC to false");
      System.out.println("       during parser generation.");
      throw new Error();
    }
    jj_initialized_once = true;
    jj_input_stream = new ASCII_UCodeESC_CharStream(stream, 1, 1);
    token_source = new ArmaniParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 227; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  static public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jjtree.reset();
    jj_gen = 0;
    for (int i = 0; i < 227; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public ArmaniParser(ArmaniParserTokenManager tm) {
    if (jj_initialized_once) {
      System.out.println("ERROR: Second call to constructor of static parser.  You must");
      System.out.println("       either use ReInit() or set the JavaCC option STATIC to false");
      System.out.println("       during parser generation.");
      throw new Error();
    }
    jj_initialized_once = true;
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 227; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(ArmaniParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jjtree.reset();
    jj_gen = 0;
    for (int i = 0; i < 227; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  static final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      if (++jj_gc > 100) {
        jj_gc = 0;
        for (int i = 0; i < jj_2_rtns.length; i++) {
          JJCalls c = jj_2_rtns[i];
          while (c != null) {
            if (c.gen < jj_gen) c.first = null;
            c = c.next;
          }
        }
      }
      trace_token(token, "");
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  static final private boolean jj_scan_token(int kind) {
    if (jj_scanpos == jj_lastpos) {
      jj_la--;
      if (jj_scanpos.next == null) {
        jj_lastpos = jj_scanpos = jj_scanpos.next = token_source.getNextToken();
      } else {
        jj_lastpos = jj_scanpos = jj_scanpos.next;
      }
    } else {
      jj_scanpos = jj_scanpos.next;
    }
    if (jj_rescan) {
      int i = 0; Token tok = token;
      while (tok != null && tok != jj_scanpos) { i++; tok = tok.next; }
      if (tok != null) jj_add_error_token(kind, i);
    }
    return (jj_scanpos.kind != kind);
  }

  static final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
      trace_token(token, " (in getNextToken)");
    return token;
  }

  static final public Token getToken(int index) {
    Token t = lookingAhead ? jj_scanpos : token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  static final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  static private java.util.Vector jj_expentries = new java.util.Vector();
  static private int[] jj_expentry;
  static private int jj_kind = -1;
  static private int[] jj_lasttokens = new int[100];
  static private int jj_endpos;

  static private void jj_add_error_token(int kind, int pos) {
    if (pos >= 100) return;
    if (pos == jj_endpos + 1) {
      jj_lasttokens[jj_endpos++] = kind;
    } else if (jj_endpos != 0) {
      jj_expentry = new int[jj_endpos];
      for (int i = 0; i < jj_endpos; i++) {
        jj_expentry[i] = jj_lasttokens[i];
      }
      boolean exists = false;
      for (java.util.Enumeration enum = jj_expentries.elements(); enum.hasMoreElements();) {
        int[] oldentry = (int[])(enum.nextElement());
        if (oldentry.length == jj_expentry.length) {
          exists = true;
          for (int i = 0; i < jj_expentry.length; i++) {
            if (oldentry[i] != jj_expentry[i]) {
              exists = false;
              break;
            }
          }
          if (exists) break;
        }
      }
      if (!exists) jj_expentries.addElement(jj_expentry);
      if (pos != 0) jj_lasttokens[(jj_endpos = pos) - 1] = kind;
    }
  }

  static final public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[128];
    for (int i = 0; i < 128; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 227; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
          if ((jj_la1_1[i] & (1<<j)) != 0) {
            la1tokens[32+j] = true;
          }
          if ((jj_la1_2[i] & (1<<j)) != 0) {
            la1tokens[64+j] = true;
          }
          if ((jj_la1_3[i] & (1<<j)) != 0) {
            la1tokens[96+j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 128; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    jj_endpos = 0;
    jj_rescan_token();
    jj_add_error_token(0, 0);
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  static private int trace_indent = 0;
  static private boolean trace_enabled = true;

  static final public void enable_tracing() {
    trace_enabled = true;
  }

  static final public void disable_tracing() {
    trace_enabled = false;
  }

  static final private void trace_call(String s) {
    if (trace_enabled) {
      for (int i = 0; i < trace_indent; i++) { System.out.print(" "); }
      System.out.println("Call:   " + s);
    }
    trace_indent = trace_indent + 2;
  }

  static final private void trace_return(String s) {
    trace_indent = trace_indent - 2;
    if (trace_enabled) {
      for (int i = 0; i < trace_indent; i++) { System.out.print(" "); }
      System.out.println("Return: " + s);
    }
  }

  static final private void trace_token(Token t, String where) {
    if (trace_enabled) {
      for (int i = 0; i < trace_indent; i++) { System.out.print(" "); }
      System.out.print("Consumed token: <" + tokenImage[t.kind]);
      if (t.kind != 0 && !tokenImage[t.kind].equals("\"" + t.image + "\"")) {
        System.out.print(": \"" + t.image + "\"");
      }
      System.out.println(">" + where);
    }
  }

  static final private void trace_scan(Token t1, int t2) {
    if (trace_enabled) {
      for (int i = 0; i < trace_indent; i++) { System.out.print(" "); }
      System.out.print("Visited token: <" + tokenImage[t1.kind]);
      if (t1.kind != 0 && !tokenImage[t1.kind].equals("\"" + t1.image + "\"")) {
        System.out.print(": \"" + t1.image + "\"");
      }
      System.out.println(">; Expected token: <" + tokenImage[t2] + ">");
    }
  }

  static final private void jj_rescan_token() {
    jj_rescan = true;
    for (int i = 0; i < 94; i++) {
      JJCalls p = jj_2_rtns[i];
      do {
        if (p.gen > jj_gen) {
          jj_la = p.arg; jj_lastpos = jj_scanpos = p.first;
          switch (i) {
            case 0: jj_3_1(); break;
            case 1: jj_3_2(); break;
            case 2: jj_3_3(); break;
            case 3: jj_3_4(); break;
            case 4: jj_3_5(); break;
            case 5: jj_3_6(); break;
            case 6: jj_3_7(); break;
            case 7: jj_3_8(); break;
            case 8: jj_3_9(); break;
            case 9: jj_3_10(); break;
            case 10: jj_3_11(); break;
            case 11: jj_3_12(); break;
            case 12: jj_3_13(); break;
            case 13: jj_3_14(); break;
            case 14: jj_3_15(); break;
            case 15: jj_3_16(); break;
            case 16: jj_3_17(); break;
            case 17: jj_3_18(); break;
            case 18: jj_3_19(); break;
            case 19: jj_3_20(); break;
            case 20: jj_3_21(); break;
            case 21: jj_3_22(); break;
            case 22: jj_3_23(); break;
            case 23: jj_3_24(); break;
            case 24: jj_3_25(); break;
            case 25: jj_3_26(); break;
            case 26: jj_3_27(); break;
            case 27: jj_3_28(); break;
            case 28: jj_3_29(); break;
            case 29: jj_3_30(); break;
            case 30: jj_3_31(); break;
            case 31: jj_3_32(); break;
            case 32: jj_3_33(); break;
            case 33: jj_3_34(); break;
            case 34: jj_3_35(); break;
            case 35: jj_3_36(); break;
            case 36: jj_3_37(); break;
            case 37: jj_3_38(); break;
            case 38: jj_3_39(); break;
            case 39: jj_3_40(); break;
            case 40: jj_3_41(); break;
            case 41: jj_3_42(); break;
            case 42: jj_3_43(); break;
            case 43: jj_3_44(); break;
            case 44: jj_3_45(); break;
            case 45: jj_3_46(); break;
            case 46: jj_3_47(); break;
            case 47: jj_3_48(); break;
            case 48: jj_3_49(); break;
            case 49: jj_3_50(); break;
            case 50: jj_3_51(); break;
            case 51: jj_3_52(); break;
            case 52: jj_3_53(); break;
            case 53: jj_3_54(); break;
            case 54: jj_3_55(); break;
            case 55: jj_3_56(); break;
            case 56: jj_3_57(); break;
            case 57: jj_3_58(); break;
            case 58: jj_3_59(); break;
            case 59: jj_3_60(); break;
            case 60: jj_3_61(); break;
            case 61: jj_3_62(); break;
            case 62: jj_3_63(); break;
            case 63: jj_3_64(); break;
            case 64: jj_3_65(); break;
            case 65: jj_3_66(); break;
            case 66: jj_3_67(); break;
            case 67: jj_3_68(); break;
            case 68: jj_3_69(); break;
            case 69: jj_3_70(); break;
            case 70: jj_3_71(); break;
            case 71: jj_3_72(); break;
            case 72: jj_3_73(); break;
            case 73: jj_3_74(); break;
            case 74: jj_3_75(); break;
            case 75: jj_3_76(); break;
            case 76: jj_3_77(); break;
            case 77: jj_3_78(); break;
            case 78: jj_3_79(); break;
            case 79: jj_3_80(); break;
            case 80: jj_3_81(); break;
            case 81: jj_3_82(); break;
            case 82: jj_3_83(); break;
            case 83: jj_3_84(); break;
            case 84: jj_3_85(); break;
            case 85: jj_3_86(); break;
            case 86: jj_3_87(); break;
            case 87: jj_3_88(); break;
            case 88: jj_3_89(); break;
            case 89: jj_3_90(); break;
            case 90: jj_3_91(); break;
            case 91: jj_3_92(); break;
            case 92: jj_3_93(); break;
            case 93: jj_3_94(); break;
          }
        }
        p = p.next;
      } while (p != null);
    }
    jj_rescan = false;
  }

  static final private void jj_save(int index, int xla) {
    JJCalls p = jj_2_rtns[index];
    while (p.gen > jj_gen) {
      if (p.next == null) { p = p.next = new JJCalls(); break; }
      p = p.next;
    }
    p.gen = jj_gen + xla - jj_la; p.first = token; p.arg = xla;
  }

  static final class JJCalls {
    int gen;
    Token first;
    int arg;
    JJCalls next;
  }

}
